#!/usr/local/bin/perl -w
# take a graph and convert to a 3-coloring puzzle in puzzle lingo


sub Error {
	my ($message) = @_;
	print STDERR $message;
	exit(-1);
} # Error

$lowLimit = 1000;
$highLimit = 0;
$doneCLASS = 0;
print "# Problem-based constraints\n";
print "PARTITION color: red yellow blue\n";
while (defined($line = <STDIN>)) {
	chomp $line;
	$line =~ s/#.*//; # remove comments
	if ($line =~ /^\s*$/) {next;} ; # empty line
	if ($line =~ /^\s*vtx\((\d+)\)/) { # single vertex
		$lowLimit = ($1 < $lowLimit) ? $1 : $lowLimit;	
		$highLimit = ($1 > $highLimit) ? $1 : $highLimit;	
	} elsif ($line =~ /^\s*vtx\((\d+)\.\.(\d+)\)/) { # vertices
		$lowLimit = $1;
		$highLimit = $2;
	} elsif ($line =~ /^\s*edge\((\d+)\s*,\s*(\d+)\)/) { # edge
		$vertex1 = $1;
		$vertex2 = $2;
		print "CLASS vertex: $lowLimit .. $highLimit\n" unless $doneCLASS;
		$doneCLASS = 1;
		if ($vertex1 < $lowLimit or $highLimit < $vertex1) {
			Error("$line: $vertex1 out of range $lowLimit .. $highLimit.\n");
		}
		if ($vertex2 < $lowLimit or $highLimit < $vertex2) {
			Error("$line: $vertex2 out of range $lowLimit .. $highLimit.\n");
		}
		print "DIFFER color: $vertex1 $vertex2\n";
	}
}
