#!/usr/local/bin/perl -w
# postprocess result of a dcs run

$length = 10;

$/ = undef; # read entire input at one gulp
print "\n";
$gulp = <>;
if (!defined($gulp)) {
	print "Answer is empty.\n";
	exit(0);
}
foreach $solution (split /\n\n/, $gulp) {
	$MyClass = undef;
	$myGuy = undef;
	foreach $line (sort (split /\n/, $solution)) { 
		# print "a line: [$line]\n";
		chomp $line;
		next if ($line =~ /\bnot_/);
		if ($line =~ /Error:/) {
			print "$line\n";
			next;
		}
		if ($line =~ /Sat=(\d+)/) {
			print "$1 solutions.\n";
			next;
		}
		if ($line =~ /aaaa\((\w+)\)/) {
			$MyClass = $1;
			# print "distinguished class is $MyClass\n";
		}
		if ($line =~ /\s*([a-z]+)_([a-z]+)\((.*),(.*)\)\s*$/) {
			if ($1 eq $MyClass) {
				$otherClass = $2;
				$myGuy = $3;
				$otherGuy = $4;
			} elsif ($2 eq $MyClass) {
				$otherClass = $1;
				$myGuy = $4;
				$otherGuy = $3;
			} else {
				next;
			}
			# print "Connect $myGuy to $otherGuy via $otherClass\n";
			${$otherClass}{$myGuy} = $otherGuy;
			$IsClass{$otherClass} = 1;
			$myGuys{$myGuy} = 1;
			next;
		} elsif ($line =~ /\s*[a-z]+_([a-z]+)\(([\w]+)\)/) {
			$vars{$1} = $2;
		}
	} # each line
	summarize();
} # gulp


sub shorten {
	my ($what) = @_;
	return sprintf("%-${length}.${length}s ", $what);
}

sub summarize {
	print "\t", shorten($MyClass);
	foreach $otherClass (sort keys %IsClass) {
		print shorten($otherClass);
	}
	print "\n\t", shorten("=" x $length);
	foreach $otherClass (sort keys %IsClass) {
		print shorten("=" x $length);
	}
	print "\n";
	foreach $myGuy (sort keys %myGuys) {
		print "\t", shorten($myGuy);
		foreach $otherClass (sort keys %IsClass) {
			print shorten(${$otherClass}{$myGuy});
		}
		print "\n";
	}
	foreach $variable (sort keys %vars) {
		print "\t$variable = $vars{$variable}\n";
	}
	print "\n";
}
