#!/usr/bin/perl -w
# generate a random graph of arg1 vertices, arg2 edges

$numVertices = $ARGV[0];
$numEdges = $ARGV[1];
if (!defined($numEdges)) {
	print STDERR "Usage: $0 numVertices numEdges\n";
	exit 1;
}
if ($numEdges > ($numVertices * ($numVertices-1) / 2)) {
	print STDERR "With $numVertices vertices, you can't exceed ",
		$numVertices * ($numVertices-1) / 2, " edges, but you asked for ",
		$numEdges, ".\n";
	exit 1;
}

print "vtx(0.." , $numVertices -1, ").\n";
for ($edge = 0; $edge < $numEdges; $edge += 1) {
	while (1) {
		$first = random($numVertices);
		$second = random($numVertices);
		next if $first eq $second;
		($first, $second) = ($second, $first) if $second < $first;
		next if defined($done{$first . "." . $second});
		last;
	};
	$done{$first . "." . $second} = 1;
	print "edge(", $first, ",", $second, ").\n";
}

sub random {
	my ($limit) = @_;
	my $result = rand $limit;
	$result = 0 if $result =~ /e/; # very small number
	# print "result $limit = $result\n";
	$result =~ s/\..*//;
	return($result);
} # random
