require 5.005;
require "y.tab.pl";
use lib ".";
use Parse::YYLex;

@tokens = 
	(
	'PREFER',	'(PREFER)', sub { return $_[1]; },
	'DECLARE',	'(CLASS|PARTITION)', sub { return $_[1]; },
	'MAP',	'(MAP)', sub { return $_[1]; },
	'VAR',	'(VAR)', sub { return $_[1]; },
	'POWERCLASS', '(POWERCLASS)', sub { return $_[1] },
	'IMPLIES', '(IMPLIES)', sub { return $_[1] },
	'SIZE', '(SIZE)', sub { return $_[1] },
 	'PASS',	'(PASS) ([sm2|sm2tn|dlv|dlv2tn|ndcs|ndcs2tn|ecl])(.*)', sub { return $_[1] },
	'REQUIRED', '(REQUIRED)', sub { return $_[1] },
	'AGREE', '(AGREE)', sub { return $_[1] },
	'CONFLICT', '(CONFLICT)', sub { return $_[1] },
	'USED', '(USED)', sub { return $_[1] },
	'NONEMPTY', '(NONEMPTY)', sub { return $_[1] },
	'OFFSET', '(OFFSET)', sub { return $_[1] },
	'OFFSETP', '(OFFSETP)', sub { return $_[1] },
	'MATCH', '(MATCH)', sub { return $_[1] },
	'DIFFER', '(DIFFER)', sub { return $_[1] },
	'SAME', '(SAME)', sub { return $_[1] },
	'BEFORE', '(BEFORE)', sub { return $_[1] },
	'AGGREGATE', '(AGGREGATE)', sub { return $_[1] },
	'UNIQUE', '(UNIQUE)', sub { return $_[1] },
	'SET', '(SET)', sub { return $_[1] },
	'ONTO', '(ONTO)', sub { return $_[1] },
	'NONREFLEXIVE', '(NONREFLEXIVE)', sub { return $_[1] },
	'ASYMMETRIC', '(ASYMMETRIC)', sub { return $_[1] },
	'SYMMETRIC', '(SYMMETRIC)', sub { return $_[1] },
	'BINOP', '(XOR|OR|IFF)', sub { return $_[1] },
	'LEFTP', '\(', sub { return $_[1] },
	'RIGHTP', '\)', sub { return $_[1] },
	'NOT',	'!', sub { return $_[1] },
	'EQUALS',	'=', sub { return $_[1] },
	'LESSEQ', '<=', sub { return $_[1] },
	'GREATEQ', '>=', sub { return $_[1] },
	'GREAT', '>', sub { return $_[1] },
	'DIFF', '[+]-', sub { return $_[1] },
	'SUM', '[+]', sub { return $_[1] },
	'PRODUCT', '[*]', sub { return $_[1] },
	'TERMINATOR', '\n', sub { return $_[1]; },
	'COMMA', ',', sub {return $_[1]; },
	'AND', '\^', sub {return $_[1]; },
	'OR', '\|', sub {return $_[1]; },
	'COLON', ':', sub { return $_[1]; },
	'PERIOD', '\.', sub {return $_[1]; },
	'STRING', '[a-zA-Z][a-zA-Z]*[.a-zA-Z0-9]*', sub { return lc $_[1]; },	
	'NUM', '(-)*[0-9][0-9]*', sub { return $_[1]; },				
	'COMMENT', '\s*#(.*)', sub {return $_[1];},
	'ERROR', '[\w]*', sub {return $_[1]; },
	);

