#!/usr/local/bin/perl -w
# postprocess result of a dcs run

$length = 10;

$/ = undef; # read entire input at one gulp
print "\n";
$gulp = <>;
if (!defined($gulp)) {
	print "Answer is empty.\n";
	exit(0);
}
$MyClass = undef;
$myGuy = undef;
$gulp =~ /aaaa\((\w+)\)/;
$MyClass = $1;
$numSolutions = 0;
foreach $line ( (split /\n/, $gulp)) { 
	# print "a line: [$line]\n";
	chomp $line;
	next if ($line =~ /\bnot_/);
	if ($line =~ /Error:/) {
		print "$line\n";
		next;
	}
	if ($line =~ /Answer-set (\d+)/) {
		# another solution; just ignore the ones coming earlier
		$numSolutions++;
		next if($numSolutions == 1);
		summarize();
		next;
	}
	if ($line =~ /\s*([a-z0-9]+)_([a-z0-9]+)\((.*),(.*)\)\s*$/) {
		if ($1 eq $MyClass) {
			$otherClass = $2;
			$myGuy = $3;
			$otherGuy = $4;
		} elsif ($2 eq $MyClass) {
			$otherClass = $1;
			$myGuy = $4;
			$otherGuy = $3;
		} else {
			next;
		}
		# print "Connect $myGuy to $otherGuy via $otherClass\n";
		${$otherClass}{$myGuy} = $otherGuy;
		$IsClass{$otherClass} = 1;
		$myGuys{$myGuy} = 1;
		next;
	} elsif ($line =~ /\s*[a-z0-9]+_([a-z0-9]+)\(([\w]+)\)/) {
		$vars{$1} = $2;
	} 
} # each line
summarize();


sub shorten {
	my ($what) = @_;
	return sprintf("%-${length}.${length}s ", $what);
}

sub summarize {
	print "\t", shorten($MyClass);
	foreach $otherClass (sort keys %IsClass) {
		print shorten($otherClass);
	}
	print "\n\t", shorten("=" x $length);
	foreach $otherClass (sort keys %IsClass) {
		print shorten("=" x $length);
	}
	print "\n";
	foreach $myGuy (sort keys %myGuys) {
		print "\t", shorten($myGuy);
		foreach $otherClass (sort keys %IsClass) {
			print shorten(${$otherClass}{$myGuy});
		}
		print "\n";
	}
	foreach $var (sort keys %vars) {
		print "\t$var = $vars{$var}\n";
	}
	print "\n";
}
