#!/usr/bin/perl -w
# postprocess result of a dcs run

$length = 10;

$/ = undef; # read entire input at one gulp
print "\n";
$gulp = <>;
if (!defined($gulp)) {
	print "Answer is empty.\n";
	exit(0);
}
$MyClass = undef;
$myGuy = undef;
$gulp =~ /aaaa\((\w+)\)/;
$MyClass = $1;
if (!defined($MyClass)) {
	print "No solutions.\n";
	exit(0);
}
$MyClass =~ s/^the//;
if (!defined($MyClass)) {
	$gulp =~ /([a-zA-Z0-9]{2,})+_/;
	$MyClass = $1;
	defined($MyClass) or die("Can't find a class name.  Stopped");
	# print "MyClass is $MyClass\n";
}

$colSize{$MyClass} = length $MyClass if(!defined($colSize{$MyClass}));
$numSolutions = 0;
$groundatoms = 0;
foreach $line ( (split /\n/, $gulp)) { 
	# print "a line: [$line]\n";
	chomp $line;
	next if ($line =~ /\bnot_/);
	if ($line =~ /Error:/) {
		print "$line\n";
		next;
	}
	if ($line =~ /Answer-set (\d+)/) {
		# another solution; just ignore the ones coming earlier
		$groundatoms = 1 if($1 == 1) ;
		$numSolutions++;
		next if($numSolutions == 1);
		summarize();
		next;
	}
	next if ($line =~ /_[^_]*_/); # likely a UNIQUE of two partitions artifact
	# print STDERR "debug: $line\n"; # debug
	if ($line =~ /\s*([a-z0-9]+)_([a-z0-9]+)\((.*),(.*)\)\s*$/) {
		if ($1 eq $MyClass) {
			$otherClass = $2;
			$myGuy = $3;
			$otherGuy = $4;
		} elsif ($2 eq $MyClass) {
			$otherClass = $1;
			$myGuy = $4;
			$otherGuy = $3;
		} else {
			next;
		}
		# print "Connect $myGuy to $otherGuy via $otherClass\n";

		$colSize{$MyClass} = length $MyClass if(!defined($colSize{$MyClass}));
		$colSize{$otherClass} = length $otherClass if(!defined($colSize{$otherClass}));
		${$otherClass}{$myGuy} .= ";$otherGuy" 
			if (defined(${$otherClass}{$myGuy}));
		${$otherClass}{$myGuy} = $otherGuy 
			if (!defined(${$otherClass}{$myGuy}));
		$colSize{$otherClass} = ($colSize{$otherClass} < length ${$otherClass}{$myGuy})?
						 length ${$otherClass}{$myGuy}:$colSize{$otherClass};
		$colSize{$MyClass} = ($colSize{$MyClass} < length $myGuy)?
					length $myGuy:$colSize{$MyClass};
		$IsClass{$otherClass} = 1;
		$myGuys{$myGuy} = 1;
		if (!defined($ground{$otherClass}) and $groundatoms == 0) {
			$ground{$otherClass} = "$myGuy:$otherGuy"; 
		} elsif ($groundatoms == 0) {
			$ground{$otherClass} .= ",$myGuy:$otherGuy"; 
		}
		next;
	} elsif ($line =~ /\s*[a-z0-9]+_([a-z0-9]+)\(([\w]+)\)/) {
		$vars{$1} = $2;
	} 
} # each line
summarize();


sub shorten {
	my ($what) = @_;
	$what = '     ' unless defined($what);
	return sprintf("%-${length}.${length}s ", $what);
} # shorten

sub clean {
	foreach $otherClass (sort keys %IsClass) {
		if (defined($ground{$otherClass})) {
			undef %{$otherClass};
			$colSize{$otherClass} = length $otherClass;
			foreach $value (split(/,/, $ground{$otherClass})) {
				my ($myGuy, $otherGuy) = split(/:/, $value);
			#print "$myGuy, $otherGuy, $otherClass,",$colSize{$otherClass},"\n";
				${$otherClass}{$myGuy} .= ";$otherGuy" 
					if (defined(${$otherClass}{$myGuy}));
				${$otherClass}{$myGuy} = $otherGuy 
					if (!defined(${$otherClass}{$myGuy}));
				$IsClass{$otherClass} = 1;
				$colSize{$otherClass} = ($colSize{$otherClass} < length ${$otherClass}{$myGuy})?
						 length ${$otherClass}{$myGuy}:$colSize{$otherClass};
			}
		} else {
			undef %{$otherClass};
			undef $IsClass{$otherClass};
			undef %myGuys;
			undef $colSize{$otherClass};
		}
	}
} # clean
	
sub summarize {
	$solution = " ";
	foreach $myGuy (sort keys %myGuys) {
		foreach $otherClass (sort keys %IsClass) {
			next if($otherClass eq $MyClass);
			$solution .= ${$otherClass}{$myGuy}
				if defined(${$otherClass}{$myGuy});
		}
	}
	if (defined $solutions{$solution}) {
		clean();
		return;
	} else {
		$solutions{$solution} = 1;
	}
	$length = $colSize{$MyClass};
	print "\t", shorten($MyClass);
	foreach $otherClass (sort keys %IsClass) {
		$length = $colSize{$otherClass};
		print shorten($otherClass);
	}
	$length = $colSize{$MyClass};
	print "\n\t", shorten("=" x $length);
	foreach $otherClass (sort keys %IsClass) {
		$length = $colSize{$otherClass};
		print shorten("=" x $length);
	}
	print "\n";
	foreach $myGuy (sort keys %myGuys) {
		$length = $colSize{$MyClass};
		print "\t", shorten($myGuy);
		foreach $otherClass (sort keys %IsClass) {
			$length = $colSize{$otherClass};
			print shorten(${$otherClass}{$myGuy});
		}
		print "\n";
	}
	foreach $var (sort keys %vars) {
		print "\t$var = $vars{$var}\n";
	}
	print "\n";
	clean();
} # summarize
