#!/usr/bin/perl -w
# postprocess result of an smodels run

$length = 10;
$solutions = 0; # initially.  Usually overridden

while (defined($line = <STDIN>)) {
	if ($line =~ /Stable|solution/) {
		$MyClass = "cluster";
		# print join("\n", split(/\s+/, $line)); # debugging
		print "\n";
		foreach $result (split /\s+/, $line) {
			if ($result =~ /^([^_]+)_([^_]+)\((.*),(.*)\)$/) {
				if ($2 eq $MyClass) {
					$otherClass = $1;
					$myGuy = $4;
					$otherGuy = $3;
				} else {
					next;
				}
				# print "Connect $myGuy to $otherGuy via $otherClass\n";
				${$otherClass}{$myGuy} = $otherGuy;
				$IsClass{$otherClass} = 1;
				$myGuys{$myGuy} = 1;
				next;
			} elsif ($result =~ /^cluster_([^(]+)\(([^)]+)\)/) {
				$variables{$1} = $2;
			}
		} # each result
		summarize();
	} elsif ($line =~ /:/) {
		$line =~ /.*:\s+(.*)/;
		$value = $1;
		$solutions = $value if ($line =~ /Answer:/);
		$atoms = $value if ($line =~ /of atoms/);
		$rules = $value if ($line =~ /of rules/);
		$branches = $value if ($line =~ /of choice points/);
		if ($line =~ /(Duration|Solving)(:?)\s+([\d\.]*)/) {
			$seconds = $3;
		} 
	} 
} # one line
$level = $ARGV[0];
$level = 2 unless defined($level);
if (defined($atoms)) {
	print "sm2c: $atoms atoms, $rules rules, $branches branches, " ,
		"$solutions solutions, $seconds seconds\n";
} else {
	print "$solutions solutions, $seconds seconds\n";
}
exit 0;

sub shorten {
	my ($what) = @_;
	die "asked to shorten something undefined.  Stopping" unless defined($what);
	return sprintf("%-${length}.${length}s ", $what);
}

sub summarize {
	print "\t";
	foreach $otherClass (sort keys %IsClass) {
		print shorten($otherClass);
	}
	print "\n\t";
	foreach $otherClass (sort keys %IsClass) {
		print shorten("=" x $length);
	}
	print "\n";
	foreach $myGuy (sort keys %myGuys) {
		print "\t";
		foreach $otherClass (sort keys %IsClass) {
			# die "No $otherClass for $myGuy" unless
			${$otherClass}{$myGuy} = "???" unless
				defined(${$otherClass}{$myGuy});
			print shorten(${$otherClass}{$myGuy});
		}
		print "\n";
	}
	foreach $variable (keys %variables) {
		print "\t$variable = $variables{$variable}\n"
			unless $variable =~ /^v\d*$/;
	}
	print "\n";
}
