#!/usr/local/bin/perl -w
# postprocess result of an smodels run

$length = 10;
$solutions = 0; # initially.  Usually overridden

while (defined($line = <STDIN>)) {
	if ($line =~ /Stable/) {
		# print join("\n", split(/\s+/, $line)); # debugging
		print "\n";
		foreach $result (split /\s+/, $line) {
			if ($result =~ /^variable_(\w+)\((\w+)\)/) {
				$ignore{$1} = $2;
			} elsif ($result =~ /^([^_]+)_([^_]+)\((.*),(.*)\)$/) {
				$MyClass = $2 unless defined($MyClass);
				$otherClass = $1;
				$myGuy = $4;
				$otherGuy = $3;
				# print $result, "\n";
				# print "Connect $myGuy to $otherGuy via $otherClass\n";
				if (defined(${$otherClass}{$myGuy}) and ${$otherClass}{$myGuy}
					ne $otherGuy) {
					print "conflict: $result and ",
						 "${otherClass}_$MyClass(${$otherClass}{$myGuy},",
						 "$myGuy)\n";
				}
				${$otherClass}{$myGuy} = $otherGuy;
				$IsClass{$otherClass} = 1;
				$myGuys{$myGuy} = 1;
				next;
			}
		} # each result
		foreach $guy (keys %ignore) {
			delete $myGuys{$guy};
			# print "removing data for $guy\n";
		}
		$IsClass{$MyClass} = 1;
		summarize();
		clear();
	} elsif ($line =~ /:/) {
		$line =~ /.*:\s+(.*)/;
		$value = $1;
		$solutions = $value if ($line =~ /Answer:/);
		$atoms = $value if ($line =~ /of atoms/);
		$rules = $value if ($line =~ /of rules/);
		$branches = $value if ($line =~ /of choice points/);
		$seconds = $value if ($line =~ /Duration/);
	} 
} # one line
$level = $ARGV[0];
$level = 2;
print "sm${level}t: $atoms atoms, $rules rules, $branches branches, " ,
	"$solutions solutions, $seconds seconds\n";
exit 0;

sub shorten {
	my ($what) = @_;
	die "asked to shorten something undefined.  Stopping" unless defined($what);
	return sprintf("%-${length}.${length}s ", $what);
}

sub summarize {
	print "\t";
	# table header
	print shorten($MyClass);
	foreach $otherClass (sort keys %IsClass) {
		print shorten($otherClass) unless $otherClass eq $MyClass;
	}
	print "\n\t";
	# separator
	foreach $otherClass (sort keys %IsClass) {
		print shorten("=" x $length);
	}
	print "\n";
	# table body
	foreach $myGuy (sort keys %myGuys) {
		${$MyClass}{$myGuy} = $myGuy;
	}
	foreach $myGuy (
		sort {${$MyClass}{$a} cmp ${$MyClass}{$b}} keys %myGuys) { # one row
		print "\t", shorten(${$MyClass}{$myGuy});
		foreach $otherClass (sort keys %IsClass) { # one column
			# die "No $otherClass for $myGuy" unless
			next if $otherClass eq $MyClass;
			${$otherClass}{$myGuy} = "???" unless
				defined(${$otherClass}{$myGuy});
			print shorten(${$otherClass}{$myGuy});
		} # one column
		print "\n";
	} # one row
	# variables
	foreach $variable (keys %ignore) {
		print "\t$variable = $ignore{$variable}\n";
	}
	print "\n";
} # summarize

sub clear {
	foreach $otherClass (sort keys %IsClass) {
		%{$otherClass} = ();	
	}
	%IsClass = ();
} # clear

