#!/usr/bin/perl -w
# postprocess result of an smodels run

$length = 28;
$solutions = 0; # initially.  Usually overridden
$name = $ARGV[1];
while (defined($line = <STDIN>)) {
	if ($line =~ /Stable|solution/) {
		# print join("\n", split(/\s+/, $line)); # debugging
		print "\n";
		foreach $result (split /\s+/, $line) {
			if ($result =~ /^variable_(\w+)\((\w+)\)/) {
				$ignore{$1} = $2;
			} elsif ($result =~ /^([^_]+)_([^_]+)\((.*),(.*)\)$/) {
				$MyClass = $2 unless defined($MyClass);
				$colSize{$MyClass} = length $MyClass if(!defined($colSize{$MyClass}));
				$colSize{$MyClass} = ($colSize{$MyClass} < length $4)?
								 length $4:$colSize{$MyClass}
						if(defined($colSize{$MyClass}));
				$otherClass = $1;
				$myGuy = $4;
				$otherGuy = $3;
				# print $result, "\n";
				# print "Connect $myGuy to $otherGuy via $otherClass\n";
#				if (defined(${$otherClass}{$myGuy}) and ${$otherClass}{$myGuy}
#					ne $otherGuy) {
#					print "conflict: $result and ",
#						 "${otherClass}_$MyClass(${$otherClass}{$myGuy},",
#						 "$myGuy)\n";
#				}
				$colSize{$otherClass} = length $otherClass if(!defined($colSize{$otherClass}));
				${$otherClass}{$myGuy} .= ";$otherGuy" 
					if (defined(${$otherClass}{$myGuy}));
				${$otherClass}{$myGuy} = $otherGuy 
					if (!defined(${$otherClass}{$myGuy}));
				$colSize{$otherClass} = ($colSize{$otherClass} < length ${$otherClass}{$myGuy})?
								 length ${$otherClass}{$myGuy}:$colSize{$otherClass};
				$IsClass{$otherClass} = 1;
				$myGuys{$myGuy} = 1;
				next;
			}
		} # each result
		foreach $guy (keys %ignore) {
			delete $myGuys{$guy};
			# print "removing data for $guy\n";
		}
		$IsClass{$MyClass} = 1;
		summarize();
		clear();
	} elsif ($line =~ /:/) {
		$line =~ /.*:\s+(.*)/;
		$value = $1;
		$solutions = $value if ($line =~ /Answer:/);
		$atoms = $value if ($line =~ /of atoms/);
		$rules = $value if ($line =~ /of rules/);
		$branches = $value if ($line =~ /of choice points/);
		if ($line =~ /(Duration|Solving)(:?)\s+([\d\.]*)/) {
			$seconds = $3;
		} 
	} 
} # one line
$level = $ARGV[0];
$level = 2;
if (defined($atoms)) {
	print "name: $atoms atoms, $rules rules, $branches branches, " ,
		"$solutions solutions, $seconds seconds\n";
} else {
	print "$solutions solutions, $seconds seconds\n";
}
exit 0;

sub shorten {
	my ($what) = @_;
	die "asked to shorten something undefined.  Stopping" unless defined($what);
	return sprintf("%-${length}.${length}s ", $what);
}

sub summarize {
	$solution = " ";
	foreach $myGuy (sort keys %myGuys) {
		foreach $otherClass (sort keys %IsClass) {
			next if($otherClass eq $MyClass);
			$solution .= ${$otherClass}{$myGuy};
		}
	}
	if (defined $solutions{$solution}) {
		return;
	} else {
		$solutions{$solution} = 1;
	}
	print "\t";
	# table header
	foreach $otherClass (sort keys %IsClass) {
		$length = $colSize{$otherClass};
		print shorten($otherClass); 
	}
	print "\n\t";
	# separator
	foreach $otherClass (sort keys %IsClass) {
		$length = $colSize{$otherClass};
		print shorten("=" x $length);
	}
	print "\n"; 
	# table body
	foreach $myGuy (sort keys %myGuys) {
		${$MyClass}{$myGuy} = $myGuy;
	}
	foreach $myGuy (
		sort {${$MyClass}{$a} cmp ${$MyClass}{$b}} keys %myGuys) { # one row
		$length = $colSize{$MyClass};
		print "\t";
		foreach $otherClass (sort keys %IsClass) { # one column
			# die "No $otherClass for $myGuy" unless
			# next if $otherClass eq $MyClass;
			${$otherClass}{$myGuy} = "???" unless
				defined(${$otherClass}{$myGuy});
			$length = $colSize{$otherClass};
			print shorten(${$otherClass}{$myGuy});
		} # one column
		print "\n";
	} # one row
	# variables
	foreach $variable (keys %ignore) {
		print "\t$variable = $ignore{$variable}\n";
	}
	print "\n";
} # summarize

sub clear {
	foreach $otherClass (sort keys %IsClass) {
		%{$otherClass} = ();	
	}
	%IsClass = ();
} # clear

