/* conventions.h */

/* constants */
#define null 0
#define true 1
#define false 0

/* types */
typedef short Boolean;
typedef struct {int dummy;} DummyStruct;

/* variables */
extern int Debug;

/* macros */
#define ERROR(Condition, Code, Reason) \
	if (Condition) { /* Reason */\
		fprintf(stdout, "Node[%d] : ** error %d: %s ** \n", Nugget_MyNode, \
			Code, Reason); \
		(void) abort(); \
		exit(1); \
	}

#define WARNING(Condition, Level, Reason, Action) \
	if (Condition) { /* Reason */\
		if (Debug >= Level) \
			printf("%d: ** warning: %s ** \n", Nugget_MyNode, \
				Reason); \
		(void) abort(); \
		exit(1); \
	}

#define PERROR(Call, message) \
	if ((Call) < 0) { \
		perror(message); \
		exit(1); \
	}

#define CRLF() printf("\n")

/* debug flags controlling partial debug statements */

#define DEBUGHOST 0100
#define DEBUGNODE 0200
#define DEBUGSAP 0400
#define DEBUGREDO 01000
#define DEBUGAPPLIC 02000

#define DEBUG(a, b, c) {if ( (Debug & a) && ( (Debug & 077) >= b) ) {c ; }}

/* debugging flag from the d option on DIB menu takes a four digit
number, say ABCD.
A=1	Redo debugging enabled
A=2	Application debugging enabled
A=3	Redo and application debugging enabled

B=1	Host debugging enabled
B=2	Node debugging enabled
B=3	Host and Node debugging enabled
B=4	SAP debugging enabled
B=5	Host and SAP debugging enabled
B=6	SAP and Node debugging enabled
B=7	Host, SAP and Node debugging enabled

C and D		1 to 7 can be used to selectively decide a level
	   	of importance. All debug statements below or equal
		to level CD are printed. 
*/

#define bcopy(from,to,len){ memcpy(to,from,len); }
#define bzero(sp,len){ int i; for(i=0;i<len;i++) sp[i]='\0'; }

