/* dewey.c */

#include <stdio.h>
#include "conventions.h"
#include "dewey.h"

void PrintDewey(DewPtr)
Dewey *DewPtr;
{
	int seq;
	fprintf(stdout, "Dewey <");
	for (seq = 1; seq <= DewPtr->Length; seq++) {
		fprintf(stdout, "%d.",DewPtr->DNums[seq]);
	}
	fprintf(stdout, "> ");
} /* PrintDewey */

Comparison DeweyCompare(DewPtrA, DewPtrB)
Dewey *DewPtrA, *DewPtrB;
/* Equal means identical; Smaller means DewPtrA is shorter
than DewPtrB (higher in the tree) or to the left if a sibling. */
{
	Comparison Answer ;
	int Seq ;
	Answer = Indeterminate;
	if (DewPtrA->Length < DewPtrB->Length) {
		Answer = Bigger; 
	} else if (DewPtrA->Length > DewPtrB->Length) {
		Answer = Smaller;
	} else if (DewPtrA->Length == 0) {
		Answer = Equal;
	} else { /* DewPtrA->Length == DewPtrB->Length, non-trivial */
		DewPtrA->DNums[DewPtrA->Length+1] = 0; /* pseudo-data */
		DewPtrB->DNums[DewPtrA->Length+1] = 1; /* pseudo-data */
		for (Seq = 1; ; Seq++) {
			if (DewPtrA->DNums[Seq] < DewPtrB->DNums[Seq]) {
				Answer = Smaller;
				break;
			} else if (DewPtrA->DNums[Seq] > DewPtrB->DNums[Seq]) {
				Answer = Bigger;
				break;
			}
		} /* for Seq */
		if (Seq >= DewPtrA->Length+1) {
			Answer = Equal;
		}
	} /* DewPtrA->Length == DewPtrB->Length */
	return(Answer);
} /* DeweyCompare */

Boolean DeweySubsumes(HigherPtr, LowerPtr)
Dewey *HigherPtr, *LowerPtr;
/* return True if the HigherPtr is a prefix (not necessarily proper) of
LowerPtr */
{
	Boolean Answer;
	int Seq;
	 
	Answer = false;
	if (HigherPtr->Length <= LowerPtr->Length) {
		for (Seq = 1; Seq <= HigherPtr->Length; Seq++) {
			if (HigherPtr->DNums[Seq] != LowerPtr->DNums[Seq]) break;
		}
		Answer = Seq > HigherPtr->Length;
	} /* if lengths right */
	return(Answer);
} /* DeweySubsumes */
