
/* types and routines exported from dewey.c */

#	define MaxDepth 40 /* depth of recursion allowed */

	typedef int Comparison;
	/* values: */
#		define Smaller 1
#		define Bigger 2
#		define Equal 3
#		define Indeterminate 4

	/* dewey address structure */
	typedef struct {
			int DNums[MaxDepth+1];
			int Length;
		} Dewey;

#define DeweyCopy(from,to) bcopy((char *) from, (char *) to, sizeof (Dewey))
#define DeweyCopyOut(from,to) { \
	int seq; \
	for (seq = 0; seq < MaxDepth+1; seq++) \
		(to).DNums[seq] = htonl((from).DNums[seq]); \
	(to).Length = htonl((from).Length); \
	}
#define DeweyCopyIn(from,to) { \
	int seq; \
	for (seq = 0; seq < MaxDepth+1; seq++) \
		(to).DNums[seq] = ntohl((from).DNums[seq]); \
	(to).Length = ntohl((from).Length); \
	}

extern Comparison DeweyCompare( /* Dewey*, Dewey* */ );
extern Boolean DeweySubsumes( /* Dewey *Higher, Dewey *Lower */ );
extern void PrintDewey( /* Dewey* */  );
