/* nugget.c:  version for PVM */

#include <stdio.h>
#include <sys/time.h>
#include <ctype.h>
#include "conventions.h"
#include "nugget.h"
#include "sap.h"
#include "pvm3.h"
#include <pvmtev.h> 

/* variables */

int Nugget_UserRunCode;
int Nugget_MySize;
int Nugget_MyNode;
char *task;
int startsec, startusec;
int initialized = 0;
int groupid;

/* flags for controlling user mode for DIB */
int PVM_DEBUG=0;
int UNDER_XPVM=0;

long Nugget_ElapsedTime()
{
	struct timeval tp;
	struct timezone tzp;

	gettimeofday(&tp,&tzp);
	if (initialized) {
		return(((tp.tv_sec-startsec+1)*1000000) -
			(1000000 - tp.tv_usec) - startusec);
	} else {
		startsec = tp.tv_sec;
		startusec = tp.tv_usec;
		initialized++;
		return((long) 0);
	}
} /* Nugget_ElapsedTime */

main(argc,argv)
int argc;
char *argv[];
{

	int i;

  	groupid=pvm_joingroup("DIB");

	task=argv[0];
	if(groupid==0){
		/* only parent pvm process can do stdio */
		/* look at command line options and set up the stuff */
		if ( argc==1 ){
			Nugget_MySize=MAXWORKERS;
		}
		else if ( argc==2 ){
			if( strncasecmp(argv[1],"-debug",strlen(argv[1]))==0 ){
				Nugget_MySize=MAXWORKERS;
				PVM_DEBUG=1;
			}
			else if( strncasecmp(argv[1],"-xpvm",strlen(argv[1]))==0 ){
				Nugget_MySize=MAXWORKERS;
				UNDER_XPVM=1;
			}
			else {
				sscanf(argv[1],"%d",&Nugget_MySize);
				for(i=0;i<strlen(argv[1]);i++){
					if( !isdigit(argv[1][i]) ){
						printf("Usage: %s [number of workers] [-mode]\n",argv[0]);
						pvm_exit();
						exit(1);
					}
				}
			}
		}
		else if ( argc==3 ){
			sscanf(argv[1],"%d",&Nugget_MySize);
			for(i=0;i<strlen(argv[1]);i++){
				if( !isdigit(argv[1][i]) ){
					printf("Usage: %s [number of workers] [-mode]\n",argv[0]);
					pvm_exit();
					exit(1);
				}
			}
			if( strncasecmp(argv[2],"-debug",strlen(argv[2]))==0 ){
				PVM_DEBUG=1;
			}
			else if( strncasecmp(argv[2],"-xpvm",strlen(argv[2]))==0 ){
				UNDER_XPVM=1;
			}
			else {
				printf("Usage: %s [number of workers] [-mode]\n",argv[0]);
				pvm_exit();
				exit(1);
			}
		}
		else {
			printf("Usage: %s [number of workers] [-mode]\n",argv[0]);
			pvm_exit();
			exit(1);
		}
	}

	if( Nugget_MySize > MAXWORKERS ){
		fprintf(stdout,
			"Number of workers cannot be more than %d. Reducing to %d\n",
			MAXWORKERS,MAXWORKERS);
		Nugget_MySize=MAXWORKERS;
	}

	(void) Nugget_ElapsedTime();
	NugMain();

	/* the 'q' option at host menu exits directly
	you wont reach here */

	printf("Node[%d]: Strange exiting from bottom of main\n", Nugget_MyNode);
	exit(0);
}
