#include "nugget.h"

typedef DummyStruct InBuf;
typedef DummyStruct OutBuf;
typedef InBuf *InBufPtr;
typedef OutBuf *OutBufPtr;


#define BCAST 500
#define NOTBCAST 501
#define PVMDMSG 502
#define INPUTMSG 503

#define MAXWORKERS 100		/* our maximum limit we dont allocate memory for
						more than this number to our data structures */
#define MAXBUFSIZE 5000
#define MAXLINELEN 500

#define PVMDAEMON MAXWORKERS+111

extern int MaxPartitionSize;  /* the user specified limit on maximum number
						of workers */
extern int Address[MAXWORKERS+1];
extern char hostname[MAXBUFSIZE];

extern void SAP_Init();
extern void SAP_Snd2();
extern void SAP_Snd3();
extern OutBufPtr SAP_GetSndBuf();
extern void SAP_ReuseMsg();
extern void SAP_RcvGlobal2(); 	/* returns immediately, maybe with null */
extern void SAP_Rcv2(); 			/* blocks until message arrives */

#ifdef interactive
extern void SAP_SndSpecific();	/* sends to specific destination with
							a specified message tag */
extern void SAP_RcvSpecific(); 	/* blocks until message of required type
							arrives */
#endif 

extern void SAP_Broadcast();
extern int SAP_ProbeAny();
extern int SAP_ProbeGlobal();
extern void SAP_AllExit();

extern void SAP_Kill();
extern int SAP_CheckWorker();
extern char* SAP_FindMachine();
extern int SAP_AddMachine();
extern int SAP_SpawnNewNode();
extern int SAP_AddNewNode();
extern int SAP_WorkersOnMyHost();

/* FUNCTION DETAILS SHOWN IN PROTOTYPES BELOW
void SAP_Init(int length);
void SAP_Snd2(OutBufPtr MsgPtr, int Dest);
void SAP_Snd3(OutBufPtr MsgPtr, int Dest, int Length);
OutBufPtr SAP_GetSndBuf();
void SAP_ReuseMsg(MsgPtr);
void SAP_RcvGlobal2(InBufPtr *MsgPtrPtr, int *SourcePtr);
void SAP_Rcv2(InBufPtr *MsgPtrPtr, int *SourcePtr);
void SAP_Broadcast(OutBufPtr MsgPtr,int Length,short LowBound,short HighBound);
*/
