/*
 * FILE : scanner.c 
 *
 * programmer - Pawel Cholewinski
 *
 * date 10/28/92
 *
 * modified 11/15/93
 */

#include "global.h"
#include "token.h"
#include "default.h"
#include "lpmodels.h"
#include "expansions.h"

#define LONGBUFOR 8096

int getdata()
{
   int success = -1;

   switch (logic_on) {
	case 'd': success = getdata_default();
		  break;
	case 'l': success = getdata_lp();
                  break;
	case 'm': success = getdata_modal();
                  break;
	}
   return success;
}


int getdata_default()
{
   char bufor[MAXBUFOR];
   char fdwbufor[MAXFILENAME];
   int lim, ok1=0, ok2=0;

   ff = 0; dffno=0; dttable[0]=ENDTH;
   lim= MAXBUFOR; err=0 ;

   while (nextline(bufor, lim, finp) != 0) {
	   if (bufor[0] == '%' || bufor[0] == EOS) ;
	   else if ((bufor[0]=='w'|| bufor[0]=='d') && bufor[1]=='=') {
		   strcpy(fdwbufor, &bufor[2]);
		   if (bufor[0]=='w'){
			   strcat(fdwbufor,".thc");
			   ok1++; 
		   }
		   else {
			   strcat(fdwbufor,".dc");
			   ok2++;
		   }
		   fdw = fopen(fdwbufor, "r");
		   if (fdw == NULL) {
			   printf("can't open file %s\n",fdwbufor);
			   err--;
		   }
		   else {
			   if (bufor[0]=='w') {
				 dttable[ff] = BOW; wbegin = ff++;
			   }
			   else { 
				dttable[ff] = BOD; dbegin = ff++;
			   }
			   printf("%c file %s opened\n",bufor[0],fdwbufor);
			   get_input_text(fdw,dttable,&dno,defhashtable);
			   fclose(fdw);
			   if (bufor[0]=='w') {
				 if (dttable[ff-1]!=SEMI) dttable[ff++]=SEMI;
				 dttable[ff] = EOW ; wend = ff++;
				 printf("Theory W consulted\n");
			   }
			   else {
				if (dttable[ff-1]!=SEMI) dttable[ff++]=SEMI;
				dttable[ff] = EOD ; dend = ff++;
				printf("Set D consulted\n");
			   }
		   }
	  } /* else - description statement */
    }/* while */
   dttable[ff] = ENDTH;
   thend = ff++;
   dttable[ff] = EOI;
   def_stack_top = ff;
   if (ok1!=1 || ok2!=1) {
	if (err==0) err--;
	if (ok1==0) error("no file for w.",0);
	else if (ok1 >1) error("ambiguous w file description.",0);
	if (ok2==0) error("no file for d.",0);
	else error("ambiguous d file descrioption.",0);
   }
   fclose(finp);
   if (err == 0) err = form_prover_structures();
   if (err == 0) on_default = 1;
   if (err==0) {
	return 1;
   }
   else return 0;
}

int getdata_lp()
{

   ff = 0; lffno=0; clno=0;
   lptable[ff] = BOP; pbegin = ff++;
   err = get_input_text(finp, lptable, &clno, lphashtable);
   fclose(finp);
   if (lptable[ff-1]!=SEMI) lptable[ff++]=SEMI;
   lptable[ff] = EOP ; pend = ff++;
   lptable[ff] = EOI;
   lp_stack_top = ff;
   err = form_lp_structures();
   if (err == 0) on_lp = 1;
   if (err==0) return 1;
   else return 0;
}

int getdata_modal()
{
   ff = 0; mffno=0; mfno=0;
   modtable[ff] = BOP; mdbegin = ff++;
   err = get_input_text(finp, modtable, &mfno, mdhashtable);
   fclose(finp);
   if (modtable[ff-1]!=SEMI) modtable[ff++]=SEMI;
   modtable[ff] = EOP ; mdend = ff++;
   modtable[ff] = EOI;
   md_stack_top = ff;
   err = form_md_structures();
   if (err == 0) on_modal = 1;
   if (err==0) return 1;
   else return 0;
}




int get_input_text(fileptr, memory, counter, hashtable)
	FILE *fileptr;
	int memory[];
	int *counter;
	struct symbolbox *hashtable[];
{
	int longlines=0, m;
	char bufor[LONGBUFOR];
	int lim;

	lim = LONGBUFOR;
	*counter = 0;
	while ((m = nextline(bufor,lim,fileptr)) != 0)
		if (m<0) {
		  longlines++ ; 
		  printf("too long line - ignored (%d)\n",*counter);
		}
		else if (bufor[0] == '%') ;
		else {
			lexscan(bufor,memory, hashtable);
			if ((bufor[0]==EOS)&&(memory[ff-1]!=SEMI)){
				 memory[ff++]= SEMI; (*counter)++;
			}
		     }
	return longlines;
}


int nextline(bufor,lim,fileptr)
	char bufor[];
	int  lim;
	FILE *fileptr;
{
	int c=0, j=0;

	while ((j<lim) && ((c=getc(fileptr)) != EOF) && (c!='\n')) {
		if (c=='\t') c=SPACE;
		if (c!=SPACE) {
			bufor[j]=c;
			j++;
		}
	}
	if (c=='\n') {
		bufor[j]=EOS;
		if ((j>0) && (bufor[j-1]==SPACE)) {
			bufor[j-1]=EOS ; 
			j--;
		}
		return ++j;
	}
	else if (c==EOF) return 0;
	else {
		while ((c!=EOF) && (c!='\n')) c=getc(fileptr);
		return -1;
	}
}


error(message,code)
char *message;
int code;
{
	printf("%s\n",message);
	if (code>0) exit(code);
}

int lexscan(bufor,memory,hashtable) 
	char bufor[];
	int memory[];
	struct symbolbox *hashtable[];
{
	int i=0, tt='$' , key, sigok=1;
	int token=BOT, varno=0, parcount;
	struct symbolbox *address;

	while (bufor[i]!=EOS) {
         	tt = bufor[i++];
         	if (tt == ' ' || tt == '\t') ; 
		else if (tt == 'L') token = LOPER;
		else if (tt == 'M') token = MOPER;
		else if (tt == '1') token = TOP;
		else if (tt == '0') token = BOT;
         	else if (isalpha(tt)) {                 /* tt is a letter */
              		int  b = 0 ;
			parcount = 0;
              		while (isalnum(tt)|| (parcount>0)) {      
							/* tt is alphanumeric */
                     		lexbuf[b] = tt;
				if (tt==')') parcount--;
                     		tt = bufor[i++];
				if (tt=='(') parcount++;
                     		b = b+1;
                     		if (b >= BSIZE)
                     		error("compiler error",0);
               		}
               		lexbuf[b]= EOS;
	       		i--;
	       		if (strcmp(lexbuf,"0")==0) token=BOT;
	       		else if (strcmp(lexbuf,"1")==0) token=TOP;
	       		else {
				token=VAR;
				key=hashkey(lexbuf);
				address=lookup(lexbuf,key,hashtable);
				if (address==NULL) 
				  address=insert(lexbuf,key,hashtable);
				varno=address->no;
	       		} 
			
	  	}
	  	else     /* tt is no a digit nor a letter */
       	     	if (tt == '!') token=NEG;
	     	else if (tt == ':') token=COLON;
	     	else if (tt == ',') token=COMMA;
		else if (tt == ';') token=SEMI;
	     	else if ((tt == '&') && (bufor[i]=='&')) {
			token=AND; i++;
	     	}
	     	else if ((tt == '|') && (bufor[i]=='|')) {
			token=OR; i++;	
	     	}
	     	else if ((tt== '=') && (bufor[i]=='>'))  {
			token=IMP; i++;
             	}
	     	else if ((tt== '-') && (bufor[i]=='>'))  {
			token=ENT; i++;
	     	}
	     	else if ((tt=='<') && (bufor[i]=='=') && (bufor[i+1]=='>')) {
			token=EQI; i=i+2;
	     	}
		 else if ((tt=='<') && (bufor[i]=='-')) {
                        token=PROV; i++;
                }
	     	else if (tt == ')') token=RGT;
	     	else if (tt == '(') token=LFT;
	     	else token=UNKNOWN;
		if (token==UNKNOWN) {
	   	   printf("unknown token in %s (position %d)\n",bufor, i);
		   sigok = -1;
	        }
		if (ff>=DTSIZE) error("unsufficient spelling table",1);
		if ((token!=SEMI)||(memory[ff-1]!=SEMI)) memory[ff++] = token;
		if (token==VAR) memory[ff++] = varno;
      	}
   return sigok;
}

print_coded_theory(memory, hashtable)
   int memory[];
   struct symbolbox *hashtable[];
{
  int i=0, pvar=0 ;
  struct symbolbox *sbx;
  char lexbufer[16];

   fprintf(fout,"w = (%4d %4d)\nd = (%4d %4d)\n", wbegin, wend, dbegin, dend);
   while(memory[i]!=ENDTH) {
	 if (pvar==1) {
			fprintf(fout,"%3d %d\n",i,memory[i]);
			pvar=0;
	 }
	 else { 
		lexform(memory[i],lexbufer);
		if (strcmp(lexbufer,"VAR")==0) pvar=1;
		else pvar=0;
		fprintf(fout,"%3d %s\n",i,lexbufer);
	}
	i++;
   }
	
   fprintf(fout,"%3d %d\n",i , memory[i]);
   for (i=0 ; i<HASHSIZE ; i++) {
	sbx=hashtable[i];
	if (sbx != NULL) fprintf(fout,"\nHASH=%3d %6X\n",i, sbx);
	while (sbx != NULL) {
	   fprintf(fout,"%6X",sbx);
	   fprintf(fout,"-------->%4d %6X %s\n",sbx->no, sbx->next, sbx->id);
	   sbx= sbx->next;
	}
	
	
   }
}

lexform(number, bufor)
	int number;
	char bufor[];
{
	strcpy(bufor,"UNKNO");
	if (number==BOT) strcpy(bufor,"BOT");
	else if (number==TOP) strcpy(bufor,"TOP");
	else if (number==VAR) strcpy(bufor,"VAR");
	else if (number==NEG) strcpy(bufor,"NEG");
	else if (number==AND) strcpy(bufor,"AND");
	else if (number==OR) strcpy(bufor,"OR");
	else if (number==IMP) strcpy(bufor,"IMP");
	else if (number==EQI) strcpy(bufor,"EQI");
	else if (number==COLON) strcpy(bufor,"COLON");
	else if (number==COMMA) strcpy(bufor,"COMMA");
	else if (number==ENT) strcpy(bufor,"ENT");
	else if (number==PROV) strcpy(bufor,"PROV");
	else if (number==LOPER) strcpy(bufor,"LOPER");
	else if (number==MOPER) strcpy(bufor,"MOPER");
	else if (number==RGT) strcpy(bufor,"RGT");
        else if (number==LFT) strcpy(bufor,"LFT");
	else if (number==SEMI) strcpy(bufor,"SEMI");
	else if (number==BOW) strcpy(bufor,"BOW");
	else if (number==EOW) strcpy(bufor,"EOW");
	else if (number==BOD) strcpy(bufor,"BOD");
	else if (number==EOD) strcpy(bufor,"EOD");
	else if (number==BOP) strcpy(bufor,"BOP");
        else if (number==EOP) strcpy(bufor,"EOP");
	else if (number==ENDTH) strcpy(bufor,"ENDTH");
	else if (number==EOI) strcpy(bufor,"EOI");
}


int hashkey(s)
      char *s ;
{
   unsigned hashval;

   for (hashval=0 ; *s != '\0' ; s++) hashval = (*s + hashval) % WSIZE ;
   hashval = hashval%HASHSIZE;
   return (int)hashval ;
}
 
struct symbolbox *lookup(s, key, hashtable) 
      char *s ;
      int key ;
      struct symbolbox *hashtable[];
{ 
   struct symbolbox *sbx ;

   for(sbx =hashtable[key] ; sbx != NULL ; sbx = sbx->next)
      if (strcmp(s,sbx->id) == 0) return  sbx;
      return NULL ; /* s - new identifier */
}
 
struct symbolbox *insert(s, key, hashtable) 
           char *s;
           int key;
           struct symbolbox *hashtable[];
{
   struct symbolbox *sbx;

   sbx = (struct symbolbox *)malloc((unsigned )sizeof(*sbx));
   if (sbx == NULL) error("no room for new symbol",1);
   sbx->id = (char *)malloc((unsigned)(strlen(s)+1));
   if ((sbx->id)==NULL) error("no room for new variable id",1);
   (void)strcpy(sbx->id,s);
   if (mode_default) {
	if (dffno>=2*MAXDSIZE) error("unfufficient defatomlex",1);
	defatomlex[dffno] = sbx->id;sbx->no = dffno++;
   }
   else if (mode_lp) {lpatomlex[lffno] = sbx->id;sbx->no = lffno++;}
   else {mdatomlex[mffno] = sbx->id;sbx->no = mffno++;}
   sbx->next = hashtable[key];
   hashtable[key] = sbx;
   return sbx;
}

deres_parse_param(par,n1,n2,n3)
char *par;
long *n1,*n2,*n3;
{
    int i,c;

    *n1=*n2=0;
    for (i=0; c=par[i++]; ) {
	if (c>='0' && c<='9')
	    *n1=10*(*n1)+c-'0';
	else if (c=='-' && *n1>0) {
	    while (c=par[i++])
		if (c>='0' && c<='9')
		    *n2=10*(*n2)+c-'0';
		else if (c==',' && *n2>0) {
		    for (*n3=0; c=par[i++]; )
			if (c>='0' && c<='9')
			    *n3=10*(*n3)+c-'0';
			else
			    return -1; /* Syntax error in command line */
		    if (c=='\0') {
			if (*n3==0)
			    return -1; /* Syntax error in command line */
			else
			    break;
		    } else
			return -1; /* Syntax error in command line */
		} else
		    return -1; /* Syntax error in command line */
	    if (c=='\0') {
		if (*n2>0) {
		    if (*n1>*n2)
			return -1; /* lower bound > upper bound */
		    else
			break;
		} else
		    return -1; /* Syntax error in command line */
	    } else
		return -1; /* Syntax error in command line */
	} else
	    return -1; /* Syntax error in command line */
    }
    /* c=='\0' */
    if (*n2==0)
	*n2=*n1;
}

