/*
 * FILE : setlib.c - implementation of set operations library
 *
 * programmer - Pawel Cholewinski
 *
 * date 10/28/92
 *
 */

#include "global.h"

int coincide(tab1, tab2, lim)
   int tab1[], tab2[], lim;
{
   int i=0;

   while (i<lim) 
	if (tab1[i] != tab2[i]) return 0;
	else i++;
   return 1;
}

int interval_coincide(tab1, tab2, st, lim)
   int tab1[], tab2[], st, lim;
{
   int i;

   i = st;
   while (i<lim)
        if (tab1[i] != tab2[i]) return 0;
        else i++;
   return 1;
}



int subset(tab1, tab2, lim)
   int tab1[], tab2[], lim;
{
   int i=0;

   while (i<lim)
        if (tab1[i] > tab2[i]) return 0;
        else i++;
   return 1;
}

increment(tab)
   int tab[];
{
   int i=0;

   while (tab[i]==1) tab[i++]=0;
   tab[i] = 1;
}

create_partition (tab1, tab2, lim)
   int tab1[], tab2[], lim;
{
   int i=0;
   while (i<lim)
   if (tab1[i]==1) tab2[i++] = -1;
   else tab2[i++] = 2;
}

int uncomparable_arrays(tab1, tab2, lim)
   int tab1[], tab2[], lim;
{
   if (subset(tab1, tab2, lim) || subset(tab2, tab1, lim)) return 0;
   else return 1;
}

int uncomparable_with_list(tab1, list, lim, cnt)
   int tab1[]; 
   struct GDset *list;
   int lim ;
   long *cnt;
{
   struct GDset *ebx;

   ebx = list;
   while (ebx != NULL) {
	if (!uncomparable_arrays(tab1,ebx->flag,lim)) 
	{
	(*cnt)++;
	return 0;
	}
	ebx = ebx -> next;
   }
   return 1;
}

int dominates_member_of_list(tab1, list, lim, cnt)
   int tab1[];
   struct GDset *list;
   int lim;
   long *cnt;
{
   struct GDset *ebx;

   ebx = list;
   while (ebx != NULL) {
        if (subset(ebx->flag,tab1,lim))
        {
        (*cnt)++;
        return 1;
        }
        ebx = ebx -> next;
   }
   return 0;
}

int not_dominates_any_of(tab1, list, lim, cnt)
   int tab1[];
   struct GDset *list;
   int lim;
   long *cnt;
{
   struct GDset *ebx;

   ebx = list;
   while (ebx != NULL) {
        if (subset(ebx->flag,tab1,lim))
        {
	(*cnt)++;
        return 0;
        }
        ebx = ebx -> next;
   }
   return 1;
}


struct GDset *newGDset(tab1, lim)
   int *tab1, lim;
{
   struct GDset *ebx;
   int *pa;

   ebx = (struct GDset *)malloc(sizeof(struct  GDset));
   if (ebx == NULL) {
	printf("newGDset :  no more memory available\n");
      exit(1);
   }
   else {
      ebx->next = NULL;
      pa = &((ebx->flag)[0]);
      while (lim--)  *pa++ = *tab1++;
   }
   return ebx;
}

void GDsetListInsert(head,tab1,lim,algth)
   struct GDset **head;
   int *tab1, lim;
   long  *algth;
{
   struct GDset *ebx;

   ebx = newGDset(tab1,lim);
   if (*head == NULL) *head = ebx;
   else {
	ebx->next = *head;
	*head = ebx;
   }
   (*algth)++;
}

int GDsetListUpdate(list,tab,lim,cnt)
   struct GDset *list;
   int *tab, lim;
   long  *cnt;
{
   int *pa, lim1;
   struct GDset *ebx, *qbx;

   ebx = list;
   while (ebx != NULL) {
        if (subset(tab,ebx->flag,lim))
        {
	   pa = &((ebx->flag)[0]);
	   lim1 = lim;
	   while (lim1--)  *pa++ = *tab++;
	   qbx = ebx;
	   while ((qbx->next) != NULL) {
	     if (subset(ebx->flag,(qbx->next)->flag,lim)) {
		   qbx->next = (qbx->next)->next;
		   (*cnt)--;
	     }
	     else qbx = qbx->next;
	   }
           return 0;
        }
        ebx = ebx -> next;
   }
   return 1;
}

convert(tab1,tab2,lim,forzero,forelse)
   int *tab1, *tab2, lim, forzero, forelse;
{
   int i;
   
   for (i=0 ; i<lim ; i++)
	if (tab1[i]==0) tab2[i] = forzero;
	else tab2[i] = forelse;
}
