/*
 * FILE: tbemit.c
 *
 * programmer - Pawel Cholewinski
 *
 * date 03/17/95
 *
 */

#include "global.h"
#include "default.h"
#include "tb_graph.h"
#include <stdio.h>
#include  "xbook.h"
#include  "x11ext.h"

#define C360x64 23040


XWhereVertices(s1, s2)
  char *s1, *s2;
{
   tb_Graph *ggg;
   tb_Paint *vi;
   tb_Vertex *v;

   int  px, py;
   
   if (s1==NULL) s1="0";
   if (s2==NULL) s2="d2";
   ggg = viewinfo.lastgraph;
   if (ggg == NULL) {
	printf("XWhereVertices : NULL graph \n");
        return -1;
   }
   vi = (tb_Paint*)malloc(sizeof(tb_Paint));
   vi->paint_winwdth = 800;
   vi->paint_winhght = 800;
   vi->interior      = 0.75;
   vi->vtxrad = vi->edgearrh = 8;
   vi->vtxpixel = vi->edgepixel = 1L;
   top_margin = foot_margin = left_margin = right_margin = 100;
   printf("tbsh geometry for %s\n",ggg->id);
   FillGraphGeometry(ggg, s2);
   printf("TbGraphBoundingRect\n");
   TbGraphBoundingRect(ggg, &gphx, &gphy, &gphw, &gphh);
   printf("x=%d, y=%d, width=%d, height=%d\n", gphx, gphy, gphw, gphh);
   TbDefineTransformation(gphw,gphh, vi, mtxA, mtxB);
   printf("Transformation: | %f  %f |     %f\n", 
			    mtxA[0][0],mtxA[0][1],mtxB[0]);
   printf("--------------: | %f  %f |     %f\n",
			    mtxA[1][0],mtxA[1][1],mtxB[1]);
   for(v= ggg->vertices;v<ggg->vertices+ggg->n;v++){
        TbMapPoint(mtxA, mtxB, gphx, gphy, v->x, v->y, &px, &py);
	printf("vertex%3d: %10s, (%5d,%5d) -> (%4d, %4d)\n", tbvtxnum(ggg,v),
	v->name, v->x, v->y, px, py);
   }
}
   
XDrawGraph(display, window, gc, ggg, vi)
Display *display;
Window  window;
GC      gc;
tb_Graph *ggg;
tb_Paint *vi;
{
   tb_Graph *ggg1;
   int px, py, qx, qy, strl, strlva, wdth, ox, oy;
   tb_Vertex *v;
   tb_Arc *a;
   char string[512], stringva[128];
   
   if (ggg == NULL) ggg1 = vi->lastgraph;
   else ggg1 = ggg;
   TbGraphBoundingRect(ggg1, &gphx, &gphy, &gphw, &gphh);
   TbDefineTransformation(gphw,gphh, vi, mtxA, mtxB);
   XClearArea(display,window,left_margin+1,top_margin+1,vi-> paint_winwdth-2,
		vi->paint_winhght-2,False);
   for(v= ggg1->vertices;v<ggg1->vertices+ggg1->n;v++){
	TbMapPoint(mtxA, mtxB, gphx, gphy, v->x, v->y, &px, &py);
	XDrawVertex(display, window, gc, px, py, vi, -1);
	for(a= v->outarcs;a;a= a->next) {
	   TbMapPoint(mtxA, mtxB, gphx, gphy, a->tip->x, a->tip->y, &qx, &qy);
	   ox = oy = 0;
           if (vi->ifarcs == 0)
                XDrawEdge(display, window, gc, px, py, qx, qy, vi,-1);
           else
                XTbDrawArc(display, window, gc, px, py, qx, qy, &ox, &oy, vi);
           if (vi->ifarrows == 1)
                XDrawArrow(display, window, gc, px, py, qx, qy, ox, oy, vi);
	}
   }
   for(v= ggg1->vertices;v<ggg1->vertices+ggg1->n;v++){
        TbMapPoint(mtxA, mtxB, gphx, gphy, v->x, v->y, &px, &py);
        XDrawVertex(display, window, gc, px, py, vi, -1);
   }
   XSetForeground( display, gc, marginclr);
   wdth = left_margin + right_margin + vi->paint_winwdth;
   XFillRectangle( display, window, gc, 2, 2,wdth-350,top_margin-2);
   XSetForeground( display, gc, black );
   strcpy(string,def_znak);
   ParenthesizeName(string);
   strl = strlen( string );
   XDrawString( display, window, gc, left_margin/2, top_margin/3, string, strl);
   sprintf(stringva,"%d defaults, %d formulas",dno,wno);
   strlva = strlen( stringva );
   XDrawString(display,window,gc,left_margin/2,2*top_margin/3,stringva,strlva);
}

XDisplayVertexNames(display, window, gc, ggg, vi)
Display *display;
Window  window;
GC      gc;
tb_Graph *ggg;
tb_Paint *vi;
{
   tb_Graph *ggg1;
   tb_Vertex *v;
   char *string;
   int xx, yy, px, py, strl, strw;

   if (ggg == NULL) ggg1 = vi->lastgraph;
   else ggg1 = ggg;
   if (ggg1 == NULL) return 1;

   XSetForeground( display, gc, black );
   for(v= ggg1->vertices;v<ggg1->vertices+ggg1->n;v++){
      string = v->name;
      strl = strlen( string );
      strw = XTextWidth(font, string, strl);
      if (strw + 8 < vi->paint_winwdth) {
	TbMapPoint(mtxA, mtxB, gphx, gphy, v->x, v->y, &px, &py);
	xx = px - strw/2;
	yy = py - 2*vi->vtxrad;
	if (xx < left_margin) xx = left_margin + 5;
        if ((xx + strw) > (left_margin + vi->paint_winwdth)) 
	  xx = left_margin + vi->paint_winwdth - strw - 5;
	  XDrawString( display, window, gc, xx, yy, string, strl);
      }
   }
}

XDisplayMarginInfo(display, window, gc, vi)
Display *display;
Window  window;
GC      gc;
tb_Paint *vi;
{
   char *string;
   int xx, yy, strl, strw, strh;

   if ((string = vi->info)==NULL) return 0;
   strl = strlen( string );
   if (strl==0) return 0;
   strw = XTextWidth(font, string, strl);
   strh = font->ascent + font->descent;
   xx = left_margin + (vi->paint_winwdth - strw)/2;
   if (xx <= left_margin) xx = left_margin + 1;
   yy = top_margin - 5;
   XSetForeground( display, gc, black );
   XDrawString( display, window, gc, xx, yy, string, strl);
   return 1;
}

XEraseMarginInfo(display, window, gc, vi)
Display *display;
Window  window;
GC      gc;
tb_Paint *vi;
{
   int yy;

   XSetForeground( display, gc, marginclr);
   yy = top_margin - 5 - font->ascent - font->descent;
   XFillRectangle(display,window,gc,left_margin,yy,vi->paint_winwdth,
	font->ascent + font->descent);
   vi->info = NULL;
   return 0;
}


XDrawVertex(display, window, gc, px, py, vi, clrloc)
   Display *display;
   Window  window;
   GC      gc;
   int px, py;
   tb_Paint *vi;
   int clrloc;
{
   unsigned long pixel;
   int rad, rad2;

   if (clrloc < 0) pixel = vi->vtxpixel;
   else {
	if (clrloc > MAX_COLORS) clrloc -= MAX_COLORS;
	else clrloc = customrgb[clrloc];
	pixel = colours[clrloc].pixel;	
   	if ((pixel==white) && ((clrloc%2)==1)) pixel = black;
   }
   rad   = vi->vtxrad;
   rad2  = 2*rad;
   XSetForeground( display, gc, pixel );
   XFillArc(display, window, gc, px-rad, py-rad, rad2, rad2, 0,C360x64);
   XSetForeground( display, gc, black );
   XDrawArc(display, window, gc, px-rad, py-rad, rad2, rad2, 0,C360x64);
} 

XDrawEdge(display, window, gc, px, py, qx, qy, vi, clrloc)
   Display *display;
   Window  window;
   GC      gc;
   int px, py;
   tb_Paint *vi;
   int clrloc;
{
   unsigned long pixel;

   if (clrloc < 0) pixel = vi->edgepixel;
   else {
        if (clrloc > MAX_COLORS) clrloc -= MAX_COLORS;
        else clrloc = customrgb[clrloc];
        pixel = colours[clrloc].pixel;
        if ((pixel==white) && ((clrloc%2)==1)) pixel = black;
   }
   XSetForeground( display, gc, pixel );
   XDrawLine(display, window, gc, px, py, qx, qy);
   XSetForeground( display, gc, black );
}  


tbvtxnum(g,v)
  tb_Graph *g;
  tb_Vertex *v;
{
  int skip;
  tb_Vertex *u;

  u = g->vertices;
  if (g->n == 1) return 0;
  skip = (int)(g->vertices+1) - (int)(g->vertices);
  return ((int)(v) - (int)(g->vertices))/skip;
 }

ParenthesizeName(string)
  char string[];
{
  int i, lngth;
  
  lngth = strlen(string);
  for (i=0 ; i<lngth ; i++) 
      if (string[i]=='_') string[i]='-';
}

XTbDrawArc(display, window, gc, ipx, ipy, iqx, iqy, aox, aoy, vi)
   Display *display;
   Window  window;
   GC      gc;
   int ipx, ipy, iqx, iqy;
   int *aox, *aoy;
   tb_Paint *vi;
{
   unsigned long pixel;
   int px, py, qx, qy, cx, cy, angle1, angle2, angle3;
   int rad, rad1, rad2, ab;
   float arcangle;
   double abdist(), GetArcCenter(), rdx;
   double dbangle1, dbangle2, dbangle3, GetArcAngle();

   pixel = vi->edgepixel;
   XSetForeground( display, gc, pixel );
   arcangle = (float)20.0;
   if (ipx < iqx) {
        px = ipx; py = ipy; qx = iqx; qy = iqy;
   }
   else if ((ipx == iqx) && (ipy < iqy)) {
        px = ipx; py = ipy; qx = iqx; qy = iqy;
   }
   else {
        px = iqx; py = iqy; qx = ipx; qy = ipy;
   }
   GetArcCenter(px,py,qx,qy,arcangle,vi,&cx,&cy);
   *aox = cx;
   *aoy = cy;
   rdx = abdist(cx,cy,px,py);
   if (rdx <= 0) {
        XDrawLine(display, window, gc, px, py, qx, qy);
        XSetForeground( display, gc, black );
        return 2;
   }
   dbangle1 = GetArcAngle(cx,cy,px,py,rdx);
   dbangle2 = GetArcAngle(cx,cy,qx,qy,rdx);
   rad = (int)rdx;
   if (dbangle1 < 0) dbangle1 = dbangle1 + 360;
   if (dbangle2 < 0) dbangle2 = dbangle2 + 360;
   if (dbangle2 < dbangle1) {
        dbangle3 = dbangle1;
        dbangle1 = dbangle2;
        dbangle2 = dbangle3;
   }
   dbangle3 = dbangle2 - dbangle1;
   if (dbangle3 > 180) {
        dbangle3 = 360 - dbangle3;
        dbangle1 = dbangle2;
   }
   angle1 = (int)(dbangle1*64);
   angle3 = (int)(dbangle3*64);
   XDrawArc(display, window, gc, cx-rad, cy-rad, 2*rad, 2*rad, angle1, angle3);
   XSetForeground( display, gc, black );
}

XDrawArrow(display, window, gc, px, py, qx, qy, ox, oy, vi)
   Display *display;
   Window  window;
   GC      gc;
   int px, py, qx, qy, ox, oy;
   tb_Paint *vi;
{
   unsigned long pixel;
   int ax, ay, bx, by, cx, cy, xsgn, ysgn, whichx;
   double sx, sy, tx, ty, zx, zy, r, R, tempz;
   double dx1, dx2, dy1, dy2, sx1, sx2, sy1, sy2, qh;
   double alpha, beta, gamma, dd1, dd2;
   double sin(), cos(), asin(), abdist();

   r = (double)vi->vtxrad;
   R = abdist(px,py,qx,qy);
   if (R < r) return -1.0;
   if (vi->ifarcs == 0) {
        zx = (double)(px-qx);
        zy = (double)(py-qy);
        zy = zy/R;
        zx = zx/R;
        sx = zx * r + qx;
        sy = zy * r  + qy;
        zx = zx * vi->edgearrh;
        zy = zy * vi->edgearrh;
        tx = zx + sx;
        ty = zy + sy;
        tempz = zx;
        zx = -zy/4;
        zy = tempz/4;
        }
   else {
        R = abdist(qx,qy,ox,oy);
        alpha = asin(r/(2*R));
        qh = (double)(qy-oy);
        if (qh < 0) qh = -qh;
        beta  = asin(qh/R);
	dx1   = R*cos(beta+2*alpha);
        dy1   = R*sin(beta+2*alpha);
        dx2   = R*cos(beta-2*alpha);
	dy2   = R*sin(beta-2*alpha);
        if (qx > ox) xsgn = 1;
        else xsgn = -1;
        if (qy > oy) ysgn = 1;
        else ysgn = -1;
        sx1 = (double)ox + xsgn*dx1;
        sy1 = (double)oy + ysgn*dy1;
        sx2 = (double)ox + xsgn*dx2;
        sy2 = (double)oy + ysgn*dy2;
        dd1 = abdist(px,py,(int)sx1,(int)sy1);
        dd2 = abdist(px,py,(int)sx2,(int)sy2);
        if (dd1 < dd2) { sx = sx1; sy = sy1; whichx = 1;}
        else    { sx = sx2; sy = sy2; whichx =2; }
        gamma  = asin((double)(vi->edgearrh)/(2*R));
        if (whichx ==1) gamma = beta+2*alpha+2*gamma;
        else gamma = beta-2*alpha-2*gamma;
        tx = (double)ox + xsgn*R*cos(gamma);
        ty = (double)oy + ysgn*R*sin(gamma);
        zx = (tx - (double)ox)*vi->edgearrh/(4*R);
        zy = (ty - (double)oy)*vi->edgearrh/(4*R);

   }
   ax = (int)(tx + zx);
   ay = (int)(ty + zy);
   bx = (int)(tx - zx);
   by = (int)(ty - zy);
   cx = (int)sx;
   cy = (int)sy;
   pixel = vi->edgepixel;
   XSetForeground( display, gc, pixel );
   XDrawLine(display, window, gc, ax, ay, cx, cy);
   XDrawLine(display, window, gc, bx, by, cx, cy);
   XSetForeground( display, gc, black );
}

