/*****************************************************************************
 *
 * FILE : user.c 
 *
 * programmer - Pawel Cholewinski & Artur Mikitiuk
 *
 * date 01/15/94; modified 05/20/94
 *
 *****************************************************************************/

#include "global.h"
#include "token.h"
#include "default.h"

internal_user_dispatch_def()
{
   if (strcmp("wdloc",argvx[0])==0) wdloc();
   else if (strcmp("adjc",argvx[0])==0) adjc(ad);
   else return 1;

   return 0;
}

external_user_dispatch_def()
{
    if (strcmp("allrat",argvx[0])==0)
	allrational(ALLEXT);
    else if (strcmp("hasrat",argvx[0])==0)
	allrational(EXISTS);
    else if (strcmp("insomerat",argvx[0])==0)
	allrational(INSOME);
    else if (strcmp("inallrat",argvx[0])==0)
	allrational(INALL);
    else if (strcmp("countrat",argvx[0])==0)
	allrational(ALLEXT);
    else if (strcmp("hello",argvx[0])==0)
	hello();
    else
	return 1;

   return 0;
}

int hello()
{
  int i, preqfree=0, jfree=0;
  printf("Hello world!\n");
  
  if (on_default != 1) {
        printf("no default theory is stored\n");
        return -1;
   }


  for (i=0 ; i<dno ; i++) {
	if (preq[i]<0) preqfree++;
	if (just[i]<0) jfree++;
  }
  printf("Number of formulas: %d\n",wno);
  printf("Number of default: %d\n",dno);
  printf("Number of prerequisite-free defaults: %d\n",preqfree);
  printf("Number of justification-free defaults: %d\n",jfree);
  return 0;
}

internal_user_dispatch_lp()
{
   return 1;
}

external_user_dispatch_lp()
{
   return 1;
}

internal_user_dispatch_md()
{
   return 1;
}

external_user_dispatch_md()
{
   printf("external user MODAL NONMONOTONIC LOGIC dispatcher started\n");
   return 1;
}



wdloc()
{
    int i;

    for (i=0; i<wno; i++)
	printf("formula %d location %d\n",i,w[i]);
    for (i=0; i<dno; i++) 
	printf("default %d location %d (preq at %d, just %d, conc %d)\n",
	i,d[i],preq[i],just[i],conc[i]);
}

adjc(tab)
int *tab;	
{
   int answer,ff,eoi=thend+1;

   answer=adjc_test1(tab,eoi,&ff);
   if (answer < 0) printf("YES. No justifications\n");
   else if (answer==0) printf("YES. W + c(ad) + just(ad) consistent.\n");
   else printf("NO.  W + c(ad) + just(ad) is not consistent.\n");
}

allrational(query)
int query;
{
    int resp,parg=1,eoi,defstop;

    if (on_default != 1) {
	printf("no default theory is stored\n");
	return -1;
    }
    def_stat(0,query);
    if (argvx[1][0]=='-') {
	set_current_options(argvx[1]);
	parg=2;
    } else
	set_current_options(NULL);
    if (flag['q'] && argvx[parg]==NULL)
	defstop=dno-1;
    else 
	defstop=(flag['q']) ? atoi(argvx[parg++]) : dno;
    if (strcmp("countrat",argvx[0])==0)
	flag['c']=1;
    if (flag['c'])
	flag['s']=0;
    if (query==INSOME || query==INALL) {
	if (argvx[parg]==NULL && inp_default==0) {
	    printf("Error: no input formula known\n");
	    return -1;
	} else if (argvx[parg]!=NULL) {
	    resp=inp(argvx[parg]);
	    if (inp_default==0) {
		printf("Error: no correct formula\n");
		return -1;
	    }
	}
	printf("query formula: ");
	printformula(thend+1);
	printf("\n");
    }
    for (eoi=thend+1; dttable[eoi]!=EOI; eoi++)
	;
    if (flag['a'] && flag['o'])
	resp=allrational_o(query,eoi,flag['c'],flag['s'],flag['g'],flag['j'],
	defstop,1-flag['b'],flag['v']);
    else if (flag['a'])  
	resp=allrational_r(query,eoi,flag['c'],flag['s'],flag['g'],flag['j'],
	defstop,flag['v']);
    else if (flag['o']) 
	resp=allrational_od(query,eoi,flag['c'],flag['s'],flag['g'],flag['j'],
	defstop,1-flag['b'],flag['v']);
    else 
	resp=allrational_rd(query,eoi,flag['c'],flag['s'],flag['g'],flag['j'],
	defstop,flag['v']);
    if (resp==2)
	printf("Stopped\n");
    if (query==EXISTS || query==INSOME)
	printfanswer(resp,1);
    else if (query==ALLEXT)
	printf("%d rational extensions.\n",n_extnsns);
    else if (query==INALL) {
	if (n_extnsns>0)
	    printf((resp>0)?"YES.\n":"NO.\n");
	else
	    printf("No rational extensions found.\n");
    }
    if (flag['x'])
	def_stat(1,query);
}

allrational_r(query,eoi,flagC,flagS,flagG,flagJ,defstop,flagV)
int query,eoi,flagC,flagS,flagG,flagJ,defstop,flagV;
{
    int i,l,ff,numb=1,answer,ans,is_ext;
    char bufor[128];

    zeroarr(GenDef);
    while (GenDef[defstop]==0) {
      if ((flagG || not_dominates_any_of(GenDef,ExtnsnsList,dno,&n_covered))
      && (!flagJ || not_dominates_any_of(GenDef,MinUnconsList,dno,&n_uncons))) {
	    n_candidates++;
	    arrcpy(ad,GenDef);
	    answer=adjc_test1(GenDef,eoi,&ff);
	    if (flagV) {
		emitarr("A=GenDef:",GenDef,0);
		printf("answer=%d\n",answer);
	    }
	    if (answer!=1) {
		zeroarr(ad);
		arrcpy(Reduct,GenDef);
		Bomega();
		if (flagV)
		    emitarr("ad po Bomega:",ad,1);
		for (i=0, ans=1; ans && i<dno; i++)
		    if (GenDef[i] && preq[i]!=-1)
			ans=prove(preq[i],1);
		if (ans) {
		    if (flagV)
			emitarr("GenDef:",GenDef,0);
		    emitset("Active set",numb++,GenDef);
		    arrcpy(ad,GenDef);
		    for (l=0, is_ext=1; is_ext && l<dno; l++)
			if (!GenDef[l]) {
			    GenDef[l]=1;
			    if (flagV)
				emitarr("B=GenDef:",GenDef,1);
			    if (just[l]==-1 || adjc_test2(eoi,ff,l,flagV)!=1) {
				zeroarr(ad);
				arrcpy(Reduct,GenDef);
				Bomega();
				if (flagV) {
				    emitarr("Niesprzeczny  ad po Bomega:",ad,0);
				    emitarr("GenDef:",GenDef,1);
				}
				if (preq[l]==-1 || prove(preq[l],1))
				    is_ext=0;
			    } /*  else if (flagJ)
				GDsetListInsert(&MinUnconsList,GenDef,dno,&m_MinUnconsList); */
			    if (flagV)
				printf("is_ext=%d\n",is_ext);
			    GenDef[l]=0;
			}
		    if (is_ext) {
			n_extnsns++;
			if (!flagG)
			    GDsetListInsert(&ExtnsnsList,GenDef,dno,&m_ExtnsnsList);
			if (!flagC)
			    emitset("Rational extension",(int)n_extnsns,GenDef);
			if (query==EXISTS)
			    return 1;
			else if (query==INSOME || query==INALL) {
			    arrcpy(ad,GenDef);
			    if (query==INSOME && prove(thend+1,1)==1)
				return 1;
			    else if (query==INALL && prove(thend+1,1)==0)
				return 0;
			}
			if (flagS)
			    for (bufor[0]='x'; bufor[0]!='y' && bufor[0]!='n'; ) {
				printf("- continue [y/n] : ");
				sysnextline(bufor,128);
				if (bufor[0]=='n')
				    return 2;
			    }
		    }
		}
	    } else if (flagJ)
		GDsetListInsert(&MinUnconsList,GenDef,dno,&m_MinUnconsList);
	}
	increment(GenDef);
    }
    return 3;
}

allrational_o(query,eoi,flagC,flagS,flagG,flagJ,defstop,mode,flagV)
int query,eoi,flagC,flagS,flagG,flagJ,defstop,mode,flagV;
{
    int i,ffc,ftu,ff,newff,k,outside,answer;
    long avoid=0;
    char bufor[128];

    zeroarr(Segment);
    while (Segment[defstop]==0) {
	if ((!flagJ||not_dominates_any_of(Segment,MinUnconsList,dno,&n_uncons))
	&& (flagG||uncomparable_with_list(Segment,ExtnsnsList,dno,&n_covered))) {
	    n_candidates++;
	    for (ffc=i=0; i<dno; i++) {
		Used[i]=ad[i]=0;
		if (Segment[i])
		    Order[ffc++]=i;
	    }
	    for (i=0; i<dno; i++)
		if (!Segment[i])
		    Order[ffc++]=i;
	    if (flagV) {
		emitarr("Segment:",Segment,0);
		emitarr("Order:",Order,1);
	    }
	    ff=eoi;
	    outside=0;
	    while (1) {
		for (ftu=0; ftu<dno; ftu++) {
		    k=Order[ftu];
		    if (Used[k])
			continue;
		    if (just[k]==-1 || adjc_test3(eoi,ff,&newff,k,flagV)!=1) {
			if (prove(preq[k],1)) {
			    if (mode && !Segment[k]) {
				outside=1;
				if (flagV)
				    printf("Outside\n");
				break;
			    }
			    ff=newff;
			    Used[k]=ad[k]=1;
			    break;
			}
		    } else if (flagJ) {
			ad[k]=1;
			if (not_dominates_any_of(ad,MinUnconsList,dno,&avoid)) {
			    GDsetListUpdate(MinUnconsList,ad,dno,&m_MinUnconsList);
			    GDsetListInsert(&MinUnconsList,ad,dno,&m_MinUnconsList);
			}
			ad[k]=0;
		    }
		    if (ff>eoi)
			dttable[ff-1]=SEMI;
		    dttable[ff]=EOI;
		}
		if (ftu==dno || outside)
		    break;
	    } /* while(1) */
	    answer=5;
	    if (!outside && (ff==eoi || (answer=prove(eoi+1,0))==0) &&
	    (!flagG && uncomparable_with_list(ad,ExtnsnsList,dno,&avoid))
	    || (flagG && coincide(ad,Segment,dno))) {
		n_extnsns++;
		if (!flagG)
		    GDsetListInsert(&ExtnsnsList,ad,dno,&m_ExtnsnsList);
		if (!flagC)
		    emitset("Rational extension",(int)n_extnsns,Used);
		if (query==EXISTS)
		    return 1;
		else if (query==INSOME || query==INALL) {
		    arrcpy(ad,Used);
		    if (query==INSOME && prove(thend+1,1)==1)
			return 1;
		    else if (query==INALL && prove(thend+1,1)==0)
			return 0;
		}
		if (flagS)
		    for (bufor[0]='x'; bufor[0]!='y' && bufor[0]!='n'; ) {
			printf("- continue [y/n] : ");
			sysnextline(bufor,128);
			if (bufor[0]=='n')
			    return 2;
		    }
	    } else if (flagJ && answer==1) {
		if (not_dominates_any_of(ad,MinUnconsList,dno,&avoid)) {
		    GDsetListUpdate(MinUnconsList,ad,dno,&m_MinUnconsList);
		    GDsetListInsert(&MinUnconsList,ad,dno,&m_MinUnconsList);
		}
	    }
	}
	increment(Segment);
    }
    return 3;
}

allrational_rd(query,eoi,flagC,flagS,flagG,flagJ,defstop,flagV)
int query,eoi,flagC,flagS,flagG,flagJ,defstop,flagV;
{
    int numb=1;

    zeroarr(GenDef);
    return dynamic_build_ratext(query,0,eoi,eoi,&numb,flagC,flagS,flagG,flagJ,defstop,flagV);
}

dynamic_build_ratext(query,level,eoi,ff,numb,flagC,flagS,flagG,flagJ,defstop,flagV)
int query,level,eoi,ff,*numb,flagC,flagS,flagG,flagJ,defstop,flagV;
{
    int i,l,answer=0,ans,is_ext,more=3;
    char bufor[128];

    if (level==0 || GenDef[level-1]) {
	if ((flagG || not_dominates_any_of(GenDef,ExtnsnsList,dno,&n_covered))
	&& (!flagJ || not_dominates_any_of(GenDef,MinUnconsList,dno,&n_uncons))) {
	    n_candidates++;
	    arrcpy(ad,GenDef);
	    answer=adjc_test4(GenDef,eoi,&ff,level-1,flagV);
	    if (flagV) {
		emitarr("A=GenDef:",GenDef,0);
		printf("answer=%d\n",answer);
	    }
	    if (answer!=1) {
		zeroarr(ad);
		arrcpy(Reduct,GenDef);
		Bomega();
		if (flagV)
		    emitarr("ad po Bomega:",ad,1);
		for (i=0, ans=1; ans && i<dno; i++)
		    if (GenDef[i] && preq[i]!=-1)
			ans=prove(preq[i],1);
		if (ans) {
		    if (flagV)
			emitarr("GenDef:",GenDef,0);
		    emitset("Active set",(*numb)++,GenDef);
		    arrcpy(ad,GenDef);
		    for (l=0, is_ext=1; is_ext && l<dno; l++)
			if (!GenDef[l]) {
			    GenDef[l]=1;
			    if (flagV)
				emitarr("B=GenDef:",GenDef,1);
			    if (just[l]==-1 || adjc_test2(eoi,ff,l,flagV)!=1) {
				zeroarr(ad);
				arrcpy(Reduct,GenDef);
				Bomega();
				if (flagV) {
				    emitarr("Niesprzeczny  ad po Bomega:",ad,0);
				    emitarr("GenDef:",GenDef,1);
				}
				if (preq[l]==-1 || prove(preq[l],1))
				    is_ext=0;
			    }
			    if (flagV)
				printf("is_ext=%d\n",is_ext);
			    GenDef[l]=0;
			}
		    if (is_ext) {
			n_extnsns++;
			if (!flagG)
			    GDsetListInsert(&ExtnsnsList,GenDef,dno,&m_ExtnsnsList);
			if (!flagC)
			    emitset("Rational extension",(int)n_extnsns,GenDef);
			if (query==EXISTS)
			    return 1;
			else if (query==INSOME || query==INALL) {
			    arrcpy(ad,GenDef);
			    if (query==INSOME && prove(thend+1,1)==1)
				return 1;
			    else if (query==INALL && prove(thend+1,1)==0)
				return 0;
			}
			if (flagS)
			    for (bufor[0]='x'; bufor[0]!='y' && bufor[0]!='n'; ) {
				printf("- continue [y/n] : ");
				sysnextline(bufor,128);
				if (bufor[0]=='n')
				    return 2;
			    }
		    }
		}
	    } else {
		if (flagJ)
		    GDsetListInsert(&MinUnconsList,GenDef,dno,&m_MinUnconsList);
		return 3;
	    }
	} else
	    return 3;
    }
    if (answer!=1 && level<defstop) {
	GenDef[level]=1;
	more=dynamic_build_ratext(query,level+1,eoi,ff,numb,flagC,flagS,flagG,flagJ,defstop,flagV);
	if (more!=3)
	    return more;
	GenDef[level]=0;
	more=dynamic_build_ratext(query,level+1,eoi,ff,numb,flagC,flagS,flagG,flagJ,defstop,flagV);
    }
    return more;
}

allrational_od(query,eoi,flagC,flagS,flagG,flagJ,defstop,mode,flagV)
int query,eoi,flagC,flagS,flagG,flagJ,defstop,mode,flagV;
{
    zeroarr(Segment);
    return order_dynamic_build_ratext(query,0,eoi,flagC,flagS,flagG,flagJ,defstop,mode,flagV);
}

order_dynamic_build_ratext(query,level,eoi,flagC,flagS,flagG,flagJ,defstop,mode,flagV)
int query,level,eoi,flagC,flagS,flagG,flagJ,defstop,mode,flagV;
{
    int i,ffc,ftu,ff,newff,k,outside,answer=0,more=3;
    long avoid=0;
    char bufor[128];

    if (level==0 || Segment[level-1]) {
	if ((flagG || not_dominates_any_of(Segment,ExtnsnsList,dno,&n_covered))
	&& (!flagJ || not_dominates_any_of(Segment,MinUnconsList,dno,&n_uncons))) {
	    if (flagG || uncomparable_with_list(Segment,ExtnsnsList,dno,&n_covered)) {
		n_candidates++;
		for (ffc=i=0; i<dno; i++) {
		    Used[i]=ad[i]=0;
		    if (Segment[i])
			Order[ffc++]=i;
		}
		for (i=0; i<dno; i++)
		    if (!Segment[i])
			Order[ffc++]=i;
		if (flagV) {
		    emitarr("Segment:",Segment,0);
		    emitarr("Order:",Order,1);
		}
		ff=eoi;
		outside=0;
		while (1) {
		    for (ftu=0; ftu<dno; ftu++) {
			k=Order[ftu];
			if (Used[k])
			    continue;
			if (just[k]==-1 || adjc_test3(eoi,ff,&newff,k,flagV)!=1) {
			    if (prove(preq[k],1)) {
				if (mode && !Segment[k]) {
				    outside=1;
				    if (flagV)
					printf("Outside\n");
				    break;
				}
				ff=newff;
				Used[k]=ad[k]=1;
				break;
			    }
			} else if (flagJ) {
			    ad[k]=1;
			    if (not_dominates_any_of(ad,MinUnconsList,dno,&avoid)) {
				GDsetListUpdate(MinUnconsList,ad,dno,&m_MinUnconsList);
				GDsetListInsert(&MinUnconsList,ad,dno,&m_MinUnconsList);
			    }
			    ad[k]=0;
			}
			if (ff>eoi)
			    dttable[ff-1]=SEMI;
			dttable[ff]=EOI;
		    }
		    if (ftu==dno || outside)
			break;
		} /* while(1) */
		answer=5;
		if (!outside && (ff==eoi || (answer=prove(eoi+1,0))==0) &&
		/* final check succeed */
		(!flagG && uncomparable_with_list(ad,ExtnsnsList,dno,&avoid))
		|| (flagG && coincide(ad,Segment,dno))) {
		    n_extnsns++;
		    if (!flagG)
			GDsetListInsert(&ExtnsnsList,ad,dno,&m_ExtnsnsList);
		    if (!flagC)
			emitset("Rational extension",(int)n_extnsns,Used);
		    if (query==EXISTS)
			return 1;
		    else if (query==INSOME || query==INALL) {
			arrcpy(ad,Used);
			if (query==INSOME && prove(thend+1,1)==1)
			    return 1;
			else if (query==INALL && prove(thend+1,1)==0)
			    return 0;
		    }
		    if (flagS)
			for (bufor[0]='x'; bufor[0]!='y' && bufor[0]!='n'; ) {
			    printf("- continue [y/n] : ");
			    sysnextline(bufor,128);
			    if (bufor[0]=='n')
				return 2;
			}
		} else if (flagJ && answer==1) {
		    if (not_dominates_any_of(ad,MinUnconsList,dno,&avoid)) {
			GDsetListUpdate(MinUnconsList,ad,dno,&m_MinUnconsList);
			GDsetListInsert(&MinUnconsList,ad,dno,&m_MinUnconsList);
		    }
		}
	    }
	} else
	    return 3;
    }
    if (answer!=1 && level<defstop) {
	Segment[level]=1;
	more=order_dynamic_build_ratext(query,level+1,eoi,flagC,flagS,flagG,flagJ,defstop,mode,flagV);
	if (more!=3)
	    return more;
	Segment[level]=0;
	more=order_dynamic_build_ratext(query,level+1,eoi,flagC,flagS,flagG,flagJ,defstop,mode,flagV);
    }
    return more;
}

adjc_test1(tab,eoi,ff)
int *tab,eoi,*ff;
{
    int i,k,answer=-1,more=1;

    *ff=eoi;
    for (i=0; i<dno; i++)
	if (tab[i] && (k=just[i])>0)
	    for (more=1; more; ) {
		dttable[(*ff)++]=AND;
		dttable[(*ff)++]=LFT;
		while (dttable[k] != COMMA && dttable[k] != ENT)
		    dttable[(*ff)++]=dttable[k++];
		dttable[(*ff)++]=RGT;
		more=(dttable[k++]==COMMA) ? 1 : 0;
	    }
    if (*ff>eoi)
	dttable[(*ff)++]=SEMI;
    dttable[*ff]=EOI;
    if (dttable[eoi] != EOI)
	answer=prove(eoi+1,0);
    return answer;
}

adjc_test2(eoi,ff,i,flagV)
int eoi,ff,i,flagV;
{
    int answer=-1,k=just[i],more=1;

    if (ff>eoi)
	ff--;
    if (k>0)
	while (more) {
	    dttable[ff++]=AND;
	    dttable[ff++]=LFT;
	    while (dttable[k] != COMMA && dttable[k] != ENT)
		dttable[ff++]=dttable[k++];
	    dttable[ff++]=RGT;
	    more=(dttable[k++]==COMMA) ? 1 : 0;
	}
    if (ff>eoi)
	dttable[ff++]=SEMI;
    dttable[ff]=EOI;
    if (flagV && ff>eoi)
	printformula(eoi+1);
    if (dttable[eoi] != EOI)
	answer=prove(eoi+1,0);
    if (flagV)
	printf("  answer=%d\n",answer);
    return answer;
}

adjc_test3(eoi,ff,newff,i,flagV)
int eoi,ff,*newff,i,flagV;
{
    int answer=-1,more=1,k=just[i];

    *newff=(ff>eoi)?ff-1:ff;
    while (more) {
	dttable[(*newff)++]=AND;
	dttable[(*newff)++]=LFT;
	while (dttable[k] != COMMA && dttable[k] != ENT)
	    dttable[(*newff)++]=dttable[k++];
	dttable[(*newff)++]=RGT;
	more=(dttable[k++]==COMMA) ? 1 : 0;
    }
    dttable[(*newff)++]=SEMI;
    dttable[*newff]=EOI;
    if (flagV) {
	printformula(eoi+1);
	emitset("Theory",0,ad);
    }
    if (dttable[eoi] != EOI)
	answer=prove(eoi+1,0);
    if (flagV)
	printf("  answer=%d\n",answer);
    return answer;
}

adjc_test4(tab,eoi,ff,i,flagV)
int *tab,eoi,*ff,flagV;
{
    int k,answer=-1,more=1;

    if (i==-1)
	return -1;
    if ((k=just[i]) > 0) {
	if (*ff>eoi)
	    (*ff)--;
	while (more) {
	    dttable[(*ff)++]=AND;
	    dttable[(*ff)++]=LFT;
	    while (dttable[k] != COMMA && dttable[k] != ENT)
		dttable[(*ff)++]=dttable[k++];
	    dttable[(*ff)++]=RGT;
	    more=(dttable[k++]==COMMA) ? 1 : 0;
	}
	dttable[(*ff)++]=SEMI;
	dttable[*ff]=EOI;
	if (flagV)
	    printformula(eoi+1);
    }
    if (dttable[eoi] != EOI)
	answer=prove(eoi+1,0);
    if (flagV)
	printf("  answer=%d\n",answer);
    return answer;
}

arrcpy(A,B)
int *A,*B;
{
    int i;

    for (i=0; i<dno; i++)
	A[i]=B[i];
}

emitarr(s,A,nl)
char *s;
int *A,nl;
{
    int i;

    printf("%s ",s);
    for (i=0; i<dno; i++)
	printf("%d ",A[i]);
    if (nl)
	printf("\n");
}

zeroarr(A)
int *A;
{
    int i;

    for (i=0; i<dno; i++)
	A[i]=0;
}
