
/*
 *      colort.h
 *      Global color name definitions for the Color Table
 *      program.
 *
 *      colort.h contains the default (pre-X11R4) definitions
 *      of 66 colors.
 *
 *      colortr4.h contains the X11R4 version, highly edited.
 *
 */


/*
 *      Global colour name definitions, edited from X11R4 rgb data base.
 *
 */
#define MAX_COLORS      255


char                    *colornames[ MAX_COLORS ] =
                        { 
                        "black",
                        "navyblue",
                        "mediumblue",
                        "blue",
                        "darkgreen",
                        "deepskyblue",
                        "darkturquoise",
                        "green2",
                        "springgreen2",
                        "cyan2",
                        "turquoise1",
                        "mediumspringgreen",
                        "green",
                        "springgreen",
                        "cyan",
                        "midnightblue",
                        "dodgerblue",
                        "lightseagreen",
                        "forestgreen",
                        "seagreen",
                        "darkslategrey",
                        "limegreen",
                        "mediumseagreen",
                        "turquoise",
                        "royalblue",
                        "royalblue2",
                        "steelblue",
                        "darkslateblue",
                        "royalblue1",
                        "mediumturquoise",
                        "seagreen2",
                        "seagreen1",
                        "darkolivegreen",
                        "steelblue2",
                        "cadetblue",
                        "steelblue1",
                        "cornflowerblue",
                        "mediumaquamarine",
                        "dimgrey",
                        "slateblue",
                        "olivedrab",
                        "slategrey",
                        "chartreuse2",
                        "aquamarine2",
                        "lightslategrey",
                        "slateblue2",
                        "mediumslateblue",
                        "lawngreen",
                        "skyblue2",
                        "chartreuse",
                        "aquamarine",
                        "slateblue1",
                        "lightslateblue",
                        "skyblue",
                        "lightskyblue",
                        "skyblue1",
                        "blueviolet",
                        "saddlebrown",
                        "darkslategray2",
                        "cadetblue2",
                        "darkseagreen",
                        "palegreen2",
                        "purple2",
                        "mediumpurple",
                        "darkviolet",
                        "darkslategray1",
                        "cadetblue1",
                        "palegreen",
                        "darkorchid",
                        "yellowgreen",
                        "palegreen1",
                        "purple1",
                        "mediumpurple2",
                        "purple",
                        "sienna",
                        "lightskyblue2",
                        "brown",
                        "mediumpurple1",
                        "lightblue",
                        "greenyellow",
                        "paleturquoise2",
                        "paleturquoise",
                        "maroon",
                        "lightsteelblue",
                        "powderblue",
                        "lightskyblue1",
                        "firebrick",
                        "darkorchid2",
                        "lightblue2",
                        "olivedrab2",
                        "darkseagreen2",
                        "darkgoldenrod",
                        "slategray2",
                        "mediumorchid",
                        "paleturquoise1",
                        "rosybrown",
                        "lightsteelblue2",
                        "darkolivegreen2",
                        "darkkhaki",
                        "darkorchid1",
                        "lightblue1",
                        "grey",
                        "olivedrab1",
                        "darkseagreen1",
                        "slategray1",
                        "mediumvioletred",
                        "lightsteelblue1",
                        "darkolivegreen1",
                        "red3",
                        "indianred",
                        "chocolate3",
                        "peru",
                        "rosybrown3",
                        "burlywood3",
                        "lemonchiffon3",
                        "violetred",
                        "mediumorchid2",
                        "lightcyan2",
                        "chocolate",
                        "tan",
                        "lightgrey",
                        "thistle",
                        "orchid",
                        "goldenrod",
                        "palevioletred",
                        "gainsboro",
                        "plum",
                        "burlywood",
                        "mediumorchid1",
                        "honeydew2",
                        "azure2",
                        "lightcyan",
                        "lavender",
                        "darksalmon",
                        "red2",
                        "magenta2",
                        "deeppink2",
                        "firebrick2",
                        "maroon2",
                        "violetred2",
                        "brown2",
                        "orangered2",
                        "tomato2",
                        "indianred2",
                        "coral2",
                        "hotpink2",
                        "darkorange2",
                        "chocolate2",
                        "sienna2",
                        "palevioletred2",
                        "orchid2",
                        "salmon2",
                        "violet",
                        "lightsalmon2",
                        "orange2",
                        "tan2",
                        "lightpink2",
                        "pink2",
                        "darkgoldenrod2",
                        "plum2",
                        "goldenrod2",
                        "rosybrown2",
                        "burlywood2",
                        "gold2",
                        "peachpuff2",
                        "navajowhite2",
                        "thistle2",
                        "bisque2",
                        "mistyrose2",
                        "wheat2",
                        "lightgoldenrod2",
                        "lightgoldenrod",
                        "antiquewhite2",
                        "lavenderblush2",
                        "seashell2",
                        "khaki2",
                        "palegoldenrod",
                        "cornsilk2",
                        "lemonchiffon2",
                        "snow2",
                        "yellow2",
                        "lightyellow2",
                        "ivory2",
                        "lightcoral",
                        "khaki",
                        "aliceblue",
                        "honeydew",
                        "azure",
                        "sandybrown",
                        "wheat",
                        "beige",
                        "whitesmoke",
                        "mintcream",
                        "ghostwhite",
                        "salmon",
                        "antiquewhite",
                        "linen",
                        "lightgoldenrodyellow",
                        "oldlace",
                        "red",
                        "magenta",
                        "deeppink",
                        "firebrick1",
                        "maroon1",
                        "violetred1",
                        "brown1",
                        "orangered",
                        "tomato",
                        "hotpink",
                        "indianred1",
                        "hotpink1",
                        "coral1",
                        "darkorange1",
                        "chocolate1",
                        "coral",
                        "sienna1",
                        "palevioletred1",
                        "orchid1",
                        "darkorange",
                        "salmon1",
                        "lightsalmon",
                        "orange",
                        "tan1",
                        "lightpink1",
                        "pink1",
                        "lightpink",
                        "darkgoldenrod1",
                        "plum1",
                        "pink",
                        "goldenrod1",
                        "rosybrown1",
                        "burlywood1",
                        "gold",
                        "peachpuff",
                        "navajowhite",
                        "thistle1",
                        "moccasin",
                        "bisque",
                        "mistyrose",
                        "wheat1",
                        "blanchedalmond",
                        "lightgoldenrod1",
                        "papayawhip",
                        "antiquewhite1",
                        "lavenderblush",
                        "seashell",
                        "khaki1",
                        "cornsilk",
                        "lemonchiffon",
                        "floralwhite",
                        "snow",
                        "yellow",
                        "lightyellow",
                        "ivory",
                        "white"
                };

/*
 *      end of file
 */
