#include <stdio.h>
#include <string.h>

#include "litset.h"
#include "token.h"
#include "putnam.h"

int pas(void);

setptr std2cnf(int p, int *tab)
{
	int current, righttoken, lefttoken;
	setptr S;
	clause C;
	collectionptr l;

	if (p<0) return NULL;

	S = create_set();
	current = p;

	if (tab[p] != LFT) {
		C = create_clause();
		if ((tab[p] == VAR && tab[p+2] == OR) ||
			 (tab[p] == NEG && tab[p+1] == VAR && tab[p+3] == OR)) {
			 /* single clause formula */
		 righttoken = firststop(p,tab)-1;
		 C = extract_clause(p,righttoken,tab);
		 if (C==NULL) return NULL;
		 l = create_memcollection(C);
		 insert_set(S,l);
		 return S;
		}
	}
	current = p;
   while (1) {
      if (tab[current] == LFT) {  /* finding next clause */
		  righttoken = matchparenthesis(current,tab);
		  if (righttoken < 0) return NULL;
		  else {
			  lefttoken = current+1;
			  current = righttoken+1;
			  righttoken--;
		  }
		 }
		 else if (tab[current] == NEG) {
				lefttoken = current;
				righttoken= current+2;
				current = current+3;
		 }
		 else if (tab[current] == VAR) {
			lefttoken = current;
			righttoken= current+1;
			current = current+2;
		 }
		else if (stopsymbol(tab[current])==1) break;
      
	  /* convert the current clause */
	  C = extract_clause(lefttoken,righttoken,tab);
	  if (C==NULL) return NULL;
	  l = create_memcollection(C);
	  insert_set(S,l);

     /* test new current symbol */
	  if (stopsymbol(tab[current])==0 && tab[current]!=AND) return NULL;
          else if (tab[current]==AND) current++;
	  else return S;
	}
	return S;
}

blokptr blk2cnf(int p, int *tab)
{
	int current, no;
	setptr S;
	memsetptr memS;
	blokptr B;

	if (p<0) return NULL;
	if (tab[p]==SEMI) return NULL;
	current = p;
	B = create_blok();
	while (tab[current] != ENT) {
		S = std2cnf(current, tab);
		memS = create_memset(S);
		no = insert_blok(B,memS);
		if (no < 1) return B;
		while (tab[current]!=COMMA && tab[current]!=ENT) current++;
		if (tab[current]==COMMA) current++;
	}
	return B;
 }

int is_cnf(p,tab)
	int p, tab[];
{
   int ans, current, righttoken, lefttoken;

   current = p;
   if (tab[p] != LFT) {
	if (tab[p] == VAR && tab[p+2] == OR) {
	    righttoken = firststop(p,tab)-1;
	    return is_clause(p,righttoken,tab);
	}
	else if (tab[p] == NEG && tab[p+1] == VAR && tab[p+3] == OR) {
	    righttoken = firststop(p,tab)-1;
	    return is_clause(p,righttoken,tab);
	}
   }
   current = p;
   while (1) {
      /*printf("current position %d\n",current); fflush(stdout);*/
      if (tab[current] == LFT) {  /* finding next clause */
	 /*printf("search to match '(' at %d\n",current);*/
	 righttoken = matchparenthesis(current,tab);
	 /*printf("')' found at %d\n",righttoken);*/
	 if (righttoken < 0) return -1;
	 else {
		lefttoken = current+1;
		current = righttoken+1;
		righttoken--;
	 }
	}
		  else if (tab[current] == NEG) {
	lefttoken = current;
	righttoken= current+2;
	current = current+3;
      }
      else if (tab[current] == VAR) {
	printf("single variable (%d)\n",current);
	lefttoken = current;
	righttoken= current+1;
        current = current+2;
		}
      else if (stopsymbol(tab[current])==1) return 1;
      
     /* test the current clause */
     if ((ans=is_clause(lefttoken,righttoken,tab))<=0) return ans;
     printf(" clause finished (%d)\n", current);

     /* test new current symbol */
     if (stopsymbol(tab[current])==0 && tab[current]!=AND) return 0;
     else if (tab[current]==AND) current++;
     else return 1;
   }
}


clause extract_clause(int lft, int rgt, int* tab)
{
	int p, sign;
	clause C;
	atomptr A;

	C = create_clause();
	p = lft;
	while (p<=rgt) {
		if (tab[p]==NEG) {
		p++;
		sign = -1;
		}
		else sign = 1;
		if (tab[p]==VAR) {
		  A = create_atom(sign*tab[p+1]);
		  insert_clause(C,A);
		  p = p+2;
		}
		else return NULL;

		if (tab[p]==OR) p++;
		else if (p==rgt+1) {
			/*show_clause(C,NULL);*/
			return C;
		}
		else return NULL;
	}
	return NULL;
}

int is_clause(lft, rgt, tab)
	int lft, rgt, tab[];
{
	int p;
	p = lft;
	while (p<=rgt) {
		if (tab[p]==NEG) p++;

      if (tab[p]==VAR) {
	p = p+2;
		}
		else return -1;
		if (tab[p]==OR) p++;
		else if (p==rgt+1) return 1;
		else return 0;
	}
	return -1;
}

setptr linkcontext(setptr *mainth, int limmn, setptr *auxth, int limaux,
						 int *indextab, int mode)
{
	setptr Ctx;
	int i;

	Ctx =  create_set();

	for (i = 0 ; i<limmn ; i++)
		Ctx = add_set(Ctx,mainth[i]);

	if (mode) {
		for (i = 0 ; i<limaux ; i++)
			if (indextab[i]) Ctx = add_set(Ctx,auxth[i]);
	}

	return Ctx;
}



int matchparenthesis(p,tab)
   int p, tab[];
{
   int i, j, count=1;

   i = p+1;
   while (count>0) {
      if ((j=tab[i++])==LFT) count++;
      else if(j==RGT) count--;
   }
   return i-1;
}

int stopsymbol(tok)
	int tok;
{
   if (tok==SEMI || tok==COLON || tok==ENT || tok==COMMA) return 1;
   else return 0;
}

int firststop(p,tab)
   int p, tab[];
{
    while (stopsymbol(tab[p])==0) 
	   if (tab[p]==VAR) p = p+2;
	   else p++;
	 return p;
}
   
