/* litset.h */

/* ATOMS */

typedef int drs_atom;

typedef struct member_atom_struct {
	drs_atom v;
	struct member_atom_struct *next;
	struct member_atom_struct *prev;
} member_atom;

typedef member_atom* atomptr;


/* CLAUSES or LISTS OF ATOMS */

typedef struct drs_collection_struct {
	int size;
	atomptr head;
} drs_collection;

typedef drs_collection* litlistptr;
typedef litlistptr clause;

typedef struct member_collection_struct {
	litlistptr c;
	struct member_collection_struct *nextc;
	struct member_collection_struct *prevc;
} member_collection;

typedef member_collection* collectionptr;

/* SETS */

typedef struct drs_set_struct {
	int size;
	collectionptr headc, tailc;
} drs_set;

typedef drs_set* setptr;

typedef struct member_set_struct {
	setptr s;
	struct member_set_struct *nexts;
	struct member_set_struct *prevs;
} member_set;

typedef member_set* memsetptr; 

/* BLOK */
typedef struct drs_blok {
	int size;
	memsetptr heads, tails;
} blok;

typedef blok* blokptr;

/* functions */
atomptr create_atom();
void destroy_atom();
void show_atom();
atomptr copy_atom();
litlistptr create_collection();
clause create_clause();
collectionptr create_memcollection();
setptr create_set();
memsetptr create_memset();
blokptr create_blok();

/* PROTOTYPES OF FUNCTIONS */

/*====================== atoms/literals ============================*/
atomptr create_atom(int);
void destroy_atom(atomptr);
void show_atom(atomptr , char **);
atomptr copy_atom(atomptr);

/*============== lists of atoms/literals, clauses =================*/
litlistptr create_collection(void);
void destroy_collection(litlistptr);
void show_collection(litlistptr, char **);
int insert_collection(litlistptr, atomptr);
litlistptr copy_collection(litlistptr);

clause create_clause(void);
void destroy_clause(clause);
void show_clause(clause, char **);
int insert_clause(clause , atomptr);
clause copy_clause(clause);

collectionptr create_memcollection(litlistptr);
void destroy_memcollection(collectionptr);
void show_memcollection(collectionptr, char **);
int insert_memcollection(collectionptr, atomptr);
collectionptr copy_memcollection(collectionptr);

/*============================ sets ===============================*/
setptr create_set(void);
void destroy_set(setptr);
void show_set(setptr sp, char **);
int insert_set(setptr, collectionptr);
setptr copy_set(setptr);
setptr add_set(setptr,setptr);

memsetptr create_memset(setptr);
void destroy_memset(memsetptr);
void show_memset(memsetptr, char **);
int insert_memset(memsetptr, collectionptr);
memsetptr copy_memset(memsetptr);
memsetptr add_memset(memsetptr,memsetptr);

/*============================ bloks ===============================*/
blokptr create_blok(void);
void destroy_blok(blokptr);
void show_blok(blokptr, char **);
int insert_blok(blokptr, memsetptr);

