/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#define PROGSUPHEADER "/usr/local/etc/sat/lib/progsup.h"
/*#define PROGSUPOBJ "/usr/local/etc/sat/lib/libprogsup.a"	*/
#define PROGSUPOBJ "/usr/local/etc/sat/lib/libsat.a"

#ifdef sgi
#	define CCOMPILER "cc"
#else
#	define CCOMPILER "gcc"
#endif

/* define EXTRASALCCOPTS if you need to have sal C compiles
	load extra libraries or add 'cc' command line definitions or options */
#ifdef __svr4__
#	define EXTRASALCCOPTS "-lnsl"
#endif

#define BTABREAD "/usr/local/etc/sat/lib/btabread"
#define RELMOD "/usr/local/bin/relmod"
#define SPP "/usr/local/bin/spp"

#define HOSTINFO "/etc/hostinfo"

#define TABDIFF "/usr/local/etc/sat/lib/tabdiff"

#define MAKE "/usr/local/gnu/bin/make"

#define SALINCLUDE "/usr/local/etc/sat/salinclude"

#define SYSDBPATH "/usr/local/etc/sat/db"

#define PULLLOCKPATH "/usr/spool/pulllock"

#define USERALIASFILE "/usr/local/etc/sat/lib/useraliasfile"
#define DISTALIASFILE "/usr/local/etc/sat/lib/distaliasfile"

/* Default User Aliases */
#define DEFOWNERALIAS		"ROOT@MAIN"
#define DEFMODIFIERALIAS	"NOBODY"
#define DEFAPPENDERALIAS	"NOBODY"
#define DEFREADERALIAS		"ANYBODY"

/* Default Host Aliases */
#define DEFMODELALIAS	"UNIXMODEL"
#define DEFTRUSTEDALIAS	"UNIXTRUSTED"
#define DEFCOPYALIAS	"UNIXCOPY"
#define DEFACCESSALIAS	"UNIXACCESS"

/* The maximum amount of time for satd to wait for another process to
	release the ClobberLock */
#define MAXLOCKWAIT 10

/* The maximum amount of time to wait for the Internet connection to
	satd to be established. */
#define MAXCONNECTWAIT 10


/* The uid you want btabread and tabread to read data as,
	this uid really can be 0 on all but NFS systems.
	On NFS systems root cannot read the database if it
	is remote mounted.
*/
#define SOMEONEOTHERTHANROOT 1


/*
	How many hosts to contact after receiving an update,
	to tell that there is a new update.
*/
#define HOSTSTOCONTACT 20

/* 
	Must be greater than the total of the largest sets of model,
	trusted, copy, and access hosts.
*/

#define MAXHOSTS 1000

/*
	These wait times are the amount of time to wait after
	receiving a pull request for that host distribution category.
	Time is in seconds. All times MUST be greater than zero.
	The time should be based on the maximum time for
	a 25k network data transfer under normal circumstances.
	The value for ACCESSWAIT is often smaller because of NFS
	and caching.
	Be liberal in your estimates.
*/

#define ACCESSWAIT 3
#define COPYWAIT 5

/*
	The Maximum number of access hosts remote mounting a relation
	from one host.
*/
#define MAXACCESSERS 20


/* Define this next if you expect to read databases over Sun NFS */
#define NFS


#define ARCHIVE "/usr/local/etc/sat/lib/archive"

#define UNARCHIVE "/usr/local/etc/sat/lib/unarchive"


/* Number of seconds for an access host doing a pull to wait on its 
	remote mount host to be updated */
#define WAITFORUPDATE (20*60)

/* The amount of time in seconds a sending host will wait to get its update, or
	to get the clobber lock. */
#define WAITTOSEND (20*60)

/* The number of seconds to wait between sending pull requests during
	the distribution of data. (Should be small.)
*/
#define WAITBETWEENPULLS 1


/*
	A number of a group that you trust as much as root.
*/
#define SECUREGROUP 0


/*
	ITBLSIZ - The initial size of tables allocated by SAL.
	This does not limit the size, but rather acts has
	a hint as to the average table size.
*/
#define ITBLSIZ (128)


/* Not at UofU? TAKE THIS OUT! */
/* #define UTAH */

/*
	Path variable used by relmod and satd to provide an execution
	environment for make's and running report, prog, and check.
	All elements should be trusted.
	Dot will always be the relation's directory.
*/

#define PATH "/usr/ucb:/usr/bin:/bin:/etc:.:/usr/local/bin:/usr/local/gnu/bin"
