/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>

#include "ps.h"

#ifdef TM_IN_SYS_TIME /* HAVE_SYS_TIME_H */
#include <sys/time.h>
#else
#include <time.h>
#endif

String
asciitime (tim)
   time_t tim;
{
  char buf[128];
  struct tm *tm;

  tm = localtime (&tim);

  (void) sprintf (buf, "%04d%02d%02d%02d%02d%02d",
		  tm->tm_year + 1900,
		  tm->tm_mon + 1,
		  tm->tm_mday,
		  tm->tm_hour,
		  tm->tm_min,
		  tm->tm_sec);
  return (FreeLater (strdup (buf)));
}

Integer
Saltime ()
{
  time_t time ();
  return ((Integer) time (0));
}


String
Salctime (tim)
     time_t tim;
{
  char buf[100];
  (void) strcpy (buf, ctime (&tim));
  if (*buf)
    buf[strlen (buf) - 1] = '\0';	/* strip newline at end */
  return (FreeLater (strdup (buf)));
}
