#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

/* raphael added 1995: need to preserve permissions and ownerships of temp
files that are intended for eventual rename back to original file.
Return open file for newly created NewName on success, NULL on failure.
*/

FILE *CloneFile(RealName, NewName)
char *RealName, *NewName;
{
	FILE *OutFile;
	struct stat StatBuf;

	if (stat(RealName, &StatBuf))
		{
		(void) fprintf(stderr,"Cannot stat %s.\n",RealName);
		return(NULL);
		}
	OutFile=fopen(NewName,"w");
	if(OutFile == NULL)
		{
		(void) fprintf(stderr,"Cannot open %s.\n",NewName);
		return(NULL);
		}
	if (chmod (NewName, 0777 & StatBuf.st_mode))
		{
		(void) fprintf(stderr,"Cannot chmod %s.\n",NewName);
		(void) fclose(OutFile);
		return(NULL);
		}
	if (chown (NewName, StatBuf.st_uid, StatBuf.st_gid))
		{
		(void) fprintf(stderr,"Cannot chown %s.\n",NewName);
		(void) fclose(OutFile);
		return(NULL);
		}
	return(OutFile);
}
