/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <pwd.h>
#include <stdio.h>
#include <signal.h>
#include "ps.h"
#include "errs.h"

int
DoRemote (command, host, argc, argv)
     char *command;
     char *host;
     int argc;
     char *argv[];
{
  int s;
  int i;
  char buf[2048];
  struct passwd *pw;
  RETSIGTYPE (*savefunc) ();
  RETSIGTYPE doalrm ();

  pw = getpwuid (getuid ());
  if (!pw)
    return (-1);

  savefunc = signal (SIGALRM, doalrm);
  alarm (MAXCONNECTWAIT);
  if ((s = openserver (host, "satd")) == -1)
    {
      return (-1);
    }
  alarm (0);
  (void) signal (SIGALRM, savefunc);

  (void) sprintf (buf, "%s\n", command);
  if (write (s, buf, strlen (buf)) == -1)
    return (-1);

  {
    char *p, *getenv ();

    p = getenv ("SATID");
    (void) sprintf (buf, "%s\n", p ? p : "unknownsatid");
    if (write (s, buf, strlen (buf)) == -1)
      return (-1);
  }

  (void) sprintf (buf, "%d\n", argc);
  if (write (s, buf, strlen (buf)) == -1)
    return (-1);

  (void) sprintf (buf, "%s\n", pw->pw_name);
  if (write (s, buf, strlen (buf)) == -1)
    return (-1);

  for (i = 1; i < argc; i++)
    {
      (void) sprintf (buf, "%s\n", argv[i]);
      if (write (s, buf, strlen (buf)) == -1)
	return (-1);
    }

  return (s);
}

RETSIGTYPE
doalrm ()			/* mainly to interrupt long socket timeouts */
{
  return;
}
