/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "ps.h"

static char *strList[10000];
static int slptr;

void FreeAll ()
{
  int i;
  if (slptr == 0)
    return;
  for (i = 0; i < slptr; i++)
    free (strList[i]);
  slptr = 0;
}

/*
	FreeLater() can be called by any string returning routine
	that strdup's is return value.  The free will take place at the
	end of the current statement.

	Note that it is necessary to strdup most string return
	arguments as if the function is called within another function
	call more than once, a static buffer would be over written at
	the second call.
*/

String
FreeLater (s)
     char *s;
{
  if (slptr >= (sizeof strList / sizeof (char *)))
      RTError ("The 'strings to be freed' list has run out of room");
  strList[slptr++] = s;
  return ((String) s);
}
