/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <sys/types.h>
#include <sys/param.h>

#include "nethead.h"
#include "ps.h"
String hostinfo ();

char *
getfulldomainname (h)
     struct hostent *h;
{
  int ind;
  char *hinfo;

  if (!h)
    return ("");

  if (strchr (h->h_name, '.'))
    return (h->h_name);
  else
    for (ind = 0; h->h_aliases[ind]; ind++)
      if (strchr (h->h_aliases[ind], '.'))
	return (h->h_aliases[ind]);
  if (hinfo = hostinfo ("FullHostName"))
	return(hinfo);
  return ("");
}

char *
fullhostname ()
{
  static char host[MAXHOSTNAMELEN];

  if (*host)
    return (host);

  (void) gethostname (host, sizeof host);
  if (strchr (host, '.'))
    return (host);

  (void) strncpy (host, getfulldomainname (gethostbyname (host)), MAXHOSTNAMELEN);
  return (host);
}



char *
hostname ()
{
  static char buf[1024];
  char *p;

  if (*buf)
    return (buf);

  (void) strncpy (buf, fullhostname (), sizeof buf);

  p = (char *) strchr (buf, '.');
  if (p)
    *p = '\0';

  return (buf);
}


#if 0
/* This function appears to be unreferenced, and hpux already has it */

char *
_gethostname ()
{
  static char host[MAXHOSTNAMELEN];

  if (*host)
    return (host);

  (void) gethostname (host, sizeof host);
  host[MAXHOSTNAMELEN - 1] = '\0';
  return (host);
}
#endif
