/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "ps.h"

static int argc, envC;
static char **argv, **envp;


void Init (ac, av, ep)
     int ac;			/* This really is an int, NOT an Integer */
     char *av[];
     char *ep[];
{
  char **p;

  argv = av;
  envp = ep;
  argc = ac;
  for (p = envp; *p; p++)
    envC++;
}

Integer
Salargc ()
{
  return ((Integer) argc);
}
String
Salargv (i)
     int i;
{
  if (i >= argc)
    return ("");
  return (argv[i]);
}
Integer
/* had a name clash with setenv(). */
envc ()
{
  return ((Integer) envC);
}
String
Salenvp (i)
     int i;
{
  if (i >= envC)
    return ("");
  return (envp[i]);
}

extern int errno;
Integer
Salerrno ()
{
  return ((Integer) errno);
}
