/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include "ps.h"
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif
#include <sys/stat.h>

#include "db.h"

#ifdef TM_IN_SYS_TIME /* HAVE_SYS_TIME_H */
#include <sys/time.h>
#else
#include <time.h>
#endif

TouchLastModified (sch)
     struct scheme *sch;
{
  char buf[2048];
  int fd;

  (void) sprintf (buf, "%s/%s", sch->path, LASTMODIFIED);
  if ((fd = open (buf, O_CREAT | O_WRONLY | O_TRUNC, 0640)) == -1)
    return (FALSE);
  (void) close (fd);
  return (TRUE);
}

char *
GetLastModifiedTime (sch)
     struct scheme *sch;
{
  static char buf[2048];
  struct stat st;
  time_t tim;
  struct tm *tm;

  (void) sprintf (buf, "%s/%s", sch->path, LASTMODIFIED);
  if (stat (buf, &st) == -1)
    return ("00000000000000");
  tim = st.st_mtime;
  tm = gmtime (&tim);

  (void) sprintf (buf, "%04d%02d%02d%02d%02d%02d",
		  tm->tm_year + 1900,
		  tm->tm_mon + 1,
		  tm->tm_mday,
		  tm->tm_hour,
		  tm->tm_min,
		  tm->tm_sec);
  return (buf);
}
