/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <stdio.h>
#include <syslog.h>
#include "ps.h"

String
Salpipe (s)
     char *s;
{
  FILE *fp, *popen ();
  char buf[MAXSTR];
  int c;
  int bp;
  int newlinecnt;

  fp = popen (s, "r");
  if (!fp)
    RTError ("Initialization of command in pipe call failed");

  syslog(LOG_DEBUG, "Salpipe: called popen(%s, r).  COE Flags:", s);
  coeflags();

  bp = 0;
  newlinecnt = 0;
  while (bp < MAXSTR && (c = fgetc (fp)) != EOF)
    {
      if (c == '\n')
	newlinecnt++;
      buf[bp] = c;
      bp++;
    }
  if (bp >= MAXSTR)
    RTError ("Command returned too much output to pipe call");
  if (newlinecnt == 1 && buf[bp - 1] == '\n')
    bp--;			/* Swallow newlines on single line of output */
  buf[bp] = '\0';

  if (pclose (fp) != 0)
    RTError ("Command in pipe call returned a non-zero status");
  return (FreeLater (strdup (buf)));
}
