#include <stdio.h>
#include <errno.h>
#include <syslog.h>
#include <signal.h>
#include "ps.h"

/* Cannot dup sockets, so we popen auxiliary routines and copy results. 
 * If args == NULL, we call system instead of execv.
 */
int
  pipeopen(s, progname, args)
int s; /* socket number */
char *progname, *args[];
{
  char		buf[BUFSIZ];
  int		FromChild[2], ToChild[2], numbytes;
  int		WriterID;
  
  if (pipe(FromChild) == -1) 
    return(1);
  if (pipe(ToChild) == -1) 
    return(1);
  if (fork() == 0) { /* child that will run progname */
    close(0);
    dup(ToChild[0]);
    close(ToChild[1]);
    close(1);
    close(2);
    dup(FromChild[1]);
    dup(FromChild[1]);
    close(FromChild[0]);
    if (args == NULL) {
      _exit(system(progname));
    } else {
      (void) execv(progname, args);
      syslog(LOG_ERR, "pipeopen: execv(%s) failed: %m",
	     progname);
      _exit(127);
    }
  } /* child running progname */
  close(ToChild[0]);
  close(FromChild[1]);
  if ((WriterID = fork()) == 0) { /* writer to progname */
    close(FromChild[0]);
    while ((numbytes=read(s, buf, sizeof buf)) > 0) {
      write(ToChild[1], buf, numbytes);
    }
    return(0);
  } /* writer to progname */
  close(ToChild[1]);
  while ((numbytes=read(FromChild[0], buf, sizeof buf)) > 0) {
    write(s, buf, numbytes);
  }
  kill(WriterID,SIGKILL);
  return(0);
} /* pipeopen */
