/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <stdio.h>
#include <math.h>


#include "ps.h"


static char buf[2048];

ReadInteger (I)
     Integer *I;
{
  if (!_ReadString ())
    return (0);
  *I = atoi (buf);
  return (1);
}
ReadReal (r)
     Real *r;
{
  if (!_ReadString ())
    return (0);
  *r = atof (buf);
  return (1);
}
ReadString (s)
     String *s;
{
  if (!_ReadString ()) {
	strcpy(*s, "");
    return (0);
  }
  if (*s)			/* should always be true anyway */
    free (*s);
  *s = (String) strdup (buf);
  return (1);
}



_ReadString ()
{
  int len;
  if (fgets (buf, sizeof buf, stdin) == 0)
    {
      if (ferror (stdin))
	RTError ("A read error occured in a read statement");
      if (isatty (fileno (stdin)))	/* Clears EOF */
	clearerr (stdin);
      return (0);
    }
  len = strlen (buf);
  if (len > 0)
    buf[len - 1] = '\0';	/* Squash newline at end. */
  return (1);
}
