#include <stdio.h>
#include <errno.h>
#include "ps.h"

/* Thu Aug 31 11:26:20 EDT 1989
 * Rename doesn't appear to work properly for all System V TCP/IP 
 * BSD emulation packages.  Build our own out of System V pieces.
 */
int rename(From, To)
#ifdef __STDC__
     const
#endif
       char		*From, *To;
{
  char		Buf[BUFSIZ];
  
  (void)sprintf(Buf, "%s.%d", From, getpid());
  /* Try to link From To, if OK then unlink the old one. */
  if (link(From, To) != -1) {
    if (unlink(From) == -1) {
      sprintf(Buf, "unlink: From=%s \n", From);
      perror(Buf);
      return -1;
    }
    return 0;
  }
  /* Couldn't link, check to see what the error is. */
  if (errno != EEXIST) {
    sprintf(Buf, "link: From=%s; To=%s \n", From, To);
    perror(Buf);
    return -1;
  }
  if (unlink(To) == -1) {
    sprintf(Buf, "unlink: To=%s \n", To);
    perror(Buf);
    return -1;
  }
  /* Try to link again, if we still can't link, give up. */
  if (link(From, To) == -1) {
    sprintf(Buf, "link: From=%s; To=%s \n", From, To);
    perror(Buf);
    return -1;
  }
  if (unlink(From) == -1) {
    sprintf(Buf, "unlink: From=%s \n", From);
    perror(Buf);
    return -1;
  }
}
