/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include "ps.h"

void
Salrename (old, new)
     String old, new;
{
  struct stat statbuf;
  if (stat (new, &statbuf) == 0)
    {				/* new file name already exists */
      if ((statbuf.st_mode & S_IFMT) != S_IFREG)
	{
	  /* not a regular file */
	  (void) fprintf (stderr, "File %s ", new);
	  RTError ("is not a regular file; won't rename");
	}
    }
  if (rename (old, new) == -1)
    {
      (void) fprintf (stderr, "For filenames: %s, %s.\n", old, new);
      RTError ("Rename failed");
    }
}
