/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "ps.h"
#include "errs.h"

String
SatErrMsg (code)
     int code;
{
  switch (code)
    {
    case GOOD:
      return ("Satisfactory completion");
    case BAD_ATTRIBUTE:
      return ("An attribute requested was not found");
    case BAD_DATATYPE:
      return ("A data type for an attribute is wrong");
    case BAD_DEF_IN_SWITCH:
      return ("Bad default taken in switch, and internal botch");
    case BAD_OPEN:
      return ("Open failed");
    case READ_ERROR:
      return ("Read error");
    case OUT_OF_STORAGE:
      return ("Ran out of dynamic storage");
    case BAD_SCHEME_OPEN:
      return ("The scheme for the relation could not be opened");
    case BAD_ARGUMENTS:
      return ("Bad arguments were send, an internal botch has occurred");
    case WRITE_ERROR:
      return ("Write error");
    case REMOTE_OPEN_FAILED:
      return ("Unable to open on remote host");
    case CANT_HAPPEN:
      return ("An internal error design error was detected");
    case SIGNAL_CAUGHT:
      return ("Interrupted by a signal");
    case DATA_OUT_OF_SYNC:
      return ("Data syncronization error");
    case NO_PERMISSION:
      return ("You did not have sufficient privileges");
    case TIMED_OUT:
      return ("Connection to host timed out");
    case BAD_DATA:
      return ("A data item did not match its checktype");
    default:
      return ("Unknown Error");
    }
}
