/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "ps.h"

Integer
split (s, S, n, starflag, c)
     String s, c, *S;
     Integer n;
     Boolean starflag;
{
  Boolean splitat[256];		/* one for each character */
  int i, count;
  char *p, *start;
  char buf[10 * MAXSIMPSTR];

  if (*s == '\0')
    return (0);

  if (strlen (s) >= sizeof buf)
    RTError ("Attempt to split a string that is too big");
  (void) strcpy (buf, s);

  for (i = 0; i < sizeof splitat; i++)
    splitat[i] = FALSE;
  for (p = c; *p; p++)
    splitat[*p] = TRUE;

  start = buf;
  count = 0;
  for (p = buf; *p;)
    {
      if (splitat[*p])
	{
	  *p = '\0';
	  if (count < n)
	    AssignString (&S[count], start);
	  count++;
	  if (starflag)
	    {
	      p++;
	      while (splitat[*p])
		p++;
	    }
	  else
	    p++;
	  start = p;
	}
      else
	p++;
    }
  if (count < n)
    AssignString (&S[count], start);
  count++;
  return (count);
}
