/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "ps.h"

#include "regexp.h"

String
substr (src, pat)
     String src, pat;
{
  char buf[MAXSTR];
  regexp *re;
  int len;

  re = regcomp (pat);
  if (!re)
    RTError ("Bad pattern passed to substr");
  regexec (re, src);
  len = abs (re->startp[0] - re->endp[0]);
  if (len > sizeof buf - 1)
    RTError ("String too long in substr");
  (void) strncpy (buf, re->startp[0], len);
  buf[len] = '\0';
  free (re);
  return (FreeLater (strdup (buf)));
}

String
substitute (old, pat, new)
     String old, pat, new;
{
  char buf[MAXSTR];
  regexp *re;

  re = regcomp (pat);
  if (!re)
    RTError ("Bad pattern passed to substr");
  regexec (re, old);

  regsub (re, new, buf);

  free (re);
  return (FreeLater (strdup (buf)));
}
