/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "ps.h"


String
tr (string, src, dst)
     String string, src, dst;
{
  int len, srclen, dstlen;
  int i;
  char buf[MAXSTR];
  char trbuf[256];

  srclen = strlen (src);
  dstlen = strlen (dst);
  if (srclen != dstlen)
    RTError ("Source and destination strings passed to 'tr' have different lengths");
  for (i = 0; i < sizeof trbuf; i++)
    trbuf[i] = i;
  for (i = 0; i < srclen; i++)
    trbuf[src[i]] = dst[i];

  if ((len = strlen (string)) >= sizeof buf - 1)
    RTError ("String passed to 'tr' is too long");
  for (i = 0; i < len; i++)
    {
      buf[i] = trbuf[*string++];
    }
  buf[i] = '\0';
  return (FreeLater (strdup (buf)));
}
