/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <pwd.h>
#include <stdio.h>

#include "ps.h"

static char username[2048];

char *
UserName ()
{
  char host[1024];
  struct passwd *pw;

  if (*username != '\0')
    return (username);

  (void) strncpy (host, fullhostname (), sizeof host);

  pw = getpwuid (getuid ());
  if (!pw)
    (void) sprintf (username, "nobody@%s", host);
  else
    (void) sprintf (username, "%s@%s", pw->pw_name, host);

  return (username);
}

SetUserName (n)
     char *n;
{
  strncpy (username, n, sizeof username);
}
