/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "sal.h"

void InitBuiltin ()
{
  declarefunc (insertwholefunc ("pipe", DT_STRING, 1, "S", FALSE));
  declarefunc (insertwholefunc ("argc", DT_INTEGER, 0, "", FALSE));
  declarefunc (insertwholefunc ("argv", DT_STRING, 1, "I", FALSE));
  declarefunc (insertwholefunc ("envc", DT_INTEGER, 0, "", TRUE));	/* CFUNC due to name clash  with a variable in setenv() */
  declarefunc (insertwholefunc ("envp", DT_STRING, 1, "I", FALSE));
  declarefunc (insertwholefunc ("errno", DT_INTEGER, 0, "", FALSE));
  declarefunc (insertwholefunc ("syserror", DT_STRING, 1, "I", TRUE));
  declarefunc (insertwholefunc ("cd", DT_VOID, 1, "S", TRUE));
  declarefunc (insertwholefunc ("system", DT_INTEGER, 1, "S", TRUE));
#ifdef BSD
  declarefunc (insertwholefunc ("random", DT_INTEGER, 0, "", TRUE));
  declarefunc (insertwholefunc ("srandom", DT_VOID, 1, "I", TRUE));
#endif
  declarefunc (insertwholefunc ("hostname", DT_STRING, 0, "", TRUE));
  declarefunc (insertwholefunc ("fullhostname", DT_STRING, 0, "", TRUE));
  declarefunc (insertwholefunc ("gethostname", DT_STRING, 0, "", FALSE));
  declarefunc (insertwholefunc ("rand", DT_INTEGER, 0, "", TRUE));
  declarefunc (insertwholefunc ("srand", DT_INTEGER, 1, "I", TRUE));
  declarefunc (insertwholefunc ("atof", DT_REAL, 1, "S", TRUE));
  declarefunc (insertwholefunc ("atoi", DT_INTEGER, 1, "S", TRUE));
  declarefunc (insertwholefunc ("Real", DT_REAL, 1, "I", FALSE));
  declarefunc (insertwholefunc ("trunc", DT_INTEGER, 1, "R", TRUE));
  declarefunc (insertwholefunc ("round", DT_INTEGER, 1, "R", TRUE));
  declarefunc (insertwholefunc ("sleep", DT_VOID, 1, "I", TRUE));
  declarefunc (insertwholefunc ("tempname", DT_STRING, 1, "S", FALSE));
  declarefunc (insertwholefunc ("rename", DT_VOID, 2, "SS", FALSE));
  declarefunc (insertwholefunc ("substr", DT_STRING, 2, "SS", TRUE));
  declarefunc (insertwholefunc ("substitute", DT_STRING, 3, "SSS", TRUE));
  declarefunc (insertwholefunc ("tr", DT_STRING, 3, "SSS", TRUE));
  declarefunc (insertwholefunc ("ostype", DT_STRING, 0, "", TRUE));
  declarefunc (insertwholefunc ("osver", DT_STRING, 0, "", TRUE));
  declarefunc (insertwholefunc ("machinetype", DT_STRING, 0, "", TRUE));
  declarefunc (insertwholefunc ("asciitime", DT_STRING, 1, "I", TRUE));
  declarefunc (insertwholefunc ("ctime", DT_STRING, 1, "I", FALSE));
  declarefunc (insertwholefunc ("time", DT_INTEGER, 0, "", FALSE));

}
