/*LINTLIBRARY*/
/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "schedit.h"

#define sfree(d) if(d){free((char *)d); d=0;}

PartialFreeScheme (sch)
     struct scheme *sch;
{
  int i;
/* This does not free scheme name, path, or attribute names */

  sfree (sch->desc);

  sfree (sch->useraliasfile);
  sfree (sch->distaliasfile);

  sfree (sch->owner);
  sfree (sch->modifier);
  sfree (sch->appender);
  sfree (sch->reader);

  sfree (sch->model_hosts);
  sfree (sch->trusted_hosts);
  sfree (sch->copy_hosts);
  sfree (sch->access_hosts);

  sfree (sch->index_attribute);
  sfree (sch->log_file);

  for (i = 0; i < sch->numattr; i++)
    {
      sfree (sch->at[i].desc);
      if (sch->at[i].checktype == CT_PAT)
	{
	  sfree (sch->at[i].at_patsrc);
	  sfree (sch->at[i].at_comppat);
	}
    }
}
FreeScheme (sch)
     struct scheme *sch;
{
  int i;

  PartialFreeScheme (sch);
  sfree (sch->name);
  sfree (sch->path);
  for (i = 0; i < sch->numattr; i++)
    {
      sfree (sch->at[i].name);
    }
}
