%{
#include <stdio.h>
#include <ctype.h>

#include "y.tab.h"

extern int Line;
extern char Delimiter;
extern int CleanWS;
extern int Swallow;
extern char *strdup();

%}

NAME	[A-Za-z._-][A-Za-z._0-9-]*

%START sppexpr sppcommand text

%%

<sppexpr>\n	{
		BEGIN text;
		Line++;
		return(EOLN);
		}
<sppexpr>{NAME}	{
		yylval.str=strdup(yytext);
		return(NAME);
		}
<sppexpr>[ \t]+	{
		}
<sppexpr>"||"	{
		return(OR);
		}
<sppexpr>"&&"	{
		return(AND);
		}
<sppexpr>.	{
		return(yytext[0]);
		}

<text>.*\n	{
		int i;
		if(yytext[0] != Delimiter)
			{
			Line++;
			if(!Swallow)
				{
				if(CleanWS && isspace(yytext[0]))
					fputs(&yytext[1],stdout);
				else
					fputs(yytext,stdout);
				}
			return(TEXT);
			}
		if(yytext[1] != Delimiter)
			{
			BEGIN sppcommand;
			for(i=yyleng-1;i>0;i--)
				unput(yytext[i]);
			}
		}

<sppcommand>[ \t]*ifhost	{
		BEGIN sppexpr;
		return(IFHOST);
		}
<sppcommand>[ \t]*elif	{
		BEGIN sppexpr;
		return(ELIF);
		}
<sppcommand>[ \t]*else	{
		BEGIN sppexpr;
		return(ELSE);
		}
<sppcommand>[ \t]*endif	{
		BEGIN sppexpr;
		return(ENDIF);
		}
<sppcommand>.	{
		fprintf(stderr,"spp(%d): unknown spp command.\n",Line);
		exit(1);
		}

.		{
		static int inited=0;
		if(inited)
			{
			fprintf(stderr,
				"spp(%d): SHOULD NOT HAPPEN -- reinited.\n",
				Line);
			exit(1);
			}
		inited=1;
		BEGIN text;
		unput(yytext[0]);
		}
