/*
 * Copyright (c) 1989 Brian Sturgill
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Brian Sturgill and Raphael Finkel at the University of Kentucky,
 * Department of Computer Science.  The names of the University or the
 * authors may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <stdio.h>

#include "db.h"

static
Usage()
{
fprintf(stderr,"Usage: convert relationname\n");
exit(1);
}


static struct scheme sch;

main(argc,argv)
int argc;
char *argv[];
{
(void) umask(0027);

if(argc != 2)
	Usage();
if(!ReadScheme(argv[1],&sch))
	{
	(void) fprintf(stderr,"Cannot open scheme for %s.\n",argv[1]);
	exit(1);
	}
if(!WriteScheme(&sch))
	{
	(void) fprintf(stderr,"Error writing scheme -- aborting.\n");
	exit(1);
	}
if(!TouchLastModified(&sch))
	{
	perror("Could not set last modified time");
	exit(1);
	}
exit(0);
}
