#include "global.h"

#define FMXL 80

ishelp(s)
  char *s;
{
  if (strncmp(s,"-help",5) == 0) return 1;
  if (strncmp(s,"-?",2) == 0) return 1;
  return 0;
}

rebuiltoptions(aztab,strtab,lim)
   int aztab[]; 
   char strtab[];
   int lim;
{
   int i=0, k=0;

   for (i='a';i<='z';i++) {
	if (aztab[i]) strtab[k++]=(char)i;
	if (k==lim) break;
   }
   if (k==lim) k--;
   strtab[k] = EOS;
   return k;
}

resetoptions(tab,f,t,v)
   int tab[], f, t, v;
{
   int i;
   i = f;
   while (i<t) tab[i++]=0;
   return (t-f);
}

tb_rulenumber_generated(n,islp)
   int n, islp;
{
   if ((n>1)||(n==0)) {
	if (islp) printf("%d rules\n",n);
        else printf("%d defaults\n",n);
   }
   else if (n==1) {
	if (islp) printf("1 rule\n");
	else printf("1 default\n");
   }
   else return -1;
   return 0;
}
   
tb_enconumber_generated(n)
   int n;
{
   if (n==1) printf("Done (1 encoding).\n");
   else if (n==0) printf("No encodings generated.\n");
   else if (n>0) printf("Done (%d encodings).\n",n); 
   else return -1;
   return 0;
}

endclause(f,oldformat)
   FILE *f;
   int oldformat;
{
   if (oldformat == 1) fprintf(f,"\n");
   else fprintf(f,";\n");
}

tbfflush(string, file, format, ctx)
   char *string;
   FILE *file;
   int  format, ctx;
{
fflush(stdout);

   switch (ctx) {
	case 0 : 
		 tbfflushdef(string, file, format);
		 break;
	case 1 :
		 tbfflushlp(string, file, format);
		 break;
	case 2 :
		 tbfflushprop(string, file, format);
		 break;
	default: if (format==0) fprintf(file,"%s;\n",string);
		 else fprintf(file,"%s\n",string);
   }
   string[0] = EOS;
}

tbfflushdef(string, file, format)
   char *string;
   FILE *file;
   int  format;
{
   int colpos, entpos, ldef, i, nj, start, stop;
   int indent, cl;

   if (format == 1) {
	fprintf(file,"%s\n",string);
	return 0;
   }
   ldef = strlen(string);
   colpos = tbfind(string,0,":");
   if (colpos < 0) {
	tbsyntaxerror(":",string);
	return -1;
   }
   entpos = tbfind(string,colpos+1,"->");
   if (entpos < 0) {
        tbsyntaxerror("->",string);
        return -1;
   }
   nj = justnumb(string,colpos+1,entpos);
   if (nj < 0) {
	 tbsyntaxerror("none",string);
	 return -1;
   }
   cl = 0;
   indent = colpos+1;
   cl = fderesprintf(file,string,0,colpos+1,cl,indent);
   start = colpos+1; 
   i = 0;
   while (i++ < nj) {
	if (i==nj) stop = entpos;
	else stop = tbfindskip(string,start,",")+1;
	cl = fderesprintf(file,string,start,stop,cl,7);
	start = stop;
   }
   cl = FMXL;
   cl = fderesprintf(file,string,entpos,ldef,cl,6);
   fprintf(file,";\n");
   return cl;
}

tbfflushlp(string, file, format)
   FILE *file;
   char *string;
   int  format;
{
   int provpos, lcl, i, na, start, stop;
   int indent, cl;

   if (format == 1) {
        fprintf(file,"%s\n",string);
        return 0;
   }
   lcl = strlen(string);
   provpos = tbfind(string,0,"<-");
   if (provpos < 0) {
        tbsyntaxerror("<-",string);
        return -1;
   }
   na = justnumb(string,provpos+1,lcl);
   if (na < 0) {
	 tbsyntaxerror("none",string);
	 return -1;
   }
   cl = 0;
   indent = (provpos<11) ? provpos+1 : 12;
   cl = fderesprintf(file,string,0,provpos+1,cl,indent);
   start = provpos+1; 
   i = 0;
   while (i++ < na) {
	if (i==na) stop = lcl;
	else stop = tbfindskip(string,start,",")+1;
	cl = fderesprintf(file,string,start,stop,cl,indent);
	start = stop;
   }
   fprintf(file,";\n");
   return cl;
}

tbfflushprop(string, file, format)
   FILE *file;
   char *string;
   int  format;
{
   if (format == 1) {
        fprintf(file,"%s",string);
        return 0;
   }
   fprintf(file,"%s;\n",string);
   return 1;
}

char *appendstr(string1, string2, lim1)
   char *string1, *string2;
   int *lim1;
{
   int totlen;
   char *tmpstr;

   if ((totlen = strlen(string1) + strlen(string2) +1) > *lim1) {
	tmpstr = malloc(2*totlen*sizeof(char));
	if (tmpstr == NULL) {
		printf("\n out of space!!! (appendstr)");
		exit(1);
	}
	tmpstr[0] = '\0';
	strcpy(tmpstr,string1);
	*lim1 = 2*totlen;
	free(string1);
  	string1 = tmpstr;
   }
   strcat(string1,string2);
   string2[0] = '\0';
   return string1;
}

tbfind(txt,loc,pattern)
  char *txt;
  int loc;
  char *pattern;
{
  int d1, d2, k;

  d1 = strlen(txt)+1;
  d2 = strlen(pattern);
  d1 -= d2;
  k = loc-1;
  while ((++k)<d1) {
	if (strncmp(&(txt[k]),pattern,d2)==0) return k;
  }
  return -1;
}

tbfindskip(txt,loc,pattern)
   char *txt;
  int loc;
  char *pattern;
{
  int d1, d2, k;

  d1 = strlen(txt);
  d2 = strlen(pattern);
  d1 -= d2;
  k = loc-1;
  while ((++k)<d1) {
        if (strncmp(&(txt[k]),pattern,d2)==0) return k;
	else if (txt[k]=='(') {
             while (txt[++k]!=')') if (k>=d1) return -1;
            }
  }
  return -1;
}

tbsyntaxerror(message,string)
   char *message, *string;
{
   printf("TheoryBase syntax error");
   if (strcmp(message,"none")==0) printf(" in line :\n");
   else printf(", %s unfound in:\n",message);
   printf("%s\n",string);
}

justnumb(string,f,t)
  char *string;
  int f, t;
{
  int i, n=0;
  
  i = f;
  while (i<t) {
    if (string[i]==',') n++;
    else if (string[i]=='(') {
	    while (string[i]!=')') {
		i++;
		if (i>=t) return -1;
	    }
    }
    i++;
  }
  if (n>0) return n+1;
  for (i=f ; i<t ;i++) if (string[i]!=' ') return 1;
  return 0;
}

fderesprintf(file,buf,f,t,cl,ind)
   FILE *file;
   char *buf;
   int f, t, cl, ind;
{
   int i, l, maxs;

   l = t-f;
   if (cl + l > FMXL) {
	putc('\n',file);
	cl = 0;
	maxs = FMXL - l - 2;
	if (maxs > 0) {
	   if (maxs<ind) ind = maxs;
	   cl = ind;
	   while (ind--) putc(' ',file);
	}
   }
   i = f;
   while (i<t) putc(buf[i++],file);
   return cl + l;
}
