/**********************************************************************
* PROJECT: University of Kentucky TheoryBase
* FILE_NAME :  indset.c
* PROGRAMMER : Artur Mikitiuk
*
* DATE WRITTEN : 03/23/95
*
***********************************************************************/

#include "global.h"
#include "tb_graph.h"

extern tb_Graph *tbgraph[]; 

extern int clrin; 
int   bufsize;   
char  *indbuf;  
char  indtmp[256];
char *appendstr();

tbsh_maxindset()
{
    int n1=0,n2=0,n3=1,dno,i,totalenc=0;
    tb_Graph *ggg;
    char *par1=NULL, opt[16];
    int ffin=0, ffout=0;

    opcja['l']  = 0;
    opt[0] = EOS;
    for (i=0; i<MAXINOUT; i++)
	inatom[i] = outatom[i] = -1;
    bufsize   = 80;
    indbuf = (char *)malloc(bufsize*sizeof(char));
    if (indbuf == NULL) {
	printf("Out of space!!! (maxindset)\n");
	return -1;
    } else
	indbuf[0] = '\0';
    while (--argcx>0) {
        if (strncmp(argvx[argcx],"-n",2)==0)
            par1=argvx[argcx]+2;
        else if (strncmp(argvx[argcx],"-l",2)==0) {
	    opcja['l'] = 1;
	    strcat(opt,"l");
	} else if (strncmp(argvx[argcx],"-o",2)==0) {
	    opcja['o'] = 1;
	    strcat(opt,"o");
	} else if (strncmp(argvx[argcx],"-in",3)==0) {
	    if (ffin<MAXINOUT)
		inatom[ffin++] = atoi(argvx[argcx]+3);
	    else
		printf("WARNING: argument %s ignored\n",argvx[argcx]);
	} else if (strncmp(argvx[argcx],"-out",4)==0) {
            if (ffout<MAXINOUT)
		outatom[ffout++] = atoi(argvx[argcx]+4);
	    else
		printf("WARNING: argument %s ignored\n",argvx[argcx]);
	} else {
              printf("Incorrect argument list\n");
              usage_tbsh_maxindset();
              return -1;
        }
    }   
    if (par1!=NULL)
	parse_param(par1,&n1,&n2,&n3);
    clrin  = 1;
    for (i=n1; i<=n2; i += n3) {
	if (tbgraph[i] != NULL) {
	    ggg = tbgraph[i];
	    tbidtofilename("maxindset",opt,ggg->id,znak,MAXIDLENGTH);
	    printf("%s, ",znak);
            if (create_files(opcja['l'])) {
                printf("Failed\n");
                return;
	    }
	    dno = tbsh_maxindset_basic(ggg);
	    tb_save(ggg,fgph);
	    fprintf(fdisp,"end %d %d %d %d\n",0,0,0,0);
	    if (dno>=0) {
		totalenc++;
		if (opcja['l'])
		    printf("%d rules\n",dno);
		else
		    printf("%d defaults\n",dno);
	    }
	    close_files();
        }
    }
    if (totalenc==1)
	printf("Done (1 encoding).\n");
    else if (totalenc==0)
	printf("No encodings generated.\n");
    else
	printf("Done (%d encodings).\n",totalenc);
    free(indbuf);
    return totalenc;
}

usage_tbsh_maxindset()
{
  printf("usage: maxind [-nRANGE] [-l] {-inNUM} {-outNUM} \n");
}

int tbsh_maxindset_basic(ggg)
tb_Graph *ggg;
{
    tb_Vertex *v;
    tb_Arc *a;
    int i, k, count=0, first;
    char *s;
  
    i = 0;
    while (inatom[i] != -1) {
	k = inatom[i++];
	if (k<ggg->n) {
	    if (opcja['l']) {
		sprintf(indtmp,"\n in(%s) <- ",(ggg->vertices+k)->name);
		indbuf = appendstr(indbuf,indtmp, &bufsize);
		tbfflush(indbuf,flp,opcja['o'],1);
	    } else {
		sprintf(indtmp,"\n in(%s)",(ggg->vertices+k)->name);
		indbuf = appendstr(indbuf,indtmp, &bufsize);
		tbfflush(indbuf,fthc,opcja['o'],2);
	    }
	}
    }
    i = 0;
    while (outatom[i] != -1) {
	k = outatom[i++];
	if (k<ggg->n) {
	    if (opcja['l'])
		printf("WARNING: !in(%s) ignored\n",(ggg->vertices+k)->name);
	    else {
		sprintf(indtmp,"\n!in(%s)",(ggg->vertices+k)->name);
		indbuf = appendstr(indbuf,indtmp, &bufsize);
		tbfflush(indbuf,fthc,opcja['o'],2);
	    }
	}
    }
    for (v=ggg->vertices; v<ggg->vertices+ggg->n; v++) {
	if (opcja['l'])
	    sprintf(indtmp,"\n in(%s) <- ",v->name);
	else
	    sprintf(indtmp,"\n : ");	
	indbuf = appendstr(indbuf,indtmp, &bufsize);
	fprintf(fdisp,"fill %d %d %d %d\n",tbvtxnum(ggg,v),clrin,0,0);
	for (a=v->outarcs, first=1; a; a=a->next) {
	    s=a->tip->name;
	    if (first) {
		sprintf(indtmp,"!in(%s)",s);	
		first=0;
	    } else
		sprintf(indtmp,", !in(%s)",s);	
	    indbuf = appendstr(indbuf,indtmp, &bufsize);
	}
	if (opcja['l'])
	    tbfflush(indbuf,flp,opcja['o'],1);
	else {
	    sprintf(indtmp," -> in(%s)",v->name);
	    indbuf = appendstr(indbuf,indtmp, &bufsize);
	    tbfflush(indbuf,fdc,opcja['o'],0);
	}
	count++;
    }
    fprintf(fstratif,"%d\n",count);
    return count;
}

