/*
 * DEFAULT THEORIES GENERATOR
 *
 * FILE : main.c - program administration, input line parser 
 *
 * programmer - Pawel Cholewinski
 *
 * date 03/05/93
 *
 */

#include "global.h"
#include "proton.h"

int opcja[MAXOPT];
char znak[MAXIDLENGTH];
char optstr[MAXIDLENGTH];

int arg1, arg2, arg3;
char *argvx[MAXPAR];
int argcx;

FILE *finp, *fdt, *fthc, *fdc, *fstratif, *fgph, *flp, *fdisp;

int dshproblem(void);
int graphmaker(void);


main()
{
	int resp, pid, died, newfork, signal=1;
	fdt = fthc = fdc = fstratif = flp = fdisp = NULL;

	tbase_setup();
	while (1) {
                if ( (signal=get_command_line()) < 0) 
                                syserror("command line error",0);
                else switch (signal) {
                   case 0 : exit(0);
                   default:
		       newfork = execute_command();
		       if (newfork == 0) {printf("going out\n"); exit(0);}
                       if (newfork == 2) { 
                        if ( (pid = fork()) <= 0) { 
                           if (pid < 0) { 
                                 syserror("fork returned error\n",2);
                           }
                           else { 
				resp = execvp(argvx[0],argvx);
				if (resp < 0) printf("%s : Command not found\n",
						argvx[0]);
				exit(1);
                           }
                         }
			else  died = wait(0);
                        break;
			}
                   } 
        }  
	return 0;
}


int get_command_line()
{
int i,length=1, signal=3;
char bufor[MAXCOM];

	printf("%s>> ", "TheoryBase");
	for (i=0 ; i< MAXCOM ; i++) bufor[i]=EOS;
	while (length==1) {
		length = sysnextline(bufor, MAXCOM);
		for (i=0 ; i<MAXPAR ; i++) argvx[i]=NULL;
		if (length<0) return -1;
		else if (length>1) create_argv(bufor, length);
	}
	return signal;
}

void create_argv(bufor, lim)
char bufor[];
int lim;
{
int i, j=0, f=0, tt=0, count=1;

	while (j<lim) {
			if (bufor[j]==SPACE) {
						count++;
						bufor[j]=EOS;
			}
		        j++;
	}
	tt--;
	if (count>MAXPAR) {
		printf("WARNING! too many parameters, using %d first\n",	MAXPAR);
		count = MAXPAR;
	}
	for (i=0 ; i<count ; i++) {
		tt++;
		while ((bufor[tt]!=EOS) && (bufor[tt]!=SPACE)) tt++;
		if (argvx[i]!=NULL) free(argvx[i]);
		argvx[i]=(char *)malloc((unsigned)(sizeof(char)*(tt-f+1)));
		if (argvx[i] == NULL) syserror("no more space available",0);
		else strcpy(argvx[i],&bufor[f]);
		f=tt+1;
	}
	     argcx = count;
        argvx[count] = NULL;
}

int sysnextline(bufor,lim)
char bufor[];
int  lim;
{
	int c=0, j=0;

	while ((j<lim) && ((c=getchar()) != EOF) && (c!='\n')) {
		if (c=='\t') c=SPACE;
		if ((c!=SPACE) || ((j>0) && (bufor[j-1]!=SPACE))) {
			bufor[j]=c;
			j++;
		}
	}
	if (c=='\n') {
		bufor[j]=EOS;
		if ((j>0) && (bufor[j-1]==SPACE)) {
			bufor[j-1]=EOS ; 
			j--;
		}
		return ++j;
	}
	else if (c==EOF) return 0;
	else {
		while ((c!=EOF) && (c!='\n')) c=getchar();
		return -1;
	}
}


void syserror(message,code)
char *message;
int code;
{
	if (code==0) printf("%s\n", message);
	if (code==1) { printf("%s\n", message); exit(code);}
}

int execute_command()
{
	if (strcmp(argvx[0],"read")==0)  read_input_file();
	else if  (strcmp(argvx[0],"symbols")==0) print_symbols();
	else if  (strcmp(argvx[0],"show")==0)   showvertex(argvx[1]);
	else if  (strcmp(argvx[0],"find")==0)   findvertex(argvx[1]);
	else if (strcmp(argvx[0],"quit")==0) return 0;
	else if (strcmp(argvx[0],"inedges")==0) create_incoming();
	else if (strcmp(argvx[0],"delinedges")==0) clear_incoming();
	else if (strcmp(argvx[0],"issymmetric")==0) is_symmetric();
	else if (strcmp(argvx[0],"symclosure")==0) symmetric_closure();
	else {
		if (dshproblem()==1) return 1;
		else if (graphmaker()==1) return 1;
		else return 2;
	}
	return 1;
}
