/*
 * FILE : proton.h
 */

struct symbolbox {
	char *id;
	int no;
	struct symbolbox *next;
	struct vertexbox *list;
};

struct vertexbox {
	struct symbolbox *sym;
	struct box *outhead, *outtail;
	struct box *inhead, *intail;
	int info1, info2;
	struct vertexbox *next, *prev;
};

struct box {
   int nb;
	struct box *next, *prev;
	struct symbolbox *sym;
};

void create_argv(char *, int);
int execute_command(void);
int get_command_line(void);
void syserror(char *, int);
int sysnextline(char *, int);

int cat(void);
int clear_symboltable(void);
int clear_incoming(void);
int clear_info(void);
int read_input_file(void);
int print_symbols(void);

struct vertexbox *append_new_source
	 (struct symbolbox *, struct vertexbox **, struct vertexbox **);
struct box *append_new_neighbour
	  (struct symbolbox *, struct vertexbox *);
int create_incoming(void);
void findvertex(char *);
int hashkey(char *);
int incident(struct vertexbox *, struct symbolbox *, int);
int is_symmetric(void);
struct symbolbox *lookup(char *, int, struct symbolbox *[]);
struct box *new_predecessor(struct symbolbox *, struct vertexbox *);
void show_node(struct vertexbox *);
void showvertex(char *);
int symmetric_closure(void);
int symmetry_test(void);


void cannotopen(char *);
int create_files(int);
void close_files(void);
int fetcharg(char *);
void makeheader(FILE *, char *);
int parse_argvx(void);
void set_current_options(char *, int*, int);

void kernel(void);

void color(void);

void hamilton(void);

void cycle(void);
