/*
 * FILE : tbprolog.c 
 *
 * programmer - Pawel Cholewinski
 *
 *
 */

#include "global.h"
#include "tb_graph.h"
#include <stdio.h>

extern tb_Graph *tbgraph[];
int prolopt[MAXOPT];
char *vpred, *epred, *lend;
FILE *fpro;


tbsh_facts()
{
   int n1=0, n2=0, n3=1, fno, i, dl, totalenc=0;
   char *par1, opt[16];
   tb_Graph *ggg;

   vpred = "vertex";
   epred = "edge";
   lend  = ".";
   resetoptions(prolopt,'a','z',0);
   opt[0] = EOS;

   while (--argcx>0) {
        if(strncmp(argvx[argcx],"-n",2)==0)
            par1=argvx[argcx]+2;
	else if (strcmp(argvx[argcx],"-e")==0) {
	     prolopt['e'] = 1;
             strcat(opt,"e");
        }
	else if (strcmp(argvx[argcx],"-u")==0) {
             prolopt['u'] = 1;
             strcat(opt,"u");
        }
	else if (strncmp(argvx[argcx],"-vertex=",8)==0) {
            vpred = argvx[argcx]+8;
	    if (strlen(vpred)<1 || vpred[0]<'a' || vpred[0]>'z') {
		printf("WARNING: invalid predicate name, \n");
		printf("argument %s ignored\n",argvx[argcx]);
		vpred = "vertex";
	    }
        }
	else if (strncmp(argvx[argcx],"-edge=",6)==0) {
            epred = argvx[argcx]+6;
	    if (strlen(epred)<1 || epred[0]<'a' || epred[0]>'z') {
                printf("WARNING: invalid predicate name, \n");
                printf("argument %s ignored\n",argvx[argcx]);
                epred = "edge";
            }
        }
	else if (strncmp(argvx[argcx],"-sep=",5)==0)
	    lend =  argvx[argcx]+5;
	else {
              if (ishelp(argvx[argcx])==0)
		printf("Incorrect argument list\n");
               usage_tbsh_facts();
              return -1;
        }
    }   
   i = -1;
   while (lend[++i]) if (lend[i]=='_') lend[i]=SPACE;
   if (par1!=NULL) parse_param(par1,&n1,&n2,&n3);
   for (i=n1; i<=n2; i += n3) {
        if (tbgraph[i] != NULL) {
           ggg = tbgraph[i];
           tbidtofilename("facts",opt,ggg->id,znak,MAXIDLENGTH);
           printf("%s, ",znak);
	   dl = strlen(znak);
	   strcat(znak,".prl");
           if ((fpro = fopen(znak,"w"))==NULL) {
                printf("fopen failed\n");
                return -1;
           }
	   znak[dl] = EOS;
	   strcat(znak,".tbg");
	   if ((fgph = fopen(znak,"w"))==NULL) {
                printf("fopen failed\n");
                return -1;
           } 
           fno = tbsh_prolog_graph(ggg,prolopt['e'],prolopt['u']);
           tb_save(ggg,fgph);
	   fclose(fpro);
	   fclose(fgph);
	   printf("%d facts\n",fno);
	   if (fno>=0) totalenc++;
         }
   }
   tb_enconumber_generated(totalenc);
   return totalenc;
}

usage_tbsh_facts()
{
  printf("usage: facts [-nRANGE] [-e] [-u] ");
  printf("[-vertex=STR1] [-edge=STR2] [-sep=STR3]\n");
}


tbsh_prolog_graph(ggg,isenum,isuni)
   tb_Graph *ggg;
   int isenum, isuni;
{
   	tb_Vertex *v, *u;
	tb_Arc *a, *b;
        int num, count, k, l;
	
	num = 0;
        for(v= ggg->vertices;v<ggg->vertices+ggg->n;v++) {
	   if (isenum) fprintf(fpro,"%s(%d)%s\n",vpred,num,lend);
	   else fprintf(fpro,"%s(\"%s\")%s\n",vpred,v->name,lend);
	   num++;
	}
	count = num;

	for(v= ggg->vertices;v<ggg->vertices+ggg->n;v++) {
	   k = tbvtxnum(ggg,v);
	   for(b= v->outarcs;b;b= b->next) {
	      u = b->tip;
	      l = tbvtxnum(ggg,u);
	      if (isuni==0 || k<l || noedge(u,v)) {
		if (isenum) fprintf(fpro,"%s(%d,%d)%s\n",epred,k,l,lend);
		else fprintf(fpro,"%s(\"%s\",\"%s\")%s\n",
				epred,v->name,u->name,lend);
		count++;
	      }
	   }
	}
	return count;
}

int noedge(u,v)
  tb_Vertex *u, *v;
{
	tb_Arc *a;
	for (a = u->outarcs;a;a=a->next) if (a->tip == v) return 0;
	return 1;
}
