/****************************************************************
 *  	file: x11sgb.c   					*
 ****************************************************************/

#include <stdio.h>
#include <math.h>
#include "xbook.h"

#define XMSGS 20	
#define YMSGS1 620     
#define YMSGS2 620    


#define MAXCLR 23

char *clrname[MAXCLR] = {
	"white",
	"black",
        "green",
        "red",
        "blue",
        "yellow",
        "violet",
        "purple",
        "plum",
        "orchid",
        "maroon",
        "cyan",
        "khaki4",
        "gold",
        "chocolate",
        "DarkOrange",
        "pink1",
        "gray6",
        "DarkBlue",
        "DarkCyan",
        "DarkMagenta",
        "DarkRed",
	"LightBlue"
};

unsigned long clrpixel[MAXCLR];


void sgbMessage();
unsigned long MyLookup();
extern GC XCreateGC();

char sgbwindowname[] = "TBase";
char sgbiconname[] = "Theory Base";
char sgbmyexp[] = "Window is exposed !";
char *string, *string1;
char *SgbProgramName;
char *graphicmode;
Display *sgbmydisplay;
Window   sgbmywindow;
GC sgbmygc;
Colormap sgbcolormap;
int sgbdepth;
XEvent sgbmyevent;
int tbshx11width, tbshx11arc, tbshx11arrow, tbshx11ids;

char *sgbdisplayname = NULL;
Drawable sgbwindow;             
XSizeHints sgbmywindowhints;   
int sgbmyscreen;
unsigned long sgbmyforeground, sgbmybackground;
int i, width, length;

x11sgbsetup(wdth, arc, arrow, ids)
   int wdth, arc, arrow, ids;
{
   if (wdth>0) width = tbshx11width = wdth;
   if (arc >0) tbshx11arc = 1 - tbshx11arc;
   if (arrow >0) tbshx11arrow = 1 - tbshx11arrow;
   if (ids >0) tbshx11ids = 1 - tbshx11ids;
   return 0;
}
x11sgbinit()
{
int fclr;

width = tbshx11width;
if (!(sgbmydisplay= XOpenDisplay(sgbdisplayname))) {
	exit(-1);
	}
sgbmyscreen = XDefaultScreen(sgbmydisplay);

printf("%s version %d of the X Window System X%d R%d\n",
        ServerVendor(sgbmydisplay),
        VendorRelease(sgbmydisplay),
	ProtocolVersion(sgbmydisplay),
	ProtocolRevision(sgbmydisplay));
printf("Display Width --- %d\n", DisplayWidth(sgbmydisplay, sgbmyscreen));
printf("Display Height --- %d\n", DisplayHeight(sgbmydisplay, sgbmyscreen));

sgbmywindowhints.width = 980;
sgbmywindowhints.height = 880;
printf("Display Width --- %d\n", DisplayWidth(sgbmydisplay, sgbmyscreen));
printf("Display Height --- %d\n", DisplayHeight(sgbmydisplay, sgbmyscreen));

sgbmywindowhints.x=(DisplayWidth(sgbmydisplay,sgbmyscreen) - sgbmywindowhints.width) >> 1;
sgbmywindowhints.y=(DisplayHeight(sgbmydisplay,sgbmyscreen) - sgbmywindowhints.height) >> 1;
sgbmywindowhints.flags = PPosition | PSize; 

sgbmybackground = WhitePixel(sgbmydisplay, sgbmyscreen);
sgbmyforeground = BlackPixel(sgbmydisplay, sgbmyscreen);
sgbdepth = DefaultDepth(sgbmydisplay, sgbmyscreen);
fclr = InitColors(sgbmydisplay, sgbmyscreen,sgbdepth);
if (fclr!=0) printf("%d colors of your list are not available",fclr);
else printf("color initialization, OK");
sgbmywindow = XCreateSimpleWindow(sgbmydisplay, DefaultRootWindow(sgbmydisplay),
	sgbmywindowhints.x, sgbmywindowhints.y, sgbmywindowhints.width,
	sgbmywindowhints.height, 5, sgbmyforeground, sgbmybackground);
XSelectInput(sgbmydisplay, sgbmywindow, ExposureMask);

printf("\n");
printf("TBase, Display the window.\n");
XMapWindow(sgbmydisplay, sgbmywindow);
while (1) {
    	XNextEvent(sgbmydisplay, &sgbmyevent);
    	if (sgbmyevent.type == Expose)
		break;
	}
XSetStandardProperties(sgbmydisplay, sgbmywindow, sgbwindowname, sgbiconname,
        None, NULL, 0, &sgbmywindowhints);

sgbmygc = XCreateGC(sgbmydisplay, sgbmywindow, 0, 0);
XSetFillStyle(sgbmydisplay, sgbmygc, FillSolid);
XSetBackground(sgbmydisplay, sgbmygc, sgbmybackground);
XSetForeground(sgbmydisplay, sgbmygc, sgbmyforeground);
XSetLineAttributes(sgbmydisplay,sgbmygc,width,LineSolid,CapRound,JoinRound);

string="PROBA1: input vertices; Button2: terminate a polyline; Button3: exit";

XSelectInput(sgbmydisplay, sgbmywindow,
	KeyPressMask | ButtonPressMask | ExposureMask);
x11sgb_fixed();
}

x11sgb_fixed()
{
   char *fontname;
   XFontStruct *sgbfont;
  
   XDrawLine(sgbmydisplay,sgbmywindow,sgbmygc,0,800,980,800);
   XDrawLine(sgbmydisplay,sgbmywindow,sgbmygc,800,0,800,800);
   XSetForeground(sgbmydisplay,sgbmygc, MyLookup("yellow"));
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,0,800,980,880);
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,800,0,180,800);
   
   XSetForeground(sgbmydisplay,sgbmygc,clrpixel[1]);
   XDrawRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830, 20,120,60);
   XDrawRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,120,120,60);
   XDrawRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,220,120,60);
   XDrawRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,320,120,60);
   XDrawRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,420,120,60);
   XDrawRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,520,120,60);
   XDrawRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,620,120,60);
   XDrawRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,720,120,60);
   
   XSetForeground(sgbmydisplay,sgbmygc,MyLookup("LightBlue"));
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830, 20,120,60);
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,120,120,60);
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,220,120,60);
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,320,120,60);
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,420,120,60);
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,520,120,60);
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,620,120,60);
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,830,720,120,60);

   XSetBackground(sgbmydisplay,sgbmygc,MyLookup("LightBlue"));
   XSetForeground(sgbmydisplay,sgbmygc,sgbmyforeground);
   fontname = "12x24";
   sgbfont = XLoadQueryFont(sgbmydisplay,fontname);
   if (sgbfont == (XFontStruct *)NULL) {
	printf("font %s not found\n",fontname);
        fontname = "fixed";
   	sgbfont = XLoadQueryFont(sgbmydisplay,fontname);
   	if (sgbfont == (XFontStruct *)NULL) {
        	printf("font %s not found\n",fontname);
		fontname = "variable";
		sgbfont = XLoadQueryFont(sgbmydisplay,fontname);
		if (sgbfont == (XFontStruct *)NULL) 
		  printf("font %s not found\n",fontname);
		else
		  printf("font %s loaded\n",fontname);
	}
	else printf("font %s loaded\n",fontname);
   }
   else printf("font %s loaded\n",fontname);

   XDrawString(sgbmydisplay,sgbmywindow,sgbmygc,870, 55,"QUIT",4);
   XDrawString(sgbmydisplay,sgbmywindow,sgbmygc,870,155,"NEXT",4);
   XDrawString(sgbmydisplay,sgbmywindow,sgbmygc,870,255,"PREVIOUS",8);
   XDrawString(sgbmydisplay,sgbmywindow,sgbmygc,870,355,"CIRCLE",6);
   XDrawString(sgbmydisplay,sgbmywindow,sgbmygc,870,455,"2D",2);
   XDrawString(sgbmydisplay,sgbmywindow,sgbmygc,870,555,"3D",2);
   XDrawString(sgbmydisplay,sgbmywindow,sgbmygc,870,655,"RANDOM",6);
   XDrawString(sgbmydisplay,sgbmywindow,sgbmygc,870,755,"BULIT IN",8);

   XDrawRectangle(sgbmydisplay,sgbmywindow,sgbmygc, 30,840,80,35);
   XDrawRectangle(sgbmydisplay,sgbmywindow,sgbmygc,130,840,80,35);
   XDrawRectangle(sgbmydisplay,sgbmywindow,sgbmygc,230,840,80,35);
   XSetForeground(sgbmydisplay,sgbmygc,MyLookup("red"));
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc, 30,840,80,35);
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,130,840,80,35);
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,230,840,80,35);
   
   XSetBackground(sgbmydisplay,sgbmygc,MyLookup("red"));
   XSetForeground(sgbmydisplay,sgbmygc,sgbmyforeground);
   XDrawString(sgbmydisplay,sgbmywindow,sgbmygc,35,863,"names on/off",12);
   XDrawString(sgbmydisplay,sgbmywindow,sgbmygc,145,863,"lines/arcs",10);
   XDrawString(sgbmydisplay,sgbmywindow,sgbmygc,235,863,"arrows on/off",13);
   XSetBackground(sgbmydisplay,sgbmygc,sgbmybackground);
}
	 
SGB_Window_Wait(gno,gname)
   int gno; 
   char *gname;
{
int cx, cy, length, done, wb, cgno;
char *cgname;
length = 0;
done = 1;
cgno = gno;
cgname = gname;
graphicmode = "cycle";
sgbMessage(graphicmode,820,840,0);
while (done) {
    XNextEvent(sgbmydisplay, &sgbmyevent);
    switch ((int)sgbmyevent.type) {
	case ButtonPress:
          cx = sgbmyevent.xbutton.x;
          cy = sgbmyevent.xbutton.y;
	  wb = whichscreenbutton(cx,cy);
          switch ((int)sgbmyevent.xbutton.button) {
	    case Button1: 
		switch  (wb) {
		   case 0: break;
		   case 1: done = 0;
			   break;
		   case 2: string = "NEXT";
			   sgbMessage(string, 820, 820,0);
			   if (GetNextGraph(&cgno,&cgname) < 0) 
				sgbMessage("No next graph",820,820,0);
			   else gx11displaygraph(cgno,cgname,graphicmode);
			   break;
		   case 3: string = "PREVIOUS";
                           sgbMessage(string, 820, 820,0);
			   if (GetPrevGraph(&cgno,&cgname) < 0) 
                                sgbMessage("No previous graph",820,820,0);
                           else gx11displaygraph(cgno,cgname,graphicmode);
			   break;
		   case 4: string = "CIRCLE";
                           sgbMessage(string, 820, 820,0);
			   graphicmode = "circle";
			   gx11displaygraph(cgno,cgname,graphicmode);
			   break;
		    case 5: string = "2D";
                           graphicmode = "2d";
                           sgbMessage(string, 820, 820,0);
		  	   gx11displaygraph(cgno,cgname,graphicmode);
                           break;
		    case 6: string = "3D";
                           graphicmode = "3d";
                           sgbMessage(string, 820, 820,0);
			   gx11displaygraph(cgno,cgname,graphicmode);
                           break;
		     case 7: string = "RANDOM";
			    graphicmode = "random";
                           sgbMessage(string, 820, 820,0);
                           gx11displaygraph(cgno,cgname,graphicmode);
                           break;
		     case 8: string = "BUILT IN";
                            graphicmode = "built in";
                           sgbMessage(string, 820, 820,0);
                           gx11displaygraph(cgno,cgname,graphicmode);
                           break;
		     case 9: if (tbshx11ids == 0) {
                                  gx11displaynames(cgno,cgname,graphicmode);
                                  tbshx11ids = 1;
                                }
                                else if (tbshx11ids == 1) {
                                  gx11displaygraph(cgno,cgname,graphicmode);
                                  tbshx11ids = 0;
                                }
			      break;
		      case 10: x11sgbsetup(0,1,0,0);
                               gx11displaygraph(cgno,cgname,graphicmode);
			       break;
		      case 11: x11sgbsetup(0,0,1,0);
                               gx11displaygraph(cgno,cgname,graphicmode);
                               break;
		  }
		  if (tbshx11ids) gx11displaynames(cgno,cgname,graphicmode);
		  break;  
		  case Button2: if (cy>800) {
				  x11sgbsetup(0,1,0,0);
				  gx11displaygraph(cgno,cgname,graphicmode);
				  if (tbshx11ids)
				     gx11displaynames(cgno,cgname,graphicmode);
				}
				else if (tbshx11ids == 0) {
				  gx11displaynames(cgno,cgname,graphicmode);
				  tbshx11ids = 1;
				}
				else if (tbshx11ids == 1) {
				  gx11displaygraph(cgno,cgname,graphicmode);
				  tbshx11ids = 0;
                                }
			break;
		    }
		break;
	case Expose:
	    break;
	case KeyPress:
	    break;
	default:
	    string = "Bad X event.";
	    sgbMessage(string, XMSGS, YMSGS1,0);
	    break;
	}
    }
XFreeGC(sgbmydisplay, sgbmygc);
XDestroyWindow(sgbmydisplay, sgbmywindow);
XCloseDisplay(sgbmydisplay);
} 

int whichscreenbutton(a,b)
   int a, b;
{
   int k, l;
   if (b>800) {
	if ((b<840) || (b>875)) return 0;
	if ((a>=30) && (a<=110)) return 9;
	else if ((a>=135) && (a<=210)) return 10;
	else if ((a>=235) && (a<=310)) return 11;
	else return 0;
   }
   if ((a<830) || (a>950)) return 0;
   k = b/100;
   l = b%100;
   if ((l<20) || (l>80)) return 0;
   return k+1;
}

void sgbMessage(str, i, j, cl)	
char *str;
int i, j, cl;
{
	unsigned length;
        int k = 980;

	if (i<800) k = 800;
	if (cl) XClearArea(sgbmydisplay, sgbmywindow, i, j-19, k-i, 25, False);
	length = strlen(str);
	XSetBackground(sgbmydisplay,sgbmygc, MyLookup("yellow"));
	XDrawString(sgbmydisplay, sgbmywindow, sgbmygc, i, j, str, length);
}

sgbClear(x, y, w, h, rectcolor)
   int x,y,w,h;
   char *rectcolor;
{
   XSetForeground(sgbmydisplay,sgbmygc, MyLookup(rectcolor));
   XFillRectangle(sgbmydisplay,sgbmywindow,sgbmygc,x,y,w,h);
   XSetForeground(sgbmydisplay,sgbmygc, MyLookup(rectcolor));
} 



sgbxtbshlinedraw(a,b,nang)
  char *a, *b;
  int nang;
{
  int ax, ay, bx, by;
  int anum, bnum;
  double cos(), sin();
  double rxa, rya, rxb, ryb, phi, scale;

  scale = 250.0;
  phi = (double)(3.14159*2/nang);

  anum = atoi(a);
  bnum = atoi(b);
  rxa  = cos(anum*phi);
  rya  = sin(anum*phi);
  rxb  = cos(bnum*phi);
  ryb  = sin(bnum*phi);
  ax   = (int)(scale*rxa + 300.0);
  ay   = (int)(scale*rya + 300.0);
  bx   = (int)(scale*rxb + 300.0);
  by   = (int)(scale*ryb + 300.0);
  XDrawLine(sgbmydisplay,sgbmywindow,sgbmygc,ax,ay,bx,by);
}

x11tbsh3line(ax,ay,bx,by)
   int ax,ay,bx,by;
{
     int tx,ty,dq, xax, xay;

     if (tbshx11arc==0) {
	XDrawLine(sgbmydisplay,sgbmywindow,sgbmygc,ax,ay,bx,by);
	if (tbshx11arrow) x11tbsharrow(ax,ay,bx,by,5,15,tbshx11arc);
	return 0;
     }
     if (tbshx11arrow) x11tbsharrow(ax,ay,bx,by,5,15,tbshx11arc);
     if (ay > by) {
        tx = ax;
        ty = ay;
        ax = bx;
        ay = by;
        bx = tx;
        by = ty;
     }

     if (ax==bx) {
	xax = (by-ay)/16;
	if (ax<400) XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,
			ax-xax,ay,2*xax,by-ay,90*64,180*64);
	else XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,
                        ax-xax,ay,2*xax,by-ay,-90*64,180*64);
	return 1;
     }
     if (ay==by) {
	if (bx<ax) {
		tx = ax; ax = bx ; bx = tx;

	}
        xay = (bx-ax)/16;
        if (ay<400) XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,
                        ax,ay-xay,bx-ax,2*xay,0,180*64);
        else XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,
                        ax,ay-xay,bx-ax,2*xay,180*64,180*64);
        return 1;
     }
	
     dq = DisplayQuater(ax,ay,bx,by,400,400);
     switch (dq) {
	case 1: if (ax<bx) XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,
		  		ax,2*ay-by,2*(bx-ax),2*(by-ay),180*64,90*64);
		else       XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,
				bx,ay,2*(ax-bx),2*(by-ay),90*64,90*64);
		break;
	case 2: if (ax<bx) XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,
                                ax,2*ay-by,2*(bx-ax),2*(by-ay),180*64,90*64);
                else       XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,
                                bx,ay,2*(ax-bx),2*(by-ay),90*64,90*64);
                break;
	case 3: if (ax<bx) XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,
                                2*ax-bx,ay,2*(bx-ax),2*(by-ay),0,90*64);
                else       XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,
                                2*bx-ax,2*ay-by,2*(ax-bx),2*(by-ay),0,-90*64);
                break;
	case 4: if (ax<bx) XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,
                                2*ax-bx,ay,2*(bx-ax),2*(by-ay),0,90*64);
                else       XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,
                                2*bx-ax,2*ay-by,2*(ax-bx),2*(by-ay),0,-90*64);
                break;
   }
   return 1;
}

x11tbsh3circle(ax,ay,rmin,rmax)
   int ax, ay, rmin, rmax;
{
   int i,j,rmin2,rmax2,d;
   
   rmin2 = 2*rmin;
   rmax2 = 2*rmax;

   XDrawArc(sgbmydisplay,sgbmywindow,sgbmygc,ax-rmax,ay-rmax,
		rmax2,rmax2,0,360*64);
}

x11tbsh3fillcircle(ax,ay,rmin,rmax)
   int ax, ay, rmin, rmax;
{
   int i,j,rmin2,rmax2,d;
  
   rmin2 = 2*rmin;
   rmax2 = 2*rmax;

   XFillArc(sgbmydisplay,sgbmywindow,sgbmygc,ax-rmax,ay-rmax,
                rmax2,rmax2,0,360*64);
}

gx11foreground(colorno)
   int colorno;
{
  XSetForeground(sgbmydisplay, sgbmygc, clrpixel[colorno]);
}

int DisplayQuater(ax,ay,bx,by,ox,oy)
   int ax,ay,bx,by,ox,oy;
{
   int cx, cy;

   cx = (ax+bx)/2;
   cy = (ay+by)/2;
   if (cx < ox) {
	if (cy < oy) return 1;
	else return 2;
   }
   else {
	if (cy > oy) return 3;
        else return 4;
   }
   return -1;
}

x11tbsharrow(ax,ay,bx,by,rad,lng,mode)
   int ax,ay,bx,by,rad,lng,mode;
{
   double fax, fay, fbx, fby, vx, vy, vnorm, fpx, fpy, fqx, fqy;
   int px, py, qx, qy;

   if (mode==1) { 
      if ((ax==bx) || (ay==by)) return 0;
      px = bx+0.2*(rad+lng);
      py = by+rad+lng;
      qx = bx-0.2*(rad+lng);
      qy = by-rad-lng;
      XDrawLine(sgbmydisplay,sgbmywindow,sgbmygc,px,py,qx,qy);
      px = bx-0.2*(rad+lng);
      py = by+rad+lng;
      qx = bx+0.2*(rad+lng);
      qy = by-rad-lng;
      XDrawLine(sgbmydisplay,sgbmywindow,sgbmygc,px,py,qx,qy);
      return 1;
   }
   fax = (double)ax;
   fay = (double)ay;
   fbx = (double)bx;
   fby = (double)by;
   vx = fbx-fax;
   vy = fby-fay;
   vnorm = sqrt(vx*vx+vy*vy);
   if (vnorm<rad*rad) return 0;
   vx = vx/vnorm;
   vy = vy/vnorm;
   fpx = bx - (rad+lng)*vx;
   fpy = by - (rad+lng)*vy;
   px = (int)(bx - rad*vx);
   py = (int)(by - rad*vy);
   
   fqx = fpx + 0.2*lng*vy;
   fqy = fpy - 0.2*lng*vx;
   qx   = (int)fqx;
   qy   = (int)fqy;
   XDrawLine(sgbmydisplay,sgbmywindow,sgbmygc,px,py,qx,qy); 
   fqx = fpx - 0.2*lng*vy;
   fqy = fpy + 0.2*lng*vx;
   qx   = (int)fqx;
   qy   = (int)fqy;
   XDrawLine(sgbmydisplay,sgbmywindow,sgbmygc,px,py,qx,qy); 
   return 0;
}

InitColors(display,screen,depth)
   Display *display;
   int depth, screen;
{
   int i, status, nf=0;
   Colormap colormap;
   XColor rgbcolor, hardwarecolor;

   colormap = DefaultColormap(display,screen);
   
   for (i = 0; i<MAXCLR ; i++) {
	if (depth>1) {
	   status = 
	   XLookupColor(display,colormap,clrname[i], &rgbcolor,&hardwarecolor);
	   if (status != 0) {
              status= XAllocColor(display,colormap,&hardwarecolor);
	      if (status != 0) clrpixel[i] = hardwarecolor.pixel;
	      else {
		 nf ++;
	         printf("XAllockColor: %s - failed, using black insetead\n",
			clrname[i]);
	         clrpixel[i] = BlackPixel(display, screen);
	      }
	   }
	   else {
	      nf++;
	      printf("XLookupColor: %s - failed, using black insetead\n",
                        clrname[i]);
              clrpixel[i] = BlackPixel(display, screen);
	   }
        }
	else clrpixel[i] = BlackPixel(display, screen);
   }
   return nf;
}

unsigned long MyLookup(clrs)
   char *clrs;
{
   int i=0;
   while (i<MAXCLR) {
	if (strcmp(clrname[i],clrs)==0) return clrpixel[i];
	i++;
   }
   printf("color %s not found, using black instead\n",clrs);
   return (clrpixel[1]);
}
