To do:
	finish teacher's guide
	beef up discussion of protection (see ps)
	insert discussion of streams into devices.
	danger of public-key methods for signatures.

Other subjects fit for discussion

Security
	See C. E. Landwehr, already in refs.
	Distinguish discretionary policies from non-.  (Former decides access based
	on identity of subject; latter on flow between objects.)

Queueing theory
	closed-form solutions
	derivations of some of the principles in time management chapter

Scheduling:
	Marketplace model (Utah tenex)
		Each process has money which accrues at some rate and is spent during
			execution.
		Accrual rate: user's income rate / number of processes that user owns
		Threshold:  those processes with money less than this are blocked.
		Threshold is estimate of expenditures during a quantum:
			w(nmtw+ct)
				w: working-set size of this process
				n: expected number of ready procs in main store
				m: memory cost in Boyntons/memory unit
				t: swap time in ms/memory unit
				c: cpu price in boytons/ms
			c: recomputed every second, exponentially filtered with half-life
				of 20 seconds.
				c := fc + (1-f)ca/o
					f: 31/32
					a: recent cpu time processes with positive balance
					o: .7 largest possible value of a
			m := fm + (1-f)mb/p
				b: sum of working sizes of procs with positive balance
				p: total avail main store
	Policy function (Bernstein, in refs)
		Each proc. has a critical time C (eg. 5 seconds)
		Priority of process is waittime-criticaltime
			where waittime is since entered short-term scheduler
		R = sum over {r in resources} {weight(r)*needed(r)}
		eg. weight(1)=7, needed(1)=working set as fraction of main store
		    weight(2)=8, needed(2)=percent of last quantum used
			Max value of R is then 15.
			set f(R) to R for 0<=R<=10
						8R-7 for higher R
			f(R) is the process' critical time

Process control:
	profile execution by trace trap or clock interrupts
	pause service call to wait for a software interrupt
	delay service call to wait for a given time.
	ability to control child process:  access virtual space, start/stop,
		single step/breakpoint, intercept service calls
Concurrency control:
	Message-based or queue based control
		Single process is the administrator of each resource
		Input queue to that process of messages
		Works even if there is no shared memory
		Number of processes tends to be large
Handling interrupts:  what if already in the kernel, helping a user? (see
	CACM)
Non-standard models
	single-user operating systems
	virtual machines
		Hard to experiment if there is a user community without this
		place this in chap. 1, nuts and bolts, with a reprise in paging?
		reference:  MacKinnon (already in refs file); VM/SP
	real-time systems
		deadline scheduling
		spacewar mode
		time-slot scheduling
	capability architectures and object-based systems
	database systems: airline reservation and credit-card verification
		about 12K terminals.  See Gifford and Spector (in refs file)

communication protocols

How to build an operating system
	structure of kernel
		procedure based
			each service call is a procedure call; the procedure may block
				the users and return later.  Unix method.  Does not fit with
				asynchronous service calls.  Unix uses some original processes
				for long things like swapping.  Otherwise, each process is its
				own agent in the kernel.
		process based
			each service call starts a new envelope task.
			hybrid:  only start a new task for long things.
		message based
			one primordial process for each function, receiving work when
				appropriate.
			generalizes to multicomputers
			monitors vs queues
	initialization
		initialize lower levels before upper ones
		set up an array of context blocks, establish lists
		construct primordial tasks
		check files for consistency
		start a 'single' command interpreter
		start utility processes
		start login process on all available lines
	debugging
	statistics and instrumentation
From @a.ms.uky.csnet:solomon@gjetost.wisc.edu Fri Feb  6 01:29:02 1987
Received: by ch.ms.uky.csnet; Fri, 6 Feb 87 01:28:58 EST
Received: from ukma by UKMG.ms.uky.csnet id aa00418; 6 Feb 87 1:28 EST
Received: from csnet-relay.csnet by UKMG.ms.uky.csnet id ai03179;
          6 Feb 87 1:27 EST
Received: from relay.cs.net by RELAY.CS.NET id ab02251; 5 Feb 87 23:44 EST
Received: from [128.105.2.33] by RELAY.CS.NET id aa20509; 4 Feb 87 10:56 EST
Date: Wed, 4 Feb 87 09:52:31 CST
From: Marvin Solomon <solomon@gjetost.wisc.edu>
Message-Id: <8702041552.AA26898@gjetost.wisc.edu>
Received: by gjetost.wisc.edu; Wed, 4 Feb 87 09:52:31 CST
To: raphael@gjetost.wisc.edu
Subject: Re:  new theme
Status: RO

> The theme you mentined might be called the Automation Principle:  Do as much
> as you can automatically, without bothering the programmer or the user.
> This includes main-store management by collecting statistics instead of over-
> lays, looking at a process' past behavior in the short-term scheduler to
> predict its next behavior instead of declaring the job 'interactive', deciding
> where to execute on a multiprocessor (Sequent way) instead of having the
> program stipulate (Butterfly way).  It's part of the Beautification Principle,
> which says the os both hides and enhances the underlying world.  Automation
> is a form of both hiding and enhancement.

It's more than that.  A better summary would be, "Do as much
as you can automatically, without bothering OR TRUSTING the programmer or the
user."  The problem with asking for advice is not only that it bothers
the programmer, but also that the programmer probably doesn't know the
answer (even worse--he may think he knows the answer when he doesn't).

By the way, I'm not sure whether I said this before, but you can view
EVERY function of the OS as a special case of the Beautification Principle.
Even the Resource Principle can be phrased as "make a resource (including
the entire computing system) look 'more beautiful' by making it appear that
there is more than one unit of it."

P.S.  You're sending unrepliable mail again. Here's a copy of your header:

>From @wiscvm.wisc.edu:raphael@ukma Wed Feb  4 09:31:44 1987
Received: from CRYS.WISC.EDU by gjetost.wisc.edu; Wed, 4 Feb 87 09:31:23 CST
Message-Id: <8702041529.AA00506@crys.wisc.edu>
Received: from WISCVM.WISC.EDU by crys.wisc.edu; Wed, 4 Feb 87 09:29:48 CST
Received: from ukma by wiscvm.wisc.edu on 02/04/87 at 08:45:21 CST
From: raphael@ukma
To: solomon@crys.wisc.edu
Date:     Wed, 4 Feb 1987 09:39:56 EST
Subject: new theme

Whoever is creating the 'From:' line should put in "raphael@ukma.BITNET".

From jatnieks@gumby.wisc.edu Wed Apr  2 14:27:15 1986
Received: from gumby.wisc.edu by cheddar.wisc.edu; Wed, 2 Apr 86 14:27:10 CST
Date: Wed, 2 Apr 86 14:27:01 cst
From: jatnieks@gumby.wisc.edu (~dan~)
Message-Id: <8604022027.AA10001@gumby.wisc.edu>
Received: by gumby.wisc.edu; Wed, 2 Apr 86 14:27:01 cst
To: raphael@gumby.wisc.edu
Subject: Byte Article
Status: RO


Raphael,

   My name is dan jatnieks, and I am a student in your 537 class.  I 
discovered this during break, and thought others may be interested.
   There is an interesting artile in the current (April) issue of
Byte magazine called "Making UNIX secure".  It's a good article and
seems to go nicely with the lecture about security that we had before
break.

   dan.                 dan@uwmacc | dan@batman | jatnieks@gumby



From jatnieks@gumby.wisc.edu Mon Apr 21 20:57:04 1986
Received: from gumby.wisc.edu by cheddar.wisc.edu; Mon, 21 Apr 86 20:57:00 CST
Date: Mon, 21 Apr 86 20:33:14 cst
From: jatnieks@gumby.wisc.edu (~dan~)
Message-Id: <8604220233.AA02011@gumby.wisc.edu>
Received: by gumby.wisc.edu; Mon, 21 Apr 86 20:33:14 cst
To: raphael@gumby.wisc.edu
Subject: Mutual Exclusion
Status: RO

Hi,

   FYI there is a two part paper called:
       "The Mutual Exclusion Problem: Part I - A Theory of Interprocess
        Communication"
   and "The Mutual Exclusion Problem: Part II - Statement and Solutions"

   It is by Leslie Lamport of DEC and is in the latest issue of the
Journal of the ACM.  (April 1986, Vol. 33 No. 2)

dan.

