#include <ctype.h>
#include <stdio.h>
#include <sys/wait.h>
#include <unistd.h>
#include <string.h>
#ifdef sgi
#	define vfork fork
#endif
#include "app.h"

void PrintMessage(char *StringPtr, DateType *DatePtr, FILE *File)
{
/* print the message, performing any substitutions required.
Substitutions:
	%y year
	%m month
	%d day
	%a month day year
If DatePtr is 0, don't convert.
*/
#define MAXARGS 80
	if (*StringPtr != '!' || DatePtr == 0)
		fprintf(File, "%s", StringPtr);
	else { /* must interpret */
		char Decoded[MAXLINE], *DecodedPtr;
		char TempString[MAXLINE];
		int status; /* from wait() call */
		char *argv[MAXARGS], *ArgPtr;
		int WhichArg;
		{ /* convert all % conventions from String into Decoded */
			DecodedPtr = Decoded;
			StringPtr++; /* past the '!' */
			while (*StringPtr) {
				switch (*StringPtr) {
				case '%':
					StringPtr++;
					switch (*StringPtr) {
					case '%':
						sprintf(TempString, "%s", "%s");
						break;
					case 'y':
						sprintf(TempString, "%d", DatePtr->Year);
						break;
					case 'm':
						sprintf(TempString, "%d", DatePtr->Month);
						break;
					case 'd':
						sprintf(TempString, "%d", DatePtr->Day);
						break;
					case 'a':
						sprintf(TempString, "%d %d %d", DatePtr->Month,
							DatePtr->Day, DatePtr->Year);
						break;
					default:
						sprintf(TempString, "%s%c", "%", *StringPtr);
						break;
					} /* switch */
					(void) strcpy(DecodedPtr, TempString);
					DecodedPtr += strlen(TempString);
					break;
				default:
					*DecodedPtr++ = *StringPtr;	
					break;
				} /* switch */
				StringPtr++;
			}
			*DecodedPtr = 0;
		} /* convert % conventions */
		{ /* split Decoded into words, into argv */
			char *calloc(size_t, size_t);
			char Quoting = 0;
			WhichArg = 0;
			ArgPtr = argv[WhichArg] = calloc(MAXLINE, 1);
			for (DecodedPtr = Decoded; *DecodedPtr; DecodedPtr++) {
				/* split the string into words */
				if (*DecodedPtr == '"' && Quoting != '\'') {
					Quoting = (Quoting == '"') ? 0 : '"';
					continue;
				} else if (*DecodedPtr == '\'' && Quoting != '"') {
					Quoting = (Quoting == '\'') ? 0 : '\'';
					continue;
				}
				if (!Quoting && isspace(*DecodedPtr)){
					while (isspace(*DecodedPtr)) DecodedPtr++;
					if (*DecodedPtr == 0) break;
					*ArgPtr = 0; /* close previous arg */
					WhichArg++; /* prepare next one */
					ArgPtr = argv[WhichArg] = calloc(MAXLINE, 1);
					DecodedPtr--; /* the loop header will re-increment */
					continue;
				}
				*ArgPtr++ = *DecodedPtr;
			} /* for decoded string */
			*ArgPtr = 0; /* close previous arg */
			WhichArg++; /* prepare next one */
			argv[WhichArg] = 0; /* terminate array */
		} /* create argv */
		{ /* interpret initial ~/ */
			char Tmp[MAXLINE];
			for (WhichArg = 0; argv[WhichArg]; WhichArg++) {
				if (*argv[WhichArg] == '~' && *(argv[WhichArg]+1) == '/') {
					(void) strncpy(Tmp, argv[WhichArg], MAXLINE);
					sprintf(argv[WhichArg], "%s/%s", User, Tmp+2);
				}
			} /* for */
		} /* interpret initial ~/ */
		{ /* print out the arg list */
			/*
			for (WhichArg = 0; argv[WhichArg]; WhichArg++) {
				printf("[%s]", argv[WhichArg]);
			}
			printf("\n");
			*/
		}
		{ /* actually do the call */
			if (vfork() == 0) { /* child */
				if (execvp(argv[0], argv) < 0) {
					fprintf(stderr, "%s: ", argv[0]);
					perror("");
					_exit(1); /* must not use ordinary exit from vfork */
				}
			}
			(void) wait(&status);
		} /* the call */
	} /* interpret */
} /* PrintMessage */
