/*
 * appmenu.c -- front end to app program using xview.
 */
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/openmenu.h>

main(argc, argv)
int argc;
char *argv[];
{
    Frame       frame;
    Panel       panel;
    Menu        menu;
    int         selected();
    void        menu_proc();

    xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

    frame = (Frame)xv_create(NULL, FRAME, NULL);
    panel = (Panel)xv_create(frame, PANEL, NULL);

    menu = (Menu)xv_create(NULL, MENU,
        MENU_NOTIFY_PROC,       menu_proc,
        MENU_STRINGS,
			"Calendar for a given date",
			"Appointments matching string",
			"New appointment",
			"Modify appointment",
			"Quit",
			NULL,
        NULL);
    (void) xv_create(panel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "Appointment scheduler",
        PANEL_NOTIFY_PROC,      selected,
        PANEL_ITEM_MENU,        menu, /* attach menu to button */
        NULL);
    window_fit(panel);
    window_fit(frame);
    xv_main_loop(frame);
}

int
selected(item, event)
Panel_item item;
Event *event;
{
    return XV_OK;
}

void
menu_proc(menu, menu_item)
Menu menu;
Menu_item menu_item;
{
    char *MenuString = (char *)xv_get(menu_item, MENU_STRING);
    if (!strcmp(MenuString, "Calendar for a given date"));
    else if (!strcmp(MenuString, "Appointments matching string"));
    else if (!strcmp(MenuString, "New appointment"));
    else if (!strcmp(MenuString, "Modify appointment"));
    else if (!strcmp(MenuString, "Quit")) {
		exit();
	}
}
