/*$Header: /u/s10/cs.x/jrezaie/612finkel.d/mydib/applic/Pothello.c,v 1.1 91/12/31 11:35:37 jrezaie Exp $
$Log:	Pothello.c,v $
 * Revision 1.1  91/12/31  11:35:37  jrezaie
 * Initial revision
 * */
#include <stdio.h>
#include "conventions.h"
#include "alphabeta.applic.h"
#define MAXSIZE 9 		/* Maximum no. of row/col in the game board */
#define MYPIECE 'X' 
#define OTHERPIECE 'O' 
#define Even(A) ((A) % 2 == 0 ? true : false)

char Title[20] = "Othello";
FILE *ofp;	/*Pointer to the file which will hold the opponents moves */

typedef struct{
	/* inherited Constants */

		int size; /* Size of the board */
	
	/* inherited variables */

		int Level; /* How deep in the tree is this node */
		int Id;	/* Which child am I */
		int ChildCount; /* No. of children */
		char board[MAXSIZE+1][MAXSIZE+1];
		int PossibleMoves; /* No. of possible moves (children) 
					from this node*/ 
		Boolean empties;   /* Indicates no. of empty locations on
					the board */
		Boolean ParentPass;/* Indicates if the parent of this node
					has passed its move(no available move)*/
	/* internal scratch variables */

		int NextMove; /* Next move's count from this node */
		int moves[MAXSIZE*MAXSIZE][3]; /*Holds the possible moves from 
					this node*/
		int row; /* currently examining */	
		int col;

	/* synthesized variables */

		int BestRow; /* best found so far */	
		int BestCol;

	} ClientStuffType;

int ClientStuffSize()
{ /* returns the size of clients fields */

	return(sizeof(ClientStuffType));
}/* ClientStuffSize */

void PrintMenu()
{/* prints the list options to the user */

	fprintf(stdout, "\nOptions:\n");
	fprintf(stdout, "1. ? (to print this list)\n\n");
	fprintf(stdout, "2. Your move (row col)\n");
	fprintf(stdout, "3. p (to pass a move)\n");
	fprintf(stdout, "4. q (to quit)\n");
	fprintf(stdout, "5. b (to print the current board)\n\n");
	fprintf(stdout, "6. Filename (To read the new board from\n");
	fprintf(stdout, "             Filename must start with O)\n");
} /* PrintMenu */

Boolean LegalMove(p, row, col, MakeTheMove, piece)
ClientStuffType *p;
int row, col;
char piece;
Boolean MakeTheMove; /* If true, the move will be made and the board will
			be adjusted.  Otherwise the position (row, col) will
			be checked only. */
{ /* Checks to see if the move is legal by looking at all eight directions
     around (row, col) to see if any of the opponents pieces can be turned
	over. */
	
	int r, c;
	char  otherPiece;
	Boolean MoveWasMade;  /* Indicates if the move was made */

	if (p->board[row][col] != '*') /* the location must be empty */
		return(false);
	if (piece == MYPIECE){
		otherPiece = OTHERPIECE;
	}else{
		otherPiece = MYPIECE;
	}
	MoveWasMade = false;
	/* Check above (row, col) */
	if (row > 2 && p->board[row-1][col] == otherPiece){
		r = row - 2;
		while (r > 0){
			if (p->board[r][col] == piece){
				if (MakeTheMove){
					p->board[row][col] = piece;
					while (++r < row)
						p->board[r][col] = piece;
					MoveWasMade = true;
					break;
				}else
					return(true);
			}else if (p->board[r][col] == '*')
				break;
			else 	r--;
		}
	}
	/* Check below (row, col) */
	if (row <=(p->size-2) && p->board[row+1][col] == otherPiece){
		r = row + 2;
		while (r <= p->size){
			if (p->board[r][col] == piece){
				if (MakeTheMove){
					p->board[row][col] = piece;
					while (--r > row)/* turn over */
						p->board[r][col] = piece;
					MoveWasMade = true;
					break;
				}else
					return(true);
			}else if (p->board[r][col] == '*')
				break;
			else 	r++;
		}
	}
	/* Check left of (row, col) */
	if (col > 2 && p->board[row][col-1] == otherPiece){
		c = col - 2;
		while (c > 0){
			if (p->board[row][c] == piece){
				if (MakeTheMove){
					p->board[row][col] = piece;
					while (++c < col)/* turn over */
						p->board[row][c] = piece;
					MoveWasMade = true;
					break;
				}else
					return(true);
			}else if (p->board[row][c] == '*')
				break;
			else 	c--;
		}
	}
	/* Check right of (row, col) */
	if (col <=(p->size-2) && p->board[row][col+1] == otherPiece){
		c = col + 2;
		while (c <= p->size){
			if (p->board[row][c] == piece){
				if (MakeTheMove){
					p->board[row][col] = piece;
					while (--c > col)/* turn over */
						p->board[row][c] = piece;
					MoveWasMade = true;
					break;
				}else
					return(true);
			}else if (p->board[row][c] == '*')
				break;
			else 	c++;
		}
	}
	/* Check upper left diagonal of (row, col) */
	if (row > 2 && col > 2 && p->board[row-1][col-1] == otherPiece){
		r = row -2; c = col - 2;
		while (r > 0 && c > 0){
			if (p->board[r][c] == piece){
				if (MakeTheMove){
					p->board[row][col] = piece;
					while (++c<col && ++r<row)/*turn over */
						p->board[r][c] = piece;
					MoveWasMade = true;
					break;
				}else
					return(true);
			}else if (p->board[r][c] == '*')
				break;
			else{
			 	c--;
				r--;
			}
		}
	}
	/* Check upper right diagonal of (row, col) */
	if (row > 2 && col <= (p->size - 2) &&
	    p->board[row-1][col+1] == otherPiece){
		r = row -2; c = col + 2;
		while (r > 0 && c <= p->size){
			if (p->board[r][c] == piece){
				if (MakeTheMove){
					p->board[row][col] = piece;
					while (--c>col && ++r<row)/*turn over */
						p->board[r][c] = piece;
					MoveWasMade = true;
					break;
				}else
					return(true);
			}else if (p->board[r][c] == '*')
				break;
			else{
			 	c++;
				r--;
		  	} 
		}
	}
	/* Check lower left diagonal of (row, col) */
	if (row <= (p->size - 2)  && col > 2 &&
	    p->board[row+1][col-1] == otherPiece){
		r = row + 2; c = col - 2;
		while (r <= p->size && c > 0){
			if (p->board[r][c] == piece){
				if (MakeTheMove){
					p->board[row][col] = piece;
					while (++c<col && --r>row)/*turn over */
						p->board[r][c] = piece;
					MoveWasMade = true;
					break;
				}else
					return(true);
			}else if (p->board[r][c] == '*')
				break;
		   	else{
			 	c--;
				r++;
		    	}
		}
	}
	/* Check lower right diagonal of (row, col) */
	if (row <= (p->size - 2)  && col <= (p->size - 2) &&
	    p->board[row+1][col+1] == otherPiece){
		r = row + 2; c = col + 2;
		while (r <= p->size && c <= p->size){
			if (p->board[r][c] == piece){
				if (MakeTheMove){
					p->board[row][col] = piece;
					while (--c>col && --r>row)/*turn over */
						p->board[r][c] = piece;
					MoveWasMade = true;
					break;
				}else
					return(true);
			}else if (p->board[r][c] == '*')
				break;
			else{
			 	c++;
				r++;
			}
		}
	}
	if (MakeTheMove && MoveWasMade)
		return(true);
	else
		return(false); /* the move is not legal */
}/* LegalMove */

void AssignMoves(p)
ClientStuffType *p;
{ /* Searches the board, find the available places to move from this node
     and stores those places in the array moves */

	int row, col, loc;
	char piece;

	loc = 0;
	if (Even(p->Level))
		piece = MYPIECE;
	else
		piece = OTHERPIECE;
	for (row = 1; row <= p->size; row++)
		for (col= 1; col<= p->size; col++)
			if (p->board[row][col] == '*')
				if (LegalMove(p, row, col, false, piece)){
					loc++;
					p->moves[loc][1] = row;
					p->moves[loc][2] = col;
				}
	p->PossibleMoves = loc;
}/* AssignMoves */

Boolean GetNewBoard(filename, p)
char *filename;
ClientStuffType *p;

{/* Gets the size, leveland moves of the new board.  If there are any
    errors, prints a messgae and returns false. */
	int size, level, row, col;
	FILE *fp;	/* file pointer */
	char c;
	
	if ((fp = fopen(filename, "r")) == NULL){	
		fprintf(stdout, "Can't open %s\n", filename);
		fprintf(stdout, "Filename must start with O\n");
		return(false);
	}
	if (fscanf(fp, "%d", &size) == 1){
		if (size > (MAXSIZE+1)){
			fprintf(stdout, "size must be <= %d\n", p->size);
			return(false);
		}else{
		  	p -> size = size;
			c = fgetc(fp); /* get the <cr> */
			if (c != '\n'){
				fprintf(stdout, "Error in reading the file\n");
				return(false);
			}
		}
	}else{
		fprintf(stdout, "error in size \n");
		return(false);
	}
	level = 0;
	for (row = 1; row <= size; row++){
		for (col = 1; col <= size; col++){
			c = fgetc(fp);
			if (Debug & DEBUGCLIENT)
				fprintf(stdout, "%c\n",c);
			if ((c == '*') || (c == 'O') ||
				(c == 'X')){
				p -> board[row][col] = c;
				if (c != '*')
					level++;
			}else{
				fprintf(stdout, "Error in reading the board\n");
				return(	false);
			}
		}
		c = fgetc(fp); /* get the <cr> */
		if (c != '\n'){
			fprintf(stdout, "Error in reading the file\n");
			return(false);
		}
	}
	p -> Level = level; /* Level for the next move */
	p->empties = size*size-level;
	AssignMoves(p);
	return(true);
}/* GetNewBoard */
		
void ClientPrintProb(p)
ClientStuffType *p;
{
	int row, col, size;

	size = p -> size;
	fprintf(stdout, "\n    The Board:\n\n    ");
	for (col = 1; col <= size; col++)
		fprintf(stdout, "%d     ",col);
	fprintf(stdout, "\n\n");
	for (row = 1; row <= size; row++){
		fprintf(stdout, "%d   ",row);
		for (col = 1; col <= size; col++)
			fprintf(stdout, "%c     ", p -> board[row][col]); 
		fprintf(stdout, "\n");
	}
}/* ClientPrintProb */

Boolean GetReply(row, col, p, MyMove)
int *row, *col;
ClientStuffType *p;
Boolean *MyMove;
{ /* gets users next move by row and col, or quit message, or new board */

	char line[20], c, filename[20];
	Boolean success;
	
	*MyMove = false; /* Opponent has made a move */
	while(true){ /* loop until row and column of the move or q(uit)
			is entered */
		fprintf(stdout, "\nYour turn>");
		fflush(stdout);
		if (gets(line) == NULL){
			fprintf(stdout, "End of input file!\n");
			return(false);
		}
		if (sscanf(line, "%d %d", row, col) == 2){
			fprintf(ofp, " %d %d\n", *row, *col);
			p -> PossibleMoves = 1;
			return(true);
		}else if (sscanf(line, "%c", &c) == 1)
			if (c == 'q'){
				fprintf(ofp, " %c\n", c);
				return(false);
			}else if (c == 'b')
				ClientPrintProb(p);
			else if (c == 'p'){
				fprintf(ofp, " %c\n", c);
				p -> PossibleMoves = 0;
				return(true);
			}else if (c == '?')
				PrintMenu();
			else if (sscanf(line, "%s", filename) == 1){
				success = GetNewBoard(filename, p);
				if (success){ 
					if (Even(p->Level)){
						*MyMove = true;/*Next move is mine */
						return(true);
					}else	ClientPrintProb(p);
				}else	fprintf(stdout, "try again\n");
			}else fprintf(stdout, "Error!! try again\n");
	}
} /*GetReply*/

void ClientPrintInfo(p)
ClientStuffType *p;
{/* prints the information about ClientStuff */
	int moves;

	fprintf(stdout, "\n size = %d\n",p->size);
	fprintf(stdout, "PossibleMoves = %d\n", p->PossibleMoves);
	fprintf(stdout, "row  col\n");
	for (moves = 1; moves <= p->PossibleMoves; moves++)
		fprintf(stdout, "%d   %d\n",p->moves[moves][1], p->moves[moves][2]);
	ClientPrintProb(p);
	fprintf(stdout, "nextMove = %d\n", p->NextMove);
	fprintf(stdout, "Level = %d\n", p->Level);
	fprintf(stdout,"\n\n");
}/* ClientPrintInfo */
			
void ClientFirstProb(size, ProbPtr)
int size;	/* size of the board */
ClientStuffType *ProbPtr;
{ /* Initializes the fields of the top node, makes the first move and
     allows the user to make a move */

	int row, col;
	char filename[20], line[10], c;

	/* make all positions of the board available */
	for (row = 1; row <= size; row++)
		for (col = 1; col<= size; col++){
			ProbPtr -> board[row][col] = '*';
		}
	ProbPtr->board[size/2][size/2] = ProbPtr->board[size/2+1][size/2+1]='X';
	ProbPtr->board[size/2+1][size/2] = ProbPtr->board[size/2][size/2+1]='O';
	ProbPtr -> size = size;
	ProbPtr -> empties = size * size - 4;
	ProbPtr -> NextMove = 1;
	ProbPtr -> row = -1;
	ProbPtr -> col = -1;
	ProbPtr -> ParentPass = false; 
	gets(filename); /* clear the input stream */
	fprintf(stdout, "\nOutput file? ");
	gets(filename); 
	if ((ofp = fopen(filename, "w")) == NULL){
		fprintf(stdout, "Can't open %s\n", filename);
		ofp = stdout;
	}
	ClientPrintProb(ProbPtr);
	fprintf(stdout, "\nWould you like to make the first move(y/n)?");
	if (fscanf(stdin, "\n%c", &c) == 1 && (c == 'Y' || c == 'y'))
		ProbPtr -> Level = 5;
	else{ /* Computer make the first move */
		ProbPtr -> Level = 4; /* First 4 moves are already made */
		AssignMoves(ProbPtr); /*Also determines the no. Possible Moves*/
		ProbPtr -> BestRow = ProbPtr->moves[1][1];
		ProbPtr -> BestCol = ProbPtr->moves[1][2];
	}
	fprintf(ofp, "%c\n", c);
	gets(filename); /* clear the input stream */
} /* ClientFirstProb */ 


Boolean NoMoreChildren(p)
ClientStuffType *p;
{
	if (p -> PossibleMoves == 0 && p -> NextMove == 1)
		return(false); /* we allow one child if the node is passing */
	if (p -> NextMove > p -> PossibleMoves)
		return(true);
	else	return(false);
}/* NoMoreChildren */

Boolean Symmetry(p)
ClientStuffType *p;
{
	return(false); /* There are no symmetries */
}/* Symmetry */

int StaticValue(p)
ClientStuffType *p;
{ /* Determines the value of the board at this leaf (pointed to by p) and 
	 stores it in the value field of the node */

	int row, col, MyCount, OtherCount, Diff;
	MyCount = 0;
	OtherCount = 0;
	for (row = 1; row <= p->size; row++)
		for (col = 1; col <= p->size; col++)
			if (p->board[row][col] == 'X')
				MyCount++;
			else if (p->board[row][col] == 'O')
				OtherCount++;
	Diff = MyCount - OtherCount;
	if (Even(p->Level))
		return(Diff);
	else
		return(-Diff);
} /* StaticValue */

Boolean ClientLeaf(p)
ClientStuffType *p;
{ /* Checks to see if the node pointed to be p is a leaf or not. If there
	 are no more room on the board or if the node and its parent both
	have passed. */

	if (p -> empties == 0)
		return(true); /* no more room on the board */
	if (p -> PossibleMoves == 0 && p -> ParentPass)
		return(true); /* Both this node and its parent have passed */
	return(false);
}/* ClientLeaf */

void ClientPrintScores(p)
ClientStuffType *p;
{ /* counts the no. of each piece on the board and prints them out */

	int MyCount = 0, OtherCount = 0, row, col;
	for (row = 1; row <= p-> size; row++)
		for (col = 1; col <= p-> size; col++)
			if (p -> board[row][col] == 'X')
				MyCount++;
			else if (p -> board[row][col] == 'O')
				OtherCount++;
	fprintf(stdout, "\n\nGame is over.\n");
	fprintf(stdout, "My score = %d\n", MyCount);
	fprintf(stdout, "Your score = %d\n\n", OtherCount);
	fflush(stdin);
	fflush(stdout);
}/* ClientPrintScores */

void SortMoves(p)
ClientStuffType *p;
{ /* Sorts the moves in order of the value of the positions using selection
	sort */
	int i, j, min, temp, col;

	for (i = 1; i <= (p->PossibleMoves-1); i++){
		min = i;
		for (j = i+1; j <= p->PossibleMoves; j++)
			if (p->moves[j][3] < p->moves[min][3])
				min = j;
		/* switch */
		for (col = 1; col <= 3; col++){
			temp = p->moves[min][col];
			p->moves[min][col] = p->moves[i][col];
			p->moves[i][col] = temp;
		}
	}
}/* SortMoves */

Boolean ClientPlay(ParentPtr, ChildPtr, ReadyToMove)
ClientStuffType *ParentPtr, *ChildPtr;
Boolean ReadyToMove; /* Indicates if this call is for a move to be made
		or it is returning the values of children to be sorted */
{ /* makes the move indicated in the Parent, modifies the Parent, interactively
     gets the next move from User. */

	int row, col;
	Boolean MyMove; /* A new board has been given by the user and it is
			my turn to make a move */

	if (Even(ParentPtr -> Level)){
		if (!ReadyToMove){
			SortMoves(ParentPtr);
			ParentPtr -> NextMove = 1;
			ParentPtr -> BestRow = -1;
			ParentPtr -> BestCol = -1;
			ParentPtr -> row = -1;
			ParentPtr -> col = -1;
			ParentPtr -> ParentPass = false;
			*ChildPtr = *ParentPtr;
			return(false); /* game is not over */
		}
		fprintf(stdout, "\nMy move = (%d  %d)\n",ParentPtr->BestRow,
			ParentPtr->BestCol);
		MyMove = LegalMove(ParentPtr, ParentPtr->BestRow, 
			ParentPtr->BestCol, true, MYPIECE);/* Ignore the value returned*/
		ParentPtr -> Level++;
		ParentPtr -> PossibleMoves = -1;
		ClientPrintProb(ParentPtr);
		ParentPtr -> empties--;
		if (ParentPtr -> empties == 0){
			ClientPrintScores(ParentPtr);
			return(true); /* game is over */
		}
	}
	while (true){
		if (GetReply(&row, &col, ParentPtr, &MyMove)){
			if (ParentPtr -> PossibleMoves == 0){
				/* occcurs when Opponent has passed */
				ParentPtr -> Level++;
				AssignMoves(ParentPtr);
				if (ParentPtr->PossibleMoves == 0){
					ClientPrintScores(ParentPtr);
					return(true);
				}else	break;
			}
			if (MyMove){
				ClientPrintProb(ParentPtr);
				if (ParentPtr -> PossibleMoves > 0)
					break;
				else{
					ParentPtr -> Level++;
					fprintf(stdout, "I must pass!\n");
				}
			}else{
				if (LegalMove(ParentPtr, row, col, true, OTHERPIECE)){
					ClientPrintProb(ParentPtr);
					ParentPtr -> empties--;
					if (ParentPtr -> empties == 0){
						ClientPrintScores(ParentPtr);
						return(true);
					}
					ParentPtr -> Level++;
					AssignMoves(ParentPtr);
					if (ParentPtr -> PossibleMoves > 0)
						break;
					else{
						ParentPtr -> Level++;
						fprintf(stdout,"I must pass!\n");
					}
				}else{
					fprintf(stdout, "Wrong move, try again\n");
				}
			}
		}else	return(true);  /* game is over */
	}
	ParentPtr -> NextMove = 1;
	ParentPtr -> BestRow = -1;
	ParentPtr -> BestCol = -1;
	ParentPtr -> row = -1;
	ParentPtr -> col = -1;
	ParentPtr -> ParentPass = false;
	*ChildPtr = *ParentPtr;
	return(false); /* game is not over */
} /* ClientPlay */

void NextChild(ChildPtr, ParentPtr)
ClientStuffType *ChildPtr, *ParentPtr;
{ /* Generates the next child of the given parentPtr */

	Boolean Dummy;
	char piece;
	ParentPtr -> ChildCount++;
	*ChildPtr = *ParentPtr;
	ChildPtr -> NextMove = 1;
	ChildPtr -> ChildCount = 0;
	ChildPtr -> Id = ParentPtr->ChildCount;
	ChildPtr -> Level++;
	if (Even(ParentPtr->Level)){
		piece = MYPIECE;
	}else{
		piece = OTHERPIECE;
	}
	if (ParentPtr -> PossibleMoves == 0)
		ChildPtr -> ParentPass = true;
	else{
		ChildPtr -> row = ParentPtr->moves[ParentPtr->NextMove][1];
		ChildPtr -> col = ParentPtr->moves[ParentPtr->NextMove][2];
		Dummy = LegalMove(ChildPtr, ChildPtr->row, ChildPtr->col,
				true, piece); /* Ignore the value returned */
if (!Dummy)
fprintf(stdout, "%d  %d is an illegal move\n",ChildPtr->row, ChildPtr->col);
		ChildPtr -> empties--;
		ChildPtr -> ParentPass = false;
	}
	ParentPtr -> NextMove++;
	AssignMoves(ChildPtr);
}/* NextChild */

void ClientStoreValue(ParentPtr, ChildPtr, Alpha)
ClientStuffType *ParentPtr, *ChildPtr;
int Alpha;
{/* stores the value of child in the parents list of moves */

	ParentPtr->moves[ChildPtr->Id][3] = Alpha;
}/* ClientStoreValue */ 

void ClientCombine(ParentPtr, ChildPtr, PlayNode)
ClientStuffType *ParentPtr, *ChildPtr;
Boolean PlayNode;
{
	if (PlayNode){
		ParentPtr -> BestRow = ChildPtr -> BestRow;
		ParentPtr -> BestCol = ChildPtr -> BestCol; 
	}else{
		ParentPtr -> BestRow = ChildPtr -> row;
		ParentPtr -> BestCol = ChildPtr -> col;
	}
	if (Debug & DEBUGCLIENT){
		fprintf(stdout, "Bestrow=%d     BestCol = %d\n",ParentPtr->BestRow, 
			ParentPtr->BestCol);
	}
}/*ClientCombine */

int FindMinMoves(p)
ClientStuffType *p;
{
 /* Finds Minimum no. of moves before we can reach a possible leaf */
	return(p -> size * 2 - 1);
}

void ClientConvertProblemOut(Internal, External)
ClientStuffType *Internal, *External;
{
	*External = *Internal;
}

void ClientConvertProblemIn(External, Internal)
ClientStuffType *External, *Internal;
{
	*Internal = *External;
}

