#!/usr/local/bin/tclsh

# See how badly clock is drifting
#  Copyright (c) 2000 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

set driftFile /etc/inet/ntp.drift ;# configure to your site

if {![catch {
	set driftLine [exec grep {time reset} /var/adm/messages |  tail -1]
} error]} {
	set driftTime [lrange $driftLine 0 3]
	set driftAmount [lindex $driftLine [expr [llength $driftLine] - 2]]
	set badness [expr 1+int(15*abs($driftAmount))]
#
# paul - 05/30/2003 - temporary
#
	set badness 5
	if {[catch {set peerLine [exec echo peers | ntpq]}]} {
		$peerLine = ""
	}
	if {[file readable $driftFile]} {
		gets [open $driftFile] driftCorrection
		append peerLine \
			"\nDrift correction is $driftCorrection parts per million."
	}
	puts "Last ntpd correction at $driftTime: $driftAmount\n$peerLine"
	report $myHost clock $badness \
		"Last ntpd correction at $driftTime: $driftAmount\n$peerLine"
} elseif {![catch {
	set drift [exec grep {time server} /var/adm/messages | \
		tail -25 | awk {{tot += $(NF-1); sum++; printf "%11.8f\n", tot/sum}} | \
		tail -1]
} error]} {
	set badness [expr 1+int(15*abs($drift))]
	puts "clock drifting $drift seconds/hour"
	report $myHost clock $badness "clock drifting $drift seconds/hour"
} elseif {![catch {
	set driftLine [exec ntpdate -d [exec ./enumerate.tcl timeHost] | tail -1]
} error]} {
	set driftAmount [lindex $driftLine 9]
	set badness [expr 1+int(15*abs($driftAmount))]
	puts "No recorded corrections; current error $driftAmount"
	report $myHost clock $badness \
		"No recorded corrections; current error $driftAmount"
} elseif {![catch {
	set driftLine [exec echo peers | ntpq]}]} {
	set driftAmount [expr [lindex $driftLine 19] / 1000]
	set badness [expr 1+int(15*abs($driftAmount))]
	puts "Apparently xntpd is running; current error is $driftAmount"
	report $myHost clock $badness \
		"Apparently xntpd is running; current error $driftAmount\n$driftLine"
} else {
	puts $error
	puts "No indication of clock correction"
	report $myHost clock 15 "No indication of clock correction"
}

exit 0
