#!/usr/local/bin/tclsh
#
# 11/01/1996 - pjl - tcl script to check rpcinfo for a host
#

source unix.tcl

set DEBUG 0
set RpcProg "/bin/rpcinfo"

set myHost [info hostname]
while {[file rootname $myHost]!=$myHost} {
        set myHost [file rootname $myHost]
}

set running [exec $RpcProg -s]

set confFile [open ./daemon.conf r]
while {[gets $confFile line]>=0} {
    if [regexp ^# $line] continue ;# comment line
    if [regexp ^$ $line] continue ;# empty line
	if {![string match [lindex $line 0] $tcl_platform(os)]} continue
	if {![string match [lindex $line 1] $myHost]} continue
	puts "working on $line"
	set service [lindex $line 2]
	set badness [expr 15*(1 - [regexp $service $running])] ;# 0=good; 15=bad
	# set badness [catch {eval exec $RPCPROG -u $myHost $service}]
	if {$badness > 0} {
		puts "$service is not running"
	}
	report $myHost $service $badness "$service is not running"
} ;# for all lines in confFfile

exit 0
