#!/usr/local/bin/perl

# convert dates from form 3/15/89 to 15-Mar-89 and from form 9/1877 to Sep-1877.
# This Perl script is far faster than the equivalent Sed script.

# Author:  Raphael Finkel 12/1996 (that is, Dec-1996)

@months[1] = "Jan";
@months[2] = "Feb";
@months[3] = "Mar";
@months[4] = "Apr";
@months[5] = "May";
@months[6] = "Jun";
@months[7] = "Jul";
@months[8] = "Aug";
@months[9] = "Sep";
@months[10] = "Oct";
@months[11] = "Nov";
@months[12] = "Dec";

while ($line = <STDIN>) {
	$line =~
		s/(0?1|0?2|0?3|0?4|0?5|0?6|0?7|0?8|0?9|10|11|12)\/([-0-9?()]+)\/([0-9?()]+)/$2-@months[$1]-$3/g ;
	$line =~ 
		s/([^\d\/])(0?1|0?2|0?3|0?4|0?5|0?6|0?7|0?8|0?9|10|11|12)\/([-0-9?()]+)/$1@months[$2]-$3/g;
	print "$line";
}
