#!/usr/local/bin/tclsh

# See if disk is getting full
#  Copyright (c) 1996, 1998 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

set dataFile [open "|$dfCommand " r]
while {[gets $dataFile line]>0} {
	if ![regexp ^/dev/ $line] continue
	if [regexp /cdrom $line] continue ;# CDROMs are always 100% full
	if [regexp /floppy $line] continue ;# Floppies are full a lot
	set used [lindex $line [expr $dfOffset +2]]
	set avail [lindex $line [expr $dfOffset + 3]]
	set availFraction [expr ($avail + 0.0) / ($used+$avail)]
	set usedPercent [format %2.2f%% [expr (100.0 * $used) / ($used+$avail)]]
	# set availFraction 0.05 ;# for debugging
	set badness [expr int(-7 * log($availFraction))]
	set filesystem [lindex $line [expr $dfOffset + 5]]
	if {$badness < 1} {set badness 1}
	puts "Filesystem $filesystem has usage $usedPercent, badness $badness, avail $avail"
	report $myHost disk:$filesystem $badness \
		"disk $filesystem at $usedPercent of capacity; $avail left"
}

exit 0
