#!/usr/local/bin/tclsh

# See if disk is getting full
#  Copyright (c) 1996, 1998 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

set myHost [info hostname]
while {[file rootname $myHost]!=$myHost} {
	set myHost [file rootname $myHost]
}

switch -regexp $tcl_platform(os) {
	{IRIX} { # any IRIX
		set dfCommand df
		set offset 1
	} "BSD/OS" {
		set dfCommand df
		set offset 0
	} "AIX" {
		set dfCommand "df -Pk"
		set offset 0
	} "HP-UX" {
		set dfCommand bdf
		set offset 0
	} default { ;# most OSes use this
		set dfCommand "df -k"
		set offset 0 ;# number of extra fields in df output
	}
} ;# switch

set dataFile [open "|$dfCommand " r]
while {[gets $dataFile line]>0} {
	if ![regexp ^/dev/ $line] continue
	if [regexp /cdrom $line] continue ;# CDROMs are always 100% full
	# puts "dealing with $line"
	set usage [string trim [lindex $line [expr $offset + 4]] %]
	set avail [lindex $line [expr $offset + 3]]
	set filesystem [lindex $line [expr $offset + 5]]
	set badness [expr ($usage * 3) - 265]
	if {$badness < 1} {set badness 1}
	puts "Filesystem $filesystem has usage $usage, badness $badness, avail $avail"
	report $myHost disk:$filesystem $badness \
		"disk $filesystem at $usage% of capacity; $avail left"
}

exit 0
