.SH 1 "Perspective"
.lp
In this chapter, we have touched on a number of issues that are the subject
of active research.
This research is the result of several sources of pressure.
.sp 10p
.ip \(bu
Computers always become saturated eventually.
.ip \(bu
New technologies, particularly the Ethernet,
.IN Ethernet
have made it inexpensive to connect computers together.
.ip \(bu
Workstations that have extensive computing power are becoming relatively
inexpensive.
.ip \(bu
Communication is necessary for networks of computers to co-operate with each
other.
.ip \(bu
Standards make it easier to expand facilities without requiring retraining of
users and reimplementation of programs.
.ip \(bu
Some problems are too expensive to solve on standard machines.
As computers become faster, users' expectations become greater, with the result
that there will always be a demand for increased computational power.
The only hope is to build a multicomputer and distribute the problem.
.sp 10p
.lp
One result of these pressures has been a trend toward operating
systems whose processes communicate with each other by standard protocols.
Local-area networks of machines with such operating systems allow sharing of
services.
A version of this trend is for fairly small and inexpensive individual
machines, possibly even lacking backing store, to be used as high-performance
workstations.
File and backing-store transfers are conducted through the communication
medium to file-server machines.
.pp
Personal computers are already showing the results of this trend.
They have only a few standard operating systems, such as CP/M, and most can
.IN CP/M "operating system"
connect to other computers either by direct connections that obey a universal 
protocol at the host-to-line level (called RS-232) or by phone connections
.IN "RS-232" protocol
that translate to RS-232.
Workstation-class computers are more expensive (as of 1987, they cost about
.IN "Workstations"
$10,000), but they still cost much less than the mainframe computers of the
previous generation.
.pp
A second trend has been to connect local-area networks into continental
networks of computers to link researchers with common interests.
These networks are used mostly for correspondence between people, but
also to support remote file transfer, remote logon, user-information
services, and distributed bulletin boards.
The gateway between the local-area network and the long-haul networks is
any one machine in the local-area network.
.pp
A third trend has been to design operating systems especially for
multicomputers.
These operating systems provide only communication and scheduling services to
their processes.
Files, other devices, and other services are provided through utility
processes.
Policy decisions are also made by utility processes.
These multicomputers are particularly appropriate for large computations that
will not fit on single machines because of either space or time limitations.
Multicomputer operating systems are the subject of major research efforts
both in industry and at universities.
The communication-kernel approach seems to be viable not only for
multicomputers but also for a wide range of other computer organizations.
