.SH 1 "Further reading"
.lp
There are several good introductions to inter-process communication methods.
An excellent survey of the facilities proposed in high-level languages for
distributed computing has been written by Scott.
.[
scott framework evaluation
.]
The distinction among input, output, and free ports was invented by Cashin,
.[
Cashin communication
.]
who also surveyed various kinds of communication.
Another survey, by Andrews and Schneider,
.[
andrews schneider concepts notation
.]
discusses mechanisms for concurrency control as well as inter-process
communication.
.pp
Tanenbaum's excellent text
.[
tanenbaum computer networks prentice
.]
is a standard reference for details on communication devices and protocols at
various levels.
A shorter form of the same treatment can be found in his survey article.
.[
tanenbaum computer networks surveys
.]
.pp
A number of distributed operating systems have been designed and built for a
variety of multiprocessors and multicomputers.
Hydra was designed for C.mmp, a multiprocessor with 16 cpu's with shared
.IN Hydra "operating system"
.IN "C.mmp" computer
access to 16 main store modules.
.[
wulf hydra
.]
StarOs
.[
jones staros
.]
and Medusa
.[
ousterhout medusa
.]
.IN StarOs "operating system"
.IN Medusa "operating system"
were both designed for Cm*, a more advanced multiprocessor in which each cpu
.IN "Cm*" computer
has its own main store but can access the main store of other cpu's with some
delay.
Locus
.[
popek locus
.]
.IN Locus "operating system"
and MOS
.[
barak moses
.]
.IN MOS "operating system"
are distributed versions of Unix that unify the file system into one hierarchy,
.IN Unix "operating system"
identically visible to all machines.
Both have demonstrated process migration.
.pp
Many research-oriented operating systems display the communication-kernel
approach in some form, including
Accent,
.[
rashid accent
.]
.IN "Accent" "operating system"
Amoeba,
.[
tanenbaum mullender amoeba
.]
.IN "Amoeba" "operating system"
Arachne,
.[
finkel solomon roscoe symposium current
.]
.IN "Arachne" "operating system"
Charlotte,
.[
Finkel solomon charlotte technical
.]
.IN "Charlotte" "operating system"
Clouds,
.[
Allchin clouds testbed
.]
.IN "Clouds" "operating system"
Demos/MP,
.[
demos powell file
.]
.IN "Demos/MP" "operating system"
Eden,
.[
lazowska levy eden
.]
.IN "Eden" "operating system"
Micros,
.[
Wittie micros micronet
.]
.IN "Micros" "operating system"
SODS/OS,
.[
Sincoskie farber SODS
.]
.IN "SODS/OS" "operating system"
Thoth,
.[
thoth
.]
.IN "Thoth" "operating system"
and
V kernel.
.[
cheriton zwaenepoel distributed v kernel
.]
.IN "V kernel" "operating system"
A number of programming language efforts are also related to the
communication-kernel approach, particularly
Argus
.[
liskov scheifler guardians actions argus
.]
.IN Argus "programming language"
and
Lynx.
.[
scott distributed systems language thesis
.]
Lynx, for example, imposes Algol-like scope rules on the virtual space shared
by threads to help limit the chaos of shared space.
It also provides inexpensive type checking of all messages.
.IN Lynx "programming language"
Birrell has reported on efficient implementation of remote procedure calls.
.[
birrell nelson
.]
.pp
Other operating systems have novel features.
Soda
.[
kepecs soda
.]
proposes an unusual communication mechanism that uses a global set of port
.IN Soda "operating system"
numbers and allows the initiator of communication to be either the reader or
the writer.
The responder to the communication is allowed to see a small amount of data
before deciding whether to accept the communication.
NonStop
.[
bartlett nonstop
.]
is a multicomputer operating system marketed by Tandem.
.IN NonStop "operating system"
It provides redundancy at a number of levels to allow for graceful degradation
when parts fail.
A discussion of distributed operating systems in general can be found in
the article by Tanenbaum and Van Renesse.
.[
tanenbaum van
.]
.SH 1 "Exercises"
.ES
.nr E+ 0 1
.EP \n+(E+.
The \fBcobegin\fP construct is a synchronization tool in the sense discussed in
Chapter 8.
Can it build the synchronization graph of Figure 8.1?
.EP \n+(E+.
Show how to build the synchronization graph of Figure 8.1 using only Split and
Join.
.EP \n+(E+.
In the scenario of Figure \n(ch.\n(F2, why did \fBA\fP have to make its own
port?
Assuming that the Finger port is a free port, why couldn't \fBA\fP have
received its
.IN "Finger" "server"
answer on that port?
.EP \n+(E+.
Demos/MP uses write capabilities to input ports for communication.
.IN "Demos/MP" "operating system"
The reader for an input port (called the \fIowner\fP) is fixed for the life of
the port, but writers can give their capabilities away.
.br
(a) What information should be stored by the port manager for the holder of a
write capability?
.br
(b) What information should be stored by the port manager for the owner of that
port?
.br
(c) In Figure \n(ch.\n(F3, we used bound ports to show how the command
interpreter can
introduce the List and the Sort processes.
How does this situation look in Demos/MP?
.br
(d) What information passes between the port managers for the three processes
when the command interpreter introduces List to Sort?
(Assume that each of these processes is on a different machine.)
.EP \n+(E+.
What information would be useful in deciding if a process should be migrated in
a multicomputer operating system?
.EP \n+(E+.
WorkEasy Computers is designing a new product in which individual machines
are used for predefined functions.
For example, one machine is used as a file server, another runs the text
editor, and a third runs the compiler.
A fourth machine is the user's interface into the network.
Is this organization reasonable?
.EP \n+(E+.
\fBBandwidth\fP
.IN Bandwidth
is the number of bits that can be sent from one machine to
another every second.
\fBDelay\fP
.IN Delay
is the amount of time between when the writer submits the WritePort call and
the reader's ReadPort call finishes.
High bandwidth and low delay are important for efficient communication.
Suggest a multicomputer application in which high bandwidth is more important
than low delay.
Suggest an application where low delay is more important.
.EP \n+(E+.
Instead of piping List and Sort, as in Figure \n(ch.\n+(F1, the standard
output of List could be directed to a file.
After List is finished, Sort could be invoked with standard input coming from
the file.
Which method is likely to execute faster?
.EP \n+(E+.
Ports that buffer unread data require some policy for deciding when to block a
writer.
For simplicity, assume a uniprocessor operating system.
Assume that there are currently ten ports and buffer space to hold 10,000 bytes.
Suggest a blocking strategy.
.nr E9 \n(E+
.EP \n+(E+.
On multiprocessors, some buffer space may be used for messages that are in
transit \(em that is, messages written by a process on a second machine
to be read by a process on a third machine.
The current machine happens to be in the communication path and must therefore
buffer messages.
How does this situation change your answer to exercise \n(E9?
.EP \n+(E+.
Charlotte
.IN Charlotte "operating system"
uses capabilities to bound ports,
.IN Ports bound
for both reading and writing.
A \fBlink\fP
.IN Charlotte link
.IN link Charlotte
is a pair of bound ports such that the reader of one is the
writer of the other, and vice versa.
Capabilities are always transmitted as a pair and are never separated.
.br
(a) What should the CreatePort call return?
.br
(b) A client process has a link to a file server process.
Suggest a protocol for opening a file for sequential read or sequential write.
.IN Files "Sequential access"
Try to make file read and file write use as few port read and port write
operations as possible.
.EP \n+(E+.
The Locus operating system has only one file hierarchy, which spans all the
machines in the multicomputer.
Assuming that each file actually exists on the secondary storage of only one
machine and that each machine has secondary storage, suggest an allocation
design for associating files with machines.
.nr E9 \n(E+
.EP \n+(E+.
Your answer to exercise \n(E9 may suffer from a situation in which more
files cannot fit on one machine, but other machines still have plenty of file
space.
Suggest an allocation design that lessens this problem.
Do not allow individual files to cross machine boundaries.
.EP \n+(E+.
We suggested that unread data might be kept in the virtual space of the writer
until they are read.
For output ports and bound ports, this design makes sense.
This strategy is more difficult to implement in a multicomputer for input
ports or free ports.
Discuss what the semantics of Read should be in those cases and what messages
must be sent from one kernel to another to implement this design.
.EP \n+(E+.
The text suggests that intermediary processes are useful for allowing a server
on one machine to interact with the kernel on another.
A second use for intermediary processes is to transmit messages between
machines in a multicomputer.
The alternative is to let the kernel transmit such messages.
What are the advantages of each alternative?
.EP \n+(E+.
The text suggests that if synchronous write on a port blocks the caller until a
reply comes, the caller should not be preempted for another process for a
while.
When is this suggestion inapplicable?
.EE
