#!/usr/local/bin/tclsh

# See if a process is replicated too often in the process list
#  Copyright (c) 1996, 1998 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

set myHost [info hostname]
while {[file rootname $myHost]!=$myHost} {
	set myHost [file rootname $myHost]
}

set message ""

if [string compare Linux $tcl_platform(os)]==0 { # special for Linux 
	if [regexp {^2.2} $tcl_platform(osVersion)] {
		set psCommand "/bin/ps -A -o comm"
	} else {
		set psCommand "/bin/ps elfxwau"
	}
} else {
	set psCommand "/bin/ps -elf"
}

# read in the configuration file
set confFile [open ./excess.conf r]
while {[gets $confFile line]>=0} { ;# line of conf file
    if [regexp ^# $line] continue ;# comment line
    if [regexp ^$ $line] continue ;# empty line
	if {[string compare [lindex $line 0] $tcl_platform(os)]!=0} continue
		# different OS
	set Goal [lindex $line 1]
	puts "Checking $Goal"
	set count 0
	set psOutput [eval "exec $psCommand"]
	while {[regexp $Goal $psOutput]} {
		set psOutput [string range $psOutput 1 [string last $Goal $psOutput]]
		incr count
	}
	puts "$Goal running $count times"
	if {$count <= 1} {
		report $myHost $Goal 0 "$Goal running $count times"
	} elseif {$count <= 2} {
		report $myHost $Goal 11 "$Goal running $count times"
	} elseif {$count <= 5} {
		report $myHost $Goal 15 "$Goal running $count times"
	} else {
		report $myHost $Goal 25 "$Goal running $count times"
	}
} ;# line of conf file

exit 0
