#!/usr/local/bin/tclsh

# See if a process is replicated too often in the process list
#  Copyright (c) 1996, 1998 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

set myHost [info hostname]
while {[file rootname $myHost]!=$myHost} {
	set myHost [file rootname $myHost]
}

set message ""

if [string compare Linux $tcl_platform(os)]==0 { # special for Linux 
	set Flags elfxwau 
} else {
	set Flags -elf
}

set psOutput [exec /bin/ps $Flags]

foreach Goal {lpNet} {
	set count 0
	while {[regexp $Goal $psOutput]} {
		set psOutput [string range $psOutput 1 [string last $Goal $psOutput]]
		incr count
	}
	puts "$Goal running $count times"
	if {$count <= 1} {
		report $myHost $Goal 0 "$Goal running $count times"
	} elseif {$count <= 2} {
		report $myHost $Goal 11 "$Goal running $count times"
	} elseif {$count <= 5} {
		report $myHost $Goal 15 "$Goal running $count times"
	} else {
		report $myHost $Goal 25 "$Goal running $count times"
	}
}

exit 0
