#!/usr/local/qddb/bin/qwish -f
#
# fam.fx
#
# This is a rewrite of nxqddb, adding function 

# to do:
#  1. finish the various varieties of adding people, making sure that
#  existing connections are used if they exist.
#  2. when a person is removed, remove all mention of that person on the stack
#  of unique ids visited.
#  3. add a way to delete a marriage.

# stack of places we have been to let the user move about
set gv_StackSize 0
set gv_StackLocation -1
set gv_Stack(initialize) whatever
set Navigating 0; #whether a move was due to GoForward or GoBack

# navigation routines
proc PushStack {Id} {
	global gv_StackSize gv_StackLocation gv_Stack
	incr gv_StackLocation 
	if {$gv_StackSize == $gv_StackLocation} {
		incr gv_StackSize
	} else {
		set gv_StackSize [expr $gv_StackLocation + 1]
	}
	set gv_Stack($gv_StackLocation) $Id
	FixEnables
} ;# PushStack

proc GoBack {} {
	global s gv_StackSize gv_StackLocation gv_Stack \
		gv_myattr Navigating fx_config
	if {$gv_StackLocation == 0} {
		menubar SearchModeProc
		return
	}
	set gv_StackLocation  [expr $gv_StackLocation - 1]
	set aKeyList [qddb_search $s -prunebyattr UniqueId \
		word $gv_Stack($gv_StackLocation)]
	# puts "going back to $gv_Stack($gv_StackLocation)"
	set aTable [qddb_rows select -format table \
		-print $fx_config(\$search\$,print) \
		-rowdescs on -attrs UniqueId $aKeyList]
	qddb_keylist delete $aKeyList
	global .mb.pgoto.menu
	FixEnables
	set Navigating 1
	menubar SetLastSearch $aTable
	menubar ChangeModeProc 0
}; # GoBack

proc GoForward {} {
	global s gv_StackSize gv_StackLocation gv_Stack Navigating fx_config
	if {$gv_StackLocation + 1 == $gv_StackSize} return
	incr gv_StackLocation 
	set aKeyList [qddb_search $s -prunebyattr UniqueId \
		word $gv_Stack($gv_StackLocation)]
	set aTable [qddb_rows select -format table \
		-print $fx_config(\$search\$,print) \
		-rowdescs on -attrs UniqueId $aKeyList]
	qddb_keylist delete $aKeyList
	FixEnables
	set Navigating 1
	menubar SetLastSearch $aTable
	menubar ChangeModeProc 0
}; # GoForward

proc FixEnables {} {
	global .mb.pgoto.menu gv_StackLocation gv_StackSize
	if {$gv_StackLocation <= 0} {
		.mb.pgoto.menu entryconfigure back -state disabled
	} else {
		.mb.pgoto.menu entryconfigure back -state normal
	}
	if {$gv_StackLocation == [expr $gv_StackSize - 1]} {
		.mb.pgoto.menu entryconfigure forward -state disabled
	} else {
		.mb.pgoto.menu entryconfigure forward -state normal
	}
}

proc ShowParents {} {
	global gv_myattr s menubar fx_config fx:status_variable
	set myParents  $gv_myattr(Person.Parents)
	set KeyList [qddb_search $s -prunebyattr Person.Marriage word $myParents]
	set aTable [qddb_rows select -format table \
		-rowdescs on -attrs Person.Marriage \
		-print $fx_config(\$search\$,print) $KeyList]
	qddb_keylist delete $KeyList
	if {[llength $aTable] == 0} {
		set fx:status_variable "No parents"
		FreeQddbTable $aTable
	} else {
		menubar SetLastSearch $aTable
		menubar DisplayLastSearch
	}
} ; # ShowParents

proc ShowOneParent {WhichParent} {
	global gv_myattr s menubar fx_config fx:status_variable
	set myParents  $gv_myattr(Person.Parents)
	set KeyList [qddb_search $s -prunebyattr UniqueId word $myParents]
	set answer [qddb_keylist get $KeyList]
	if {[string length $answer] == 0} { ; # false alarm; deleted tuple
		set fx:status_variable "No parents"
	} else {
		set answer [qddb_tuple read $s [lindex $answer 0]]
		global ParentId
		if {[string compare $WhichParent father] == 0} {
			set Lookfor Husband
		} else {
			set Lookfor Wife
		}
		set aView \
			[qddb_view define $answer " \"Marriage.$Lookfor ParentId\" "]
		if {$ParentId == ""} {
			set fx:status_variable "No $WhichParent"
		} else {
			set KeyList [qddb_search $s -prunebyattr UniqueId word $ParentId]
			set aTable [qddb_rows select -format table \
				-print $fx_config(\$search\$,print) \
				-rowdescs on -attrs UniqueId $KeyList]
			set numRows [qddb_table row maxnum $aTable]
			for {set i 2} {$i <= $numRows} {incr i} { 
				# delete all rows except the first one
				qddb_table row delete $aTable $i
			}
			qddb_keylist delete $KeyList
			menubar SetLastSearch $aTable
			menubar DisplayLastSearch
		}
	}
} ; # ShowOneParent

proc ShowMarriage {WhichId} {
	global gv_myattr s menubar fx_config
	set KeyList [qddb_search $s -prunebyattr UniqueId word $WhichId]
	set aTable [qddb_rows select -format table \
		-print $fx_config(\$search\$,print) \
		-rowdescs on -attrs UniqueId $KeyList]
	qddb_keylist delete $KeyList
	if {[llength $aTable] == 0} {
		global fx:status_variable
		set fx:status_variable "No marriage"
	} else {
		menubar SetLastSearch $aTable
		menubar ChangeModeProc 0
	}
} ; # ShowMarriage

proc ShowSpouse {} {
	global gv_myattr s menubar fx_config
	set myID $gv_myattr(UniqueId)
	set myMarriage  $gv_myattr(Person.Marriage)
	set aKeyList [qddb_search $s -prunebyattr Person.Marriage word $myMarriage]
	set bKeyList [qddb_search $s -prunebyattr UniqueId word $myID]
	set keyList [qddb_keylist op exclusion $aKeyList $bKeyList]
	set aTable [qddb_rows select -format table \
		-print $fx_config(\$search\$,print) \
		-rowdescs on -attrs Person.Marriage $keyList]
	qddb_keylist delete $keyList
	if {[llength $aTable] == 0} {
		global fx:status_variable
		set fx:status_variable "No spouse"
		FreeQddbTable $aTable
	} else {
		menubar SetLastSearch $aTable
		menubar ChangeModeProc 0
	}
} ; # ShowSpouse

proc ShowChildren {MarriageId} {
	global gv_myattr s menubar fx_config
	set KeyList [qddb_search $s -prunebyattr Person.Parents word $MarriageId]
	set aTable [qddb_rows select -format table \
		-rowdescs on -attrs Person.Parents \
		-print $fx_config(\$search\$,print) $KeyList]
	qddb_keylist delete $KeyList
	if {[llength $aTable] == 0} {
		global fx:status_variable
		set fx:status_variable "No children"
	} else {
		menubar SetLastSearch $aTable
		menubar DisplayLastSearch
	}
} ; # ShowChildren

proc ShowMSpouse {Which} {
	global gv_myattr s menubar fx_config
	set mySpouse  $gv_myattr(Marriage.$Which)
	set KeyList [qddb_search $s -prunebyattr UniqueId word $mySpouse]
	set aTable [qddb_rows select -format table \
		-print $fx_config(\$search\$,print) \
		-rowdescs on -attrs UniqueId $KeyList]
	qddb_keylist delete $KeyList
	if {[llength $aTable] == 0} {
		global fx:status_variable
		set fx:status_variable "No $Which"
	} else {
		menubar SetLastSearch $aTable
		menubar ChangeModeProc 0
	}
} ; # ShowMSpouse

# addition routines
proc AddChild {MarriageId} {
	# give $MarriageId a new child, if possible.
	global gv_myattr s menubar NextP gv_defaults fx_config
	if {$MarriageId == ""} {
		global fx:status_variable
		set fx:status_variable "Not married"
		return
	}
	set KeyList [qddb_search $s -prunebyattr UniqueId word $MarriageId]
	set aTable [qddb_rows select -format table \
		-print $fx_config(\$search\$,print) \
		-rowdescs on -attrs UniqueId $KeyList]
	qddb_keylist delete $KeyList
	if {[llength $aTable] == 0} {
		global fx:status_variable
		set fx:status_variable "No marriage record"
		FreeQddbTable $aTable
		return
	}
	FreeQddbTable $aTable
	while {[string length [probe $NextP P]] > 0} {
		# we seem to have added that one
		incr NextP
		# puts "advancing to P$NextP"
	}
	set gv_defaults(UniqueId) P$NextP
	set gv_defaults(Person.Parents) $MarriageId
	set gv_defaults(LastName) $gv_myattr(Person.Name.LastName)
	# Adding child P$NextP to marriage $MarriageId"
	set aKeyList [qddb_search $s -prunebyattr UniqueId \
		word $MarriageId]
	set aTable [qddb_rows select -format table \
		-print $fx_config(\$search\$,print) \
		-rowdescs on -attrs UniqueId $aKeyList]
	# aTable has {qddb_tuple2 qddb_row3} in the comment field
	# of each row.
	qddb_keylist delete $aKeyList
	set aTuple [lindex [qddb_table row cget $aTable 1 -comment] 0]
	global theChildren
	set aView [qddb_view define $aTuple { {Marriage.Children theChildren} }]
	qddb_instance switch $aView Marriage.Children \
		[qddb_instance new $aView Marriage.Children]
	set theChildren P$NextP
	qddb_tuple write $aTuple
	# Free up the memory to avoid a memory leak.
	FreeQddbTable $aTable
	menubar AddModeProc
} ; # AddChild

# deletion routines
proc DeletePerson {UniqueId} {
	global s menubar gv_defaults NextP
	# first, the person record
	set KeyList [qddb_search $s -prunebyattr UniqueId word $UniqueId]
	set aTable [qddb_rows select -format table \
		-rowdescs on -attrs UniqueId $KeyList]
	qddb_keylist delete $KeyList
	if {[llength $aTable] != 0} {
		set aTuple [lindex [qddb_table row cget $aTable 1 -comment] 0]
		qddb_tuple remove $aTuple
		puts "deleting person record $UniqueId"
	}
	FreeQddbTable $aTable
	# next, the marriage record if this is a husband
	set KeyList [qddb_search $s -prunebyattr Marriage.Husband word $UniqueId]
	set aTable [qddb_rows select -format table \
		-rowdescs on -attrs Marriage.Husband $KeyList]
	qddb_keylist delete $KeyList
	if {[llength $aTable] != 0} {
		set aTuple [lindex [qddb_table row cget $aTable 1 -comment] 0]
		set aView [qddb_view define $aTuple {}]
		global theHusband
		set aView [qddb_view define $aTuple {{Marriage.Husband theHusband}}]
		set theHusband ""
		qddb_tuple write $aTuple
		puts "deleting marriage notice for husband: $UniqueId"
	}
	FreeQddbTable $aTable
	# next, the marriage record if this is a wife
	set KeyList [qddb_search $s -prunebyattr Marriage.Wife word $UniqueId]
	set aTable [qddb_rows select -format table \
		-rowdescs on -attrs Marriage.Wife $KeyList]
	qddb_keylist delete $KeyList
	if {[llength $aTable] != 0} {
		set aTuple [lindex [qddb_table row cget $aTable 1 -comment] 0]
		global theWife
		set aView [qddb_view define $aTuple {{Marriage.Wife theWife}}]
		set theWife ""
		qddb_tuple write $aTuple
		puts "deleting marriage notice for wife: $UniqueId"
	}
	FreeQddbTable $aTable
	# next, the child record if this is a child
	set KeyList [qddb_search $s -prunebyattr Marriage.Children \
		word $UniqueId]
	set aTable [qddb_rows select -format table \
		-rowdescs on -attrs Marriage.Children $KeyList]
	qddb_keylist delete $KeyList
	if {[llength $aTable] != 0} {
		set aTuple [lindex [qddb_table row cget $aTable 1 -comment] 0]
		global theChild
		set aView [qddb_view define $aTuple {{Marriage.Children theChild}}]
		set theInstance 1
		while {$theChild != $UniqueId} {
			incr theInstance
			qddb_instance switch $aView Marriage.Children $theInstance
		}
		# puts "$UniqueId is Children instance $theInstance of view $aView"
		puts "deleting child notice for $theInstance -th child: $UniqueId"
		qddb_instance remove $aView Marriage.Children $theInstance
		qddb_tuple write $aTuple
	}
	FreeQddbTable $aTable
	# avoid gaps in the person numbers
	# puts "NextP is $NextP before renumbering"
	set NextP [expr $NextP - 1]
	if {[string compare $UniqueId P$NextP] == 0} {
		puts "deleting last person; no gap introduced"
	} else {
		Renumber P$NextP $UniqueId
	}
	# puts "NextP is $NextP after renumbering"
	GoBack
	global gv_StackSize gv_StackLocation
	set gv_StackSize [expr $gv_StackLocation + 1]
	if {$gv_StackSize == 0} {
		menubar SearchModeProc
	}
	FixEnables
} ; # DeletePerson

proc Renumber {ExistingID NewID} {
	# all references to $ExistingID (a person) should be changed to NewID.
	# as UniqueId
	global MyField s
	# puts "Changing $ExistingID to $NewID"
	set KeyList [qddb_search $s -prunebyattr UniqueId word $ExistingID]
	set aTable [qddb_rows select -format table \
		-rowdescs on -attrs UniqueId $KeyList]
	if {[llength $aTable] == 0} {
		puts "No match to the UniqueID field"
	} else {
		qddb_keylist delete $KeyList
		set aTuple [lindex [qddb_table row cget $aTable 1 -comment] 0]
		set aView [qddb_view define $aTuple { {UniqueId MyField} } ]
		# puts "Changing $MyField to $NewID in UniqueId"
		set MyField $NewID
		qddb_tuple write $aTuple
	}
	FreeQddbTable $aTable
	# as Husband
	set KeyList [qddb_search $s -prunebyattr Marriage.Husband word $ExistingID]
	set aTable [qddb_rows select -format table \
		-rowdescs on -attrs Marriage.Husband $KeyList]
	qddb_keylist delete $KeyList
	if {[llength $aTable] != 0} {
		# found an appropriate Marriage record
		set aTuple [lindex [qddb_table row cget $aTable 1 -comment] 0]
		set aView [qddb_view define $aTuple { {Marriage.Husband MyField} } ]
		# puts "Changing $MyField to $NewID in Marriage.Husband"
		set MyField $NewID
		qddb_tuple write $aTuple
	}
	FreeQddbTable $aTable

	# as Wife
	set KeyList [qddb_search $s -prunebyattr Marriage.Wife word $ExistingID]
	set aTable [qddb_rows select -format table \
		-rowdescs on -attrs Marriage.Wife $KeyList]
	qddb_keylist delete $KeyList
	if {[llength $aTable] != 0} {
		# found an appropriate Marriage record
		set aTuple [lindex [qddb_table row cget $aTable 1 -comment] 0]
		set aView [qddb_view define $aTuple { {Marriage.Wife MyField} } ]
		# puts "Changing $MyField to $NewID in Marriage.Wife"
		set MyField $NewID
		qddb_tuple write $aTuple
	}
	FreeQddbTable $aTable

	# as Children
	set KeyList [qddb_search $s -prunebyattr Marriage.Children word $ExistingID]
	set aTable [qddb_rows select -format table \
		-rowdescs on -attrs Marriage.Children $KeyList]
	qddb_keylist delete $KeyList
	if {[llength $aTable] != 0} {
		# found an appropriate Marriage record
		set aTuple [lindex [qddb_table row cget $aTable 1 -comment] 0]
		global MyField
		set aView [qddb_view define $aTuple { {Marriage.Children MyField} } ]
		set theInstance 1
		while {$MyField != $ExistingID} {
			incr theInstance
			qddb_instance switch $aView Marriage.Children $theInstance
		}
		# puts "$ExistingID is Children instance $theInstance of view $aView"
		# puts "Changing $MyField to $NewID in Marriage.Children"
		set MyField $NewID
		qddb_tuple write $aTuple
	}
	FreeQddbTable $aTable
} ; # Renumber

proc ForceMarriage {MyID WhichMarriage MyRole NewRole} {
	# MyID is a person id.  This person needs a new relative added.
	# The relative will be connected via WhichMarriage: Parents, Marriage, Mxxx
	# In that marriage, I am MyRole: Children, Husband, Wife.
	# The new person will have NewRole: Children, Husband, Wife.
	# First build a Marriage record if needed with MyID in MyRole
	# Then invent a new person, link to the marriage in NewRole
	# Then go to change mode for that person.
	global gv_myattr s menubar NextP NextM gv_defaults fx:status_variable
	global MarriageId; # needed for the view later.
	# Look for an appropriate marriage that already exists.
	if {[string match $WhichMarriage {M[1-9]*}]} { # marriage already exists
		set KeyList [qddb_search $s -prunebyattr \
			UniqueId word $WhichMarriage]
		set aTable [qddb_rows select -format table \
			-rowdescs on -attrs UniqueId $KeyList]
		qddb_keylist delete $KeyList
		set aTuple [lindex [qddb_table row cget $aTable 1 -comment] 0]
		puts "Marriage record found: $aTable"
		global aRole
		set MarriageId WhichMarriage
		set aView [qddb_view define $aTuple [list \
			[list Marriage.$MyRole aRole]] ]
		if {string compare $aRole $MyRole} { 
			puts "I don't have role $MyRole in marriage $WhichMarriage"
			set fx:status_variable "Marriage does not exist"
			FreeQddbTable $aTable
			return
		}
	} else { # we don't know the Marriage Id
		set KeyList [qddb_search $s -prunebyattr \
			Marriage.$MyRole word $MyID]
		set aTable [qddb_rows select -format table \
			-rowdescs on -attrs Marriage.$MyRole $KeyList]
		qddb_keylist delete $KeyList
		if {[llength $aTable] != 0} {
			# found an appropriate Marriage record
			set aTuple [lindex [qddb_table row \
				cget $aTable 1 -comment] 0]
			puts "Marriage record found: $aTable"
			global aRole
			set aView [qddb_view define $aTuple [list \
				[list UniqueId MarriageId] \
				[list Marriage.$NewRole aRole]]]
			if {[string length $aRole] > 0} {
				puts "Marriage $MarriageId already has $NewRole set to $aRole"
				set fx:status_variable "Appears to be a duplicate $NewRole"
				FreeQddbTable $aTable
				return
			}
		} else { # build a Marriage record
			while {[string length [probe $NextM M]] > 0} {
				# we seem to have added that one
				incr NextM
			}
			set MarriageId M$NextM
			puts "Introducing marriage $MarriageId."
			puts "UniqueId = \"$MarriageId\" ; Marriage ( $MyRole = \"$MyID\" )"
			set aTuple [qddb_tuple put readable $s \
			"UniqueId = \"$MarriageId\" ; Marriage ( $MyRole = \"$MyID\" ) " ]
		}
	}
	# we need a new person.  Get the right id.
	while {[string length [probe $NextP P]] > 0} {
		# we seem to have added that one
		incr NextP
		# puts "advancing to P$NextP"
	}
	puts "Linking new person P$NextP into marriage record"
	global theValue
	set aView [qddb_view define $aTuple " \"Marriage.$NewRole theValue\" "]
	if {[string compare $NewRole Children] == 0} {
		# get a new instance, a last instance
		qddb_instance switch $aView Marriage.Children \
			[qddb_instance new $aView Marriage.Children]
	}
	set theValue P$NextP
	qddb_tuple write $aTuple ; # write the marriage record
	qddb_tuple delete $aTuple ; # free some space in memory
	# modify MyID to hold the link to the new marriage
	if {![string match $WhichMarriage {M[1-9]*}]} {
		# marriage does not already exist
		set KeyList [qddb_search $s -prunebyattr UniqueId word $MyID]
		FreeQddbTable $aTable
		set aTable [qddb_rows select -format table \
			-rowdescs on -attrs UniqueId $KeyList]
		qddb_keylist delete $KeyList
		if {[llength $aTable] == 0} {
			set fx:status_variable "Can't find a person record for $MyID"
			FreeQddbTable $aTable
			return
		}
		set aTuple [menubar info public tuple -value]
		global aMarriage
		set aView [qddb_view define $aTuple \
			" \"Person.$WhichMarriage aMarriage\""]
		puts "Setting Person.$WhichMarriage in $MyID to $MarriageId"
		set aMarriage $MarriageId
		puts "at point a"
		qddb_tuple write $aTuple
		Fx_Attribute::TupleChanged 0
		puts "at point b"
		#qddb_tuple delete $aTuple  # don't delete tuple
		puts "at point c"
		FreeQddbTable $aTable
	}
	# set up default fields in the new person
	if {[string compare $NewRole Children] == 0} {
		set gv_defaults(theConnection) Person.Parents
		set gv_defaults(LastName) $gv_myattr(Person.Name.LastName)
	} else {
		set gv_defaults(theConnection) Person.Marriage
		set gv_defaults(LastName) ""
	}
	set gv_defaults(UniqueId) P$NextP
	set gv_defaults(Person.Parents) ""
	set gv_defaults(LastName) $gv_myattr(Person.Name.LastName)
	set gv_defaults(theMarriage) $MarriageId
	# Add child P$NextP to marriage $MarriageId"
	menubar AddModeProc
	Fx_Attribute::TupleChanged 1
} ; # ForceMarriage

proc probe {where type} {
	# returns the read list for the probe; check size to see if probe hits.
	# $type is either P or M.
	global s
	# puts "probe $where $type"
	set k [qddb_search $s -prunebyattr UniqueId $type$where]
	set answer [qddb_keylist get $k]
	if {[string length $answer] > 0} { ; # may be a false alarm
		set answer [qddb_tuple read $s [lindex $answer 0]]
	}
	# puts "answer is $answer"
	qddb_keylist delete $k
	return $answer
} ; # probe

proc LastIndividual {type} { ;# find the P or M number past the end.
	# find an upper bound on the number
	set try 1
	while {[string length [probe $try $type]] > 0} {
		set try [expr 2*$try]
	}
	#binary search to get a close upper bound
	set low [expr $try / 2]
	set high $try
	while {$low < $high} {
		set mid [expr ($low+$high)/2];
		if {[string length [probe $mid $type]] == 0} {
			set high $mid
		} else {
			set low [expr $mid + 1]
		}
	}
	# high is now the one after the last person
	# puts "The next $type is $type$high."
	return $high
}

# FreeQddbTable
#   Free up a Qddb table and all the tuple/row descriptors embedded
#   in the comment fields.
proc FreeQddbTable {aTable} {
	if {[string length $aTable] == 0} {return}
	set numRows [qddb_table row maxnum $aTable]
	for {set i 1} {$i <= $numRows} {incr i} {
		set aTuple [qddb_table row cget $aTable $i -comment]
		if {[llength $aTuple] > 0} {
			set aTuple [lindex $aTuple 0]
			catch "qddb_tuple delete $aTuple"
		}
	}
	qddb_table delete $aTable
}

# NxqddbSetup --
#     w    - frame
#     s    - schema
#     p    - printed schema
#     n    - current ancestry name
#     fnum - frame number
proc NxqddbSetup {w s p n fnum} {
    global gv_search_entry gv_init fx_config

    set first 0
	foreach i $p {
		if {[string compare $n ""] == 0} {
				set newn [lindex $i 0]
		} else {
				set newn $n.[lindex $i 0]
		}
		if {[llength [split $newn .]] == 1} { # marriage goes on right
		    if {[regexp "UniqueId" $newn] || [regexp "Comment" $newn] ||
				[regexp "Source" $newn]} { # common to both left and right
				set f $w.top.f$fnum
		    } elseif {[regexp "Marriage" $newn]} {
				set f $w.right.f$fnum
		    } else {
				set f $w.left.f$fnum
		    }
		} else {
		    set f $w.f$fnum
		}
		incr fnum
		if {[llength [lindex $i 2]] > 0} { # not a leaf
			Fx_Frame f_$newn -w $f -attr $newn -side top -setschema $s \
				-relief raised -bd 2 -labelfg deeppink -pady 0 -padx 0
			pack $f.f_0 -side left -anchor ne -expand on -fill x
			$f.f_0.l configure -anchor ne
			pack $f.f_0.l -expand on -fill x -anchor ne ;# -in $subframe
			set f $f.f
			frame $f -relief raised -bd 2
			pack $f -side right -anchor ne ;# -in $subframe
			NxqddbSetup $f $s [lindex $i 2] $newn $fnum
		} else { # leaf
			set makeReadOnly [regexp \
				"UniqueId|Person.Parents|Person.Marriage|Marriage.Children|Marriage.Husband|Marriage.Wife" \
				$newn]
			if {$gv_init} {
				Fx_Entry f_$newn -w $f -attr $newn -side left -anchor ne \
					-width $fx_config(entry_width) -type Entry -setschema $s \
					-padx 0 -pady 0 -read_only $makeReadOnly
			} else {
				set gv_init 1
				Fx_Entry f_$newn -w $f -attr $newn -side left -anchor ne \
					-width $fx_config(entry_width) -type Entry -setschema $s \
					-padx 0 -pady 0 -searchfor_entry $gv_search_entry \
					-read_only $makeReadOnly
			}
			if {$makeReadOnly} {[f_$newn GetEntry] configure -bg gray70 }
			pack $f.f_0 -expand on -fill x -anchor ne ;# -in $subframe
			$f.f_0.l configure -anchor ne
			pack $f.f_0.l -expand on -fill x ;# -in $subframe
			pack $f.e -expand off -fill none ;# -in $subframe
			if {!$first && [string compare $n ""] != 0} {
				set first 1
				f_$n configure -focus [f_$newn GetEntry]
			}
		}
	}
}
proc max {a b} {
    if {$a < $b} {
	return $b
    }
    return $a
}
proc min {a b} {
    if {$a < $b} {
	return $a
    }
    return $b
}

proc XqddbReconfigure {{widg ""} {withdraw 1}} {
    global scrwid scrht fx_config

    if {$withdraw} {
	wm withdraw .
    }
    if {[string compare $widg ""] != 0} {
	pack $widg -expand off -fill none
    }
    wm minsize . $scrwid [expr $scrht / 10]; wm maxsize . $scrwid $scrht
    update
    update idletasks
    set wid [winfo reqwidth .c.f]
    set ht [winfo reqheight .c.f]
    .c configure -width $wid -height $ht
    .c configure -scrollregion [list 0 0 $wid $ht]
    update
    update idletasks
    set reqwid [winfo reqwidth .]; set reqht [winfo reqheight .]
    wm minsize . $reqwid [expr int(($reqht - $ht + $ht)/10)]; wm maxsize . $reqwid [min $reqht $scrht]
    if {[info exists fx_config(maingeom)] && [lindex $fx_config(maingeom) 1] < [min $reqht $scrht]} {
	wm geometry . \
	    ${reqwid}x[lindex $fx_config(maingeom) 1]+[lindex $fx_config(maingeom) 2]+[lindex $fx_config(maingeom) 3]
    } else {
	wm geometry . ${reqwid}x[min $reqht $scrht]
	if {[info exists fx_config(maingeom)]} {
	    wm geometry . +[lindex $fx_config(maingeom) 2]+[lindex $fx_config(maingeom) 3]	    
	}
    }
    if {$withdraw} {
	wm deiconify .    
    }
    update
    update idletasks
    set geo [split [wm geom .] +]
    set l2 [lindex $geo 0]
    set l2 [split $l2 x]
    set fx_config(maingeom) [concat $l2 [lrange $geo 1 2]]
}

proc BindConfigure {} {
    bind . <Configure> {
	if {[string compare %W .] == 0} {
	    set geo [split [wm geometry .] +]
	    set x [lindex $geo 1]
	    set y [lindex $geo 2]
	    set fx_config(maingeom) [list %w %h $x $y]
	    .c yview scroll 0 units
	}
    }
}

proc ReconfigureEntryWidths {} {
    global fx_config

    bind . <Configure> { }
    wm withdraw .
    foreach i [Fx_Entry::GetInstances] {
	$i configure -width $fx_config(entry_width)
    }
    update
    XqddbReconfigure
    BindConfigure
}

proc ManPage {} {
    global qddb_library qddb_version fx_config

    if {[winfo exists .manPage]} {
	wm withdraw .manPage
	wm deiconify .manPage
	focus .manPage
	update idletasks
        return
    }
    toplevel .manPage
    wm title .manPage "nxqddb manual page"
    set x .manPage.buttons
    frame $x -highlightthickness 0
    pack $x -side bottom -fill x
    button $x.ok -text "Ok" -command "
	set [list fx_config(geom,\$manPage\$)] \[wm geometry .manPage\]
        destroy .manPage
    "
    pack $x.ok -fill x

    if {[winfo depth .] < 8} {
	label .manPage.qddb -bitmap @$qddb_library/fx/pixmaps/qddb2.xbm
    } else {
	image create photo qddb_color2 -file $qddb_library/fx/pixmaps/qddb_color2.gif
	label .manPage.qddb -image qddb_color2 -justify c
    }
    pack .manPage.qddb -side top

    message .manPage.label -justify center -aspect 400 \
	-text "nxqddb(1) Manual Page"
    pack .manPage.label -side top

    message .manPage.version -justify center -aspect 400 \
        -text "Quick and Dirty DataBase\nVersion $qddb_version\n"
    pack .manPage.version -side top

    message .manPage.copyright -justify center -aspect 400 \
	-text "Copyright(c) 1993, 1994, 1995\nHerrin Software Development, Inc.\nAll rights reserved.\n" 
    pack .manPage.copyright -side top

    set fd [open $qddb_library/fx/nxqddb.0 "r"]
    set MAN [read $fd]
    close $fd
    set x .manPage.f
    frame $x -highlightthickness 0
    pack $x -side top -expand on -fill both
    scrollbar $x.s -orient vertical -relief sunken -command [list $x.c yview]
    pack $x.s -side right -fill y
    text $x.c -relief sunken -bd 2 -yscrollcommand [list $x.s set] -wrap word -setgrid on
    pack $x.c -side left -expand on -fill both
    $x.c insert 0.0 $MAN
    $x.c configure -state disabled
    if {[info exists fx_config(geom,\$manPage\$)]} {
	wm geometry .manPage $fx_config(geom,\$manPage\$)
    } else {
	wm geometry .manPage +70+0
    }
}

if {![info exists fx_config(entry_width)]} {
    set fx_config(entry_width) 30
}
lappend auto_path $qddb_library/fx 
if {[info exists blt_library]} {
    lappend auto_path $blt_library
}
set fx_config_dir .nxqddb_config
set argv "family"
if {[catch "qddb_schema open [lindex $argv 0]" s] != 0} {
    puts "Cannot open Schema for relation: [lindex $argv 0]\n$s"; exit 1
}
Fx:Init $s
set scrwid [winfo screenwidth .]
set scrht [winfo screenheight .]
toplevel .msg
if {[winfo depth .] < 8} {
    label .msg.l -bitmap @$qddb_library/fx/pixmaps/qddb.xbm
} else {
    image create photo qddb_color -file $qddb_library/fx/pixmaps/qddb_color.gif
    label .msg.l -image qddb_color -justify c
}
pack .msg.l -side top

set msgcolor powderblue
if {!$fx_monochrome} {
    .msg.l configure -bg $msgcolor
    .msg configure -bg $msgcolor
}
pack .msg.l -expand on -fill x
frame .mb
pack .mb -side top -expand on -fill x

puts "Seeing how many people and marriages are on record ..."
set NextP [LastIndividual P]
set NextM [LastIndividual M]
# puts "There are [expr $NextP - 1] people and [expr $NextM -1] marriages."
set gv_defaults(UniqueId) ""
set gv_defaults(Person.Parents) ""
set gv_defaults(LastName) ""
set gv_defaults(theConnection) ""

menubutton .mb.pgoto -text "Go to" -underline 0 -menu .mb.pgoto.menu
menu .mb.pgoto.menu -tearoff 0

.mb.pgoto.menu add command -label "parents" -command ShowParents -underline 0
.mb.pgoto.menu add command -label "father" -command "ShowOneParent father" \
	-underline 0
.mb.pgoto.menu add command -label "mother" -command "ShowOneParent mother" \
	-underline 0
.mb.pgoto.menu add command -label "parents' marriage" -underline 1\
	-command {ShowMarriage $gv_myattr(Person.Parents)}
.mb.pgoto.menu add command -label "siblings" -underline 0 \
	-command {ShowChildren $gv_myattr(Person.Parents)}
.mb.pgoto.menu add command -label "spouse" -command ShowSpouse -underline 3
.mb.pgoto.menu add command -label "marriage" -underline 3\
	-command {ShowMarriage $gv_myattr(Person.Marriage)}
.mb.pgoto.menu add command -label "children" -underline 0\
	-command {ShowChildren $gv_myattr(Person.Marriage)}
.mb.pgoto.menu add separator
.mb.pgoto.menu add command -label "back" -underline 0\
	-command {GoBack}
.mb.pgoto.menu add command -label "forward" -underline 0\
	-command {GoForward}

menubutton .mb.mgoto -text "Go to" -underline 0 -menu .mb.mgoto.menu
menu .mb.mgoto.menu -tearoff 0

.mb.mgoto.menu add command -label "husband" -command {ShowMSpouse Husband} \
	-underline 0
.mb.mgoto.menu add command -label "wife" -command {ShowMSpouse Wife} \
	-underline 0
.mb.mgoto.menu add command -label "children" -underline 0 \
	-command {ShowChildren $gv_myattr(UniqueId)}
.mb.pgoto.menu add separator
.mb.mgoto.menu add command -label "back" -underline 0 \
	-command {GoBack}
.mb.mgoto.menu add command -label "forward" -underline 0 \
	-command {GoForward}

menubutton .mb.padd -text "Add" -underline 0 -menu .mb.padd.menu
menu .mb.padd.menu -tearoff 0

.mb.padd.menu add command -label "Child" -underline 0 \
	-command {AddChild $gv_myattr(Person.Marriage)}
.mb.padd.menu add command -label "Sibling" -underline 0 \
	-command {AddChild $gv_myattr(Person.Parents)}
.mb.padd.menu add command -label "Husband" -underline 0 -command {
	ForceMarriage $gv_myattr(UniqueId) Marriage Wife Husband
}
.mb.padd.menu add command -label "Wife" -underline 0 -command {
	ForceMarriage $gv_myattr(UniqueId) Marriage Husband Wife
}
.mb.padd.menu add command -label "Father" -underline 0 -command {
	ForceMarriage $gv_myattr(UniqueId) Parents Children Husband
}
.mb.padd.menu add command -label "Mother" -underline 0 -command {
	ForceMarriage $gv_myattr(UniqueId) Parents Children Wife
}

menubutton .mb.pdelete -text "Delete" -underline 0 -menu .mb.pdelete.menu 
menu .mb.pdelete.menu -tearoff 0

.mb.pdelete.menu add command -label "If you are certain!" -command {
	DeletePerson $gv_myattr(UniqueId)
}

proc myButtonsAble {how} {
	# $how shouldbe normal or disabled.  Set all the aux buttons that way.
	.mb.pdelete configure -state $how
	.mb.padd configure -state $how
	.mb.pgoto configure -state $how
} ;# myButtonsAble

set path [qddb_schema path $s]
set tail [file tail $path]
if {[string compare $tail ""] == 0} {
    set tail [file tail [file dirname $path]]
}
wm title .msg "nxqddb ($tail)"
label .msg.m1 -text "Reading schema from relation `$tail'"
catch [list .msg.m1 configure -font -adobe-helvetica-bold-r-*-*-*-180-*-*-*-*-*-*]
pack .msg.m1 -side top -expand on -fill both
label .msg.m2 -text "\nThere are [expr $NextP - 1] people and [expr $NextM -1] marriages."
catch [list .msg.m2 configure -font -adobe-helvetica-bold-r-*-*-*-180-*-*-*-*-*-*]
pack .msg.m2 -side top -expand on -fill both
if {!$fx_monochrome} {
    .msg.m1 configure -bg $msgcolor
    .msg.m2 configure -bg $msgcolor
}
wm withdraw .
if {$fx_blt} {
    blt_busy hold .msg
    blt_busy hold .msg.l
    blt_busy hold .msg.m1
    blt_busy hold .msg.m2
}
wm withdraw .msg
update idletasks
update
wm geometry .msg +[expr $scrwid/2 - [winfo reqwidth .msg]/2]+[expr $scrht/2 - [winfo reqheight .msg]/2]
wm deiconify .msg
update idletasks
update
wm title . "nxqddb ($tail)"

proc ShowPhoto {} {
	global gv_myattr
	catch {destroy .photo}
	if {[string compare [string index $gv_myattr(UniqueId) 0] P] == 0 &&
	  [string length $gv_myattr(Person.Photo.File)] > 0} {
		# display photo
		image create photo myphoto -file $gv_myattr(Person.Photo.File) \
			-palette 64
		set width [image width myphoto]
		set height [image height myphoto]
		toplevel .photo
		canvas .photo.mycanvas -width $width -height $height
		.photo.mycanvas create image [expr $width/2] \
			[expr $height/2] -image myphoto 
		pack .photo.mycanvas
	} ;# display photo
}

	# -afterviewinstance {puts "ShowPhoto"}

Fx_Menubar menubar -w .mb -schema $s -array gv_myattr \
	-config_dir .nxqddb_config \
	-auxbuttons {.mb.pgoto .mb.mgoto .mb.padd .mb.pdelete} \
	-afterpost_edit {.mb.edit.menu entryconfigure Delete -state disabled} \
	-afterreadonlymode ShowPhoto \
    -afterchangemode {
		global gv_myattr
		ShowPhoto
		myButtonsAble normal
		uplevel \#0 {
			if {$Navigating} {
				set Navigating 0
			} else {
				PushStack $gv_myattr(UniqueId)
			}
			$gv_search_entry configure -state normal
			$gv_search_entry delete 0 end; # remove the search info
			$gv_search_entry configure -state disabled
		}
		if {[string compare [string index $gv_myattr(UniqueId) 0] P] == 0} {
			global gv_showing
			if {[string compare $gv_showing left] != 0} {
				pack forget .c.f.right
				pack forget .mb.mgoto
				pack .c.f.left -side left -expand on -fill both
				pack .mb.pgoto .mb.padd .mb.pdelete -side left
				wm withdraw .
				XqddbReconfigure
				wm deiconify .
				set gv_showing left
			}
		} else {
			global gv_showing
			if {[string compare $gv_showing right] != 0} {
				pack forget .c.f.left
				pack forget .mb.pgoto .mb.padd .mb.pdelete
				pack .c.f.right -side right -expand on -fill both
				pack .mb.mgoto
				wm withdraw .
				XqddbReconfigure
				wm deiconify .
				set gv_showing right
			}
		}
	} \
    -aftersearchmode {
		myButtonsAble disabled
		global gv_showing
		if {[string compare $gv_showing left] != 0} {
			pack forget .c.f.right
			pack forget .mb.mgoto
			pack .c.f.left -side left -expand on -fill both
			pack .mb.pgoto .mb.padd .mb.pdelete -side left
			wm withdraw .
			XqddbReconfigure
			wm deiconify .
			set gv_showing left
		}
    } \
    -afteraddmode {
		myButtonsAble disabled
		global gv_defaults gv_myattr
		uplevel \#0 {
			set gv_myattr(UniqueId) $gv_defaults(UniqueId)
			set gv_myattr(Person.Parents) $gv_defaults(Person.Parents)
			set $gv_defaults(Person.Parents) ""
			set gv_myattr(Person.Name.LastName) $gv_defaults(LastName)
			set $gv_defaults(LastName) ""
			if {[string length $gv_defaults(theConnection)] > 0} {
				puts "setting $gv_defaults(theConnection) to $gv_defaults(theMarriage)"
				set gv_myattr($gv_defaults(theConnection)) \
					$gv_defaults(theMarriage)
				set gv_defaults(theConnection) ""
			}
		}
		Fx_Attribute::TupleChanged 1
    } \
	-beforesave {
		global fx:change_modeval fx:mode_variable
		set fx:mode_variable ${fx:change_modeval}
	} \
	-aftersave {
		global gv_myattr fx:change_modeval fx:mode_variable
		PushStack $gv_myattr(UniqueId)
		set fx:mode_variable ${fx:change_modeval}
		GoBack
	}

.mb.config.menu add separator
.mb.config.menu add cascade -label "Entry Widths" \
	-menu .mb.config.menu.entrywidth -underline 0
menu .mb.config.menu.entrywidth -tearoff 0
.mb.config.menu.entrywidth add radiobutton -variable fx_config(entry_width) -value 10 -label 10 \
    -command ReconfigureEntryWidths
.mb.config.menu.entrywidth add radiobutton -variable fx_config(entry_width) -value 20 -label 20 \
    -command ReconfigureEntryWidths
.mb.config.menu.entrywidth add radiobutton -variable fx_config(entry_width) -value 30 -label 30 \
    -command ReconfigureEntryWidths
.mb.config.menu.entrywidth add radiobutton -variable fx_config(entry_width) -value 40 -label 40 \
    -command ReconfigureEntryWidths
.mb.config.menu.entrywidth add radiobutton -variable fx_config(entry_width) -value 50 -label 50 \
    -command ReconfigureEntryWidths
.mb.config.menu.entrywidth add radiobutton -variable fx_config(entry_width) -value 60 -label 60 \
    -command ReconfigureEntryWidths
.mb.config.menu.entrywidth add radiobutton -variable fx_config(entry_width) -value 70 -label 70 \
    -command ReconfigureEntryWidths
.mb.config.menu.entrywidth add radiobutton -variable fx_config(entry_width) -value 80 -label 80 \
    -command ReconfigureEntryWidths
.mb.config.menu.entrywidth add radiobutton -variable fx_config(entry_width) -value 90 -label 90 \
    -command ReconfigureEntryWidths
.mb.help.menu add separator
.mb.help.menu add command -label "nxqddb Manual Page" -command ManPage -underline 0

set gv_search_entry [menubar SearchForEntry]
scrollbar .s -command {.c yview}
pack .s -side right -expand on -fill y
canvas .c -yscrollcommand {.s set} -highlightthickness 0
pack .c -side left -expand on -fill both
frame .c.f -highlightthickness 0
pack .c.f -side top -expand on -fill both
.c create window 0 0 -anchor nw -window .c.f
set gv_init 0
frame .c.f.top
frame .c.f.left
frame .c.f.right
set gv_showing left ; # start by showing just the left.
pack .c.f.top -side top -expand on -fill both
pack .c.f.left -side left -expand on -fill both
pack forget .mb.mgoto
NxqddbSetup .c.f $s [qddb_schema print $s] "" 0
FixEnables
update idletasks
incr scrht -50
XqddbReconfigure "" 0
BindConfigure
menubar configure -instances [Fx_Entry::GetInstances] -frames [Fx_Frame::GetInstances]
Fx_Entry::BeforeReconfigure {wm withdraw .}
Fx_Entry::AfterReconfigure {XqddbReconfigure [$this GetEntry] 1}
Fx_Menubar::AfterReconfigure {XqddbReconfigure}
Fx_Entry::ScrollbarSide left
menubar SearchModeProc
if {$fx_blt} {
    blt_busy forget .msg.l
    blt_busy forget .msg.m1
    blt_busy forget .msg.m2
}
destroy .msg
update idletasks
update
wm deiconify .
set geo [split [wm geom .] +]
set geo [split [lindex $geo 0] x]
set fx_config(maingeom) [concat $geo [winfo x .] [winfo y .]]
.c yview scroll 0 units
eval .s set [.c yview]
