\ 
.nr R
.nr LL +.3i
.nr PS 14
.nr VS 15
.ps 14
.vs 15
.LP
.GS
4 14
3 12
2 10
1 8
roman R
default
.GE
.EQ
delim $$
gsize 14
define Ahat 'A back 68 up 18 "^" '
define etil 'e back 50 up 10 "~" '
define atil 'a back 50 up 10 "~" '
define xtil 'x back 50 up 10 "~" '
define || '\(bv\(bv'
.EN
.ps 18
.ce 1
Numerical Analysis/Breadth Exam
.LP
.sp 1
.tl 'Two Hours. Open Book''January 1993'
.sp 1
.IP 1.
I want to estimate the value of $f(x)~=~ln x$ at $x~=~1.5$.
Unfortunately, I don't have a calculator nor do I have a log table.
However, I know that $f(1)=0$, $f(2)=0.693147$, $f sup {prime} (1)=1$
and $f sup {prime} (2)=0.5$.
Please use these values to provide an approximation of $ln 1.5$ and 
estimate the error.
.ig
de Boor, page 67, example 2.9
..
.sp 1
.IP 2.
How many equally spaced points are needed so that the composite Trapezoid and
Simpson's rules approximate $I$ with an absolute error $<=~10 sup -4$
where $I$ is defined as follows.
.sp 1
.EQ
I~=~int from 0 to 1 ~~ x over {x~+~1} ~dx
.EN
.sp 1
.IP 3.
For given $n$ and real numbers $a sub 1$, ..., $a sub n+1$, let
.sp .5
.EQ
f(a sub 1 ,~...~,~a sub n+1 )~mark =~sum from i=1 to n (a sub i~+~a sub i+1 ) sup 2
.EN
.EQ
~lineup =~(a sub 1~+~a sub 2 ) sup 2~+~(a sub 2~+~a sub 3 ) sup 2~+~...~+~
(a sub n~+~a sub n+1 ) sup 2
.EN
.sp .5
.IP
Consider the algorithm:
.sp .5
.RS
.IP
$A~:=~(a sub 1 ~+~a sub 2 ) sup 2$ ;
.IP
.UL for
$i~:=~2,~...~,~n$
.UL do
.RS
.IP
$A~:=~A~+~(a sub i~+~a sub i+1 ) sup 2$
.RE
.RE
.sp .5
.IP
Prove that it is numerically stable by showing that the computed value of $A$
equals $f( atil sub 1 ,~...~,~atil sub n+1 )$ for slightly perturbed
$a sub i$'s. Estimate the error $| a sub i~-~atil sub i |/| a sub i |$.
.sp 1
.IP 4.
Let $A$ be an $n times n$ matrix. Show that
$C sub k A sup k~+~...~+~C sub 2 A sup 2~+~C sub 1 A sup 1~+~I~=~0$ 
(for some numbers $C sub 1~,~...~,~C sub k$) implies
nonsingularity of $A$.
.sp 1
.IP 5.
Consider a "nice" function $f$ so that the Newton iteration when applied to
$f(x)~=~0$ would theoretically yield quadratic convergence:
.sp .5
.EQ
e sub n+1~=~x sub n+1~-~r~=~C ~e sub n sup 2~=~C ~(x sub n~-~r) sup 2
.EN
.sp .5
.IP
Suppose however that instead of $f(x sub n )$ and $f sup {prime} (x sub m )$
we use approximations with small relative errors. That is, we construct
.sp .5
.EQ
xtil sub n+1~=~x sub n~-~{f( xtil sub n )} over {f sup {prime} ( xtil sub n )}
~{(1~+~delta sub n )} over {(a~+~alpha sub n )}~,
~~~~~~~~~~| delta sub n | ,~~| alpha sub n |~<=~epsilon
.EN
.sp .5
for some small $epsilon$. What can you say about the convergence of
$etil sub n~=~xtil sub n ~-~r$?
That is, estimate $etil sub n+1$ in terms of $etil sub n$, $epsilon$, and
the constant $C$.
