\ 
.ft R
.nr PS 14
.nr VS 15
.nr LL +.3i
.LP
.ps 14
.vs 15
.sp 1
.EQ
delim $$
gsize 14
define xhat 'x back 55 up "^" ~'
define yhat 'y back 55 up "^" ~'
define bb 'bold b'
define bR 'bold R'
define bx 'bold x'
define by 'bold y'
.EN
.ps 16
.ce 1
\fBNumerical Analysis (Breadth)\fR
.sp 2
.ps 14
.tl 'Two Hours. Open Book''May 1993'
.sp 2
.IP 1.
Adding $a sub 1~+~...~+~a sub k$ is much more difficult than multiplying
$a sub 1~*~...~*~a sub k$.
Consider the following algorithm to compute $S~=~a sub 1~+~...~+~a sub k$ :
.sp .5
.EQ
S~:=~ln (e sup {a sub 1}~*~e sup {a sub 2}~*~...~*~e sup {a sub k} )
.EN
.sp .5
This algorithm has no additions, only multiplications and special function
($"exp"$ and $"log"$) calls.
However, it still might yield large relative errors.
Provide a formal explanation for that.
.sp 1
.IP 2.
Find the 3-point Gaussian rule for the weighted integration over interval
$[ -1,~1]$ with the weight $w(x)~=~1/ sqrt |x|$. That is, find $x sub 0$,
$x sub 1$, $x sub 2$ and $A$, $B$, $C$ so that the rule
.sp .5
.EQ
Q(f)~=~Af(x sub 0 )~+~Bf(x sub 1 )~+~Cf (x sub 2 )
.EN
.sp .5
is exact for polynomials of degree less than ....
.sp 1
.IP 3.
What is the order of convergence of the following modified Newton's method:
.sp .5
.EQ
x sub i+1~=~x sub i~-~{f(y sub i )} over {f sup {prime} (x sub i )}
~~~~~~~"with"~~~~~~y sub i~=~x sub i~-~{f(x sub i )} over {f sup {prime} (x sub i )}
.EN
.sp .5
That is, find the largest $p$ so that for regular function $f$ with a single
root $r$, the error $| x sub i+1~-~r |~<=~C | x sub i~-~r | sup p$.
When is this method more efficient than the Newton's method?
.sp 1
.ig

.IP 2.
Let $A$ be s numerically stable algorithm for computing $f$, i.e.,
.sp .5
.EQ
A (x)~=~f( xhat )~~~~~~~"with"~~~~~| x - xhat |/|x|~<=~K sub f u
.EN
.sp .5
$u$ is the unit round-off. 
Let $B$ be s numerically stable algorithm for computing $g$, i.e.,
.sp .5
.EQ
B (y)~=~g( yhat )~~~~~~~"with"~~~~~| y - yhat |/|y|~<=~K sub g u
.EN
.sp .5
Show that $A(B(~cdot~))$ is a stable algorithm for computing
$f(g(y))$. Also, estimate the error of the algorithm (in terms of
$K sub f $, $K sub g$, $u$, and condition numbers of $f$ and $g$).
.sp 1


.IP 3.
The following equation
.sp .5
.EQ
x sup 6 ~-~x sup 5~+~x sup 3~+~x~-~1~=~0
.EN
.sp .5
has at most 4 real roots and at least 2 complex roots.
Besides, all roots are of magnitude $<=~2$. Why?
.sp 1

..
.IP 4.
Given the following function
.sp .5
.EQ
f(x)~=~a sub 0 (1-x) sup 3~+~3a sub 1 x(1-x) sup 2~+~3a sub 2 x sup 2 (1-x)~+~
a sub 3 x sup 3 ,~~~~~~~~0~<=~x~<=~1
.EN
.sp .5
where $a sub 0$, $a sub 1 ,~a sub 2 ,~a sub 3$ are arbitrary real numbers,
I can evaluate $f(x)$ using the following procedure:
.sp .5
.DS L
	for i:= 0 to 3 do
	   A[i] $<-~a sub i$
	for i:= 1 to 3 do
	   for j:=0 to 3-i do
	       A[j]:= x * A[j] + (1-x) * A[j+1]
.DE
.sp .5
The value of $f(x)$ is in A[0] when the procedure halts. Explain why.
The function would interpolate $a sub 0$ and $a sub 3$ at $x~=~0$ and
$x~=~1$, respectively, and the value of $f(x)$ would always contained in
the \fBconvex hull\fR of $a sub 0$, $a sub 1$, $a sub 2$ and $a sub 3$.
Why?
.sp 1
.IP 5.
Let $p(x)$ be the Lagrange interpolation polynomial (degree $<=~n$) to
a continuous function $f$ at $x sub 0$, $x sub 1$, ..., $x sub n$.
Denote by A an addition or subtraction, and by M a multiplication or
division. If we compute
.sp .5
.EQ
Y sub k~=~f sub k~/~ prod from k=0 to n ~(x sub k~-~x sub j ),~~~~~
k~=~0,1,...,n
.EN
.sp .5
once and for all then
.RS
.IP (a)
How many arithmetic operations it takes to evaluate Lagrange form at a point?
.IP (b)
On the other hand, in Newton form, if we evaluate the divided differences
of $f$ in Cotes table first then
.sp .5
.EQ
p(x)~=~ sum from k=0 to n f[x sub 0 ,~x sub 1 ,...,x sub k ]
(x~-~x sub 0 ) (x~-~x sub 1 )~...~(x ~-~x sub k-1 )
.EN
.sp .5
can be evaluated using Horner's rule in how many arithmetic operations?
.IP (c)
Compare the efficiency of Lagrange form to that of Newton form.
.RE
.LP
