\documentstyle[12pt]{article}
\input mssymb
\setlength{\oddsidemargin}{.0in}
\setlength{\evensidemargin}{.0in}
\setlength{\textwidth}{6.5in}
\begin{document}
\begin{center} {\bf Numerical Analysis, Breadth Exam\\
                January 1994}\end{center}

\vfill
\noindent{\bf PROBLEM 1:\ } 
Propose a numerically sound way of computing 
\[
   f(x)=\ln\left(e^x+\sin x\right)-2\sin x\qquad\mbox{for}\quad 
  x\simeq0.
\]

\vfill
\noindent{\bf PROBLEM 2:\ } 
Find $A,B,C,D,E$ so that $\phi_h(f)=Af'(x+h)+Bf'(x-h)+Cf(x+h)+Df(x)+Ef(x-h)$
approximates $f'(x)$ with the error $O(h^p)$ for as large $p$ as possible.

What is the value of such $p$? 

What would be the error if we extrapolated once? (Explain briefly.)

\vfill
\noindent{\bf PROBLEM 3:\ } 
Let $f(x)=e^{g(x)}$ for $x\in[a,b]$. The function $g$ is unknown; we only know 
that $g,g',g'',g'''$ are continuous, $\|g'''\|_{\infty}\le M$, and 
$\|f\|_{\infty}\le K$. Moreover, we know the values of $f$ at $n$ 
equally spaced points $x_i$. To preserve the special form of $f$, we want to 
construct $h$ so that $p(x):=e^{h(x)}$ interpolates $f$, i.e., 
$f(x_i)=p(x_i)$ for $i=1,\dots,n$. 

{\bf (a)} Explain briefly what kind of interpolation (polynomial, piecewise 
polynomial, etc.) should be used to get $h$, and how this can be done 
knowing only the values of $f(x_i)$. 

{\bf (b)} Estimate the error $\|f-p\|_{\infty}$ in terms of $K,M,b-a$ and $n$. 

%\vfill
\newpage
\noindent{\bf PROBLEM 4:\ } 
Using $n$ values of $f$ at $n$ equally spaced points $x_i$, 
I want to approximate $I(f)=\int_{-1}^1f(x)g(x)\,dx$ for $g(x)=
\lambda e^{-\lambda|x|}$ with very large $\lambda$. The function $f$ 
has 2nd derivative continuous. 

{\bf (a)} Explain why the following approach does not work well 
(even if $n$ is odd). Take $h(x):=f(x)g(x)$ and approximate 
$\int_{-1}^1h(x)\,dx$ by Trapezoid rule applied to $h$. 

{\bf (b)} Propose a good (and simple to implement) method 
$R_n(f)=\sum_{i=1}^nf(x_i)w_i$ to approximate $I(f)$. 
(You don't have to produce explicit values of the coefficients $w_i$; 
it is sufficient to explain ways for computing $w_i$'s provided that they are 
indeed easy to implement). 

{\bf (c)} Estimate the error of the method in terms of $n$, $\lambda$, and 
$\|f''\|_{\infty}=\max_{-1\le x\le 1}|f''(x)|$. 

\vfill
\noindent{\bf PROBLEM 5:\ } 
Suppose that for special points $x_1,\dots,x_n\in[0,1]$ and special 
(easy to compute) functions $g_1,\dots,g_n:[0,1]\to R$, 
\[
  A(f)(x)=\sum_{i=1}^n f(x_i)g_i(x)
\]
provides a good approximation to $f$. More specifically, assume that 
\[
  \max_{0\le x\le1}|f(x)-A(f)(x)|\le C n^{-k} 
      \max_{0\le x\le1}|f^{(p)}(x)|
\]
for some $k,p,C$ 

{\bf (a)} Using a simple change of variables, modify $A$ so it can be used for 
functions defined over $[a,b]\not=[0,1]$. That is, find $y_1,\dots,y_n
\in[a,b]$ and $h_1,\dots,h_n:[a,b]\to R$ so that 
\[
  B(F)(t)=\sum_{i=1}^{n} F(y_i)h_i(t)
\]
approximates $F:[a,b]:\to R$.

{\bf (b)} In terms of $a,b,k,p,n,C$ and $\max_{a\le t\le b}|F^{(p)}(t)|$, 
estimate the error 
\[
  \max_{a\le t\le b}|F(t)-B(F)(t)|.
\]

\end{document}
