BREADTH - May 4, 1993


       Answer the Machine Organization Questions plus any two additional
subject area questions.  You are to answer all questions in any selected
subject area.  Be sure to put your code number on every sheet that you
wish considered for grading.



Machine Organization

1)  Assume that an instruction fetch, operand load, or storage of a result
       each take 10 time units to complete.  Instruction decode, operation
       execution, and program counter update each take 1 time unit to
       complete.  How long does it take to execute the following code
       sequence:

       add    D, E, F       { add D and E and then store the result in F }
       sub    F, G, H       { subtract G from F and store the result in H }

       D, E, F, G, and H are stored in main memory.  Assume that the CPU
       has 10 internal general-purpose registers.

              You MUST explain how you arrive at your final answer.  Hint: a
       timing diagram would be an excellent technique to aid in your
       explanation.



2.  Consider the design of an instruction format for a machine that has 4
       registers -- AC, SP, PC, and IX (used for Indexing) and  1024 words
       of memory where each word is 16 bits long.  You task is to design an
       instruction format that meets the following specifications:

       (a)  The format should support the following addressing modes:
              direct, indirect, immediate, index, stack, and register.  In
              immediate and index modes, the operand consists of a 10 bit
              integer.

       (b)  15 different opcodes should be supported in each addressing
       mode.

       (c)  In register addressing mode, two register operands must be
              specified.

       (d) After constraints (a)-(c) are satisfied, any unused bit patterns
              may be used to allow some zero-address opcodes that use regis-
              ters as implicit operands.

Design an instruction format that meets the specifications and indicate
how many (if any) zero-address instructions are supported by your design.






Operating Systems


1)  Prove that hierarchical resource allocation prevents deadlocks.


2)  You have been hired as a consultant for a company which designs and
       sells a virtual memory operating system.  The company's current
       product uses a FIFO page replacement policy.  However, the manager
       saw a graph in an operating systems textbook that said LRU replace-
       ment works better than FIFO.  The manager wants to know if they
       should use LRU in their product.  What is your recommendation? 
       Explain.


3)  Assume an operating system provides ports as the basic interprocess
       communication mechanism.  We would like to use a filter process
       between a user's process and a server process to translate the data
       flowing from the user process to the server processes.  We create
       two ports for the filter process: one for messages from the user,
       and one for messages from the server (as shown below)

     +----------+            +------------+          +------------+
     |    Port A|<-----------|      Port B|<---------|            |
     |  USER    |            |   FILTER   |          |   SERVER   |
     |          |----------->|Port C      |--------->|Port D      |
     +----------+            +------------+          +------------+



       A.     Should the ports be synchronous or asynchronous?  Explain.

       B.     How would you change the filter process to make it more effi-
              cient?




Programming Languages


Describe the semantics of labels passed as parameters.  In particular,
       what effect on the stack does a goto have from inside a procedure
       when the target of the goto is a formal parameter?





Compiling


1)  Give a formal definition of a context free grammar. 


2)  If G is a context free grammar with non-terminal A, then LAST(A) is
       defined to be the set of terminals b such that A derives a string
       (of arbitrary grammar symbols) which ends in b.  Note that LAST(A)
       is not the same as FOLLOW(A).  Describe an algorithm which calcu-
       lates the values of LAST(A) for all non-terminals A of the grammar
       G.  Note that LAST(A) could include ~.  

       Does your algorithm terminate?  Explain. 




Databases


1)  Consider that a database consists of the following relations in a
       factory database:

              Project (P#, PName, Organization, Deadline)
              Machine (M#, MName, Department, Cost-Per-Hour)
              Employee (E#, EName, Department)
              Manager (E#, Manager#)  
              Usage (M#, P#, E#, Use-Hours)

       Transform the following queries into relational algebra:

       a)  get the names of all employees who work on the same machine in
              all projects of the factory.

       b)  get the name of the project which needs to be finished first,
              i.e., whose deadline is before all other projects. 

       c)  find all projects in which every one of Jim's (i.e., his name is
              'Jim') employee uses a machine.


2)  Suppose we have a database R, consisting of the following attributes:
       A, B, C, D, E, F and G, with the following functional dependencies:

              A --> G
              A, B --> C
              C --> D
              C, B --> E
              C --> B

       a) How many candidate keys does R have?  Show all of them.

       b) Is R in third normal form?  If so, explain why it is in third
              normal form.

       c) If R is not in third normal form, find a decomposition of R into
              third normal form having a lossless join and preserving depen-
              dencies.  Show why your decomposition is in third normal form
              and is lossless and dependency preserving.

