Systems Breadth Exam

January 26, 1994

Closed Books & Notes

       .  Answer Section I plus two of the Sections II, III, IV, or V.

       .  Please make sure that your code is written on the upper right
               corner of every page.

       .  Please use only one side of a page and start each section (i.e.,
               each roman numeral) on another page.

       .  Write your name on the bottom of this cover sheet and be sure to
               turn in this sheet.

       Name: ________________________________________________________



I.     Machine Organization                                                           Code: _____

1.     Consider a machine language with the following two instructions:

               AND    RegNo, hex_const
               OR     RegNo, hex_const

       There are eight 16-bit registers.  Show how to use these two in-
       structions to perform the following task:

               Change bit no. 3 in register 5 to 1 and change bit no. 6 in
               the same register to 0 without affecting any other bits.  Bits
               in a register are numbered left-to-right, 0 to 15.

                                             Before
               x   x   x   x   x   x   x   x   x   x   x   x   x   x   x   x
               0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15
               x   x   x   1   x   x   0   x   x   x   x   x   x   x   x   x
                                              After


2.     Consider a system with a DMA controller that has four registers that
       can be written or read by software running on the CPU.  The regis-
       ters are:

       (a)     R1 contains the memory address to be read or written
       (b)     R2 contains the count of the number of words to be transfer-
                      red.
       (c)     R3 contains the device number to be used.
       (d)     R4 tells the operation to be performed, i.e., whether data is
               to be read or written to the I/O device.

       The DMA controller has direct access to the main 16-bit bus.

       2.1     Describe the sequence of instructions given by the CPU to
               write a block of 64 bytes from memory address 1000 to device
               number 4.

       2.2     Describe the sequence of actions taken by the DMA controller
               to complete the request.  Be specific about the bus, I/O, and
               memory requests made by the controller and specify the points
               when interrupt signals are generated by the DMA controller. 


3.     Consider a stack-based machine architecture that has 16 registers
       including a stack pointer (SP) and the following machine instruc-
       tions:

               PUSH X -- pushes word X on stack after advancing the stack
                      pointer
               POP Y  -- loads the word on top of stack in Y and then decre-
                      ments the stack pointer.
               INCSP, DECSP --respectively increment or decrement stack
                      pointer without pushing or popping any data.
               CALL sub  -- transfers control to procedure sub after pushing
                      the return address (current PC) on the stack.

       Other machine instructions are not relevant for this problem and are
       omitted. 

       Assume you are translating code written for a high-level language P
       such as Pascal into the above machine language. The language P has
       only call-by-value parameter passing and scope rules are similar to
       Pascal.

       Given the following procedure in P, show the sequence of machine
       level instructions your translator must generate to accomplish the
       procedure call 

               ``call_me_P( FirstParam, SecondParam)''

         procedure call_me_P( a, b : int);
            var p,q : int;
         begin
               ....
         end

       Be sure to indicate the instructions executed by both the caller and
       callee.




II.    Operating Systems

1.     Consider a virtual address space of 32 pages (beginning at location
       0) with each page being 4096 bytes long.  The maximum physical
       memory capacity of the underlying hardware is 8 frames (4096 byte
       frames).

       a) how many bits are required to store a virtual address?
       b) what components is a virtual address divided into?
       c) how many bits are required to represent physical addresses?


2.     Consider the following 2 dimensional array A.

               var A: array [1..100] of array [1..100] of character;

       where A[1][1] is at location 200 in the virtual address space,
       A[1][2] is at location 201 in the virtual address space, A[1][3] is
       at location 202, etc, A[2][1] is at location 300, etc.  The page
       size is 200.  A small program is in page 0 (locations 0 to 199) that
       manipulates the matrix A. Because page 0 contains the program, page
       0 must not be paged out.

       Assume there are 4 frames of physical memory (numbered 0-3).  The
       small program in page 0 resides in frame 0 and executes the follow-
       ing code:

                      A[1][1]   = 1;
                      A[21][32] = 2;
                      A[32][71] = 3;
                      A[2][18]  = 4;
                      A[43][81] = 5;
                      A[1][54]  = 6;
                      A[31][9]  = 7;
                      A[48][62] = 8;
                      A[44][12] = 9;
                      A[43][41] = A[32][71];

       Assume that frames 1-3 are initially empty.  Show which accesses to
       the A matrix cause page faults under FIFO and LRU page replacement
       and state the total number of page faults for each method.


3.     Consider a modified Round Robin Scheduling Algorithm which is
       identical to standard Round Robin Scheduling in all aspects except
       that a process's id (its pid) may appear on the ready list multiple
       times.  An example of such a list is shown below:


       Ready List --> pid-3 --> pid-7 --> pid-3 --> pid-2



       What are the advantages and disadvantages of this scheme?


4.     Consider the following program (the psuedo-code is given below). 
       Insert the appropriate code to synchronize the following four
       processes so that characters are written out on terminal B in the
       same order that they are read in from terminal A.  First show how
       you would synchronize the processes using semaphores and then show
       how you would synchronize the processes using event counts and
       sequencers.

         main() {
               create and start process 1 executing procedure R();
               create and start process 2 executing procedure R();
               create and start process 3 executing procedure W();
               create and start process 4 executing procedure W();
         }

         char shared_buff[100];

         R()
         {
               while(1) {
                      read a character from Terminal A;
                      put the character in "shared_buff";
               }
         }

         W()
         {
               while(1) {
                      get a character from "shared_buff";
                      write the character to Terminal B;
               }
         }



III.   Compiling

       Given a context free grammar G:

               S  l c i S
               S  p L k
               S  a
               L  S T
               T  ; L
               T  ~


       a)      What is FOLLOW(S)?


       b)      Construct an LL(1) parse table for grammar G.


       c)      Draw a parse tree for:

                      p l c i a ; s k



IV.    Programming Languages

1.     a)      Show that the following grammar for the if-then-else construct
               is ambiguous and give the corresponding unambiguous grammar:

               <stmt> --> <assign> | <if-stmt>
               <assign> --> <id> := <expr>
               <if-stmt> --> if <logic-expr> then <stmt> | 
                              if <logic-expr> then <stmt> else <stmt>

       (A complete grammar would need also to define <id>, <expr>, and
               <logic-expr>.)


       b)      Give unambiguous grammars for the arithmetic expression over
               {i, *, +, -, /}, where i is an identifier; both *, +, -, and /
               are binary operators such that:

               * and + have equal precedence; * is right associative and + is
               left associative,

               - and / have equal precedence;  / is left associative and - is
               right associative, 
       
               * and + have higher precedence than - and /.



2.     Consider the following function definition:

       function Sum (adder: real, index: integer, lenght: integer): real;
               var    tempsum : real;
               begin
                      tempsum := 0.0;
                      for index := 1 to length do tempsum := tempsum + adder;
                      Sum := tempsum
               end;
               
       If lenght is pass by value and the other two parameters are passed
       by name, what is the purpose of the following calls:

               a) Sum(A, I, 100), where A is a scalar.
               b) Sum(A[I], I, 100).
               c) Sum(A[I]*B[I], I, 100)


3.     Consider the following program segment:
               ....
               var    elem : integer;
                      A : array [1..2] of integer;
       
               procedure WhichMode (X: integer);
               begin
                      A[1] := 8;
                      elem := 2;
                      X := X + 3;
               end;
               begin
                      A[1] := 2;  A[2] := 1;
                      elem := 1;
                      WhichMode(A[elem]);
               ...

               Give the values of A[1], A[2] and elem, if the parameter
               passing method in call WhichMode(A[elem]) is:

               i)     Call by value
               ii)    Call by value-result
               iii)   Call by reference
               iv)    Call by name

                      

4.     If subprograms are permitted to be subprogram parameters, what are
       the possible ways of determining the correct referencing environment
       of the passed subprograms.  Give relative advantages and disadvan-
       tages of your suggested methods.



V.     Database

1.     Consider the following database schema used by a small printing
               company:

               Publisher(P#, PName, Address, Creditcode)
               Bookjobs(J#, P#, DueDate, Type)
               Item(I#, Quantityonhand, Price)
               ItemRequirement(J#, I#, Quantity)

       Transform the following queries into either relational algebra or
               SQL:

       a) List PName of publishers who have a job due "1/19/94" (i.e.,
               Bookjobs DueDate = `1/19/94')


       b) Find all Items which are required for more than 1 book jobs.


       c) Find any Publisher not having any book job.


       d) Find the Publisher who has at least one job that uses all items
               available in the printing company.



2.     Suppose we have a relation R, consisting of the following attrib-
       utes: A, B, C, D, E, and F with the following functional dependen-
       cies:

               A  C,
               C  B,
               C  F
               C  D, and
               A, B  E

       a) How many candidate keys does R have?  Show all of them.

       b) Is R in third normal form?  If so, explain why it is, or is not,
               in third normal form.

       c) If R is not in third normal form, find a decomposition of R into
               third normal form having a lossless join and preserving depen-
               dencies.  Show why your decomposition is in third normal form
               and is lossless and dependency preserving.


3.     Consider transactions T1, T2, and T3, defined as follows:
               T1: read(A), write(B)
               T2: read(B), write(A), read(C)
               T3: read(C), write(C)

       Assume that the transaction operations are executed by the DBMS in
       the following order:

                        T1                     T2                    T3
                                             read(B)

                                                                   read(C)

                      read(A)

                                             write(A)

                                                                                  write(C)

                      write(B)

                                             read(C)
                                           


       a) Is this schedule conflict-serializable?  Give reasons for your
               answer by drawing a precedence graph.


       b) Is it possible to use a two-phase locking protocol to ensure
               conflict-serializability of the above transactions?

