.ig xx \" preprocessor stuff
.EQ
delim $$
gfont C
.EN
.xx
.if n .ll 78
.if n .na
.nr pp 12
.nr sp 15
.nr sf 3
.sz 15
.tl 'Systems Breadth Exam''Code: \l'2i_'

.ce 1
Thursday, Janauary 19, 1995

.sz 13
.bu
Closed books and notes
.bu
Answer all three questions.
.bu
Please make sure that your private code is written on the upper right corner
of every answer page.
.bu
Please use only one side of an answer page and start each major question area
on a new page.
.bu
Write your name on the bottom of this cover sheet and be sure to turn
in this sheet.
.lp
.rs
.sp 4i
Your name: \l'5i_'
.he 'Systems Breadth Exam'January 1995'-%-'
.bp 1
.sh 1 "Machine Organization
.\" question by raphael

(a)
Draw a picture of a computer (any hypothetical computer) showing how the
following components are interconnected: cpu, memory, address-translation
hardware, disk.
Distinguish lines carrying addresses, data, and commands.

(b)
Consider the following decomposition of instruction processing using a
five-stage pipeline:
.ip FI
Fetch Instruction: Read the next instruction from memory into a register.
.ip DI
Decode Instruction: Determine the opcode and operand specifiers.
.ip CO
Calculate Operands: Calculate effective address(es) for each operand.
.ip FO
Fetch Operands: Fetch each memory operand.
.ip EI
Execute Instruction: Perform the indicated instruction, storing the results
in memory if necessary.
.lp
Assume that each stage in the pipeline takes the same amount of time (once
cycle), but that
any stage that requires memory access is delayed one cycle if a later stage
is also
accessing memory during the same cycle.
.lp
There is a short program of 5 instructions, each of which accesses one
operand in memory during stage FO and stores a result during stage EI.
Draw a timing diagram for this short program that shows for each cycle
which stage of which instruction is active.

(c)
Define the concepts of \fBhorizontal\fP and \fBvertical\fP microcode.
Describe one advantage of each form.

.ne 20
.sh 1 "Programming languages

Consider the following program written in an Algol-like language
(that is, there is deep binding and static scope):
.(b
.ds N \\h'|5i-\\n(.iu'
.ft C
\f(CBprocedure\fP A(\*N1
    \f(CBvalue\fP AParam : integer;\*N2
    FProc : \f(CBprocedure\fP()\*N3
);\*N4
    \f(CBprocedure\fP B();\*N5
    \f(CBbegin\fP -- B\*N6
        write(AParam);\*N7
        \f(CBgoto\fP lab;\*N8
    \f(CBend\fP; -- B\*N9
\f(CBbegin\fP -- A\*N10
    \f(CBcase\fP AParam \f(CBof\fP\*N11
        \f(CBwhen\fP 2 => A(1, B);\*N12
        \f(CBwhen\fP 1 => A(0, FProc);\*N13
        \f(CBwhen\fP 0 => FProc();\*N14
    \f(CBend\fP; -- case\*N15
    lab: write("leaving");\*N16
\f(CBend\fP; -- A\*N17

\f(CBprocedure\fP Dummy(); \f(CBbegin\fP \f(CBend\fP;\*N17
    -- never called; same type as B\*N18

\f(CBbegin\fP -- main program\*N19
    A(2, Dummy);\*N20
\f(CBend\fP;\*N21
.)b

(a) What does this program output?

(b) Show the central stack when control reaches line 7.
Include the static chain.

(c) Define the concept of \fBfunctional programming language\fP.
Explain why recursion and higher-order functions are important in such
languages.

.ne 10
.sh 1 "Databases

(a)
Consider a relational database consisting of the following relations:
.(b
.ft C
     employee(employeeName, age, salary)
     manager (employeeName, managerName, departmentName)
.)b

Give an expression in relational algebra for this query:
.(q
.ft C
Find all departments where the manager has a higher salary than any of that
manager's employees.
.)q

.ne 10
(b) Consider the following set of functional and multivalued dependencies:
.(b
.ft C
    A \(-> B
    B \(-> C
    C \(-> E
    E \(->\(-> D
    DE \(-> A
.)b
Is relation \fCR(A, B, C, D, E)\fP in 4th normal form? If yes, justify
your answer. If no, decompose \fCR\fP into 4th normal form and also
justify your answer.

.lp
(c)
Consider the 2PL (two-phase locking) protocol
to guarantee serializability of a transaction
schedule.  Let us modify the protocol as follows:
.(q
.ft C
Any transaction that releases a write lock for a data item 
may reacquire only a read lock on that data item.
.ft P
.)q
Does the modified 2PL protocol guarantee serializability?
If yes, prove it, otherwise, give a counter-example and discuss 
under what conditions the modified protocol may guarantee serializability.
