\documentstyle[12pt]{article}
\input mssymb
%\input{psfig}

%----------- dimensions and where on page -----------

\textwidth 7.0in
\textheight 9.3in
\hoffset=-.75in
\voffset=-1.3in

%--------- other numeric parameters ------------------

\parskip=.1in

%----------- spacing definitions ---------------------

\def\doublespaced{\baselineskip=\normalbaselineskip     % reset to normal
    \multiply\baselineskip by 2}
\def\doublespace{\doublespaced}                         % synonym

\def\singlespaced{\baselineskip=\normalbaselineskip}    % reset interline space
\def\singlespace{\singlespaced}                         % synonym

\def\triplespaced{\baselineskip=\normalbaselineskip     % reset interline space
    \multiply\baselineskip by 3}                        % increase X 3

\def\widenspacing{\multiply\baselineskip by 150         % increase interline
    \divide\baselineskip by 100}                        %  by X 1.5
\def\whitespace{\widenspacing}                          % synonym

%++++++++++ END ++++++++++++++++++++++++++++++++++++++

\begin{document}
{\large
%-----------------------------------------------------------------------------
\begin{center}
{\it THEORY AND ALGORITHMS}\\
PhD Breadth Examination\\
Spring 1992
\end{center}

\noindent
Please print your name at the top of this page, answer each question on a 
separate sheet of paper, and write the code letter found at the top of this 
page on each page you turn in.\\

\noindent
1. Define the following classes of languages:
\begin{itemize}
\item recursive languages 
\item recursively enumerable languages.
\end{itemize}
Give examples of languages in each of the classes. 
Is it true that if $L$ is a recursive language and $L'$ is a subset of $L$
then $L'$ is recursive? Justify your answer.\\

\noindent
2. Define the class of context-free languages. Provide at least one other
equivalent
characterization of context-free languages. Provide a context-free grammar 
which generates the following language $\{a^ib^{2i+1}: i\geq 0\}$.
Using your grammar derive the string $aabbbbb$. Show the derivation.\\

\noindent
3. Define {\em a binary heap}. Design an algorithm, which uses this data 
structure, to merge $k$ linked lists each of them sorted. Estimate the 
running time of your algorithm. \\

\noindent
4. You are given a binary tree with $n$ nodes labeled with 0s and 1s.
Provide an algorithm, described in a pseudocode, finding the number of nodes 
of the tree labeled with 1. Estimate its running time.  \\

\noindent
5. Give an example of a formula in propositional logic which is true precisely 
when propositional variables $p$, $q$ and $r$ are all true or are all false.

\begin{center}
$\bullet\ \bullet$ {\it SEE THE NEXT PAGE} $\bullet
\ \bullet$
\end{center}
\newpage
\begin{center}
$\bullet\ \bullet$ {\it ANSWER ONE OF THE FOLLOWING THREE QUESTIONS} $\bullet
\ \bullet$
\end{center}

\noindent
6. Suppose that a directed graph $G$ is given with $n$ vertices $1,\ldots, n$.
Each edge $[i,j]$ of the graph is assigned a non-negative weight $W[i,j]$. 
Suppose that the shortest distances between
all pairs of vertices have been precomputed. Let $A[i,j]$ be the shortest 
distance from vertex $i$ to vertex $j$.
Suppose next that a new vertex $n+1$
is added to the graph and that the weights of all edges between vertex $n+1$ 
and vertices $1,\ldots,n$
are given in $W[n+1, i]$ and $W[i, n+1]$, $1 \leq i \leq n$. Give
an algorithm with time complexity $O(n^2)$ for computing the shortest
distances for all pairs of vertices $1,\ldots, n+1$. Prove the correctness of 
your method.\\

\noindent
7.  A tree machine is a parallel computer with one processor at each
node of the tree. In a single step each processor can only communicate with
its parent and its children. Given an arbitrary binary tree machine
with a number at each leaf of the tree, describe an algorithm for computing
the prefix for these numbers. Your algorithm should run in time proportional
to the depth of the tree.\\

\noindent
8. What is the {\em Steiner Tree Problem} for VLSI
layouts?  What are some of the applications?
What is the complexity of the Steiner Tree Problem?  Provide
an algorithm for use in producing a solution.
What is the complexity of your algorithm?  How good is a solution found by 
your algorithm? Justify your answers.


%\nondent
%9. Computational Geometry

}
\end{document}
