\documentstyle[12pt]{article}
\input mssymb
%\input{psfig}

%----------- dimensions and where on page -----------

\textwidth 7.0in
\textheight 9.3in
\hoffset=-.75in
\voffset=-1.3in

%--------- other numeric parameters ------------------

\parskip=.1in

%----------- spacing definitions ---------------------

\def\doublespaced{\baselineskip=\normalbaselineskip     % reset to normal
    \multiply\baselineskip by 2}
\def\doublespace{\doublespaced}                         % synonym

\def\singlespaced{\baselineskip=\normalbaselineskip}    % reset interline space
\def\singlespace{\singlespaced}                         % synonym

\def\triplespaced{\baselineskip=\normalbaselineskip     % reset interline space
    \multiply\baselineskip by 3}                        % increase X 3

\def\widenspacing{\multiply\baselineskip by 150         % increase interline
    \divide\baselineskip by 100}                        %  by X 1.5
\def\whitespace{\widenspacing}                          % synonym

%++++++++++ END ++++++++++++++++++++++++++++++++++++++

\begin{document}
%{\large
%-----------------------------------------------------------------------------
\begin{center}
{\it THEORY AND ALGORITHMS}\\
PhD Breadth Examination\\
August 1992
\end{center}

\noindent
Please print your name at the top of this page, answer each question on a 
separate sheet of paper, and write the code letter found at the top of this 
page on each page you turn in.\\

\noindent
1. Define the following classes of languages:
\begin{itemize}
\item recursively enumerable languages,
\item recursive languages.
\end{itemize}
Give an example of a language which is recursively enumerable but not recursive.
Is it true that if $L_1$ and $L_2$ are recursive languages then $L_1\cap L_2$
is recursive?  Justify your answers.\\

\noindent
2. Define the class of regular languages. What operations on languages do you
know (one example is the union, give other examples)? Provide formal 
definitions. Which of them have the property that when
given regular languages as arguments they produce a regular language. Prove
at least three of your claims.\\ 

\noindent
3. Define {\em a binary search tree}. Give a pseudocode for the {\em insert}
procedure. What is the complexity of this procedure? Describe the
{\em delete} procedure. Show the tree after 5 is deleted from the binary
search tree given in the picture. \\
\ \\
\ \\
\ \\
\ \\
\ \\
\ \\

\noindent
4. Describe in detail an algorithm which, given an undirected, weighted
graph $G$ and an edge $e$ of $G$, produces a spanning tree of the minimum cost
among all spanning trees of $G$ which contain $e$. Provide an estimate
of the running time of your algorithm. Prove the correctness of your 
algorithm.\\

\noindent
5. Define when a set of propositional formulas is satisfiable. Let $X$ be 
a satisfiable set of propositional formulas. Let $\varphi$ be any 
propositional formula. Is the following set of formulas:
\[
Y = Cn(Cn(X)\setminus\{\varphi\})
\]
satisfiable? \\

\noindent
(By $Cn(A)$ we mean the set of all logical consequences of $A$.)


\begin{center}
$\bullet\ \bullet$ {\it SEE THE NEXT PAGE} $\bullet
\ \bullet$
\end{center}
\newpage
\begin{center}
$\bullet\ \bullet$ {\it ANSWER ONE OF THE FOLLOWING THREE QUESTIONS} $\bullet
\ \bullet$
\end{center}

\noindent
6. (a) Define the concept of topological sorting for a directed graph.
Characterize the class of graphs which posses a topological sorting. 
Give a pseudocode for an algorithm that finds a topological sorting.
Discuss its complexity. 

\noindent
(b) Assume a directed, weighted graph has a topological
sorting. Give a pseudocode of an algorithm which finds in such a graph
shortest paths from a given vertex to all other vertices in the graph. 
Prove correctness of your algorithm. Provide an estimate of the running time. 
Your score for this problem will depend on the efficiency of your algorithm.

\noindent
7. A parallel algorithm is given which, if $p$ processors are available, 
runs in time $t$. If only $q < p$ processors are available, what is its time 
complexity? What is its complexity if the number $q$ of available processors 
is greater than $p$?\\ 

\noindent
8. What is the {\em Steiner Tree Problem} for VLSI
layouts?  What are some of the applications?
What is the complexity of the Steiner Tree Problem?  Provide
an algorithm for use in producing a solution.
What is the complexity of your algorithm?  How good is a solution found by 
your algorithm? Justify your answers.


%\nondent
%9. Computational Geometry

%}
\end{document}
