.\" needs eqn, tbl
.nh \" turn off hyphenation
.ad b
.if n .ll 79
.sz 12
.nr pp 12
.nr sp 14
.\" .ds TY Foundational
.\" .ds TY Breadth
.ds TY Depth
.he 'Systems \*(TY Exam'Page %'January 1996'
.ce 100
.sz 20
Systems Exam: \*(TY
.sz 12
.ce 0
.sp 1i
.lp
This test is \fBclosed book\fP.
.ie '\*(TY'Depth' \{\c
Do all parts of all questions.
. \}
.el \{\c
Do question 1 and any other two questions.
If you do more than three questions, you will be graded on an arbitrary subset.
When you do a question, answer all parts.
.\}
Please follow these guidelines:
.bu
Use only one side of your answer sheets.
.bu
Put your code number at the top of each answer sheet.
.bu
Start each question on a new answer sheet.
.bu
Put your name and code number at the bottom of this sheet.
.ls
.sp |8i
Name: \l'5i_'
.sp .3i
Code number: \l'2i_'
.EQ
delim @@
gfont C
gsize 12
tdefine S_1 ' {S sub 1} '
tdefine S_2 ' {S sub 2} '
.EN
.bp
.if '\*(TY'Depth' .ig DE
.sh 1 "Machine Organization
.uh "Part 1.
Assume that an instruction fetch, operand load from memory, and
storage of a result to memory each take 10 time units to complete.
Further assume that operand load and storage to a register each take
1 time unit to complete.  Instruction decode, operation execution,
and program counter update each take 1 time unit to complete.  How
long does it take to execute the following code sequence:
.TS
center;
lfC l .
add   D, E, R1	{add D & E then store result in reg 1 }
store R1, F   	{store contents of reg 1 into F }
sub   R1, 2, G	{subtract reg 1 from reg 2 then store result in H }
.TE
In this code sequence,
D, E, F, and G are stored in main memory.  R1 and R2 are general-purpose
registers.
.pp
You \fBmust\fP explain how you arrive at your final answer.  Hint: a timing
diagram would be an excellent technique to aid in your explanation.
.uh "Part 2.
Consider the design of an instruction format for a machine that
has 16 registers (Registers 0 through 15) and 16M words of memory,
where each word is 32 bits long.  You task is to design an
instruction format that meets the following specifications:
.ip (a)
The format should support the following addressing modes:
direct, indirect, immediate, index, stack, and register.  In
immediate and index modes, the operand consists of a 24-bit integer.
.ip (b)
63 different opcodes should be supported in each addressing
mode.
.ip (c)
In register addressing mode, two register operands must be
specified.
.ip (d)
After constraints (a)-(c) are satisfied, any unused bit patterns
may be used to allow some zero-address opcodes that use registers as
implicit operands.
.pp
Design an instruction format that meets the specifications and
indicate how many (if any) zero-address instructions are supported by
your design.
.br
.if !'\*(TY'Breadth' .ig FO
.uh "Part 3.
List several typical differences between CISC (Complex
Instruction Set Computers) and RISC (Reduced Instruction Set
Computers) processors.  Give at least two examples of CISC processors
and at least two examples of RISC processors.
.FO
.br
.ne 3i
.sh 1 "Compilers"
.uh "Part 1.
Consider the following attribute grammar:
.TS
center ;
lb lb
lfC lfC .
production	semantic action
_
@S_1@ \(-> @S_2@ & t	@S_1@.valt := @S_2@.valt * 2
	@S_1@.valf := @S_2@.valf

@S_1@ \(-> @S_2@ & f	@S_1@.valt := @S_2@.valt
	@S_1@.valf := @S_2@.valf * 3

S \(-> & t	S.valt := 2
	S.valf := 1

S \(-> & f	S.valt := 1
	S.valf := 3
.TE
The symbol \fCS\fP is the only nonterminal of this grammar.
@S_1@ and @S_2@ are used
to differentiate between attribute values for \fCS\fP on the left- and on the
right-hand sides of the productions.
.ip (a)
Is \fCS.valf\fP an inherited or a synthesized attribute?
.ip (b)
Parse (draw the parse tree) and compute attribute values (placing
them next to the corresponding node in the parse tree) for the string
.(l
.ft C
& t & f & f & t
.)l
.ip (c)
Explain what \fCS.valt\fP and \fCS.valf\fP compute.
.lp
.rs
.if !'\*(TY'Breadth' .ig FO
.uh "Part 2.
Some people decry function subprograms for the reason that
a compiler cannot prevent the programmer from writing functions
with side effects.
.ip (a)
Define the concept of side effects.
.ip (b)
Discuss to what extent a compiler can detect side effects.
Illustrate your discussion with
specific examples from your favorite programming language that
allows for functions.
.lp
.rs
.FO
.br
.nr 2i
.sh 1 "Programming Languages"
.uh "Part 1.
Say you want to write a program that reads a list of Danish words and their
definitions and
then accepts interactive input.
The user will type in a word, and the program should output its definition.
The input format is not relevant for this question.
.ip "(a)
If you are writing in a language that has no facility for procedure definition
and procedure call,
what data types would you like the language to implement directly?
.ip "(b)
If you are writing in a language that has procedures but has no facility for
iteration, how can
you structure the part of the program that needs to read in the list of words?
.ip "(c)
Say that you store the word and definition list in some large structured
variable \fCAllDefs\fP, and that you call a procedure
\fCLookup(Word, AllDefs)\fP to find the definition of any given word.
Some parameter-passing modes are better than others for passing
\fCAllDefs\fP.
List as many modes as you can.
For each, indicate whether the mode is \fIunacceptable\fP, \fIpoor\fP, or
\fIgood\fP for passing \fCAllDefs\fP.
.if !'\*(TY'Breadth' .ig FO
.ip "(d)
In an object-oriented programming language such as C++, what classes would you
introduce to structure this program?
.FO
.sh 1 "Operating Systems"
.uh "Part 1.
Consider a segmented virtual memory and the following
segment reference string.
.(l
.ft C
0 1 2 3 2 1 3 2 1 3
.)l
The segments have the following sizes:
.TS
center ;
cfB cfB
nfC nfC .
Segment Number	Size
_
0	1K
1	10K
2	2K
3	3K
4	4K
.TE
The physical memory size of the machine is 14K.
Assume the physical memory is initially empty (cold start), and that shuffling
(moving segments in memory) is done whenever necessary to put all free space
together.
.ip (a)
Show the segment faults that occur under FIFO replacement.
.ip (b)
Show the segment faults that occur under LRU replacement.
.lp
.rs
.uh "Part 2.
Consider a uniprocessor operating system that uses RR (Round Robin)
scheduling.  Is busy waiting (using, for instance, spin locks) a reasonable
synchronization mechanism in such an environment?  Explain.
.if !'\*(TY'Breadth' .ig FO
.uh "Part 3.
Consider a file system where free space is kept on a free-space
linked list.  Suppose that the pointer to the beginning of the free-space
list is lost.  Can the file system recover from this error?  Explain.
.FO
.br
.ne 2i
.sh 1 "Databases"
.uh "Part 1.
A schedule S is \fBstrictly serializable\fP if it is conflict-equivalent to a
serial schedule in which transactions that do not overlap in S are
serialized in the same order as they appear in S.
.ip (a)
Show an example of a schedule S that is
conflict-serializable but not strictly serializable.
.ip (b)
Design a scheduler that produces only strictly serializable
schedules.
.lp
.rs
.if !'\*(TY'Breadth' .ig FO
.uh "Part 2.
Let us define the notion of conflicting database operations in the following
nonstandard way:
Two operations \fBconflict\fP if they belong to different transactions,
operate on the same data item and \fIboth\fP of them are write operations.
.ip (a)
Under this nonstandard definition of conflict,
give an example of a view-serializable schedule that is not
conflict-serializable.
.ip (b)
Under this nonstandard definition of conflict,
give an example of conflict-serializable schedule
that is not view-serializable.
.lp
.rs
.FO
.ig FO
.DE
.sh 1 "Operating Systems
.uh "Part 1.
Recent operating systems employ a microkernel design.
Argue against a microkernel design.
.uh "Part 2.
New and emerging hardware devices are causing OS designers to rethink
the way we design operating systems.  For example, the performance
of high-speed network interface (for instance, ATM) is often slowed by the
operating system because the OS's networking code is not designed for
this type of device.  More importantly, the operating system may
not provide access to new features of the device (such as quality of
service guarantees in an ATM network).  Other examples include
high-end graphics displays with on-board graphics capabilities.
The operating system often does not provide access to these
facilities, and the access that does exist is far from optimized.
.pp
Describe the design of an adaptable operating system kernel that
allows applications to tailor the operating system to meet
the performance requirements of the application.  In your answer be
sure to discuss:
.bu
the type of kernel you would use as a starting point
(microkernel, monolithic, modular)
.bu
protection concerns
.bu
fairness concerns
.bu
things that can/can't be modified
.bu
the interface routines that applications use to modify the kernel
.bu
dynamic incorporation of new services
.bu
accessing new system calls or upcalls
.lp
To illustrate your design, show how an application would modify the kernel
to provide efficient support for a high-speed ATM network that provides
guaranteed bandwidth and/or guaranteed maximum propagation delays.
.sh 1 "Networks"
.uh "Part 1 (5 points).
Transport protocols employ end-to-end flow control between two end points 
communicating across an internet.  However, some link level protocols (such as
HDLC) also employ their own link-level flow control.
.pp
Given a transport-level connection over a path consisting of one or more
links with a link-level protocol using flow control, comment on how the
link-level flow control may interact (or interfere) with transport-level flow
control.  In your answer, 
you must cite specific examples of flow-control mechanisms 
used at both transport and link level.
.uh "Part 2 (10 points).
Consider an internet consisting of several packet-switched networks
connected together.
The internet uses IP (the Internet Protocol) to provide
connectionless delivery of datagrams on end-to-end basis.  In addition, UDP
and TCP respectively provide connectionless and byte-stream delivery across
such an internet. 
.pp
Assume that some of the packet-switched networks in this
internet provide connectionless service at the network layer, whereas some of
the networks provide connection-oriented network layer service (such as X.25
or ATM).
.ip "(a: 4 points)
Describe the potential problems, performance issues, and implementation
issues involved in providing IP (and UDP/TCP) service on an end-to-end basis
when the path between the end points may consist of a mix of
connectionless and connection-oriented networks.
.ip "(b: 4 points)
Sketch out alternative approaches to resolving the issues/problems mentioned
in (a).
.ip "(c: 2 points)
Do you envision additional (and interesting) problems in implementing IP
multicast in such an environment?
.lp
.rs
.FO
