.\" macros for outline generation
.\" Call ".PH n" to start a new entry at the 'n' level (1, 2, ...) of
.\" your outline.  The text that follows (on the next input line) will
.\" appear on the same line as the entry, lined up nicely.  At least
.\" two spaces will appear after the entry.  Overflow lines will also
.\" line up nicely.  If you want to reset for a new outline, ".nr ^1 0 1"
.\" will do the trick.  If you don't like the default of 4 spaces
.\" indentation per level, you may set the '^^' number register to
.\" whatever you prefer.  The entry registers are '^1' .. '^5',
.\" in formats I, A, 1, a, and i, respectively.  You may change
.\" the formats.  To outdent without leaving a section, .in -\n(^^
.\" 
.nr ^^ 4 \" standard indentation; tailor to your own tastes.
.nr ^1 0 1 \" initial value for top level of outline.
.nr ^2 0 1 \" initial value for top level of outline.
.nr ^3 0 1 \" initial value for top level of outline.
.af ^1 I \" formats for different outline levels.
.af ^2 A
.af ^3 1
.af ^4 a
.af ^5 i
.af ^6 I
.af ^7 A
.af ^8 1
.af ^9 a
.de PH \" print heading.  argument: level. Sample use: .PH 3
.br
.if '\\$1'1' .sp
.ne 6-\\$1 \" move to next page if close to bottom.
.nr ^0 \\n(^^*\\$1  \" particular indentation for the level
.in \\n(^0m \" establish indentation
.ti -\\n(^^m \" except for first line
.ds ^0 \\n+(^\\$1\" set string ^0 to the leader.
.if \\$1-5 .ds ^0 (\\*(^0)\" parens if deep
.ds ^0 \\*(^0.\" and add a period at the end.
.nr ^0 \\n(^^m-\\w'\\*(^0'u \" set number ^0 to space count after leader
.if !\\n(^0 .nr ^0 1m \" with 1 being the minimum.
\\*(^0\\h'\\n(^0u'\\c\" print leader and move over to start column for text
.if !'\\$2'' \fB\\$2\\$3\\fP\"  print heading in bold
.if 9-\\$1 .nr ^9 0 1 \" reset the initial value for deeper levels.
.if 8-\\$1 .nr ^8 0 1
.if 7-\\$1 .nr ^7 0 1
.if 6-\\$1 .nr ^6 0 1
.if 5-\\$1 .nr ^5 0 1
.if 4-\\$1 .nr ^4 0 1
.if 3-\\$1 .nr ^3 0 1
.if 2-\\$1 .nr ^2 0 1
.if 1-\\$1 .nr ^1 0 1
..
