.\" needs eqn
.if n .ll 79
.sz 12
.nr pp 12
.he 'Systems Foundational Exams'Page % of 3'December 5, 1988'
.ce 100
.sz 20
Systems Foundational Exam

.sz 12
.ce 0
.lp
You must do section I and any two of sections II,  III, IV, and V.
Answer \fBall\fP the questions in the sections you do.
This test is \fBclosed book\fP.
.so outline.nr
.nr ^^ 2 \" indentation
.EQ
delim $$
.EN
.PH 1 "Computer organization."
.PH 2 "Instruction emulation."
.br
a)  Define the fetch-decode-execute cycle.
.br
b)  The Monoplum Computer has 21-bit words.
An instruction is composed of a 10-bit opcode, a 2-bit register number, and
9 bits of addressing.
How many opcodes are possible on this machine?
How many registers does the machine have?
.br
c)  Assuming that the Monoplum has no memory management hardware, and assuming
that registers are 12 bits long, what is the largest amount of memory that can
be placed on a Monoplum?
Defend your answer.
.PH 2 "Peripherals."
What does the cpu hardware do when an interrupt occurs?
Be sure to describe changes to the protection state, the memory, and registers.
You need not show details for any particular computer architecture.
.PH 1 "Operating systems."
.PH 2 "Scheduling."
Assume that the job mix on a computer run in batch mode is composed of 50%
short jobs, which take less then a second to complete, and 50% long jobs, which
take about a minute each.
You happen to always run long jobs.
Do you prefer round robin or first-come, first-served scheduling?
Why?
.PH 2 "Space management."
.br
a)  Describe 3 fields in a segment table, telling what they do and how the
architect decides how many bits wide each should be.
.br
b)  Is free-space allocation easier under segmentation or under paging?  Why?
.PH 2 "File systems."
File information such as protections, physical disk layout, and access times
can be stored in a directory entry or as part of the file itself.
Describe one difference this choice makes.
.PH 1 "Compilers."
.PH 2 "Syntax analysis."
Consider a text file containing a list of telephone numbers
separated by the character #.
Telephone numbers can be of the following forms:
.(l
.ft C
(666) 222-7777
(666) 222-7777 ext. 27
222-7777
222-7777 ext. 27
.ft R
.)l
In other words, each telephone number is of the form
.(l L
<area_code> <group_of_3_digits> - <group_of_4_digits> ext. <group_of_digits>
.)l
where <area_code> and <extension_part> are optional.
<area_code> is a group of 3 digits embedded in ( ),
<extension_part> is ext. followed by a group of digits.
Spaces are ignored.
The following list constitutes a syntactically correct list of telephone
numbers:
.(l L
.ft C
(666) 222-7777 #  333-1111 ext. 111 #
(777) 511-0909 ext. 22 # 111-9999 #
(777) 111-6666
.ft R
.)l
.br
a) Write a grammar describing the language of correct lists of telephone
numbers.
You may completely ignore blanks and tabs.
.br
b) Find the FOLLOW and FIRST sets for the nonterminal symbols of this grammar.
.PH 2 "Storage organization."
.br
a)  Describe the contents of a stack frame (sometimes called an activation
record) for a procedure invocation.
.br
b)  A dynamic array is one whose size is determined at runtime.
The compiler does not know how long such an array will be.
How is space allocated for it in a stack frame?
What runtime information is needed for proper access?
.PH 1 "Programming languages."
.PH 2 "Name scopes."
Define \fBdynamic scoping\fP and \fBstatic scoping\fP.
Present an example (a piece of program, using any syntax you wish)
illustrating the difference between dynamic and static scoping.
.PH 2 "Parameter passing."
Present a subroutine and an invocation that will give different
results depending on whether the parameters to the subroutine are passed
by value, but reference, or by name.
Tell what the results will be in each case.
.PH 2 "Language design."
Describe one unpleasant aspect of the design of each of the following languages
from the point of view of a programmer:
Pascal, Lisp, C.
.PH 1 "Database systems."
.PH 2 "Queries."
Consider three relational schemas defined as follows:
.(l
.ft C
Student = <SID, NAME>
Grade   = <SID, GRADE, SEMESTER, COURSEID>
Course  = <COURSEID, COURSE_NAME>
.ft R
.)l
The keys for these relations are as follows:
.(l
Student: SID
Grade: SID, SEMESTER, COURSEID
Course: COURSEID
.)l
Using any well-defined query language, formulate the following query:
.q "List all students names obtaining the grade of `I', the semester in which they received it, and the course name."
.PH 2 "Dependencies."
Consider the following set of functional dependencies:
.(l
ABC \(-> D
ACD \(-> B
CD  \(-> A
AB  \(-> C
BC \(-> D
.)l
Find a nonredundant cover of this set and justify your answer.
.PH 2 "Transactions."
Consider two transactions $T sub 1$ and $T sub 2$, defined as follows:
.(l
$T sub 1$: $r sub 1$(a) $w sub 1$(b)
$T sub 2$: $w sub 2$(a) $r sub 2$(b)
.)l
Assume that the transaction operations are executed by the DBMS in the
following order:
.(l
$r sub 1$(a) $w sub 2$(a) $w sub 1$(b) $r sub 2$(b) 
.)l
Is this schedule serializable?
Why or why not?
