.ig xx \" preprocessor stuff
.EQ
delim $$
gfont C
chartype "letter" 0123456789
.EN
.xx
.if n .ll 78
.if n .na
.nr pp 12
.nr sp 15
.nr sf 3
.sz 15
.tl 'Systems Foundational Exam''Code: \l'2i_'

.ce 1
Thursday, Janauary 19, 1995

.sz 13
.bu
Closed books and notes
.bu
Answer Question 1 plus any two of the questions 2, 3, 4, and 5.
.bu
Please make sure that your private code is written on the upper right corner
of every answer page.
.bu
Please use only one side of an answer page and start each major question area
on a new page.
.bu
Write your name on the bottom of this cover sheet and be sure to turn
in this sheet.
.lp
.rs
.sp 4i
Your name: \l'5i_'
.he 'Systems Foundational Exam'January 1995'-%-'
.bp 1
.sh 1 "Machine Organization
.\" question by raphael

(a)
Draw a picture of a computer (any hypothetical computer) showing how the
following components are interconnected: cpu, memory, address-translation
hardware, disk.
Distinguish lines carrying addresses, data, and commands.

(b)
Consider the following decomposition of instruction processing using a
five-stage pipeline:
.ip FI
Fetch Instruction: Read the next instruction from memory into a register.
.ip DI
Decode Instruction: Determine the opcode and operand specifiers.
.ip CO
Calculate Operands: Calculate effective address(es) for each operand.
.ip FO
Fetch Operands: Fetch each memory operand.
.ip EI
Execute Instruction: Perform the indicated instruction, storing the results
in memory if necessary.
.lp
Assume that each stage in the pipeline takes the same amount of time (once
cycle), but that
any stage that requires memory access is delayed one cycle if a later stage
is also
accessing memory during the same cycle.
.lp
There is a short program of 4 instructions, each of which accesses one
operand in memory during stage FO and stores a result during stage EI.
Draw a timing diagram for this short program that shows for each cycle
which stage of which instruction is active.

.sh 1 "Operating systems

(a) Some machines are designed so that the amount of physical memory
is larger than the size of biggest virtual memory space.  What is
the reason for designing the virtual memory hardware in this way?
If the virtual memory is smaller than the physical memory, why
even support virtual memory?

(b) Consider a file system that only provides three operations:
\fCread()\fP,
\fCwrite()\fP,
and \fCdelete()\fP.
\fCRead()\fP reads in a whole file in a single operation.
\fCWrite()\fP writes a whole file in a single operation.  \fCDelete()\fP
removes a file.

Would you expect the performance of this type of file system to be
better or worse than typical file systems (such as in Unix) which
support more operations?  Explain.

(c) (Continuing problem b) Would you expect the disk space utilization to be
better or worse than typical file systems?  Explain.
.sh 1 "Compiler construction

Consider the following grammar:
.(l
.ft C
(0) N \(-> Z L {L.s := 0;
	 N.v := IF Z.neg THEN -L.v ELSE L.v}
(1) Z \(-> + {Z.neg := False}
(2) Z \(-> - {Z.neg := True}
(3) L \(-> B {B.s := L.s; L.v := B.v}
(4) L \(-> L B {$L sub 1$.s := $L sub 0$.s + 1;
	B.s := $L sub 0$.s; $L sub 0$.v := $L sub 1$.v + B.v}
(5) B \(-> 0 {B.v := 0}
(6) B \(-> 1 {B.v := $2 sup {B.s}$}
.)l

\fCN\fP is the starting symbol.

With each production we have associated a semantic action, that is, a method 
to evaluate attribute values associated with the symbols in this production.
This action is enclosed in braces \fC{}\fP.
In these braces,
we use notation \fCL.s\fP to denote  attribute \fCs\fP of \fCL\fP.
For production 4, \fC$L sub 0$.s\fP denotes the attribute of the left hand side
\fCL\fP, and
\fC$L sub 1$.s\fP denotes the attribute of the right hand side \fCL\fP,
respectively.

(a) Define the concepts of \fBsynthesized\fP and \fBinherited\fP attributes.

(b) In the above semantic actions, list which attributes are
synthesized and which are inherited.

(c) Draw the parse tree for string \fC-1101\fP

(d) For each node in the parse tree evaluate the corresponding attributes.

(e) What do these attributes do?  That is, what functions do they compute?
.sh 1 "Programming languages

Consider the following program written in an Algol-like language:
.(b
.ds N \\h'|5i-\\n(.iu'
.ft C
\f(CBprocedure\fP A(\*N1
    \f(CBvalue\fP AParam : integer;\*N2
    FProc : \f(CBprocedure\fP()\*N3
);\*N4
    \f(CBprocedure\fP B();\*N5
    \f(CBbegin\fP -- B\*N6
        \f(CBwrite\fP(AParam);\*N7
    \f(CBend\fP; -- B\*N8
\f(CBbegin\fP -- A\*N9
    \f(CBcase\fP AParam \f(CBof\fP\*N10
        \f(CBwhen\fP 2 => A(1, B);\*N11
        \f(CBwhen\fP 1 => A(0, FProc);\*N12
        \f(CBwhen\fP 0 => FProc();\*N13
    \f(CBend\fP; -- case\*N14
\f(CBend\fP; -- A\*N15

\f(CBprocedure\fP Dummy(); \f(CBbegin\fP \f(CBend\fP;\*N16
    -- never called; same type as B\*N17

\f(CBbegin\fP -- main program\*N18
    A(2, Dummy);\*N19
\f(CBend\fP;\*N20
.)b

(a) What does this program output?

(b) Show the central stack when control reaches line 7.
Include the static chain.
.sh 1 "Databases

(a)
Consider a relational database consisting of the following relations:
.(b
.ft C
     employee(employeeName, age, salary)
     manager (employeeName, managerName, departmentName)
.)b

Give an expression in relational algebra for this query:
.(q
.ft C
Find all departments where the manager has a higher salary than any of that
manager's employees.
.)q

.ne 10
(b) Consider the following set of functional and multivalued dependencies:
.(b
.ft C
    A \(-> B
    B \(-> C
    C \(-> E
    E \(->\(-> D
    DE \(-> A
.)b
Is relation \fCR(A, B, C, D, E)\fP in 4th normal form? If yes, justify
your answer. If no, decompose \fCR\fP into 4th normal form and also
justify your answer.
