.\" needs eqn, tbl
.if n .ll 79
.sz 12
.nr pp 12
.nr sp 14
.he 'Systems Foundational/Depth Exam'Page % of 3'August 1995'
.ce 100
.sz 20
Systems Exam: Foundational

.sz 12
.ce 0
.lp
This test is \fBclosed book\fP.
Do question 1 and any other two questions.
If you do more than three questions, you will be graded on an arbitrary subset.
When you do a question, answer all parts.
If you do more than three questions, you will be graded on an arbitrary subset.
.EQ
delim @@
gfont C
gsize 12
.EN
.sh 1 "Machine architecture"
.uh "Part 1
.lp
Consider a computer with a DMA controller that has four registers that 
can be written or read by software running on the CPU.  
The registers are:
.ip R1
contains the first (lowest) memory address to be read or written
.ip R2
contains the last (highest) memory address to be read or written.
.ip R3
contains the device number to be used and the operation.
(the left-most 4 bits are used for the operation and 
the remaining low-order bits designate the device.)
.ip R4
tells the operation to be performed: whether data is
to be read from or written to the I/O device.
When the cpu writes this register, the operation starts.
.lp
The DMA controller has direct access to the main 32-bit bus.
.br
(a)
Describe the sequence of instructions given by the CPU to write a 
block of 64 bytes from memory address 1000 to device number 4.
.br
(b)
Describe the sequence of actions taken by the DMA controller to 
complete the request.  Be specific about the bus, I/O, and memory 
requests made by the controller and specify the points when 
interrupt signals are generated by the DMA controller. 
.br
(c)
Would you anticipate any problems if you were to write 33 bytes 
instead of 64 as requested in part (a)?
Explain.
.uh "Part 2
.lp
Assume that an instruction fetch, operand load, and storage of a result 
each take 5 time units to complete.  Instruction decode, operation 
execution, and program counter update each take 1 time unit to 
complete.  How long does it take to execute the following code 
sequence?
.TS
center ;
lfC lfC lfC l .
	load	X	{ fetch X into the accumulator register }
	add	Y	{ add Y to the accumulator register }
	jump-zero	a	{ only store a non-zero answer }
	store	Z	{ save the result in Z }
a:	halt		{ stop the machine }
.TE
\fCX\fP, \fCY\fP, and \fCZ\fP are stored in main memory, and the initial values
of \fCX\fP and \fCY\fP are 2 and 3, respectively.
You \fBmust\fP explain how you arrive at your final answer.  
Hint: a timing diagram would be an excellent technique to aid 
in your explanation.
.ig xx
.uh "Part 3 (B)"
Using a cache is one way to speed up main memory accesses.  
What other techniques have been used to do this.  
Illustrate with as much detail and specific examples as you can.
.xx
.br
.bp
.br
.bp
.sh 1 "Operating Systems"
.lp
Selecting an appropriate value for the time slice quantum (\fCQ\fP) in
a round robin scheduling policy can be difficult.  Assume that the
average process switch takes time \fCS\fP, and assume that the average amount
of time a process runs before doing an I/O operation is time \fCT\fP.
.br
(a)
State if (and why) the following settings for \fCQ\fP are good or bad.
.br
.po +1i
.ip "i)
0 < \fCQ\fP < \fCS\fP
.ip "ii)
\fCQ\fP = \fCS\fP
.ip "iii)
\fCS\fP < \fCQ\fP < \fCT\fP
.ip "iv)
\fCQ\fP = \fCT\fP
.ip "v)
\fCQ\fP > \fCT\fP
.ip "vi)
\fCQ\fP = infinity
.br
.po -1i
.lp
(b)
A process is generating a large number of page faults.  Argue both for
and against giving it the highest priority on the CPU.
.br
(c)
The operating system is thrashing.  Argue both for and against increasing the
number of processes allowed to run.
Which argument wins?
.br
(d)
Briefly describe how fragmentation manifests itself in each of the following
types of virtual storage systems:
.br
.po +1i
.ip i)
segmentation
.ip ii)
paging
.lp
.rs
.po -1i
.sh 1 "Programming language design"
.uh "Part 1
.br
(a)
Define the concepts of L-value and R-value.
.br
(b)
Define parameter passing in value mode and in reference mode by using the terms
L-value and R-value.
.br
(c)
Give an example in C of an expression that has an L-value and an example of an
expression that does not have an L-value.
.uh "Part 2
.br
(a)
In the Tcl language, procedures introduce new name scopes.
Identifiers introduced in a name scope are invisible in all other name scopes.
It is possible, however, to declare an identifier (in any name scope) as
global, which places the identifier in the outer scope and makes it visible in
the current scope.
In what ways is this rule different from the rule in Pascal?
.br
(b)
Tcl provides a syntax whereby a nonlocal identifier can be accessed.
It is specified by name and by which activation record it is in.
The activation record is specified by counting either from the bottom or the
top of the call stack.
Would you call this organization a static or a dynamic scope rule?
Why?
.br
.bp
.sh 1 "Databases"
.lp
Consider a relational schema \fCR(ABCD)\fP and the following set of functional
dependencies:
.(l
.ft C
     A \(-> BC     C \(-> AB
     A \(-> CD     C \(-> AD
     A \(-> BD     C \(-> BD
     B \(-> AC     D \(-> AB
     B \(-> AD     D \(-> AC
     B \(-> CD     D \(-> BC
.)l
Find all non-redundant covers of this set.
.sh 1 "Compilers"
.uh "Part 1
.br
(a)
What is \fBtail recursion\fP?
.br
(b)
Describe and illustrate with a simple example how to remove tail recursion
from a procedure.
.br
(c)
Explain why some compilers automatically remove tail recursion.
.uh "Part 2
.lp
Consider the following context-free grammar and semantic actions.
.TS
center ;
l l
lfC lfC .
rule	actions
_
@N sub 1@ \(-> @N sub 2@ a	@N sub 1@.aNum := @N sub 2@.aNum + 1
	@N sub 1@.bNum := @N sub 2@.bNum 

@N sub 1@ \(-> @N sub 2@ b	@N sub 1@.aNum := @N sub 2@.aNum
	@N sub 1@.bNum := @N sub 2@.bNum + 1 

N \(-> a	N.aNum := 1
	N.bNum := 0

N \(-> b	N.aNum := 0
	N.bNum := 1
.TE
(a)
Which attributes above are inherited?
.br
(b) Which attributes above are synthesized?
.br
(c) Parse and compute the corresponding attribute values for string \fCabbab\fP.
.br
(d)
What is the language generated by this grammar?
.br
(e)
Is this grammar LL(1)?
.br
