.\" needs eqn, tbl
.nh \" turn off hyphenation
.ad b
.if n .ll 79
.sz 12
.nr pp 12
.nr sp 14
.ds TY Foundational
.\" .ds TY Breadth
.\" .ds TY Depth
.he 'Systems \*(TY Exam'Page %'January 1996'
.ce 100
.sz 20
Systems Exam: \*(TY
.sz 12
.ce 0
.sp 1i
.lp
This test is \fBclosed book\fP.
.ie '\*(TY'Depth' \{\c
Do all parts of all questions.
. \}
.el \{\c
Do question 1 and any other two questions.
If you do more than three questions,
you will be graded on question 1 and the best two of the others.
When you do a question, answer all parts.
.\}
Please follow these guidelines:
.bu
.b "Use only one side of your answer sheets."
.bu
Put your code number at the top of each answer sheet.
.bu
Start each question on a new answer sheet.
.bu
Put your name and code number at the bottom of this sheet.
.ls
.sp |8i
Name: \l'5i_'
.sp .3i
Code number: \l'2i_'
.EQ
delim @@
gfont C
gsize 12
tdefine R1 ' {font C R sub 1} '
tdefine R2 ' {font C R sub 2} '
tdefine -> '\(->'
.EN
.bp
.sh 1 "Machine Organization
.uh "Memory management"
.br
a)
Distinguish between \fBpages\fP and \fBsegments\fP.  What are typical page
sizes, physical memory sizes, and virtual memory sizes?
Describe a typical physical address and typical virtual address.
.br
b)
What is the structure of a typical page table?  Include descriptions
of typical control bits and other fields in a page table entry.  Where
are page tables stored?  Can it be in virtual memory?
If so, what are the advantages and disadvantages; if not, why not?
.br
c)
Describe the mapping process from virtual to physical addresses.
Your descriptions should be in terms of the page table(s) you have described
and additional typical registers that you describe here.
.if '\*(TY'Foundational' .ig FO
.br
d)
What is a \fBtranslation lookaside buffer\fP?  Describe a typical
organization and operation for it.  
.br
e)
What is a page fault?  Describe its purpose and what a typical page
fault handler
would do, clearly distinguishing between those tasks typically
handled in various parts of the memory management hardware from those
parts typically handled by the operating system.
.FO
.bp
.sh 1 "Compilers"
.if '\*(TY'Breadth' .ig BR
.pp
Consider the grammar
.(l
.ft C
S @->@ ( X ) 
S @->@ a
X @->@ S , a
X @->@ SS
.)l
.br
a) Let \fCS.np\fP be an attribute that denotes the number of pairs of matching 
parenthesis, and \fCS.nc\fP denote the number of commas, in the sentence
derived from \fCS\fP.
Augment the above grammar by adding semantic rules for computing
\fCS.np\fP and \fCS.nc\fP
(and other auxiliary attributes, if needed).
.br
b) Parse these two strings and compute attribute values for them:
.(l
.ft C
(((a,a)a)a)
(a(a(a,a)))
.)l
c) Implement (provide pseudocode) a recursive-descent parser for your 
attribute grammar (syntax-directed translation scheme).
.BR
.if '\*(TY'Foundational' .ig FO
.br
a)
A null production has a form \fCB @->@ @epsilon@\fR.
Develop an algorithm for eliminating null productions from an input grammar
\fCG\fP.
.br
b) Apply your null-elimination algorithm to this grammar \fCG\fP:
.(l
.ft C
S @->@ A 1 B | B
A @->@ 0 A | @epsilon@
B @->@ 1 S | B | @epsilon@
.)l
c) Show that your algorithm produces a grammar \fCG'\fP such that
\fCL(G) = L(G')\fP.
.FO
.bp
.sh 1 "Programming Languages"
.if '\*(TY'Breadth' .ig BR
.uh "Types"
.br
a)
Define the concept of \fBtype\fP.
.br
b) What does it mean for a language to have \fBdynamic typing\fP?
.br
c) What does it mean for a language to have \fBstrong typing\fP?
.br
d) Define the concept of \fBabstract data type\fP.
.BR
.uh "Dynamically sized objects"
.br
a)
What is a \fBdynamically sized array\fP?
.br
b)
Are dynamically sized arrays available in Pascal?
If so, show a code fragment that declares such an array.
You will not be graded on Pascal syntax.
If not, explain why not.
.br
c)  In a language that has both records and dynamically sized arrays,
show how to declare a dynamically sized record.
You will not be graded on syntax; you may invent whatever syntax you like.
.if '\*(TY'Foundational' .ig FO
.uh "Prolog"
.pp
Write a Prolog predicate \fCodd(X)\fP (you will not be graded on exact syntax)
that is true for any positive odd number.
In particular, the following queries should have the results shown:
.TS
center;
l l .
\fBquery\fC	\fBresult\fC
_
\fC?- odd(3).\fR	yes
\fC?- odd(4).\fR	no
\fC?- odd(-3).\fR	no
\fC?- odd(X).\fR	\fC1;\fP
	\fC3;\fP
	\fC5;\fP
	 ... (so long as the user asks for more)
.TE
.FO
.bp
.sh 1 "Operating Systems"
.uh Scheduling
.pp
Consider the following table of job arrival times and service times.
.TS
center;
bc bc bc bc bc bc bc bc bc
bc bc bc bc bc bc bc bc bc
c n n n n .
Process	Arrival	Service	Start	Finish	T	M	P
Name	Time	Time	Time	Time	\^	\^	\^
_
A	0	3	0	3
B	1	5	3	8
C	3	2	8	10
D	9	5	10	15
E	12	5	15	20
.TE
.br
a) Is this table consistent with any standard scheduling algorithm(s)?
.br
b) Is so, briefly name the algorithm and describe how it works.  Otherwise,
explain why you can't tell which algorithm was used. 
.br
c) Fill in T (response Time), M (Missed Time), and P (Penalty Ratio)
in the chart above.
.pp
Now consider the following table of job arrival times and service times.
.TS
center;
bc bc bc bc bc bc bc bc bc
bc bc bc bc bc bc bc bc bc
c n n n n .
Process	Arrival	Service	Start	Finish	T	M	P
Name	Time	Time	Time	Time
_
A	0	3	0	6
B	1	5	1	11
C	3	2	4	8
D	9	5	9	18
E	12	5	12	20
.TE
d) Is this table consistent with any standard scheduling algorithm(s)?
.br
e) Is so, briefly name the algorithm and describe how it works.  Otherwise,
explain why you can't tell which algorithm was used. 
.br
f) Fill in T (response Time), M (Missed Time), and P (Penalty Ratio)
in the chart above.
.uh "Deadlock and starvation"
.br
a) Define \fBdeadlock\fP.
.br
b) Define \fBstarvation\fP.
.br
c) 
Which is worse: deadlock or starvation?
Why?
.if '\*(TY'Foundational' .ig FO
.uh "Cache replacement"
.pp
You work for a leading-edge Internet company that builds Web browsers.
The browser you are developing will cache Web pages accessed by the user.
You must choose a cache replacement policy.
You think back to all the policies you studied in your operating
systems course.
What replacement policy will you use?
Explain.
(Assume that Web documents are cached in their
entirety or not at all.)
.FO
.bp
.sh 1 "Databases"
.uh "Functional dependencies"
.pp
Given a relation
\fCR = {A, B, C, D, E, F, G}\fP
and the following functional dependencies:
.(l
.ft C
B, C, D @->@ A
B, C @->@ E
A @->@ E
F @->@ G
C @->@ D
A @->@ G
.)l
.br
a)  Find a minimal cover \fCG\fP for this set of functional dependencies.
.br
b)  Form a lossless decompose of \fCR\fP into @R1@ and @R2@, both of which
should be in
2NF (second normal form).  List carefully the candidate keys of @R1@ 
and @R2@ and the functional dependencies that lie in each new 
relation.
.br
c)  Continue decomposition to bring \fCR\fP into a 3NF (third normal form).
Discuss whether or not your decomposition is in Boyce-Codd 
Normal Form.
.if '\*(TY'Foundational' .ig FO
.br
d)  Find a lossless 3NF decomposition that preserves the 
functional dependencies \fCG\fP (from part a).
.FO
.uh "Queries"
.pp
Consider the following database schema used by a computer 
manufacturer:
.(l
.ft C
Hardware (Platform, Vendor, Model)
Software (Product, Name, Version, Usage, Cost, Vendor)
Employee (E_Num, Name, Vendor)
Installed (Platform, Product, Date, E_Num)
.)l
In the following parts, formulate the given queries
into any commercial query language (such as SQL, QBE or Quel).  
It is acceptable to formulate several simple expressions to 
produce the requested result.
Your syntax need not be precise so long as your answers are clear.
.br
a)  List every hardware platform (\fCHardware.Platform\fP) that is 
manufactured by IBM (that is, \fCHardware.Vendor = "IBM"\fP)
installed after 12 January 1992.
.br
b) Microsoft has just decided to change the product name of 
.q "Windows '95"
to
.q "Lexington"
(not
.q Detroit,
as you may have 
suspected).
Henceforth, the name
.q "Windows '95"
will always appear as
.q "Lexington" .
All references to
.q "Window's '95"
are to be changed.  Give the query (or queries) necessary to make this 
change.
.br
c)  List every computer (\fCPlatform\fP) that has never had installed 
on it any software product sold by Microsoft
(\fCSoftware.Vendor = "Microsoft"\fP).
.if '\*(TY'Foundational' .ig FO
.br
d)  Find all employees who have installed every game in the 
database (\fCSoftware.Usage="Game"\fP).
.FO
.ig xx
Comments by the grader:

1) Functional Decomposition Problem
a) finding minimal covers - almost all of the students did well
  at this part.  The only errors were silly errors of leaving
  several attributes on the right hand side and leaving an extra
  attribute on the right hand side.  There was a typo on one of the FDs
  but that had no effect on this question.
b) Turning it into 2 relations which were 2NF did have a problem.  You had to
  decompose it into more that two relations because of the error in the
  previous part.  This really made the correct answer either - "can't do it
  in two because ..." or "can't do it in two, but here is the answer if
  more than two."  I was lenient on the grading of this and only took
  off credit where a student actually made an incorrect statement.
c) The 3NF was simple and most students got it easily.  Most used an 
  algorithm which insured BCNF.

  One person interpreted A, B, C --> D to mean
	A --> D
	B --> D
	C --> D
  This drastically influenced the answer.  I graded that student
  on the stated interpretation, not the intended interpretation.

2) Queries
a) after 1/12/1992 is date>1/12/1992 not date>=1/12/1992.
   A list really should use DISTINCT - no credit taken off for this
b) Both Software and Installed should have the Product changed.
   The easiest way was to use MODIFY, UPDATE, of SET, not to try to use 
  lots of small steps to decompose the tables and then build them back up
  with one attribute changed and then merge that back with the unchanged
  tuples.  All who tried that made mistakes.
c) Biggest mistake was to assume that just because a platform has SOMETHING
  installed that is not made by Mircosoft that that implies that ALL
  of the software was not made by Microsoft.
   Best approach was to grab All the platforms and "minus" any that use
  Microsoft.
.xx


