/* Calculate amount of free swap space for an OSF1 machine.

Author: Raphael Finkel <raphael@cs.uky.edu> 12/96
Works for OSF1, IRIX 6 and Solaris 2.5
Does not work for Linux.

*/

#include <sys/stat.h>
#include <sys/swap.h>
#include <sys/param.h>
#ifndef PAGESIZE
	long getpagesize();
#	define PAGESIZE getpagesize()
#endif
#include <malloc.h>
#include <stdio.h>

int swapctl (int cmd, void *arg );

struct swaptable *myTable;

int main () {
#ifndef __sgi
	char *malloc();
#endif
	int numAreas, tableIndex, freepages;
	numAreas = swapctl(SC_GETNSWP, 0);
	myTable = (struct swaptable *)
		malloc(sizeof(int)+sizeof(swapent_t)*numAreas);
	for (tableIndex = 0; tableIndex < numAreas; tableIndex++) {
		myTable->swt_ent[tableIndex].ste_path = malloc(200);
	}
	myTable->swt_n = numAreas;
	numAreas = swapctl(SC_LIST, myTable);
	if (numAreas < 0) {
		perror("swapctl");
		exit(1);
	}
	freepages = 0;
	for (tableIndex = 0; tableIndex < numAreas; tableIndex++) {
#ifdef DEBUG
		printf("Region %s of length %d has %d pages, of which %d are free\n",
			myTable->swt_ent[tableIndex].ste_path,
			myTable->swt_ent[tableIndex].ste_length,
			myTable->swt_ent[tableIndex].ste_pages,
			myTable->swt_ent[tableIndex].ste_free);
#endif
		freepages += myTable->swt_ent[tableIndex].ste_free;
	}
	printf("%ld free K of swap\n", freepages * PAGESIZE / 1024);
	return 0;
}
