/*
 *  Gremlin for the X window package.  Hacked from the aed gremlin.
 *  
 *  Copyright 1986 Dick Leban, University of Wisconsin Computer Systems Lab
 *  1210 West Dayton, Madison WI, 53706
 *  
 *  Permission is hearby granted to distribute this program provided that:
 *    (*) no commerical advantage is gained
 *    (*) the recipient has a gremlin license
 *    (*) this copyright notice appears on all copies
 *    (*) "On Wisconsin" sung in its entirety while the software
 *        is being copied to the distribution media.
 *  
 *        Here's the words, you'll have to find the tune if you're
 *        an uncultured slug.
 *  
 *           On Wisconsin, On Wisconsin,
 *           Plunge right through that line!
 *           Run the ball clear down the field boys,
 *           Touchdown sure this time (u-rah-rah)
 *           On Wisconsin, On Wisconsin,
 *           Fight on for her fame!
 *           Fight fellows fight-fight-fight 
 *           we'll win this game!
 *  
 *  Copyright -C- 1982 Barry S. Roitblat
 */

#ifndef lint
	static char *rcsid="$Header: /u/f/cs/raphael/source/mygremlin/X.c,v 1.3 89/05/17 14:50:19 raphael Exp $";
#endif
#include <stdio.h>
#include "gremlin.h"
#include "decls.h"
#include <X11/Xutil.h>
#ifdef XCURSORS
#	include "cursorfont.h"
#else XCURSORS

/*
 *  Minimum and default sizes for the gremlin window
 *  The defaults are somewhat arbitrary, but the minimums are based on
 *  based on the sizes of the icons as well as asthetics -- dave@cs.wisc.edu
 */
#define MIN_ROOT_HEIGHT ((((WIN_DRAW+2) / 3) * 39) + 2)
#define MIN_ROOT_WIDTH  (MIN_ROOT_HEIGHT + (39 * 3))
#define DEF_ROOT_WIDTH	938
#define DEF_ROOT_HEIGHT 848

char *geometry;
char *displaystr; /* which display */

/*
 *  crosshair cursor.
 */
static char page_cursor_bits[] = {
   0x1f, 0xfc, 0x67, 0xf3, 0x7b, 0xef, 0xfd, 0xdf, 0xfd, 0xdf, 0x7e, 0xbf,
   0x7e, 0xbf, 0x18, 0x8c, 0x7e, 0xbf, 0x7e, 0xbf, 0xfd, 0xdf, 0xfd, 0xdf,
   0x7b, 0xef, 0x67, 0xf3, 0x1f, 0xfc, 0xff, 0xff};

static char page_cursor_mask_bits[] = {
   0xe0, 0x03, 0xf8, 0x0f, 0xfc, 0x1f, 0x0e, 0x38, 0x86, 0x30, 0xc7, 0x71,
   0xe7, 0x73, 0x77, 0x77, 0xe7, 0x73, 0xc7, 0x71, 0x86, 0x30, 0x0e, 0x38,
   0xfc, 0x1f, 0xf8, 0x0f, 0xe0, 0x03, 0x00, 0x00};

/*
 *  pencil cursor.
 */

static char text_cursor_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xef, 0xff, 0xc7, 0xff, 0xe3, 0xff, 0xf5,
   0xff, 0xfa, 0x7f, 0xfd, 0xbf, 0xfe, 0x5f, 0xff, 0xaf, 0xff, 0xd7, 0xff,
   0xeb, 0xff, 0xf3, 0xff, 0xfd, 0xff, 0xff, 0xff};

static char text_cursor_mask_bits[] = {
   0x00, 0x00, 0x00, 0x10, 0x00, 0x38, 0x00, 0x7c, 0x00, 0x3e, 0x00, 0x1f,
   0x80, 0x0f, 0xc0, 0x07, 0xe0, 0x03, 0xf0, 0x01, 0xf8, 0x00, 0x7c, 0x00,
   0x3e, 0x00, 0x1f, 0x00, 0x0f, 0x00, 0x07, 0x00};

/*
 *  diamond cursor.
 */

static char icon_cursor_bits[] = {
   0x7f, 0xff, 0x3f, 0xfe, 0x9f, 0xfc, 0xcf, 0xf9, 0xe7, 0xf3, 0x73, 0xe7,
   0x39, 0xce, 0x1c, 0x9c, 0x39, 0xce, 0x73, 0xe7, 0xe7, 0xf3, 0xcf, 0xf9,
   0x9f, 0xfc, 0x3f, 0xfe, 0x7f, 0xff, 0xff, 0xff};

static char icon_cursor_mask_bits[] = {
   0x80, 0x00, 0xc0, 0x01, 0xe0, 0x03, 0x70, 0x07, 0xb8, 0x0e, 0xdc, 0x1d,
   0xee, 0x3b, 0x77, 0x77, 0xee, 0x3b, 0xdc, 0x1d, 0xb8, 0x0e, 0x70, 0x07,
   0xe0, 0x03, 0xc0, 0x01, 0x80, 0x00, 0x00, 0x00};

#endif XCURSORS

#define gremlin_width 48
#define gremlin_height 48
static char gremlin_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00,
   0x80, 0x01, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x63, 0x1c, 0xc7, 0x71, 0x1c,
   0x80, 0x01, 0x00, 0x00, 0x00, 0x10, 0x00, 0x06, 0x00, 0x00, 0x00, 0x10,
   0x00, 0x00, 0xfc, 0x01, 0x00, 0x00, 0x00, 0x80, 0xff, 0x0f, 0x00, 0x00,
   0x00, 0xe0, 0x03, 0x3e, 0x00, 0x00, 0x00, 0x70, 0x00, 0x70, 0x00, 0x10,
   0x00, 0x18, 0x00, 0xc0, 0x00, 0x10, 0x00, 0x0c, 0x00, 0x80, 0x01, 0x10,
   0x00, 0x06, 0x00, 0x00, 0x03, 0x00, 0x00, 0x03, 0x00, 0x00, 0x06, 0x00,
   0x00, 0x03, 0x00, 0x00, 0x06, 0x00, 0x80, 0x01, 0x02, 0x00, 0x0c, 0x10,
   0x80, 0x01, 0x06, 0x00, 0x0c, 0x10, 0x80, 0x01, 0x0e, 0x00, 0x0c, 0x10,
   0xc0, 0x00, 0x1e, 0x00, 0x18, 0x00, 0xc0, 0x00, 0x36, 0x00, 0x18, 0x00,
   0xc0, 0x00, 0x66, 0x00, 0x18, 0x00, 0xc0, 0x00, 0xc6, 0x00, 0x18, 0x10,
   0xc0, 0x00, 0x86, 0x01, 0x18, 0x10, 0xc0, 0x00, 0x86, 0x01, 0x18, 0x10,
   0xc0, 0x00, 0x06, 0x03, 0x18, 0x00, 0x80, 0x01, 0x06, 0x06, 0x0c, 0x00,
   0x80, 0x01, 0x06, 0x0c, 0x0c, 0x00, 0x80, 0x01, 0x06, 0x18, 0x0c, 0x54,
   0x00, 0x03, 0x06, 0x30, 0x06, 0x54, 0x00, 0x03, 0x06, 0x60, 0x06, 0x38,
   0x00, 0x06, 0x06, 0xc0, 0x03, 0x38, 0x00, 0x0c, 0x06, 0x80, 0x01, 0x10,
   0xfe, 0x19, 0x06, 0xc0, 0x03, 0x10, 0xfe, 0x71, 0x06, 0x70, 0x06, 0x10,
   0x86, 0xe1, 0x07, 0x3e, 0x0c, 0x00, 0x86, 0x81, 0xff, 0x0f, 0x18, 0x00,
   0x86, 0x01, 0xfe, 0x01, 0x30, 0x00, 0x86, 0x01, 0x06, 0x00, 0x30, 0x00,
   0x86, 0x01, 0x06, 0x00, 0x60, 0x00, 0x86, 0x01, 0x06, 0x00, 0xc0, 0x00,
   0x86, 0x01, 0x06, 0x00, 0x80, 0x01, 0x86, 0x01, 0x06, 0x00, 0x00, 0x03,
   0x86, 0x01, 0x06, 0x00, 0x00, 0x06, 0xfe, 0x01, 0xfe, 0xff, 0xff, 0x0f,
   0xfe, 0x01, 0xfe, 0xff, 0xff, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

/*
 *  information about each window.
 */
Window WindowList[NUM_WINDOWS];

/*
 *  gremlin fonts for error messages and other trivia.
 */
Font	pointfont;
XFontStruct *pointfontdata;
Font	text_win_font;

/*
 *  cursor junk
 */
Pixmap	Page_Bitmap, Page_Mask_Bitmap;
Pixmap	Text_Bitmap, Text_Mask_Bitmap;
Pixmap  Icon_Bitmap, Icon_Mask_Bitmap;
Cursor	Page_Cursor;
Cursor  Text_Cursor;
Cursor	Icon_Cursor;

/*
 * a bitmap for our icon
 */
Pixmap  Gremlin_Pixmap;

/*
 * Stipple patterns for fixed polygons.
 */
GC StippleContext[MAXFILL+1];

static char stipple_bits[MAXFILL+1][4] = {
  	/* 0 */ { 0x0, 0x0, 0x0, 0x0,},
	/* 1 */ { 0x0, 0x4, 0x0, 0x0,},
	/* 2 */ { 0x0, 0x4, 0x0, 0x1,},
	/* 3 */ { 0x0, 0x4, 0x0, 0x5,},
	/* 4 */ { 0x0, 0x5, 0x0, 0x5,},
	/* 5 */ { 0x8, 0x5, 0x0, 0x5,},
	/* 6 */ { 0x8, 0x5, 0x2, 0x5,},
	/* 7 */ { 0x8, 0x5, 0xa, 0x5,},
	/* 8 */ { 0xa, 0x5, 0xa, 0x5,},
	/* 9 */ { 0xa, 0x7, 0xa, 0x5,},
	/* 10*/ { 0xa, 0x7, 0xa, 0xd,},
	/* 11*/ { 0xa, 0x7, 0xa, 0xf,},
	/* 12*/ { 0xa, 0xf, 0xa, 0xf,},
	/* 13*/ { 0xe, 0xf, 0xa, 0xf,},
	/* 14*/ { 0xe, 0xf, 0xb, 0xf,},
	/* 15*/ { 0xe, 0xf, 0xf, 0xf,},
	/* 16*/ { 0xf, 0xf, 0xf, 0xf,},
};

unsigned long Foreground, Background;
int BadFlags;
int CopyBrushes[1+NBRUSHES*2]; /* Those that must be done in copy mode because
	of bugs in the X server */
int MyXor; /* What we use for Xor depending on the server; some require Equiv */
int depth;

/*
 *  Initialize the X windows and events.
 */
XInit(Argc, Argv)
int Argc;
char **Argv;
{
	int	count;
	XSetWindowAttributes attr;
	XSizeHints  xsh;
	XWMHints	xwmh;
	XGCValues GCValues;
	XKeyboardControl KeyboardControl;
	Colormap cm;
	static char HalftoneBits[] = {0x01, 0x02};
	unsigned long ValueMask;
	int PlaneMask;
    unsigned long flip; /* 1 for monocrome, Foreground for multi-plane*/
    XColor  CursorForeground, CursorBackground;
    int DefScreen;
    int inithgt, initwid;   /* initial height and width of root window */
    int x = 0, y = 0, w, h, flags;

	{ /* open the display.  */
		if ((MyDisplay = XOpenDisplay(displaystr)) == 0) {
			fprintf(stderr, "Gremlin:  can't open %s.\n",
				(*displaystr ? displaystr : "default display"));
			exit(1);
		}
		DefScreen = DefaultScreen(MyDisplay);
		cm = DefaultColormap(MyDisplay, DefScreen);
		depth = DefaultDepth(MyDisplay, DefScreen);
	}
	{ /* make sure the focus is reasonable */
		XSetInputFocus(MyDisplay, PointerRoot, RevertToParent, CurrentTime);
	}
	{ /* establish special rules for poor implementations */
		printf("Vendor %s, depth %d, ", ServerVendor(MyDisplay), depth);
		switch (DefaultVisual(MyDisplay, 0)->class) {
			case StaticGray:  printf("StaticGray\n"); break;
			case StaticColor:  printf("StaticColor\n"); break;
			case TrueColor:  printf("TrueColor\n"); break;
			case GrayScale:  printf("GrayScale\n"); break;
			case PseudoColor:  printf("PseudoColor\n"); break;
			case DirectColor:  printf("DirectColor\n"); break;
		}
		BadFlags = 0; /* nothing bad yet */
		if (strncmp(ServerVendor(MyDisplay), "DECWINDOWS", 10) == 0) {
			if (depth == 1) { /* qvss */
				BadFlags |= BadSlowThick;
			} else { /* other bad dec */
				BadFlags |= BadXorBroken;
			}
			if (depth <= 4 && ReverseVideo) BadFlags |= BadImageBroken;
		} else if (strncmp(ServerVendor(MyDisplay), "MIT X Cons", 10) == 0) {
			if (depth == 8)
				BadFlags |= BadStoreNamedColor | BadXorBroken;
			BadFlags |= BadDrawLines;
			if (ReverseVideo) BadFlags |= BadImageBroken;
		} else if (strncmp(ServerVendor(MyDisplay), "Digital Eq", 10) == 0) {
				BadFlags |= BadPointFont | BadDrawLines | BadDotDash;
				if (depth <= 4 && ReverseVideo) BadFlags |= BadImageBroken;
		}
		if (DefaultVisual(MyDisplay, 0)->class == DirectColor)
			BadFlags |= BadStoreNamedColor;
	} /* special rules */
	{ /* set the video configuration; see file "notes". */
		depth = 1; /* Doesn't really work otherwise */
		if (depth == 1) { /* simple Black/White display */
		black_and_white:
			if (ReverseVideo) {
				Foreground = BlackPixel(MyDisplay, 0);
				Background = WhitePixel(MyDisplay, 0);
				XParseColor(MyDisplay, cm, "white", &CursorBackground);
				XParseColor(MyDisplay, cm, "black", &CursorForeground);
			} else { /* normal video: white on black */
				if (WhitePixel(MyDisplay,0) == 0) /* Sun */
					BadFlags |= BadImageBroken;
				Background = BlackPixel(MyDisplay, 0);
				Foreground = WhitePixel(MyDisplay, 0);
				XParseColor(MyDisplay, cm, "white", &CursorForeground);
				XParseColor(MyDisplay, cm, "black", &CursorBackground);
			}
			flip = 1;
			PlaneMask = 1;
			MyXor = Background ? GXequiv : GXxor; 
		} else { /* multiplane */
			unsigned long planes[2], pix;
			if (!(BadFlags & BadStoreNamedColor)) { /* Can allocate */
				if (XAllocColorCells(MyDisplay, cm, 0 /* not contig */,
						planes, 1, &pix, 1) == 0) {
					/* punt */
					printf("Could not allocate color cells; treating as B/W\n");
					depth = 1;
					goto black_and_white;
				}
				Background = pix;
				Foreground = pix | planes[0];
				PlaneMask = planes[0] /* | planes[1] */ ;
			} /* Can allocate */
			if (ReverseVideo) {
				if (BadFlags & BadStoreNamedColor) {
					Background = 0;
					Foreground = 1;
					PlaneMask = Background | Foreground;
				} else {
					XStoreNamedColor(MyDisplay, cm, "black", Foreground,
						DoRed|DoGreen|DoBlue);
					XStoreNamedColor(MyDisplay, cm, "white", Background,
						DoRed|DoGreen|DoBlue);
				}
				XParseColor(MyDisplay, cm, "white", &CursorBackground);
				XParseColor(MyDisplay, cm, "black", &CursorForeground);
			} else {
				if (BadFlags & BadStoreNamedColor) {
					Background = 1;
					Foreground = 0;
					PlaneMask = Background | Foreground;
				} else {
					XStoreNamedColor(MyDisplay, cm, "black", Background,
						DoRed|DoGreen|DoBlue);
					XStoreNamedColor(MyDisplay, cm, "white", Foreground,
						DoRed|DoGreen|DoBlue);
				}
				XParseColor(MyDisplay, cm, "white", &CursorForeground);
				XParseColor(MyDisplay, cm, "black", &CursorBackground);
			}
			flip = Foreground;
		} /* multiplane */
	} /* video configuration */
	{ /* calculate initial size, placement of the Root window:
	   *   initwid = min(screen_width, DEF_ROOT_WIDTH)
	   *   inithgt = min(screen_height-20, DEF_ROOT_HEIGHT)
	   *             // -20 to give window manager room to add a header
	   * If the screen is smaller than MIN_ROOT_WIDTH by MIN_ROOT_HEIGHT,
	   *   report error and exit.
	   */
		if (DisplayWidth(MyDisplay, DefScreen) < DEF_ROOT_WIDTH)
			initwid = DisplayWidth(MyDisplay, DefScreen);
		else
			initwid = DEF_ROOT_WIDTH;
		if (DisplayHeight(MyDisplay, DefScreen) < (DEF_ROOT_HEIGHT+20))
			inithgt = DisplayHeight(MyDisplay, DefScreen)-20;
		else
			inithgt = DEF_ROOT_HEIGHT;
		if (initwid < MIN_ROOT_WIDTH || inithgt < MIN_ROOT_HEIGHT) {
			fprintf(stderr, "Your screen is too small for gremlin.");
			exit(2);
		}
		if (geometry) {
			/* initially, x and y are 0; initwid and inithgt are set. */
			flags = XParseGeometry(geometry, &x, &y, &w, &h);
			if (flags & WidthValue) {
				initwid = w;
				if (initwid < MIN_ROOT_WIDTH) initwid = MIN_ROOT_WIDTH;
			}
			if (flags & HeightValue) {
				inithgt = h;
				if (inithgt < MIN_ROOT_HEIGHT)
					inithgt = MIN_ROOT_HEIGHT;
			}
			if ((flags & XValue) && (flags & XNegative))
				x += DisplayWidth(MyDisplay, DefScreen) - initwid - 2;
			if ((flags & YValue) && (flags & YNegative))
				y += DisplayHeight(MyDisplay, DefScreen) - inithgt - 2;
		} /* geometry */
	} /* initial size, placement */
	{ /* build Root window */
		xsh.flags = (USPosition | USSize | PMinSize | PMaxSize);
		xsh.height = xsh.max_height = xsh.min_height = inithgt;
		xsh.width = xsh.max_width = xsh.min_width = initwid;
		xsh.x = x;
		xsh.y = y;
		attr.border_pixel = Foreground;
		attr.backing_store = WhenMapped;
		attr.background_pixel = Background;
		Root = XCreateWindow(
			MyDisplay, DefaultRootWindow(MyDisplay),  /* display, parent   */
			xsh.x, xsh.y, xsh.width, xsh.height,      /* x,y, width,height */
			1, 0,                                     /* border_width, depth */
			InputOutput, CopyFromParent,              /* class, visual */
			CWBorderPixel | CWBackingStore | CWBackPixel
			, &attr);
		XSelectInput(MyDisplay, Root, ExposureMask);
	} /* Root window */
	{ /* convey some hints to the window manager */
		Gremlin_Pixmap = XCreateBitmapFromData(MyDisplay, Root,
			gremlin_bits, gremlin_width, gremlin_height);
		XSetStandardProperties(MyDisplay, Root,
			Argv[0], 0,     /* window_name, icon_name */
			Gremlin_Pixmap,
			Argv, Argc, &xsh);
		xwmh.flags = InputHint | StateHint | IconPixmapHint | IconMaskHint;
		xwmh.input = True; /* was false */
		xwmh.initial_state = NormalState;
		xwmh.icon_pixmap = xwmh.icon_mask = Gremlin_Pixmap;
		XSetWMHints(MyDisplay, Root, &xwmh);
	} /* hints to window manager */
	{ /* get fonts */
		pointfontdata = XLoadQueryFont(MyDisplay, "6x10");
		pointfont = pointfontdata->fid;
		XTry(text_win_font = XLoadFont(MyDisplay, "9x15"),
			"Can't get font %s", "9x15");
	} /* fonts */
	{ /* subwindows */
		for(count=0;count<WIN_DRAW;count++) {
			XTry(
				WindowList[count] = XCreateSimpleWindow(
					MyDisplay, Root,            /* display, parent            */
					39*(count%3), 39*(count/3), /* x,y                        */
					38, 38, 1,                  /* width, height, borderwidth */
					Foreground, Background),    /* border, background         */
				"can't create window %d", count
			);
		}
		/* WIN_DRAW */
		pagewindowwidth = initwid - ((3*39)+3);
		pagewindowheight = inithgt-53;
		XTry(
			WindowList[WIN_DRAW] = XCreateSimpleWindow(
				MyDisplay, Root,                      /* display, parent */
				118, 0,                               /* x,y             */
				pagewindowwidth, pagewindowheight,    /* width, height   */
				1,                                    /* border_width    */
				Foreground, Background),              /* border, background */
			"can't create window %d", WIN_DRAW
		);
		/* WIN_TEXT */
		/* if user resizes, force the text window to remain visible. */
		attr.border_pixel = Foreground;
		attr.background_pixel = Background;
		attr.win_gravity = SouthWestGravity;
		XTry(
			WindowList[WIN_TEXT] = XCreateWindow(
				MyDisplay, Root,                         /* display, parent  */
				118, pagewindowheight+1, pagewindowwidth, 52, /* x,y,wid,hgt */
				1, 0,                                    /* borderwid, depth */
				InputOutput, CopyFromParent,             /* class, visual */
				CWBorderPixel | CWBackPixel | CWWinGravity,
				&attr),
			"can't create window %d", WIN_TEXT
		);
	} /* subwindows */
	{ /* cursors */
#		ifdef XCURSORS
			Icon_Cursor = XCreateFontCursor(MyDisplay, XC_iron_cross);
			XRecolorCursor(MyDisplay, Icon_Cursor, &CursorForeground,
				&CursorBackground);
			Page_Cursor = XCreateFontCursor(MyDisplay, XC_crosshair);
			XRecolorCursor(MyDisplay, Page_Cursor, &CursorForeground,
				&CursorBackground);
			Text_Cursor = XCreateFontCursor(MyDisplay, XC_pencil);
			XRecolorCursor(MyDisplay, Text_Cursor, &CursorForeground,
				&CursorBackground);
#		else no XCURSORS
			Icon_Bitmap = XCreateBitmapFromData(MyDisplay, Root,
				icon_cursor_bits, 16, 16);
			Icon_Mask_Bitmap = XCreateBitmapFromData(MyDisplay, Root,
				icon_cursor_mask_bits, 16, 16);
			Icon_Cursor = XCreatePixmapCursor(MyDisplay, Icon_Bitmap,
				Icon_Mask_Bitmap, &CursorForeground, &CursorBackground, 7, 7);
			Page_Bitmap = XCreateBitmapFromData(MyDisplay, Root,
				page_cursor_bits, 16, 16);
			Page_Mask_Bitmap = XCreateBitmapFromData(MyDisplay,
				Root, page_cursor_mask_bits, 16, 16);
			Page_Cursor = XCreatePixmapCursor(MyDisplay, Page_Bitmap,
				Page_Mask_Bitmap, &CursorBackground, &CursorForeground, 7, 7);
			Text_Bitmap = XCreateBitmapFromData(MyDisplay, Root,
				text_cursor_bits, 16, 16);
			Text_Mask_Bitmap = XCreateBitmapFromData(MyDisplay, Root,
				text_cursor_mask_bits, 16, 16);
			Text_Cursor = XCreatePixmapCursor(MyDisplay, Text_Bitmap,
				Text_Mask_Bitmap, &CursorForeground, &CursorBackground, 1, 15);
#		endif XCURSORS
	} /* cursors */
	{ /* map the windows, display them, define their cursors */
		XStoreName(MyDisplay, Root, "Gremlin");
		for (count=0; count<NUM_WINDOWS; count++) {
			XSelectInput(MyDisplay, WindowList[count],
				ButtonPressMask|ExposureMask|KeyPressMask);
			XDefineCursor(MyDisplay, WindowList[count], Icon_Cursor);
		}
		XMapRaised(MyDisplay, Root);
		XMapSubwindows(MyDisplay, Root);
		XDefineCursor(MyDisplay, WindowList[WIN_DRAW], Page_Cursor);
		XDefineCursor(MyDisplay, WindowList[WIN_TEXT], Text_Cursor);
	} /* map */
	{ /* set feep level to 30% */
		/* commented out; let the user choose a personal feep level *
		KeyboardControl.bell_percent = 30;
		XChangeKeyboardControl(MyDisplay, KBBellPercent, &KeyboardControl);	
		*/
	} /* feep level */
	{ /* graphics defaults */
		/* default values for all contexts.  Some values are overridden
		for each case */
		GCValues.background = Background;
		GCValues.cap_style = CapButt; /* was CapRound; trying to speed up */
		GCValues.fill_style = FillOpaqueStippled;
		GCValues.font = text_win_font;
		GCValues.foreground = flip;
		GCValues.function = GXcopy;
		GCValues.graphics_exposures = FALSE;
		GCValues.join_style = JoinMiter;
		GCValues.line_style = LineSolid;
		GCValues.line_width = 0;
		GCValues.plane_mask = /* PlaneMask; raphael 6/1998 */ -1;
		GCValues.stipple =
			XCreateBitmapFromData(MyDisplay, Root, HalftoneBits, 2, 2);
		ValueMask = /* basic values; others added in some cases */
			GCFunction | GCForeground | GCBackground | GCPlaneMask
			| GCGraphicsExposures;
	} /* graphics defaults */
	{ /* normal text in dialog window WIN_TEXT */
		extern int _Xdebug;	 
		if (_Xdebug) {
#			define Test(what, where) \
				XDrawImageString(MyDisplay, WindowList[WIN_TEXT], TextContext, \
					where*9, 26, what, strlen(what)); \
				XDrawString(MyDisplay, WindowList[WIN_TEXT], TextContext, \
					where*9, 42, what, strlen(what));
			XSync(MyDisplay, 0);
			TextContext = XCreateGC(MyDisplay, Root, ValueMask | GCFont,
				&GCValues);
			Test("copy ", 1);
			GCValues.function = GXcopyInverted;
			TextContext = XCreateGC(MyDisplay, Root, ValueMask | GCFont,
				&GCValues);
			Test("inverted ", 6);
			GCValues.function = GXcopy;
			XSync(MyDisplay, 0);
		} /* _Xdebug */
		GCValues.function = (BadFlags & BadImageBroken) ? GXcopyInverted :
			GXcopy;
		GCValues.foreground = Foreground;
		TextContext = XCreateGC(MyDisplay, Root, ValueMask | GCFont, &GCValues);
		GCValues.function = GXcopy;
	}
	{ /* help window; also used for prompt in text window */
		GCValues.foreground = Background;
		GCValues.background = Foreground;
		HelpContext = XCreateGC(MyDisplay, Root, ValueMask | GCFont, &GCValues);
		GCValues.foreground = Foreground;
		GCValues.background = Background;
	}
	{ /* labels on points */
		GCValues.function = (BadFlags & (BadXorBroken | BadPointFont))
			? GXcopy : MyXor;
		GCValues.font = pointfont; 
		PointContext = XCreateGC(MyDisplay, Root, ValueMask|GCFont, &GCValues);
	}
	{ /* normal text in the graphics window WIN_DRAW; font set before use  */
		/* use same function as for PointContext */
		PutTextContext = XCreateGC(MyDisplay, Root,
			ValueMask, &GCValues);
	}
	{ /* highlight (1/2 cset) text in WIN_DRAW; font set before use */
		/* use same function as for PointContext */
		PutTextHighlightContext = XCreateGC(MyDisplay, Root,
			ValueMask | GCStipple | GCFillStyle, &GCValues);
	}
	{ /* glyph contexts */
		GCValues.font = pointfont;
		GCValues.function = GXcopy;
		GCValues.foreground = Background;
		GCValues.background = Foreground;
		GlyphContext = XCreateGC(MyDisplay, Root, ValueMask, &GCValues);
		GCValues.foreground = Foreground;
		GCValues.background = Background;
		RevGlyphContext = XCreateGC(MyDisplay, Root, ValueMask, &GCValues);
	} /* glyphs */
	{ /* lines */
		static char DotDash[4] = { 8, 3, 2, 3 };
		static char HighlightedDotDash[4] = { 5, 2, 1, 2 };
		int seq;
		int Style;
		 
		ValueMask |= GCLineWidth | GCLineStyle;
		for (seq = NBRUSHES*2; seq>=0; seq--)
			CopyBrushes[seq] = False; /* ok unless proven bad */
		if (BadFlags & BadXorBroken) { /* never use Xor */
			for (seq = NBRUSHES*2; seq>=0; seq--)
				CopyBrushes[seq] = True;
		} else if (BadFlags & BadSlowThick) { /* thick lines are a problem */
			CopyBrushes[B_MEDIUM] = CopyBrushes[B_MEDIUM_HIGHLIGHT] =
				CopyBrushes[B_THICK] = CopyBrushes[B_THICK_HIGHLIGHT] = True;
		} else if (BadFlags & BadDotDash) { /* only dot or dash are a problem */
			CopyBrushes[B_DOT] = CopyBrushes[B_DOT_HIGHLIGHT] =
				CopyBrushes[B_DOTDASH] = CopyBrushes[B_DOTDASH_HIGHLIGHT] =
				CopyBrushes[B_DASH] = CopyBrushes[B_DASH_HIGHLIGHT] = True;
		}
		 
		Style = B_THIN;
		GCValues.function = CopyBrushes[Style] ? GXcopy : MyXor;
		BrushContext[Style] = XCreateGC(MyDisplay, Root, ValueMask, &GCValues);
		 
		Style = B_MEDIUM;
		GCValues.function = CopyBrushes[Style] ? GXcopy : MyXor;
		GCValues.line_width = 2;
		BrushContext[Style] = XCreateGC(MyDisplay, Root, ValueMask, &GCValues);
		 
		Style = B_THICK;
		GCValues.function = CopyBrushes[Style] ? GXcopy : MyXor;
		GCValues.line_width = 4;
		BrushContext[Style] = XCreateGC(MyDisplay, Root, ValueMask, &GCValues);
		 
		Style = B_DOT;
		GCValues.line_width = 0;
		GCValues.line_style = LineDoubleDash;
		GCValues.dashes = 2;
		GCValues.function = CopyBrushes[Style] ? GXcopy : MyXor;
		BrushContext[Style] = XCreateGC(MyDisplay, Root, ValueMask | GCDashList,
			&GCValues);
		 
		Style = B_DASH;
		GCValues.dashes = 8;
		GCValues.function = CopyBrushes[Style] ? GXcopy : MyXor;
		BrushContext[Style] = XCreateGC(MyDisplay, Root, ValueMask | GCDashList,
			&GCValues);
		 
		Style = B_DOTDASH;
		GCValues.function = CopyBrushes[Style] ? GXcopy : MyXor;
		BrushContext[Style] = XCreateGC(MyDisplay, Root, ValueMask, &GCValues);
		XSetDashes(MyDisplay, BrushContext[Style], 0, DotDash, 4);
		 
		Style = B_THIN_HIGHLIGHT;
		GCValues.line_style = LineSolid;
		ValueMask |= GCStipple | GCFillStyle;
		GCValues.function = CopyBrushes[Style] ? GXcopy : MyXor;
		BrushContext[Style] = XCreateGC(MyDisplay, Root, ValueMask, &GCValues);
		 
		Style = B_MEDIUM_HIGHLIGHT;
		GCValues.line_width = 2;
		GCValues.function = CopyBrushes[Style] ? GXcopy : MyXor;
		BrushContext[Style] = XCreateGC(MyDisplay, Root, ValueMask, &GCValues);
		 
		Style = B_THICK_HIGHLIGHT;
		GCValues.line_width = 4;
		GCValues.function = CopyBrushes[Style] ? GXcopy : MyXor;
		BrushContext[Style] = XCreateGC(MyDisplay, Root, ValueMask, &GCValues);
		 
		Style = B_DOT_HIGHLIGHT;
		ValueMask &= ~(GCStipple | GCFillStyle);
		GCValues.line_width = 0;
		GCValues.line_style = LineDoubleDash;
		GCValues.dashes = 1;
		GCValues.function = CopyBrushes[Style] ? GXcopy : MyXor;
		BrushContext[Style] = XCreateGC(MyDisplay, Root, ValueMask | GCDashList,
			&GCValues);
		 
		Style = B_DASH_HIGHLIGHT;
		GCValues.dashes = 5;
		GCValues.function = CopyBrushes[Style] ? GXcopy : MyXor;
		BrushContext[Style] = XCreateGC(MyDisplay, Root, ValueMask | GCDashList,
			&GCValues);
		 
		Style = B_DOTDASH_HIGHLIGHT;
		GCValues.function = CopyBrushes[Style] ? GXcopy : MyXor;
		BrushContext[Style] = XCreateGC(MyDisplay, Root, ValueMask, &GCValues);
		XSetDashes(MyDisplay, BrushContext[Style], 0, HighlightedDotDash, 4);
	} /* lines */
	{ /* Stipples (for polygon fill) */
		/* GCValues.function = (BadFlags & BadXorBroken) ? GXcopy : MyXor */;
		GCValues.function = GXcopy;
		ValueMask =
			GCFunction | GCForeground | GCBackground | GCGraphicsExposures
			| GCStipple | GCFillStyle;
		GCValues.foreground = Foreground;
		for (count=0; count<=MAXFILL; count++) {
			Pixmap mask = XCreateBitmapFromData(MyDisplay, Root,
				stipple_bits[count], 4, 4);
			GCValues.stipple = mask;
			StippleContext[count] = XCreateGC(MyDisplay, Root, ValueMask,
				&GCValues);
		}
	}
} /* XInit */
