/*
 *  Gremlin for the X window package.  Hacked from the aed gremlin.
 *  
 *  Copyright 1986 Dick Leban, University of Wisconsin Computer Systems Lab
 *  1210 West Dayton, Madison WI, 53706
 *  
 *  Permission is hearby granted to distribute this program provided that:
 *    (*) no commerical advantage is gained
 *    (*) the recipient has a gremlin license
 *    (*) this copyright notice appears on all copies
 *    (*) "On Wisconsin" sung in its entirety while the software
 *        is being copied to the distribution media.
 *  
 *        Here's the words, you'll have to find the tune if you're
 *        an uncultured slug.
 *  
 *           On Wisconsin, On Wisconsin,
 *           Plunge right through that line!
 *           Run the ball clear down the field boys,
 *           Touchdown sure this time (u-rah-rah)
 *           On Wisconsin, On Wisconsin,
 *           Fight on for her fame!
 *           Fight fellows fight-fight-fight 
 *           we'll win this game!
 *  
 *  Copyright -C- 1982 Barry S. Roitblat
 */

/*
 *      This file contains routines for implementing the database
 * manipulations for the gremlin picture editor.
 */

#include "gremlin.h"
#include "grem2.h"
#include "decls.h"
#ifndef lint
	static char *rcsid="$Header: db2.c,v 2.2 88/08/12 13:36:48 solomon Stab $";
#endif lint

ELT *DBCopy(element, transform, db)
ELT *element, *db[];
float transform[3][2];
/*
 *      This routine creates a copy of the the element transformed by
 * the transformation matrix and adds the new copy to the database.
 */

{
	POINT *pt, *newlist;
	char *newtext;

	newlist = PTInit();
	forpoint(pt, element->ptlist) { /* matrix multiply */
		(void) PTMakePoint((  ( (pt->x) * transform[0][0])
		                    + ( (pt->y) * transform[1][0])
		                    + transform[2][0]),
		                   (  ( (pt->x) * transform[0][1])
		                    + ( (pt->y) * transform[1][1])
		                    + transform[2][1]), &newlist);
	}  /* end forpoint */;
	newtext = malloc((unsigned) strlen(element->textpt) + 1);
	(void) strcpy(newtext, element->textpt);
	return(DBCreateElt(element->type, newlist, element->brushf,
		element->size, newtext, db));
}  /* end DBcopy */


DBXform(element, transform, db)
ELT *element;
float transform[3][2];
ELT *db[];
/*
 *      This routine transforms the element by multiplying the
 * coordinates of each of the points in the element by the 
 * transformation matrix.
 */

{
	POINT *pt;
	float px, py;

	UNRembMod(element, db);
	forpoint(pt, element->ptlist) {
		px =  ( (pt->x) * transform[0][0] )
		    + ( (pt->y) * transform[1][0] )
		    + transform[2][0];
		py =  ( (pt->x) * transform[0][1] )
		    + ( (pt->y) * transform[1][1] )
		    + transform[2][1];
		pt->x = px;
		pt->y = py;
	}  /* end forpoint */;
}  /* DBXform */


DBChangeBrush(element, brush, db)
ELT *element, *db[];
int brush;
/*
 *      This routine changes the brush attribute of the element
 */

{
	UNRembMod(element, db);
	element->brushf = brush;
}  /* end ChangeBrush */

DBChangeSize(element, size, db)
ELT *element, *db[];
int size;
/*
 *      This routine changes the size attribute of the element
 *      (currently only used for POLYGON's, where "size" is fill color).
 */
{
	UNRembMod(element, db);
	element->size = size;
}  /* end ChangeBrush */

DBChangeFont(element, font, size, db)
ELT *element, *db[];
int font, size;
/*
 *      This routine changes the font and size attributes of the  given
 * element.
 */
{
	UNRembMod(element, db);
	element->brushf = font;
	element->size = size;
}  /* end ChangeFont */

