/*
 *  Gremlin for the X window package.  Hacked from the aed gremlin.
 *  
 *  Copyright 1986 Dick Leban, University of Wisconsin Computer Systems Lab
 *  1210 West Dayton, Madison WI, 53706
 *  
 *  Permission is hearby granted to distribute this program provided that:
 *    (*) no commerical advantage is gained
 *    (*) the recipient has a gremlin license
 *    (*) this copyright notice appears on all copies
 *    (*) "On Wisconsin" sung in its entirety while the software
 *        is being copied to the distribution media.
 *  
 *        Here's the words, you'll have to find the tune if you're
 *        an uncultured slug.
 *  
 *           On Wisconsin, On Wisconsin,
 *           Plunge right through that line!
 *           Run the ball clear down the field boys,
 *           Touchdown sure this time (u-rah-rah)
 *           On Wisconsin, On Wisconsin,
 *           Fight on for her fame!
 *           Fight fellows fight-fight-fight 
 *           we'll win this game!
 *  
 *  Copyright -C- 1982 Barry S. Roitblat
 */

/*
 *       This file contains additional routines to implement the database
 * manipulations necessary for the gremlin picture editor.
 */

#include "gremlin.h"
#include "grem2.h"
#include "decls.h"
#ifndef lint
	static char *rcsid="$Header: db3.c,v 2.2 88/08/12 13:36:51 solomon Stab $";
#endif lint

/* the following variable is a pointer for the current set and is
 * available to the outside world.
 */

DBAddSet(element)
ELT *element;
/*
 *      This routine adds the element to the current set database.  We add at
 *		the end in order to preserve order when writing out, and because things
 *		at the end overwrite things earlier.
 */

{
	int index;

	fordbindex(index, cset) if (cset[index] == element) return;
	cset[index++] = element;
	cset[index] = nullelt;
}  /* end AddSet */

DBInitSet()
{
	/* prepare to build a new current set */
	if (CSETPOINTS) DoBlink(FALSE); /* remove stipple from old current set */
	DBClearSet();         /* Clear current set in preparation for making this
		the new one */
	halftone = CSETPOINTS; /* ready for new current set */
} /* DBInitSet */

int DBInSet(e, db)
ELT *e, *db[];
/* returns whether e is in the given set */
{
	ELT **eptr;
	fordb(eptr, db) if (*eptr == e) return TRUE;
	return FALSE;
} /* DBInSet */
