/* declarations for the *.c files */
#ifndef lint
static char *decls_rcsid="$Header: /X11R3/uw/xgremlin/RCS/decls.h,v 2.7 89/02/24 14:41:29 solomon Exp Locker: solomon $";
#endif

#ifndef X_H
#	include "X.h"
#	include "Xlib.h"
#endif
#undef CSIZE

/* icons.c */

/* In an older version of this code, the following declarations were
	extern Pixmap glyphs[NUM_ICONS][2];  (* 0==normal, 1==highlight *)
	extern Pixmap adjust_glyphs[6];
 * etc., intialized from icons[], adjust_icons[], etc. by
 * XCreatePixmapFromBitmapData(), but
 * for some servers, graphics to pixmaps are a couple of orders of magnitude
 * slower than graphics to the screen.  Thus it makes sense to recreate
 * the image each time, rather than create a pixmap and copy it.
 *
 * Even on 1-plane displays, this method is fast enough, so we adopt it in
 * general instead of pixmaps.
 *
 * For this case, the various "*glyphs" arrays are just pointers to the
 * corresponding bitmap data arrays "*icons".
 */
	char (*glyphs)[190];
	char (*adjust_glyphs)[190];
	char (*font_glyphs)[190];
	char (*size_glyphs)[190];
	char (*buffer_glyphs)[190];
	char (*point_glyphs)[190];
	char (*brush_glyphs)[190];
	char (*just_glyphs)[190];

/* db1.c */
	extern void DBRead();

/* point.c */
	extern POINT *PTInit(), *PTMakePoint();

/* X.c */
	extern Window WindowList[];
	extern XFontStruct *pointfontdata;
	extern unsigned long Foreground, Background;
	extern int depth;
	extern GC StippleContext[];
	extern char *geometry, *displaystr;
	extern int CopyBrushes[1+NBRUSHES*2];
		/* Those to be done in copy mode because of bugs in the X server */
	extern int BadFlags;
#		define BadSlowThick 01 /* thick lines draw very slowly */
#		define BadXorBroken 02 /* xor fails on dashed or gray thin */
#		define BadImageBroken 04
			/* XDrawImageString either invisible or on inverted background */
#		define BadStoreNamedColor 010 /* protocol error on StoreNamedColor */
#		define BadPointFont 020 /* need copy for drawing */
#		define BadDrawLines 040 /* need to prevent duplicate points in lines */
#		define BadDotDash 0100 /* patterned styles don't work in xor */

/* X1.c */
	extern TextPut(), InputText(), RedrawText(), DoBlink();
	extern int XChangeGrid();
	extern XFontStruct *text_font[5][5];
	extern char* text_font_names[5][5];
	extern int ERRVISIBLE; /* whether there is anything in the last line of
		the Text area */

/* imports from menu.c */
	extern XHelp(), XCSBlink();

/* graphics */
	extern GRInit(), GRClose();
	extern GRSetGrid(), GRDisplayGrid(), GRBlankGrid();
	extern GRDisableTablet(), GREnableTablet();
	extern GRSetMap(), GRsetwmask();
	extern GRBlankPoints(), GRShowPoints();
	extern artmode;

/* graphics1.c */
	extern int halftone;
	extern int brush[]; /* ?? was pattern; should most likely be GC */
	extern int rmask, charysize, charxsize, descenders;

/* graphics2.c */
#	define MAXPOINTS 500 /* in one line */
	extern XPoint vlist[]; /* length MAXPOINTS */
	extern charxsize, charysize;
	int artmode;
	extern GRVectors(), GRVector(), GRArc(), GRPutText(), GRDisplayPoint(),
		GRDeletePoint(), GRBlankPoints(), GRCurve(), GRClear();

/* undodb.c */
	extern UNELT *unlist, *unback;
	extern UNForget(), UNRembMod(), UNRembAdd(), UNRembDelete();

/* long.c */
	extern (*(lrtns[]))();
	extern char *lcmds[];
	extern LGText(), LGLittlePoint(), LGPrintPath(), LGCSetPoints(),
		LGUpAlign(), LGSetAlign(), LGDownAlign(), CP(), LGCommand(), LGQuit(),
		LGEdit(), LGDrawPolygon(), LGDrawBPolygon(), LGPoint(),
		LGDeletePoint(), LGHAdjust(), LGVAdjust(), LGMAdjust(), LGMirror(),
		LGMirrorCopy(), LGRead(), LGQuit(), LGUndo(), LGMPoint(),
		LGClearPoints(), LGMText(), LGMBrush(), LGMFont(), LGMSize(),
		LGPath(), LGShowPoints(), LGPutBuffer(), LGGetBuffer(), LGHidePoints(),
		LGMFill(), LGMJust();

/* long1.c */
	extern GetNumParm(), LGLookup();
	extern int bang;
	extern int ShowingPoints;

/* long2.c */
	extern LGSave(), LGWrite();

/* long3.c */
	extern LGBackup(), LGReorderStart(), LGReorderEnd(), LGCenter(),
		LGNewArrow(), LGMultiCopy(), LGChangeArrowMode();
	extern int ArrowMode;

/* short.c */
	extern (*(shrtns[]))();
	extern char shcmds[];
	extern SHCommand(), SHSetArea(), SHRedis(), SHUpdate(), SHDrawVector(),
		SHDrawArc(), SHDrawEllipse(), SHDrawCurve(), SHBox(),
		SHFillBox(), SHFillOnlyBox(), SHArrow(),
		SHFillArrow(), SHUpGravity(), SHGrid(), SHDefineSet(), SHIncludeSet(),
		SHErase(), SHTranslate(), SHCopy(), SHScale(), SHXScale(), SHYScale(),
		SHRotate(), SHRotateCopy(), SHShellEsc(), SHSave1(), SHSave2(),
		SHSave3(), SHSave4(), SHCurveToFromVector(), SHFilledToFromUnfilled(),
		SHBorderedToFromUnbordered();

/* display.c */
	extern DISScreenAdd(), DISScreenErase(), DISDisplaySet(), DISEraseSet(),
		DISClearSetDisplay();

/* path.c */
	extern int PSetPath(), PConvertTilde();
	extern char *PGetPath();
	extern char path[];

/* main.c */
#	define MAXELTS 1000 /* greatest number of elements in a picture */
	extern ELT *nullelt;
	extern ELT *cset[MAXELTS];               /* current set database          */
	extern ELT *oldcset[MAXELTS];            /* current set database          */
	extern Display *MyDisplay;
	extern Window Root;
	extern int SEARCH;        /* Boolean: search the path for filename */
	extern GC BrushContext[1+2*NBRUSHES], GlyphContext, RevGlyphContext,
		PointContext, TextContext, HelpContext, PutTextContext,
		PutTextHighlightContext;
	extern XUpBrush(), XDownBrush(), XUpFont(), XDownFont(), XUpSize(),
		XDownSize(), XUpJust(), XDownJust(), XUpAdjust(), XDownAdjust(),
		XUpFill(), XDownFill(),
		XUpBuffer(), XDownBuffer(), XChangeGrid(), XBang(),
		XCSet(), error(), OnStop(), unimplemented(), Strip();
	extern int pagewindowheight, pagewindowwidth;
	extern Font pointfont, text_win_font;
	extern char *textpos[];
	extern int textmode[];
	extern char killchar, erasechar;    /* user's favorites */
	extern int jmodes;                  /* number of justification modes */
	extern ELT *PICTURE[];                /* current PICTURE database      */
	extern ELT arhead;                  /* arrowhead                     */
	extern int CBUF, CGRID, CSETPOINTS;
	extern CBRUSH, CSIZE, CFONT;        /* current brush, size, font     */
	extern CFILL;                       /* current polygon fill          */
	extern CJUST;                       /* current text justification    */
	extern Gridon;                      /* grid mode flag                */
	extern Orientation;                 /* orientation of workspace      */
	extern Alignment;                   /* point alignment indicator     */
	extern Adjustment;                  /* point adjustment mode         */
	extern GravityMode;                 /* gravity mode flag             */
	extern float PX, PY;                /* cursor coordinates            */
	extern float Lastx, Lasty;          /* previous cursor coordinates   */
	extern SEQ;                         /* point sequence number         */
	extern char *Editfile;              /* current edit file             */
	extern POINT *POINTLIST, *BACKPOINT;/* accumulated point list        */
	extern Consume;                     /* point clear flag              */
	extern CHANGED;                     /* PICTURE changed flag          */
	extern ELT *MEN[NUSER][MAXELTS];    /* pointers for user symbols     */
	extern POINT MENPOINT[];            /* pointers used fo user symbols */
	extern char cmdbuf[];               /* line buffer for commands      */
	extern char *lines[], *fonts[];     /* line and character styles     */
	extern int lnum[], fnum[];
	extern int ReverseVideo;			/* if set, black on white 		 */

/* C library */
	extern char *malloc(), *strcat(), *strncat(), *strcpy(),
		*getlogin(), *getwd();

/* from somewhere */
	extern char input_buffer[];
	extern Cursor Page_Cursor, Text_Cursor;
	extern int TextMode, window_num;
	extern int (*last_function)();
	extern int bang;
	extern csetoff;
	extern MNHighLt(), MNUnHighLt();
	extern char GMapFile[];

/* imports from database files */
	extern ELT *DBCreateElt(), *DBCopy();
	extern DBDelete(), DBSetGravitate(), DBGravitate(), DBClearElt(), DBXform(),
		DBChangeBrush(), DBAddSet(), DBBounded(), PTDeletePoint(),
		DBInSet();
	extern POINT *PTInit(), *PTMakePoint();

/* shorthand */
#	define XTry(code, msg, arg) if ((code)<= 0) printf(msg, arg)

