/*
 *  Gremlin for the X window package.  Hacked from the aed gremlin.
 *  
 *  Copyright 1986 Dick Leban, University of Wisconsin Computer Systems Lab
 *  1210 West Dayton, Madison WI, 53706
 *  
 *  Permission is hearby granted to distribute this program provided that:
 *    (*) no commerical advantage is gained
 *    (*) the recipient has a gremlin license
 *    (*) this copyright notice appears on all copies
 *    (*) "On Wisconsin" sung in its entirety while the software
 *        is being copied to the distribution media.
 *  
 *        Here's the words, you'll have to find the tune if you're
 *        an uncultured slug.
 *  
 *           On Wisconsin, On Wisconsin,
 *           Plunge right through that line!
 *           Run the ball clear down the field boys,
 *           Touchdown sure this time (u-rah-rah)
 *           On Wisconsin, On Wisconsin,
 *           Fight on for her fame!
 *           Fight fellows fight-fight-fight 
 *           we'll win this game!
 *  
 *  Copyright -C- 1982 Barry S. Roitblat
 */

/*
 *      This file contains routines to implement the higher level display
 * driver routines
 */

#include "gremlin.h"
#include "grem2.h"
#include "decls.h"
#ifndef lint
	static char *rcsid="$Header: display.c,v 2.2 88/08/12 13:36:54 solomon Stab $";
#endif lint


DISScreenAdd(element)
ELT *element;
/*
 *      This routine displays an arbitrary element type on the specified 
 * memory plane using the parameters stored with the element
 *  
 *  Note:  memory planes do not apply to monochrome X.  Calls to plane
 *  setting routines were commented out just in case somebody wants them.
 */
{
	POINT *p1, *p2, pos;
	if ( !DBNullelt(element) ) {
		if (TEXT(element->type)) {
			p1 = element->ptlist;
			(void) GRPutText(element->type, p1, element->brushf,
			element->size, element->textpt, &pos);
		} else {
			switch (element->type) {
				case ARC:
					p1 = element->ptlist;
					p2 = PTNextPoint(p1);
					/* angle is stored in size */
					(void) GRArc(p1, p2, (float) element->size, 
						element->brushf);
					break;
				case CURVE:
					(void) GRCurve(element->ptlist, element->brushf);
					break;
				case POLYGON:
					GRPolygon(element->ptlist, element->size);
					if (element->brushf == 0) break; /* no border */
					/* fall through to draw outline */
				case VECTOR:
					GRVectors(element->ptlist, element->brushf);
					break;
			}  /* end switch */;
		}  /* end else TEXT */
	}  /* end if */
}  /* end ScreenAdd */

DISScreenErase(element)
ELT *element;
/*
 *      This routine erases an arbitrary element type from the specified 
 * memory plane by redrawing the element in the background color.  It
 * uses the parameters stored with the element.
 */
{
    POINT *p1, *p2, pos;

    if ( !DBNullelt(element) ) {
        if (TEXT(element->type)) {
             p1 = element->ptlist;
             (void) GREraseText(element->type, p1, element->brushf,
				  element->size, element->textpt, &pos);
        } else {
            switch (element->type) {
                case ARC:
					p1 = element->ptlist;
					p2 = PTNextPoint(p1);
					/* angle is stored in size */
					(void) GRArc(p1, p2, (float) element->size, 
						-(element->brushf+1));
					break;
				case CURVE:
					(void) GRCurve(element->ptlist, -(element->brushf+1));
					break;
				case POLYGON:
					GRPolygon(element->ptlist, -(element->size+1));
					if (element->brushf == 0) break; /* no border */
					/* fall through to draw outline */
				case VECTOR:
					GRVectors(element->ptlist, -(element->brushf+1));
					break;
            }  /* end switch */;
        }  /* end else TEXT */
    }  /* end if */
}  /* end ScreenErase */

DISDisplaySet(element)
ELT *element;
/*
 *      This routine displays the specified element as the part of
 * the current set by calling screenadd with the current set layers
 * specified
 */
{
    DISScreenAdd(element /* , setmask */ );
}  /* end DisplaySet */

DISEraseSet(element)
ELT *element;
/*
 *      This routine erases the set attribute of the specifed element by
 * calling Screen Erase with the layer mask set for the current set layer(s)
 */

{
    DISScreenErase(element /* , setmask */ );
}  /* end EraseSet */
