/*
 *  Gremlin for the X window package.  Hacked from the aed gremlin.
 *  
 *  Copyright 1986 Dick Leban, University of Wisconsin Computer Systems Lab
 *  1210 West Dayton, Madison WI, 53706
 *  
 *  Permission is hearby granted to distribute this program provided that:
 *    (*) no commerical advantage is gained
 *    (*) the recipient has a gremlin license
 *    (*) this copyright notice appears on all copies
 *    (*) "On Wisconsin" sung in its entirety while the software
 *        is being copied to the distribution media.
 *  
 *        Here's the words, you'll have to find the tune if you're
 *        an uncultured slug.
 *  
 *           On Wisconsin, On Wisconsin,
 *           Plunge right through that line!
 *           Run the ball clear down the field boys,
 *           Touchdown sure this time (u-rah-rah)
 *           On Wisconsin, On Wisconsin,
 *           Fight on for her fame!
 *           Fight fellows fight-fight-fight 
 *           we'll win this game!
 *  
 *  Copyright -C- 1982 Barry S. Roitblat
 */

#include "gremlin.h"
#include "grem2.h"
#include "decls.h"
#ifndef lint
	static char *rcsid="$Header: graphics2.c,v 2.2 88/08/12 13:37:08 solomon Stab $";
#endif lint

#define STARTMAYBECOPY(Test, GC) \
	if (Test) { \
		XGCValues GCValues; \
		GCValues.function = GXcopyInverted; \
		XChangeGC(MyDisplay, GC, GCFunction, &GCValues); \
	}
#define ENDMAYBECOPY(Test, GC) \
	if (Test) { \
		XGCValues GCValues; \
		GCValues.function = GXcopy; \
		XChangeGC(MyDisplay, GC, GCFunction, &GCValues); \
	}

int artmode;
XPoint vlist[MAXPOINTS];
	/* negative styles are erase.  Applies throught this file.  */

void FixLineList(List, SizePtr)
XPoint List[];
int *SizePtr;
/* some display servers refuse to XDrawLines in some brushes if there are
duplicate adjacent points */
{
	int Here;
	for (Here = 1; Here < *SizePtr; Here++) {
		if ((List[Here].x==List[Here-1].x) && (List[Here].y==List[Here-1].y)){
			bcopy((char *) (&List[Here]), (char *) &List[Here-1], 
				(unsigned) ((*SizePtr - Here)*sizeof(XPoint)));
			--(*SizePtr);
			--Here;
		} /* duplicate detected */
	} /* for Here */
} /* FixLineList */

GRVectors(p1, style)
POINT *p1;
int   style;
{
	int i = 0;
	int Erasing = False;
	forpoint(p1, p1) {
		vlist[i].x = (int) p1->x;
		vlist[i++].y = (int) p1->y;
	}  /* end while */;
	if (style<0) {
		style = -style-1;
		Erasing = True;
	}
	if (halftone) style += NBRUSHES;
	STARTMAYBECOPY(Erasing && CopyBrushes[style], BrushContext[style]);
	if (BadFlags & BadDrawLines) FixLineList(vlist, &i);
	XDrawLines(MyDisplay, WindowList[WIN_DRAW],
		BrushContext[style], vlist, i, CoordModeOrigin);
	ENDMAYBECOPY(Erasing && CopyBrushes[style], BrushContext[style]);
} /* GRVectors */

GRVector(point1,point2,style)
POINT *point1,*point2;
int   style;
{
	int Erasing = False;
	int i;
	vlist[0].x = (int)point1->x;
	vlist[0].y = (int)point1->y;
	vlist[1].x = (int)point2->x;
	vlist[1].y = (int)point2->y;
	if (style<0) {
		style = -style-1;
		Erasing = True;
	}
	STARTMAYBECOPY(Erasing && CopyBrushes[style], BrushContext[style]);
	if (halftone) style += NBRUSHES;
	i = 2;
	if (BadFlags & BadDrawLines) FixLineList(vlist, &i);
	XDrawLines(MyDisplay, WindowList[WIN_DRAW],
		BrushContext[style], vlist, i, CoordModeOrigin);
	ENDMAYBECOPY(Erasing && CopyBrushes[style], BrushContext[style]);
} /* GRVector */

#define pi 3.14159265357
#define log2_10 3.321915

int
GRArc(center,cpoint,angle,style)
POINT *center, *cpoint;
double angle;
int   style;
{
	double xs, ys, radius, resolution, t1, epsalon, fullcircle;
	double degreesperpoint;
	int    i, extent;
	int index;
	int granularity;
	int grain = 1;
	int Erasing = False;
 
	xs = cpoint->x - center->x;
	ys = cpoint->y - center->y;
	if ((xs == 0) && (ys == 0)) { /* radius = 0 */
		error("Arc: zero radius");
		return(-1);
	}
	/* calculate drawing parameters */
	radius = sqrt(xs * xs + ys * ys);
	granularity = radius / 16.0 + 1;
	t1 = floor(log10(radius) * log2_10);
	resolution = pow(2.0, t1);
	epsalon = 1.0 / resolution;
	fullcircle = ceil(2 * pi * resolution);
	degreesperpoint = 360.0 / fullcircle;
	if (angle == 0) { /* full circle */
		return GRCircle(center, radius, style);
	} else { /* partial */
		extent = angle/degreesperpoint;
		index = 0;
		for (i=0; i<extent; ++i) { /* compute one point */
			xs += epsalon * ys;
			ys -= epsalon * xs;
			if (--grain == 0 || i+1== extent){ /* draw this point */
				if(index>=MAXPOINTS) { /* should never happen */
					error("SHArc: circle too large.");
					return(-1);
				}
				vlist[index].x = (short) (xs + center->x) ;   /* round */
				vlist[index].y = (short) (ys + center->y) ;   /* round */
				index++;
				grain = granularity;
			} /* draw this point */
		}   /* for */;
		if (style<0) {
			style = -style-1;
			Erasing = True;
		}
		if (halftone) style += NBRUSHES;
		STARTMAYBECOPY(Erasing && CopyBrushes[style], BrushContext[style]);
		if (BadFlags & BadDrawLines) FixLineList(vlist, &index);
		XDrawLines(MyDisplay, WindowList[WIN_DRAW],
			BrushContext[style], vlist, index, CoordModeOrigin);
		ENDMAYBECOPY(Erasing && CopyBrushes[style], BrushContext[style]);
		return(0);
	} /* partial arc */
}  /* GRArc */;

/* Bresenham's incremental circle algorithm from:
	Procedural Elements for Computer Graphics, David F. Rogers. pp. 42-8 */
int
GRCircle(center,radius,style)
POINT *center;
double radius;
int   style;
{
    register int x = 0; register int y = radius;
        /* start at relative (0, radius) anticlockwise */
    register int d = 2 * (1 - radius);
    int numV = 0; /* how many vertices */
    int Limit = 0;
    int i;
    int iV, dp;
	int granularity = radius / 16.0 + 1;
	int grain = 1;
	int Erasing = False;
 
	if (radius == 0) {
		error("Circle: zero radius");
		return(-1);
	}
	for (;;) { /* first quadrant */
		if (--grain == 0 || y <= Limit) {
			vlist[numV].x = x;
			vlist[numV].y = y;
			numV++;
			grain = granularity;
		}
		if(y <= Limit) break;
		if(d < 0) {
			dp = d+d+y+y-1;
			if(dp > 0) goto jump;
			x++;
			d += x+x+1;
		} else if(d > 0) {
			dp = d+d-x-x-1;
			if(dp <= 0) goto jump;
			y--;
			d -= y+y-1;
		} else {
	jump:
			x++;
			y--;
			d += x+x-y-y+2;
		}
	} /* for loop */
	iV=numV;
	for(i=iV-1;i>=0;i--) { /* fourth quadrant */
		vlist[numV].x = vlist[i].x;
		vlist[numV].y = -vlist[i].y;
		numV++;
	}
	iV=numV;
	for(i=0;i<iV;i++) { /* third, second quadrant */
		vlist[numV].x = -vlist[i].x;
		vlist[numV].y = -vlist[i].y;
		numV++;
		}
	for(i=0;i<numV;i++) { /* translate */
		vlist[i].x += center->x;
		vlist[i].y += center->y;
	}
	if (style<0) {
		style = -style-1;
		Erasing = True;
	}
	if (halftone) style += NBRUSHES;
	STARTMAYBECOPY(Erasing && CopyBrushes[style], BrushContext[style]);
	if (BadFlags & BadDrawLines) FixLineList(vlist, &i);
	XDrawLines(MyDisplay, WindowList[WIN_DRAW],
		BrushContext[style], vlist, i, CoordModeOrigin);
	ENDMAYBECOPY(Erasing && CopyBrushes[style], BrushContext[style]);
	return(0);
}  /* GRCircle */;

static Paramaterize(x, y, h, n)
float x[MAXPOINTS], y[MAXPOINTS], h[MAXPOINTS];
int n;
/*     This routine calculates parameteric values for use in calculating
 * curves.  The parametric values are returned in the array h[1..n-1].
 * The values are an approximation of arc lengths of the curve (uses cord
 * length).  For additional information, see paper cited below.
 */

{
	register int i;
	for (i=1; i<n; ++i) {
		register double dx = x[i+1] - x[i];
		register double dy = y[i+1] - y[i];
		h[i] = sqrt(dx*dx + dy*dy);
	}
}  /* Paramaterize */

static PeriodicSpline(h, z, dz, d2z, d3z, npoints)
float h[MAXPOINTS], z[MAXPOINTS];	/* paramaterization and point list */
float dz[MAXPOINTS];			/* to return the 1st derivative */
float d2z[MAXPOINTS], d3z[MAXPOINTS];	/* 2nd and 3rd derivatives */
int npoints;				/* number of valid points */
/*
 *     This routine solves for the cubic polynomial to fit a spline
 * curve to the the points  specified by the list of values.
 * The Curve generated is periodic.  The alogrithms for this 
 * curve are from the "Spline Curve Techniques" paper cited below.
 */
{
	float d[MAXPOINTS]; 
	float deltaz[MAXPOINTS], a[MAXPOINTS], b[MAXPOINTS];
	float c[MAXPOINTS], r[MAXPOINTS], s[MAXPOINTS];
	int i;

/* step 1 */
	for (i=1; i<npoints; ++i) {
		if (h[i] != 0)
			deltaz[i] = (z[i+1] - z[i]) / h[i];
		else
			deltaz[i] = 0;
	}
	h[0] = h[npoints-1];
	deltaz[0] = deltaz[npoints-1];
/* step 2 */
	for (i=0; i<npoints-1; ++i) {
		d[i] = deltaz[i+1] - deltaz[i];
	}
/* step 3a */
	a[1] = 2 * (h[0] + h[1]);
	if (a[1] == 0) return(-1);  /* 3 consecutive knots at same point */
	b[1] = d[0];
	c[1] = h[0];
	for (i=2; i<npoints-1; ++i) {
		register double tmp = h[i-1];
		a[i] = 2 * (tmp + h[i]) - tmp*tmp / a[i-1];
		if (a[i] == 0) return(-1);  /* 3 consec knots at same point */
		b[i] = d[i-1] - tmp * b[i-1]/a[i-1];
		c[i] = -tmp * c[i-1]/a[i-1];
	}
/* step 3b */
	r[npoints-1] = 1;
	s[npoints-1] = 0;
	for (i=npoints-2; i>0; --i) {
		r[i] = -(h[i] * r[i+1] + c[i])/a[i];
		s[i] = (6 * b[i] - h[i] * s[i+1])/a[i];
	}
/* step 4 */
	d2z[npoints-1] = (6 * d[npoints-2] - h[0] * s[1] 
	                   - h[npoints-1] * s[npoints-2]) 
	                 / (h[0] * r[1] + h[npoints-1] * r[npoints-2] 
	                    + 2 * (h[npoints-2] + h[0]));
	for (i=1; i<npoints-1; ++i) {
		d2z[i] = r[i] * d2z[npoints-1] + s[i];
	}
	d2z[npoints] = d2z[1];
/* step 5 */
	for (i=1; i<npoints; ++i) {
		dz[i] = deltaz[i] - h[i] * (2 * d2z[i] + d2z[i+1])/6;
		if (h[i] != 0)
			d3z[i] = (d2z[i+1] - d2z[i])/h[i];
		else
			d3z[i] = 0;
	}
	return(0);
}  /* PeriodicSpline */

static NaturalEndSpline(h, z, dz, d2z, d3z, npoints)
float h[MAXPOINTS], z[MAXPOINTS];	/* Point list and parameterization */
float dz[MAXPOINTS];			/* to return the 1st derivative */
float d2z[MAXPOINTS], d3z[MAXPOINTS];	/* 2nd and 3rd derivatives */
int npoints;				/* number of valid points */
/*
 *     This routine solves for the cubic polynomial to fit a spline
 * curve the the points  specified by the list of values.  The alogrithms for
 * this curve are from the "Spline Curve Techniques" paper cited below.
 */
{	float d[MAXPOINTS];
	float deltaz[MAXPOINTS], a[MAXPOINTS], b[MAXPOINTS];
	int i;
 
/* step 1 */
	for (i=1; i<npoints; ++i) {
		if (h[i] != 0)
			deltaz[i] = (z[i+1] - z[i]) / h[i];
		else
			deltaz[i] = 0;
	}
	deltaz[0] = deltaz[npoints-1];
/* step 2 */
	for (i=0; i<npoints-1; ++i) {
		d[i] = deltaz[i+1] - deltaz[i];
	}
/* step 3 */
	a[0] = 2 * (h[2] + h[1]);
	if (a[0] == 0) return(-1);  /* 3 consec knots at same point */
	b[0] = d[1];
	for (i=1; i<npoints-2; ++i) {
		register double hip1 = h[i+1];
		a[i] = 2 * (hip1 + h[i+2]) - hip1*hip1 / a[i-1];
		if (a[i] == 0) return(-1);  /* 3 consec knots at same point */
		b[i] = d[i+1] - hip1 * b[i-1]/a[i-1];
	}
/* step 4 */
	d2z[npoints] = d2z[1] = 0;
	for (i=npoints-1; i>1; --i) {
		d2z[i] = (6 * b[i-2] - h[i] *d2z[i+1])/a[i-2];
	}
/* step 5 */
	for (i=1; i<npoints; ++i) {
		dz[i] = deltaz[i] - h[i] * (2 * d2z[i] + d2z[i+1])/6;
		if (h[i] != 0)
			d3z[i] = (d2z[i+1] - d2z[i])/h[i];
		else
			d3z[i] = 0;
	}
	return(0);
}  /* NaturalEndSpline */

#define PointsPerInterval 16

GRCurve(pointlist,style)
POINT *pointlist;
int   style;
/*
 *    This routine generates a smooth curve through a set of points.  The 
 * method used is the parametric spline curve on unit knot mesh described
 * in "Spline Curve Techniques" by Patrick Baudelaire, Robert Flegal, and 
 * Robert Sproull -- Xerox Parc.
 */
{
	float h[MAXPOINTS];
	float x[MAXPOINTS], y[MAXPOINTS], dx[MAXPOINTS], dy[MAXPOINTS];
	float d2x[MAXPOINTS], d2y[MAXPOINTS], d3x[MAXPOINTS], d3y[MAXPOINTS];
	float t, t2, t3, xinter, yinter;
	POINT *ptr;
	int numpoints, i, j, k, stat, count;
	int Erasing = False;
/* Copy point list to array for easier access */
	ptr = pointlist;
	for (i=1; (!Nullpoint(ptr)); ++i) {
		x[i] = ptr->x;
		y[i] = ptr->y;
		if (i >= MAXPOINTS - 1) break;
		ptr = PTNextPoint(ptr);
	}
/* Solve for derivatives of the curve at each point separately for x and y
(parametric).  */
	numpoints = i - 1;
	Paramaterize(x, y, h, numpoints);
  	stat = 0;
	if ((x[1] == x[numpoints]) && (y[1] == y[numpoints])) { /* closed curve */
		stat |= PeriodicSpline(h, x, dx, d2x, d3x, numpoints);
		stat |= PeriodicSpline(h, y, dy, d2y, d3y, numpoints);
	} else {
		stat |= NaturalEndSpline(h, x, dx, d2x, d3x, numpoints);
		stat |= NaturalEndSpline(h, y, dy, d2y, d3y, numpoints);
	}
	if (stat != 0) return(-1);  /* error occurred */
/* generate the curve using the above information and PointsPerInterval
vectors between each specified knot.  */
	count = 0;
	for (j=1; j<numpoints; ++j) {
		for (k=0; k<=PointsPerInterval; ++k) {
			t = (float) k * h[j] / (float) PointsPerInterval;
			t2 = t * t;
			t3 = t * t2;
			xinter = x[j] + t * dx[j] + t2 * d2x[j]/2.0 + t3 * d3x[j]/6.0;
			yinter = y[j] + t * dy[j] + t2 * d2y[j]/2.0 + t3 * d3y[j]/6.0;
			if(count>=MAXPOINTS) {
				error("Curve: too many vectors.");
				return(-1);
			}
			vlist[count].x = xinter;
			vlist[count].y = yinter;
			count++;
		}  /* for k */
	}  /* for j */
	if (style<0) {
		style = -style-1;
		Erasing = True;
	}
	if (count >= MAXPOINTS) {
		error("Too many points in spine");
		return(1);
	}
	if (halftone) style += NBRUSHES;
	STARTMAYBECOPY(Erasing && CopyBrushes[style], BrushContext[style]);
	if (BadFlags & BadDrawLines) FixLineList(vlist, &count);
	XDrawLines(MyDisplay, WindowList[WIN_DRAW],
		BrushContext[style], vlist, count, CoordModeOrigin);
	ENDMAYBECOPY(Erasing && CopyBrushes[style], BrushContext[style]);
	return(0);
}  /* GRCurve */

GREraseText(justify,point1,font,size,string,pos)
int justify, font, size;
POINT *point1, *pos;
char string[];
{
	PutText(justify,point1,font,size,string,pos,1);
}

GRPutText(justify,point1,font,size,string,pos)
int justify, font, size;
POINT *point1, *pos;
char string[];
{
	PutText(justify,point1,font,size,string,pos,0);
}

/*
 *  Put text in WIN_DRAW, not text window, unlike TextPut.
 */
/*ARGSUSED*/ /* erase is no longer needed, but let's keep it a while */
PutText(justify,point1,font,size,string,pos,erase)
int justify, font, size, erase;
POINT *point1, *pos;
char string[];
{
	int length;
	XGCValues GCValues;
    GC gc = halftone ? PutTextHighlightContext : PutTextContext;
 
	if(text_font[font][size]==NULL) {
		text_font[font][size] = XLoadQueryFont(MyDisplay,
			text_font_names[font][size]);
	}
	if(text_font[font][size]==NULL) {
		char mesg[100];
		(void) sprintf(mesg,"Gremlin:  couldn't load font %s [%d][%d].",
			text_font_names[font][size], font, size);
		error(mesg);
		text_font[font][size] = pointfontdata;
	}
	length = XTextWidth(text_font[font][size], string, strlen(string));
	switch (justify) {
		case BOTLEFT:	pos->x = point1->x;
			pos->y = point1->y - text_font[font][size]->ascent;
			break;
		case BOTCENT:	pos->x = point1->x - (length/2);
			pos->y = point1->y - text_font[font][size]->ascent;
			break;
		case BOTRIGHT:	pos->x = point1->x - length;
			pos->y = point1->y - text_font[font][size]->ascent;
			break;
		case CENTLEFT:	pos->x = point1->x;
			pos->y = point1->y - (text_font[font][size]->ascent/2);
			break;
		case CENTCENT:	pos->x = point1->x - (length/2);
			pos->y = point1->y - (text_font[font][size]->ascent/2);
			break;
		case CENTRIGHT:	pos->x = point1->x - length;
			pos->y = point1->y - (text_font[font][size]->ascent/2);
			break;
		case TOPLEFT:	pos->x = point1->x;
			pos->y = point1->y;
			break;
		case TOPCENT:	pos->x = point1->x - (length/2);
			pos->y = point1->y;
			break;
		case TOPRIGHT:	pos->x = point1->x - length;
			pos->y = point1->y;
			break;
	}
	GCValues.font = text_font[font][size]->fid;
	XChangeGC(MyDisplay, gc, GCFont, &GCValues);
	STARTMAYBECOPY (erase && BadFlags & (BadXorBroken | BadPointFont), gc);
	XDrawString(MyDisplay, WindowList[WIN_DRAW], gc,
		(int) pos->x, (int) pos->y+text_font[font][size]->ascent, string,
		strlen(string));
	ENDMAYBECOPY (erase && BadFlags & (BadXorBroken | BadPointFont), gc);
} /* PutText */;

/*ARGSUSED*/ /* we no longer use mask, but let's leave it in */
GRClear(mask)
int mask;
{
	XClearWindow(MyDisplay, WindowList[WIN_DRAW]);
}

GRDisplayPoint(x, y, number, mark)
int x, y, number, mark;
/*
 *      This routine displays a point on the screen.  The point is
 * displayed as a '+' centered about the point (x,y) and followed by
 * number.
 */
{
	POINT p1, p2;
	int psize;
	char	asc[4];
	if (artmode) psize = 1;
	else psize = 4;
	halftone = FALSE; /* will restore later */
	p1.y = p2.y = y;
	p1.x = x - psize;
	p2.x = x + psize;
	GRVector(&p1, &p2, mark);
	p1.x = p2.x = x;
	p1.y = y - psize;
	p2.y = y + psize;
	GRVector(&p1, &p2, mark);
	if ( !artmode ) { /* display or erase the number */
		(void) sprintf(asc,"%d",number);
		STARTMAYBECOPY(
			(mark < 0) &&
			(BadFlags & BadXorBroken || BadFlags & BadPointFont),
			PointContext);
		XDrawString(MyDisplay, WindowList[WIN_DRAW], PointContext, x+2,
			y+3+pointfontdata->ascent, asc, strlen(asc));
		ENDMAYBECOPY(
			(mark < 0) &&
			(BadFlags & BadXorBroken || BadFlags & BadPointFont),
			PointContext);
	} /* display or erase the number */
	halftone = CSETPOINTS; /* restoring from earlier */
}  /* DisplayPoint */

GRErasePoint(x, y, number)
int x, y, number;
/*
 *      This routine erases the specified point by redrawing it in the
 * background color
 */
{
	GRDisplayPoint(x, y, number, -(B_THIN+1));
}  /* ErasePoint */

GRBlankPoints()
{
	POINT *plist;
	int	count;

	count = 0;
	forpoint(plist, POINTLIST) {
		GRErasePoint((int)plist->x,(int)plist->y,count++);
	}
}  /* BlankPoints */

GRShowPoints()
{
	POINT *plist;
	int	count;

	count = 0;
	forpoint(plist, POINTLIST) {
		GRDisplayPoint((int)plist->x,(int)plist->y,count++,pointstyle);
	}
} /* GRShowPoints */

/*
 * Fill a polygon with the fill pattern selected by "color" (see gremlin.h
 * for more comments about the meaning of "color").
 * If color<0, erase using pattern -color-1.
 * Notes:
 * This procedure only does the filling; it does not draw the boundary.
 * It overlays the pattern on top of what was there before by xoring
 * all pixels that are set in the stipple pattern with the Foreground color.
 * On displays
 * with enough planes, we really should use another plane for the stipple
 * overlay, or just use different colors.
 */
GRPolygon(pointlist, color)
POINT *pointlist;
int color;
{
	POINT *p;
	int i;
	int Erasing = False;
 
	for (i=0,p=pointlist; !Nullpoint(p); i++,p=PTNextPoint(p)) {
		vlist[i].x = p->x;
		vlist[i].y = p->y;
	}
	vlist[i].x = vlist[0].x;
	vlist[i].y = vlist[0].y;
	i++;
	if (color<0) {
		color = -color-1;
		Erasing = True;
	}
	if (color >= MAXFILL) {
		/* shouldn't happen, but it does with bad data files. */
		color = MAXFILL;
	}
	if (Erasing) {
		XGCValues GCValues;
		GCValues.function = GXandInverted;
		XChangeGC(MyDisplay, StippleContext[color], GCFunction, &GCValues);
	}
	XFillPolygon(MyDisplay, WindowList[WIN_DRAW], StippleContext[color],
		vlist, i, Complex, CoordModeOrigin);
	if (Erasing) {
		XGCValues GCValues;
		GCValues.function = GXcopy;
		XChangeGC(MyDisplay, StippleContext[color], GCFunction, &GCValues);
	}
} /* GRPolygon */
