/*
 *  Gremlin for the X window package.  Hacked from the aed gremlin.
 *  
 *  Copyright 1986 Dick Leban, University of Wisconsin Computer Systems Lab
 *  1210 West Dayton, Madison WI, 53706
 *  
 *  Permission is hearby granted to distribute this program provided that:
 *    (*) no commerical advantage is gained
 *    (*) the recipient has a gremlin license
 *    (*) this copyright notice appears on all copies
 *    (*) "On Wisconsin" sung in its entirety while the software
 *        is being copied to the distribution media.
 *  
 *        Here's the words, you'll have to find the tune if you're
 *        an uncultured slug.
 *  
 *           On Wisconsin, On Wisconsin,
 *           Plunge right through that line!
 *           Run the ball clear down the field boys,
 *           Touchdown sure this time (u-rah-rah)
 *           On Wisconsin, On Wisconsin,
 *           Fight on for her fame!
 *           Fight fellows fight-fight-fight 
 *           we'll win this game!
 *  
 *  Copyright -C- 1982 Barry S. Roitblat
 */

#include "gremlin.h"
#include "decls.h"
#ifndef lint
	static char *rcsid="$Header: help.c,v 2.2 88/08/12 13:37:17 solomon Stab $";
#endif lint

char *lbm[NUM_WINDOWS][3] = {
{	/* WIN_CLEARPT */
	"Clears excess points from the display.",
	"Long form:  clear",
	"",
},
{	/* WIN_VECTOR */
	"Draws vectors (in current brush)",
	"connecting the placed points.",
	"Short form: v",
},
{	/* WIN_VECCURVE */
	"Interchanges vectors and splines for all items in the current set.",
	"",
	"",
},
{	/* WIN_SPLINE */
	"Draws a cubic spline (in current brush)",
	"connecting the placed points.",
	"Short form: b",
},
{	/* WIN_RECTANGLE */
	"Draws a rectangle (in current brush)",
	"using the first two points as opposite corners.",
	"Short form: x",
},
{	/* WIN_ARC */
	"Draws an arc (in current brush) centered at point 0, starting at",
	"point 1, and heading towards point 2.  If point 2 is not",
	"specified, a circle is drawn.  Short form: a",
},
{	/* WIN_ARROWHEAD */
	"Draws an arrowhead (in current brush) with the tip at point 0,",
	"coming from point 1.",
	"Short form: w",
},
{	/* WIN_ENTERTEXT */
	"Enters text (in current font, size, justification)",
	"at point 0, or between 0 and 1 if both exist.",
	"Long form:  text newtext",
},
{	/* WIN_BRUSH */
	"Advances the current brush style.  The current brush is displayed in",
	"the icon window.",
	"Long form:  brush n",
},
{	/* WIN_FONT */
	"Advances the current font.  R=roman, I=italics, B=bold, S=special.",
	"Long form:  font n",
	"",
},
{	/* WIN_SIZE */
	"Advances the current font size.",
	"Long form:  size n",
	"",
},
{	/* WIN_JUSTIFY */
	"Advances the current justification mode.",
	"Long form:  justification n",
	"",
},
{	/* WIN_ADJUST */
	"Advances the adjustment mode.",
	"Short form: z",
	"Long form:  {h,v}adjust",
},
{	/* WIN_ALIGN */
	"Sets the alignment to the integer contained in the text buffer or",
	"twice its current size",
	"Long form:  align n",
},
{	/* WIN_GRAVITY */
	"Advances gravity mode.  When this icon is lit P, points will gravitate",
	"towards existing points; when lit O, points gravitate to lines or arcs",
	"Short form: g",
},
{	/* WIN_FILL */
	"Advances the current fill pattern.  The current fill pattern is displayed",
	"in the icon window.",
   "Long form:  fill n",
},
{	/* WIN_GRID */
	"Toggles the grid.",
	"Short form: q",
	"",
},
{	/* WIN_POINT */
	"Toggles the image of points.",
	"Long form:  littlepoint",
	"",
},
{	/* WIN_CSET */
	"Toggles the mode in which line elements in the current set are",
	"displayed with a half-tone pattern.",
	"Long form:  halftone",
},
{	/* WIN_DEFINE */
	"Define set:  The current set is defined to be the element(s) closest to",
	"any points.  No points specified will define the entire picture as",
	"the current set.  Short form: d",
},
{	/* WIN_BDEFINE */
	"Box define set:  the current set becomes all objects entirely",
	"contained within the rectangle defined by the first two points.",
	"Short form: f",
},
{	/* WIN_DELETE */
	"Erases the current set.",
	"Short form: e",
	"",
},
{	/* WIN_MOVE */
	"Moves the current set.  The displacement is relative to the first two",
	"points.",
	"Short form: t",
},
{	/* WIN_COPY */
	"Copies the current set.  The displacement of the copy is relative to the",
	"first two points.  Multiple copies may be made.  The last copy becomes",
	"the current set.  Short form: c",
},
{	/* WIN_MOVEPT */
	"The element of the current set which contains the point closest to the",
	"first point is redrawn with that point replaced by the remaining points.",
	"(deleted if no other points).  Short form: y",
},
{	/* WIN_SCALE */
	"Scale current set using the first three points.  The scaling factor is",
	"the ratio of the distance between the first two points and the first and",
	"third points.  Short form: s",
},
{	/* WIN_ROTATE */
	"Rotate current set at point 0.  The angle between line 0,1 and line 0,2",
	"is the angle of rotation.  Short form: r",
	"",
},
{	/* WIN_MIRROR */
	"Mirror current set at point 0.  Mirrors horizontal if point 2 and point 1",
	"are on opposite x sides of point 0, vertical if point 2 and point 1 are on",
	"opposite y sides of point 0.  Short form: m",
},
{	/* WIN_PATH */
	"Set the search path for reading gremlinfiles.",
	"Components are seperated by colons.  :: means the current directory.",
	"Long form:  path newpath",
},
{	/* WIN_BANG */
	"Toggles certainly mode.  When this icon is unlit (safe) and the picture has",
	"changed since the last write, gremlin refuses to read a new picture or",
	"quit until the current picture has been saved. Turns itself off shortly.",
},
{	/* WIN_READ */
	"Edits the filename that is contained in the text buffer.",
	"Long form:  edit",
	"",
},
{	/* WIN_WRITE */
	"Writes the picture to the current editfile.",
	"Long form:  write [filename]",
	"",
},
{	/* WIN_BUFFER */
	"Advances the current set buffer.  The number of the buffer is displayed",
	"in the icon.",
},
{	/* WIN_REDRAW */
	"Redraws the page window.",
	"Short form: ^L",
	"",
},
{	/* WIN_UNDO */
	"Undoes the last gremlin operation.",
	"Long form:  undo",
	"",
},
{	/* WIN_HELP */
	"Help: after selecting this icon, click any mouse button in the icon for",
	"which help is wanted.  The help window will stay displayed until",
	"another mouse button is clicked.",
},
{	/* WIN_REORDER */
	"The current set is placed below (is hidden by) everything else.",
	"Later objects in the set are placed above early objects.",
	"",
},
{	/* WIN_QUIT */
	"Quits gremlin.",
	"Long form:  quit",
	"",
},
{	/* WIN_DRAW */
	"Lays down a point at the current mouse location.",
	"Long form:  point x y; zpoint",
	"",
},
{	/* WIN_TEXT */
	"","","",
},
};

char *mbm[NUM_WINDOWS][3] = {
{ "","","",},	/* WIN_CLEARPT */
{	/* WIN_VECTOR */
	"Draws a polygon defined by the points and fills it with the current",
	"fill pattern, outlined with the current brush" ,
	"Short form: h",
},
{	/* WIN_VECCURVE */
	"Interchanges bordered and borderless polygons in all items",
	"in the current set.  Uses current fill pattern.",
	"",
},
{ "","","",},	/* WIN_SPLINE */
{	/* WIN_RECTANGLE */
	"Draws a filled (in current fill) rectangle (in current brush)",
	"using the first two points as opposite corners.",
	"",
},
{	/* WIN_ARC */
	"Draws an ellipse centered at point 0, with x limit defined by point 1,",
	"y limit defined by point 2.",
	"",
},
{	/* WIN_ARROWHEAD */
	"Draws a filled arrowhead (in current fill)",
	"including a border (in current brush)",
	"Short form: W",
},
{	/* WIN_ENTERTEXT */
	"Changes the text of all text elements in the current set to be the text",
	"in the text buffer.",
	"Long form:  mtext newtext",
},
{	/* WIN_BRUSH */
	"Changes the brush of all line elements in the current set to be the brush",
   "displayed in the icon.",
	"Long form:  mbrush [n]",},
{	/* WIN_FONT */
	"Changes the font of all text elements in the current set to be the font",
  "displayed in the icon.",
	"Long form:  mfont [n]",},
{	/* WIN_SIZE */
	"Changes the size of all text elements in the current set to be the size",
	"displayed in the icon.",
	"Long form:  msize [n]",},
{	/* WIN_JUSTIFY */
	"Changes the justification of all the text elements in the current set",
	"to be the justification displayed in the icon.",
	"Long Form:  mjust",
},
{ "","","",},	/* WIN_ADJUST */
{	/* WIN_ALIGN */
	"Sets the alignment to the integer contained in the text buffer or",
	"the current grid size",
	"",
},
{ "","","",},	/* WIN_GRAVITY */
{	/* WIN_FILL */
	"Changes the fill of all polygons and rectangles in the current set",
	"to the pattern displayed in the icon.",
	"Long form:  mfill [n]",
},
{	/* WIN_GRID */
	"Sets the grid size.  The text buffer should contain an integer.",
	"Long form:  grid n", "",
},
{ "","","",},	/* WIN_POINT */
{ "","","",},	/* WIN_CSET */
{	/* WIN_DEFINE */
	"For each point laid down, the element nearest to it is added to the",
	"current set.",
	"Long form:  includeset",
},
{ "","","",},	/* WIN_BDEFINE */
{ "","","",},	/* WIN_DELETE */
{	/* WIN_MOVE */
	"Move all elements in the current set to be centered in the window.",
	"", "",
},
{ "","","",},	/* WIN_COPY */
{ "","","",},	/* WIN_MOVEPT */
{	/* WIN_SCALE */
	"Scale current set in the X direction using the first three points.",
	"","",
},
{	/* WIN_ROTATE */
	"Rotate current set, but leave a copy of old set in place.",
	"Short form: R","",
},
{	/* WIN_MIRROR */
	"Mirror current set, but leave a copy of old set in place.",
	"Short form: M","",
},
{	/* WIN_PATH */
	"Prints the current search path.","","",
},
{ "","","",},	/* WIN_BANG */
{	/* WIN_READ */
	"Read in from the current or specified buffer to each point given.",
	"Last copy becomes current set.",
	"Long form:  buffer [n]",
},
{	/* WIN_WRITE */
	"Write the picture into a backup file named '<currentfile>.bak'.",
	"Will overwrite existing backup file.",
	"Short form: .",
},
{	/* WIN_BUFFER */
	"Save a copy of the current set in the current buffer.",
	"Short form: 1, 2, 3, or 4",
	"",
},
{ "","","",},	/* WIN_REDRAW */
{ "","","",},	/* WIN_UNDO */
{ "","","",},	/* WIN_HELP */
{ "","","",},	/* WIN_REORDER */
{ "","","",},	/* WIN_QUIT */
{	/* WIN_DRAW */
	"Removes the last point.","Long form:  deletepoint",
	"Long form:  align n",
},
{ "","","",},	/* WIN_TEXT */
};

char *rbm[NUM_WINDOWS][3]={
{ "","","",},	/* WIN_CLEARPT */
{	/* WIN_VECTOR */
	"Draws a polygon defined by the points and fills it with the current",
	"fill pattern, but draws outline with brush 0 (invisible).",
	"",
},
{	/* WIN_VECCURVE */
	"Interchanges bordered polygons and vectors for all items",
	"in the current set.  Uses current brush.",
	"",
},
{ "","","",},	/* WIN_SPLINE */
{	/* WIN_RECTANGLE */
	"Fills in a rectangle using the first two points as opposite corners",
	"but draws the outline with brush 0 (invisible).",
	"Short form: X",
},
{ "","","",},	/* WIN_ARC */
{	/* WIN_ARROWHEAD */
	"The current set, along with two positioning points,",
	"becomes the new arrowhead form.",
	"",
},
{ "","","",},	/* WIN_ENTERTEXT */
{	/* WIN_BRUSH */
	"Backs up the current brush style.  The current brush is displayed in",
	"the icon window.",
	"",
},
{	/* WIN_FONT */
	"Backs up the current font.",
	"",
	"",
},
{	/* WIN_SIZE */
	"Backs up the current font size.",
	"",
	"",
},
{	/* WIN_JUSTIFY */
	"Backs up the current justification mode.",
	"",
	"",
},
{	/* WIN_ADJUST */
	"Backs up the adjustment mode.",
	"",
	"",
},
{	/* WIN_ALIGN */
	"Sets the alignment to the integer contained in the text buffer or",
	"half its current size",
	"",
},
{ "","","",},	/* WIN_GRAVITY */
{	/* WIN_FILL */
	"Backs up the current fill pattern.  The current pattern is displayed in",
	"the icon window.",
	"",
},
{ "","","",},	/* WIN_GRID */
{	/* WIN_POINT */
	"Sets the automatic arrow mode to the integer contained in the text",
	"buffer or advances by one.",
	"Long form:  arrowmode [n]",
},
{ "","","",},	/* WIN_CSET */
{ "","","",},	/* WIN_DEFINE */
{ "","","",},	/* WIN_BDEFINE */
{ "","","",},	/* WIN_DELETE */
{ "","","",},	/* WIN_MOVE */
{	/* WIN_COPY */
	"Copies the current set to appear n times, where n is in",
	"the input window, relative to the two points given.",
	"The last copy becomes the current set.",
},
{ "","","",},	/* WIN_MOVEPT */
{	/* WIN_SCALE */
	"Scale current set in the Y direction using the first three points.",
	"","",
},
{ "","","",},	/* WIN_ROTATE */
{ "","","",},	/* WIN_MIRROR */
{ "","","",},	/* WIN_PATH */
{ "","","",},	/* WIN_BANG */
{ 	/* WIN_READ */
	"Reads in the file named in the text buffer.  May take a positioning point.",
	"Long form:  read filename",
	"BUG: positioning point is flakey.",},
{	/* WIN_WRITE */
	"Writes the current set to the file specified by the text buffer.",
	"Long form:  saveset filename","",
},
{	/* WIN_BUFFER */
	"Backs up the current set buffer.  The number of the buffer is displayed",
	"in the icon.",
	"",
},
{ "","","",},	/* WIN_REDRAW */
{ "","","",},	/* WIN_UNDO */
{ "","","",},	/* WIN_HELP */
{	/* WIN_REORDER */
	"The current set is placed on top of (hides) everything else.",
	"Later objects in the set are placed above early objects.",
	"",
},
{ "","","",},	/* WIN_QUIT */
{	/* WIN_DRAW */
	"Repeats the last function.","","",
},
{ "","","",},	/* WIN_TEXT */
};

#define SayThis(x, y, what) \
	XDrawString(MyDisplay, windowid, HelpContext, x, y, what, strlen(what))

XHelp()
{
	XEvent event;
	int count;
	Window windowid;
	XSetWindowAttributes attr;
	int ValueMask = CWBorderPixel | CWBackingStore | CWBackPixel;

	ShowIcon(glyphs[WIN_HELP], WindowList[WIN_HELP], 1);
	XNextEvent(MyDisplay, &event);
	ShowIcon(glyphs[WIN_HELP], WindowList[WIN_HELP], 0);
	if (event.type==ButtonPress) {
		for(count=0;count<NUM_WINDOWS;count++)
			if (event.xbutton.window==WindowList[count])
				goto gotit;
		TextPut("That window is not used.");
		return;
	} else {
		XPutBackEvent(MyDisplay, &event);
		TextPut("Select Help, then select an icon with any button.");
		return;
	}
gotit:
	attr.border_pixel = Background;
	attr.backing_store = WhenMapped;
	attr.background_pixel = Foreground;
	windowid = XCreateWindow(MyDisplay, Root, 140, 35, 700, 400, 1, 0,
		InputOutput, CopyFromParent, ValueMask, &attr);
	if (windowid ==0) {
		TextPut("help! couldn't create help window.");
		return;
	}
	XSelectInput(MyDisplay, windowid, ButtonPressMask);
	XMapRaised(MyDisplay, windowid);
	if (count<WIN_DRAW) {
		ShowIcon(glyphs[count], windowid, 0);
	} else if (count==WIN_DRAW) {
		SayThis(10, 15, "Page Window");
		SayThis(10, 35, "  Chars typed here are considered short commands.");
		SayThis(10, 55, "  Type <tab> or : to get pencil cursor.");
	} else {
		SayThis(10, 15, "Text Window");
		SayThis(10, 35, "  Chars typed here are considered long commands.");
		SayThis(10, 55, "  Type ^U <cr> to get crosshair cursor.");
	}
	SayThis(10, 80, "Left Button:");
	SayThis(10, 100, lbm[count][0]);
	SayThis(10, 120, lbm[count][1]);
	SayThis(10, 140, lbm[count][2]);
	SayThis(10, 180, "Middle Button:");
	SayThis(10, 200, mbm[count][0]);
	SayThis(10, 220, mbm[count][1]);
	SayThis(10, 240, mbm[count][2]);
	SayThis(10, 280, "Right Button:");
	SayThis(10, 300, rbm[count][0]);
	SayThis(10, 320, rbm[count][1]);
	SayThis(10, 340, rbm[count][2]);
	XNextEvent(MyDisplay, &event);
	if (event.type!=ButtonPress)
		XPutBackEvent(MyDisplay, &event);
	XDestroyWindow(MyDisplay, windowid);
	Consume = FALSE;
} /* XHelp */
