/*
 *  Gremlin for the X window package.  Hacked from the aed gremlin.
 *  
 *  Copyright 1986 Dick Leban, University of Wisconsin Computer Systems Lab
 *  1210 West Dayton, Madison WI, 53706
 *  
 *  Permission is hearby granted to distribute this program provided that:
 *    (*) no commerical advantage is gained
 *    (*) the recipient has a gremlin license
 *    (*) this copyright notice appears on all copies
 *    (*) "On Wisconsin" sung in its entirety while the software
 *        is being copied to the distribution media.
 *  
 *        Here's the words, you'll have to find the tune if you're
 *        an uncultured slug.
 *  
 *           On Wisconsin, On Wisconsin,
 *           Plunge right through that line!
 *           Run the ball clear down the field boys,
 *           Touchdown sure this time (u-rah-rah)
 *           On Wisconsin, On Wisconsin,
 *           Fight on for her fame!
 *           Fight fellows fight-fight-fight 
 *           we'll win this game!
 *  
 *  Copyright -C- 1982 Barry S. Roitblat
 */

#include "gremlin.h"
#include "grem2.h"
#include <ctype.h>
#include "decls.h"
#ifndef lint
static char *rcsid="$Header: /X11R3/uw/xgremlin/RCS/long1.c,v 2.5 89/02/15 12:55:26 solomon Exp Locker: solomon $";
#endif

/* The following is available to the outside world */
	int bang;
	int ShowingPoints = FALSE; /* boolean: true if showpoints is in effect */

/*      The following are defined to allow creation of the command
 * lookup table.
 */

extern LGSetAlign(), LGBrush(), LGClearPoints(), LGGripe(), LGLittlePoint(),
	LGDeletePoint(), LGEdit(), LGFont(), LGIncludeSet(), LGSize(), LGSave(),
	LGJust(), LGPutBuffer(), LGPoint(), LGPath(), LGQuit(), LGRead(),
	LGHAdjust(), LGMBrush(), LGMFont(), LGMSize(), LGMText(), LGMPoint(),
	LGMirror(), LGVAdjust(), LGText(), LGUndo(), LGWrite(), LGOpoint(),
	LGShowPoints(), LGCSetPoints(), LGFill(), LGMFill(), LGMJust();

/* The following two arrays define the long commands and the routines
 * that process them.
 */
char *lcmds[] = {
    "align",
	"arrowmode",
	"backup",
    "brush",
    "buffer",
    "clearpoints",
    "deletepoint",
    "edit",
	"fill",
    "font",
	"grid",
    "hadjust",
	"halftone",
    "includeset",
    "justification",
    "littlepoint",
    "mbrush",
	"mfill",
    "mfont",
    "mirror",
    "mpoint",
    "msize",
	"mjust",
    "mtext",
    "path",
    "point",
    "quit",
    "read",
    "size",
    "saveset",
    "showpoints",
    "text",
    "undo",
    "vadjust",
    "write",
    "zpoint",
    NULL};
(*(lrtns[]))() = {
    LGSetAlign,			/* align */
	LGChangeArrowMode,		/* arrow mode */
	LGBackup,		/* backup current picture */
    LGBrush,			/* set brush */
    LGPutBuffer,			/* select user set buffer */
    LGClearPoints,		/* clear points */
    LGDeletePoint,		/* delete a point */
    LGEdit,			/* edit new file */
    LGFill,			/* set fill color for polygons */
    LGFont,			/* set font */
	XChangeGrid,    /* change grid size */
    LGHAdjust,                  /* horizontal adjust */
	LGCSetPoints,		/* cset halftoning */
    LGIncludeSet,		/* add to set */
    LGJust,			/* text justification */
    LGLittlePoint,		/* point size */
    LGMBrush,			/* modify brush */
    LGMFill,			/* modify polygon fill color */
    LGMFont,			/* modify font */
    LGMirror,			/* mirror current set */
    LGMPoint,			/* move point */
    LGMSize,			/* modify size */
	LGMJust,			/* modify justification */
    LGMText,			/* modify text string */
    LGPath,			/* set path or toggle search mode */
    LGOpoint,			/* obtain point from terminal */
    LGQuit,			/* quit */
    LGRead,			/* read user sysmbol */
    LGSize,                     /* character size */
    LGSave,			/* save current set in file */
    LGShowPoints,		/* display reference points in set */
    LGText,			/* input text */
    LGUndo,			/* undo last command */
    LGVAdjust,                  /* vertical adjust */
    LGWrite,			/* write file */
    LGPoint};			/* create point from cursor */

int
LGLookup(str, table, next)
char str[];			/* Pointer to a string to be looked up */
char *(table[]);		/* Pointer to an array of string pointers
				 * which are the valid commands.  The strings
				 * must be ordered monotonically (i.e. all
				 * strings whose first characters are identical
				 * must be adjacent in the table).
				 */
int *next;

/*---------------------------------------------------------
 *	LGLookup searches a table of strings to find one that matches a
 *	given string.
 *
 *	Results:
 *	If str is an unambiguous abbreviation for one of the entries
 *	in table, then the index of the matching entry is returned.
 *	If str is an abbreviation for more than one entry in table,
 *	then -1 is returned.  If str doesn't match any entry, then
 *	-2 is returned.
 *
 *	Side Effects:	None.
 *
 * (Modified from software written by John Ousterhout for the caesar
 *  program)
 *---------------------------------------------------------
 */

{
    /* The search is carried out by using two pointers, one which moves
     * forward through table from its start, and one which moves backward
     * through table from its end.  The two pointers mark the range of
     * strings that match the portion of str that we have scanned.  When
     * all of the characters of str have been scanned, then the two
     * pointers better be identical.
     */
    char **bot, **top;
    int match, index;

    /* bang = FALSE; */
    match = 0;
    bot = table;
    for (top = table; *top != NULL; top++);
    if (top == bot) return(-2);
    top--;

    for (index=0; ; index++)
    {
        *next = index;

	/* Check for the end of string */

	if ( (str[index] == '\0')  ||
             (str[index] == ',')   ||
             (str[index] == ' ')       )
	{
	    if (bot == top) return(match);
	    else return(-1);
	}
	if (str[index] == '!') bang = TRUE;
	else
	{

	/* Move bot up until the string it points to matches str in the
	 * index'th position.  Make match refer to the index of bot in table.
	 */
	    while ((*bot)[index] != str[index])
	    {
	        if (bot == top) return(-2);
	        bot++;
	        match++;
	    }
    
	/* Move top down until it matches */
	    while ((*top)[index] != str[index])
	    {
	        if (bot == top) return(-2);
	        top--;
	    }
        }
    }
}


LGCommand(command)
char *command;

/*---------------------------------------------------------
 *	This routine reads in, looks up, and executes a long command.
 *
 *	Results:	None.
 *
 *	Side Effects:
 *	Depends on the command that is invoked.
 *---------------------------------------------------------
 */

{
    int index, next=0;

    if (*command == '\0') 
    {
        Consume = FALSE;
        return; 
    }
    index = LGLookup(command, lcmds, &next);
	next++;
    if (index >= 0)
    {
		(void) strcpy(input_buffer,(command+next));
		(*(lrtns[index]))();
    }
    else
    {
	if (index == -1) error(".gremlinrc: command is ambiguous.");
	if (index == -2) error(".gremlinrc: not a command.");
    }
}

#define BADNUM -1
#define NONUM -2
#define Delimiter(c) ((c == '\0') || (c == ' ') || (c == ','))

GetNumParm(linei, index)
char *linei;
int *index;
/*
 *      This routine trys to interpret the string starting at
 * line+index as a positive integeral numeric parameter.  The function
 * returns the numeric equivalent or a negative number it there is some
 * error in interpreting the string.
 */

{
	char num[20];
	int i, result;
	char *line;

	line = linei;
	for (i=0; !Delimiter(*(line + *index)); ++i)
	{
		num[i] = *(line + *index);
		if ( !isdigit(num[i]) ) return (BADNUM);
		++(*index);
	}  /* end for */
	if ( i == 0 ) return(NONUM);
	num[i] = '\0';
	(void) sscanf(num,"%d",&result);
	return(result);
}  /* end GetNumParm */


LGOpoint()
/*
 *      This routine accepts coordinates from the text terminal
 * and creates and displays a point from them by passing them
 * along to LGPoint.
 *
 * NOTE: coordinates from the terminal must be non-negative
 * integers.
 */

{
	int index, xcoord, ycoord;
	char *line;

	line = input_buffer;
	index = 0;
	xcoord = GetNumParm(line, &index);
	if (xcoord < 0)
	{
		error("set point: bad x coordinate.");
		return;
	}
	++index;
	ycoord = GetNumParm(line, &index);
	if (ycoord < 0)
	{
		error("set point: bad y coordinate.");
		return;
	}
	PX = xcoord;
	PY = ycoord;
	LGPoint();
}  /* end LGOpoint */


LGPoint()
/*
 *      This routine accepts cursor coordinates and creates and
 * displays points according to the current adjustment and alignment
 * modes.  Note that alignment and gravity are mutually exclusive
 * and adjustment takes precedence over either.
 */
{
	ELT *CloseElt;
	POINT *DummyPointPtr;
#	define sign(a,b) (a >= b ? 1 : -1)
#	define dist(x1, y1, x2, y2) (sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2)))
	CloseElt = nullelt;
	if (SEQ > 0) { /* this isn't the first point */
		float dis;
		switch (Adjustment) {
			case HORZ: PY = Lasty; break;
			case VERT: PX = Lastx; break;
			case MAN:
				if (fabs(PX - Lastx) > fabs(PY - Lasty)) PY = Lasty;
				else   PX = Lastx;
				break;
			case DIAG:
				{	float root2 = sqrt(2.0);
					dis = dist(PX, PY, Lastx, Lasty) / root2;
					PX = Lastx + sign(PX,Lastx) * dis;
					PY = Lasty + sign(PY,Lasty) * dis;
				}
				break;
			case DIAGMAN:
				{	float MX, MY, DX, DY;
					float root2 = sqrt(2.0);
					if (fabs(PX - Lastx) > fabs(PY - Lasty)) {
						MY = Lasty; MX = PX;
					} else {
						MX = Lastx; MY = PY;
					}
					dis = dist(PX, PY, Lastx, Lasty) / root2;
					DX = Lastx + sign(PX,Lastx) * dis;
					DY = Lasty + sign(PY,Lasty) * dis;
					if (dist(PX, PY, MX, MY)>dist(PX, PY, DX, DY)) {
						PX = DX; PY = DY;
					} else {
						PX = MX; PY = MY;
					}
				}
				break;
			default: ;
		} /* switch */
	}  /* if not first point */;
	if (GravityMode)
		DBGravitate (PX, PY, &PX, &PY, &DummyPointPtr, &CloseElt, PICTURE);
	if (DBNullelt(CloseElt)) { /* gravity has no effect */
		/* Round to nearest alignment boundary */
		PX = (float) (((int) (PX / Alignment + 0.5)) * Alignment);
		PY = (float) (((int) (PY / Alignment + 0.5)) * Alignment);
	}
	GRDisplayPoint((int) PX, (int) PY, SEQ, pointstyle);
	(void) PTMakePoint(PX, PY, &POINTLIST);
	Lastx = PX;
	Lasty = PY;
	Consume = FALSE;
	++SEQ;
} /* end Point */

CP()
/*
 *      This routine deletes all points from the POINTLIST.
 */
{
	POINT *temp;

	while ( !Nullpoint(BACKPOINT) ) {
		temp = PTNextPoint(BACKPOINT);
		free((char *) BACKPOINT);
		BACKPOINT = temp;
	}
	free((char *) BACKPOINT); /* the sentinel */
	BACKPOINT = POINTLIST;
	POINTLIST = PTInit();
	SEQ = 0;
}  /* end CP */

LGClearPoints()
{
	GRBlankPoints();
}

LGDeletePoint()
/*
 *      This routine removes the last point from the POINTLIST
 * and erases it from the screen.
 */
{
	POINT *pt1, *pt2, *pt3; 
	/* float savex, savey; not used */

	if (SEQ == 0) {
		error("Delete Point:  no point");
		return;
	}
	pt2 = pt3 = POINTLIST;
	while ( !Nullpoint(pt3) ) {  /* find last point and pointer to it */
		pt1 = pt2;
		pt2 = pt3;
		pt3 = PTNextPoint(pt3);
	};
	SEQ--;
	/* ??
	savex = pt2->x;
	savey = pt2->y;
	*/
	GRErasePoint( (int) pt2->x, (int) pt2->y, SEQ);
	PTDeletePoint(pt2);
	if (SEQ > 0) { /* any points left after deleting */
	    /* then pt1 points to last of them */
		Lastx = pt1->x;
		Lasty = pt1->y;
	}
	Consume = FALSE;
}  /* end DeletePoint */


LGShowPoints()
{
	ELT **eptr;
	POINT *p1;
	int pno;

	if (DBNullSet(cset)) {
		error("Show Points:  no current set.");
		return;
	}
	forcset(eptr) {
		pno = 0;
		forpoint(p1, (*eptr)->ptlist) {
			GRDisplayPoint((int)p1->x, (int)p1->y, pno, pointstyle);
			pno++;
		}
	}  /* end forcset */
	ShowingPoints = TRUE;
	Consume = FALSE;
} /* end ShowPoints */

LGUnShowPoints()
{
	ELT **eptr;
	POINT *p1;
	int pno;

	forcset(eptr) {
		pno = 0;
		forpoint(p1, (*eptr)->ptlist) {
			GRErasePoint((int)p1->x, (int)p1->y, pno);
			pno++;
		}
	}  /* end while */
	ShowingPoints = FALSE;
} /* end UnShowPoints */

LGText()
/*      This routine implements the text commands.  It first looks
 * for a justification specification (if not specified, default is
 * centering), and then the text string from the input line.  Text
 * justification requires a point upon which the text is positioned.
 */
{
	POINT pos, ppnt, *p1;
	char *text;
	ELT *eptr;

	if (SEQ == 0 && SEQ != 1) {
		error("Text:  specify exactly 1 or 2 points for positioning.");
		return;
	}
	if (*input_buffer == '\0') {
		error("Text:  no text.");
		return;   /* no text */
	}
	DBInitSet();
	GRBlankPoints();
	text = malloc((unsigned)strlen((char*)input_buffer)+1);
	(void) strcpy(text, input_buffer);
	ppnt.x = POINTLIST->x;
	ppnt.y = POINTLIST->y;
	if (SEQ > 1) {
		p1 = PTNextPoint(POINTLIST);
		ppnt.x = (POINTLIST->x + p1->x)/2;
		ppnt.y = (POINTLIST->y + p1->y)/2;
	}
	p1 = PTInit();
	(void) PTMakePoint(ppnt.x, ppnt.y, &p1);
	eptr = DBCreateElt(CJUST, p1, CFONT, CSIZE, text, PICTURE);
	DBAddSet(eptr);
	/* use GRPutText instead of DISScreenAdd to capture the 'pos' return value
	*/
	(void) GRPutText(eptr->type, p1, eptr->brushf, eptr->size, eptr->textpt,
		&pos);
/* extra positioning points */
	(void) PTMakePoint(pos.x, pos.y, &p1);   
	(void) PTMakePoint(pos.x + strlen(text) * charxsize / 2, pos.y, &p1);
	(void) PTMakePoint(pos.x + strlen(text) * charxsize, pos.y, &p1);
	CHANGED = TRUE;
}  /* end LGText */

LGBrush()
/*
 *      This routine sets the current brush to that specified in the
 * parameter.
 */
{
	int newbrush, index;
	char *line;

	line = input_buffer;
	index = 0;
	if (isalpha(*line)) {
		newbrush = LGLookup(line, lines, &index);
		if (newbrush >= 0) newbrush = lnum[newbrush];
		else  newbrush = BADNUM;
	}
	else newbrush = GetNumParm(line, &index);
	if ( (newbrush == BADNUM) || (newbrush > NBRUSHES) || (newbrush<0)) {
		error("brush: bad arguments.");
		return;
	}
	CBRUSH = newbrush;
	ShowIcon(brush_glyphs[CBRUSH], WindowList[WIN_BRUSH], 0);
}  /* end LGBrush */

LGMBrush()
/*
 *      This routine causes the elements in the current set
 * to be redrawn using the new brush.
 */

{
	ELT *(*eptr);
	int new, index;
	char *line;

	line = input_buffer;
	index = 0;
	if (isalpha(*line)) {
		new = LGLookup(line, lines, &index);
		if (new >= 0) new = lnum[new];
		else  new = BADNUM;
	}
	else new = GetNumParm(line, &index);
	if ( (new < 0) || (new > NBRUSHES) )
		new = CBRUSH;
	if (DBNullSet(cset)) {
		error("modify brush: no current set.");
		return;
	}
	forcset(eptr) {
		if (!TEXT((*eptr)->type)) {
			DISScreenErase(*eptr);
			DBChangeBrush(*eptr, new, PICTURE);
			DISScreenAdd(*eptr);
		}  /* end if */
	}  /* end forcset */
	CHANGED = TRUE;
	Consume = FALSE;
} /* end MBrush */

LGMFill()
/*
 *      This routine causes POLYGONS in the current set
 *      to be redrawn using the current fill color.
 */

{
	ELT **eptr;
	int new, index;
	char *line;

	line = input_buffer;
	index = 0;
	new = GetNumParm(line, &index);
	if (new < 0 || new > MAXFILL)
		new = CFILL;
	if (DBNullSet(cset)) {
		error("modify fill color: no current set.");
		return;
	}
	forcset(eptr) {
		if ((*eptr)->type == POLYGON) {
			DISScreenErase(*eptr);
			DBChangeSize(*eptr, new, PICTURE);
			DISScreenAdd(*eptr);
		}  /* end if */
	}  /* end forcset */
	CHANGED = TRUE;
	Consume = FALSE;
} /* end LGMFill */

LGMFont()
/*
 *      This routine causes the text elements in the current set
 * to be redrawn using the new font.
 */

{
	ELT **eptr;
	int new, index;
	char *line;

	line = input_buffer;
	index = 0;
	if (isalpha(*line)) {
		new = LGLookup(line, fonts, &index);
		if (new >= 0) new = fnum[new];
		else  new = BADNUM;
	}
	else new = GetNumParm(line, &index);
	if ( (new <= 0) || (new > NFONTS) )
		new = CFONT;
	if (DBNullSet(cset))
	{
		error("modify font: no current set");
		return;
	}
	forcset(eptr) {
		if (TEXT((*eptr)->type)) {
			DISScreenErase(*eptr);
			DBChangeFont(*eptr, new, (*eptr)->size, PICTURE);
			DISScreenAdd(*eptr);
		}  /* end if */
	}  /* end forcset */
	CHANGED = TRUE;
	Consume = FALSE;
} /* end MFont */

LGMSize()
/*
 *      This routine causes the text elements in the current set
 * to be redrawn using the new size.
 *
 */
{
	POINT *p1, *p2, pos;
	ELT **eptr;
	int new, index, i;
	char *line;

	line = input_buffer;
	index = 0;
	new = GetNumParm(line, &index);
	if ( (new <= 0) || (new > NSIZES) )
		new = CSIZE;
	if (DBNullSet(cset)) {
		error("modify size: no current set");
		return;
	}
	forcset(eptr) {
		if (TEXT((*eptr)->type)) {
			DISScreenErase(*eptr);
			UNRembMod(*eptr, PICTURE);
			(*eptr)->size = new;
			p1 = (*eptr)->ptlist;
			GRPutText((*eptr)->type, p1, (*eptr)->brushf,
				  (*eptr)->size, (*eptr)->textpt, &pos);
			i= strlen((*eptr)->textpt);
			p2 = PTInit();
			(void) PTMakePoint(p1->x, p1->y, &p2);
                   	   /* end extra positioning points */
			(void) PTMakePoint(pos.x, pos.y, &p2);   
			(void) PTMakePoint(pos.x + i * charxsize / 2, 
					   pos.y, &p2);
			(void) PTMakePoint(pos.x + i * charxsize, pos.y, &p2);
			(*eptr)->ptlist = p2;
		}  /* end if */
	}  /* end forcset */
	CHANGED = TRUE;
	Consume = FALSE;
} /* end MSize */


LGMJust()
/*
 *      This routine causes the text elements in the current set
 * to be redrawn using the new justification.
 *
 */

{
	POINT *p1, *p2, pos;
	ELT *(*eptr);
	int new, i;

	new = CJUST;
	if (DBNullSet(cset)) {
		error("modify justification: no current set");
		return;
	}
	forcset(eptr) {
		if (TEXT((*eptr)->type))
		{
			DISScreenErase(*eptr);
			UNRembMod(*eptr, PICTURE);
			(*eptr)->type = new;   /* justification kept in type */
			p1 = (*eptr)->ptlist;
			GRPutText((*eptr)->type, p1, (*eptr)->brushf,
				  (*eptr)->size, (*eptr)->textpt, &pos);
			i= strlen((*eptr)->textpt);
			p2 = PTInit();
			(void) PTMakePoint(p1->x, p1->y, &p2);
                   	   /* end extra positioning points */
			(void) PTMakePoint(pos.x, pos.y, &p2);   
			(void) PTMakePoint(pos.x + i * charxsize / 2, 
					   pos.y, &p2);
			(void) PTMakePoint(pos.x + i * charxsize, pos.y, &p2);
			(*eptr)->ptlist = p2;
		}  /* end if */
	}  /* end while */
	CHANGED = TRUE;
	Consume = FALSE;
} /* end MJust */

LGMText()
/*      This routine allows modification of text by replacing 
 * an existing string with a new one, appropriately repositioned
 */

{
    ELT *(*eptr);
    POINT pos, ppnt, *p1;
    int i;
    char *text;

	i = strlen(input_buffer);
	if(i==0) {
		error("modify text: null text string.");
		return;
	}
	text = malloc((unsigned) i+1);
	(void) strcpy(text,input_buffer);
	forcset(eptr) {
        if (TEXT((*eptr)->type)) {
            DISScreenErase(*eptr);
            UNRembMod(*eptr, PICTURE);
            ppnt.x = (*eptr)->ptlist->x;
            ppnt.y = (*eptr)->ptlist->y;
        
            GRPutText((*eptr)->type, &ppnt, (*eptr)->brushf, (*eptr)->size,
				text, &pos);
            p1 = PTInit();
            (void) PTMakePoint(ppnt.x, ppnt.y, &p1);
                       /* end extra positioning points */
            (void) PTMakePoint(pos.x, pos.y, &p1);   
            (void) PTMakePoint(pos.x + i * charxsize / 2, pos.y, &p1);
            (void) PTMakePoint(pos.x + i * charxsize, pos.y, &p1);
            (*eptr)->textpt = text;
        }  /* end if text */
    }  /* end forcset */
    CHANGED = TRUE;
	Consume = FALSE;
}  /* end LGMText */

/*ARGSUSED*/
LGMPoint(line)
char *line;
/*
 *      This routine modifies the element which contains the point
 * closest to the first of >1 specified points so that that point
 * coincides with the second of the points (if specified).
 *
 *       Note: it implies knowlege of the database representation by modifying
 *           the element directly.
 */
/* ??? the line argument is not used */
{
	ELT *eptr;
	POINT *p1, *p2, *p3, *p4;
	float x1, y1;
	int OldGravityMode;

	if (SEQ == 0) {
		error("Move Point:  no point specified");
		return;
	}
/* find point */
	OldGravityMode = GravityMode;
	GravityMode = POINTGRAVITY;
	eptr = nullelt;
	DBGravitate(POINTLIST->x, POINTLIST->y, &x1, &y1, &p1, &eptr, cset);
	GravityMode = OldGravityMode;
	GRBlankPoints();
	if ( !DBNullelt(eptr) ) {
		if (eptr->type == ARC || TEXT(eptr->type)) {
			error("Can't move or delete points from arc or text");
			return;
		}
		DBClearSet();
		DISScreenErase(eptr);
		UNRembMod(eptr, PICTURE);
		if (SEQ > 1) { /* move a point, not delete */
			p2 = PTNextPoint(POINTLIST);
			p1->x = p2->x;
			p1->y = p2->y;
			p2 = PTNextPoint(p2);
			if (!Nullpoint(p2)) {
				p3 = PTInit();
				while (!Nullpoint(p2)) {
					p4 = PTMakePoint(p2->x, p2->y, &p3);
					p2 = PTNextPoint(p2);
				}
				p4->nextpt = p1->nextpt;
				p1->nextpt = p3;
			}
		} else {
			PTDeletePoint(p1);
		}
		DISScreenAdd(eptr);
		DBAddSet(eptr);
	}  /* if !DBNullelt */
}  /* LGMPoint */

/*ARGSUSED*/
LGLittlePoint(line)
char *line;
/*
 *      This routine controls the size of the point that is displayed
 * The sizes available are artmode in which a small (3 x 3) point is displayed
 * with no number and regular (non- artmode).
 */
 /* ??? the line argument is not used */
{
    char arrowtype[5];
	GRBlankPoints();
	if (artmode) artmode = FALSE;
	else artmode = TRUE;
	GRShowPoints();
	ShowIcon(point_glyphs[artmode], WindowList[WIN_POINT], 0);
	switch (ArrowMode) {
		case ARROWNONE: (void) strcpy(arrowtype, "---"); break;
		case ARROWSTART: (void) strcpy(arrowtype, "<--"); break;
		case ARROWEND: (void) strcpy(arrowtype, "-->"); break;
		case ARROWBOTH: (void) strcpy(arrowtype, "<->"); break;
	}
	XDrawString(MyDisplay, WindowList[WIN_POINT], PointContext, 17,
		27+pointfontdata->ascent, arrowtype, strlen(arrowtype));
	Consume = FALSE;
}  /* LGLittle Point */
