/*
 *  Gremlin for the X window package.  Hacked from the aed gremlin.
 *  
 *  Copyright 1986 Dick Leban, University of Wisconsin Computer Systems Lab
 *  1210 West Dayton, Madison WI, 53706
 *  
 *  Permission is hearby granted to distribute this program provided that:
 *    (*) no commerical advantage is gained
 *    (*) the recipient has a gremlin license
 *    (*) this copyright notice appears on all copies
 *    (*) "On Wisconsin" sung in its entirety while the software
 *        is being copied to the distribution media.
 *  
 *        Here's the words, you'll have to find the tune if you're
 *        an uncultured slug.
 *  
 *           On Wisconsin, On Wisconsin,
 *           Plunge right through that line!
 *           Run the ball clear down the field boys,
 *           Touchdown sure this time (u-rah-rah)
 *           On Wisconsin, On Wisconsin,
 *           Fight on for her fame!
 *           Fight fellows fight-fight-fight 
 *           we'll win this game!
 *  
 *  Copyright -C- 1982 Barry S. Roitblat
 */

#include "gremlin.h"
#include "grem2.h"
#include <ctype.h>
#include "decls.h"
#ifndef lint
	static char *rcsid="$Header: long2.c,v 2.2 88/08/12 13:37:43 solomon Stab $";
#endif lint

#define BADNUM -1
#define NONUM -2
#define Delimiter(c) ((c == '\0') || (c == ' ') || (c == ','))

LGChangeAlign(UpDown)
int UpDown;  /* -1, 0, or 1 */
/*
 *      This routine sets the point alignment indicator
 */
{
    int newalign, index;
    char num[5];

    index = 0;
    newalign = GetNumParm(input_buffer, &index);
    if (newalign == NONUM) {
		newalign = Alignment;
		switch (UpDown) {
			case -1: newalign >>= 1; if (newalign == 0) newalign = 1; break;
			case 0: newalign = CGRID; break;
			case 1: newalign += newalign;
		}
	}
	if ((newalign < 1) || (newalign > pagewindowheight/2) ) {
		error("Align: bad arguments.");
		return;
	}
	Alignment = newalign;
	(void) sprintf(num,"%4d",Alignment);
	ShowIcon(glyphs[WIN_ALIGN], WindowList[WIN_ALIGN], 0);
	XDrawString(MyDisplay, WindowList[WIN_ALIGN], PointContext, 1,
		1+pointfontdata->ascent, num, strlen(num));
    Consume = FALSE;
}  /* end LGChangeAlign */

LGUpAlign()
{
	LGChangeAlign(1);
}

LGDownAlign()
{
	LGChangeAlign(-1);
}

LGSetAlign()
{
	LGChangeAlign(0);
}

LGFill()
/*
 *      This routine sets the current color for polygon fill
 */
{
    int newfill, index;
	char num[3];
 
    index = 0;
	newfill = GetNumParm(input_buffer, &index);
	if (newfill<1 || newfill>MAXFILL) {
		error("Fill must be between 1 and 16.");
		return;
	}
	CFILL = newfill;
	ShowIcon(glyphs[WIN_FILL], WindowList[WIN_FILL], 0);
	XFillRectangle(MyDisplay, WindowList[WIN_FILL], StippleContext[CFILL],
				8, 11, 22, 16);
	(void) sprintf(num,"%2d",CFILL);
	XDrawString(MyDisplay, WindowList[WIN_FILL], PointContext, 10,
		1+pointfontdata->ascent, num, strlen(num));
    Consume = FALSE;
}  /* end LGFill */

LGIncludeSet()
/*
 *      This routine adds all elements selected by points in POINTLIST
 * to the current set.  It does not remove previously selected elements.
 *
 */
{
    POINT *p1, *DummyPointPtr;
    ELT **eptr, *ClosestEltPtr;
    float DummyX, DummyY;
	int OldGravityMode;

    if (DBNullSet(PICTURE)) return;
    if (SEQ == 0) { /* no points: entire picture becomes current set */
		fordb(eptr, PICTURE) {
            DBAddSet(*eptr);
        }
    } else {
		OldGravityMode = GravityMode;
		GravityMode = POINTGRAVITY;
		forpoint(p1, POINTLIST) {
			ClosestEltPtr = nullelt;
            DBGravitate(p1->x, p1->y, &DummyX, &DummyY, &DummyPointPtr,
				&ClosestEltPtr, PICTURE);
            if ( !DBNullelt(ClosestEltPtr) ) {
                DBAddSet(ClosestEltPtr);
            }
        }  /* end forpoint */;
		GravityMode = OldGravityMode;
    }  /* end else */
} /* end LGIncludeSet */


LGPutBuffer()
/*
 *      This routine implements the put buffer command.  The contents of 
 * the specified buffer is copied into the PICTURE transformed
 * to the positioning point.
 */

{

    ELT **buffeltptr, *eptr;
    POINT *plist;
    int symbol, index;
    float xmat[3][2];

    index = 0;
	if((symbol=GetNumParm(input_buffer,&index))<0)
		symbol = CBUF;
    if ( (symbol <= 0) || (symbol > NUSER) ) {
        error("Get Buffer: no buffer specified.");
        return;
    }
	GRBlankPoints();
	if (SEQ == 0) { /* no positioning point; assume 0, 0 */
		(void) PTMakePoint(0.0, 0.0, &POINTLIST);
	}
	if (CSETPOINTS) DoBlink(FALSE); /* remove stipple from old current set */
	halftone = FALSE; /* will restore after all copies but one in */
    symbol--;     /* users inputs number between 1 and N, actual
                     symbol number is between 0 and N-1          */
    xmat[0][0] = xmat[1][1] = 1;    /* create transformation matrix */
    xmat[0][1] = xmat[1][0] = 0;    /* for copy into PICTURE        */
	forpoint(plist, POINTLIST) {
        DBClearSet();
		if (Nullpoint(PTNextPoint(plist))) halftone = CSETPOINTS;
        xmat[2][0] = plist->x - (MENPOINT[symbol]).x;
        xmat[2][1] = plist->y - (MENPOINT[symbol]).y;
		fordb(buffeltptr, MEN[symbol]) { /* copy buffer to picture */
            eptr = DBCopy(*buffeltptr, xmat, PICTURE);
            DBAddSet(eptr);
            DISScreenAdd(eptr);
        }  /* end fordb */
    }  /* end forpoint */
	if (SEQ == 0) POINTLIST = PTInit();
    CHANGED = TRUE;
}  /* end LGPutBuffer */

LGRead()
/*
 *      This routine reads in the specified filename (command line) to the
 * selected user symbol or current set if no user symbol is selected.  If
 * no filename is specified, the current set is copied to the user symbol;
 */

{
    POINT pos, ppos;
	ELT *TmpPicture[MAXELTS], **tmpeptr;
    ELT *eptr;
    float xmat[3][2];
    int orient;

    if ( input_buffer[0] == '\0' ) { /* no arguments */
        error("Read: no filename specified.");
        return;
    }
	GRBlankPoints();
	if (CSETPOINTS) DoBlink(FALSE); /* remove stipple from old current set */
	halftone = CSETPOINTS;
    DBRead(&input_buffer[0], &orient, &pos, TmpPicture); /* read file */
    UNForget();     /* forget changes registered by DBRead */
    if (SEQ == 0) {  /* no positioning point */
        ppos.x = pos.x;
        ppos.y = pos.y;
    } else {
        ppos.x = POINTLIST->x;
        ppos.y = POINTLIST->y;
    }
    xmat[0][0] = xmat[1][1] = 1;   /* set up matrix to copy to */
    xmat[0][1] = xmat[1][0] = 0;   /* appropriate place in     */
    xmat[2][0] = ppos.x - pos.x;   /* picture as current set   */
    xmat[2][1] = ppos.y - pos.y;
    DBClearSet();
	fordb(tmpeptr, TmpPicture) {
        eptr = DBCopy(*tmpeptr, xmat, PICTURE);
        DISScreenAdd(eptr);
        DBAddSet(eptr);
        DBClearElt(*tmpeptr);
    }
    CHANGED = TRUE;
}  /* end LGRead */

LGEdit()
/*
 * This routine reads in a new PICTURE for editing
 */
{
    FILE *fp, *POpen();
    POINT pos;
    ELT **eptr;
    char tname[50]; 
    int i;

    if (!bang) { /* no ! */
        if (CHANGED) {
            error("Edit:  no write");
            return;
        }
    }  /* end if !bang */;
    DBClearSet();
	fordb(eptr, PICTURE) { /* clear current PICTURE */
        DBClearElt(*eptr);
    };
    (void) sscanf(input_buffer, "%s", tname);
    POINTLIST = PTInit();   /* Initialize globals */
    SEQ = 0;
    CHANGED = FALSE;
    i = strlen(tname);
    if (i > 0) { /* filename present */
        fp = POpen(tname, (char **) NULL, SEARCH);
        if (fp == NULL) {
            error(" (creating new file)");
			DBInit(PICTURE);
        } else {
            DBRead(tname, &Orientation, &pos, PICTURE);
			(void) fclose(fp);
        }
        (void) strcpy (Editfile, tname);
    } else { /* no filename present */
        (void) strcpy(Editfile, "");
    }
    unlist = unback = nullun;
    CP();
    SHUpdate();      /* display new picture */
	RedrawText();
}  /* LGEdit */

static restorepoints()
/* This routine (re) displays the points in the back-up pointlist
 */
{
    int i;
    POINT *plist, *pl1;

    GRBlankPoints();
    plist = BACKPOINT;
    for (i=0; !Nullpoint(plist); ++i) {
        Lastx = plist->x;
        Lasty = plist->y;
        GRDisplayPoint( (int) plist->x, (int) plist->y, i, pointstyle );
        plist = PTNextPoint(plist);
    }
    pl1 = POINTLIST;
    POINTLIST = BACKPOINT;
    SEQ = i;
    BACKPOINT = pl1;
}  /* end restorepoints */


LGUndo()
/* 
 *      This routine uses the information in the undo database to reconstruct
 * the PICTURE as it was before the last command.  The undo database is set
 * so that the next undo would nullify this one.
 * An undo of an Add is to delete the new element.
 * Add the old element back to undo a delete.
 * Modified elements are undone by copying the old element into the database
 * in place of the modified element.
 */

{
    UNELT *fix, *temp;
    ELT *oldcset[MAXELTS];
	int index;

    fix = unlist;       /* initialize unlist so that undo-ing can   */
    unlist = nullun;    /* add items to properly undo the undo      */
    if (fix == nullun) {
        fix = unback;
        unback = nullun;
    }
	DBCopySet(cset, oldcset);
	DBClearSet();         /* Clear current set in preparation */ 
    while (fix != nullun) {
        switch (fix->action) {
            case ADD: if (DBInSet(fix->newelt, oldcset)) halftone = CSETPOINTS;
					  else halftone = FALSE;
					  DISScreenErase(fix->newelt /* , linemask */ );
                      DBDelete(fix->newelt, fix->dbase);
                      temp = fix->nextun;
                      free((char *) fix);
                      fix = temp;
					  halftone = CSETPOINTS;
                      break;
         case DELETE: fix->action = ADD;   /* create undo unelt */
                      fix->newelt = fix->oldelt;
                      fix->oldelt = NULL;
					  if (CSETPOINTS && (fix->nextun == nullun))
						halftone = TRUE;
					  else
						halftone = FALSE;
					  DBClearSet(); /* the one we put in now becomes current */
                      DBAddSet(fix->newelt);
                      DISScreenAdd(fix->newelt /* ,(linemask|setmask) */ );
					  dbend(PICTURE, index);
					  PICTURE[index++] = fix->newelt;    /* put in database */
					  PICTURE[index] = nullelt;
                      temp = fix->nextun;
                      fix->nextun = unlist;     /* link into unlist */
                      unlist = fix;
                      fix = temp;
                      break;
            case MOD: DISScreenErase(fix->newelt /* , linemask */ );
                      DISScreenAdd(fix->oldelt /* , (setmask | linemask) */ );
                      DBAddSet(fix->oldelt);
					  /* replace fix->newelt by fix->oldelt in fix->dbase */
						  fordbindex(index, fix->dbase)
							if (fix->dbase[index] == fix->newelt) break;
						  fix->dbase[index] = fix->oldelt;
					  /* create undo elt */
						  fix->newelt = fix->oldelt;
						  temp = fix->nextun;
						  fix->nextun = unlist;
						  unlist = fix;     /* link into unlist */
						  fix = temp;
                      break;
        }  /* end switch */;
    }  /* end while */
    restorepoints();
    Consume = FALSE;
}  /* LGUndo */

LGWrite()
{
	LGOutput(PICTURE);
}

LGSave()
{
	LGOutput(cset);
}

LGOutput(db)
ELT *db[];
/* Write the db (either cset or PICTURE) into the specified filename or to the
current Editfile */
{
    FILE *fp, *fopen();
    char tname[50], filename[100], string[100], *tn, *fn, *wfile;
    ELT **eptr;
    POINT *plist, pos;
    int i, space, stat;
	char *dbstring = db==cset ? "Write current set" : "Write file";
 
	if (SEQ > 1) {
		(void) sprintf(string, "Write %s: at most 1 positioning point.",
			db==cset ? "current set" : "file" );
		error(string);
		return;
	}
    space = 100;
    tn = tname;  fn = filename;
    (void) strcpy(tname, input_buffer);
    i = strlen(tname);
    if (i == 0) { /* no filename */
        if (db == cset || *Editfile == '\0' ) {
			(void) sprintf(string, "%s: to where?", dbstring);
            error(string);
            return;
        }
        fp = fopen(Editfile, "w");
        wfile = Editfile;
    } else { /* file name present */
		stat = PConvertTilde(&tn, &fn, &space);
		*fn = '\0';
		if (stat == FALSE) {
			(void) sprintf(string, "%s: unknown path %s", dbstring, tname);
			error(string);
			return;
		}
		if ( !bang ) { /* user doesn't insist */
			fp = fopen(filename, "r");
			if ( fp != NULL ) {
				(void) sprintf(string, "%s: file already exists", dbstring);
				 return;
			}
		}
		fp = fopen(filename, "w");
		wfile = filename;
	}; /* file name present */
	if (fp == NULL) { /* file error */
		(void) sprintf(string, "%s:  can't open %s", dbstring, wfile);
		error(string);
		return;
	};
	(void) sprintf(string, "%s: writing '%s'...", dbstring, wfile);
	message(string);
	XSync(MyDisplay, 0);
	CHANGED = FALSE;
	if (SEQ == 1) { /* specified a positioning point */
		pos.x = POINTLIST->x;
		pos.y = POINTLIST->y;
	} else if ( !DBNullSet(db) ) { /* use the first element's position */
		pos.x = db[0]->ptlist->x;
		pos.y = db[0]->ptlist->y;
	} else if ( !DBNullSet(PICTURE) ) { /* use the first element's position */
		pos.x = PICTURE[0]->ptlist->x;
		pos.y = PICTURE[0]->ptlist->y;
	} else { /* use 0, 0; no points */
		pos.x = pos.y = 0;
	} /* no positioning point */
	fprintf(fp,"gremlinfile\n");    /* write header */
	fprintf(fp, "%d %g %g\n", Orientation, pos.x, pos.y);
	fordb(eptr, db) { /* write each element */
		fprintf(fp, "%d\n", (*eptr)->type);
		forpoint(plist, (*eptr)->ptlist) { /* write each point */
			fprintf(fp, "%g %g\n",plist->x, DEFAULTFLIP-plist->y);
		}  /* end forpoint */
		fprintf(fp, "%d %d\n", -1, -1);  /* end pointlist */ 
		fprintf(fp, "%d %d\n",(*eptr)->brushf, (*eptr)->size);
		fprintf(fp,"%d %s\n ", strlen((*eptr)->textpt), (*eptr)->textpt);
	}  /* end fordb */
	fprintf(fp,"%d\n",-1);   /* end of element list */
	(void) sprintf(string, "%s, done writing '%s'.", dbstring, wfile);
	message(string);
	(void) fclose(fp);
}  /* end LGOutput */;

LGQuit()
/*
 *      This routine terminates the editor.  The terminal states for the text
 * terminal and the graphics display are restored and an EXIT is performed.
 */

{
    if (!bang) {
        if (CHANGED) {
            error("Quit:  no write");
            return;
        }
    }  /* end if */;
    GRClose();
    exit(0);
}  /* end LGQuit */

ShowAdjust()
{
	ShowIcon(adjust_glyphs[Adjustment], WindowList[WIN_ADJUST], 0);
} /* ShowAdjust */

LGHAdjust()
/*
 * Horizontal adjust -
 */
{
	Adjustment = HORZ;
    Consume = FALSE;
	ShowAdjust();
}

LGVAdjust()
/*
 * Vertical adjust -
 */
{
	Adjustment = VERT;
    Consume = FALSE;
	ShowAdjust();
}

LGMAdjust()
/*
 * Manhattan Adjust -
 */
{
	Adjustment = MAN;
	Consume = FALSE;
	ShowAdjust();
}

static sign(x)
float x;
/*
 *      This local routine returns 1 if x >= 0
 * otherwise returns 0;
 */

{
    if (x >= 0) return(1);
    else  return(0);
}

LGMirror(){
	LGDoMirror(0);
}

LGMirrorCopy(){
	LGDoMirror(1);
}

LGDoMirror(Copy)
int Copy; /* 0 if no copy to be made; 1 if copy to be made */
/*
 *      This routine mirrors the elements in the current set as defined
 * by points.  The mirroring is accomplished by defining a transformation
 * matrix and calling DBXform.
 */
{
    ELT **eptr;
	ELT *TmpSet[MAXELTS];
    POINT pt, pos, *p1, *p2;
    float xmat[3][2], ident[3][2], scalex, scaley;
    int i;
/* error checking */
    if (SEQ != 3) {
        error("Mirror:  need three points");
        return;
    }
    if (DBNullSet(cset)) {
        error("Mirror:  no current set");
        return;
    }
/* transforms */
	ident[0][0] = ident[1][1] = 1.0;
	ident[0][1] = ident[1][0] = ident[2][0] = ident[2][1] = 0.0;
    p1 = PTNextPoint(POINTLIST);
    p2 = PTNextPoint(p1);
    scalex = scaley = 1;
    if (sign(p1->x - POINTLIST->x) != sign(p2->x - POINTLIST->x))
        scalex = -scalex;
    if (sign(p1->y - POINTLIST->y) != sign(p2->y - POINTLIST->y))
        scaley = -scaley;
	/* create transformation matrix to translate set to origin, 
	   performing the mirroring and translating back               */
    xmat[0][0] = scalex;
    xmat[1][1] = scaley;
    xmat[1][0] = xmat[0][1] = 0;
    xmat[2][0] = - POINTLIST->x * (scalex - 1.0);
    xmat[2][1] = - POINTLIST->y * (scaley - 1.0);
/* display */
	GRBlankPoints();
	DBCopySet(cset, TmpSet);
	DBInitSet(); /* will be making a new current set */
	fordb(eptr, TmpSet) {
		if (Copy) { /* make a copy before changing */
			(void) DBCopy(*eptr, ident, PICTURE);
		} else {
			halftone = FALSE;
			DISScreenErase(*eptr);
			halftone = CSETPOINTS;
		}
		DBXform(*eptr, xmat, PICTURE);
        if (TEXT((*eptr)->type)) {
            p1 = (*eptr)->ptlist;
            GRPutText((*eptr)->type, p1, (*eptr)->brushf, (*eptr)->size,
				(*eptr)->textpt, &pos);
            i= strlen((*eptr)->textpt);
            p2 = PTInit();
            (void) PTMakePoint(p1->x, p1->y, &p2);
                       /* add extra positioning points */
            (void) PTMakePoint(pos.x, pos.y, &p2);   
            (void) PTMakePoint(pos.x + i * charxsize / 2, pos.y, &p2);
            (void) PTMakePoint(pos.x + i * charxsize, pos.y, &p2);
            (*eptr)->ptlist = p2;
        }  else { /* not text */
            if ((*eptr)->type == ARC)   /* arcs require special handling */
                if ((*eptr)->size > 0)   /* circles are OK */
                    if (scalex * scaley < 0) { /* both directions OK */
                    	/* swap starting and ending points of arc */
                        p1 = PTNextPoint((*eptr)->ptlist);
                        p2 = PTNextPoint(p1);
                        pt.x = p1->x;
                        pt.y = p1->y;
                        p1->x = p2->x;
                        p1->y = p2->y;
                        p2->x = pt.x;
                        p2->y = pt.y;
                    }
            DISScreenAdd(*eptr);
        }  /* not text */
		DBAddSet(*eptr);
    }  /* end fordb */
    CHANGED = TRUE;
}  /* end LGDoMirror */

LGPath()
/*
 *      This routine looks at the command line for parameters to set
 * the current search path.
 */
{
    char path[100];
	char *line;

	line = input_buffer;
    if ( *line == '\0' ) 	/* no arguments */
		error("Path:  no argument.");
    else {
		SEARCH = TRUE;
		(void) sscanf(line, "%s", path);
		if (PSetPath(path) < 0) error("Can't set up path.");
    }
    Consume = FALSE;
}  /* end LGPath */

LGPrintPath()
{
	TextPut(path);
}

LGFont()
/*
 *      This routine looks at the command line for parameters to set
 * the current Font.
 */
{
    int new, index;
    char *line;
 
    Consume = FALSE;
	line = input_buffer;
    index = 0;
    if (isalpha(*line)) {
        new = LGLookup(line, fonts, &index);
        if ( new >= 0) new = fnum[new];
        else new = BADNUM;
    } else
		new = GetNumParm(line, &index);
    if ( new > NFONTS|| new <= 0) {
        error("Font: bad argument.");
        return;
    }
	CFONT = new;
	ShowIcon(font_glyphs[CFONT], WindowList[WIN_FONT], 0);
}  /* end LGFont */

LGJust()
/*
 *      This routine looks at the command line for parameters to set
 * the current text justification mode.
 */
{
    int new, index;
	char *line;
#ifndef tolower
#	define tolower(c) ((c)-'A'+'a') /* no need for library routine on Ultrix */
#endif
 
	line = input_buffer;
    Consume = FALSE;
    index = 0;
    if (isalpha(*line)) { /* make sure mode is in lower case; find in table */
        if (isupper(*line)) {
            *line = tolower(*line);
            *(line+1) = tolower(*(line+1));
        }
        for (new = 0; (strcmp(line, textpos[new]) != 0); ++new)
            if (new > jmodes) {
               error("Justify: no such mode");
               return;
            }
    }
    else
		new = GetNumParm(line, &index) - 1;
    if ( (new < 0) || (new > jmodes) ) {
        error("Justify: bad arguments.");
        return;
    }
	new = textmode[new];
	CJUST = new;
	ShowIcon(just_glyphs[CJUST], WindowList[WIN_JUSTIFY], 0);
}  /* end LGJust */

LGSize()
/*
 *      This routine changes the current character size.
 */
{
    int new, index;
    char *line;

	line = input_buffer;
    index = 0;
    new = GetNumParm(line, &index);
    if ( new <= 0 || new > NSIZES ) {
        error("Size: bad arguments.");
        return;
    }    
	CSIZE = new;
	ShowIcon(size_glyphs[CSIZE], WindowList[WIN_SIZE], 0);
    Consume = FALSE;
}  /* end LGSize */

LGCSetPoints()
{
	if(CSETPOINTS) {
		ShowIcon(glyphs[WIN_CSET], WindowList[WIN_CSET], 0);
		CSETPOINTS = 0;
	} else {
		ShowIcon(glyphs[WIN_CSET], WindowList[WIN_CSET], 1);
		CSETPOINTS = 1;
	}
	DoBlink(CSETPOINTS);
	Consume = FALSE;
}

LGDrawPolygon()
{
	LGDoDrawPolygon(0);
}

LGDrawBPolygon()
{
	LGDoDrawPolygon(1);
}

LGDoDrawPolygon(border)
int border; /* 0 means none; 1 means present */
{
	ELT *eptr;
	char *txt;
	POINT *p1, *p2, *plist;
 
	if (SEQ < 3) { /* not enough points */
		error("Polygon: need at least 3 points");
		return;
	}
	GRBlankPoints();
	DBInitSet();
	plist = PTInit();
	p1 = POINTLIST;
	(void) PTMakePoint(p1->x, p1->y, &plist);
	p2 = PTNextPoint(p1);
	while ( !Nullpoint(p2) ) {
		(void) PTMakePoint(p2->x, p2->y, &plist);
		p1 = p2;
		p2 = PTNextPoint(p1);
	}  /* end while */;
	if (border && (p1->x != POINTLIST->x || p1->y != POINTLIST->y)) {
		/* not closed, but border should be */
		(void) PTMakePoint(POINTLIST->x, POINTLIST->y, &plist);
	}
	txt = malloc(1);
	*txt = '\0';
	eptr = DBCreateElt(POLYGON, plist, border ? CBRUSH : 0, CFILL, txt,
		PICTURE);
	DBAddSet(eptr);
	DISScreenAdd(eptr);
	CHANGED = TRUE;
}  /* LGDoDrawPolygon */
