/*
 *  Gremlin for the X window package.  Hacked from the aed gremlin.
 *  
 *  Copyright 1986 Dick Leban, University of Wisconsin Computer Systems Lab
 *  1210 West Dayton, Madison WI, 53706
 *  
 *  Permission is hearby granted to distribute this program provided that:
 *    (*) no commerical advantage is gained
 *    (*) the recipient has a gremlin license
 *    (*) this copyright notice appears on all copies
 *    (*) "On Wisconsin" sung in its entirety while the software
 *        is being copied to the distribution media.
 *  
 *        Here's the words, you'll have to find the tune if you're
 *        an uncultured slug.
 *  
 *           On Wisconsin, On Wisconsin,
 *           Plunge right through that line!
 *           Run the ball clear down the field boys,
 *           Touchdown sure this time (u-rah-rah)
 *           On Wisconsin, On Wisconsin,
 *           Fight on for her fame!
 *           Fight fellows fight-fight-fight 
 *           we'll win this game!
 *  
 *  Copyright -C- 1982 Barry S. Roitblat
 */

#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/param.h>
#include <sys/ioctl.h>
#include "gremlin.h"
#include "grem2.h"
#include "decls.h"
#ifndef lint
	static char *rcsid="$Header: main.c,v 2.2 88/08/12 13:37:48 solomon Stab $";
#endif lint

/*
 *  jump tables
 */

int (*last_function)();
int (*jump_left[NUM_WINDOWS])() =
{
	LGClearPoints,
	SHDrawVector,
	SHCurveToFromVector,
	SHDrawCurve,
	SHBox,
	SHDrawArc,
	SHArrow,
	LGText,
	XUpBrush,
	XUpFont,
	XUpSize,
	XUpJust,
	XUpAdjust,
	LGUpAlign,
	SHUpGravity,
	XUpFill,
	SHGrid,
	LGLittlePoint,
	LGCSetPoints,
	SHDefineSet,
	SHSetArea,
	SHErase,
	SHTranslate,
	SHCopy,
	LGMPoint,
	SHScale,
	SHRotate,
	LGMirror,
	LGPath,
	XBang,
	LGEdit,
	LGWrite,
	XUpBuffer,
	SHUpdate,
	LGUndo,
	XHelp,
	LGReorderStart,
	LGQuit,
	LGPoint,
	unimplemented,
};

int (*jump_middle[NUM_WINDOWS])() = {
	unimplemented,
	LGDrawBPolygon,
	SHBorderedToFromUnbordered,
	unimplemented,
	SHFillBox,
	SHDrawEllipse,
	SHFillArrow,
	LGMText,
	LGMBrush,
	LGMFont,
	LGMSize,
	LGMJust,
	unimplemented,
	LGSetAlign,
	unimplemented,
	LGMFill,
	XChangeGrid,
	unimplemented,
	unimplemented,
	SHIncludeSet,
	unimplemented,
	unimplemented,
	LGCenter,
	unimplemented,
	unimplemented,
	SHXScale,
	SHRotateCopy,
	LGMirrorCopy,
	LGPrintPath,
	unimplemented,
	LGPutBuffer,
	LGBackup,
	LGGetBuffer,
	unimplemented,
	unimplemented,
	unimplemented,
	unimplemented,
	unimplemented,
	LGDeletePoint,
	unimplemented
};

int (*jump_right[NUM_WINDOWS])() = {
	unimplemented,
	LGDrawPolygon,
	SHFilledToFromUnfilled,
	unimplemented,
	SHFillOnlyBox,
	unimplemented,
	LGNewArrow,
	unimplemented,
	XDownBrush,
	XDownFont,
	XDownSize,
	XDownJust,
	XDownAdjust,
	LGDownAlign,
	unimplemented,
	XDownFill,
	unimplemented,
	LGChangeArrowMode,
	unimplemented,
	unimplemented,
	unimplemented,
	unimplemented,
	unimplemented,
	LGMultiCopy,
	unimplemented,
	SHYScale,
	unimplemented,
	unimplemented,
	unimplemented,
	unimplemented,
	LGRead,
	LGSave,
	XDownBuffer,
	unimplemented,
	unimplemented,
	unimplemented,
	LGReorderEnd,
	unimplemented,
	unimplemented,
	unimplemented,
};


/* globals */

Window Root;
Display *MyDisplay;
GC BrushContext[1+2*NBRUSHES], GlyphContext, RevGlyphContext, PointContext,
	TextContext, HelpContext, PutTextContext, PutTextHighlightContext;
char erasechar, killchar;
char *Editfile;
int masked, window_num;
int pagewindowheight, pagewindowwidth;
int ReverseVideo;

ELT *PICTURE[MAXELTS];
ELT *cset[MAXELTS];
ELT *oldcset[MAXELTS];
ELT arhead;
ELT *nullelt = (ELT *) -1;
int CBRUSH, CFONT, CSIZE, CJUST, CBUF, CGRID, CFILL, Gridon, Orientation; 
int Alignment, SEQ, Adjustment, GravityMode, Consume, CHANGED, csetoff;
int TextMode, CSETPOINTS = 0;
float PX, PY, Lastx, Lasty;
POINT *POINTLIST, *BACKPOINT, MENPOINT[NUSER];
ELT *MEN[NUSER][MAXELTS];
char cmdbuf[400];
int SEARCH = TRUE;
int jmodes = 8;

char *textpos[] = {"bl", "bc", "br", "cl", "cc", "cr", "tl", "tc", "tr",
                   "lb", "cb", "rb", "lc",       "rc", "lt", "ct", "rt" };
int textmode[] = { 0, 15, 1, 13, 2, 14, 10, 11, 12, 
                   0, 15, 1, 13,    14, 10, 11, 12 };

/* symbolic types, brushes, etc. */

char *lines[] = { "broken", "dashed", "dotted", 
                  "medium", "narrow", "thick", NULL };
int lnum[] = { 2, 4, 1, 6, 5, 3 };
char types[] = { 'l', 'r', 'c', 'v', 'a', 'u', '\0' };
char *fonts[] = { "Bold", "Italics", "Roman", "Special",
                  "bold", "italics", "roman", "special", NULL };
int fnum[] = { 3, 2, 1, 4, 3, 2, 1, 4 };

XEvent event;

error(s)
char *s;
/*
 *      This routine prints an error message and sets the Consume flag
 * so that points are not cleared.
 */
{
    XBell(MyDisplay, 0);
	TextPut(s);
    Consume = FALSE;
}

message(s)
char *s;
/*
 *      This routine prints an informational message.
 */
{
	TextPut(s);
}

main(argc, argv)
int argc;
char *argv[];
{
    FILE *fp, *POpen(), *fopen(), *startup;
    POINT *p1, pos;
    int i;
    char *file = (char *) 0;
    char *ptr, *getenv(), home[100];
    char *path = ".";
	Window WhichWindow;
	int arg;
	extern int _Xdebug;

	ReverseVideo = FALSE;
	displaystr = "";
 	for (arg=1; arg<argc && argv[arg][0]=='-'; arg++) {
 		switch(argv[arg][1]) {
 			case 'd':
				if(strcmp(argv[arg], "-display") == 0) {
					arg++;
					if(arg == argc) goto usage;
					displaystr = argv[arg];
				} else {
					_Xdebug = 1;
					setbuf(stdout,(char *)0);
				}
 				break;
			case 'g':
				arg++;
				if(arg == argc) goto usage;
				if(arg < argc) {
					geometry = argv[arg];
					break;
				}
			case 'r':
				ReverseVideo = TRUE;
				break;
 			default: goto usage;
 		}
 	}
 	if (arg < argc-1) {
 	usage:
 		fprintf(stderr,"usage: %s [-d] [-r] [file]\n",argv[0]);
		fprintf(stderr,"	-d for debugging (synch output)\n");
		fprintf(stderr,"	-r for reverse video (black on white)\n");
 		exit(1);
 	}
 	if (arg == argc-1)
 		file = argv[arg];
    if (PSetPath(path) < 0) {
		fprintf(stderr, "Can't establish path\n");
		exit(3);
	}
	/* signal(SIGINT, SIG_IGN); */
	(void) signal(SIGTSTP, (void *)OnStop);
	(void) signal(SIGTTIN, (void *)OnStop);
	(void) signal(SIGTTOU, (void *)OnStop);
    CBRUSH = 5;
    CFONT = 1;
    CSIZE = 1;
    CJUST = 0;
	CBUF = 0;
	CGRID = 16;
	CFILL = MAXFILL;
	csetoff = 0;
	last_function = unimplemented;
    Gridon = FALSE;
    Adjustment = NOADJ;
	TextMode = 0;
    Alignment = 1;
    artmode = FALSE;
    SEQ = 0;
    GravityMode = NOGRAVITY;
	ArrowMode = ARROWNONE;
    CHANGED = FALSE;
    POINTLIST = PTInit();
    BACKPOINT = PTInit();
    unlist = unback = nullun;
    p1 = PTInit();       /* initialize arrowhead template */
    (void) PTMakePoint(0.0, 0.0, &p1);
    (void) PTMakePoint(-5.0, 3.0, &p1);
    (void) PTMakePoint(-3.0, 0.0, &p1);
    (void) PTMakePoint(-5.0, -3.0, &p1);
    (void) PTMakePoint(0.0, 0.0, &p1);
    arhead.type = VECTOR;
    arhead.ptlist = p1;
    arhead.brushf = 0;   /* brush filled in when used */
    arhead.size = 0;
    arhead.textpt = malloc(1);
    *(arhead.textpt) = '\0';

	XInit(argc,argv);

    DBInit(PICTURE);    /* initialize picture databse */
    DBInit(cset);       /* and current set   */
    for (i=0; i<NUSER; ++i)    /* and user symbols  */
        DBInit(MEN[i]);
    unlist = unback = nullun;
/* read start-up file; look in home directory */
    (void) sprintf(home,"%s/.gremlinrc",getenv("HOME"));
    startup = fopen(home, "r");
    if (startup != NULL) {
        ptr = fgets(cmdbuf, 400, startup);
        while (ptr != NULL) {
            for (i=0; (cmdbuf[i] != '\n'); ++i) 
                if (i > 399) break;
            cmdbuf[i] = '\0';    /* remove trailing carriage return */
            if (cmdbuf[0] == ':') LGCommand(&(cmdbuf[1]));
            else SHCommand(&(cmdbuf[0]));
            ptr = fgets(cmdbuf, 400, startup);
        }  /* end while */
    }  /* end if startup */
/* look in current directory for start-up file, too */
    startup = fopen(".gremlinrc", "r");
    if (startup != NULL) {
		char junk[MAXPATHLEN];
		if (strcmp(getenv("HOME"),getcwd(junk, MAXPATHLEN))!=0) {
			/* same as before */
            ptr = fgets(cmdbuf, 400, startup);
            while (ptr != NULL) {
                for (i=0; (cmdbuf[i] != '\n'); ++i) 
                    if (i > 399) break;
                cmdbuf[i] = '\0';    /* remove trailing carriage return */
                if (cmdbuf[0] == ':') LGCommand(&(cmdbuf[1]));
                else SHCommand(&(cmdbuf[0]));
                ptr = fgets(cmdbuf, 400, startup);
            }  /* end while */
        }  /* end if cwd is home */
    }  /* end if startup */
	
    Editfile = malloc(100);
    if (file == NULL)
        *Editfile = '\0';
    else {
        (void) strcpy(Editfile, file);
        fp = POpen(Editfile, (char **) NULL, SEARCH);
        if (fp == NULL)  error("(creating new file)");
        else DBRead(Editfile,&Orientation, &pos, PICTURE);
    }
    {   /* find default erase, kill character */
#if defined(TIOCGETP) && !defined(__sgi__) && !defined(__linux__)
        struct sgttyb buf;
        if (ioctl(0, TIOCGETP, (char *) &buf) == 0) {
            erasechar = buf.sg_erase;
            killchar = buf.sg_kill;
        } else {
#else
	{
#endif
            erasechar = 128; /* out of range */
            killchar = 128; /* out of range */
        }
    }
	input_buffer[0] = '\0';
	
	while ( TRUE ) { /* Exits through the 'quit' command */
        Consume = TRUE;
        UNForget();
		/* if (CSETPOINTS) DoBlink(1); */
		XFlush(MyDisplay);
		XNextEvent(MyDisplay, &event);
		WhichWindow = event.xkey.window;
		for(window_num=0;window_num<NUM_WINDOWS;window_num++) {
			if (WhichWindow == WindowList[window_num]) goto gotit;
		}
		/* must have been for the Base or Help Window */
		if(event.type == Expose && WhichWindow == Root) {
			XRedrawBaseWin();
			continue;
		}
		fprintf(stderr,"gremlin internal error--bad window id.\n");
		break;
gotit:
		if (event.type == Expose) {
			if (event.xexpose.count == 0) switch(window_num) {
				/* special cases for icons that may change over time */
				case WIN_BRUSH:
					ShowIcon(brush_glyphs[CBRUSH], WhichWindow, 0);
					break;
				case WIN_FILL:
					{
						char num[3];

						ShowIcon(glyphs[window_num], WhichWindow, 0);
						XFillRectangle(MyDisplay, WindowList[WIN_FILL],
							StippleContext[CFILL], 8, 11, 22, 16);
						(void) sprintf(num, "%2d", CFILL);
						XDrawString(MyDisplay, WhichWindow, PointContext, 10,
							1+pointfontdata->ascent, num, strlen(num));
						break;
					}
				case WIN_FONT:
					ShowIcon(font_glyphs[CFONT], WhichWindow, 0);
					break;
				case WIN_JUSTIFY: /* justification */
					ShowIcon(just_glyphs[CJUST], WhichWindow, 0);
					break;
				case WIN_SIZE: /* font size */
					ShowIcon(size_glyphs[CSIZE], WhichWindow, 0);
					break;
				case WIN_ADJUST:
					ShowIcon(adjust_glyphs[Adjustment], WhichWindow, 0);
					break;
				case WIN_GRID:
					{	char num[5];
						(void) sprintf(num,"%4d",CGRID);
						ShowIcon(glyphs[window_num], WhichWindow, 0);
						XDrawString(MyDisplay, WhichWindow, PointContext, 1,
							1+pointfontdata->ascent, num, strlen(num));
						break;
					}
				case WIN_ALIGN:
					{	char num[5];
						(void) sprintf(num,"%4d",Alignment);
						ShowIcon(glyphs[window_num], WhichWindow, 0);
						XDrawString(MyDisplay, WhichWindow, PointContext, 1,
							1+pointfontdata->ascent, num, strlen(num));
						break;
					}
				case WIN_BUFFER:
					ShowIcon(buffer_glyphs[CBUF], WhichWindow, 0);
					break;
				case WIN_POINT: /* point type */
					{	char arrowtype[5];
						ShowIcon(point_glyphs[artmode], WhichWindow, 0);
						switch (ArrowMode) {
							case ARROWNONE:
								(void) strcpy(arrowtype, "---"); break;
							case ARROWSTART:
								(void) strcpy(arrowtype, "<--"); break;
							case ARROWEND:
								(void) strcpy(arrowtype, "-->"); break;
							case ARROWBOTH:
								(void) strcpy(arrowtype, "<->"); break;
						}
						XDrawString(MyDisplay, WhichWindow, PointContext, 17,
							27+pointfontdata->ascent, arrowtype,
							strlen(arrowtype));
						break;
					}
				case WIN_GRAVITY: /* gravity window */
					GravityMode--; /* prime the pump */
					SHUpGravity();
					break;
				case WIN_DRAW: /* main graphics window */
					SHUpdate();
					if (ShowingPoints) LGShowPoints();
					break;
				case WIN_TEXT: /* text region */
					RedrawText();
					break;
				default: /* normal windows */
					{	int reverse =
							(window_num==WIN_CSET && CSETPOINTS) ||
							(window_num==WIN_BANG && bang);
						ShowIcon(glyphs[window_num], WhichWindow, reverse);
					}
				} /* switch */
			} else /* not expose event */ {
			if (ERRVISIBLE) TextPut(""); /* clear message line */
			if (event.type == KeyPress) {
				int bcount;
				char input;
				
				event.xkey.state &= ~LockMask; /* turn off lock bit */
				bcount = XLookupString((XKeyEvent*)&event, &input, 1, 0, 0);
				if (bcount == 1) InputText(input);
			} else if (event.type == ButtonPress) {
				XButtonEvent *ButEvPtr = &event.xbutton;
				PX = ButEvPtr->x;
				PY = ButEvPtr->y;
				/* if (window_num!=WIN_DRAW && CSETPOINTS) DoBlink(0); */
				if (ShowingPoints) LGUnShowPoints();
				if (ButEvPtr->button == Button1) {
					if (WhichWindow != WindowList[WIN_DRAW])
						last_function = jump_left[window_num];
					(*jump_left[window_num])();
				} else if (ButEvPtr->button == Button2) {
					if (WhichWindow != WindowList[WIN_DRAW])
						last_function = jump_middle[window_num];
					(*jump_middle[window_num])();
				} else { /* Button3 */
					if (window_num==WIN_DRAW) { /* repeat last command */
						/* if (CSETPOINTS) DoBlink(0); */
						(*last_function)();
					} else {
						last_function = jump_right[window_num];
						(*jump_right[window_num])();
					}
				} /* Button3 */
				if (Consume) CP();
				if (bang)
					if (!--bang)
						ShowIcon(glyphs[WIN_BANG], WindowList[WIN_BANG], 0);
			} /* ButtonPress */ else
				fprintf(stderr,"gremlin internal error--bad event type\n");
			if (_Xdebug) DebugPrint();
		} /* not expose event */
    }  /* end while */
}  /* end main */

OnStop(signo)
int signo;
{
    (void) signal(signo, SIG_DFL);
    (void) sigsetmask(0);
    (void) kill(0, signo);
    (void) signal(signo, (void *)OnStop);
}

unimplemented()
{
	XBell(MyDisplay, 0);
	TextPut("not implemented.");
	Consume = FALSE;
}
