	/* modified for X11 */
/*
 *  Gremlin for the X window package.  Hacked from the aed gremlin.
 *  
 *  Copyright 1986 Dick Leban, University of Wisconsin Computer Systems Lab
 *  1210 West Dayton, Madison WI, 53706
 *  
 *  Permission is hearby granted to distribute this program provided that:
 *    (*) no commerical advantage is gained
 *    (*) the recipient has a gremlin license
 *    (*) this copyright notice appears on all copies
 *    (*) "On Wisconsin" sung in its entirety while the software
 *        is being copied to the distribution media.
 *  
 *        Here's the words, you'll have to find the tune if you're
 *        an uncultured slug.
 *  
 *           On Wisconsin, On Wisconsin,
 *           Plunge right through that line!
 *           Run the ball clear down the field boys,
 *           Touchdown sure this time (u-rah-rah)
 *           On Wisconsin, On Wisconsin,
 *           Fight on for her fame!
 *           Fight fellows fight-fight-fight 
 *           we'll win this game!
 *  
 *  Copyright -C- 1982 Barry S. Roitblat
 */

#include "gremlin.h"
#include "grem2.h"
#include "decls.h"
#ifndef lint
	static char *rcsid="$Header: undodb.c,v 2.2 88/08/12 13:38:09 solomon Stab $";
#endif lint

/* The following are used to point to the undo database lists */

UNELT *unlist, *unback;

/* imports from point.c */

POINT *PTInit(), *PTMakePoint();

UNRembAdd(element, db)
ELT *element, *db[];
/*
 *      This routine records an addition to the database by saving
 * a pointer to the new element
 */
{
    UNELT *temp;

    temp = (UNELT *) malloc(sizeof(UNELT));
    temp->action = ADD;
    temp->dbase  = db;
    temp->oldelt = NULL;
    temp->newelt = element;
    temp->nextun = unlist;
    unlist = temp;
}  /* end RembAdd */

UNRembDelete(element, db)
ELT *element, *db[];
/*
 *      This routine records a deletion from the database by saving
 * a pointer to the deleted element
 */

{
    UNELT *temp;

    temp = (UNELT *) malloc(sizeof(UNELT));
    temp->action = DELETE;
    temp->dbase  = db;
    temp->oldelt = element;
    temp->newelt = NULL;
    temp->nextun = unlist;
    unlist = temp;
}  /* end RembDelete */


UNRembMod(element, db)
ELT *element, *db[];
/*
 *      This routine records a modification to the database.  The
 * element passed to it is the element which will be modified and it
 * is therefore copied (copying the text and pointlist also)
 * and saved as oldelt.  A pointer of the element (which will be
 * modified) is saved in newelt.
 */

{
    POINT *pt;
    UNELT *temp;
    ELT *hold;

    temp = (UNELT *) malloc(sizeof(UNELT));
    temp->action = MOD;
    temp->dbase = db;
    temp->newelt = element;
    temp->oldelt = hold = (ELT *) malloc(sizeof(ELT));
    hold->type = element->type;
    hold->brushf = element->brushf;
    hold->size = element->size;
    hold->textpt = malloc((unsigned) strlen(element->textpt) + 1);
    (void) strcpy(hold->textpt, element->textpt);
    hold->ptlist = PTInit();
	forpoint(pt, element->ptlist) {
        (void) PTMakePoint(pt->x, pt->y, &(hold->ptlist));
    }  /* end forpoint */
    temp->nextun = unlist;
    unlist = temp;
}  /* end RembMod */

UNForget()
/*
 *      This routine clears the undo database.  The database is copied
 * into the backup database and elements from the backup database
 * are deleted and returned to free storage.  If nothing is in the undo
 * database, the backup database is preserved.
 */

{
    UNELT *temp;

    if (unlist == nullun) return;
    while (unback != nullun) {
        temp = unback->nextun;
        switch (unback->action) {
               case ADD: free((char *) unback);
                         break;

               case MOD:
            case DELETE: /* DBClearElt(unback->oldelt); */
				/* raphael: translate, undo, translate causes DBClearElt
				to free some pointlist structures that are still in use,
				in fact, on POINTLIST.  Better to have a memory leak for now. 
				*/
                         free((char *) unback);
                         break;
        }  /* end switch */;
        unback = temp;
    }  /* end while */;
    unback = unlist;
    unlist = nullun;
}  /* end Forget */

