/*
 * $Header: /src/misc/ditroff/RCS/dev.h,v 1.2 89/06/06 17:01:58 tim Exp $
 *
 * $Log:	dev.h,v $
 * Revision 1.2  89/06/06  17:01:58  tim
 * merge support for stipples and biggest font.  Add ifdef for compiling
 * as part of TROFF.
 * 
 * Revision 1.1  89/05/19  10:54:33  tim
 * Initial revision
 * 
 */

/*
	dev.h: characteristics of a typesetter
*/

struct dev {
      unsigned  short filesize;	/* number of bytes in file, */
				/* excluding dev part */
	short	res;		/* basic resolution in goobies/inch */
	short	hor;		/* goobies horizontally */
	short	vert;
	short	unitwidth;	/* size at which widths are given, in effect */
	short	nfonts;		/* number of fonts physically available */
	short	nsizes;		/* number of sizes it has */
	short	sizescale;	/* scaling for fractional point sizes */
	short	paperwidth;	/* max line length in units */
	short	paperlength;	/* max paper length in units */
	short	nchtab;		/* number of funny names in chtab */
	short	lchname;	/* length of chname table */
	short	nstips;		/* number of stipple fonts */
	short	biggestfont;	/* #chars in largest ever font */
};

#ifdef TROFF
struct Font {		/* characteristics of a font */
#else
struct font {		/* characteristics of a font */
#endif
	char	nwfont;		/* number of width entries for this font */
	char	specfont;	/* 1 == special font */
	char	ligfont;	/* 1 == ligatures exist on this font */
	char	spare1;		/* unused for now */
#ifdef UK
	char	namefont[10];	/* name of this font (e.g., "R" */
	char	intname[10];	/* internal name (=number) on device, in ascii */
#else
	char	namefont[3];	/* name of this font (e.g., "R" */
	char	intname[3];	/* internal name (=number) on device, in ascii */
#endif
};

/* ligatures, ORed into ligfont */

#define	LFF	01
#define	LFI	02
#define	LFL	04
#define	LFFI	010
#define	LFFL	020
