#!/usr/local/bin/tclsh

# Just identify self
#  Copyright (c) 1996, 1998 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

set myHost [info hostname]
while {[file rootname $myHost]!=$myHost} {
	set myHost [file rootname $myHost]
}

set Info [exec uname -a]
if {[catch {
	set Location [exec tabread Hosts -a Location -w "HostName == \"$myHost\""]
	}]} {
		set Location "unknown location\n"
	}
switch -regexp $tcl_platform(os) {
	SunOS {
		if {[catch {set OtherInfo [exec dmesg | grep clock | tail -1]}]} {
			set OtherInfo ""
		}
	} Linux {
		set OtherInfo "[exec cat /proc/cpuinfo | grep -v no | grep -v yes]
[exec grep -i controller /proc/pci]"
	} AIX {
		set OtherInfo [exec /usr/local/bin/machtype2]
	} default {
		set OtherInfo ""
	}
} ;# switch
# puts "$OtherInfo"

regsub -all "\n\n" $OtherInfo "\n \n" OtherInfo
report $myHost identity 1 "$Info in $Location $OtherInfo"

puts "$myHost identity 1 $Info in $Location\n$OtherInfo"

exit 0
