#!/usr/local/bin/tclsh

# Just identify self
#  Copyright (c) 1996, 1998 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

# This method is very site dependent.

set Info [exec uname -a]
if {[catch {
	set Location [exec tabread Hosts -W -1 -a Location -w "HostName == \"$myHost\""]
	}]} {
		set Location "unknown location"
	}
switch -regexp $tcl_platform(os) {
	SunOS {
		if {[catch {set OtherInfo [exec dmesg | grep clock | tail -1]}]} {
			set OtherInfo ""
		}
	} Linux {
		set OtherInfo "Total available memory: [lindex [exec free | grep Mem] 1]
[exec cat /proc/cpuinfo | grep -v no | grep -v yes]
[exec grep -i controller /proc/pci]"
	} AIX {
		set OtherInfo [exec machtype2]
    } NetBSD {
        set OtherInfo [exec dmesg | grep cpu0: ]
	} default {
		set OtherInfo ""
	}
} ;# switch
# puts "$OtherInfo"

regsub -all "\n\n" $OtherInfo "\n \n" OtherInfo
set Message "$Info\nLocation: $Location\n$OtherInfo"
report $myHost identity 1 $Message
puts $Message

exit 0
