#!/usr/bin/perl -w

# test reversal of lingala.  Quick and dirty.
# 4/22/2005
# Raphael Finkel, Nancy Snoke, Greg Stump

use strict;

my @testCases = (
	'iisukolakI' ,
	'nakomosukolE',
	'iesukolakI',
	'maXYsukolakI',
	'maXosuYolakI',
);

my $testCase;
foreach $testCase (@testCases) { 
	my $testing = $testCase;
	$testCase = join(',', split(//, $testCase));
	$testCase =~ s/([EI])/'$1'/g;
	my $queryString = "leafNode(Q, surfaceForm([$testCase]), S)";
	open THEORY, "echo -e aend_of_file . | " .
		"gprolog --init-goal \"['lingala.pro']\" " .
		" --query-goal \"$queryString\" |" or die("can't open gprolog.");
	my $line;
	my ($lemma, $subj, $obj, $tense, $X, $Y);
	while (defined($line = <THEORY>)) { # one line
		next if $line =~
			/compiling|compiled|GNU|Daniel|copyright|warning|ms\)/;
		# print "debug: $line"; # debug
		if ($line =~ /leafQuery/) {
			$line =~ s/argAgreement\(([^)]+)\)//;
			$subj = $1;
			if ($line =~ /\bref\b/) {
				$obj = 'reflexive';
			} else {
				$line =~ s/argAgreement\(([^)]+)\)//;
				$obj = $1;
			}
			$line =~ s/tenseInflection\(([^)]+)\)//;
			$tense = $1;
		} elsif ($line =~ /S = '(.*)'/) {
			$lemma = $1;
			printf "%13s = $lemma (%-9s) (%-9s) %s\n",
				$testing, $subj, $obj, $tense
				unless $testing =~ /[XY]/;
		} elsif ($line =~ /leafNode/) {
			# print $line;
		} elsif ($line =~ /X = '?(.)'?/) {
			$X = $1;
		} elsif ($line =~ /Y = '?(.)'?/) {
			$Y = $1;
			printf "%13s = $lemma (%-9s) (%-9s) %s; XY = %s\n",
				$testing, $subj, $obj, $tense, "$X$Y";
		} else {
			# print $line;
		}
	} # one line of prolog output
} # one test case
