/* global.h
 *
 * Written by Matt Levy
 * modified 28 Jul 1999 by Neil Moore <neil@cs.uky.edu>
 * Modified  5 Sep 1999 by Neil Moore <neil@cs.uky.edu>
 *
 * Part of lderes.  See COPYRIGHT for copyright information.
 *
 */

#ifndef _GLOBAL_H
#define _GLOBAL_H	1

#include "stdio.h"

#define INFORMATION_FILE_EXTENSION "dt"
#define KNOWLEDGE_MARKER 'w'
#define KNOWLEDGE_FILE_EXTENSION ".thc"
#define DEFAULT_MARKER 'd'
#define DEFAULT_FILE_EXTENSION ".dc"
#define STRAT_FILE_EXTENSION "str"
#define MAX_IDENTIFIER_LENGTH 128

#define LINE_LENGTH 5

#ifndef NULL
#define NULL 0
#endif

#define DISPLAY(commandLine) if (verbosity > 1) commandLine

inline void stub(const char *message);
inline void fatal_error(const char *message);
extern int verbosity;
extern int timex;

#endif /* _GLOBAL_H */
