/* File: token.h
 * Contains token definitions for use in parsing theories
 *
 * Written by Matt Levy
 *
 * Part of lderes.  See COPYRIGHT for copyright information.
 *
 */

#ifndef _TOKEN_H
#define _TOKEN_H	1
#include <stdlib.h>

#define SPACE ' '
#define IS_SKIPPABLE(c) (c == ' ' || c == '\t' || c == '\n' || c == '%')
#define IS_COMMENT(c) (c == '%')

/* Tokens */
#define VAR        -1
#define ENTAIL     -2
#define COMMA      -3
#define SEMI_COLON -4
#define COLON      -5
#define AND_SYMB   -6
#define OR_SYMB    -7
#define NOT_SYMB   -8
#define NULL_TOKEN -9
#endif /* _TOKEN_H */

