/* lp_fks.h
 * Neil Moore <neil@cs.uky.edu>
 * 11 May 1999
 *
 * Part of liblp.  See COPYRIGHT for copyright information.
 */
#ifndef _LP_FKS_H_INCLUDED
#define _LP_FKS_H_INCLUDED

#include <lp.h>
#include <lp_lists.h>

/* Compute the Fitting-Kunen semantics for a logic program */
int *lp_fks(struct lp *p);
void lp_fks_rel(struct lp *p, int *model);

/* internal function */
void _do_compute_fks(struct lp *p, struct lp_alist **atoms, int *inmodel,
		     int *stricken, struct lp_rlist **pdepends,
		     struct lp_rlist **ndepends, int *pbs, int *nbs, int *nhead);

#endif /* _LP_FKS_H_INCLUDED */
