.\" -*- nroff -*-
.TH smdtconv 1 "20 Sep 1999" "lpsms 0.0"
.\" Turn off hyphenation
.hlm 0
.\" Turn off adjustment
.na
.SH NAME
smdtconv - convert a logic program into a DeReS default theory
.SH SYNOPSIS
.B smdtconv
.RI "[" options "]"
.RI "[" file "...]"
.\" Back to standard adjustment
.ad
.\" Allow hyphenation, omit if you want no hyphenation in the man page
.hlm 1

.SH DESCRIPTION

.B smdtconv
converts a 
.BR "smodels 1" -format
logic program into three files: a theory file (\fB.thc\fR), a defaults file (\fB.dc\fR), and a main
file (\fB.dt\fR).  Currently, the \fR.thc\fB file generated is empty; facts are generated as
defaults with empty prerequisites and justifications.  Eventually, facts may be placed into the
\fB.thc\fR file instead.

If
.B smdtconv
is run on the output of
.BR stratify ,
the resulting \fB.dc\fR file will be compatible with the \fB.str\fR file produced by
.BR stratify .

.SH OPTIONS
.TP
.BR "\-t" ", " "\-\-time"
Perform timing.  The CPU time in seconds (as measured by
.BR clock (3))
is displayed to stderr after the conversion is performed.  This is the default.
.TP
.BR "\-n" ", " "\-\-no-time"
Do not display timing information.
.TP
.BR "\-V" ", " "\-\-verbose"
Display extra status information to stderr.  This flag causes
.B smdtconv
to print a message when entering each phase of processing.
.TP
.BR "\-m" ", " "\-\-messages"
Display only error messages (and possibly timing information, depending on the state of the
.B "\-t"
and
.B "\-n"
flags) to stderr.
.TP
.BR "\-q" ", " "\-\-quiet"
Do not display any messages (other than perhaps timing information) to stderr.
.TP
\fB\-o\fI filename\fR, \fB\-\-output=\fIfilename\fR
Send the output to \fIfilename\fB.dt\fR, \fIfilename\fB.dc\fR, and \fIfilename\fB.thc\fR.
The default is \(lq\fBsm2dt\fR\(rq.  There is currently no way to give the various result
files different base names.
.TP
.BR "\-v" ", " "\-\-version"
Print version information to stdout.  The information indicates the version numbers of
.BR smdtconv ", " liblp ", and " lpsms .
.TP
.BR "\-h" ", " "\-\-help"
Display usage information to stdout.

.SH AUTHOR
.RI "Neil Moore <" neil@cs.uky.edu ">"

.B smdtconv
is Copyright \(co 1998-1999 The University of Kentucky.  See the file COPYRIGHT in the
.B lpsms
distribution for details.

.SH BUGS
.B smdtconv
does not currently support the
.B smodels 2
format.
.B lparse
can produce both
.B smodels 1
and
.B 2
format programs, and we do not deal with
.B smodels 2
special rule types, so support for the
.B smodels 2
format is not a high priority.

The user should be allowed to give the theory (\fB.thc\fR), default (\fB.dc\fR), and main
(\fB.dt\fR) files different base names.

.SH SEE ALSO
.BR simplify "(1), " stratify "(1), " sm2dt "(1), " sderes "(1), " lderes "(1)."
