#!/usr/local/bin/tclsh

# See if mail queue has waiting things
#  Copyright (c) 1996, 1998 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

set myHost [info hostname]
while {[file rootname $myHost]!=$myHost} {
	set myHost [file rootname $myHost]
}

set myUse ""
catch { set myUse [exec mailq] }

if {$myUse == ""} {
	# puts "no mailq program"
	exit 0
}

if [string compare $myUse "Mail queue is empty"]==0 {
	report $myHost mail 1 "all well"
} else {
	report $myHost mail 15 "non-empty mail queue: $myUse"
}

if {[file exists /usr/tmp/dead.letter] && [file size /usr/tmp/dead.letter]>0} {
	report $myHost deadmail 16 "Dead letter in /usr/tmp/dead.letter"
} else {	
	report $myHost deadmail 0 "No dead letter in /usr/tmp/dead.letter"
}

exit 0
