#!/usr/local/bin/tclsh

# See if mail queue has waiting things
#  Copyright (c) 1996, 1998 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

set myUse ""
if {[catch { set myUse [exec mailq | tail -2 ] } error]} {
	puts "no mailq program"
	report $myHost mail 11 \"$error\"
	exit 0
}

if {[regexp {is empty} $myUse]} {
	report $myHost mail 1 "all well"
} elseif {[string length $myUse] == 0} {
	report $myHost mail 15 "mailq gives empty result: configuration error?"
} else {
	regexp {([0-9]+ (r|R)equest)|(requests: [0-9]+)} $myUse match
	report $myHost mail 15 "non-empty mail queue: $match"
	puts "$match"
}

if {[catch { set myUse [exec mailq -Ac | tail -2 ] } error]} {
	puts "no mailq program"
	report $myHost mailQ 11 \"$error\"
	exit 0
}

if {[regexp {is empty} $myUse]} {
	report $myHost mailQ 1 "all well"
} elseif {[string length $myUse] == 0} {
	report $myHost mailQ 15 "mailq -Ac gives empty result: configuration error?"
} else {
	regexp {([0-9]+ (r|R)equest)|(requests: [0-9]+)} $myUse match
	report $myHost mailQ 15 "non-empty mail clientmqueue: $match"
	puts "$match"
}

if {[file exists /usr/tmp/dead.letter] && [file size /usr/tmp/dead.letter]>0} {
	report $myHost deadmail 16 "Dead letter in /usr/tmp/dead.letter"
} else {	
	report $myHost deadmail 0 "No dead letter in /usr/tmp/dead.letter"
}

exit 0
