/*
# 
#  Copyright (c) 1990 Raphael Finkel
#  All rights reserved.
# 
#  Redistribution and use in source and binary forms are permitted
#  provided that the above copyright notice and this paragraph are
#  duplicated in all such forms and that any documentation,
#  advertising materials, and other materials related to such
#  distribution and use acknowledge that the software was developed
#  by Raphael Finkel at the University of Kentucky,
#  Department of Computer Science.  The names of the University or the
#  author may not be used to endorse or promote products derived
#  from this software without specific prior written permission.
#  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
#  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
#  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
*/

#include <stdio.h>
#include "menu.h";

/* constants */
#	define DummyArg 0
#	define FortuneDirty 0
#	define FortuneShort 1
#	define FortuneLong 2

/* forward declarations */
	/* routines */
		extern TryMe();
		extern NoTryMe();
		extern Fortune();
	/* menus */
		extern Menu MainMenu, FortuneMenu;

/* initialized vars */

	Menu MainMenu = {
		"Main menu", 0, 0, 0, {
			{"Try me!", TryMe, DummyArg},
			{"No, try me!", NoTryMe, DummyArg},
			{"You can't lose with this one!", DoMenu, (long) &FortuneMenu},
			{0, 0, DummyArg}
		}
	}; /* MainMenu */
	Menu FortuneMenu = {
		"Fortune cookie menu", 0, 0, 0, {
			{"A dirty fortune", Fortune, FortuneDirty},
			{"A short fortune", Fortune, FortuneShort},
			{"A long fortune", Fortune, FortuneLong},
			{0, 0, DummyArg}
		}
	}; /* FortuneMenu */

/* procedures */

TryMe(){
	fprintf(stdout,"And into a recursive descent...\n");
	sleep(1);
	DoMenu(&MainMenu);
	fprintf(stdout,"Wasn't that recursive descent fun?\n");
	sleep(1);
} /* TryMe */

NoTryMe(){
	fprintf(stdout,"Actually, this entry doesn't do very much\n");
	sleep(1);
} /* NoTryMe */

Fortune(Which){
	char *Argument;
#	define LINELENGTH 2
	char Line[LINELENGTH];

	switch (Which) {
		case FortuneDirty:
			Argument = "-o";
			break;
		case FortuneShort:
			Argument = "-s";
			break;
		case FortuneLong:
			Argument = "-l";
			break;
		default:
			fprintf(stderr,"Internal error #1\n");
			exit(1);
	}
	CallProcess(2, "/usr/games/fortune", "fortune", Argument, 0);
	fprintf(stdout,"\n\nType carriage return to continue.\n");
	(void) fgets(Line, LINELENGTH, stdin);			
} /* Fortune */

main(){
	DoMenu(&MainMenu);
} /* main */
