# initialization code for all SAT reports

$SatDBRoot = "$SATHOME/db"; # the root of the SAT database.

# where the scheme and data files located.
$schemefile = "$SatDBRoot/$Relation/scheme";
$datafile = "$SatDBRoot/$Relation/data";

$ENV{PATH} = "/bin:/usr/bin:/sbin:/usr/local/bin"; # enter a safe environment
$> = $<; # on some machines (SGI), effective id set to 1; we need 0.

# parse the command-line arguments. An argument turns on debugging mode
# and specifies the machine that I am to emulate.
if ($#ARGV ne $NULL) { # there are parameters
	if ($#ARGV == 0) { # just one parameter
		my ($aliases, $type, $length, @addrs); # all dummy
		($MyFullHostName, $aliases, $type, $length, @addrs) =
			gethostbyname $ARGV[0];
		$Debug = $TRUE;
		$MyRoot = "$MYHOME/$ARGV[0]/$Relation".".Outputs";
			# where the debugging directory located.
	} else { # more than one parameter
		die "Only one parameter allowed";
	}
} else { # no parameters
	$MyFullHostName = GetFullHostName();
	$Debug = $FALSE;
}
$MyFullHostName =~ /^(\w*)/; # detect first component
$MyHostName = $1;
# print "I am $MyFullHostName, or $MyHostName for short.\n";

$Debug = Untaint($Debug);
$DebugOwner = Untaint($DebugOwner);

# set debug-dependent values
if ($Debug) {
	$Root = $MyRoot;
	$lastmodified = "$MYHOME/.LastModified";
} else {
	$Root = $ETCHOME;
	$lastmodified = "$SatDBRoot/$Relation/.LastModified";
}

$MyRoot = Untaint($MyRoot);
$Root = Untaint($Root);

1; # package return value
