#!/usr/local/bin/perl

# check the Motd relation to prevent erroneous records.

# imports two packages:
#	Definitions.pl includes some constant variables
#	PutRecords.pl includes the PutRecords subroutine.
#
$SATHOME = "/usr/local/etc/sat";
require "$SATHOME/perlinclude/Definitions.pl";
require "$SATHOME/perlinclude/PutRecords.pl";

# define which relation this program reports.
$Relation = "Motd";

# the root of the SAT database.
$SatDBRoot = "$SATHOME/db";

# where the necessary files located.
$lastmodified = "$SatDBRoot/$Relation/.LastModified";
$motdschemefile = "$SatDBRoot/$Relation/scheme";
$motddatafile = "$SatDBRoot/$Relation/data.new";

# read the new Motd relation into @Motd.
@Motd = PutRecords ($motdschemefile, $motddatafile);

for $motd_tuple (@Motd) { # check one tuple
	@UserInfo = getpwnam ($motd_tuple->{'Author'});
	$#UserInfo != $NULL ||
		die "$motd_tuple->{'Author'} is not a valid user name.\n";
	$motd_tuple->{'TextOfMotd'} ne "" ||
		die "No text in message by $motd_tuple->{'Author'} on"
		. " $motd_tuple->{'Date'}.\n";
} # check one tuple

# exit status.
exit 0;
