#!/usr/local/bin/tclsh

# ping all machines we should be able to reach
#  Copyright (c) 1996, 1998 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

foreach host [exec ./enumerate.tcl upHosts] {
	if [regexp -- - $host] continue ;# don't want secondary names of hosts
	regsub {%h} $pingCommand $host myPing
	puts "checking $host"
	if {[catch {set pingString [eval exec $myPing]} result]==1} {
		puts "$host Does not respond to ping: $result"
		report $host ping 30 "Does not respond to ping from [info hostname]"
	} elseif {[regexp {100%} $pingString]} {
		# some versions of ping don't return bad status; you have to look
		# at the return string
		puts "$host Does not respond to ping: $result"
		report $host ping 30 "Does not respond to ping from [info hostname]"
	} else { # see if $host is up enough to answer a date request.
		# set result [exec sh -c "telnet $host $unixTelnetPort < /dev/null 2>&1 ; true"]
		#   Telnet always returns status 1, so we must mask that, but
		#   socket is more direct than telnet.
		catch {close [socket $host $unixTelnetPort]} result
		# puts $result
		if {[regexp {refused|time} $result]} {
			catch {close [socket $host 139]} result
			if {[regexp {refused} $result]} {
				report $host ping 9 \
					"Doesn't answer Unix ($unixTelnetPort) or Windows (139) request"
				puts "$host: Doesn't appear to be Unix or Windows"
			} else {
				report $host ping 1 "Seems to be running Windows or NT"
				puts "$host: Seems to be running Windows or NT"
			}
		} else {
			report $host ping 1 "Appears to be Unix"
			puts "$host: seems to be running Unix"
		}
	}
}

exit 0
