.ro \" roman page number
.pn 11
.UC Preface
.lp
Traditionally, a vade mecum (pronounced
.q "VAHdee MAYkem" )
is a laboratory manual that guides
the student step by step through complex procedures.
Operating systems are complex mixtures of policy and mechanism,
of algorithm and heuristic, and of theoretical goals and practical
experience.
This vade mecum tries to unify these diverse points of view and guide the
novice step by step through the complexities of the subject.
As a text, this book is intended for a first course
in operating systems at the undergraduate level.
The subject has so many individual parts that its
practitioners and teachers often concentrate on
subareas and ignore the larger concepts that
govern the entire subject.
I have tried to rectify that situation in this book
by structuring the presentation about the dual
ideas of resource management and beautification.
.pp
To unify disparate threads of discussion,
I have taken the liberty introducing names for
recurrent themes and glorifying them with the title
.q principles. " "
I hope that this organization and nomenclature will
help the reader to understand the subject better and
to integrate new ideas into the same framework.
.pp
Each technical term that is introduced in the text is
printed in \fBboldface\fP the first time it appears.
All boldface entries are collected and defined in the
glossary.
I have striven to use a consistent nomenclature
throughout the book.
At times this nomenclature is at odds with accepted
American practice.
For example, I prefer to call computer memory
.q store. " "
This name allows me to unify the various levels of
the storage hierarchy, including registers, main
store, swap space, files on disk, and files on
magnetic tape.
I also prefer the single word
.q trans\%put
to the clumsier but more common term
.q input/output. " "
Although I found this term jarring at first, I have
grown to like it.
.pp
Each chapter closes with a section on perspective,
suggestions for further reading, and exercises.
The perspective section steps back from the details of the
subject and summarizes the choices that actual operating
systems have made and rules of thumb for distinguishing
alternatives.
It also fits the subject of the chapter into the larger
picture.
The suggestions for further reading have two purposes.
First, they show the reader where more information on the
subject discussed in the chapter may be found.
Second, they point to research articles related to the subject
that describe actual implementations and areas of current
activity.
The exercises also serve two purposes.
First, they allow the student to test his or her understanding
of the subject presented in the text by working exercises
directly related to the material.
More importantly, they push the student beyond the confines of
the material presented to consider new situations and to
evaluate new policies.
Subjects that are only hinted at in the text are developed
more thoroughly in this latter type of exercise.
.pp
A course in operating systems is not complete without computer
projects.
Unfortunately, such exercises require a substantial investment
in software.
The most successful projects for a first course in operating
systems involve implementing parts of an operating system.
A complete operating system can be presented to the
class, with well-defined modules and interfaces, and the class
can be assigned the task of replacing modules with ones of
their own design.
A less ambitious project has the students first build a simple scheduler
for a simulated machine.
After it is completed, it can be enhanced by adding virtual
memory, trans\%put, and other features.
If the necessary software is not available for these
assignments, students can be asked to simulate particular
policies or algorithms in isolation from a complete operating system.
Several exercises in the book give guidelines for this sort of
project.
.pp
This second edition of the text differs from the first in several ways.
Many figures have been added, both to clarify individual points and to 
unify the treatment of different subjects with similar diagrams.
For example, the history of operating system styles is now adorned with
consistent pictures.
The nuts and bolts of process switching has been moved from Chapter 2 to
Chapter 1, and a new section on virtual-machine operating systems has been
added.
The discussion of page-replacement policies in Chapter 2 has been enhanced
with fault-rate graphs drawn from a simulation.
Analysis and simulation are described near the end of Chapter 2.
Chapter 9 on co-operating processes has been enlarged with a major new section
on the communication-kernel approach.
The Hysteresis Principle has been introduced.
Minor errors and inconsistencies have been fixed throughout the text.
.pp
I owe a debt of gratitude to the many people who helped me
write this text.
The students of Bart Miller's operating system class all wrote
book reviews for an early draft.
My parents Asher and Miriam and my brothers Joel and
Barry devoted countless hours
to a careful reading of the entire text, suggesting
clarifications and rewording throughout.
My colleagues Bart Miller, Mary Vernon, and Michael Carey read
and criticized individual chapters.
Michael Scott's careful reading of Chapter 8 and his keen insight into language
issues in general were of great help.
I am also grateful to Charles Shub, Felix Wu, Aaron Gordon, Mike Litskow,
Ianne H. Koritzinsky, Shlomo Weiss, Bryan Rosenburg, and Hari Madduri for
their helpful comments.
This book was prepared using the Troff program on a Unix
operating system.
I would have been lost without it.
Finally, I would like to thank my wife, Beth Goldstein, for
her support and patience, and my daughter, Penina, for being wonderful.
.sp
.tl '''\fIRaphael A. Finkel\fP'
.tl '''\fIUniversity of Wisconsin\(miMadison\fP'
.ar
.pn 1
