#!/usr/local/bin/tclsh

# See if printers are up.
#  Copyright (c) 1996, 1998 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

set printerList [exec ./enumerate.tcl printers]

# the tests here are intended for LPRng-controlled printers.
foreach printer $printerList {
	puts "trying $printer"
	if {[catch {set result [exec lpq -P$printer]} error]} {
		report printers $printer 15 "$error"
		puts "$error"
		continue
	}
	regsub "^\[\n \t\]+" $result {} result
	regsub -all "\n\n" $result "\n" result
	switch -regexp $result {
		{cannot|attempt|faulted|stalled|not responding|ERROR|not in printcap|stalled} {
			report printers $printer 15 "$result"
			puts "printers $printer 15 $result"
		} default {
			report printers $printer 1 "$result"
			puts "printers $printer 1 $result"
		}
	} ;# switch
	# puts "$result"
} ;# foreach printer

exit 0
