#!/usr/local/bin/tclsh

# Notice machines that should be reporting but aren't.
#  Copyright (c) 2003 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

foreach fileName {presenter.log presenter.log.1 presenter.log.2} { ;# one file
	if {[catch {set file [open $fileName]}]} break;
	# puts "using file $fileName"
	while {[gets $file line] > 0} { ;# one line
		# puts "on line $line"
		if {[lindex $line 7] == "cpu"} { ;# a cpu line
			set host [lindex $line 6]
			set seen($host) 1
			# puts "$host is up";
		} ;# a cpu line
	} ;# one line
} ;# one file

foreach host [exec ./enumerate.tcl upHosts] {
	if {[info exists seen($host)]} {
		lappend ok $host
		# puts "$host reporting"
		report $host pulsar 1 "reporting regularly"
	} else {
		lappend bad $host
		# puts "$host not reporting";
		report $host pulsar 15 "no recent report"
	}
}

puts "hosts reporting: [lsort $ok]"
puts ""
puts "hosts not reporting: [lsort $bad]"
