#!/usr/local/bin/tclsh

# Check for file systems I can't write to.
#  Copyright (c) 1998 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

# read in the configuration file
set confFile [open ./readonly.conf r]
while {[gets $confFile line]>=0} {
    if [regexp ^# $line] continue ;# comment line
    if [regexp ^$ $line] continue ;# empty line
	set fileToWrite [lindex $line 0]
	set remoteHost [lindex $line 1]
	if [file exists $fileToWrite] {
		puts "trying to delete $fileToWrite"
		if {[catch {exec /bin/rm $fileToWrite} message]} {
			puts "failed to delete: $message"
			report $remoteHost fileSystem 21 \
				"$myHost cannot delete $fileToWrite on $remoteHost"
		} else {
			report $remoteHost fileSystem 0 "writable"
		}
	} else {
		puts "trying to create $fileToWrite"
		if {[catch {set fileDescriptor [open $fileToWrite w]} message]} {
			puts "failed to create: $message"
			report $remoteHost fileSystem 21 \
				"$myHost cannot create $fileToWrite on $remoteHost"
		} else {
			close $fileDescriptor
			report $remoteHost fileSystem 0 "writable"
		}
	}; # does not yet exist
} ;# for each line of configuration
