#!/usr/local/bin/perl

# report a problem to presenter
#  Copyright (c) 1996, 1998 Raphael Finkel.  See the COPYRIGHT file for details.

$argCount = $#ARGV + 1;

if ($argCount != 4) {
	print "Wrong number of arguments.  You gave me $argCount; I need 4.\n";
	exit 1;
}

@ARGV[3] =~ s/"/'/g;

# print "Args are @ARGV[0], @ARGV[1],  @ARGV[2], \"@ARGV[3]\".\n" ;

open confFile, "presenter.conf";
while (<confFile>) {
	if (/(.*) (.*)/) {
		$remoteHost = $1;
		$port = $2;
		# print "Host is $remoteHost:$port\n";
	}
}

close confFile;

# get modified time on presenter.conf for protocol check
$mTime = (stat("presenter.conf"))[9];
# print "mtime is $mTime\n";

# build socket to presenter (boy, is this easier in Tcl!)
use Socket;
$sockaddr = 'S n a4 x8';  # template for sockaddr structures
chop($hostname = `hostname`);  # get my own name
($name, $aliases, $proto) = getprotobyname('tcp');  # get proto
($name, $aliases, $type, $len, $thisAddr) = # get thisAddr
	gethostbyname($hostname);
($name, $aliases, $type, $len, $thatAddr) = # get thatAddr
	gethostbyname($remoteHost);
$this = pack($sockaddr, AF_INET, 0, $thisAddr); # build remote socket structure
$that = pack($sockaddr, AF_INET, $port, $thatAddr); # and local socket structure
socket(S, PF_INET, SOCK_STREAM, $proto) || die "socket: $!"; # new socket S
bind(S, $this) || die "bind: $!"; # establish my end
connect(S, $that) || die "connect: $!"; # establish remote end
select(S); $| = 1; select(stdout); # turn on autoflush

print S "$mTime\n";
print S "@ARGV[0] @ARGV[1] @ARGV[2] \"@ARGV[3]\"\n";
close S;

exit 0
