/*
 *=========================================================
 * FILE: proto.h
 *
 * modified 19 Apr 1999 by Neil Moore <neil@cs.uky.edu>
 *
 * Part of sDeReS.  See COPYRIGHT for copyright information.
 *=========================================================
 */

/* main.c */
void setoptions(void);
void init_working_memory(void);

/* scanner.c */
int getdata(void);
int getdata_default(void);
int get_input_text(FILE *, int*, int*, struct symbolbox **);
int nextline(char *, int, FILE *);
void error(char *, int);
int lexscan(char *, int *, struct symbolbox **);
int hashkey(char *);
struct symbolbox *lookup(char *, int, struct symbolbox **);
struct symbolbox *insert(char *, int, struct symbolbox **);

/* interf.c (interface.c) */
int loadtheory(char *);

/* emitter.c */
void emitextnsn(int, int *);
int  printliteral(int, char**);
void printformula(int);
void printtoken(int);

/* atomprv.c */
int prove(int,int);
void SetProverStructures(int *,int *,int *,int ,int ,int ,long *,char**);

/* stratex.c */
int stratified_extnsns(void);
int read_stratification(int);

/* deflib.c */
int form_prover_structures(void);
int rewindft(int,int);
int default_is_consistent(int);
int Bomega(void);
int new_monrule_first_fireable(int, int);
