.\" -*- nroff -*-
.TH sderes 1 "29 Apr 1999" "sderes 1.3.1"
.\" Turn off hyphenation
.hlm 0
.\" Turn off adjustment
.na
.SH NAME
sderes - compute extensions of a simple default theory
.SH SYNOPSIS
.B sderes
.RI "[" options "]"
.RI "[" file "...]"
.\" Back to standard adjustment
.ad
.\" Allow hyphenation, omit if you want no hyphenation in the man page
.hlm 1

.SH DESCRIPTION
The program
.B sDeReS
computes extensions of a subclass of simple default theories.  This subclass includes logic
programs; thus, for a logic program, sDeReS computes stable models of the program.  Input is in
DeReS format, and consists of three files: a .dt file which points to the other two files; a
.dc file which contains the defaults, or rules, of the theory; and a .thc file, containing the
initial set of facts (possibly including conjunction, but not disjunctions or more complicated
logical connectives).  File formats are described below, but these files are most often generated by
sm2dt.

.SH OPTIONS
.TP
.BR "\-1" ", " "\-\-single"
Generate a single extension.  This is the default.
.TP
.BR "\-a" ", " "\-\-all"
Generate all extensions.
.TP
.BI "\-e" NNN, " \-\-extensions=" NNN
Generate the first
.I NNN
extensions.
.TP
.BR "\-t" ", " "\-\-time"
Measure CPU time taken by parsing and computation, and display to stdout.  This is the default.
.TP
.BR "\-n" ", " "\-\-no-time"
Do not display CPU time.
.TP
.BR "\-v" ", " "\-\-version"
Display version information to stdout and exit.
.TP
.BR "\-h" ", " "\-\-help"
Display usage information to stdout and exit.


.SH "FILE FORMATS"

When given a filename
.I file
on the command line, 
.B sDeReS
first opens
.IR file .dt.
This file contains two lines (in addition to any comments):
.RS
\fCw = \fIwfile\fP
.br
d = \fIdfile\fP
\fR
.RE
The default theory is then read from
.IR wfile .thc
and
.IR dfile .dc.
The first file, contains disjunction-free logical expressions.  Expressions are separated by blank
lines.  The second contains a set of defaults of the form:
.RS
\fC a : b1, b2, b3
.br
     -> g;
.RE
The prerequisite, a, is a literal or conjunction of literals.  Conjunction is represented by
\(lq&&\(rq, negation by \(lq!\(rq.  The justifications b1 . . .  b3, are also literals or
conjunctions of literals.  Finally, the conclusion, g, is a logical expression.  Each default is
separated from the next by a blank line.  A default indicates that the conclusion can be proved if
the prerequisite can be proved and each of the justifications is consistent with the theory.  See
[CMT 98] for a more accurate description of default logic (although it should again be noted that
.B sDeReS
accepts only a small subset of default logic).


.SH AUTHOR
.B DeReS
was originally written by Pawel Cholewinski.
.br
.B DeReS
was simplified into
.B sDeReS
by
.RI "Neil Moore <" neil@cs.uky.edu ">" .
.br
.B DeReS
and
.B sDeReS
are Copyright \(co 1992-1999 The University of Kentucky.  See the file COPYRIGHT in the
.B sDeReS
distribution for details.

.SH BUGS
Without stratification,
.B sDeReS
is very slow.  It is possible to mechanically stratify a default theory, but there is currently no
program to do so.  Theories generated by
.BR sm2dt ,
however are automatically stratified, and it should be relatively simple to convert the
.B stratify
component of
.B sm2dt
so that it accepts input in
.B DeReS
format.

Because
.B sDeReS
is primarily intended to work with theories converted from logic programs, the existence of the
separate .thc file makes little sense; it should be possible to elimitate the .dt and .thc files,
leaving only the .dc and .str files.  Changes to the file format should allow these two files to be
integrated.

.SH SEE ALSO
sm2dt(1)
.br
[CMT 98] Pawel Chowelinski, Victor Marek, and Miroslaw Truszczynski, `Default Reasoning System
DeReS\(aq.  \fIProceedings of KR\fP, 1996.  pp 518\(en528.
