/* lp_smrnd.h
 * Neil Moore <neil@cs.uky.edu>
 * 30 Mar 1999
 *
 * Part of liblp.  See COPYRIGHT for copyright information.
 */
#ifndef _LP_SMRND_H_INCLUDED
#define _LP_SMRND_H_INCLUDED

#include <lp.h>

/* Constants for flipmode below */
#define LP_FM_ONCE   0 /* Flip each atom at most once per restart */
#define LP_FM_LR     1 /* Break ties by choosing the least recently flipped */
#define LP_FM_RANDOM 2 /* Break ties randomly */

/* Randomly find a stable model of a logic program */
int *lp_sm_rand(struct lp *p, int *restarts, int *flips, int flipmode);

#endif /* _LP_SMRND_H_INCLUDED */
