/* lp_strrd.c
 * Neil Moore <neil@cs.uky.edu>
 * 30 Mar 1999
 *
 * Part of liblp.  See COPYRIGHT for copyright information.
 */
#include <stdio.h>
#include <lp_util.h>

/* Read a stratification.  *strata is allocated as an array of ints, with
 * (*strata)[i] indicating the number of rules in the ith strata.  The
 * input file is in DeReS stratification format, which makes things quite
 * simple.  This function returns an integer indicating the number of
 * strata, or -1 if there was an error.
 *
 */
int lp_read_strata(FILE *f, int **strata) 
{
	char buff[80];
	int nstrata=0;
	int i;

	while(!feof(f)) {
		fgets(buff,80,f);
		if(!feof(f))
			nstrata++;
	}
	
	*strata = lp_malloc(nstrata * sizeof(int));
	
	fseek(f,0,SEEK_SET);
	for(i=0;i<nstrata;i++) {
		if(((*strata)[i] = lp_getnumline(f)) < 0) {
			fprintf(stderr, "Error on line %d\n", i);
			return -1;
		}
		
	}

	return nstrata;
}

