.SH 1 "Exercises"
.ES
.nr E+ 0 1
.EP \n+(E+.
In a single-segment scheme, the storage manager wants to shuffle.
.IN "Shuffling"
How should it find which process corresponds to which busy piece of physical
store?
.EP \n+(E+.
Design a data structure for the shared-segment table in the two-segment
organization.
How is the table addressed?
.EP \n+(E+.
You are the president of Cheapo Computronics, and your star hardware designer
has suggested a brilliant idea:
Implement segmentation, but let the \fIleast significant\fP
@m@ bits of a virtual address be used to select the segment, and let the other
bits determine the offset.
Should the designer retire or get a raise?
Why?
.EP \n+(E+.
A process generally has no inkling when a segment fault occurs.
Describe how a process could use a TimeOfDay service call to guess that such a
.IN "Service call" "TimeOfDay"
fault has occurred.
.EP \n+(E+.
If we allow a process to have anywhere from zero segments to the maximum
number of segments allowed by the hardware, it takes one more bit to
represent the number of segments in use than to represent any particular
segment.
Why?
What implementation difficulty does that create?
What can be done about it?
.EP \n+(E+.
There is a similar problem for segment sizes.
What is the problem?
.EP \n+(E+.
What is the relation between the size of physical store and virtual store under
segmentation?
.EP \n+(E+.
Suppose we wish to implement paging and want to use the load-image file as
backing store for instructions and read-only data as a way to save space on
the backing drum.
What information must be stored in the load-image file?
What constraints should we place on that file?
.EP \n+(E+.
How long is a process page table on the VAX?
.EP \n+(E+.
On the VAX, a process may access kernel space.
What prevents a process from generating nuisance missing-page faults by trying
to read regions in the kernel?
.EP \n+(E+.
If a process releases the instructions segment in which it is currently
executing, describe in detail the actions taken by the kernel that lead
inexorably to catastrophe.
How should the kernel treat the disaster?
.EP \n+(E+.
Should the address translation table be in the virtual space of the associated
process?
Consider the ramifications of making the opposite decision.
.EP \n+(E+.
Write a program to generate page-reference strings by using the following
approach, which was used to generate Figure \n(ch.\n(F1. 
All @n@ pages of virtual store are listed in order.
Use the exponential distribution with mean @sqrt n@ to pick a number between 1
and @n@.
The page at that point in the list is the next page in the reference string.
Move that page to the start of the list, and repeat the algorithm.
(Elements near the front of the list were referenced recently; those near the
end have not been referenced for a long time.)
.nr E9 \n(E+
.EP \n+(E+.
What properties of true page-reference strings are not exhibited by the ones
generated by the program of exercise \n(E9?
.EP \n+(E+.
Use the program from exercise \n(E9 to generate a graph like the one in
Figure \n(ch.\n(F1. 
.EP \n+(E+.
Design a combination of the NUR and second-chance cyclic page-replacement
policies.
.EP \n+(E+.
Given the reference string
4 5 2 1 4 3 5 4 3 2 1 5,
draw the cold-start fault-rate graphs for main store ranging between
1 and 7 pages,
using Min, FIFO, LRU, and two forms of NUR, the ordinary one
(resetting Used to false in each page table entry that the scan passes) and
a variant (resetting Used to
false everywhere in the page table when all the Used fields are true).
.EP \n+(E+.
If a machine offers several states, each with its own register set, why not use
different states for different processes to reduce the process switch cost?
.EP \n+(E+.
Several processes sharing the same instructions are given separate register
sets.
(a)  Why not let them all use the same registers?
(b)  Why not divide up the registers and let each process use a different subset
in order to avoid duplication?
.EP \n+(E+.
We claimed that segmentation hardware can check the subscripts of all array
references to make sure they are in bounds.
When is this claim false?
.EP \n+(E+.
Evaluate the suggestion that segments that are brought into main store can be
discarded from backing store.
Under what circumstances would this mechanism be useful?
How could it prove costly?
.EP \n+(E+.
Suggest an architecture that would allow Dirty fields for shared segments to be
set directly by the hardware.
.EP \n+(E+.
The translation look-aside buffer on a particular machine has a 95 percent hit
rate and takes 100 nanoseconds to yield a value.
Main store takes 1 microsecond to read a value.
The hardware for address translation needs to make one access to the
translation table per access and an additional 30 nanoseconds to complete the
translation.
What is the average time per address translation?
.EP \n+(E+.
When a process terminates, it may own a number of pages in physical store
that have the Dirty field true.
What should be done with these pages?
.EP \n+(E+.
A particular database program repeatedly scans an array of 1,000 pages.
Each scan starts with page 0 and continues to page 999.
There is only enough main store to hold 100 pages.
None of the page-replacement policies given in this chapter does very well.
Suggest a different policy that will do as well as Min for this program.
.EP \n+(E+.
How can the child distinguish itself from the parent after a Split service
call?
.IN Split "Service call"
.EP \n+(E+.
Consider a computer that supports two different page sizes, 512 bytes and 4K
bytes.
All the pages in a virtual space must be of one size or the other.
What advantages can the operating system derive from this ability?
How hard is it to achieve these benefits?
.EP \n+(E+.
Why is it necessary to use the eager method for updating composite
address-translation tables when a client updates a privileged-state table?
.IN "Composite" "address-translation tables"
.EE
