.SH 1 "Exercises"
.ES
.nr E+ 0 1
.EP \n+(E+.
What does the scheduler do under RR when there is only one process that can
run?
.EP \n+(E+.
What does the scheduler do under RR when there are no processes that can run?
.EP \n+(E+.
Of all the policies discussed in the chapter, which requires the least amount
of \fBoverhead time\fP, that is, time needed to compute the policy?
.IN "Overhead time"
.EP \n+(E+.
Which of the policies would you prefer if @rho~=~2@?
.EP \n+(E+.
The expected amount of time needed by a process is always @1 / beta@ under
the exponential distribution.
Is a process therefore expected never to terminate?
.EP \n+(E+.
Consider the following process arrival list:
.(b L
.TS
box, center;
cb | cb cb
cb | n n.
.sp 3p
Name	Arrival time	Service time
.sp 3p
_
.sp 3p
A	0	3
B	2	6
C	3	10
D	7	1
E	8	5
F	15	2
G	25	7
.sp 3p
.TE
.)b
Figure \n(ch.\n+(FN depicts this situation graphically.
.(b
.GS
width 4
file figs/fig.2.ex.arrival
.GE
.FI "Process arrival list"
.)b
Complete the figure, showing which process is executing over time,
and calculate @T@, @M@, and @P@ for each process,
under the following policies:
FCFS, SPN, PSPN, HPRN, RR with @q ~=~ 1@, RR with @q ~=~ 5@,
and SRR with @b ~/~ a ~=~ 0.5 ~ {roman and}  ~ q ~=~ 1@.
.IN "First-come, first served (FCFS)"
.IN "Round Robin (RR)"
.IN "Shortest Process Next (SPN)"
.IN "Preemptive Shortest Process Next (PSPN)"
.IN "Highest penalty ratio next (HPRN)"
Assume that if events are scheduled to happen at exactly the same time,
new arrivals precede terminations, which precede quantum expirations.
.EP \n+(E+.
Here are some procedures that give you exponentially distributed random
numbers:
.IN "Random numbers"
.(b
.FS
\fWfunction\fP Random(\fWvar\fP Seed : integer) : real;
.fi
{ Linear-congruential random number generator, for 32-bit
computers.   Start the Seed anywhere you like, but then don't
touch it.  Returns a pseudo-random number between 0 and 1.  }
.nf
\fWconst\fP
	Multiplier = 1103515245;
	Adder = 12345;
	Modulus = 2147483648; { 2 ** 31 }
\fWbegin\fP
	Seed := (Seed * Multiplier + Adder) mod Modulus;
	Random := Seed / Modulus;
\fWend\fP Random;

.IN "Exponential distribution"
\fWfunction\fP Expo(Lambda: real; \fWvar\fP Seed : integer) : real;
.fi
{ Returns a random number distributed according to the exponential
distribution with parameter Lambda.  Seed should be set once and
then not touched. }
.nf
\fWbegin\fP
	Expo:= -ln(Random(Seed)) / Lambda;
\fWend\fP Expo;
.FE
.)b
Write a program to generate 1000 samples from Expo(3) and draw a histogram
(a bar graph)
showing how many samples fall in each interval of length 0.1 from 1 to 10.
For example, how many samples were in the half-open interval (2.3, 2.4]?
.EP \n+(E+.
Write a program that
generates @n@ processes, with arrival intervals drawn from an exponential
distribution with parameter @alpha@ and service requirements drawn from
an exponential distribution with parameter @beta@.
The program then schedules these processes according to either FCFS or SPN and
.IN "First-come, first served (FCFS)"
.IN "Shortest Process Next (SPN)"
computes @T@, @M@, @P@, and @R@ for each process.
Run your program with @n ~=~ 100 ~{roman and}~rho ~=~ 0.5,~ 0.9,~ 1.5@.
.EP \n+(E+.
Using a similar program, show the length of the ready list for FCFS
.IN "First come, first served (FCFS)"
and how it changes over time when @rho@ = 0.5, 0.9, and 1.5.
Can you predict the average length just knowing @rho@?
.EP \n+(E+.
Devise a data structure that allows SRR to be implemented efficiently.
.IN "Selfish Round Robin (SRR)"
In particular, how do we organize the new list, and how do we store the current
priorities?
.EP \n+(E+.
Predict the behavior of the LCFS (last come, first served) non-preemptive
policy.
.IN "Last come, first served (LCFS)"
Simulate this policy with a program, and compare the results to your prediction.
.EP \n+(E+.
Repeat the previous exercise with a preemptive LCFS policy.
.EP \n+(E+.
Consider a preemptive HPRN policy.
.IN "Highest penalty ratio next (HPRN)"
Can it be implemented exactly?
If not, how would you approximate it?
.EP \n+(E+.
What countermeasures can an inherently short process take to get better
service if the scheduling method favors long processes?
.EP \n+(E+.
Which of the methods discussed in this chapter have a scheduling cost that is
independent of the number of processes in the ready list?
.EP \n+(E+.
Some operating systems are used in environments where processes must get
guaranteed service.
\fBDeadline scheduling\fP means that each process specifies how much service
time it needs and by what real time it must be finished.
Design a preemptive algorithm that services such processes.
There will be occasions when deadlines cannot be met; try to discover these
situations as early as possible (before starting a process at all if it cannot
be finished in time).
.EE
