#!/usr/local/bin/tclsh

# See if there is important unread mail.
#  Copyright (c) 2001 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

set trouble ""
set mailDir [exec ./enumerate.tcl mailDir]
set confFile [open ./unreadmail.conf r]
while {[gets $confFile line]>=0} { # one line of configuration
    if [regexp ^# $line] continue ;# comment line
    if [regexp ^$ $line] continue ;# empty line
	set mailFile $mailDir/$line
	if {[file exists $mailFile]} {
		set mailLength [file size $mailFile]
	} else {
		set mailLength 0
	}
	if {$mailLength > 0} {
		append trouble "\n  $line: $mailLength bytes"
	}
}

if {$trouble == ""} {
	report mail $myHost 1 "no bytes of important unread mail"
	puts "no bytes of important unread mail"
} else {
	report mail $myHost 10 "Unread mail on $myHost:$trouble"
	puts "Unread mail on $myHost:$trouble"
}

exit 0
