.SH 1 "Further reading"
.lp
Good's article
.[
good etude folklore
.]
presents a clear description of the desired characteristics of
a command interpreter.
It has an extensive bibliography that can guide you to other literature about
command interpretation.
Kernighan and Pike
.[
kernighan pike
.]
have written an extensive introduction to the Unix command
interpreter and the Unix environment in general.
.IN "Unix" "operating system"
One description of a window package can be found in the paper by Meyrowitz and
Moser.
.[
meyrowitz moser
.]
Another window package intended for use in a multiple-process environment has
been described by Lantz and Rashid.
.[
lantz virtual terminal
.]
A number of integrated programming environments have been built, including
the Cornell program synthesizer
.[
teitelbaum reps horwitz
.]
and the Pascal-oriented editor.
.[
fischer poe
.]
An extremely fancy text formatting program, TeX, is described by Knuth.
.[
knuth texbook
.]
One example of the attempt to unify all program interaction under the aegis of
editing is the recent thesis by Dewan.
.[
dewan thesis
.]
.SH 1 "Exercises"
.ES
.nr E+ 0 1
.EP \n+(E+.
Describe the features available in a command language with which you are
familiar.
What features described in this chapter are not available?
Are these omissions due to design outside the command interpreter, or could
they be added?
For those that could be added, suggest a syntax.
For those that cannot be added, explain why.
.EP \n+(E+.
In what way are the commands one might give an interactive file manager similar
to the commands one might give a text editor?
In what way are they different?
.EP \n+(E+.
If the operating system does not provide for any inter-process data transfer,
how can the command interpreter establish a pipeline that directs the output of
one process into the input of another?
.EP \n+(E+.
How do pipelines of processes and the ability for processes to start
subordinate processes interfere with each other?
.EP \n+(E+.
Find out what computer networks are accessible to your computer.
What is the form of a mail address on these networks?
.EP \n+(E+.
A message sent to someone's terminal can be a nuisance
to the recipient.
Design some mechanism to allow users to restrict incoming messages.
.EP \n+(E+.
It was recently discovered that
the ability to send arbitrary messages to someone's terminal can introduce
security problems.
The problem arises because a debugging feature of the terminal allows it to
enter a mode in which it echoes all data coming from the computer back to the
computer.
How do the two features, messages and terminal debugging, combine to create a
problem?
.EP \n+(E+.
Some operating systems allow programs to load the terminal input buffer with
characters as if the user had typed them in.
These characters are then displayed; the user can modify them and activate the
line.
When would such a facility be useful?
When would it be harmful?
.EE
