/*
 * $Header: /usr/src/misc/ditroff/troff/RCS/tdef.h,v 1.4 89/07/25 16:37:52 tim Exp $
 *
 * $Log:	tdef.h,v $
 * Revision 1.4  89/07/25  16:37:52  tim
 * Merge bug fixes in from DWB2
 * 
 * Revision 1.3  89/07/25  11:10:33  tim
 * make more palatable for RT compiler
 * 
 * Revision 1.2  89/06/06  16:59:49  tim
 * add support for stipples, drawing commands (THICK, STYLE, POLY, UBPOLY)
 * 
 * Revision 1.1  89/05/23  11:57:29  tim
 * Initial revision
 * 
 */


/* starting values for typesetting parameters: */

#define	PS	10	/* default point size */
#define	FT	1	/* default font position */
#define STIP	1	/* default stipple */
#define ULFONT	2	/* default underline font */
#define	BDFONT	3	/* default emboldening font */
#define	BIFONT	4	/* default bold italic font */
#define	LL	(unsigned) 65*INCH/10	/* line length; 39picas=6.5in */
#define	VS	((12*INCH)/72)	/* initial vert space */

#ifdef	NROFF
#	define	EM	t.Em
#	define	HOR	t.Adj
#	define	VERT	t.Vert
#	define	INCH	240	/* increments per inch */
#	define	SPS	INCH/10	/* space size */
#	define	SS	INCH/10	/* " */
#	define	TRAILER	0
#	define	PO	0 /* page offset */
#	define	ASCII	1
#	define	PTID	1
#	define	LG	0
#	define	DTAB	0	/* set at 8 Ems at init time */
#	define	ICS	2*SPS
#endif
#ifndef NROFF	/* TROFF */
	/* Inch is set by ptinit() when troff started.
	/* all derived values set then too
	*/
#	define	INCH	Inch	/* troff resolution -- number of goobies/inch  */
#	define	POINT	(INCH/72)	/* goobies per point (1/72 inch) */
#	define	HOR	Hor	/* horizontal resolution in goobies */
#	define	VERT	Vert	/* vertical resolution in goobies */
#	define	SPS	(EM/3)	/* space size  */
#	define	SS	12	/* space size in 36ths of an em */
#	define	PO	(INCH)	/* page offset 1 inch */
#	define	EM	(((long) INCH * pts + 36) / 72)	/* don't lose significance */
#	define	EMPTS(pts)	(((long) INCH * (pts) + 36) / 72)
#	define	ASCII	0
#	define	PTID	1
#	define	LG	1
#	define	DTAB	(INCH/2)
#	define	ICS	(3*SPS)
#endif

/* These "characters" are used to encode various internal functions
/* Some make use of the fact that most ascii characters between
/* 0 and 040 don't have any graphic or other function.
/* The few that do have a purpose (e.g., \n, \b, \t, ...
/* are avoided by the ad hoc choices here.
/* See ifilt[] in n1.c for others -- 1, 2, 3, 5, 6, 7, 010, 011, 012 
*/

#define	LEADER	001
#define	IMP	004	/* impossible char; glues things together */
#define	TAB	011
#define	RPT	014	/* next character is to be repeated many times */
#define	CHARHT	015	/* size field sets character height */
#define	SLANT	016	/* size field sets amount of slant */
#define	DRAWFCN	017	/* next several chars describe arb drawing fcns */
#	define	DRAWTHICK	't'
#	define	DRAWSTYLE	's'
#	define	DRAWLINE	'l'	/* line: 'l' dx dy char */
#	define	DRAWCIRCLE	'c'	/* circle: 'c' r */
#	define	DRAWELLIPSE	'e'	/* ellipse: 'e' rx ry */
#	define	DRAWARC		'a'	/* arc: 'a' dx dy dx dy */
#if UK
#	define	DRAWPOLY	'P'	/* filled, border polygon */
#	define	DRAWUBPOLY	'p'	/* filled, no border polygon */
#else
#	define	DRAWPOLY	'p'	/* polygon with stipples */
#	define	DRAWUBPOLY	'P'	/* polygon, stipples, no border */
#endif
#	define	DRAWCURVE	'g'	/* gremlin spline */
#	define	DRAWSPLINE	'~'	/* quadratic B spline: '~' dx dy dx dy ... */
					/* other splines go thru too */
/* NOTE:  the use of ~ is a botch since it's often used in .tr commands */
/* better to use a letter like s, but change it in the postprocessors too */

#define	LEFT	020	/* \{ */
#define	RIGHT	021	/* \} */
#define	FILLER	022	/* \& and similar purposes */
#define	XON	023	/* \X'...' starts here */
#define	OHC	024	/* optional hyphenation character \% */
#define	CONT	025	/* \c character */
#define	PRESC	026	/* printable escape */
#define	UNPAD	027	/* unpaddable blank */
#define	XPAR	030	/* transparent mode indicator */
#define	FLSS	031	/* next tchar contains vertical space */
			/* used when recalling diverted text */
#define	WORDSP	032	/* paddable word space */
#define	ESC	033	/* current escape character */
#define	XOFF	034	/* \X'...' ends here */
			/* matches XON, but they will probably never nest */
			/* so could drop this when another control is needed */

#define	iscontrol(n)	(n==035 || n==036)	/* used to test the next two */
#define	HX	035	/* next character is value of \x'...' */
#define	FONTPOS	036	/* position of font \f(XX encoded in top */

#define	HYPHEN	c_hyphen
#define	EMDASH	c_emdash	/* \(em */
#define	RULE	c_rule		/* \(ru */
#define	MINUS	c_minus		/* minus sign on current font */
#define	LIG_FI	c_fi		/* \(ff */
#define	LIG_FL	c_fl		/* \(fl */
#define	LIG_FF	c_ff		/* \(ff */
#define	LIG_FFI	c_ffi		/* \(Fi */
#define	LIG_FFL	c_ffl		/* \(Fl */
#define	ACUTE	c_acute		/* acute accent \(aa */
#define	GRAVE	c_grave		/* grave accent \(ga */
#define	UNDERLINE c_under	/* \(ul */
#define	ROOTEN	c_rooten	/* root en \(rn */
#define	BOXRULE	c_boxrule	/* box rule \(br */
#define	LEFTHAND c_lefthand	/* left hand for word overflow */
#define	DAGGER	c_dagger	/* dagger for footnotes */

/* array sizes, and similar limits: */

#define	NFONT	10	/* maximum number of fonts (including specials) */
#define	EXTRAFONT 500	/* extra space for swapping a font */
#define	NN	400	/* number registers */
#define	NNAMES	15	 /* predefined reg names */
#define	NIF	15	/* if-else nesting */
#define	NS	128	/* name buffer */
#define	NTM	256	/* tm buffer */
#define	NEV	3	/* environments */
#define	EVLSZ	10	/* size of ev stack */
#define	DSIZE	512	/* disk sector size in chars */

#define	NM	500	/* requests + macros */
#define	DELTA	1024	/* delta core bytes */
#define	NHYP	10	/* max hyphens per word */
#define	NHEX	128	/* byte size of exception word list */
#define	NTAB	40	/* tab stops */
#define	NSO	5	/* "so" depth */
#define	NMF	5	/* number of -m flags */
#define	WDSIZE	270	/* word buffer size */
#define	LNSIZE	680	/* line buffer size */
#define	OLNSIZE	780	/* output line buffer;  bigger for 'w', etc. */
#define	NDI	5	/* number of diversions */
#define	NCHARS	512	/* maximum size of troff character set */
#define	NTRTAB	NCHARS	/* number of items in trtab[] */
#define NWIDCACHE NCHARS	/* number of items in widcache[] */
#define	NTRAP	20	/* number of traps */
#define	NPN	20	/* numbers in "-o" */
#define	FBUFSZ	256	/* field buf size words */
#define	OBUFSZ	4096	/* bytes */
#define	IBUFSZ	4096	/* bytes */
#define	NC	1024	/* cbuf size words */
#define	NOV	10	/* number of overstrike chars */
#define	NPP	10	/* pads per field */

/*
	Internal character representation:
	Internally, every character is carried around as
	a 32 bit cookie, called a "tchar" (typedef long).
	Bits are numbered 31..0 from left to right.
	If bit 15 is 1, the character is motion, with
		if bit 16 it's vertical motion
		if bit 17 it's negative motion
	If bit 15 is 0, the character is a real character.
		if bit 31	zero motion
		bits 30..24	size
		bits 23..16	font
*/

/* in the following, "L" should really be a tchar, but ... */

#define	MOT	(01L<<15)	/* motion character indicator */
#define	MOTV	(07L<<15)	/* clear for motion part */
#define	VMOT	(01L<<16)	/* vert motion bit */
#define	NMOT	(01L<<17)	/* negative motion indicator*/
#define	MAXMOT	32767	/* bad way to write this!!! */
#define	ismot(n)	((n) & MOT)
#define	isvmot(n)	((n) & VMOT)	/* must have tested MOT previously */
#define	isnmot(n)	((n) & NMOT)	/* ditto */
#define	absmot(n)	(unsigned)(0177777 & (n) & ~MOT)	/* (short) is cheap mask */

#define	ZBIT	(01L << 31)	/* zero width char */
#define	iszbit(n)	((n) & ZBIT)

#define	SMASK		(0177L << 24)
#define	FMASK		(0377L << 16)
#define	SFMASK		(SMASK|FMASK)	/* size and font in a tchar */
#define	sbits(n)	(((n) >> 24) & 0177)
#define	fbits(n)	(((n) >> 16) & 0377)
#define	sfbits(n)	(unsigned)(0177777 & (((n) & SFMASK) >> 16))
#define	cbits(n)	(unsigned)(0177777 & (n))	/* isolate bottom 16 bits  */

#define	setsbits(n,s)	n = (n & ~SMASK) | (tchar)(s) << 24
#define	setfbits(n,f)	n = (n & ~FMASK) | (tchar)(f) << 16
#define	setsfbits(n,sf)	n = (n & ~SFMASK) | (tchar)(sf) << 16
#define	setcbits(n,c)	n = (n & ~077777L | (c))	/* set character bits */

#define	BYTEMASK	0377
#define	BYTE	8

#define	ZONE	5	/* 5 hrs for EST */
#define	TABMASK	 037777
#define	RTAB	(unsigned) 0100000
#define	CTAB	040000

#define	TABBIT	02		/* bits in gchtab */
#define	LDRBIT	04
#define	FCBIT	010

#define	PAIR(A,B)	(A|(B<<BYTE))

#define	oput(c)	if ((*obufp++ = (c)), obufp >= &obuf[OBUFSZ]) flusho(); else

/*
 * "temp file" parameters.  macros and strings
 * are stored in an array of linked blocks,
 * which may be in memory and an array called
 * corebuf[], if INCORE is set during
 * compilation, or otherwise in a file called trtmp$$.

 * The numerology is delicate if filep is 16 bits:
	#define BLK 128
	#define NBLIST 512
 * i.e., the product is 16 bits long.

 * If filep is an unsigned long (and if your
 * compiler will let you say that) then NBLIST
 * can be a lot bigger.  Of course that makes
 * the file or core image a lot bigger too,
 * and means you don't detect missing diversion
 * terminations as quickly... .
 * It also means that you may have trouble running
 * on non-swapping systems, since the core image
 * will be over 1Mb.

 * BLK must be a power of 2
 */

typedef unsigned int filep;	/* this is good for 32 bit machines */

#define	BLK	128	/* alloc block in tchars */

#ifdef SMALLER
#	define	NBLIST	512
#else
#	define	NBLIST	2048	/* allocation list.  smallish machines use 512 */
				/* machines without paging can use 1024 */
#endif

/* Other things are stored in the temp file or corebuf:
 *	a single block for .rd input, at offset RD_OFFSET
 *	NEV copies of the environment block, at offset ENV_OFFSET

 * The existing implementation assumes very strongly that
 * these are respectively NBLIST*BLK and 0.

 */

#define	RD_OFFSET	(NBLIST * BLK)
#define ENV_OFFSET	0
#define	ENV_BLK		((NEV * sizeof(env) / sizeof(tchar) + BLK-1) / BLK)
				/* rounded up to even BLK */

typedef	long	tchar;

extern	tchar	getch(), getch0();
#ifdef NROFF
extern	tchar	gettch();
#endif
extern	tchar	rbf(), rbf0();
extern	tchar	mot(), hmot(), vmot();
extern	tchar	makem(), sethl();
extern	tchar	popi();
extern	tchar	getlg();
extern	tchar	xlss();
extern	tchar	setfield();
extern	tchar	setz();
extern	tchar	setch();
extern	tchar	setht(), setslant();

#define	atoi()	((int) atoi0())
extern	long	atoi0();

extern	int	Inch, Hor, Vert, Unitwidth;

/* these characters are used as various signals or values
/* in miscellaneous places.
/* values are set in specnames in t10.c
*/

extern int	c_hyphen;
extern int	c_emdash;
extern int	c_rule;
extern int	c_minus;
extern int	c_fi;
extern int	c_fl;
extern int	c_ff;
extern int	c_ffi;
extern int	c_ffl;
extern int	c_acute;
extern int	c_grave;
extern int	c_under;
extern int	c_rooten;
extern int	c_boxrule;
extern int	c_lefthand;
extern int	c_dagger;

extern int	stderr;	/* this is NOT the stdio value! */

#ifdef	DEBUG
extern	int	debug;	/*debug flag*/
#define	DB_MAC	01	/*print out macro calls*/
#define	DB_ALLC	02	/*print out message from alloc()*/
#define	DB_GETC	04	/*print out message from getch()*/
#define	DB_LOOP	010	/*print out message before "Eileen's loop" fix*/
#endif	DEBUG

struct	d {	/* diversion */
	filep	op;
	int	dnl;
	int	dimac;
	int	ditrap;
	int	ditf;
	int	alss;
	int	blss;
	int	nls;
	int	mkline;
	int	maxl;
	int	hnl;
	int	curd;
};

struct	s {	/* stack frame */
	int	nargs;
	struct s *pframe;
	filep	pip;
	int	pnchar;
	tchar	prchar;
	int	ppendt;
	tchar	pch;
	tchar	*lastpbp;
	int	mname;
};

extern struct contab {
	unsigned short	rq;
	struct	contab *link;
	int	(*f)();
	unsigned mx;
} contab[NM];

extern struct numtab {
	short	r;		/* name */
	short	fmt;
	short	inc;
	int	val;
	struct	numtab *link;
} numtab[NN];

#define	PN	0
#define	NL	1
#define	YR	2
#define	HP	3
#define	CT	4
#define	DN	5
#define	MO	6
#define	DY	7
#define	DW	8
#define	LN	9
#define	DL	10
#define	ST	11
#define	SB	12
#define	CD	13
#define	PID	14

/* the infamous environment block */

#define	ics	env.e_ics
#define	sps	env.e_sps
#define	spacesz	env.e_spacesz
#define	lss	env.e_lss
#define	lss1	env.e_lss1
#define	ll	env.e_ll
#define	ll1	env.e_ll1
#define	lt	env.e_lt
#define	lt1	env.e_lt1
#define	ic	env.e_ic
#define	icf	env.e_icf
#define	chbits	env.e_chbits
#define	spbits	env.e_spbits
#define	nmbits	env.e_nmbits
#define	apts	env.e_apts
#define	apts1	env.e_apts1
#define	pts	env.e_pts
#define	pts1	env.e_pts1
#define	font	env.e_font
#define	font1	env.e_font1
#define	stip	env.e_stip
#define	stip1	env.e_stip1
#define	ls	env.e_ls
#define	ls1	env.e_ls1
#define	ad	env.e_ad
#define	nms	env.e_nms
#define	ndf	env.e_ndf
#define	fi	env.e_fi
#define	cc	env.e_cc
#define	c2	env.e_c2
#define	ohc	env.e_ohc
#define	tdelim	env.e_tdelim
#define	hyf	env.e_hyf
#define	hyoff	env.e_hyoff
#define	un1	env.e_un1
#define	tabc	env.e_tabc
#define	dotc	env.e_dotc
#define	adsp	env.e_adsp
#define	adrem	env.e_adrem
#define	lastl	env.e_lastl
#define	nel	env.e_nel
#define	admod	env.e_admod
#define	wordp	env.e_wordp
#define	spflg	env.e_spflg
#define	linep	env.e_linep
#define	wdend	env.e_wdend
#define	wdstart	env.e_wdstart
#define	wne	env.e_wne
#define	ne	env.e_ne
#define	nc	env.e_nc
#define	nb	env.e_nb
#define	lnmod	env.e_lnmod
#define	nwd	env.e_nwd
#define	nn	env.e_nn
#define	ni	env.e_ni
#define	ul	env.e_ul
#define	cu	env.e_cu
#define	ce	env.e_ce
#define	in	env.e_in
#define	in1	env.e_in1
#define	un	env.e_un
#define	wch	env.e_wch
#define	pendt	env.e_pendt
#define	pendw	env.e_pendw
#define	pendnf	env.e_pendnf
#define	spread	env.e_spread
#define	it	env.e_it
#define	itmac	env.e_itmac
#define	lnsize	env.e_lnsize
#define	hyptr	env.e_hyptr
#define	tabtab	env.e_tabtab
#define	line	env.e_line
#define	word	env.e_word

extern struct env {
	int	e_ics;
	int	e_sps;
	int	e_spacesz;
	int	e_lss;
	int	e_lss1;
	int	e_ll;
	int	e_ll1;
	int	e_lt;
	int	e_lt1;
	tchar	e_ic;
	int	e_icf;
	tchar	e_chbits;
	tchar	e_spbits;
	tchar	e_nmbits;
	int	e_apts;
	int	e_apts1;
	int	e_pts;
	int	e_pts1;
	int	e_stip;
	int	e_stip1;
	int	e_font;
	int	e_font1;
	int	e_ls;
	int	e_ls1;
	int	e_ad;
	int	e_nms;
	int	e_ndf;
	int	e_fi;
	int	e_cc;
	int	e_c2;
	int	e_ohc;
	int	e_tdelim;
	int	e_hyf;
	int	e_hyoff;
	int	e_un1;
	int	e_tabc;
	int	e_dotc;
	int	e_adsp;
	int	e_adrem;
	int	e_lastl;
	int	e_nel;
	int	e_admod;
	tchar	*e_wordp;
	int	e_spflg;
	tchar	*e_linep;
	tchar	*e_wdend;
	tchar	*e_wdstart;
	int	e_wne;
	int	e_ne;
	int	e_nc;
	int	e_nb;
	int	e_lnmod;
	int	e_nwd;
	int	e_nn;
	int	e_ni;
	int	e_ul;
	int	e_cu;
	int	e_ce;
	int	e_in;
	int	e_in1;
	int	e_un;
	int	e_wch;
	int	e_pendt;
	tchar	*e_pendw;
	int	e_pendnf;
	int	e_spread;
	int	e_it;
	int	e_itmac;
	int	e_lnsize;
	tchar	*e_hyptr[NHYP];
	int	e_tabtab[NTAB];
	tchar	e_line[LNSIZE];
	tchar	e_word[WDSIZE];
} env;
