####################################################################
#
#    This file was generated using Parse::Yapp version 1.05.
#
#        Don't edit this file, use source file instead.
#
#             ANY CHANGE MADE HERE WILL BE LOST !
#
####################################################################
package LATR;
use vars qw ( @ISA );
use strict;

@ISA= qw ( Parse::Yapp::Driver );
#Included Parse/Yapp/Driver.pm file----------------------------------------
{
#
# Module Parse::Yapp::Driver
#
# This module is part of the Parse::Yapp package available on your
# nearest CPAN
#
# Any use of this module in a standalone parser make the included
# text under the same copyright as the Parse::Yapp module itself.
#
# This notice should remain unchanged.
#
# (c) Copyright 1998-2001 Francois Desarmenien, all rights reserved.
# (see the pod text in Parse::Yapp module for use and distribution rights)
#

package Parse::Yapp::Driver;

require 5.004;

use strict;

use vars qw ( $VERSION $COMPATIBLE $FILENAME );

$VERSION = '1.05';
$COMPATIBLE = '0.07';
$FILENAME=__FILE__;

use Carp;

#Known parameters, all starting with YY (leading YY will be discarded)
my(%params)=(YYLEX => 'CODE', 'YYERROR' => 'CODE', YYVERSION => '',
			 YYRULES => 'ARRAY', YYSTATES => 'ARRAY', YYDEBUG => '');
#Mandatory parameters
my(@params)=('LEX','RULES','STATES');

sub new {
    my($class)=shift;
	my($errst,$nberr,$token,$value,$check,$dotpos);
    my($self)={ ERROR => \&_Error,
				ERRST => \$errst,
                NBERR => \$nberr,
				TOKEN => \$token,
				VALUE => \$value,
				DOTPOS => \$dotpos,
				STACK => [],
				DEBUG => 0,
				CHECK => \$check };

	_CheckParams( [], \%params, \@_, $self );

		exists($$self{VERSION})
	and	$$self{VERSION} < $COMPATIBLE
	and	croak "Yapp driver version $VERSION ".
			  "incompatible with version $$self{VERSION}:\n".
			  "Please recompile parser module.";

        ref($class)
    and $class=ref($class);

    bless($self,$class);
}

sub YYParse {
    my($self)=shift;
    my($retval);

	_CheckParams( \@params, \%params, \@_, $self );

	if($$self{DEBUG}) {
		_DBLoad();
		$retval = eval '$self->_DBParse()';#Do not create stab entry on compile
        $@ and die $@;
	}
	else {
		$retval = $self->_Parse();
	}
    $retval
}

sub YYData {
	my($self)=shift;

		exists($$self{USER})
	or	$$self{USER}={};

	$$self{USER};
	
}

sub YYErrok {
	my($self)=shift;

	${$$self{ERRST}}=0;
    undef;
}

sub YYNberr {
	my($self)=shift;

	${$$self{NBERR}};
}

sub YYRecovering {
	my($self)=shift;

	${$$self{ERRST}} != 0;
}

sub YYAbort {
	my($self)=shift;

	${$$self{CHECK}}='ABORT';
    undef;
}

sub YYAccept {
	my($self)=shift;

	${$$self{CHECK}}='ACCEPT';
    undef;
}

sub YYError {
	my($self)=shift;

	${$$self{CHECK}}='ERROR';
    undef;
}

sub YYSemval {
	my($self)=shift;
	my($index)= $_[0] - ${$$self{DOTPOS}} - 1;

		$index < 0
	and	-$index <= @{$$self{STACK}}
	and	return $$self{STACK}[$index][1];

	undef;	#Invalid index
}

sub YYCurtok {
	my($self)=shift;

        @_
    and ${$$self{TOKEN}}=$_[0];
    ${$$self{TOKEN}};
}

sub YYCurval {
	my($self)=shift;

        @_
    and ${$$self{VALUE}}=$_[0];
    ${$$self{VALUE}};
}

sub YYExpect {
    my($self)=shift;

    keys %{$self->{STATES}[$self->{STACK}[-1][0]]{ACTIONS}}
}

sub YYLexer {
    my($self)=shift;

	$$self{LEX};
}


#################
# Private stuff #
#################


sub _CheckParams {
	my($mandatory,$checklist,$inarray,$outhash)=@_;
	my($prm,$value);
	my($prmlst)={};

	while(($prm,$value)=splice(@$inarray,0,2)) {
        $prm=uc($prm);
			exists($$checklist{$prm})
		or	croak("Unknow parameter '$prm'");
			ref($value) eq $$checklist{$prm}
		or	croak("Invalid value for parameter '$prm'");
        $prm=unpack('@2A*',$prm);
		$$outhash{$prm}=$value;
	}
	for (@$mandatory) {
			exists($$outhash{$_})
		or	croak("Missing mandatory parameter '".lc($_)."'");
	}
}

sub _Error {
	print "Parse error.\n";
}

sub _DBLoad {
	{
		no strict 'refs';

			exists(${__PACKAGE__.'::'}{_DBParse})#Already loaded ?
		and	return;
	}
	my($fname)=__FILE__;
	my(@drv);
	open(DRV,"<$fname") or die "Report this as a BUG: Cannot open $fname";
	while(<DRV>) {
                	/^\s*sub\s+_Parse\s*{\s*$/ .. /^\s*}\s*#\s*_Parse\s*$/
        	and     do {
                	s/^#DBG>//;
                	push(@drv,$_);
        	}
	}
	close(DRV);

	$drv[0]=~s/_P/_DBP/;
	eval join('',@drv);
}

#Note that for loading debugging version of the driver,
#this file will be parsed from 'sub _Parse' up to '}#_Parse' inclusive.
#So, DO NOT remove comment at end of sub !!!
sub _Parse {
    my($self)=shift;

	my($rules,$states,$lex,$error)
     = @$self{ 'RULES', 'STATES', 'LEX', 'ERROR' };
	my($errstatus,$nberror,$token,$value,$stack,$check,$dotpos)
     = @$self{ 'ERRST', 'NBERR', 'TOKEN', 'VALUE', 'STACK', 'CHECK', 'DOTPOS' };

#DBG>	my($debug)=$$self{DEBUG};
#DBG>	my($dbgerror)=0;

#DBG>	my($ShowCurToken) = sub {
#DBG>		my($tok)='>';
#DBG>		for (split('',$$token)) {
#DBG>			$tok.=		(ord($_) < 32 or ord($_) > 126)
#DBG>					?	sprintf('<%02X>',ord($_))
#DBG>					:	$_;
#DBG>		}
#DBG>		$tok.='<';
#DBG>	};

	$$errstatus=0;
	$$nberror=0;
	($$token,$$value)=(undef,undef);
	@$stack=( [ 0, undef ] );
	$$check='';

    while(1) {
        my($actions,$act,$stateno);

        $stateno=$$stack[-1][0];
        $actions=$$states[$stateno];

#DBG>	print STDERR ('-' x 40),"\n";
#DBG>		$debug & 0x2
#DBG>	and	print STDERR "In state $stateno:\n";
#DBG>		$debug & 0x08
#DBG>	and	print STDERR "Stack:[".
#DBG>					 join(',',map { $$_[0] } @$stack).
#DBG>					 "]\n";


        if  (exists($$actions{ACTIONS})) {

				defined($$token)
            or	do {
				($$token,$$value)=&$lex($self);
#DBG>				$debug & 0x01
#DBG>			and	print STDERR "Need token. Got ".&$ShowCurToken."\n";
			};

            $act=   exists($$actions{ACTIONS}{$$token})
                    ?   $$actions{ACTIONS}{$$token}
                    :   exists($$actions{DEFAULT})
                        ?   $$actions{DEFAULT}
                        :   undef;
        }
        else {
            $act=$$actions{DEFAULT};
#DBG>			$debug & 0x01
#DBG>		and	print STDERR "Don't need token.\n";
        }

            defined($act)
        and do {

                $act > 0
            and do {        #shift

#DBG>				$debug & 0x04
#DBG>			and	print STDERR "Shift and go to state $act.\n";

					$$errstatus
				and	do {
					--$$errstatus;

#DBG>					$debug & 0x10
#DBG>				and	$dbgerror
#DBG>				and	$$errstatus == 0
#DBG>				and	do {
#DBG>					print STDERR "**End of Error recovery.\n";
#DBG>					$dbgerror=0;
#DBG>				};
				};


                push(@$stack,[ $act, $$value ]);

					$$token ne ''	#Don't eat the eof
				and	$$token=$$value=undef;
                next;
            };

            #reduce
            my($lhs,$len,$code,@sempar,$semval);
            ($lhs,$len,$code)=@{$$rules[-$act]};

#DBG>			$debug & 0x04
#DBG>		and	$act
#DBG>		and	print STDERR "Reduce using rule ".-$act." ($lhs,$len): ";

                $act
            or  $self->YYAccept();

            $$dotpos=$len;

                unpack('A1',$lhs) eq '@'    #In line rule
            and do {
                    $lhs =~ /^\@[0-9]+\-([0-9]+)$/
                or  die "In line rule name '$lhs' ill formed: ".
                        "report it as a BUG.\n";
                $$dotpos = $1;
            };

            @sempar =       $$dotpos
                        ?   map { $$_[1] } @$stack[ -$$dotpos .. -1 ]
                        :   ();

            $semval = $code ? &$code( $self, @sempar )
                            : @sempar ? $sempar[0] : undef;

            splice(@$stack,-$len,$len);

                $$check eq 'ACCEPT'
            and do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Accept.\n";

				return($semval);
			};

                $$check eq 'ABORT'
            and	do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Abort.\n";

				return(undef);

			};

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Back to state $$stack[-1][0], then ";

                $$check eq 'ERROR'
            or  do {
#DBG>				$debug & 0x04
#DBG>			and	print STDERR 
#DBG>				    "go to state $$states[$$stack[-1][0]]{GOTOS}{$lhs}.\n";

#DBG>				$debug & 0x10
#DBG>			and	$dbgerror
#DBG>			and	$$errstatus == 0
#DBG>			and	do {
#DBG>				print STDERR "**End of Error recovery.\n";
#DBG>				$dbgerror=0;
#DBG>			};

			    push(@$stack,
                     [ $$states[$$stack[-1][0]]{GOTOS}{$lhs}, $semval ]);
                $$check='';
                next;
            };

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Forced Error recovery.\n";

            $$check='';

        };

        #Error
            $$errstatus
        or   do {

            $$errstatus = 1;
            &$error($self);
                $$errstatus # if 0, then YYErrok has been called
            or  next;       # so continue parsing

#DBG>			$debug & 0x10
#DBG>		and	do {
#DBG>			print STDERR "**Entering Error recovery.\n";
#DBG>			++$dbgerror;
#DBG>		};

            ++$$nberror;

        };

			$$errstatus == 3	#The next token is not valid: discard it
		and	do {
				$$token eq ''	# End of input: no hope
			and	do {
#DBG>				$debug & 0x10
#DBG>			and	print STDERR "**At eof: aborting.\n";
				return(undef);
			};

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Dicard invalid token ".&$ShowCurToken.".\n";

			$$token=$$value=undef;
		};

        $$errstatus=3;

		while(	  @$stack
			  and (		not exists($$states[$$stack[-1][0]]{ACTIONS})
			        or  not exists($$states[$$stack[-1][0]]{ACTIONS}{error})
					or	$$states[$$stack[-1][0]]{ACTIONS}{error} <= 0)) {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Pop state $$stack[-1][0].\n";

			pop(@$stack);
		}

			@$stack
		or	do {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**No state left on stack: aborting.\n";

			return(undef);
		};

		#shift the error token

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Shift \$error token and go to state ".
#DBG>						 $$states[$$stack[-1][0]]{ACTIONS}{error}.
#DBG>						 ".\n";

		push(@$stack, [ $$states[$$stack[-1][0]]{ACTIONS}{error}, undef ]);

    }

    #never reached
	croak("Error in driver logic. Please, report it as a BUG");

}#_Parse
#DO NOT remove comment

1;

}
#End of include--------------------------------------------------


#line 2 "LATR.yp"

# This is a parser for the latr language.
# It is based on a BNF, and has used Yapp to convert it to Perl
#
#
#line 9 "LATR.yp"

BEGIN {
    push (@INC, "/a/zonker/u/zon-d1/csgrad/meares/ling/yapp/Parse-Yapp-1.05/lib");
}


use vars qw/ @words @variables @slots $myCount $nodeName 
$input $output 
@rules @toShow @redirects %isLeaf $Infile $leafIn $leafOut @NotList 
$isRest $NodeOutput $next %varAssign $substVal %subst @StarList $Debug 
%varsdecs @OptList $traceRule @TypeList %startVars @doTrace $search @cRules 
@DepthRules @leaf @parsedTheory @varIn @typeIn %Depth %varDecls/ ;

my @Vars = ("X", "Y", "Z", "A", "B", "C", "M", "N", "I", "J", "K");

# The Terminals Recognizable
my %Term   = (
  ","	    => "Comma",
  "."       => "Period",
  "\n"      => "Endline",
  "%"       => "PC",
  ":"       => "Colon",
  ">"       => "GT",
  "="       => "Eq",
  "("       => "LP",
  ")"       => "RP",
  "\$" 	    => "DS",
  "\/"	    => "SL",
  "/*" 	    => "SLStar",
  "*/"      => "StarSL",
  "#type" => "SlotStart",
  "#vars"  => "VStart",
  "#show"  => "SStart",
  "#hide"  => "HStart",
  "#leaf"  => "LStart",
  "#trace" => "TRACE",
  "or"     => "OR",
  "*" => "CProd",
  "+"      => "Plus",
  "-"	   => "Minus",
  "SELF"   => "Self",
  "REST"   => "Rest",
  "LEAF"   => "Leaf",
  "START"  => "Start",
  "set"	   => "SET",
  "list"   => "LIST",
);


sub new {
        my($class)=shift;
        ref($class)
    and $class=ref($class);

    my($self)=$class->SUPER::new( yyversion => '1.05',
                                  yystates =>
[
	{#State 0
		ACTIONS => {
			'' => -1,
			'Uppercase_String' => 1,
			'SLStar' => 13,
			'HStart' => 12,
			'VStart' => 15,
			'SlotStart' => 17,
			'PC' => 18,
			'LStart' => 20,
			'error' => 6,
			'Endline' => 7,
			'SStart' => 8
		},
		GOTOS => {
			'nodestart' => 2,
			'show' => 11,
			'nodename' => 14,
			'hide' => 19,
			'document' => 3,
			'vars' => 16,
			'comments' => 5,
			'node' => 4,
			'leaf' => 10,
			'slot' => 9
		}
	},
	{#State 1
		DEFAULT => -56
	},
	{#State 2
		ACTIONS => {
			'DS' => 25,
			'LP' => 27
		},
		DEFAULT => -27,
		GOTOS => {
			'vardecl' => 21,
			'lhs' => 24,
			'varname' => 26,
			'rule' => 22,
			'rules' => 23
		}
	},
	{#State 3
		ACTIONS => {
			'' => 28
		}
	},
	{#State 4
		ACTIONS => {
			'' => -1,
			'Uppercase_String' => 1,
			'SLStar' => 13,
			'HStart' => 12,
			'VStart' => 15,
			'SlotStart' => 17,
			'PC' => 18,
			'LStart' => 20,
			'error' => 6,
			'Endline' => 7,
			'SStart' => 8
		},
		GOTOS => {
			'nodestart' => 2,
			'show' => 11,
			'nodename' => 14,
			'hide' => 19,
			'document' => 29,
			'vars' => 16,
			'comments' => 5,
			'node' => 4,
			'slot' => 9,
			'leaf' => 10
		}
	},
	{#State 5
		ACTIONS => {
			'' => -1,
			'Uppercase_String' => 1,
			'SLStar' => 13,
			'HStart' => 12,
			'VStart' => 15,
			'SlotStart' => 17,
			'PC' => 18,
			'LStart' => 20,
			'error' => 6,
			'Endline' => 7,
			'SStart' => 8
		},
		GOTOS => {
			'nodestart' => 2,
			'show' => 11,
			'nodename' => 14,
			'hide' => 19,
			'document' => 30,
			'vars' => 16,
			'comments' => 5,
			'node' => 4,
			'slot' => 9,
			'leaf' => 10
		}
	},
	{#State 6
		ACTIONS => {
			'Period' => 31
		}
	},
	{#State 7
		ACTIONS => {
			'' => -1,
			'Uppercase_String' => 1,
			'SLStar' => 13,
			'HStart' => 12,
			'VStart' => 15,
			'SlotStart' => 17,
			'PC' => 18,
			'LStart' => 20,
			'error' => 6,
			'Endline' => 7,
			'SStart' => 8
		},
		GOTOS => {
			'nodestart' => 2,
			'show' => 11,
			'nodename' => 14,
			'hide' => 19,
			'document' => 32,
			'vars' => 16,
			'comments' => 5,
			'node' => 4,
			'slot' => 9,
			'leaf' => 10
		}
	},
	{#State 8
		ACTIONS => {
			'LP' => 33
		}
	},
	{#State 9
		ACTIONS => {
			'' => -1,
			'Uppercase_String' => 1,
			'SLStar' => 13,
			'HStart' => 12,
			'VStart' => 15,
			'SlotStart' => 17,
			'PC' => 18,
			'LStart' => 20,
			'error' => 6,
			'Endline' => 7,
			'SStart' => 8
		},
		GOTOS => {
			'nodestart' => 2,
			'show' => 11,
			'nodename' => 14,
			'hide' => 19,
			'document' => 34,
			'vars' => 16,
			'comments' => 5,
			'node' => 4,
			'slot' => 9,
			'leaf' => 10
		}
	},
	{#State 10
		ACTIONS => {
			'' => -1,
			'Uppercase_String' => 1,
			'SLStar' => 13,
			'HStart' => 12,
			'VStart' => 15,
			'SlotStart' => 17,
			'PC' => 18,
			'LStart' => 20,
			'error' => 6,
			'Endline' => 7,
			'SStart' => 8
		},
		GOTOS => {
			'nodestart' => 2,
			'show' => 11,
			'nodename' => 14,
			'hide' => 19,
			'document' => 35,
			'vars' => 16,
			'comments' => 5,
			'node' => 4,
			'slot' => 9,
			'leaf' => 10
		}
	},
	{#State 11
		ACTIONS => {
			'' => -1,
			'Uppercase_String' => 1,
			'SLStar' => 13,
			'HStart' => 12,
			'VStart' => 15,
			'SlotStart' => 17,
			'PC' => 18,
			'LStart' => 20,
			'error' => 6,
			'Endline' => 7,
			'SStart' => 8
		},
		GOTOS => {
			'nodestart' => 2,
			'show' => 11,
			'nodename' => 14,
			'hide' => 19,
			'document' => 36,
			'vars' => 16,
			'comments' => 5,
			'node' => 4,
			'slot' => 9,
			'leaf' => 10
		}
	},
	{#State 12
		ACTIONS => {
			'Uppercase_String' => 1
		},
		DEFAULT => -72,
		GOTOS => {
			'nodeList' => 38,
			'nodename' => 37
		}
	},
	{#State 13
		ACTIONS => {
			'Colon' => 41,
			'SET' => 40,
			'CProd' => 39,
			'Start' => 42,
			'Number' => 43,
			'RP' => 44,
			'Lowercase_String' => 45,
			'TRACE' => 48,
			'HStart' => 49,
			'VStart' => 50,
			'SlotStart' => 51,
			'Period' => 52,
			'LP' => 53,
			'PC' => 54,
			'LStart' => 56,
			'LIST' => 55,
			'SL' => 57,
			'OR' => 58,
			'Uppercase_String' => 60,
			'Rest' => 61,
			'Any_String' => 62,
			'Eq' => 64,
			'Self' => 65,
			'Plus' => 66,
			'Endline' => 67,
			'SStart' => 68,
			'GT' => 69,
			'SLStar' => 70,
			'DS' => 71,
			'Comma' => 73,
			'Leaf' => 75,
			'Minus' => 74
		},
		DEFAULT => -13,
		GOTOS => {
			'multiline' => 63,
			'any' => 72,
			'noneRuletokens' => 46,
			'anystring' => 47,
			'anytoken' => 59
		}
	},
	{#State 14
		ACTIONS => {
			'Colon' => 76
		}
	},
	{#State 15
		ACTIONS => {
			'DS' => 25
		},
		GOTOS => {
			'varname' => 77
		}
	},
	{#State 16
		ACTIONS => {
			'' => -1,
			'Uppercase_String' => 1,
			'SLStar' => 13,
			'HStart' => 12,
			'VStart' => 15,
			'SlotStart' => 17,
			'PC' => 18,
			'LStart' => 20,
			'error' => 6,
			'Endline' => 7,
			'SStart' => 8
		},
		GOTOS => {
			'nodestart' => 2,
			'show' => 11,
			'nodename' => 14,
			'document' => 78,
			'vars' => 16,
			'node' => 4,
			'comments' => 5,
			'hide' => 19,
			'slot' => 9,
			'leaf' => 10
		}
	},
	{#State 17
		ACTIONS => {
			'Lowercase_String' => 79
		},
		GOTOS => {
			'slotname' => 80
		}
	},
	{#State 18
		ACTIONS => {
			'Colon' => 41,
			'SET' => 40,
			'CProd' => 39,
			'Start' => 42,
			'Number' => 43,
			'RP' => 44,
			'Lowercase_String' => 45,
			'TRACE' => 48,
			'HStart' => 49,
			'VStart' => 50,
			'SlotStart' => 51,
			'Period' => 52,
			'LP' => 53,
			'PC' => 54,
			'LStart' => 56,
			'LIST' => 55,
			'SL' => 57,
			'OR' => 58,
			'Uppercase_String' => 60,
			'Rest' => 61,
			'Any_String' => 62,
			'Self' => 65,
			'Eq' => 64,
			'StarSL' => 82,
			'Plus' => 66,
			'GT' => 69,
			'SStart' => 68,
			'SLStar' => 70,
			'DS' => 71,
			'Comma' => 73,
			'Minus' => 74,
			'Leaf' => 75
		},
		DEFAULT => -16,
		GOTOS => {
			'singleline' => 81,
			'any' => 83,
			'noneRuletokens' => 46,
			'anystring' => 47,
			'anytoken' => 59
		}
	},
	{#State 19
		ACTIONS => {
			'' => -1,
			'Uppercase_String' => 1,
			'SLStar' => 13,
			'HStart' => 12,
			'VStart' => 15,
			'SlotStart' => 17,
			'PC' => 18,
			'LStart' => 20,
			'error' => 6,
			'Endline' => 7,
			'SStart' => 8
		},
		GOTOS => {
			'nodestart' => 2,
			'show' => 11,
			'nodename' => 14,
			'document' => 84,
			'vars' => 16,
			'node' => 4,
			'comments' => 5,
			'hide' => 19,
			'slot' => 9,
			'leaf' => 10
		}
	},
	{#State 20
		ACTIONS => {
			'Lowercase_String' => 79
		},
		GOTOS => {
			'slotname' => 85
		}
	},
	{#State 21
		ACTIONS => {
			'LP' => 86
		},
		DEFAULT => -31
	},
	{#State 22
		ACTIONS => {
			'Comma' => 87
		}
	},
	{#State 23
		ACTIONS => {
			'Period' => 88
		}
	},
	{#State 24
		ACTIONS => {
			'Eq' => 89
		}
	},
	{#State 25
		ACTIONS => {
			'Uppercase_String' => 60,
			'Any_String' => 62,
			'Lowercase_String' => 45
		},
		GOTOS => {
			'anystring' => 90
		}
	},
	{#State 26
		ACTIONS => {
			'Colon' => 91
		}
	},
	{#State 27
		ACTIONS => {
			'Rest' => 97,
			'Uppercase_String' => 60,
			'Any_String' => 62,
			'DS' => 25,
			'Number' => 93,
			'Lowercase_String' => 45,
			'SL' => 96
		},
		DEFAULT => -34,
		GOTOS => {
			'vardecl' => 98,
			'atomorvars' => 92,
			'atomorvar' => 99,
			'atombase' => 100,
			'varname' => 95,
			'anystring' => 94
		}
	},
	{#State 28
		DEFAULT => 0
	},
	{#State 29
		DEFAULT => -9
	},
	{#State 30
		DEFAULT => -3
	},
	{#State 31
		ACTIONS => {
			'' => -1,
			'Uppercase_String' => 1,
			'SLStar' => 13,
			'HStart' => 12,
			'VStart' => 15,
			'SlotStart' => 17,
			'PC' => 18,
			'LStart' => 20,
			'error' => 6,
			'Endline' => 7,
			'SStart' => 8
		},
		GOTOS => {
			'nodestart' => 2,
			'show' => 11,
			'nodename' => 14,
			'document' => 101,
			'vars' => 16,
			'node' => 4,
			'comments' => 5,
			'hide' => 19,
			'slot' => 9,
			'leaf' => 10
		}
	},
	{#State 32
		DEFAULT => -2
	},
	{#State 33
		ACTIONS => {
			'Rest' => 97,
			'Uppercase_String' => 60,
			'Number' => 93,
			'Any_String' => 62,
			'DS' => 25,
			'Lowercase_String' => 45
		},
		GOTOS => {
			'showlist' => 104,
			'showvalue' => 102,
			'atombase' => 105,
			'varname' => 103,
			'anystring' => 94
		}
	},
	{#State 34
		DEFAULT => -4
	},
	{#State 35
		DEFAULT => -8
	},
	{#State 36
		DEFAULT => -6
	},
	{#State 37
		ACTIONS => {
			'Uppercase_String' => 1
		},
		DEFAULT => -72,
		GOTOS => {
			'nodeList' => 106,
			'nodename' => 37
		}
	},
	{#State 38
		ACTIONS => {
			'Period' => 107
		}
	},
	{#State 39
		DEFAULT => -109
	},
	{#State 40
		DEFAULT => -98
	},
	{#State 41
		DEFAULT => -89
	},
	{#State 42
		DEFAULT => -114
	},
	{#State 43
		DEFAULT => -110
	},
	{#State 44
		DEFAULT => -107
	},
	{#State 45
		DEFAULT => -120
	},
	{#State 46
		DEFAULT => -100
	},
	{#State 47
		DEFAULT => -87
	},
	{#State 48
		DEFAULT => -90
	},
	{#State 49
		DEFAULT => -92
	},
	{#State 50
		DEFAULT => -94
	},
	{#State 51
		DEFAULT => -93
	},
	{#State 52
		DEFAULT => -102
	},
	{#State 53
		DEFAULT => -106
	},
	{#State 54
		DEFAULT => -103
	},
	{#State 55
		DEFAULT => -97
	},
	{#State 56
		DEFAULT => -95
	},
	{#State 57
		DEFAULT => -117
	},
	{#State 58
		DEFAULT => -96
	},
	{#State 59
		DEFAULT => -88
	},
	{#State 60
		DEFAULT => -119
	},
	{#State 61
		DEFAULT => -115
	},
	{#State 62
		DEFAULT => -118
	},
	{#State 63
		ACTIONS => {
			'StarSL' => 108
		}
	},
	{#State 64
		DEFAULT => -105
	},
	{#State 65
		DEFAULT => -112
	},
	{#State 66
		DEFAULT => -111
	},
	{#State 67
		ACTIONS => {
			'Colon' => 41,
			'SET' => 40,
			'CProd' => 39,
			'Start' => 42,
			'Number' => 43,
			'RP' => 44,
			'Lowercase_String' => 45,
			'TRACE' => 48,
			'HStart' => 49,
			'VStart' => 50,
			'SlotStart' => 51,
			'Period' => 52,
			'LP' => 53,
			'PC' => 54,
			'LStart' => 56,
			'LIST' => 55,
			'SL' => 57,
			'OR' => 58,
			'Uppercase_String' => 60,
			'Rest' => 61,
			'Any_String' => 62,
			'Self' => 65,
			'Eq' => 64,
			'Plus' => 66,
			'Endline' => 67,
			'GT' => 69,
			'SStart' => 68,
			'SLStar' => 70,
			'DS' => 71,
			'Comma' => 73,
			'Minus' => 74,
			'Leaf' => 75
		},
		DEFAULT => -13,
		GOTOS => {
			'multiline' => 109,
			'any' => 72,
			'noneRuletokens' => 46,
			'anystring' => 47,
			'anytoken' => 59
		}
	},
	{#State 68
		DEFAULT => -91
	},
	{#State 69
		DEFAULT => -104
	},
	{#State 70
		DEFAULT => -116
	},
	{#State 71
		DEFAULT => -108
	},
	{#State 72
		ACTIONS => {
			'Colon' => 41,
			'SET' => 40,
			'CProd' => 39,
			'Start' => 42,
			'Number' => 43,
			'RP' => 44,
			'Lowercase_String' => 45,
			'TRACE' => 48,
			'HStart' => 49,
			'VStart' => 50,
			'SlotStart' => 51,
			'Period' => 52,
			'LP' => 53,
			'PC' => 54,
			'LStart' => 56,
			'LIST' => 55,
			'SL' => 57,
			'OR' => 58,
			'Uppercase_String' => 60,
			'Rest' => 61,
			'Any_String' => 62,
			'Self' => 65,
			'Eq' => 64,
			'Plus' => 66,
			'Endline' => 67,
			'GT' => 69,
			'SStart' => 68,
			'SLStar' => 70,
			'DS' => 71,
			'Comma' => 73,
			'Minus' => 74,
			'Leaf' => 75
		},
		DEFAULT => -13,
		GOTOS => {
			'multiline' => 110,
			'any' => 72,
			'noneRuletokens' => 46,
			'anystring' => 47,
			'anytoken' => 59
		}
	},
	{#State 73
		DEFAULT => -101
	},
	{#State 74
		DEFAULT => -99
	},
	{#State 75
		DEFAULT => -113
	},
	{#State 76
		ACTIONS => {
			'SLStar' => 13,
			'Endline' => 112,
			'PC' => 18
		},
		DEFAULT => -19,
		GOTOS => {
			'endornot' => 113,
			'comments' => 111
		}
	},
	{#State 77
		ACTIONS => {
			'Colon' => 114
		}
	},
	{#State 78
		DEFAULT => -5
	},
	{#State 79
		DEFAULT => -58
	},
	{#State 80
		ACTIONS => {
			'Eq' => 115
		}
	},
	{#State 81
		ACTIONS => {
			'Endline' => 116
		}
	},
	{#State 82
		ACTIONS => {
			'Colon' => 41,
			'SET' => 40,
			'CProd' => 39,
			'Start' => 42,
			'Number' => 43,
			'RP' => 44,
			'Lowercase_String' => 45,
			'TRACE' => 48,
			'HStart' => 49,
			'VStart' => 50,
			'SlotStart' => 51,
			'Period' => 52,
			'LP' => 53,
			'PC' => 54,
			'LStart' => 56,
			'LIST' => 55,
			'SL' => 57,
			'OR' => 58,
			'Uppercase_String' => 60,
			'Rest' => 61,
			'Any_String' => 62,
			'Self' => 65,
			'Eq' => 64,
			'StarSL' => 82,
			'Plus' => 66,
			'GT' => 69,
			'SStart' => 68,
			'SLStar' => 70,
			'DS' => 71,
			'Comma' => 73,
			'Minus' => 74,
			'Leaf' => 75
		},
		DEFAULT => -16,
		GOTOS => {
			'singleline' => 117,
			'any' => 83,
			'noneRuletokens' => 46,
			'anystring' => 47,
			'anytoken' => 59
		}
	},
	{#State 83
		ACTIONS => {
			'Colon' => 41,
			'SET' => 40,
			'CProd' => 39,
			'Start' => 42,
			'Number' => 43,
			'RP' => 44,
			'Lowercase_String' => 45,
			'TRACE' => 48,
			'HStart' => 49,
			'VStart' => 50,
			'SlotStart' => 51,
			'Period' => 52,
			'LP' => 53,
			'PC' => 54,
			'LStart' => 56,
			'LIST' => 55,
			'SL' => 57,
			'OR' => 58,
			'Uppercase_String' => 60,
			'Rest' => 61,
			'Any_String' => 62,
			'Self' => 65,
			'Eq' => 64,
			'StarSL' => 82,
			'Plus' => 66,
			'GT' => 69,
			'SStart' => 68,
			'SLStar' => 70,
			'DS' => 71,
			'Comma' => 73,
			'Minus' => 74,
			'Leaf' => 75
		},
		DEFAULT => -16,
		GOTOS => {
			'singleline' => 118,
			'any' => 83,
			'noneRuletokens' => 46,
			'anystring' => 47,
			'anytoken' => 59
		}
	},
	{#State 84
		DEFAULT => -7
	},
	{#State 85
		ACTIONS => {
			'Minus' => 119
		}
	},
	{#State 86
		ACTIONS => {
			'Rest' => 97,
			'Uppercase_String' => 60,
			'Any_String' => 62,
			'DS' => 25,
			'Number' => 93,
			'Lowercase_String' => 45,
			'SL' => 96
		},
		DEFAULT => -34,
		GOTOS => {
			'vardecl' => 98,
			'atomorvars' => 120,
			'atomorvar' => 99,
			'atombase' => 100,
			'varname' => 95,
			'anystring' => 94
		}
	},
	{#State 87
		ACTIONS => {
			'TRACE' => 122
		},
		DEFAULT => -24,
		GOTOS => {
			'trace' => 121
		}
	},
	{#State 88
		DEFAULT => -22
	},
	{#State 89
		ACTIONS => {
			'GT' => 123
		}
	},
	{#State 90
		DEFAULT => -57
	},
	{#State 91
		ACTIONS => {
			'Lowercase_String' => 79
		},
		GOTOS => {
			'slotname' => 124
		}
	},
	{#State 92
		ACTIONS => {
			'RP' => 125
		}
	},
	{#State 93
		DEFAULT => -54
	},
	{#State 94
		DEFAULT => -53
	},
	{#State 95
		ACTIONS => {
			'Colon' => 91,
			'CProd' => 126
		},
		DEFAULT => -36
	},
	{#State 96
		DEFAULT => -40
	},
	{#State 97
		DEFAULT => -55
	},
	{#State 98
		DEFAULT => -37
	},
	{#State 99
		ACTIONS => {
			'Rest' => 97,
			'Uppercase_String' => 60,
			'Any_String' => 62,
			'DS' => 25,
			'Number' => 93,
			'Lowercase_String' => 45,
			'SL' => 96
		},
		DEFAULT => -34,
		GOTOS => {
			'vardecl' => 98,
			'atomorvars' => 127,
			'atomorvar' => 99,
			'atombase' => 100,
			'varname' => 95,
			'anystring' => 94
		}
	},
	{#State 100
		DEFAULT => -38
	},
	{#State 101
		DEFAULT => -10
	},
	{#State 102
		ACTIONS => {
			'Colon' => 128
		},
		DEFAULT => -75
	},
	{#State 103
		DEFAULT => -77
	},
	{#State 104
		ACTIONS => {
			'RP' => 129
		}
	},
	{#State 105
		DEFAULT => -78
	},
	{#State 106
		DEFAULT => -73
	},
	{#State 107
		DEFAULT => -71
	},
	{#State 108
		DEFAULT => -12
	},
	{#State 109
		DEFAULT => -15
	},
	{#State 110
		DEFAULT => -14
	},
	{#State 111
		ACTIONS => {
			'Endline' => 112,
			'SLStar' => 13,
			'PC' => 18
		},
		DEFAULT => -19,
		GOTOS => {
			'endornot' => 130,
			'comments' => 111
		}
	},
	{#State 112
		ACTIONS => {
			'Endline' => 112,
			'SLStar' => 13,
			'PC' => 18
		},
		DEFAULT => -19,
		GOTOS => {
			'endornot' => 131,
			'comments' => 111
		}
	},
	{#State 113
		ACTIONS => {
			'Lowercase_String' => 79
		},
		GOTOS => {
			'types' => 133,
			'slotname' => 132
		}
	},
	{#State 114
		ACTIONS => {
			'Rest' => 97,
			'Uppercase_String' => 60,
			'CProd' => 134,
			'Any_String' => 62,
			'DS' => 25,
			'Number' => 93,
			'Plus' => 138,
			'Minus' => 139,
			'Lowercase_String' => 45
		},
		DEFAULT => -80,
		GOTOS => {
			'value' => 135,
			'atombase' => 140,
			'varname' => 136,
			'values' => 137,
			'anystring' => 94
		}
	},
	{#State 115
		ACTIONS => {
			'CProd' => 141,
			'Lowercase_String' => 79,
			'OR' => 144,
			'LP' => 143
		},
		DEFAULT => -60,
		GOTOS => {
			'slotvalue' => 145,
			'slotvalues' => 146,
			'connector' => 147,
			'slotname' => 142
		}
	},
	{#State 116
		DEFAULT => -11
	},
	{#State 117
		DEFAULT => -18
	},
	{#State 118
		DEFAULT => -17
	},
	{#State 119
		ACTIONS => {
			'GT' => 148
		}
	},
	{#State 120
		ACTIONS => {
			'RP' => 149
		}
	},
	{#State 121
		ACTIONS => {
			'SLStar' => 13,
			'Endline' => 112,
			'PC' => 18
		},
		DEFAULT => -19,
		GOTOS => {
			'endornot' => 150,
			'comments' => 111
		}
	},
	{#State 122
		DEFAULT => -25
	},
	{#State 123
		ACTIONS => {
			'Endline' => 112,
			'SLStar' => 13,
			'PC' => 18
		},
		DEFAULT => -19,
		GOTOS => {
			'endornot' => 151,
			'comments' => 111
		}
	},
	{#State 124
		DEFAULT => -33
	},
	{#State 125
		DEFAULT => -30
	},
	{#State 126
		DEFAULT => -39
	},
	{#State 127
		DEFAULT => -35
	},
	{#State 128
		ACTIONS => {
			'Colon' => 152
		}
	},
	{#State 129
		ACTIONS => {
			'Period' => 153
		}
	},
	{#State 130
		DEFAULT => -21
	},
	{#State 131
		DEFAULT => -20
	},
	{#State 132
		ACTIONS => {
			'Minus' => 154
		}
	},
	{#State 133
		ACTIONS => {
			'TRACE' => 122
		},
		DEFAULT => -24,
		GOTOS => {
			'trace' => 155
		}
	},
	{#State 134
		DEFAULT => -86
	},
	{#State 135
		ACTIONS => {
			'SLStar' => 13,
			'PC' => 18,
			'Endline' => 112
		},
		DEFAULT => -19,
		GOTOS => {
			'endornot' => 156,
			'comments' => 111
		}
	},
	{#State 136
		DEFAULT => -83
	},
	{#State 137
		ACTIONS => {
			'Period' => 157
		}
	},
	{#State 138
		DEFAULT => -84
	},
	{#State 139
		DEFAULT => -85
	},
	{#State 140
		DEFAULT => -82
	},
	{#State 141
		DEFAULT => -64
	},
	{#State 142
		DEFAULT => -65
	},
	{#State 143
		ACTIONS => {
			'Rest' => 97,
			'Uppercase_String' => 60,
			'Number' => 93,
			'Any_String' => 62,
			'DS' => 25,
			'Lowercase_String' => 45
		},
		GOTOS => {
			'atombase' => 159,
			'varname' => 158,
			'anystring' => 94
		}
	},
	{#State 144
		DEFAULT => -63
	},
	{#State 145
		ACTIONS => {
			'SLStar' => 13,
			'PC' => 18,
			'Endline' => 112
		},
		DEFAULT => -19,
		GOTOS => {
			'endornot' => 160,
			'comments' => 111
		}
	},
	{#State 146
		ACTIONS => {
			'Period' => 161
		}
	},
	{#State 147
		ACTIONS => {
			'SLStar' => 13,
			'PC' => 18,
			'Endline' => 112
		},
		DEFAULT => -19,
		GOTOS => {
			'endornot' => 162,
			'comments' => 111
		}
	},
	{#State 148
		ACTIONS => {
			'Lowercase_String' => 79
		},
		GOTOS => {
			'slotname' => 163
		}
	},
	{#State 149
		DEFAULT => -32
	},
	{#State 150
		ACTIONS => {
			'DS' => 25,
			'LP' => 27
		},
		DEFAULT => -27,
		GOTOS => {
			'vardecl' => 21,
			'lhs' => 24,
			'varname' => 26,
			'rule' => 22,
			'rules' => 164
		}
	},
	{#State 151
		ACTIONS => {
			'Rest' => 97,
			'Uppercase_String' => 60,
			'Colon' => 41,
			'SET' => 40,
			'Any_String' => 62,
			'Self' => 169,
			'Start' => 165,
			'Number' => 93,
			'Lowercase_String' => 45,
			'SStart' => 68,
			'TRACE' => 48,
			'HStart' => 49,
			'VStart' => 50,
			'DS' => 25,
			'SlotStart' => 51,
			'LP' => 168,
			'Comma' => -41,
			'Leaf' => 172,
			'Minus' => 74,
			'LIST' => 55,
			'LStart' => 56,
			'nodeName' => 174,
			'OR' => 58
		},
		DEFAULT => -43,
		GOTOS => {
			'rhs' => 170,
			'atombase' => 173,
			'varname' => 167,
			'noneRuletokens' => 166,
			'anystring' => 94,
			'rhsvalue' => 171
		}
	},
	{#State 152
		ACTIONS => {
			'Rest' => 97,
			'Uppercase_String' => 60,
			'Number' => 93,
			'Any_String' => 62,
			'DS' => 25,
			'Lowercase_String' => 45
		},
		GOTOS => {
			'showlist' => 175,
			'showvalue' => 102,
			'atombase' => 105,
			'varname' => 103,
			'anystring' => 94
		}
	},
	{#State 153
		DEFAULT => -74
	},
	{#State 154
		ACTIONS => {
			'GT' => 176
		}
	},
	{#State 155
		ACTIONS => {
			'SLStar' => 13,
			'Endline' => 112,
			'PC' => 18
		},
		DEFAULT => -19,
		GOTOS => {
			'endornot' => 177,
			'comments' => 111
		}
	},
	{#State 156
		ACTIONS => {
			'Rest' => 97,
			'Uppercase_String' => 60,
			'CProd' => 134,
			'Any_String' => 62,
			'DS' => 25,
			'Number' => 93,
			'Plus' => 138,
			'Minus' => 139,
			'Lowercase_String' => 45
		},
		DEFAULT => -80,
		GOTOS => {
			'value' => 135,
			'atombase' => 140,
			'varname' => 136,
			'values' => 178,
			'anystring' => 94
		}
	},
	{#State 157
		DEFAULT => -79
	},
	{#State 158
		ACTIONS => {
			'SET' => 179,
			'RP' => 180,
			'LIST' => 181
		}
	},
	{#State 159
		ACTIONS => {
			'RP' => 182
		}
	},
	{#State 160
		ACTIONS => {
			'CProd' => 141,
			'Lowercase_String' => 79,
			'OR' => 144,
			'LP' => 143
		},
		DEFAULT => -60,
		GOTOS => {
			'slotvalue' => 145,
			'slotvalues' => 183,
			'connector' => 147,
			'slotname' => 142
		}
	},
	{#State 161
		DEFAULT => -59
	},
	{#State 162
		ACTIONS => {
			'CProd' => 141,
			'Lowercase_String' => 79,
			'OR' => 144,
			'LP' => 143
		},
		DEFAULT => -60,
		GOTOS => {
			'slotvalue' => 145,
			'slotvalues' => 184,
			'connector' => 147,
			'slotname' => 142
		}
	},
	{#State 163
		ACTIONS => {
			'Period' => 185
		}
	},
	{#State 164
		DEFAULT => -28
	},
	{#State 165
		DEFAULT => -48
	},
	{#State 166
		DEFAULT => -45
	},
	{#State 167
		ACTIONS => {
			'CProd' => 186
		},
		DEFAULT => -46
	},
	{#State 168
		ACTIONS => {
			'Rest' => 97,
			'Uppercase_String' => 60,
			'Colon' => 41,
			'SET' => 40,
			'Any_String' => 62,
			'Self' => 169,
			'Start' => 165,
			'Number' => 93,
			'RP' => -41,
			'Lowercase_String' => 45,
			'SStart' => 68,
			'TRACE' => 48,
			'HStart' => 49,
			'VStart' => 50,
			'DS' => 25,
			'SlotStart' => 51,
			'LP' => 168,
			'Leaf' => 172,
			'Minus' => 74,
			'LIST' => 55,
			'LStart' => 56,
			'nodeName' => 174,
			'OR' => 58
		},
		DEFAULT => -43,
		GOTOS => {
			'rhs' => 187,
			'atombase' => 173,
			'varname' => 167,
			'noneRuletokens' => 166,
			'anystring' => 94,
			'rhsvalue' => 171
		}
	},
	{#State 169
		DEFAULT => -50
	},
	{#State 170
		DEFAULT => -29
	},
	{#State 171
		ACTIONS => {
			'Endline' => 112,
			'SLStar' => 13,
			'PC' => 18
		},
		DEFAULT => -19,
		GOTOS => {
			'endornot' => 188,
			'comments' => 111
		}
	},
	{#State 172
		DEFAULT => -49
	},
	{#State 173
		DEFAULT => -44
	},
	{#State 174
		DEFAULT => -47
	},
	{#State 175
		DEFAULT => -76
	},
	{#State 176
		ACTIONS => {
			'Lowercase_String' => 79
		},
		GOTOS => {
			'slotname' => 189
		}
	},
	{#State 177
		DEFAULT => -23
	},
	{#State 178
		DEFAULT => -81
	},
	{#State 179
		ACTIONS => {
			'RP' => 190
		}
	},
	{#State 180
		DEFAULT => -67
	},
	{#State 181
		ACTIONS => {
			'RP' => 191
		}
	},
	{#State 182
		DEFAULT => -66
	},
	{#State 183
		DEFAULT => -61
	},
	{#State 184
		DEFAULT => -62
	},
	{#State 185
		DEFAULT => -70
	},
	{#State 186
		DEFAULT => -51
	},
	{#State 187
		ACTIONS => {
			'RP' => 192
		}
	},
	{#State 188
		ACTIONS => {
			'Rest' => 97,
			'Uppercase_String' => 60,
			'Colon' => 41,
			'SET' => 40,
			'Any_String' => 62,
			'Self' => 169,
			'Start' => 165,
			'Number' => 93,
			'RP' => -41,
			'Lowercase_String' => 45,
			'SStart' => 68,
			'TRACE' => 48,
			'HStart' => 49,
			'VStart' => 50,
			'DS' => 25,
			'SlotStart' => 51,
			'LP' => 168,
			'Comma' => -41,
			'Leaf' => 172,
			'Minus' => 74,
			'LIST' => 55,
			'LStart' => 56,
			'nodeName' => 174,
			'OR' => 58
		},
		DEFAULT => -43,
		GOTOS => {
			'rhs' => 193,
			'atombase' => 173,
			'varname' => 167,
			'noneRuletokens' => 166,
			'anystring' => 94,
			'rhsvalue' => 171
		}
	},
	{#State 189
		DEFAULT => -26
	},
	{#State 190
		DEFAULT => -69
	},
	{#State 191
		DEFAULT => -68
	},
	{#State 192
		DEFAULT => -52
	},
	{#State 193
		DEFAULT => -42
	}
],
                                  yyrules  =>
[
	[#Rule 0
		 '$start', 2, undef
	],
	[#Rule 1
		 'document', 0, undef
	],
	[#Rule 2
		 'document', 2, undef
	],
	[#Rule 3
		 'document', 2,
sub
#line 97 "LATR.yp"
{ push @parsedTheory, $_[1];}
	],
	[#Rule 4
		 'document', 2,
sub
#line 99 "LATR.yp"
{ push @typeIn, $_[1];}
	],
	[#Rule 5
		 'document', 2,
sub
#line 101 "LATR.yp"
{ push @varIn, $_[1];}
	],
	[#Rule 6
		 'document', 2,
sub
#line 103 "LATR.yp"
{push @toShow, $_[1];}
	],
	[#Rule 7
		 'document', 2,
sub
#line 105 "LATR.yp"
{push @parsedTheory, $_[1];}
	],
	[#Rule 8
		 'document', 2,
sub
#line 107 "LATR.yp"
{push @leaf, $_[1];}
	],
	[#Rule 9
		 'document', 2,
sub
#line 109 "LATR.yp"
{ push @parsedTheory, $_[1];}
	],
	[#Rule 10
		 'document', 3, undef
	],
	[#Rule 11
		 'comments', 3,
sub
#line 116 "LATR.yp"
{ return "$_[1] $_[2]";}
	],
	[#Rule 12
		 'comments', 3,
sub
#line 118 "LATR.yp"
{ return "$_[1] $_[2] $_[3]";}
	],
	[#Rule 13
		 'multiline', 0, undef
	],
	[#Rule 14
		 'multiline', 2,
sub
#line 124 "LATR.yp"
{ return "$_[1] $_[2]";}
	],
	[#Rule 15
		 'multiline', 2,
sub
#line 126 "LATR.yp"
{ return "$_[1]$_[2]";}
	],
	[#Rule 16
		 'singleline', 0, undef
	],
	[#Rule 17
		 'singleline', 2,
sub
#line 132 "LATR.yp"
{ return "$_[1] $_[2]";}
	],
	[#Rule 18
		 'singleline', 2,
sub
#line 134 "LATR.yp"
{ return "$_[1] $_[2]";}
	],
	[#Rule 19
		 'endornot', 0, undef
	],
	[#Rule 20
		 'endornot', 2,
sub
#line 140 "LATR.yp"
{return "$_[1]$_[2]";}
	],
	[#Rule 21
		 'endornot', 2,
sub
#line 142 "LATR.yp"
{return "$_[2]";}
	],
	[#Rule 22
		 'node', 3,
sub
#line 147 "LATR.yp"
{ return "$_[1] $_[2] $_[3]";}
	],
	[#Rule 23
		 'nodestart', 6,
sub
#line 152 "LATR.yp"
{
		my $nodeName = $_[1];
		my $trace = $_[5];
	        push @TypeList, "$nodeName:=$_[4]";
		if ($trace =~ /\#trace/) 
	            {push @doTrace, "$nodeName";}
                return "$_[1]$_[2]\n";
        }
	],
	[#Rule 24
		 'trace', 0, undef
	],
	[#Rule 25
		 'trace', 1, undef
	],
	[#Rule 26
		 'types', 4,
sub
#line 170 "LATR.yp"
{return "$_[1]$_[2]$_[3]$_[4]";}
	],
	[#Rule 27
		 'rules', 0, undef
	],
	[#Rule 28
		 'rules', 5,
sub
#line 176 "LATR.yp"
{return "$_[1] $_[2] $_[3] \n$_[5]";}
	],
	[#Rule 29
		 'rule', 5,
sub
#line 181 "LATR.yp"
{ return "$_[1] $_[2]$_[3] $_[5]";}
	],
	[#Rule 30
		 'lhs', 3,
sub
#line 186 "LATR.yp"
{ return "$_[1]$_[2]$_[3]";}
	],
	[#Rule 31
		 'lhs', 1, undef
	],
	[#Rule 32
		 'lhs', 4,
sub
#line 189 "LATR.yp"
{return "$_[2]$_[3]$_[4]";}
	],
	[#Rule 33
		 'vardecl', 3,
sub
#line 194 "LATR.yp"
{return "$_[1]$_[2]$_[3]";}
	],
	[#Rule 34
		 'atomorvars', 0, undef
	],
	[#Rule 35
		 'atomorvars', 2,
sub
#line 201 "LATR.yp"
{ return "$_[1] $_[2]";}
	],
	[#Rule 36
		 'atomorvar', 1, undef
	],
	[#Rule 37
		 'atomorvar', 1, undef
	],
	[#Rule 38
		 'atomorvar', 1, undef
	],
	[#Rule 39
		 'atomorvar', 2,
sub
#line 209 "LATR.yp"
{ return "$_[1]$_[2]";}
	],
	[#Rule 40
		 'atomorvar', 1, undef
	],
	[#Rule 41
		 'rhs', 0, undef
	],
	[#Rule 42
		 'rhs', 3,
sub
#line 216 "LATR.yp"
{ return "$_[1] $_[3]";}
	],
	[#Rule 43
		 'rhsvalue', 0, undef
	],
	[#Rule 44
		 'rhsvalue', 1, undef
	],
	[#Rule 45
		 'rhsvalue', 1, undef
	],
	[#Rule 46
		 'rhsvalue', 1, undef
	],
	[#Rule 47
		 'rhsvalue', 1, undef
	],
	[#Rule 48
		 'rhsvalue', 1, undef
	],
	[#Rule 49
		 'rhsvalue', 1, undef
	],
	[#Rule 50
		 'rhsvalue', 1, undef
	],
	[#Rule 51
		 'rhsvalue', 2,
sub
#line 228 "LATR.yp"
{ return "$_[1]$_[2]";}
	],
	[#Rule 52
		 'rhsvalue', 3,
sub
#line 230 "LATR.yp"
{ return "$_[1]$_[2]$_[3]";}
	],
	[#Rule 53
		 'atombase', 1, undef
	],
	[#Rule 54
		 'atombase', 1, undef
	],
	[#Rule 55
		 'atombase', 1,
sub
#line 238 "LATR.yp"
{ return "\$Rest";}
	],
	[#Rule 56
		 'nodename', 1, undef
	],
	[#Rule 57
		 'varname', 2,
sub
#line 247 "LATR.yp"
{return "$_[1]$_[2]";}
	],
	[#Rule 58
		 'slotname', 1, undef
	],
	[#Rule 59
		 'slot', 5,
sub
#line 256 "LATR.yp"
{
		push @slots, "$_[2]:=$_[4]";
		return "$_[1] $_[2] $_[3] $_[4] $_[5]";
	}
	],
	[#Rule 60
		 'slotvalues', 0, undef
	],
	[#Rule 61
		 'slotvalues', 3,
sub
#line 265 "LATR.yp"
{ return "$_[1] $_[3]";}
	],
	[#Rule 62
		 'slotvalues', 3,
sub
#line 267 "LATR.yp"
{ return "$_[1] $_[3]";}
	],
	[#Rule 63
		 'connector', 1, undef
	],
	[#Rule 64
		 'connector', 1, undef
	],
	[#Rule 65
		 'slotvalue', 1, undef
	],
	[#Rule 66
		 'slotvalue', 3,
sub
#line 279 "LATR.yp"
{ return "$_[1]$_[2]$_[3]";}
	],
	[#Rule 67
		 'slotvalue', 3,
sub
#line 281 "LATR.yp"
{return "$_[1]$_[2]$_[3]";}
	],
	[#Rule 68
		 'slotvalue', 4,
sub
#line 283 "LATR.yp"
{ return "$_[1]$_[2] $_[3]$_[4]";}
	],
	[#Rule 69
		 'slotvalue', 4,
sub
#line 285 "LATR.yp"
{ return "$_[1]$_[2] $_[3]$_[4]";}
	],
	[#Rule 70
		 'leaf', 6,
sub
#line 289 "LATR.yp"
{
	   $leafIn = $_[2]; $leafOut = $_[5];
	   push @TypeList, "LEAF:=$_[2]$_[3]$_[4]$_[5]";
           return "$_[1] $_[2]$_[3]$_[4]$_[5] $_[6]";   
	}
	],
	[#Rule 71
		 'hide', 3,
sub
#line 297 "LATR.yp"
{return "$_[1] $_[2] $_[3]";}
	],
	[#Rule 72
		 'nodeList', 0, undef
	],
	[#Rule 73
		 'nodeList', 2,
sub
#line 302 "LATR.yp"
{return "$_[1] $_[2]";}
	],
	[#Rule 74
		 'show', 5,
sub
#line 307 "LATR.yp"
{ return "$_[1] $_[2]$_[3]$_[4] $_[5]";}
	],
	[#Rule 75
		 'showlist', 1, undef
	],
	[#Rule 76
		 'showlist', 4,
sub
#line 313 "LATR.yp"
{ return "$_[1]$_[2]$_[3]$_[4]";}
	],
	[#Rule 77
		 'showvalue', 1, undef
	],
	[#Rule 78
		 'showvalue', 1, undef
	],
	[#Rule 79
		 'vars', 5,
sub
#line 323 "LATR.yp"
{	
	    my ($VarName, $values);
	    if ($_[2] =~ /^(\$)(.+)/) { $VarName = $2; }
	    $values = $_[4];	    
            push @variables, "$VarName:=$values";
	    return "$_[1] $_[2]$_[3] $_[4] $_[5]";
        }
	],
	[#Rule 80
		 'values', 0, undef
	],
	[#Rule 81
		 'values', 3,
sub
#line 336 "LATR.yp"
{return "$_[1] $_[3]";}
	],
	[#Rule 82
		 'value', 1, undef
	],
	[#Rule 83
		 'value', 1, undef
	],
	[#Rule 84
		 'value', 1, undef
	],
	[#Rule 85
		 'value', 1, undef
	],
	[#Rule 86
		 'value', 1, undef
	],
	[#Rule 87
		 'any', 1, undef
	],
	[#Rule 88
		 'any', 1, undef
	],
	[#Rule 89
		 'noneRuletokens', 1, undef
	],
	[#Rule 90
		 'noneRuletokens', 1, undef
	],
	[#Rule 91
		 'noneRuletokens', 1, undef
	],
	[#Rule 92
		 'noneRuletokens', 1, undef
	],
	[#Rule 93
		 'noneRuletokens', 1, undef
	],
	[#Rule 94
		 'noneRuletokens', 1, undef
	],
	[#Rule 95
		 'noneRuletokens', 1, undef
	],
	[#Rule 96
		 'noneRuletokens', 1, undef
	],
	[#Rule 97
		 'noneRuletokens', 1, undef
	],
	[#Rule 98
		 'noneRuletokens', 1, undef
	],
	[#Rule 99
		 'noneRuletokens', 1, undef
	],
	[#Rule 100
		 'anytoken', 1, undef
	],
	[#Rule 101
		 'anytoken', 1, undef
	],
	[#Rule 102
		 'anytoken', 1, undef
	],
	[#Rule 103
		 'anytoken', 1, undef
	],
	[#Rule 104
		 'anytoken', 1, undef
	],
	[#Rule 105
		 'anytoken', 1, undef
	],
	[#Rule 106
		 'anytoken', 1, undef
	],
	[#Rule 107
		 'anytoken', 1, undef
	],
	[#Rule 108
		 'anytoken', 1, undef
	],
	[#Rule 109
		 'anytoken', 1, undef
	],
	[#Rule 110
		 'anytoken', 1, undef
	],
	[#Rule 111
		 'anytoken', 1, undef
	],
	[#Rule 112
		 'anytoken', 1, undef
	],
	[#Rule 113
		 'anytoken', 1, undef
	],
	[#Rule 114
		 'anytoken', 1, undef
	],
	[#Rule 115
		 'anytoken', 1, undef
	],
	[#Rule 116
		 'anytoken', 1, undef
	],
	[#Rule 117
		 'anytoken', 1, undef
	],
	[#Rule 118
		 'anystring', 1, undef
	],
	[#Rule 119
		 'anystring', 1, undef
	],
	[#Rule 120
		 'anystring', 1, undef
	]
],
                                  @_);
    bless($self,$class);
}

#line 393 "LATR.yp"


#_Lexer returns the next token 
sub _Lexer {
    my $word = $words[0];

    if (not defined $word) {
        return ('', undef);
    }
    #$word = uc $word;
    my $token = $Term{$word};
    if (defined $token) {
        $word = shift @words;
	if ($Debug >=5) {print "returning $token, $word\n";}
	if ($token eq "Endline") { $myCount++; }
        return ($token, $word);
    }

  # Check for token embedded in word
    if ($word =~ /^(\/\*|\*\/|list|set)(.+)/) 
    { 
	$words[0] = $2;
	if ($Debug>=5) {print "returning $Term{$1}, $1\n";}
	return ($Term{$1}, $1);
    }
    if ($word =~ /^(\-|\%|\$|\(|\)|\>|\:|\.|\,|\=|START|SELF|LEAF|REST|\*|\/)(.+)/) 
    {
	$words[0] = $2;
	if ($Debug>=5) {print "returning $Term{$1}, $1\n";}
	return ($Term{$1}, $1);
    }
    if ($word =~ /^([^a-zA-Z0-9]+)(list|set|SELF|LEAF|START|REST)/) 
    {
	$words[0] = $2;
	$word = $1;
    }
    if ($word =~ /^([^,%()>:.=*-]+)(\/\*|\*\/)/)
    {
	$words[0] = $2;
	$word = $1;
    }
    elsif ($word =~ /^([^%()>:.=*,-]+)(\-|\,|\%|\$|\(|\)|\>|\:|\.|\=|\/|\*)(.*)/) 
    {
	$words[0] = "$2$3";
	$word = $1;
    } else {
    	$token = shift @words;
    }

  if ($word =~ /^[A-Z](.*)/)  {
	if ($Debug >=5) {print "returning Uppercase_String, $word\n";}

        return ("Uppercase_String", $word);
  }
	
  if ($word =~ /^[a-z](.*)/)  {
	if ($Debug >=5) {print "returning Lowercase_String, $word\n";}
	
        return ("Lowercase_String", $word);
  }
  if ($word =~ /^[0-9]+/)  {
	if ($Debug >=5) {print "returning Number, $word\n";}

        return ("Number", $word);
  }
  if ($Debug >= 5) {print "returning Any_String, $word\n";}

  return ("Any_String", $word);
    
}


# Default Parse Error
sub _PError {
    print "Parse Error line $myCount\n";
}

# Major Parsing takes place
sub parseFile {
        my @lines = @_;
	my $line;
	$myCount = 1;

        my($self)=shift @lines;
	foreach $line (@lines) {	
	    my @w = split(" ", $line);
	    my $wrd;
	    foreach $wrd (@w) {
		push (@words, $wrd);
	    }
	    push (@words, "\n");
        }

        $self->YYParse( yylex => \&_Lexer, yyerror => \&_PError);

} #parseFile


# This is run after parsing to print some general rules.
sub BoilerPlate {
        PrintLeafRules();
	PrintShowRules();
        PrintNotRules();
  	PrintStarRules();
	PrintOptRules();
	PrintCommonRules();
} #BoilerPlate


sub PrintStarRules {
    my ($val, $type, $value);
  
    foreach $value (@StarList) {
        if ($value =~ /^([a-zA-Z0-9]+)(:=)(.+)$/)
            {$val = $1; $type = $3;}
        print OUTPUT "star_" . $type . "_" . "$val(X, Y, Z) :-\n";
        print OUTPUT "\tX = $type(X1), Y = $type(Y1), Z= $type(Z1),\n";
        print OUTPUT "\tstar_" . "$val(X1, Y1, Z1) .\n\n";
        print OUTPUT "star_" . "$val([X|Y], [X|W], Z) :-\n";
        print OUTPUT "\tvar_" . "$val(X), !,\n";
	print OUTPUT "\tstar_" . "$val(Y,W,Z).\n";
        print OUTPUT "star_" . "$val(X, [], X) .\n\n";
    }
}


sub PrintOptRules {
    my ($val, $type, $value);

    foreach $val (@OptList) {
        if ($value =~ /^([a-zA-Z0-9]+)(:=)(.+)$/)
            {$val = $1; $type = $3;}
        print OUTPUT "opt_" . $type . "_" . "$val(X, Y, Z) :-\n";
        print OUTPUT "\tX = $type(X1), Y = $type(Y1), Z= $type(Z1),\n";
        print OUTPUT "\topt_" . "$val(X1, Y1, Z1) .\n\n";
        print OUTPUT "opt_" . "$val([X|Y], [X], Y) :- ";
        print OUTPUT "\tvar_" . "$val(X), ! .\n";
        print OUTPUT "opt_" . "$val(X, [], X) .\n\n";
    }
}


sub printTrace {
    my $query = "@_";
    my $queryOut;
    
    if ($query eq "Query") {$queryOut = "printOut(Query)";}
    else {$queryOut = "write('". $query . "')" ;}

    $NodeOutput .= "\n\twrite('node $nodeName, line $myCount: ";
    $NodeOutput .= "\query is <'), printOut($query) ,\n";
    $NodeOutput .= "\twrite('> result is <'), printOut(Result), ";
    $NodeOutput .= "write('>\\n'),\n";
}    


sub PrintNotRules {
    my $val;
    my ($type, $variable, @vals, $varName);

    foreach $val (@NotList) {
        $type = getVarType($val);
	if ($type eq "None") {$type = getSlotType($val);}
        foreach $variable (@variables) {
            if ($variable =~/^($type):=(.*)/) {
                @vals = split(/\s/, $2);
                foreach $varName (@vals) {
                    if (!($varName eq $val))
                        {print OUTPUT "not($val, $varName) .\n";}
                }
            }
        }
        foreach $variable (@slots) {
            if ($variable =~/^($type):=(.*)/) {
                $varName = $2;
		$varName =~ s/^\(([^)]*)\)$/$1/;
                if (!($varName eq $val))
                    {print OUTPUT "not($val, $varName) .\n";}
            }
        }
    }
}


sub PrintVarietyRule {
    my ($CurPath, $in, $val, $count, @list, $i, $value, $extras);

    $in = $leafIn;
    print OUTPUT "variety(Query) :-\n";
    foreach $val (@toShow) {
	if ($Debug >=1) {print "Variety Query is of [$val], \n";}
        if (isSlot($val) eq "valid") {
	    if (!(getType($val, 1) eq "List")&&!(getType($val, 1) eq "Set"))
	    {
                print OUTPUT "\tslot_$val($Vars[$count]),\n";
                $count++;
	    }
	}
	elsif (isVar($val) eq "valid") {
            print OUTPUT "\tvar_$val($Vars[$count]),\n";
            $count++;
	}
    }
   ($CurPath,  @list) = getNodePart("LessThan", $in, "Valid", @toShow);
   if ($Debug >=2) 
       {print OUTPUT "%path:($CurPath), input:($in), show:(@toShow)\n";}
   $i = 0;
   foreach $val (@toShow) {
       if (isSlot($val) eq "valid") { 		
           if (!(getType($val, 1) eq "List")&&!(getType($val, 1) eq "Set"))
	   {
               $CurPath = substitute($CurPath, $val, $Vars[$i]);
	       $i++;
	   }
	   else {$CurPath =~ s/$val\(\_\)/$val\(\[\]\)/g;}
       }
       elsif (isVar($val) eq "valid") {
	   $CurPath =~ s/\($val/\($Vars[$i]/g;	
	   $CurPath =~ s/\s$val/\s$Vars[$i]/g;	
	   $CurPath =~ s/$val\,/$Vars[$i]\,/g;	
	   $CurPath =~ s/$val\)/$Vars[$i]\)/g;
	   $i++;
       }	
   }

    print OUTPUT "\tQuery = $CurPath .\n\n";
}

sub CheckForTrace {
    my $node = "@_";
    my $atom;   

    foreach $atom (@doTrace) {
        if ($atom eq $node) { return (1);}
    }
    return (0);
}


sub AddStar {
    my ($val,$type) = @_;
    my $atom;
    my $value = $val . ":=" . $type;

    foreach $atom (@StarList) {
        if ($atom eq $value) { return;}
    }
    push @StarList, $value;
}

sub AddOpt {
    my ($val, $type) = @_;
    my $atom;
    my $value = $val . ":=" . $type;

    foreach $atom (@OptList) {
        if ($atom eq $value) { return;}
    }
    push @OptList,$value;
}

sub AddRedirect {
    my $val = "@_";
    my $atom;

   if ($isLeaf{$val} == 1) {return;}

    foreach $atom (@redirects) {
        if ($atom eq $val) {return;}
    }
    push @redirects, $val;
}


sub AddNot {
    my $val = "@_";
    my $atom;
    foreach $atom (@NotList) {
        if ($atom eq $val) {return;}
    }
    push @NotList, $val;
}



sub PrintShowRules {
    my ($slot, $SlotName, @vals, $val, $rule, $count);
    my (@slotCount, $lhs, $vars, $i);

    print OUTPUT "printOut([]) .\n";
    print OUTPUT "printOut([X|Y]) :- printOut(X), printOut(Y), ! .\n";

    foreach $slot (@slots) {
        if ($slot =~ /^([a-z][^:]*)(:=)(.*)/) {
            $SlotName = $1;
            $rule = $3;
        }
        @vals = split(/\s\*\s/, $rule);
	$count =0;
        foreach $val (@vals) {$count++;}
        $lhs = "printOut($SlotName(XXX)) :- ";
        if (AlreadyShown($SlotName, $count, @slotCount) eq "No") {
            if (getType($SlotName, 1) eq "List") {
                $lhs =~ s/XXX/X/;
                print OUTPUT "$lhs" . "printOut(X), ! .\n";
            }
            else {
		$vars = getVars($count);
                $lhs =~ s/XXX/$vars/;
                print OUTPUT "$lhs";
                if (OnShowList($SlotName) eq "Yes") {
                    print OUTPUT "\n\twrite(\'(\'), ";
                }
                for ($i = 0; $i<$count; $i++) {
                    print OUTPUT "printOut($Vars[$i]), ";
                }
                if (OnShowList($SlotName) eq "Yes") {
                    print OUTPUT "\n\twrite(\')\'), write(\' \'), ";
                }
                print OUTPUT " ! .\n";
            }
            push @slotCount, "$SlotName:=$count";
        }
    }
    print OUTPUT "printOut(X) :- write(X), write(\' \'), ! .\n";
}


sub PrintCommonRules {
    print OUTPUT "% memberOf(Element, List, List-Element)\n";
    print OUTPUT "memberOf(X,[X|Y],Y).\n";
    print OUTPUT "memberOf(X,[Z|Y],[Z|Rest]) :- memberOf(X,Y,Rest).\n\n";

    print OUTPUT "% inSet(SubList, List, List-SubList)\n";
    print OUTPUT "inSet([],X,X).\n";
    print OUTPUT "inSet([X|Y],Z,W) :-\n";
    print OUTPUT "\tnonvar(Z), memberOf(X,Z,Rst), inSet(Y,Rst,W).\n";
    print OUTPUT "inSet(X,Z,[]) :- var(Z), Z=X.\n\n"; 

    print OUTPUT "\nleaves :- leafNode(Query, Result, Name),\n";
    print OUTPUT "\twrite(Name), write(' '), printOut(Query), write('='),\n";
    print OUTPUT "\twrite(\' \'), printOut(Result), write('\\n') .\n\n";

    print OUTPUT "all :- leaves, fail .\n\n";
    print OUTPUT "not(A) :- A, !, fail .\n";
    print OUTPUT "not(_) .\n\n";
    print OUTPUT "% vim:filetype=prolog:\n";
}
    
# checks if Passed in $SlotName and $count are on the CurList
sub AlreadyShown {
    my ($SlotName, $count, @curList) = @_;
    my ($cur, $Name, $Num);

    foreach $cur (@curList) {
        if ($cur =~ /^([a-z][^:]*)(:=)([0-9]+)/) {
             $Name = $1;
             $Num = $3;
        }
        if ($Name eq $SlotName && $count eq $Num) {return "Yes";}
    }
    return "No";
}


sub OnShowList {
    my $SlotName = "@_";
    my ($slot);

    foreach $slot (@toShow) {
        if ($slot eq $SlotName) {return "Yes";}
    }
    return "No";
}


sub emitNodeRule {
    my ($rule, $count, $i);

    $traceRule = 0;
    $count = 0;
    OrderRules();
    foreach $rule (@rules) {
	$next = 0;
	%varAssign = ();
	%subst = ();
	%startVars = ();
	$search = "GreaterThan";
	while ($rule =~/^(.*)(\s)$/) { $rule = $1;}
        $traceRule = CheckForTrace($nodeName);
        if ($rule =~ /^(.*)(\#trace)$/) {$rule = $1; $traceRule=1;}
	my $type = getType($input, 1);
        $rule = GetSubsts($rule);
	print OUTPUT "% Rule: $rule\n";
        #if (getType($input, 1) eq "List" && ($input eq $output)) {
	#    if ($Debug >= 1) {print OUTPUT "% Sandhi\n";}
	#    SandhiRule($rule);
	#}
        if ($rule =~/^(\(\$[a-zA-Z0-9]+)(\?|\*)*(\s\$[a-zA-Z0-9]+(\?|\*)*)*(\))(\s)*(=>)(\s)*(.*)/) 
        {
	    if ($Debug >=1) {print OUTPUT "% Complex\n";}
	    ComplexNodeRule($rule);
	}
        elsif ($rule =~/^(\()(.*)(\)\s*)(=>)(\s)*(LEAF|SELF|START)\(.*/)
        {
            if ($Debug >=1) {print OUTPUT "%Simple\n";}
            SimpleNodeRule($rule);
        }
	elsif ($rule =~/^(\()(.*)(\)\s*)(=>)(\s)*([A-Z][a-zA-Z0-9]*)\(\$([^)]*)(\))(\s)?$/)
	{ 
	    if ($Debug >=1) {print OUTPUT "%CallNode\n";}
	    CallNodeLeftAtoms($rule);
	}
        elsif ($rule =~/(\()([^)]*)(\))(\s)*(=>)(\s)*(.*)/) {
	    if ($Debug >=1) {print OUTPUT "%Simple\n";}
	    SimpleNodeRule($rule);
        }
	elsif ($rule =~/^(\$)([^=]+)(\s)*(=>)(\s)*([A-Z])(.*)/) {
	    if ($Debug >=1) {print OUTPUT "% Complex\n";}
	    #CallDifferentNode($rule);
	    ComplexNodeRule($rule); 
	}
	elsif ($rule =~/^(\$)([^=]+)(\s)*(=>)(\s)*(.*)(LEAF|SELF|START)(.*)/) {
	    if ($Debug >=1) {print OUTPUT "% Complex\n";}
	    ComplexNodeRule($rule); 
        }
	elsif ($rule =~/^(\$)([^=]+)(\s)*(=>)(\s)*(.*)/) {
	    if ($Debug >=1) {print OUTPUT "% VarNode\n";}
	    VarNodeRule($rule);
        }
	PrintNodeRule();
	$count++;
    } 
  
    @rules = ();
}

sub GetSubsts {
    my $NodeRule = "@_";
    my ($l, $r, @list, $var, $v);
    if ($NodeRule =~/^(\()(.*)(\))(=>)(.*)(\s)?/)
        {$l = $2; $r = $5;}
    else { return "$NodeRule";}
    @list = split(/\s/, $l);

    foreach $var (@list) {
        if ($var =~/^([^\/]+)(\/)(.+)$/) {
	    $v = "XXS$1XXS";
            $subst{$v} = $3;
            $var = $v;
        }
    }
    $l = join(" ", @list);
    return "($l) => $r";
}


sub PrintNodeRule() {
    my $node = $NodeOutput;
    my $count = 0;
 
    while ($node =~ s/StartNode/_/) {$count++;}
    if ($count <= 1) { $NodeOutput =~ s/StartNode/_/;} 	
    $count = 0;
    while ($node =~ s/Rest/_/) {$count++;}
    if ($count <= 1) { $NodeOutput =~ s/Rest/_/;}
    $NodeOutput =~ s/\[\s\]/\[\]/g;
    $NodeOutput =~ s/XXS//g;
    print OUTPUT $NodeOutput;
}

sub OrderRules
{
    my (@rules) = @_;
    my @ratings;
    my ($lhs, $count, $rule, $i, @lhsList, $min, $index, $rate, $j, $k, $temp);

    $i = 0;
    foreach $rule (@rules) {
       $lhs = "\$var";
	if ($rule =~/^(\(\))(\s)*(=>)(.*)/) {$lhs = "%None%";}
	elsif ($rule =~/^([^=]+)(\s*)(=>)(.*)/) {$lhs = $1;}
	$rule =~ s/(\+\+)//g;
        $rule =~ s/(\+)([1-9]+)//g;
	$lhs =~ s/\)//g;
	@lhsList = split(/(\s|\()+/, $lhs);
	$count=0;
	foreach $lhs (@lhsList) {
	    if ($lhs =~ /^(\+)([1-9]+)/) {$count=$count+$2;}
	    elsif ($lhs =~ /^(\$)/) {$count++;}
	    elsif ($lhs eq "%None%") {$count = $count + .9;}
	    else {$count = $count + 1.1;}
	}
	#print "$rule => $count\n";
	$ratings[$i] = $count;
        $i++;    
    }


    for ($k= $i; $k>0; $k--) {
        $min = $ratings[0];
        $index = 0;
        for ($j=0; $j<$k; $j++) {
	    if ($ratings[$j] < $min) {
	        $min = $ratings[$j];
	        $index = $j;
	    }
        }	
        $temp = $ratings[$index];
        $ratings[$index] = $ratings[$k-1];
        $ratings[$k-1] = $temp;
        $temp = $rules[$index];
        $rules[$index] = $rules[$k-1];
        $rules[$k-1] = $temp;
    }
    return @rules;
}

sub makeSubst {
   my @list = @_;
   my ($var, $value, $temp);

   foreach $var (keys %subst) {
       foreach $value (@list) {
	   #print OUTPUT "%($value) ($var) ($subst{$var})\n";
           if ($value eq $var) {$value = $subst{$var};}
	   elsif ($value =~/^(Not_)(.*)/) {
		$temp = $2;
		if ($temp eq $var) {$value = "Not_$subst{$var}";} 
	   }
       }
   }
   return @list;
}	

 
sub CallNodeLeftAtoms {
    my $NodeRule = "@_";
    my ($lhs, $rhs, $myNode, $myVar, $varValue, @lhslist, $sec, $val2);
    my ($Var1, $Var2, $Val1, $Value2);

   ($lhs, $rhs) = getPieces($NodeRule);
   @lhslist = split(/\s/, $lhs);
   if ($rhs =~/^(\s)*([A-Z])([^(]*)(\(\$)([^)]*)(\)*)(\))(\s)?/)
   {
        $myNode = "$2$3";
        $myVar = "$5$6";
   }
   $myVar=~ s/\$//g;
   ($lhs, $varValue, $sec, $val2) = getLhsRuleInfo($input, $lhs, $myVar);
    $NodeOutput = "node_$nodeName($lhs, Result, StartNode) :-\n"; 
    $NodeOutput .=  "\tX = $varValue,\n";
    PrintNots(@lhslist);
    PrintVars(@lhslist);
    if ($varValue =~ /^([a-z][^(]*)(\()(.*)/) {$Val1=$1;}
    else {$Val1=$varValue;}
    if ($Debug >=3) {print "sub(X) for ($Val1) in ($myVar)\n";}
    $Var1 = substitute($myVar, $Val1,"X");
    $Var1 = FixDontCares($Var1);
    $NodeOutput .= "\tnode_$myNode($Var1, Result, StartNode), ";
    if ($traceRule == 1) {printTrace($lhs);}
    $NodeOutput .= "! .\n";
    if (!($sec eq "None")) {
        PrintNodeRule();
        $NodeOutput = "node_$nodeName($sec, Result, StartNode) :-\n"; 
        $NodeOutput .=  "\tX = $val2,\n";
        PrintNots(@lhslist);
        PrintVars(@lhslist);
        if ($val2 =~ /^([a-z][^(]*)(\()(.*)/) {$Value2=$1;}
        else {$Value2=$val2;}
        $Var2 = substitute($myVar, $Value2,"X");
	$Var2 = FixDontCares($Var2);
        $NodeOutput .= "\tnode_$myNode($Var2, Result, StartNode), ";
        if ($traceRule == 1) {printTrace($sec);}
        $NodeOutput .= "! .\n";
    }

}


sub getLhsRuleInfo
{
    my ($in, $lhs, $myVar) = @_;
    my (@list, @nlist, $res, $Result, $varValue, $val, $second, $val2, @vlist);

    @list = split(/\s/, $lhs);
    $res= $myVar;
    @vlist = split(/\(|\,/,$res);
    foreach $res (@vlist) {
	$res =~ s/\s//g; $res =~ s/\)//g; $res =~ s/\(//g;
	push @list, $res;
    } 

    ($res, @nlist) = getNodePart("GreaterThan", $in, "Valid", @list);
    LhsMatchError(@nlist);
    ($second, @nlist) = getNodePart("LessThan", $in, "Valid", @list);
    foreach $val2 (@vlist) {
	if ($res =~ /$val2/) { $myVar=$val2; @vlist=();}
    }
    if ($res eq $second) { $second = "None";}
    if ($in eq $myVar) { 
	$varValue = $res;
	$res = $Vars[$next];
	$second = "None";
	$val2 = "None";
    }
    else {
	if (!($second eq "None")) {
	    if ($Debug >=3) {print "LHS: sub($Vars[$next]) for ($myVar) in ($second)\n";}
	    $second = substitute($second, $myVar, $Vars[$next]);
            foreach $val (@list) {
	        if ($second =~ /$val/) { $val = "XXXXX";}
            }
           ($val2, @nlist) = getNodePart("LessThan", $myVar, "Valid", @list);
	}    
	if ($Debug >=3) {print "LHS: sub ($Vars[$next]) for ($myVar) in ($res)\n";}
        $res = substitute($res, $myVar, $Vars[$next]);
        foreach $val (@list) {
	    if ($res =~ /$val/) { $val = "XXXXX";}
        }
        ($varValue, @nlist) = getNodePart("GreaterThan", $myVar, "Valid", @list);    
    }
    $next++;
    return ($res, $varValue, $second, $val2);
}



sub AddCommas {
    my $list = "@_";
    my ($value, @vals);

    @vals = split(/\s/, $list);
    foreach $value (@vals) {
        if (!($value =~ /^(Var_|R)/)) {
	    $value = makeProperAtom($value);
        }
    }
    $list = join(", ", @vals);
    if ($list =~ /^(\s*)$/) {return "None";}
    $list =~ s/\$([a-zA-Z0-9]*)\*/Star_$1/g;
    $list =~ s/\$([a-zA-Z0-9]*)\?/Opt_$1/g;
    return $list;
}

sub getSandhiRulePieces
{
    my $rhs = "@_";
    my ($var, $cur, @rhslist);
    my @list = ();
    my $open = 0;

    $cur = "";
    @rhslist = split(/\s/, $rhs);
    foreach $var (@rhslist)
    {
      if ($var =~ /^(\s)?([A-Z][A-Za-z0-9]*)(\:\([^)]*)/) {
            if (($open <= 0) && !($cur =~/^(\s*)$/)) {
                if ($cur =~ /(.*)(\s)/) {$cur = $1;}
                push @list, $cur;}
            if ($open <=0) {$cur = "$var ";}
            else {$cur .= "$var ";}
            $open++;
        }
        elsif ($var =~ /^(\s*)\)(\s*)$/) {
            $open--;
            if (($open <=0) && !($cur =~/^(\s*)$/)) {
                if ($cur =~ /(.*)(\s)/) {$cur = "$1";}
                $cur = "$cur )";
                push @list, $cur;
                $cur = "";
            }
            else { $cur .= ") ";}
        }
        elsif ($var =~ /^(\s*)SELF\([^)]*/) {
            if (($open <= 0) && !($cur =~/^(\s*)$/)) {
                if ($cur =~ /(.*)(\s)/) {$cur = $1;}
                push @list, $cur;}
            if ($open <=0) {$cur = "$var ";}
            else {$cur .= "$var ";}
            $open++;
        }
        elsif ($var =~ /^(\$)([a-z][a-zA-Z0-9]*)(\*|\?)/) {
            if (($open <= 0) && !($cur =~/^(\s*)$/)) {
                if ($cur =~ /(.*)(\s)/) {$cur = $1;}
                push @list, $cur; $cur = "";}
            if ($open <= 0) {push @list, $var;}
            else {$cur .= "$var ";}
        }
        elsif ($var =~ /^(\s*)(SELF\(\))(\s*)$/) {
            if (($open <=0) && !($cur =~/^(\s*)$/)) {
                if ($cur =~ /(.*)(\s)/) {$cur = $1;}
                push @list, $cur;}
            if ($open <=0) {push @list, $var; $cur="";}
            else {$cur .= "$var ";}
        }
	else {$cur .= "$var ";}
    }
    if (!($cur eq "")) {
        if ($cur =~ /(.*)(\s)/) {$cur = $1;}
        push @list, $cur;
    }
    return @list;
}

sub PrintLhsSandhi {
    my ($type, $lhs, $q1)= @_;
    my ($val, @list, @toprint, $count, $ls, $var);
    my $q2 = "Q";
    my $res = "";
    my $starORopt;

    $count=1;
    @toprint = ();
    @list = split(/,\s/, $lhs);

    foreach $val (@list) {
        if ($val =~/(Star_|Opt_)(.*)/){
	    $starORopt = $1;
            $var = $2;
            if ($starORopt =~/Star_/) {$starORopt="star";}
            elsif ($starORopt =~/Opt_/) {$starORopt="opt";}
            $ls = join(", ", @toprint);
            $NodeOutput .= $res;
            if (!($ls =~ /^(\s)*$/)) {
                $NodeOutput .= "\t$type($input([$ls]), Query$count, $q1),\n";
                $q1 = "Query$count";
		$q2 = "Q$count";
                $count++;
                @toprint = ();
            }
	    $NodeOutput .= "\t$q1 = $input($q2),\n";
	    $res = "\tQuery$count = $input(Q$count),\n";
            $res .= "\t$starORopt" . "_". "$var($q2, $val, Q$count),\n";
            if($starORopt eq "star") {AddStar($var);}
            if($starORopt eq "opt") {AddOpt($var);}
            $q1 = "Query$count";
	    $q2 = "Q$count";
            $count++;
        }
        else { push @toprint, $val;}
    }
    $ls = join(", ", @toprint);
    if (!($ls =~ /^(\s)*$/) || ($count <= 1))
        {$NodeOutput .= "$res\t$type($input([$ls]), Rest, $q1),\n";}
    else { $res =~ s/$q1/Rest/; $NodeOutput .= $res;}
}

sub PrintRhsSandhi {
    my ($type, $lhs, $final)= @_;
    my ($val, @list, @toprint, $count, $ls, $var);
    my ($j, $i, $next, $f, $r);
    my $q1 = "Temp0";
    my $res = "";
    $r = "Temp";

    $count=1;
    @toprint = ();
    @list = split(/,\s/, $lhs);

    foreach $val (@list) {
        if ($val =~/(Star_|Opt_)(.*)/){
            $var = $2;
            $ls = join(", ", @toprint);
            $NodeOutput .= $res;
            if (!($ls =~ /^(\s)*$/)) {
                if ($ls =~ /^(R)([0-9]+\s*)$/) {$f = $ls;}
                else {$f = "$output([$ls])";}
                $NodeOutput .= "\t$q1 = $f,\n";
                $q1 = "Temp$count";
                $count++;
                @toprint = ();
            }
            $NodeOutput .= "\t$q1 = $output($val),\n";
            $q1 = "Temp$count";
            $count++;
        }
        else { push @toprint, $val;}
    }
    $ls = join(", ", @toprint);
    if (!($ls =~ /^(\s)*$/)) {
        if ($ls =~ /^(R)([0-9]+\s*)$/) {$f = $ls;}
        else {$f = "$output([$ls])";}
        $NodeOutput .= "$res\t$type($f, Rest, $q1),\n";}
    else { $res =~ s/$q1/Rest/; $NodeOutput .= $res;}

    if ($count <= 1) {$NodeOutput .= "\t$final = $q1,\n";}
    else {
        $j = 0;
        $next = $count;
        for ($i=1; $i<$count; $i++) {
            if ($i < $count-1) {$f = "$r$next";}
            else {$f = $final;}
            $NodeOutput .= "\t$type($r$j, $r$i, $f),\n";
            $j = $next;
            $next++;
        }
    }
}


sub ComplexNodeRule {
    my ($lhs, $lhs2, $rhs, @lhsList, $NodeRule, @VarList);
    my ($vars, $count, $res, $rs, $i, $j, $temp, $slot, @lst, @ls);
    $NodeRule = "@_";

    @ls = ();
    ($lhs, $rhs) = getPieces($NodeRule);
    @lhsList = split(" ", $lhs);
    $temp = $rhs;
    while ($temp =~ s/(\$)([a-z][^(),]*)//) {
	$rs = $2;
	if ((isSlot($rs) eq "valid")&&!($lhs =~ /$rs/)) 
	    {push @lhsList, "\$$rs";}
    }
    $lhs =~ s/\$//g;

    if ((getType($input,1) eq "List") && !(isSlot($lhs) eq "valid")) {
        $lhs = join(" ", @lhsList);
        @VarList = makeSubst(@lhsList);
        $lhs2 = join(" ", @VarList);
        LhsSandhiType($lhs, $lhs2);
        $vars = "Query";
	$rs = "None";
    }
    elsif ((getType($input, 1) eq "Set") && !(isSlot($lhs) eq "valid")) {
        $lhs = join(" ", @lhsList);
        LhsSet($lhs);
        @VarList = makeSubst(@lhsList);
        $vars = "Query";
	$rs = "None";
    }
    else {
        ($rs,$vars,@VarList) = emitComplexLhs(@lhsList);
        @VarList = makeSubst(@VarList);
    }

    while (!($rs eq "Done")) {
        PrintNots(@lhsList);
        PrintVars(@lhsList);
        if ($vars eq "Query") {
            $res = emitComplexRhs($input,$output,$rhs,"AtomList","R",@VarList);
	} else {
            $res = emitComplexRhs($input,$output,$rhs,$vars,"R",@VarList);
	}
        $NodeOutput .="\tResult=$res, ";
	if ($traceRule == 1) {printTrace($vars);}
	$NodeOutput .= "! .\n";
	if ($rs eq "None") { $rs = "Done";}
	else {
	    PrintNodeRule(); $next=0; %varAssign=(); $vars="$input($rs)";
	    $NodeOutput = "node_$nodeName($vars, Result, StartNode) :-\n";
	    $rs = "None";  $search = "LessThan";
            @ls = OrderSlotList($search,$input, @lhsList);
            foreach $temp (@ls) 
    	    {
	        $temp =~ s/\$//g;
                ($temp, @lst) = getNodePart("LessThan", $temp, "Valid", @ls);
	        while ($temp =~ s/_/$Vars[$next]/) {$next++;}
            }

   	    @VarList = makeSubst(@ls); 
       }
    }	
}

sub isNodeCall {
    my $var = "@_";
    my @list = split(/\s+/, $var);
    my ($piece, $res, $node, $in, $out);

    $res = "No";
    foreach $piece (@list) {
        if ($piece =~ /^([A-Z][^(]*)(:)?\(/) {
            $node = $1;
            if ($node =~ /^(START|LEAF|SELF)$/) {$res="Yes";}
            else {
                ($in,$out) = getTypes($node);
                if (!($in eq "None") && !($out eq "None"))
                   {$res = "Yes";}
            }
        }
    }
    return $res;
}

sub splitRhs {
    my $rhs = "@_";
    my (@list, @rules, $cur, $var, $open);

    @rules = ();
    $open= 0;
    @list = split(/\s+/, $rhs);
    $cur = "";

    foreach $var (@list) {
        if ($var =~ /^([A-Z]|\$)([^:]*)\:\(.*/) {
            if ($open < 1) {
                if (!($cur eq "")) {
                    if ($cur =~/^(.*)(\s)$/) {$cur= $1;}
                    push @rules, $cur;
                    $cur = "";
                }
            }
            $open++;
            $cur .= "$var ";
        } elsif ($var =~ /^(SELF|LEAF|START)(\()([^)]*)$/) {
            if ($open < 1) {
                if (!($cur eq "")) {
                    if ($cur =~/^(.*)(\s)$/) {$cur= $1;}
                    push @rules, $cur;
                    $cur = "";
                }
            }
            $open++;
            $cur .= "$var ";
        }elsif($var =~/^(\s*)(\))+(\s*)$/){
            $open--;
            $cur .= " ) ";
            if ($open < 1) {push @rules, $cur; $cur="";}
        }elsif($var =~/^(LEAF|SELF|START)(\()([^)]*)(\))/) {
            if ($open < 1) {
                if (!($cur eq "")) {
                    if ($cur =~/^(.*)(\s)$/) {$cur=$1;}
                    push @rules, $cur;
                    $cur = "";
                }
                push @rules, $var;
            }
            else { $cur .= "$var ";}
        }elsif($var =~ /^([A-Z]|\$)([^(]*)\(.*\)(\s*)$/) {
            if ($open < 1) {
                if (!($cur eq "")) {
                    if ($cur =~/^(.*)(\s)$/) {$cur=$1;}
                    push @rules, $cur;
                    $cur = "";
                }
                push @rules, $var;
            }
            else { $cur .= "$var ";}
        }elsif($var =~ /^([A-Z]|\$)([^(]*)\(.*[^)\s](\s*)$/) {
            if ($open < 1) {
                if (!($cur eq "")) {
                    if ($cur =~/^(.*)(\s)$/) {$cur=$1;}
                    push @rules, $cur;
                    $cur = "";
                }
            }
            $open++;
            $cur .= "$var ";
        }elsif($var =~ /^(\$)(.*)(\*|\?)/) {
            if ($open < 1) {
                if (!($cur eq "")) {
                    if ($cur =~/^(.*)(\s)$/) {$cur=$1;}
                    push @rules, $cur;
                    $cur = "";
                }
                push @rules, $var;
            }
            else { $cur .= "$var ";}
        }
        else {$cur .= "$var ";}
    }

    if (!($cur eq "")) {
        if ($cur =~/^(.*)\s/){$cur = $1;}
        push @rules, $cur;
    }

    return @rules;
}

sub splitViaCommas {
    my $rhs = "@_";
    my (@list, @rules, $cur, $var, $open);

    @rules = ();
    $open= 0;
    @list = split(/\,/, $rhs);
    $cur = "";

    foreach $var (@list) {
        if ($open >= 1) {
            if ($cur eq "") { $cur=$var;}
            else {$cur .= ",$var";}
        }
        else {
            if (!($cur eq "")) {
                if ($cur =~/^(.*)(\s)$/) {$cur= $1;}
                push @rules, $cur;
                $cur = "";
            }
            $cur = $var;
        }
        while ($var =~ s/\(/XOX/) {$open++;}
        while ($var =~ s/\)/XCX/) {$open--;}
        $var =~ s/XOX/\(/g;
        $var =~ s/XCX/\)/g;
    }

    if (!($cur eq "")) {
        if ($cur =~/^(.*)(\s)$/) {$cur= $1;}
        push @rules, $cur;
    }
    return @rules;
}


sub emitComplexRhs {
    my ($in, $out, $rhs, $myVars, $r, @VarList) = @_;
    my (@ruleList, $ruleCount, $rule, $slotName, $i, $j, $conres);
    my ($next, $CurNode, $slot, $rm, $flag, $nodeIN, $nodeOUT, $inA);
    my $res = "Result";
    my @ls = ();
    my $type = $out;

    $i = 0;
    $flag = "Yes";
    if ($Debug  >=3) {print OUTPUT "%[$rhs], $r\n";}

    while ($rhs =~ /^(\s)(.*)$/) {$rhs = $2;}
    $ruleCount = 0;
    @ruleList = splitRhs($rhs);
    foreach $rule (@ruleList) {$ruleCount++;}
    if ($ruleCount <= 1) {
        @ruleList = splitViaCommas($rhs);
        $flag = "No";
    }

    $ruleCount = 0;

    foreach $rule (@ruleList) {
	$res = "$r$ruleCount";
        if ($rule =~ /^(START)(\:\(\s*)(.*)(\)\s*)$/) {
            $CurNode = $3;
            if ($CurNode =~ /^(\s*)([A-Z][^):]*)(\:)?(\()(.*)(\)\s*)$/) {
                $CurNode = $2;
                $slot = $5;
                $slot = emitComplexRhs($in,$out,$slot,$myVars,$res,@VarList);
	        $slot = GetSlotVars($slot, $myVars, @VarList);
            }
            elsif ((getType($input,1) eq "List")||(getType($input,1) eq "Set"))
                {$slot = "Query";}
            elsif ($myVars eq "AtomList") {
                $slot=getAtomQuery(@VarList);
            } else {$slot = $myVars;}
            emitStartRule($slot, $CurNode, $res);
            $ls[$ruleCount] = $res;
        }
        elsif ($rule =~ /^([A-Z][^(:]*):\((.*)(\)\s*)$/) {
           $rule = $2;
           $CurNode = $1;
           $slot = emitComplexRhs($in,$out,$rule,$myVars,$res,@VarList);
           $slot = GetSlotVars($slot, $myVars, @VarList);
	   $slot = FixDontCares($slot);
           $NodeOutput .= "\n\tnode_" . "$CurNode($slot, $res, StartNode),\n";
	   $ls[$ruleCount] = $res; 
        }
        elsif ($rule =~ /^LEAF(\(\s*)(.*)(\s*\)\s*)$/) {
	     emitRedirectRule($2, $res, $myVars, "redirect", @VarList);
	     $ls[$ruleCount] = $res; 
        }
        elsif ($rule =~ /^(SELF)(\(\s*)(.*)(\s*\)\s*)$/) {
            print OUTPUT "% 3 ($1) ($3)\n";
             $slot = $3;
             if ($slot =~ /(\()([^)]*)(\))/) {
                 $slot = emitComplexRhs($in,$out,$slot,$myVars,$res,@VarList);
             }
             emitRedirectRule($slot, $res, $myVars, "node_$nodeName", @VarList);
             $ls[$ruleCount] = $res;
        }
        elsif ($rule =~ /^([A-Z][^(]*)(\()(.*)(\)\s*)$/) {
             $CurNode = $1;
             ($nodeIN, $nodeOUT) = getTypes($CurNode);
             if ($nodeIN eq "None") {$nodeIN = $in;}
             if ($nodeOUT eq "None") {$nodeOUT = $out;}
             $slotName = $3;
	     if ($slotName =~ /^(\$)([^()]+)/) {$inA = $2;}
             else {$inA = $in;}
	     $slotName =~ s/^([a-z].*)$/\$$1/;
	     #print OUTPUT "%eCR:1 CN($CurNode) sN($slotName)\n";
	     if ($slotName =~ /^(\$|[A-Z])/) {
		$slotName = emitComplexRhs($nodeIN,$nodeOUT,$slotName,$myVars,$res,@VarList);
	     }
	     #print OUTPUT "%eCR:2 sN($slotName) mV($myVars) VL(@VarList)\n";
	     $slot = GetSlotVars($slotName, $myVars, @VarList);
	     #print OUTPUT "%eCR:3 sN($slotName) s($slot)\n";
             emitCallNodeRule($CurNode, $slot, $res);
	     $ls[$ruleCount] = $res;
        }
        elsif ($rule =~/^(\$[a-z][^(]*)(\()(.*)(\)\s*)$/) {
             $CurNode = $1;
             $slotName = $3;
	     $slotName =~ s/^([a-z].*)$/\$$1/;
             if ($slotName =~ /^(\$|[A-Z])/) {
                 $slotName = emitComplexRhs($in,$out,$slotName,$myVars,$res,@VarList);
             }
             $ls[$ruleCount] = "$CurNode($slotName)";
        }
        elsif ($rule =~/^(\$[a-z][a-zA-Z0-9]*)\,(.*)$/) {
             $CurNode = $1;
             $slotName = $2;
             if ($slotName =~ /^(\$|[A-Z])/) {
                 $slotName = emitComplexRhs($in,$out,$slotName,$myVars,$res,@VarList);
             }
             $ls[$ruleCount] = "$CurNode,$slotName";
        }
        elsif ($rule =~/^(\$)([a-z][a-zA-Z0-9]*)$/) {
            $slot = $2;
            if ((isSlot($slot) eq "valid")&&($flag eq "Yes")) {
                if ((getType($slot,1) eq "List")||(getType($slot,1) eq "Set"))
                    {$type = $slot;}
                $slot = GetSlotVars($slot,$myVars,@VarList);
                $NodeOutput .= "\t$res = $slot,\n";
                $ls[$ruleCount] = $res;
            }
	    else {$ls[$ruleCount]=$rule;}
        }
        else {
	    emitEquivalenceRule($rule, $res);
	    $ls[$ruleCount] = $res;
	}
        $ruleCount++;
    }
    if ($flag eq "Yes") {
        $j = 0;        
	$res = $ls[$j];
        $next = $ruleCount;
        for ($i=1; $i<$ruleCount; $i++) {
	    print OUTPUT "%ECR: ($r$i)($ls[$i]) ($r$j) ($ls[$j])\n";
            $NodeOutput .= "\t$type" . "Append($res, $ls[$i], $r$next),\n";
            $j = $next;
	    $res = "$r$j";
            $next++;
        }
        return "$r$j";
    }
    else {
        $res = join(",", @ls);
        return $res;
   }
}

sub emitStartRule {
    my ($query, $node, $res)= @_;
    while ($node =~ /^([A-Z].*)(\s)$/) {$node = $1;}
    AddRedirect($node);
    $query = FixDontCares($query);
    $NodeOutput .= "\tnode_$node($query, $res, start_$node),\n";
}

sub getAtomQuery {
        my (@List) = @_;
        my ($slot, $res);

        if (getType($input, 1) eq "List") {
            $slot = join(" ", @List);
            $slot = AddCommas($slot);
            if ($slot eq "None") {$res= "$input([])";}
            else {$res = "Query";}
        }
        else {
            ($slot, @List) = getNodePart($search, $input, "Valid", @List);
	    if (!defined $startVars{$slot}) {
                $res = AddVariables($slot);
		$startVars{$slot} = $res;
	    }
	    else {$res = $startVars{$slot};}
        }
        return $res;
}

sub AddVariables {
        my ($query) = "@_";
        my $count = 0;
	my $i = 0;

        while ($query =~ s/Var_/XXVXVXX/) {$count++;}
        for ($i=0; $i<$count; $i++) {
            $NodeOutput =~ s/Var_/XXVXVXX/;
        }
        $count = 0;
        while ($query =~ s/Star_/XXSXSXX/) {$count++;}
        for ($i=0; $i<$count; $i++) {
            $NodeOutput =~ s/Star_/XXSXSXX/;
        }
        $count = 0;
        while ($query =~ s/Opt_/XXOXOXX/) {$count++;}
        for ($i=0; $i<$count; $i++) {
            $NodeOutput =~ s/Opt_/XXOXOXX/;
        }
        $count = 0;
        while ($query =~ s/Not_/XXNXNXX/) {$count++;}
        for ($i=0; $i<$count; $i++) {
            $NodeOutput =~ s/Not_/XXNXNXX/;
        }

        $NodeOutput =~ s/node_/XXNSXX/g;
        $NodeOutput =~ s/start_/XXSSXX/g;

        while ($query =~ s/_/$Vars[$next]/) {
            $NodeOutput =~ s/_/$Vars[$next]/;
            $next++;
        }

        $NodeOutput =~ s/XXSSXX/_/;

        $query =~ s/XXVXVXX/Var_/g;
        $NodeOutput =~ s/XXVXVXX/Var_/g;
        $query =~ s/XXSXSXX/Star_/g;
        $NodeOutput =~ s/XXSXSXX/Star_/g;
        $query =~ s/XXOXOXX/Opt_/g;
        $NodeOutput =~ s/XXOXOXX/Opt_/g;
        $query =~ s/XXNXNXX/Not_/g;
        $NodeOutput =~ s/XXNXNXX/Not_/g;

        $NodeOutput =~ s/XXSSXX/start_/g;
        $NodeOutput =~ s/XXNSXX/node_/g;

        return $query;
}


sub FixDontCares {
    my $slot = "@_";

    while ($slot =~ /(\(|\,|\[)\s*_\s*(\)|\,|\])/) {
        if ($slot =~ /(\[)\s*_\s*(\])/) 
	    {$slot =~ s/(\[)\s*_\s*(\])/$1$2/;}
	else {$slot =~ s/(\(|\,)\s*_\s*(\)|\,)/$1unSpecified$2/;}
    }
    return $slot;
}

sub emitCallNodeRule {
    my ($CurNode, $slot, $Res) = @_;

    $slot = FixDontCares($slot);
    $NodeOutput .= "\tnode_$CurNode($slot, $Res, StartNode),";
    if ($Res eq "Result") {$NodeOutput .= " ! .";}
    $NodeOutput .= "\n";
}


sub emitEquivalenceRule {
    my ($rule, $res) = @_;
    my ($value, $type, @list, $var);

    $rule =~ s/\#//g;
    $value= "$output(XXX)";
    $type = getType($output, 1);
    if ((($type eq "List")||($type eq "Set")) && !($rule =~ /(\$)(.*)(\*|\?)/)) 
	{$value =~ s/XXX/[XXX]/;}

    @list =split(/\s+/, $rule);
    foreach $var (@list) {
        $var =~ s/\$(.*)\*/Star_$1/;
        $var =~ s/\$(.*)\?/Opt_$1/;
        $var =~ s/\$/Var_/g;
	$var =~ s/\#//g;
	$var = makeProperAtom($var);
    }
    $rule = join(", ", @list);
    $value =~ s/XXX/$rule/;

    $NodeOutput .= "\t$res = $value,";
    if ($res eq "Result") {$NodeOutput .= " ! .";}
    $NodeOutput .= "\n";
}

sub emitRedirectRule {
   my ($atom, $res, $myVars, $node, @list) = @_;
   my ($theRest, $out, $type, $app, @atoms);
   while ($atom =~/^(.*)(\s)$/) {$atom=$1;}
   print OUTPUT "%ERR: ($atom) ($myVars) (@list) \n";
   @atoms = split (/\s*,\s*/,$atom);
   $type = getType($input,1);
   if (($atom =~ /\$/)&& !($type eq "List") && !($type eq "Set")) {
	if ($node eq "redirect") 
	   {$out = getRedirectRes($atom, $myVars, $leafIn, @list);}
	else {$out = getRedirectRes($atom, $myVars, $input, @list);}
	#print OUTPUT "%eRR:1 ($out) ($search)\n";
   	emitRedirectRhs($res, $out, $node);
   }
   elsif ($node eq "redirect") {
        ($out,  @atoms) = getNodePart($search, $leafIn, "NotValid", @atoms);
	 #print OUTPUT "%eRR:2 ($out) ($search)\n";
	 $out =~ s/_/unSpecified/g;
         emitRedirectRhs($res, $out, $node);
   } elsif (!($type eq "List" || $type eq "Set")) {
        ($out,  @atoms) = getNodePart($search, $input, "NotValid", @atoms);
	#print OUTPUT "%eRR:3 ($out) ($search)\n";
	$out =~ s/_/unSpecified/g;
        emitRedirectRhs($res, $out, $node);
   }
   elsif ($type eq "List") {
        $atom = AddCommas($atom);
        if ($atom eq "None") {$out="Rest";}
        else {
            $out = "Temp";
            $atom =~ s/None//;
            $atom =~ s/\#//g;
            $app = "$input" . "Append";
            PrintRhsSandhi($app, $atom, $out);
        }
        emitRedirectRhs($res, $out, $node);
   }
   elsif ($type eq "Set") {
        $atom = AddCommas($atom);
        if ($atom eq "None") {$out="$input(Rest)";}
        else {
            $out = "Temp";
            $atom =~ s/None//;
            $atom =~ s/\#//g;
            $app = "$input" . "Append";
            PrintRhsSandhi($app, $atom, $out);
        }
        emitRedirectRhs($res, $out, $node);
   }
}


sub GetSlotVars {
   my ($slotName, $vars, @list)= @_;
   my ($i, $piece, $sl, @values, $count, $value, $name);
   my ($res1, $res2, @nlist, $tmp, $open, $vl); 

   #print OUTPUT "% [$slotName][$vars](@list)\n";
   $slotName =~ s/\$//g;
   
   if (isVar($slotName) eq "valid") {
	$slotName =~ s/\#//g;
	return "Var_$slotName";
   }
   if ($slotName eq $input){ 
       if (!($vars eq "AtomList")) {return $vars;}
       elsif ((getType($input,1) eq "List")||(getType($input,1) eq "Set"))
           {return "Query";}
   }
   if ($slotName =~ /^(R)([0-9]+)$/) {return $slotName;}
   if ($slotName =~ /^(CNR)([0-9]+)$/) {return $slotName;}
   if ($slotName =~ /^(CONV)$/) {return $slotName;}
   if ($vars eq "AtomList" && $slotName =~/^([a-zA-Z0-9]+)$/) {
       ($res1, @nlist) = getNodePart("GreaterThan", $slotName, "Valid", @list);
       ($res2, @nlist) = getNodePart("LessThan", $slotName, "Valid", @list);
       if ($NodeOutput =~ /$res1/) 
	  {$res1 = "\t$Vars[$next] = $res1,\n";}
       else {$res1= "\t$Vars[$next]=$res2,\n";}
       $NodeOutput = substitute($NodeOutput, $slotName, $Vars[$next]);
       $NodeOutput .= $res1;
       $slotName = $Vars[$next];
       $next++;
   }
   elsif ($vars eq "AtomList") {
       foreach $sl (@slots) {
          if ($sl =~/^([^:]*):=(.*)/) {
              $name = $1;
	      $value = $2;
	      if ($slotName =~ /$name[^(]/) {
                  foreach $piece (@list) {
		     if ($value =~ /^($piece\s)|(\s$piece\s)|(\s$piece)$/) 
			{$slotName=~ s/$name/$name($piece)/g;}
		  } #end foreach piece
		  if ($slotName=~ s/$name/$Vars[$next]/g) {
                      $NodeOutput = substitute($NodeOutput, $name, $Vars[$next]);
		      $next++;
		 } #end if $slotName match subst
	     } #end if $slotName matches a compound name
          } #end if $sl matches the slot form 
       } #end foreach $sl on Slots array	
   } #end elsif $vars is AtomList
   else {
       $slotName =~ s/$input([^(]+)/$vars$1/g;

       $i = 0;
       foreach $piece (@list) {
	   #print OUTPUT "%GSV:0 pce($piece) sN($slotName)\n";

	   if (isSlot($piece) eq "valid") {
               $slotName =~ s/$piece/$Vars[$i]/g;
	   } elsif ($piece =~ /^([a-z][^(]*)(\()/) {
	       #print OUTPUT "%GSV:1 pce($piece) first($1)\n";
	       if (isSlot($1) eq "valid") {$slotName =~ s/$1/$piece/g;}
	   } 
	   if ($piece =~ /$slotName(\()(.*)$/) {
	       #print OUTPUT "%GSV:2 pce($piece) sN($slotName)\n";
	       $slotName .= "\(";
	       $tmp = $2;	
	       $open = 1;
 	       while ($open >= 1 && !($tmp eq "")) {
		   if ($tmp =~ /^([^()]*)(\(|\))(.*)$/) {
		       $slotName .= "$1$2";
		       $vl = $2;	
		       $tmp = $3;
		       if ($vl =~ /\(/) {$open++;}
		       elsif ($vl =~ /\)/) {$open--;}
		   }
		   else {$tmp = "";}
	      } # end while
	   } #end elsif piece matches the slotName		
           $i++;
       }
       foreach $sl (@slots) {
          if ($sl =~/^([^:]*):=(.*)/) {
              $name = $1;
              if ((getType($name,1) eq "List")||(getType($name,1) eq "Set"))
	      {
		  if ($slotName =~ /$name\(\)/) {
		      $slotName =~ s/$name\(\)/$name\(\[\]\)/g;
		  } else {
                      $slotName =~ s/$name\(([^A-Z)][^)]*)\)/$name\(\[$1\]\)/g;
     		  } #end else
	      } #end if type is List or Set
          }  #end  if sl match slot form
       } #end foreach sl on slots array
   }

   return $slotName;
}

sub emitComplexLhs {
    my @lhs = @_;
    my ($piece, $vars,$count, $i,$sec,@list, @lst);
    $count=0;
    @lst = @lhs;
    if ($Debug >= 3) {print OUTPUT "%ECL: ($input) [@lhs] ";}
    $vars = "@lhs"; $vars =~ s/\$//g;
    if ($input eq $vars) {@lhs = (); $vars="false";}
    else {$vars="true";} 
    if ($Debug >= 3) {print OUTPUT "($vars)\n";}
    @lhs = OrderSlotList("GreaterThan",$input, @lhs);
    @lst = OrderSlotList("LessThan",$input, @lst);
    if ($Debug >= 2) {print OUTPUT "%ECL: [@lhs] [@lst] ";}
    foreach $piece (@lhs) 
    {
	$piece =~ s/\$//g;
        if ($vars eq "true") {
	    ($piece, @list) = getNodePart("GreaterThan", $piece, "Valid", @lhs);
	    while ($piece =~ s/_/$Vars[$next]/) {$next++;}
	}
        $count++;
    }
    $i=0;
    foreach $piece (@lst) 
    {
	$piece =~ s/\$//g;
	if ($vars eq "true") {
            ($piece, @list) = getNodePart("LessThan", $piece, "Valid", @lst);
	    while ($piece =~ s/_/$Vars[$i]/) {$i++;}
	}
    }
    if ($Debug >= 2) {print OUTPUT " [@lhs] [@lst]\n";}
    $piece =join (",",@lhs);
    $sec = join(",",@lst);
    if ($Debug >= 2) {print OUTPUT "%ECL: [$input($piece)] [$input($sec)] [$input(" . 
	getVars($count) . ")]\n";}
    if ($vars eq "false") 
    {
        $vars = "$input(" .getVars($count) . ")";
	$next = $count;
	$sec = "None";
    } else {
        $vars = "$input($piece)";
	if ($piece eq $sec) {$sec = "None";}
    }
    $NodeOutput = "node_$nodeName($vars, Result, StartNode) :-\n";

    return ($sec,$vars,@lhs);
}


sub OrderSlotList {
    my ($whichSearch,$SlotName, @List) = @_;
    my ($slot, $piece, @ord, $i, $j, $rule, $val, $tmp, @Vals, %Best, @atoms);

   foreach $val (@List) {$val =~ s/\$//g;}
    
   ($piece, @atoms) = getNodePart($whichSearch, $SlotName, "Valid", @List);
   if ($Debug >= 3) {print OUTPUT "%OSL: ($piece) ($whichSearch)\n";}

    foreach $slot (@slots) {
        @atoms = @List;
        if ($slot =~/^($SlotName)(:=)(.*)/) {
            $rule = $3;
	    $Best{$rule} = 0;
            @Vals = split(/\s\*\s/, $rule);
	    if ($Debug >= 4) {print OUTPUT "%OSL: ($slot) (@Vals)\n";}
            foreach $val (@Vals) {
		if ($piece =~ /(\($val\)|\($val\s|\($val\,|\s$val\)
			|\s$val\,|\s$val\s|\,$val\)|\,$val\s|\,$val\,
			|\,$val\(|\s$val\(|\($val\()/) 
		    {$Best{$rule} = $Best{$rule} + 2;}
		elsif ($piece =~ /$val/) 
		    {$Best{$rule} = $Best{$rule} + 1;}
		else {$Best{$rule} = $Best{$rule} - 1;}
	    }	
            foreach $val (@atoms) {
		if ($rule =~ /(\($val\)|\($val\s|\($val\,|\s$val\)
			|\s$val\,|\s$val\s|\,$val\)|\,$val\s|\,$val\,
			|\,$val\(|\s$val\(|\($val\()/) 
		    {$Best{$rule} = $Best{$rule} + 2;}
		elsif ($rule =~ /$val/) 
		    {$Best{$rule} = $Best{$rule} + 1;}
		else {$Best{$rule} = $Best{$rule} - 1;}
	    }	
	    if ($Debug >=3) {print OUTPUT "%OSL: ($rule) ($Best{$rule})\n";}	  
        } # endif 
    }
    $i = -10000;
    foreach $j (keys %Best) {
	if ($Best{$j} > $i) {$rule =$j; $i=$Best{$j};}
    }
    if ($Debug >= 2) {print OUTPUT "%OSL: Best ($rule) ($i)\n";}
    @ord = split(/\s\*\s/, $rule);
    return @ord;
}

sub substitute {

    my ($res, $type, $subst) = @_;
    my $extras;
    if ($Debug >=2) {print OUTPUT "%[$extras] [$res] ($type)\n";}
    if ($res =~ /$type\(([^)]*)(\))(.*)/) {
        $extras = "$1$2$3";
        while ($extras =~ s/^([^)]*)\(/$1/) {
            $res =~ s/$type\(([^)]*)\)/$type\($1/;
	    if ($Debug >=3) {print OUTPUT "%[$extras] [$res] ($type)\n";}
	    $extras =~ s/^([^)]*)\)\,/$1/;
	}
        $res =~ s/$type\(([^)]*)\)/$subst/;
    }
    else {$res =~ s/$type/$subst/;}
    if ($Debug >=4) {print "SUB: ($res)\n";}
    return $res;
}


sub getVarType {
    my $val = "@_";
    my $variable;

    foreach $variable (@variables) {
        if ($variable =~/^([^:]+)(:=)(.*)/)
            {if (isVarType($1, $val) eq "Valid") { return $1;}}
    }
    return "None";
}


sub getSlotType {
    my ($atom) = "@_";
    my ($slot);

    foreach $slot (@slots) {
         if ($slot =~ /^([^:]*)(\:\=)(\($atom\))/) {return $1;}
    }
    return "None";
}


sub getRedirectRes {

    my ($atom, $myVars, $type, @list) = @_;
    my ($Result, $out, $val, $cur, $extras, @subst, @nlist, @atoms);

    my ($piece, @ls, $count, $vl, $tmp, $open);

    if ($Debug >= 2) 
	{print OUTPUT "%gRR: ($atom) ($myVars) ($type) (@list)\n";}
    @subst = (); @ls = (); $count = 0;
    @atoms = split(/\s*,\s*/,$atom);
    foreach $piece (@atoms) {
        $subst[$count] = "NONE";
        if ($piece =~ s/\$//g) {
            if ($myVars eq "AtomList") {
                foreach $val (@list) {
		    ($Result, @nlist) = getNodePart($search, $piece, "NotValid", $val);
                    if ($Result =~ /(\($val\)|\($val\s|\($val\,|
                                     \s$val\s|\s$val\,|\s$val\))/)
                        {push @ls, $val;}
                } #foreach $val
                ($Result, @nlist) = getNodePart($search, $piece, "Valid", @list);
	        if ($Debug >=3) 
		    {print OUTPUT "%gRR: ($Result)-($piece,[@list]) ($Vars[$next])\n";}
               if ($Result =~ /_/) {
                   if (!(defined $varAssign{$piece})) {
                        $varAssign{$piece} = $Vars[$next];
                        $next++;         
	       	        if ($Debug >=4)            
	       	            {print OUTPUT "%gRR: cur ($NodeOutput)\n";}
                        $NodeOutput = substitute($NodeOutput, $piece, $varAssign{$piece});
                        $NodeOutput .= "\t$varAssign{$piece} = $Result,\n";
	                if ($Debug >= 4) 
	       	            {print OUTPUT "%gRR: after($NodeOutput)\n";}
	           }
                   $subst[$count] = $varAssign{$piece};
                }
            } #if myVars is AtomList
            elsif ($piece eq $input) {$subst[$count] = $myVars;}
            else {
                $cur = 0;
                foreach $val (@list) {
		    if ($val =~ /^([a-z][^(]*)(\()/) {$vl=$1;}
		    else {$vl = $val;}
                    if (isSlot($vl) eq "valid" && $piece eq $vl)
		    {
		        if ($piece eq $val) 
                            {$subst[$count] = $Vars[$cur];}
			else {$subst[$count] = $val;}
		    }
                    $cur++;
                } #foreach val
                if ($subst[$count] eq "NONE") {
                    $cur = 0;
                    foreach $val (@list) {
                        if (isSlot($val) eq "valid") {
                            ($Result, $out) = getNodePart($search, $val, "NotValid", $piece);
                            if ($Result =~ /$piece/) {
                                if (!(defined $varAssign{$piece})) {
                                    $varAssign{$piece} = $Vars[$next];
                                    $next++;
                                }
                                $subst[$count] = $varAssign{$piece};
                                $Result = substitute($Result, $piece, $subst[$count]);
                                $NodeOutput .= "\t$Vars[$cur] = $Result,\n";
                                if ($Debug >=3) {print "*$Vars[$cur]* is ($Result)\n";}
                            } # if Result matches piece
                        } # if $val is a valid Slot
		        elsif ($val =~ /($piece\()(.*)$/) {
			    $subst[$count] = $1;
			    $open =1;
			    $tmp = $2;
			    while (($open >= 1) && !($tmp eq "")) {
			        if ($tmp =~ /^([^()]*)(\(|\))(.*)$/) {
				    $subst[$count] .= "$1$2";
				    $vl = $2;
				    $tmp = $3;
				    if ($vl =~ /\(/) {$open++;}
				    elsif ($vl =~ /\)/) {$open--;}
				}
			    }
                            if (!(defined $varAssign{$piece})) {
                                $varAssign{$piece} = $subst[$count];
			    }
			} #end elsif $val is compound
                        $cur++;
                    } #foreach $val at list
                } # if $subst is NONE
            } # closes else
        } # close if is a dollar sign
        else {push @ls, $piece;}
        $count++;
    } #foreach piece at atoms
    ($Result, @nlist) = getNodePart($search, $type, "NotValid", @ls);
    for ($cur = 0; $cur < $count; $cur++) {
        if (!($subst[$cur] eq "NONE")) {
            $piece = $atoms[$cur];
            $Result = substitute($Result, $piece, $subst[$cur]);
            if ($Debug >=2) {$NodeOutput .= "% gRR: ($Result)\n";}
        }
    } #for cur from zero to count
    while ($Result =~ /(\(|\,|\[)\s*_\s*(\)|\,|\])/) {
        if ($Result =~ /(\[)\s*_\s*(\])/) 
            {$Result =~ s/(\[)\s*_\s*(\])/$1$2/;}
	else {$Result =~ s/(\(|\,|)\s*_\s*(\)|\,|)/$1unSpecified$2/;}
    }
    return $Result;
}



sub emitRedirectRhs {
    my ($res, $Result, $node) = @_;

    $NodeOutput .= "\t$node($Result, $res, StartNode),";
    if ($res eq "Result") {$NodeOutput .= " ! .";}
    $NodeOutput .= "\n";
}


sub VarNodeRule {
    my ($lhs, $rhs, @lhsList, @rhsList, $NodeRule, $vars, $res);
    $NodeRule = "@_";
    my @temp;

   ($lhs, $rhs) = getPieces($NodeRule);
   if ($lhs =~/^(\$)(.*)/) {$lhs = $2;}
   @rhsList = split(/\s+/, $rhs);
   @lhsList = split(/\s+/, $lhs);
   $vars=emitNodeLhs($input, $lhs);
   PrintNots(@lhsList);
   PrintVars(@lhsList);
   @lhsList = makeSubst(@lhsList);
   if ($rhs =~/LEAF(\()(.*)(\))/) { 
       $res=emitComplexRhs($input,$output,$rhs,$vars,"R",@lhsList);
       $NodeOutput .= "\tResult=$res, ";
   }
   elsif ($rhs =~/SELF(\()(.*)(\))/) { 
       $res = emitComplexRhs($input,$output,$rhs, $vars,"R",@lhsList);
       $NodeOutput .= "\tResult=$res, ";
   }
   else {emitSimpleRhs(@rhsList);}
   if ($traceRule == 1) {printTrace($vars);}
   $NodeOutput .= "! .\n";
}



sub getPieces {
   my $NodeRule = "@_";
   my ($lhs, $rhs, $variable, $name);

   if ($NodeRule =~/^(\()([^)]*)(\))(\s)*(=>)(\s)*(.*)/)
   {
        $lhs = $2;
        $rhs = $7;
   }
   elsif ($NodeRule =~/^(\$)([^=]+)(\s)*(=>)(\s)*(.*)/)
   {
        $lhs = "$1$2";
        $rhs = $6;
    }

   if ($lhs =~ /(.*)(\s)$/) { $lhs = $1;}
   $lhs =~ s/\!/Not_/g;
   foreach $variable (@variables) {
        if ($variable =~/^([a-z][a-zA-Z0-9]*)(:=)(.*)/) {
		$name = $1;
		if ($lhs =~ /\$$name/) {
		   if ($Debug >= 2) {print OUTPUT "%($name) in ($lhs)\n";}
		   if (!($lhs =~ /\$$name\*/)) 
		       {$lhs =~ s/\$$name(\s|\#)/Var_$name$1/g;
		       $lhs =~ s/\$$name$/Var_$name/g;}
                   if (!($rhs =~ /\$$name(\*|\?)/))
                       {$rhs =~ s/\$$name(\s|\#)/Var_$name$1/g;
                       $rhs =~ s/\$$name$/Var_$name/g;}
		}
	}
   }
   return ($lhs, $rhs);
}

sub PrintNots {
    my @list = @_;
    my $val;
 
   foreach $val (@list) {
        if ($val =~ /(Not_)(.*)/) {
            $NodeOutput .= "\tnot($2, $val),\n";
            AddNot($2);
        }
   }
}

#sub makeProperAtom {
#	my $value = "@_";
#
#	if ($value =~ /^(Var_|Star_|Opt_|Not_)/) {return $value;}
#	if ($value =~ /^(\')(.*)(\')$/) {return $value;}
#	if ($value =~ /^([^a-z0-9\$])(.*)$/) {
#	    $value =~ s/^([^a-z0-9\$])(.*)$/\'$value\'/;
#	}
#	elsif ($value =~ /^([0-9])(.*)([^0-9])(.*)$/) {
#	    $value =~ s/^([0-9])(.*)([^0-9])(.*)$/\'$value\'/;
#	}
#	else {$value =~ s/^(.*)[^[:ascii:]](.*)$/\'$value\'/;}
#	return $value;
#}


sub PrintVars {
    my @list = @_;
    my $val;
 
   foreach $val (@list) {
        if ($val =~ /(Var_)([a-z][a-zA-Z0-9]*)(\#)?([0-9]*)?/) {
            $NodeOutput .= "\tvar_" . "$2(Var_" . "$2$4),\n";
        }
   }
}


sub LhsSandhiType {
    my ($lhs, $lhs2) = @_;
    my $type = "$input" . "Append";

    $lhs = AddCommas($lhs);
    $NodeOutput = "node_$nodeName(Query, Result, StartNode) :-\n";
    $lhs =~ s/None//;
    $lhs =~ s/\#//g;
    $substVal = "Rest";
    PrintLhsSandhi($type, $lhs, "Query");

    $lhs2 = AddCommas($lhs2);
    $lhs2 =~ s/None//;
    $lhs2 =~ s/\#//g;
    if (!($lhs eq $lhs2)) {
        $substVal = "Temp";
        PrintLhsSandhi($type, $lhs2, "Temp");
    }
}


sub LhsSet {
    my $lhs = "@_";

    $lhs = AddCommas($lhs);
    $lhs =~ s/None//;
    $lhs =~ s/\#//g;
    $substVal = "$input(Rest)";

    $NodeOutput = "node_$nodeName(Query, Result, StartNode) :-\n";
    $NodeOutput .= "\tQuery = $input($Vars[$next]),\n";
    $NodeOutput .= "\tinSet([$lhs], $Vars[$next], Rest),\n";

}


sub SimpleNodeRule {
   my ($lhs, $rhs, @lhsList, @rhsList, $NodeRule, $res, $sec, $rs, $lhs2, $qu);
   $NodeRule = "@_";
   my @temp;
   $rs = "NONE";

   ($lhs, $rhs) = getPieces($NodeRule);
   @lhsList = split(/\s+/, $lhs);
   @rhsList = split(/\s+/, $rhs);
   if ($Debug >=1) {print OUTPUT "% Simple:[@lhsList] [@rhsList]\n";}

    if (getType($input, 1) eq "List") {
        $lhs = join(" ", @lhsList);
        @lhsList = makeSubst(@lhsList);
        $lhs2 = join(" ", @lhsList);
        LhsSandhiType($lhs, $lhs2);
        $res = "None";
        $qu = "Query";
   }
   elsif (getType($input, 1) eq "Set") {
        $lhs = join(" ", @lhsList);
        LhsSet($lhs);
        $res = "None";
	$qu = "Query";
   }
   else {($qu, $res, $sec) = emitListLhs(@lhsList);
        @lhsList = makeSubst(@lhsList);
   }
   while (!($res eq "Done")) {
       PrintNots(@lhsList);
       PrintVars(@lhsList);
       if ($rhs =~ /([A-Z][^:]*)(\:)(\()(.*)/) 
	   {$rs=emitComplexRhs($input,$output,$rhs,"AtomList","R",@lhsList);}
       elsif ($rhs =~ /([A-Z][^(]*)\((.*)/)
           {$rs=emitComplexRhs($input,$output,$rhs,"AtomList","R",@lhsList);}
       elsif ($rhs =~/LEAF(\()(.*)(\))/) 
	   {$rs=emitComplexRhs($input,$output,$rhs,"AtomList","R",@lhsList);}
       elsif ($rhs =~/SELF(\()(.+)(\))/) 
	   {$rs=emitComplexRhs($input,$output,$rhs,"AtomList","R",@lhsList);}
       elsif ($rhs =~/^(\s*)SELF(\(\))(\s*)$/) {
	   $substVal = FixDontCares($substVal);
	   $NodeOutput .= "\tnode_$nodeName($substVal, Result, StartNode), 
";
       }
       elsif ($rhs =~/SELF(\(\))/)
           {$rs=emitComplexRhs($input,$output,$rhs,"AtomList", "R",@lhsList);}
       else {emitSimpleRhs(@rhsList);}
       if (!($rs eq "NONE")) {
	  $NodeOutput .= "\tResult=$rs, ";
	  $rs = "NONE";
       }
       if ($traceRule == 1) {printTrace($qu);}
       $NodeOutput .= "! .\n";
       if ($res eq "None") { $res = "Done";}
       else { PrintNodeRule(); $next=0; %varAssign = (); 
	   $NodeOutput = "node_$nodeName($res, Result, StartNode) :-\n";	 
	   $qu=$res; $res="None"; $substVal = $sec;
	   $search = "LessThan"}
   }
}

sub emitNodeLhs {
    my ($lhs, $type) = @_;
    my ($count, $slot, @values, $value, $vars);

    foreach $slot (@slots) {
        if ($slot =~/^($input):=(.*)/) {
            @values = split(/\s+\*\s+/, $2);
            $count = 0;
            foreach $value (@values) { $count++;}
        }
    }
    $lhs .= "(XXX)";
    $vars = getVars($count);
    $next = $count;
    $lhs =~ s/XXX/$vars/;
    $NodeOutput = "node_$nodeName($lhs, Result, StartNode) :-\n";
    if ($input eq $type) { return $lhs;}
    return $vars;
}


sub getNodePart {
    my ($flag, $var, $setflag, @list) = @_;
    my ($count, $slot, @values, $value, @res, $val, $Result, $vl, $nxt);
    my $found = "No";
    my (@nlist, $cur, %Best);
    @res = ();

    foreach $value (@list) 
	{$value =~ s/XXS//g;}
    
    foreach $slot (@slots) {
	@nlist = @list;
        if ($slot =~/^($var):=(.*)/) {
            @values = split(/\s\*\s/, $2);
            $count = 0;
            foreach $value (@values) {
                $res[$count] = "_";
		#if (notMatched(@nlist) eq "Yes") {
                  if (isSlot($value) eq "valid") {
                    ($res[$count], @nlist) = getNodePart($flag, $value, $setflag, @nlist);
                  } elsif ($value =~/(\(\$)([^)]*)(\slist|\sset)(\))/) {
                    ($res[$count], @nlist) = getListPart($2, $setflag, @nlist);
                  } elsif ($value =~/(\(\$)([^)]*)(\))/) {
		    $nxt = $2;
                    foreach $val (@nlist) {
			if ($val =~/^(Not_)(.*)/) {$vl = $2;}
			elsif ($val =~/^(Var_)(.*)/) {$vl = $2;}
			else { $vl = $val;}
                        if (isVarType($nxt, $vl) eq "Valid"){
	    		    $val = makeProperAtom($val);
			    $res[$count] = $val; $val = "XXXXX";
		        }elsif ($nxt eq $vl) {
	    		    $val = makeProperAtom($val);
			    $res[$count]=$val; $val="XXXXX";
			}
                    }
                  } elsif ($value =~/(\()([^)]*)(\))/) {
		    $nxt = $2;
                    foreach $val (@nlist) {
			if ($val =~/^(Not_)(.*)/) {$vl = $2;}
			else { $vl = $val;}
                        if ($vl eq $nxt){
	    		    $val = makeProperAtom($val);
                            $res[$count]=$val; $val="XXXXX";
			}
                    } #close foreach
                  } #close elsif
                #} # if notMatched 
                $count++;
            } #foreach value
            $Result = join(", ", @res);
            $Result = "$var($Result)";
            $Best{$Result} = 0;

            foreach $val (@list) {
		if ($Result =~/$val/) {$Best{$Result} = $Best{$Result} + .8;}
		if ($Result =~/(\($val\)|\($val\,|\s$val\,|\s$val\))/)
		    {$Best{$Result} = $Best{$Result} + .2;}	    
            }
        } #if slot
    } #foreach slot
    $cur = -1;
    foreach $val (keys %Best) {
        if ($Best{$val} > $cur) { $Result = $val; $cur = $Best{$val};}
	elsif ($Best{$val} == $cur) {
	    if (!($val =~ /\(\)/)) {
		if ($flag eq "GreaterThan" && (length $val > length $Result)) 
		    {$Result = $val; $cur=$Best{$val};}
		elsif ($flag eq "LessThan" && (length $val < length $Result))
		    {$Result = $val; $cur=$Best{$val};}
	    }
	}
    }
    foreach $val (@nlist) {
        if ($Result =~/(\($val\)|\($val\,|\s$val\,|\s$val\)|\[$val\]|\[$val\,|\s$val\])/)
            {$val = "XXXXX";}
    }

    return ($Result, @nlist);
}

sub notMatched {
   my @list = @_;
   my $val;
   foreach $val (@list) {
	if (!($val eq "XXXXX")) {return "Yes";}
   }
   return "No";	
}    


#sub getListPart {
#    my ($var, $flag, @ls) = @_;
#    my ($li, @res, $result);
#
#    foreach $li (@ls) {
#        if (isVarType($var, $li) eq "Valid") {
#	    $li = makeProperAtom($li);
#            push @res, $li;
#            $li = "XXXXX";
#        }
#    }
#    #print "GLP: [@res] (@ls)\n";
#    $result = join(", ", @res);
#    if ($result eq "") {
#        if ($flag eq "Valid") {return ("_", @ls);}
#	else {return ("[]", @ls);}
#    }
#    $result = "[$result]";
    #print "GLP: RET[$result]\n";
#    return ($result, @ls);
#}


sub LhsMatchError {
    my @list = @_;
    my $var;   

    if (notMatched(@list) eq "Yes") {	
	print "Error line: $myCount, for type: $input\n";
	print "\tCould not match: ";
	for $var (@list) {
	    if (!($var eq "XXXXX")) {print "$var ";}
	}
	print "\n";
    }
}
		 
sub emitListLhs {
    my @lhs = @_;
    my ($lhsResult, $count, $piece, $second, @list);
    my ($substRes1, $substRes2, @nlist);    
    $count=0;

    ($lhsResult, @list) = getNodePart("GreaterThan", $input, "Valid", @lhs);
    LhsMatchError(@list);
    ($second, @list) = getNodePart("LessThan", $input, "Valid", @lhs);
    @nlist = makeSubst(@lhs);
    ($substRes1, @list) = getNodePart("GreaterThan", $input, "Valid", @nlist);
    ($substRes2, @list) = getNodePart("LessThan", $input, "Valid", @nlist);
    if ($lhsResult eq $substRes1) {
        $NodeOutput = "node_$nodeName($lhsResult, Result, StartNode) 
:-\n";
        if ($second eq $lhsResult) {return ($lhsResult, "None", "None");}
        else { return ($lhsResult, $second, "None");}
    }
    else {
	    $lhsResult =~ s/(Var|Not)_/$1XVXVX/;
	    $second =~ s/(Var|Not)_/$1XVXVX/;
	    $substRes1 =~ s/(Var|Not)_/$1XVXVX/;
	    $substRes2 =~ s/(Var|Not)_/$1XVXVX/;
	while ($lhsResult =~ /_/) {
	    $lhsResult =~ s/_/$Vars[$next]/;
	    $second =~ s/_/$Vars[$next]/;
	    $substRes1 =~ s/_/$Vars[$next]/;
	    $substRes2 =~ s/_/$Vars[$next]/;
	    $next++;
	}
	$lhsResult =~ s/XVXVX/_/;
	$second =~ s/XVXVX/_/;
	$substRes1 =~ s/XVXVX/_/;
	$substRes2 =~ s/XVXVX/_/;
        $NodeOutput = "node_$nodeName($lhsResult, Result, StartNode) 
:-\n";
	$substVal = $substRes1;
	if ($second eq $lhsResult) {return ($lhsResult, "None", "None");}
	else {return ($lhsResult, $second, $substRes2);}
    }

}



sub getVars {
    my $count = "@_";
    my ($i, $vars);
    $vars = "";
    for ($i=0; $i < $count; $i++) {
        $vars .= "$Vars[$i]";
        if ($i != $count-1) {$vars .= ",";}
    }
    #print " vars $vars \n";
    return $vars;
}


sub emitSimpleRhs {
    my @rhs = @_;
    my ($rhsResult, $val, @temp);
    if ("@rhs" eq "!") { $NodeOutput .= "\t!, fail, ";}
    else {
        foreach $val (@rhs) {
            $val =~ s/\$(.*)\*/Star_$1/;
            $val =~ s/\$(.*)\?/Opt_$1/;
            $val =~ s/\$/Var_/g;
            $val =~ s/\#//g;
        }
        ($rhsResult, @temp) = getNodePart("GreaterThan", $output, "Valid", @rhs);
	$rhsResult =~ s/\(_\)/\(\[\]\)/g;
        $NodeOutput .= "\tResult = $rhsResult, ";
    }
}

sub getNewList {
    my ($type, $count, $prevType, @vals) = @_;
    my @newList;
    
    $newList[0] = "NotValid";
    if ($type eq "List" || $type eq "Set") {
        if (CheckList($prevType, @vals) eq "Valid") {@newList = @vals;}
    }
    if ($type eq "None") {
	if ($count <= 1) {$newList[0] = $vals[0];}
	else {@newList = orderSlot($prevType, @vals);}
    }
    if ($type eq "atom$vals[0]") {$newList[0] = $vals[0];}
    return @newList;
}


sub CheckList {
    my ($slotName, @vals) = @_;
    my ($slot, $varType, $val);

    foreach $slot (@slots) {
        if ($slot =~/^($slotName)(:=)(\(\$)([^\s]*)\s(list|set)(\))/)
	    {$varType = $4;}
    }
        foreach $val (@vals) {
        if (isVarType($varType, $val) eq "NotValid") {return "NotValid";}
    }
    return "Valid";
}


#sub getTypeString {
#    my ($slotType, $count, @vals) = @_;
#    my $Result = "$slotType(XXX)";
#    my $oldtype = $slotType;
#    my $num = 1;
#    my $type = getType($oldtype, $num);  
#    my (@newList, $res);
#    @newList = getNewList($type, $count, $oldtype, @vals);
#    if ($Debug >= 2) {print OUTPUT "% GetTypeString: $type (@newList)\n";}
#    while (($newList[0] eq "NotValid") && !($type eq "None" || $type eq 
#"Set" || $type eq "List"  || $type eq "atom$vals[0]"))
#    {
#	if ($Debug >=3) {print OUTPUT "% GetTypeString:$type @newList\n";}
 #       if ($type eq "None" || $type eq "List" || $type eq "Set" || $type 
#=~ /^(atom)(.*)/)
 #       {
  #          $num++;
   #         $oldtype = $type = $slotType;
    #        $type = getType($type, $num);
  #      }
  #      else {
  #          $Result =~ s/XXX/$type\(XXX\)/;
  #          $oldtype = $type;
  #          $type = getType($type, $num);
  #      }
  #      if ($type eq "No Match") {return "No Match";}
  #      @newList = getNewList($type, $count, $oldtype, @vals);
  #      if ($Debug >=2) {print OUTPUT "% GetTypeString:$type $oldtype\n";}
  #  }
            
 #  $Result = AddResult($type, $Result, @newList);
 #       
 #  return $Result;
#}

sub getTypes {
    my $node = "@_";
    my ($in, $out, $value);

    foreach $value (@TypeList) {
        if ($value =~ /^($node):=([a-z][^-]*)->([a-z].*)$/)
        {
            $in = $2;
            $out = $3;
            return ($in, $out);
        }
    }
    print "Error $myCount: Undefined node $node called here.\n";
    return ("None", "None");
}

sub printSlotToSlotRule {
    my ($have, $want) = @_;
    my ($slot, $slotName, $slotDefn, $temp, $piece, @pieces);
    my $res = "Invalid";
    my $flag = "Valid";

    foreach $slot (@slots) {
        if ($slot =~ /^([a-z].*):=(.*)$/) {
            $slotName = $1;
            $slotDefn = $2;
            if (($slotName eq $have)&&($slotDefn =~ /$want/))
            {
                while ($slotDefn =~ /$want/) {
                    @pieces = split(/\s\*\s/,$slotDefn);
                    foreach $piece (@pieces) {
                        if (($piece eq $want)&&($flag eq "Valid"))
                            {$piece = "Y"; $flag="Invalid";}
                        else {$piece = "_";}
                    }
                    $temp = join(",",@pieces);
                    print OUTPUT "convert(X,Y) :-\n";
                    print OUTPUT "\tY = $want(_),\n";
                    print OUTPUT "\tX = $have($temp).\n";
                    $slotDefn =~ s/$want/_/;
                    $flag = "Valid";
                }
                $res = "Valid";
            }
            elsif (($slotName eq $want)&&($slotDefn eq $have))
            {
                print OUTPUT "convert(X,Y):-\n";
                print OUTPUT "\tX = $have(_),\n";
                print OUTPUT "\tY = $want(X) .\n";
                $res = "Valid";
            }
            elsif (($slotName eq $want)&&($slotDefn =~ /$have/))
            {
                if ($res eq "Invalid") {$res = "Error";}
            }
        } # end if
    } #end for
    return $res;
} #end function


sub AddResult {
    my ($type, $Result, @List) = @_;
    my ($piece, $res);
    
    foreach $piece (@List) {
	$piece = makeProperAtom($piece);
	$piece =~ s/\#//g;
    }

    $res = join(", ", @List);

    if ($res eq "'NotValid'") {return "No Match";} 
    if ($type eq "List" || $type eq "Set") {$Result =~ s/XXX/[$res]/;}
    else {$Result =~ s/XXX/$res/;}
    
    return $Result;
}


sub getType {
    my ($slotName, $num) = @_;
    my ($slot, $type, $i);

    $type = "None";
    $i=0;
    foreach $slot (@slots) {
        if ($slot =~ /^($slotName):=(.*)/) {
            $type = $2;
	    $i++;	
        }
        if ($i == $num) {
            if ($type =~/^[a-z](.*)/) { return $type;}
            elsif ($type =~/^(\(\$)([^\s]+)\s(list)(\))/) {return "List";}
            elsif ($type =~/^(\(\$)([^\s]+)\s(set)(\))/) {return "Set";}
            elsif ($type =~/^(\(\$)(.*)/) {return "None";}
            elsif ($type =~/^(\()([^)]+)(\))/) {return "atom$2";}
        }
    }
    if ($i < $num) {
        if ($type =~/^[a-z](.*)/) { return $type;}
        elsif ($type =~/^(\(\$)([^\s]+)\s(list)(\))/) {return "List";}
        elsif ($type =~/^(\(\$)([^\s]+)\s(set)(\))/) {return "Set";}
        elsif ($type =~/^(\(\$)(.*)/) {return "None";}
        elsif ($type =~/^(\()([^)]+)(\))/) {return "atom$2";}
    }
    return "No Match";    
}


sub orderSlot {
   my ($slotName, @vals) = @_;
   my ($slot, $count, $value, $val, $i, $j, $temp);
   my @values;
   my $found = "NotValid";

   if ($slotName =~/(.*)(\s+)$/) {$slotName=$1;}
   foreach $slot (@slots) {
        if ($slot =~/^($slotName):=(.*)/) {
	    $found = "Valid";
            @values = split(/\)\s+\*\s+\(\$/, $2);
            $count = 0;
            foreach $value (@values) { $count++;}
            if ($values[0] =~ /^(\(\$)(.*)/) {$values[0] = $2;}
            if ($values[$count-1] =~ /(.*)(\)\s*)$/) {$values[$count-1]=$1;}
            $i = 0;
            foreach $value (@values) {
		#print "%values $value $vals[$i]\n";
                if (isVarType($value, $vals[$i]) eq "NotValid") {
		   	$found = "NotValid";
                        $j = 0;
                        foreach $val (@vals) {
                            if (isVarType($value, $val) eq "Valid") {
                                $found = "Valid";
			        $temp = $vals[$j];
                                $vals[$j] = $vals[$i];
                                $vals[$i] = $temp;
                            }
                            $j++;
                        }
                }
                $i++;
            }
        }
    }
    if ($found eq "Valid") {return @vals;}
    else {return $found;}
}


sub isVarType {
    my ($varName, $varValue) = @_;
    my ($variable, $value, @values, $nxtval);

    foreach $variable (@variables) {
        if ($variable =~/^($varName)(:=)(.*)/) {
 	    if ($varValue =~ /^(Var_)($varName)/) {return "Valid";}
            @values = split(/\s+/, $3);
            foreach $value (@values) {
                if ($value =~/^(\s$varValue|$varValue|$varValue\s)$/)
                    {return "Valid";}
		elsif ($value =~/^(\$)(.*)$/) {
		    $nxtval = $2;
		    if (isVarType($nxtval, $varValue) eq "Valid")
		       {return "Valid";}
		    elsif ($nxtval eq $varValue) {return "Valid";}

		}
            }
        }
    }
    return "NotValid";
}

sub SortSlots {
    my ($count, $slot, @rating, $i, $j, $Max, $index, $temp);

    $count=0;
    foreach $slot (@slots){
        if ($slot =~ /^([a-z][^:]*)(:=)(\()([^\$\)]*)(\))/)
            {$rating[$count]=1;}
        else {$rating[$count] =2;}
        $count++;
    }

    for ($i=$count; $i > 0; $i--) {
        $Max = $rating[0];
        $index = 0;
        for ($j=0; $j<$i; $j++) {
            if ($rating[$j] > $Max) {
                $Max = $rating[$j];
                $index = $j;
            }
        }
        $temp = $rating[$index];
        $rating[$index] = $rating[$i-1];
        $rating[$i-1] = $temp;
        $temp = $slots[$index];
        $slots[$index] = $slots[$i-1];
        $slots[$i-1] = $temp;
    }
}


sub emitSlotRule {
      my ($slotname, $slotrule) = @_; 

      if ($slotrule =~ /^(.+)(\s)$/) { $slotrule = $1;}
      SlotBegin($slotname);
      if ($slotrule =~/^(\(\$)([^\s]+)\s(list)(\))/) {
		ListSlotRule($slotname, $slotrule);
		ListAppendRule($slotname);
      } elsif ($slotrule =~/^(\(\$)([^\s]+)\s(set)(\))/) {
		ListSlotRule($slotname, $slotrule);
		SetAppendRule($slotname);
		SlotEnd();
		ListAppendRule($slotname);
      #} elsif ($slotrule =~/^(\(\$)(.+)/) {
	#	SlotwithVars($slotrule);
      } elsif ($slotrule =~/^([a-z]|\(\$)(.*)/) {
		CrossSlot($slotrule);
      } elsif ($slotrule =~/^(\()([^)\s]+)(\))(\s*)$/) {
		   print OUTPUT "$2))";
      } else {
	       CrossSlot($slotrule);
      }
      SlotEnd();
}			   



sub ListSlotRule
{
    my ($slotname, $slotrule) = @_;
    ListSlot1($slotrule);
    SlotEnd();
    SlotBegin($slotname);
    ListSlot2($slotname, $slotrule);
    SlotEnd();
}

sub SlotBegin {
    my $SlotName = "@_";
    print OUTPUT "slot_$SlotName($SlotName(";
}

sub SlotEnd { print OUTPUT ".\n";}


sub ListAppendRule {
    my $SlotName = "@_";
    
    print OUTPUT "$SlotName" . "Append($SlotName($Vars[0]), $SlotName($Vars[1]),"
        . " $SlotName($Vars[2])) :-\n";
    print OUTPUT "\tappend($Vars[0], $Vars[1], $Vars[2]) ";
}

sub SetAppendRule {
    my $SlotName = "@_";
    
    print OUTPUT "$SlotName" . "Append($SlotName($Vars[0]), $SlotName($Vars[0])," . 
	" $SlotName($Vars[0])) ";
}


sub printVars {
    my $count = "@_";
    my $i;
    for ($i=0; $i < $count; $i++) {
	print OUTPUT "$Vars[$i]";
	if ($i != $count-1) {print OUTPUT ",";}
	else {print OUTPUT ")) :-\n";}
    }
}

sub CrossSlot {
    my ($Name, $count, $i, @VarName);
    my $SlotRule = "@_";

    @VarName = split(/\s+\*\s+/, $SlotRule);

    foreach $Name (@VarName) { $count++;}
    printVars($count);

    $i=0;
    foreach $Name (@VarName) {
	if ($Name=~ /\(\$([^)]+)\)/) {
	    print OUTPUT "\tvar_$1($Vars[$i])";
	} else {
            print OUTPUT "\tslot_$Name($Vars[$i])";
	}
        if ($i != $count-1) {print OUTPUT ",\n";}
        $i++;
    }
}


sub ListSlot1 {
   my $SlotRule = "@_";
   my ($curvar);

if ($SlotRule =~/^(\(\$)([^)]+)\s(list|set)(\))/) {$curvar = $2};

    print OUTPUT "[])) ";
}


sub ListSlot2 {
   my ($SlotName, $SlotRule) = @_;
   my $curvar;

   if ($SlotRule =~/^(\(\$)([^)]+)\s(list|set)(\))/) {$curvar = $2};

    print OUTPUT "[$Vars[0]|$Vars[1]])) :-\n";
    print OUTPUT "\tvar_$curvar($Vars[0]),\n";
    print OUTPUT "\tslot_$SlotName($SlotName([$Vars[1]]))";
}
	

sub PrintLeafRules {
    my $nName;
    foreach $nName (keys %isLeaf) {
        print OUTPUT "leafNode(Query, Result, Name) :- % forward\n" .
                "\tName = '" . $nName . "',\n" .
                "\tvariety(Query),\n" .
                "\tnode_$nName" .  "(Query, Result, start_$nName) .\n\n"
            if $isLeaf{$nName};
    }
    foreach $nName (keys %isLeaf) {
        print OUTPUT "redirect(Query, Result, start_$nName) :- " .
                "node_$nName(Query, Result, start_$nName) .\n"
            if $isLeaf{$nName};
    }
    foreach $nName (@redirects) {
        print OUTPUT "redirect(Query, Result, start_$nName) :- " .
                "node_$nName(Query, Result, start_$nName) .\n";
    }
}


sub isSlot {
	my $slot;
	foreach $slot (@slots) {
	     if ($slot =~ /^(@_)(\:\=)(.+)/) {
		return "valid";
	     }
	}
	return "NotValid";
} #isSlot

sub isVar {
	my $var;
	foreach $var (@variables) {
	     if ($var =~ /^(@_)(\:\=)(.+)/) {
		return "valid";
	     }
	}
	return "NotValid";
} #isVar


sub LeafErrors {
    my ($in, $out, $num) = @_;

    if (isSlot($in) eq "NotValid") {
        print "Type Error: $in used for input of #leaf where type expected.\n";
    }
    if (isSlot($out) eq "NotValid") {
        print "Type Error: $out used for output of #leaf where type expected.\n";
    }
    if ($num > 1) { print "Error:  More than one #leaf declared.\n";}
    elsif ($num < 1) {print "Error: No #leaf declared.\n";}
}



sub CreateLeafRule {
    # passed a leaf input from LATR theory without #leaf and number
    # number of time Create Leaf Rule has been called
    my ($leafRule, $num) = @_;
    my ($in, $out);
    my ($rule);

    ($in, $out) = GetInOutTypes($leafRule);
    CheckValidityLeaf($in, $out, $num);

    $rule = "% Leaf input type: ($in), Leaf output type: ($out)\n";
    return $rule;
}

sub CheckValidityLeaf {
    my ($in, $out, $num) = @_;

    if (isSlot($in) eq "NotValid") {
        print "Type Error: $in used for input of #leaf where type expected.\n";
    }
    if (isSlot($out) eq "NotValid") {
        print "Type Error: $out used for output of #leaf where type expected.\n";
    }
    if ($num > 0) { print "Error:  More than one #leaf declared.\n";}
    elsif ($num < 0) {print "Error: No #leaf declared.\n";}
}


sub GetInOutTypes {
   # input is a type set from leaf or node declaration
   my ($types) = "@_";
   my ($in, $out);

   # remove a last period and/or spaces from beginning and end
   $types =~ s/(\.)$//;
   $types =~ s/(\s+)$//;
   $types =~ s/^(\s+)//;

   # get the type names
   if ($types =~ /^([a-z][^\-\s]*)(\s*\-\>\s*)([a-z].*)/) {
        $in = $1; $out = $3;
   }

   return ($in, $out);
}


sub CreateComment {
    # Create Comment is passed comment minus starting token
    my $comment = "@_";

    # split the comment via endlines
    my @comments = split("\n", $comment);

    # get the numComments in the list
    my $numComments = 0;
    foreach $comment (@comments) {$numComments++;}
    # remove Star Slash from the last comment line
    if ($comments[$numComments-1] =~ /(^.*)(\*\/)$/)
         {$comments[$numComments-1] = $1;}

    # add percent and endline to each comment to make into prolog comment
    foreach $comment (@comments) {
        $comment = "% $comment \n";
    }

    #return the list of prolog formated comments
    return @comments;
}

sub CreateVarRule {
    #var Query is LATR theory rule with #vars
    my $varQuery = "@_";
    my ($varName, $varDefn);
    my @varVals = ();
    my @varRules = ();

    # extract the name and defn of variable
    ($varName, $varDefn) = ExtractNameAndDefn($varQuery);

    # check defn first case defn uses operators
    if ($varDefn =~ /(\+|\-|\*)/) {
        @varRules = CreateVarWithOpRule($varName, $varDefn);
    }
    # defn is list
    else { @varRules = CreateVarListRule($varName, $varDefn);}

    return @varRules;
}

sub CreateVarListRule {
    # input is the variable name and a list defn
    my ($name, $defn) = @_;
    my ($value, $rule);
    my @varRules = ();

    # split defn into its values via spaces
    my @values = split(/\s+/, $defn);

    # go through each value creating rule
    foreach $value (@values) {
        # rule for another variable in list
        if ($value =~ s/^(\$)//) {
            # validate var
	    if (isVar($value) eq "NotValid") 
		{print "Error: $value used where declared variable expected\n";}
            $rule = "var_" . $name . "(X):- var_" . $value . "(X).\n";
        }
        # rule for an atom
        else {
            $value = makeProperAtom($value);
            $rule = "var_" . $name . "(" . $value . ").";
        }
        push @varRules, $rule;
    }

    return @varRules;

}

sub CreateVarWithOpRule {
    # input is the name and defn of variable input with an operator
    my ($name, $defn) = @_;
    my @valList = ();
    my $ruleStart = "var_" . $name . "(X) :- ";
    my ($op, $term, $rule, $value);
    my @varRules = ();

    # add * to defn to start
    $defn = "* " . $defn;

    while ($defn =~ /^(\s*)(\+|\-|\*)(\s*)(\$)([^\s]+)(.*)$/) {
        $op = $2; $term = $5; $defn = $6;
        #validate term
	if (isVar($term) eq "NotValid") 
	    {print "Error: $term is not declared variable\n";}
        if ($op eq "*") {
            $rule = "var_" . $term . "(X)";
        } elsif ($op eq "-") {
            $rule = "not(var_" . $term . "(X))";
        } elsif ($op eq "+") {
            $value = join(",", @valList);
            $rule = $ruleStart . $value . ".";
            push @varRules, $rule;
            @valList = ();
            $rule = "var_" . $term . "(X)";
        }
        push @valList, $rule;
    }
    $value = join(",", @valList);
    $rule = $ruleStart . $value . ".";
    push @varRules, $rule;

    return @varRules;

}

sub ExtractNameAndDefn {
    # passed either a var or type rule and will extract name and defn
    my $rule = "@_";
    my $name = "";
    my $defn = "";

    #extract name and defn from rule
    if ($rule =~ /^(\$)?([^=:\s]+)(\s*)(=|:)([^\.]+)(\.)(\s*)/) {
        $name = $2; $defn = $5;
    }
    $name =~ s/(\s+)$//g;
    $name =~ s/^(\s+)//g;
    $defn =~ s/(\s+)$//g;
    $defn =~ s/^(\s+)//g;
    # return the name and defn
    return ($name, $defn);
}

sub CreateTypeRule {
    # type input from theory passed in
    my $type = "@_";
    my @typeRules = ();
    my ($typeName, $typeDefn);

    #extract name and defn from type input
    ($typeName, $typeDefn) = ExtractNameAndDefn($type);

    # use the name and defn to get a list of possible rules created
    @typeRules = MakeDefnRules($typeName, $typeDefn);

    # return this list of type rules
    return @typeRules;
}

sub MakeDefnRules {
    # given the type name and type defn
    my ($typeName, $typeDefn) = @_;

    my @typeRules = ();
    my @typeDefns = ();
    my ($rule, $listT, $isList);

    # split the defn based on any ors
    @typeDefns = split(/\s+or\s+/, $typeDefn);

    # for each defn we create possible rules
    foreach $typeDefn (@typeDefns) {
        # list or set rules
        if ($typeDefn =~ /^(\(\$)([^\s]+)(\s)(list|set)(\))$/) {
             $rule = CreateListorSetTypeRule($typeName, $typeDefn);
             push @typeRules, $rule;
        }
        # or basic rules
        else {
            $rule = CreateBasicTypeRule($typeName, $typeDefn);
            push @typeRules, $rule;
        }
    }

    return (@typeRules);
}

sub CreateListorSetTypeRule {
    my ($name, $defn) = @_;
    my ($isList, $rule, $typeRule);

    if ($defn =~ /^(\(\$)([^\s\)]+)(\s+)(list|set)(\))/) {
        $isList = $4;
    }
    $typeRule = getBasicListRule($name, $defn);
    if ($isList eq "set") {
        $rule = getSetAppendRule($name);
        $typeRule .= $rule;
    }
    $rule = getListAppendRule($name);
    $typeRule .= $rule;

    return $typeRule;
}

sub CreateBasicTypeRule {
    # pass in the type name and defn of a basic rule
    my ($name, $defn) = @_;
    my @slotOrVarList = ();
    my @queryList = ();
    my ($val, $value, $rule, $typeRule);
    my $numValues = 0;
    #split the defn via '*'
    my @valueList = split(/\s*\*\s*/, $defn);

    # for each value get var name and rule for generation
    #   or if value is an atom use atom explicitly
    foreach $value (@valueList) {
        $val = getAtomOrVar($value);
        if ($val eq "X") {
            $val .= "$numValues";
            $rule = GetTypeGen($value, $val);
            push @slotOrVarList, $rule;
        }
        push @queryList, $val;
        $numValues++;
    }

    # join the lists and put together rule
    $val = join(",", @queryList);
    $rule = join(",\n\t", @slotOrVarList);
    # if rule is not empty add start
    if (!($rule eq "")) { $rule = ":-\n\t" . "$rule";}

    $typeRule = "slot_" . $name . "(" . $name . "(" . $val . ")) $rule .";
    return $typeRule;
}

sub GetTypeGen {
    # passed a value to generate and store in varName
    my ($value, $varName) = @_;
    my $typeinfo = "";

    # if generating variable
    if ($value =~ /^(\(\$)([^\)\s]*)(\s)*(list|set)*(\))$/) {
        $value = $2;
        $typeinfo = "var_" . $value . "($varName)";
        # want to validate elsewhere
        if (isVar($value) eq "NotValid") 
            {print "Type Error: $value used where variable expected\n";}
    }
    # generating a type
    else { 
	if (isSlot($value) eq "NotValid") 
            {print "Type Error: $value used where type expected\n";}
	$typeinfo = "slot_" . $value . "($varName)"; 
    }

    return $typeinfo;
}

sub getAtomOrVar {
    # passed a value if it is atomic return value, else return X
    my $value = "@_";
    my $retVal = "X";

    if ($value =~ /^(\()([^\$\)]+)(\))$/) {
        $retVal = $2;
    }
    #add else to validate slot and variable types exist

    return $retVal;
}


sub getBasicListRule {
    my ($typeName, $typeVal) = @_;
    my ($typeRule, $valT, $slotT);

    $valT = GetTypeGen($typeVal, "X");
    $slotT = GetTypeGen($typeName, "[Y]");
    $typeRule = "slot_" . $typeName . "(" . $typeName . "([])).\n";
    $typeRule .= "slot_" . $typeName . "(" . $typeName . "([X|Y])) :-\n\t"
        . $valT . ",\n\t" . $slotT . " .\n";

    return $typeRule;
}

sub getListAppendRule {
    my $typeName = "@_";
    my $listAppendRule;

    $listAppendRule = $typeName . "Append($typeName(X), $typeName(Y), " .
        "$typeName(Z)) :-\n\tappend(X,Y,Z) .\n";

     return $listAppendRule;
}

sub getSetAppendRule {
    my $typeName = "@_";
    my $setAppendRule;

    $setAppendRule = $typeName . "Append($typeName(X), $typeName(X), " .
        "$typeName(X)) .\n";

    return $setAppendRule;
}


sub OrderCRules {
    my (@creates) = @_;
    my ($size, $i, $cur, $index, $max, $temp, $val, $name);
    $size = 0;
    foreach $val (@creates) {$size++;}

    for ($cur=$size; $cur > 1; $cur--) {
        $index=0;
        if ($creates[0] =~ /^(create_)([a-z][^\(]*)(\()/) {$max=$2;}
        for ($i=0; $i<$cur; $i++) {
            if ($creates[$i] =~ /^(create_)([a-z][^\(]*)(\()/) {
                $name = $2;
                if ($name eq $max) {$max=$name; $index=$i;}
                elsif ($name > $max) {$max=$name; $index=$i;}
            }
        }
        $temp = $creates[$index];
        $creates[$index] = $creates[$cur-1];
        $creates[$cur-1] = $temp;
    }

    return @creates;
}


sub GetDepthCreateRules {
    my $rule = "@_";
    # print "%($rule) [@_]\n";
    my ($name, $defn, $val, $vl, $from, @values, @defns);
    my @dRules = ();
    if ($rule =~ /^([a-z][^\:]*)(\:\=)(.*)$/) {$name = $1; $defn=$3;}
    # print "($rule) nm($name) dfn($defn)\n";
    @defns = split(/\s+\*\s+/, $defn);
    @values = split(/\s+/, $Depth{$name});
    foreach $val (@values) {
        if ($val =~ /^([a-z][^\:]*)(\:\=)(.*)$/) {
            $from = $1;
            foreach $vl (@defns) {
                if ($vl eq $from) {
                    $rule=MakeRecursiveCreate($name, $val, $defn);
                    push @dRules, $rule;
                }
            } # checking each defn for path
        } # close if found a path instead of singleton
    }
    return @dRules;
}

sub CreateCreateRule {
    # type input from theory passed in
    my $type = "@_";
    my @typeRules = ();
    my ($typeName, $typeDefn, $rule);

    # print "% ($type)\n";

    #extract name and defn from type input
    ($typeName, $typeDefn) = ExtractNameAndDefn($type);
     # print "% tN($typeName) tD($typeDefn)\n";

    # use the name and defn to get a list of possible rules created
    @typeRules = ExamineDefnForCreates($typeName, $typeDefn);

    #get the reflexive rule
    $rule = GetReflexiveCreate($typeName);
    push @typeRules, $rule;

    # return this list of type rules
    return @typeRules;
}


sub GetReflexiveCreate {
    my $name = "@_";
    my $rule;

    $rule = "create_" . $name . "(X,X):-\n\tslot_" . $name .
        "(X) .\n";
    return $rule;
}

sub ExamineDefnForCreates {
    # given the type name and type defn
    my ($typeName, $typeDefn) = @_;

    my @typeRules = ();
    my @typeDefns = ();
    my ($rule, $listT, $have);
    my ($want, $count, @list);

    # split the defn based on any ors
    @typeDefns = split(/\s+or\s+/, $typeDefn);

    # for each defn we create possible rules
    foreach $typeDefn (@typeDefns) {
        # found a single variable or var list or set
        if ($typeDefn =~ /^(\(\$)([^\s]+)(\slist|\sset)?(\))$/) {
             $have = $2;
             $rule = MakeBasicCreateRule($have, $typeName, $typeDefn);
             push @typeRules, $rule;
        }
        # check for defn of types not vars
        elsif ($typeDefn =~ /^([a-z][^\$]*)$/) {
            @list = split(/\s+\*\s+/, $typeDefn);
            $count = 0;
            foreach $want (@list) {$count++;}
            $want = join(" ", @list);
            push @DepthRules, "$typeName:=$typeDefn";
            if (defined $Depth{$typeName}) {AddDepthTo($typeName,$typeName,$want);}
            else {$Depth{$typeName} = "$want";}
            if ($count >= 2) {
                foreach $want (@list) {
                    $rule = MakeBasicCreateRule($typeName, $want, $typeDefn);
                    push @typeRules, $rule;
                }
            } # close if $count greater than 2
            else {
                $rule = MakeBasicCreateRule($typeName, $typeDefn, $typeDefn);
                push @typeRules, $rule;
                $rule = MakeBasicCreateRule($typeDefn, $typeName, $typeDefn);
                push @typeRules, $rule;
            }
        }
    }

    return (@typeRules);
}


sub MakeRecursiveCreate {
    my ($have, $wantpath, $defn) = @_;
    my ($want, $path, $rule, $item, @items);

    if ($wantpath =~ /^([a-z][^\:]*)(\:\=)(.*)$/) {$path=$1; $want=$3;}

    # print "MRC: $have, $want, $path, $defn\n";
    @items = split(/\s+\*\s+/, $defn);
    foreach $item (@items) {
        if ($item eq $path) {$item = "Z";}
        else {$item = "_";}
    }
    $item = join(",", @items);

    $rule = "create_" . $want . "(X,Y):-\n\tslot_" . $have .
        "(X),\n\t" . "X=$have($item),\n\t" . "create_" . $want . "(Z,Y) .\n";

    return $rule;
}

sub AddDepthTo {
    my ($name, $from, $path) = @_;
    my (@values, $val, @newLst, $pc, $add);
    my $change = "No";

    if ($name eq $from) {$from = "";}
    else {$from .= ":=";}
    @newLst = split(/\s+/, $path);
    @values = split(/\s+/, $Depth{$name});
    foreach $pc (@newLst) {
        $add = "Yes";
        if ($pc =~ /^([^\:]+)(\:\=)(.*)$/) {$pc = $3}
        $pc = $from . $pc;
        foreach $val (@values) {
            if ($val eq $pc) {$add = "No";}
        }
        if ($add eq "Yes") {push @values, $pc; $change = "Yes";}
    }
    $val = join(" ", @values);
    $Depth{$name} = $val;
    return $change;
}

sub ExtendDepths {
    my ($name, $value, $val, @vals, $change, $anychg);

    $anychg = "No";
    $change = "No";

    foreach $name (keys %Depth) {
        @vals = split(/\s+/, $Depth{$name});
        foreach $value (@vals) {
            if ($value =~ /^([^\:]+)(\:\=)(.*)$/) {$value=$1; $val=$3;}
            else {$val = $value}
            if (defined $Depth{$val}) {
                $change = AddDepthTo($name, $value, $Depth{$val});
                if ($change eq "Yes") {$anychg="Yes";}
            }
        }
    }
    return $anychg;
}

sub MakeBasicCreateRule {
   # take what have what you want and the defn and make create rule
   my ($have, $want, $defn) = @_;

   my ($rule, $item, @items);
   my $isList = "X";
   my $isVar = "No";

   if ($defn =~ /^(\(\$)/) { $isVar = "Yes";}
   if ($defn =~ /^(\(\$)([a-z][a-zA-Z0-9]*)\s+(list|set)\s*(\))/)
        {$isList = "[X]";}

   $rule = "create_" . $want . "(X,Y):-\n\t";
   if ($isVar eq "Yes") { $rule .= "var_" . $have . "(X),\n\t";}
   else {$rule .= "slot_" . $have . "(X),\n\t";}

   if ($defn =~ /$have/) {$rule .= "Y = $want($isList),\n\t";}
   else {
        @items = split(/\s*\*\s*/, $defn);
        foreach $item (@items) {
            if ($item eq $want) {$item = "Y";}
            else {$item = "_";}
        }
        $item = join(",", @items);
        $rule .= "X = $have($item),\n\t";
   }
   $rule .= "slot_" . $want . "(Y)\n\t.\n";

   return $rule;
}


sub CreateNodeRules { 
   my ($node) = "@_";
   my ($name, @rules) = ExtractNodeInfo($node);
   my ($in, $out) = getTypes($name);
   my ($rule, $val, $lhs, $rhs, @PrologNode, @temp, @NodeRules);

   if ($in eq $leafIn && $out eq $leafOut) {
       $isLeaf{$name} = 1 unless defined($isLeaf{$name});
   }
   $nodeName = $name;  
   my $start = "node_" . $name . "(Query, Result, StartNode) :-";
   @NodeRules = ();
   @rules = OrderRules(@rules);
   foreach $rule (@rules) {
        @PrologNode = ();
        ($lhs, $rhs) = ExtractRuleInfo($rule); 
        @temp = CreateLhsProlog($in, $lhs, "Query");
        foreach $val (@temp) { push @PrologNode, $val;}
        @temp = CreateRhsProlog($out, $rhs, "Result");
        foreach $val (@temp) { push @PrologNode, $val;}
        $val = join(",\n\t", @PrologNode);
        push @NodeRules, "$start\n\t$val, ! .\n";
        %varDecls = ();
    }
    return @NodeRules;
}
        
sub ExtractNodeInfo {
        my ($node) = "@_";
        my ($name, $rule, @rules);

       $node =~ s/\n//g;
       if ($node =~ /^([A-Z][^\:]*)(\:)([^\.]+)(\.)$/)
          {$name = $1; $rule=$3;}
       @rules = split(/\s*\,\s*/, $rule);
       return ($name, @rules);
}

sub ExtractRuleInfo {
        my ($rule) = "@_";
        my ($lhs, $rhs);
       
        # print "% r: ($rule) ";
        if ($rule =~ /^([^\=]+)(\s*)(\=\>)(\s*)(.*)$/) {$lhs =$1; $rhs=$5;}
        $lhs = formatBasic($lhs);
        $rhs = formatBasic($rhs);

        # print "lhs:($lhs) rhs:($rhs)\n"; 
       
        return ($lhs, $rhs);
}

sub formatBasic {
    my ($side) = "@_";

    $side =~ s/^(\s+)//g;
    $side =~ s/(\s+)$//g;
    $side =~ s/\s+\(/\(/g;
    $side =~ s/\s+\)/\)/g;

    return $side;
}


sub CreateLhsProlog {
    my ($in, $lhs, $vName) = @_;
    my @lhsList = GetLhsList($lhs);
        
    my ($piece, $num, @ToGenerate, $name, $type, $inside, $temp);
    my @tempList;
    my $typeStruct = "_";   
    my $isList = getTypeID($in); 

    my @list = ();

    foreach $piece (@lhsList) { 
        if ($piece =~ s/^(\$)//) { 
            if ($piece =~ /^([a-z][A-Za-z0-9]*)(\:)(.*)$/) {
                $name = $1;
                $type = $3;
                if ($type =~ /^([^(]+)(\(.*)$/) {
                    $type = $1; $inside = $2;
                    @tempList = CreateLhsProlog($type, $inside, "X$name");
                    foreach $temp (@tempList) {
                        push @ToGenerate, $temp;
                    }
                }
		$varDecls{$type} = "X$name";
                push @list, "$type:X$name";
            }
            else { $name = $type = "\$". "$piece"; push @list, $type;}
        }
        else { push @list, $piece;}
    }
    if ($isList eq "List") {@tempList= MakeLhsList($in, $vName, @list);}
    elsif ($isList eq "Set") {@tempList = MakeSetProlog($in, $vName, @list);}
    else {@tempList = GenerateBasicStruct($in, $vName, @list);}
    foreach $temp (@tempList) {push @ToGenerate, $temp;}

    @ToGenerate = reverse @ToGenerate;
    # print "%CLP: [@ToGenerate]\n";
    return @ToGenerate;
}

sub formatList {
    my (@list) = @_;
    my $val;

    foreach $val (@list) {
        $val =~ s/^(\$)([a-zA-Z0-9]*)\*/Star_$2/;
        $val =~ s/^(\$)([a-zA-Z0-9]*)\?/Opt_$2/;
        $val =~ s/^(\$)([a-zA-Z0-9]*)/Var_$2/;
        $val =~ s/^(\!)(.*)/Not_$2/;
        if (!($val =~ /^(Star_|Opt_|Not_|Var_|R|X)/))
            {$val = makeProperAtom($val);}
        $val =~ s/\#//g;
    }

    $val = join(", ", @list);
    if ($val =~ /^(\s*)$/) {return "None";}
    return $val;
}

sub MakeSetProlog {
    my ($type, $vName, @list) = @_;
    my $val = formatList(@list);
    my $ans;
    my @withNot = ();
    my @basic = ();
    my @toAdd = ();
    if ($val =~ /Not_/) {
        @list = split(", ", $val);
        foreach $val (@list) {
            if ($val =~ /^(Not_)(.*)$/) {push @withNot, $2;}
            else {push @basic, $val;}
        }
        foreach $val (@withNot) {
            $ans = "not(inSet([$val], Set$type, _))";
            push @toAdd, $ans;
        }
        $val = formatList(@basic);
    }
    $val =~ s/^(None)//;
    $ans = "inSet([$val], Set$type, Rest)";
    push @toAdd, $ans;
    $ans = "$vName = $type(Set$type)";
    push @toAdd, $ans;

    return @toAdd;
}

sub GenerateBasicStruct {
    my ($type, $vName, @list) = @_;
    my ($value, $varType, $atom, $rule);
    my @Rules = ();

    foreach $value (@list) {
        if ($value =~ /^(\$)(.*)(\*|\?)/) {
            print "Error: Stars and Opts are only allowed on variables in"
                .  " lists, $value used in type $type incorrectly.\n";
        }
        elsif ($value =~ /^(\$)(.*)$/) {
            $varType = $2;
            $rule = varGenRule($varType, $varType);
            push @Rules, $rule;
        }
        elsif ($value =~ /^(\!)(.*)$/) {
            $atom = $2;
            AddNot($atom);
            $rule = "not(Not_" . $atom . ", $atom)";
            push @Rules, $rule;
            $value = "Not_" . $atom;
        }
    }
    $rule = GetTypeStruct($type, @list);
    if ($rule eq "_") {$rule = getGenRule($type,$vName);}
    else {$rule = "$vName = $rule";}
    push @Rules, $rule;
    return @Rules;
}



sub MakeLhsList {
    my ($type, $vName, @list) = @_;
    my $val = formatList(@list);
    my $final = $type . "Append(WQ, Rest, " . $vName . ")";
    $isRest = "Rest";
    my @toAdd = ();
    my ($r, @temp);
    $val =~ s/^(None)$//;
    push @toAdd, $final;
    if ($val =~ /(Star_|Opt_)/) {
        @list = split(/,\s/, $val);
        @temp = getComplexLhsList($type, "WQ", @list);
        foreach $r (@temp) {push @toAdd, $r;}
    }
    else {
        $final = "WQ = $type" . "([" . $val . "])";
        push @toAdd, $final;
    }
    return @toAdd;

}

sub getComplexLhsList {
    my ($type, $vName, @list) = @_;
    my @toAdd = ();
    my @toAppend = ();
    my $num = 0;
    my ($val, $var, $starOrOpt, $ans, @temp);
    my ($left, $more);
    $left = $vName;
    $more = "QL" . $num;

    foreach $val (@list) {
        if ($val =~ /(Star_|Opt_)(.*)/) {
            $starOrOpt = $1;
            $var = $2;
            if ($starOrOpt =~/Star_/) {$starOrOpt="star"; AddStar($var,$type);}
            elsif ($starOrOpt =~/Opt_/) {$starOrOpt="opt"; AddOpt($var,$type);}
            $ans = join(",", @temp);
            if (!($ans eq "")) {
                $ans = $type . "([" . $ans . "])";
                push @toAdd, "$type" . "Append(" . "$ans, $more, $left)";
                $num++;
                @temp = ();
                $left = $more;
                $more = "QL" . $num;
            }
            $ans = "$starOrOpt" . "_" . "$type" . "_"
                . "$var($left, $val, $more)";
            push @toAdd, $ans;
            $num++;
            $left = $more;
            $more = "QL" . $num;
        }
        else {push @temp, $val;}
    }
    $ans = join(",", @temp);
    if (!($ans eq "")) {
        $ans = $type . "([" . $ans . "])";
        push @toAdd, "$left = $ans";
    }
    else {
        $ans = $type . "([])";
        $toAdd[$num-1] =~ s/$left/$ans/g;
    }
    return @toAdd;
}


        
sub CreateRhsProlog {
    my ($catT, $rhs, $vName) = @_;
    my @rhsList = GetRhsList($rhs);
    my ($in, $out);
    my ($piece, @ToGenerate, $name, $type, $inside, $temp);
    my @tempList;
    my $isList = getTypeID($catT);
    my $typeStruct = "_";
        
    my @list = ();  #list to create structure from
    my @appends = (); # list of Vars of List type catT to append together
    my $num = 0;
     
    foreach $piece (@rhsList) {
        if ($piece =~ /^([A-Z][^\(]*)(\(.*)$/) {
            $name = $1;
            $inside = $2;
            if (isNode($name) eq "valid") {
                ($in, $out) = getTypes($name);
                $type = "Q" . $name . $num;   
                ($type, $inside) = CheckForSimpleCase($in, $inside, $type);
                if (!($inside eq "")) {
                    @tempList = CreateRhsProlog($in, $inside, $type);
                    foreach $temp (@tempList) {
                        push @ToGenerate, $temp;
                    }
		}
                $temp = makeCallNodeRule($name, $type, "$vName$num");
                $temp = ResolveVariables($temp);
                push @ToGenerate, $temp;
                if ($isList eq "List" || $isList eq "Set") {
                    if ($out eq $catT) {push @list,  "$vName$num";}
                    else {
                	$temp = varCreateRule($catT, "$vName$num", "$vName$num");
                        if ($temp eq "NONE") {push @list, "$vName$num";}
                        else {
                            push @ToGenerate, $temp;
                            push @list, "X$vName$num";
                        }
                    }
                }
                else {
                    $varDecls{$out} = "$vName" . $num;
                    push @list, "$out:$vName$num";
                }
                $num++;
            } # end valid nodeName found
        } # end if piece is node call
        elsif ($piece =~ /^(\$)(.*)$/) {
		$name = ""; $type = $catT;
		if ($piece =~ /^(\$)(.*)(\*)$/) {$name = "Star_" . $2;}
                elsif ($piece =~ /^(\$)(.*)(\?)$/) {$name = "Opt_" . $2; }
                elsif (isVar($2) eq "valid") {
                        $temp = varCreateRule($2, $2, $2);
                        push @ToGenerate, $temp;
                        $name = "Var_" . $2;
                }
                else {$name = "X" . $2; $type = varLookUp($name);}
                if ($isList eq "List" || $isList eq "Set") {
                    if ($type eq $catT) {push @list, $name;}
                    else {
                        $temp = varCreateRule($catT, $name, $name);
			if ($temp eq "NONE") {$appends[$num] = $name;}
                        else {
                            push @ToGenerate, $temp;
                            $appends[$num] = "X$name";
                        }
                    }
                } # close List or Set
                else {
		    $varDecls{$type} = $name;
		    push @list, "$type:$name";
		}
                $num++;   
        }
        else { $name = $type = $piece; push @list, $piece;}
    } # foreach piece
                            
    if ($isList eq "List") {
        @tempList = MakeRhsListProlog($catT, $vName, @list);
        foreach $temp (@tempList) {push @ToGenerate, $temp;}
    }
    elsif ($isList eq "Set") {
        @tempList = MakeSetProlog($catT, $vName, @list);
        foreach $temp (@tempList) {push @ToGenerate, $temp;}
    }
    else {
        $typeStruct = GetTypeStruct($catT, @list);
        $typeStruct = ResolveVariables($typeStruct);
        push @ToGenerate, "$vName = $typeStruct";
    }
            
    #@ToGenerate = reverse @ToGenerate;
         
    return @ToGenerate;
}

sub MakeRhsListProlog {
    my ($type, $vName, @list) = @_;
    if ($isRest eq "Rest") {push @list, "Rest";}
    my $val = formatList(@list);
    my ($final, $temp, $rl);
    my @toAdd = ();
    my @append = ();
    my @ls = ();
    my $num = 0;
    $val =~ s/^(None)$//;
    if ($val =~ /[A-UW-Z]/) {
        @list = split(/,\s/, $val);
        foreach $temp (@list) {
            if ($temp =~ /^([A-UW-Z])/)  {
                $rl = formatList(@ls);
                if (!($rl eq "None")) {
                    $rl = $type . "([" . $rl . "])";
                    push @append, $rl;
                    $num++;
                    @ls = ();
                }
                push @append, $temp;
                $num++;
            } else {push @ls, $temp;}
        }
        $rl = formatList(@ls);
        if (!($rl eq "None")) {
            $rl = $type . "([" . $rl . "])";
            push @append, $rl;
            $num++;
        }

        @toAdd = CreateAppendRules($type, $vName, $num, @append);
    }
    else {
        $final = "$vName = $type" . "([" . $val . "])";
        push @toAdd, $final;
    }
    return @toAdd;
}


sub CheckForSimpleCase {
     my ($in, $inside, $type) = @_;
     my $inner = $inside;
     my $retType;
     my $id = getTypeID($in);

     $inner =~ s/^(\()(.*)(\))$/$2/;
     $inner =~ s/\$/X/g;
     $retType = varLookUp($inner);

     if ($retType eq $in) { return($inner, "");}
     elsif (($id == "List" || $id == "Set")&&($inner eq "")){
	return("Rest", ""); $isRest="";}
     else {return ($type, $inside);}
}



sub makeCallNodeRule {
    my ($name, $quer, $res)= @_;
    my $callNode;
     
    if ($name eq "LEAF") {$name = "redirect";}
    elsif ($name eq "SELF") {$name = "node_" . $nodeName;}
    else {$name = "node_" . $name;}

    $callNode = "$name($quer, $res, StartNode)";
    return $callNode;
}

 
sub CreateAppendRules {
    my ($type, $final, $num, @toAppend) = @_;
    my ($i, $j, $res, $next, $rule);
    my @rules = ();
    
    $j = 0;
    $res = $toAppend[$j];
    $next = 1;
    for ($i=1; $i<$num; $i++) {
        $rule = "$type" . "Append($res, $toAppend[$i], $final" .
                "App$next" . ")";
        push @rules, $rule;
        $res = "$final" . "App$next";
        $next++;
    }
    push @rules, "$final = $res";
    return @rules;
}

sub GetLhsList {
    my $lhs = "@_";
    my ($val, @vals, $open, $cur, $temp);
    
    my @list = ();
    
    if ($lhs =~ /^(\()(.*)(\))$/) {$lhs = $2;}
    else {return $lhs;}
    @vals = split(/\s+/, $lhs);

    $open = 0; $cur = "";
    foreach $val (@vals) {
        if ($val =~ /^(\$)([a-z][a-zA-Z0-9]*)(\:)([a-z][a-zA-Z0-9]*)(\()/)
        {
            $temp = $val;
            while ($temp =~ s/\(//) {$open++;}
            $cur .= "$val ";
        }
        elsif ($open < 1) {
            push @list, $val;
        }
        elsif ($val =~ /\)/) {
            $temp = $val;
            while ($temp =~ s/\)//) {$open--;}
            $cur .= "$val";
            if ($open < 1) { push @list, $cur; $cur = "";}
        }
        else { $cur .= "$val ";}
    }
    return @list;
}
        
sub GetRhsList {
    my $rhs = "@_";
    my ($val, @vals, $open, $cur, $temp);
            
    my @list = ();
    if ($rhs =~ /^(\()(.*)(\))$/) {$rhs = $2;}

    @vals = split(/\s+/, $rhs);
        
    $open = 0; $cur = "";
    foreach $val (@vals) {
        if ($val =~ /\(/)
        {   
            if (($open < 1) && !($cur eq ""))
                {$cur =~ s/(\s)$//; push @list, $cur; $cur="";}
            $temp = $val;
            while ($temp =~ s/\(//) {$open++;}
            while ($temp =~ s/\)//) {$open--;}
            if ($open < 1) {$cur .= "$val"; push @list, $cur; $cur="";}
            else {$cur .= "$val ";}
        }
        elsif ($val =~ /\)/) {
            $temp = $val;
            while ($temp =~ s/\)//) {$open--;}
            if ($open < 1) {$cur .= "$val"; push @list, $cur; $cur = "";}
            else {$cur .= "$val ";}
        }
        elsif ($open < 1) {push @list, $val;} 
        else { $cur .= "$val ";}
    }
    if (!($cur eq "")) {$cur =~ s/(\s)$//; push @list, $cur;}
    return @list;
}

sub GetTypeStruct {
    my ($in, @list) = @_;
    my (@out, @nlist, $slot, $defn, @defns, $value, @values, $temp);
    my ($val,$num, $rule, $Result, $tp);  
    my %possible = ();

    # if in is on list just return in
    foreach $temp (@list) {
        if ($temp eq $in) {return $in;}
        if ($temp =~ /^($in)(\:)([A-Z])(.+)/) {return "$3$4";}
    }

    #other wise find slot defn
    foreach $slot (@slots) {
        if ($slot =~/^($in):=(.*)$/)
            {@defns = split(/\sor\s/, $2);}
    }
        
    foreach $defn (@defns) {
	$defn =~ s/(\s+)$//g; $defn =~ s/^(\s+)//g;
        @out = ();
        $num = 0;
        @values = split(/\s\*\s/, $defn);
        foreach $value (@values) {
            $out[$num] = "_";
            foreach $temp (@list) {
                if ($temp eq $value) {$out[$num] = $value;}
                elsif ($temp =~ /^($value)(\:)([A-Z])(.+)/) {$out[$num]="$3$4";}
            }
            if ($out[$num] eq "_") {
                if (isSlot($value) eq "valid") {
                    $out[$num] = GetTypeStruct($value, @list);
                }
                elsif ($value =~ /^(\(\$)([^\s]+)\s+(list|set)/) {
                    $out[$num] = GetListPart($2, @list);
                }
                elsif ($value =~ /^(\(\$)([^\)\s]+)\s*(\))/) {
                    if (isVar($2) eq "valid")
                        {$out[$num] = FindValueForVar($2, @list);}
               }
               elsif ($value =~ /^(\()([^\)]+)(\))/) {
                   $out[$num] = $2;
                }
           }  #end if
           $num++;
        } # end of for each value
        $rule = join(",", @out);
        $Result =  "$in($rule)";
        $possible{$Result} = 0;
        foreach $temp (@list) {
            if ($temp =~ /^([^\:]+)(\:)([A-Z].+)/) {$tp = $3;}
            else {$tp = $temp;}
            if ($Result =~ /$tp/)
                {$possible{$Result} = $possible{$Result} + .5;}
            if ($Result =~ /(\'|\[|\(|\s|\,)($tp)(\)|\,|\]|\'|\s)/)
                {$possible{$Result} = $possible{$Result} + .5;}
        }
	if ($Result =~ /\[\]/) {$possible{$Result}=$possible{$Result}+1;}
        # print "GTS: ($defn) ($Result) $possible{$Result} \n";
    } #close foreach defn
        
    $val = -1;
    foreach $temp (keys %possible) {
        if ($possible{$temp} > $val)
            {$Result = $temp; $val = $possible{$temp};}
    }
    if ($val < 1) {return "_";}
    else {return $Result;}
}
    
        

sub GetListPart {
    my ($var, @ls) = @_;
    my ($li, @res, $result);
     
    foreach $li (@ls) {
        if (isVarType($var, $li) eq "Valid") {
            $li = makeProperAtom($li);
            push @res, $li;
        }
    }
    $result = join(", ", @res);
    $result = "[$result]";
    return $result;
}    

sub makeProperAtom {
    my $value = "@_";
    
    if ($value =~ /^(Var_|Not_|Star_|Opt_)/) {return $value;}
    if ($value =~ /^(\')(.*)(\')$/) {return $value;}
    if ($value =~ /^([^a-z0-9])/)
        {$value = "'" . $value . "'";}
    elsif ($value =~ /([^[:ascii:]])/)
        {$value = "'" . $value . "'";}
    elsif ($value =~ /^([0-9]+)([^0-9])(.*)/)
        {$value = "'" . $value . "'";} 
    return $value;
}
     
sub FindValueForVar {
    my ($varType, @list) = @_;
    my ($var, $val, @values);
     
    @values = ();
    foreach $var (@variables) {
        if ($var =~ /^($varType)(\:\=)(.*)$/) {
            @values = split(/\s+/, $3);
        }
    }   

    foreach $var (@values) {  
        foreach $val (@list) {
            if ($var eq $val) {return $var;}
        }
    }
        
    foreach $val (@list) {
        if ($val =~ /^(X|Not_|Var_|Opt_|Star_)($varType)$/) {return $val;}
        if ($val eq $varType) {return $varType;}
    }   

    return "_";
}
     
         
     
sub ResolveVariables {
    my $line = "@_";
    my ($vars, $value);
    foreach $value (keys %varDecls) {
        $line =~ s/^($value)$/$varDecls{$value}/;
        $line =~ s/^($value)(\,|\s)/$varDecls{$value}$2/;
        $line =~ s/(\,|\s)($value)$/$1$varDecls{$value}/;
        $line =~ s/(\(|\s|\,)$value(\)|\,|\s)/$1$varDecls{$value}$2/g;
    }

    return $line;   
}

sub varLookUp {
    my $line = "@_";
    my ($vars, $value);
     
    foreach $value (keys %varDecls) {
        $line =~ s/$varDecls{$value}/$value/g;
    }
    
    return $line;
}       

    
sub getGenRule {
    my ($type, $vars) = @_;
    my $rule = "";
        
    if (isSlot($type) eq "valid") {$rule = "slot_";}
    elsif (isVar($type) eq "valid") {$rule = "var_";}
    else {return "NONE";}
    $rule .= $type . "(" . $vars . ")";
    return $rule;
}
    
    
        
sub varGenRule {
    my ($type, $num) = @_;
    my $rule = "NONE";   
         
    $rule = getGenRule($type, "X$num");
    if (!($rule eq "NONE")) {$varDecls{$type} = "X" . $num;}
 
    return $rule;
}   
        
sub varCreateRule {
    my ($type, $num, $vname) = @_;
    my $rule = "NONE";   
    if (isSlot($type) eq "valid") { 
        $rule = "create_" . $type . "(" . $vname . ",X" . $num . ")";
        $varDecls{$type} = "X" . $num;
    }
    elsif (isVar($type) eq "valid") {
    	$rule = "var_" . $type . "(Var_" . $num . ")";
    }
    return $rule;
}

sub getTypes {
    my $node = "@_";
    my ($in, $out, $value);
     
    if ($node eq "SELF") {$node = $nodeName;}
    
    foreach $value (@TypeList) {
        if ($value =~ /^($node):=([a-z][^-]*)->([a-z].*)$/)
        {
            $in = $2;
            $out = $3;
            return ($in, $out);
        }
    }
    return ("NONE", "NONE");
}   

sub isNode {
    my $node = "@_";
    my ($value);
            
    if ($node eq "SELF") {return "valid";}
         
    foreach $value (@TypeList) {
        if ($value =~ /^($node):=(.*)$/)
        {return "valid";}
    }
    print "Error $myCount: Undefined node $node called here.\n";
    return ("NotValid");
}

sub getTypeID {
    my $slotName = "@_";
    my ($slot, $type);
        
    $type = "None";
    foreach $slot (@slots) {
        if ($slot =~ /^($slotName):=(.*)/) {$type = $2;}
    }
    if ($type =~/^[a-z](.*)/) {return "Slot";}
    elsif ($type =~/^(\(\$)([^\s]+)\s(list)(\))/) {return "List";}
    elsif ($type =~/^(\(\$)([^\s]+)\s(set)(\))/) {return "Set";}
    elsif ($type =~/^(\(\$)(.*)/) {return "Var";}
    elsif ($type =~/^(\()([^)]+)(\))/) {return "Atom";}
    return "No Match";
}

        
sub CreateShowRule {
    my $showRule = "@_";
    my @showList = ();
    my ($ToShow, $type, $temp, $gen, $typeStruct);
    my @ToGenerate = ();
    my $num = 0;


    if ($showRule =~ /^(#show\s*\()([^\)]+)(\)\s*\.)$/) {
        $ToShow = $2;
        @showList = split(/\s*\:\:\s*/, $ToShow);
        #print "($ToShow) (@showList)\n";
    }
    foreach $ToShow (@showList) {
        if ($ToShow =~ /^(\$)(.*)$/) {
            $ToShow = $2;
            $temp = varGenRule($ToShow, $num);
            if (!($temp eq "NONE")) {push @ToGenerate, $temp;}
        }
        $num++;
    }
    $typeStruct = GetTypeStruct($leafIn, @showList);
    $typeStruct = ResolveVariables($typeStruct);

    $ToShow = join(",\n\t", @ToGenerate);
    $showRule = "variety(Query) :-\n\t" . $ToShow . ",\n\tQuery = " .
        $typeStruct . ".\n";

    # clear var decls
    %varDecls = ();
    return $showRule;
}




sub GenerateRules {
    my @Rules = ();
    my ($r, $num, $val, $dr, @vals);

    @parsedTheory = reverse @parsedTheory;
    @varIn = reverse @varIn;
    @typeIn = reverse @typeIn;

    push @Rules, "% Variables Declarations \n";
    foreach $r (@varIn) {
	$r =~ s/^(\#vars)(\s+)//;
	push @Rules, "\n% variables: $r ";
	@vals = CreateVarRule($r);
	foreach $val (@vals) {push @Rules, $val;}
    }
    push @Rules, "\n\n";

    push @Rules, "% Type or Slot Declarations \n";
    foreach $r (@typeIn) { 
	$r =~ s/^(\#type)(\s+)//;
	push @Rules, "\n% type decl: $r ";
	@vals = CreateTypeRule($r);
	foreach $val (@vals) {push @Rules, $val;}
        @vals = CreateCreateRule($r);
	foreach $val (@vals) {push @cRules, $val;}
    }
 
    #print "Depths:\n";
    #foreach $r (keys %Depth) {print "($r) ($Depth{$r})\n";}

    push @Rules, "\n\n";
    push @Rules, "% Create Type Rules \n";
    $val = ExtendDepths();
    while ($val eq "Yes") {
	#print "Depths:\n";
        #foreach $r (keys %Depth) {print "($r) ($Depth{$r})\n";}
	$val = ExtendDepths();}
    foreach $dr (@DepthRules) {
	@vals = GetDepthCreateRules($dr);
	#print "% dr:($dr)\n@vals\n";
	foreach $val (@vals) {push @cRules, $val;}
    }
    @cRules = OrderCRules(@cRules);
    foreach $r (@cRules) {push @Rules, $r;}	
    push @Rules, "\n\n";
    
    $num = 0;
    foreach $r (@leaf) { 
	$r =~ s/^(\#leaf)//;
	$val = CreateLeafRule($r, $num);
	push @Rules, $val;
	$num++;
    }
    push @Rules, "\n\n";

    foreach $r (@parsedTheory) { 
	if ($r =~ s/^(\%|\/\*)//) {
	    @vals = CreateComment($r);
	    foreach $val (@vals) {push @Rules, $val;}
 	}
	else {
	    @vals = CreateNodeRules($r);
	    foreach $val (@vals) {push @Rules, $val;}
	}
    }
    push @Rules, "\n\n";

    foreach $r (@toShow) { 
	push @Rules, "% $r";
	$val = CreateShowRule($r);
	push @Rules, $val;
    }
    push @Rules, "\n\n";

    return @Rules;
}

sub setDebug {
    my $val = "@_";
    if ($val =~/-d([0-5])/) { $val = $1;}
    else {$val = 0;}

    return $val;
}    


sub GetInput {
    my $filename = "@_";
    if (! open(INPUT,"<$filename") ) {
            print "Can't open file for input $filename\n";     
            die;
    }
    my @lines = <INPUT>;
    close INPUT;
 
    return @lines;
}


sub openOutfile {
    my $filename = "@_";
    if (! open(OUTPUT,">$filename") ) {
        print "Can't open file for output $filename\n";     
        die;
    }
}

sub CreateOutput {
    my ($Outfile, @Rules) = @_;
    my $rule;

    openOutfile($Outfile);

    foreach $rule (@Rules) {
	print OUTPUT "$rule \n";
    }
    BoilerPlate();
    close OUTPUT;
    
    print "Output written to: $Outfile.\n";
}


sub RunLatr {

    my $Infile = $ARGV[0];
    my $Outfile = $ARGV[1];
    my @Rules = ();
    $Debug = $ARGV[2];

    my ($DOC) = new LATR;                
    @redirects = ();
    %Depth = ();
    @DepthRules = ();
    @cRules = ();

    $Debug = setDebug($Debug);
    my @fileinput = GetInput($Infile);
  
    $DOC->parseFile(@fileinput);

    @Rules = GenerateRules();
    CreateOutput($Outfile, @Rules);
}


RunLatr();

1;
