% codes used in this table
% /P: preposition
% /A: adjective
% /Kstem: adjective, takes comparitive and superlative, based on
% the known stem or the given one, if present.
% Iending: adjective based on the known stem, given ending
% /N: noun, plural in -n
% /S: noun, plural in -s
% /Eending: the stem + the ending gives a valid form
% /C: proper noun, takes dative
% /Dstem: form diminutives on the known stem or the given one, if present.
% /V: verb based on the known stem
% /T: verb participle ends in -t based on the known stem
% /Bform: verb participle has the given form
% /Gcomplement: the verb takes the given adverbial complement
% /H: the word needs spelling attention, usually because it is Hebrew.
% {my spelling code}: the proper spelling of this word or fragment
% /Lprefix: the known stem takes the given prefix
% /-form: the given form, which might get generated, is spurious
% GYD: German-Yiddish Dictionary
% V: suggestion from "vi men zogt es oyf yidish"
% use u02bc (ʼ) for internal quote marks.

% ordinary Yiddish words

a/P [def: a (article)]
a/Een [m] [def: the letter A] 
abi [def: if only]
aboni'r/V/Baboni'rt [def: subscribe] abona'nt/N [m] [def: subscriber]
	abonament/N [m] [def: subscription]
abort/N [m] [def: abortion]
absolut/A [def: absolute]
abstrakt/A [def: abstract] abstraktsye/S [f] [def: abstraction]
absurd/N [m] [def: absurdity] /A [def: absurd] 
ad{ed}/H [def: until] adhayem{ed-hywm}/H [def: until today]
adaptatsye/S [f] [def: adaptation]
adar{adr}/H [m] [def: month of Adar]
adayem{ed-hywm}/H [def: until today]
aderabe{adrb#}/H [def: on the contrary]
adir{adir}/Xadirem{adyrym} [def: wealthy person] 
adl [m] [def: nobility] /Idik [def: noble] 
administratsye/S [f] [def: administration; management] 
	administrati'v/A [def: administrative]
admira'l/N [m] [def: admiral] 
adopti'r/V/Badopti'rt [def: adopt] 
adoyn{adwn}/H adoyni{adwny}/H [def: Mister]
adrenal/A [def: adrenal (physiology)]
	adrenali'n [m] [def: adrenalin]
adres/N [m] [def: address] vebadres/N
	adresi'r/V/Badresi'rt [def: address] 
		zikh-adresirt/A [def: self-addressed] 
adverb/N [m] [def: adverb]
advoka't/N [m] [def: lawyer]
	[idiom: dem ruekhs{rwHs} advokat = devil's advocate] [note: V]
adye [def: adieu]
adyektiv/N [m] [def: adjective]
af{Of} afn{Ofn} [def: on] [see: oyf]
afere/S [f] [def: affair, love affair] 
afi'ks/N [m] [def: affix (grammatical)]
afikoymen{afikwmn}/H/S [m] [def: afikomen (matsoh eaten at end of Passover seder)] 
afile{afylw}/H [def: even, only]
afish/N [m/f] [def: poster] [note: Weinreich says m, GYD says f]
afrikans [noun] [def: Afrikaans (language)] 
age'nt/N [m] [def: agent]
	agentsye/S [f] agentu'r/N [f] age'nts/N [f] [def: agency] 
	pirsem{pyrswm}-age'nt/N [m] [def: publicity agent] 
agev{agB}/H [def: by the way]
agmes{egmwT}/H [def: sorrow]
agitatsye/S [f] [def: agitation] 
agole{eglh}/H [def: wagon]
	balagole{bel-eglh} [def: wagon driver]
agres/X/N [def: gooseberry] 
agresye/S [f] [def: aggression] 
	agresor/N [m] [def: aggressor]
	agresiv/A [def: aggressive] agresivkayt/N [def: aggressiveness] 
agune{agwnh}/Xagunes{agwnwT}/H [f] [def: deserted wife]
aha [interj] [def: aha! (expression of justification)]
ahave{ahBh}/H [f] [def: love] ahavas{ahBT}/H [def: love of]
	ahavas{ahBT}-yisroyl{yQr#l} [def: love of fellow-Jews] 
aher [adv] aherttsu [adv] aherttsutsu [adv] [def: hither]
	ahin [adv] ahintsu [adv] ahintsutsu [adv] [def: thither]
akademish/A [def: academic] akademye/S [def: academy]
	akademiker/S [def: academician] % Forwards
akatsye/S [f] [def: acacia (tree)]
akdomes{akdmwT}/H [def: introduction (Aramaic)]
aker/V/T [def: plow]
	faraker/V/Bfarakert [def: plow]
	tseaker/V/Btseakert [def: plow]
akeyde{ekdh}/H [def: binding of Isaac] akeydenik{ekdhnik}/Ees
akh [interj] [def: ah (expression of disgust)]
akharey{aHry}/H [def: after]
akhdes{aHdwT}/H [def: unity]
	lakhodem{l#Hdym} [def: retail]
		lakhodemnik{l#Hdymnik}/Ees [m] [def: retail buyer]
		lakhodemnitse{l#Hdymnitse}/S [f] [def: retail buyer]
	yokhed{yHyd}/Xyekhidem{yHydym}/H [m] [def: individual] yekhidish{yHydish}/A
		yekhidey{yHydy}-sgule{sgwlh} [def: exceptional people] 
akhes{aHT}/H [def: one]
akhper/V/T [def: honor, venerate]
akhrayes{aHrywT}/H [def: responsibility] /Idik [def: responsible] 
	akhrayesdikayt{aHrywTdikayt}/N [f] [def: responsibility] 
	umakhrayesdik{umaHrywTdik}/A [def: irresponsible] 
	akrayeslozikayt{aHrywTlozikayt}/N [f] [def: irresponsibility] [usage: inadmissable]
akhren{aHrwn}/Xakhroynem{aHrwnym}/H [m] [def: last]
akhsanye{axsny#}/H [def: inn] akhsani{axsny}/H [def: innkeeper]
akht/A [def: 8] akhtns [def: eigth] akhtl [def: 1/8]
	akhtsn [def: 18] akhtsnt/A [def: 18th]
		akhtsntl [def: 1/18]
	akhtsik/A [def: 80] akhtsikst/A [def: 80th]
		akhtsikstl [def: 1/80]
akhtung/N [f] [def: esteem]
akhzer{axzr}/Xakhzorem{axzrym}/H [m] [def: vicious person]
	akhzoryes{axzrywT}/H/Idik [def: viciousness]
akord/N [m] [def: accord]
akordeo'n/N [m] akordyo'n/N [m] [def: accordion (musical instrument)] 
	akordyoni'st/N [m] akordyonistke/S [f] [def: accordionist] 
akore{ekrh}/Xakores{ekrwT}/H [f] [def: barren woman]
akorsht [def: once, just] korsht
akroba't [m] [def: acrobat] /Iish [def: acrobatic] 
	akrobatik [f] [def: acrobatics (subject)]
aks/N [n] [def: axis; axle] /Iyal [def: axial (chemistry)] 
	umdrey-aks/N [f] [def: rotational axis] 
	igrek-aks/N [f] [def: X axis (mathematics)] 
	iks-aks/N [f] [def: Y axis (mathematics)] 
aksesuar/N [m] [def: accessory]
akshn{ekSn}/Xakshonem{ekSnym} [m] [def: stubborn person]
	akshn/V/T [def: be stubborn]
	far|akshn|t/A [def: stubborn, tenacious, obstinate]
	akshones{ekSnwT}/H/Idik [def: stubbornness]
aksl/N [m] [def: shoulder]
akt/N [m] [def: act]
	eyn-akter/S [m] [def: one-act play] 
	aktue'l/A [def: actual, real]  aktuelkayt/N [f] [def: reality] 
aktinyum [m] [def: actinium (Ac)] 
aktiv/A [def: active] aktivistish/A
	aktivi'st/N [f] aktivistke/S [f] [def: activist]
aktiv/A [def: active] aktivitet/N [f] [def: activity]
aktsent/N [m] [def: accent]
	aktsenti'r/V/Baktsenti'rt [def: accent]
aktsepti'r/V/Baktsepti'rt [def: accept]
aktsye/S [f] [def: action, stock (financial security)]
aktyor/N [m] [def: actor] aktyorish/A aktrise/S [f] [def: actress]
akurat/A [def: accurate]
akustik/N [f] [def: accoustics] 
akuzativ/A [def: accusative (grammar)]
akuzi'r/V/Bakuzi'rt [def: accuse] akuzatsye/S [def: accusation]
akzyome/S [f] [def: axiom] 
alarem/S [m] alarm/S [m] [def: alarm, alert] 
albaster/A [def: alabaster]
albatros/N [m] [def: albatross]
ale [adj] [def: all] alemen/S [def: everyone]
	ile [adj] [def: all] % southern variant
	alts ales alem altsding [def: everything]
	[idiom: alts +comparative (like neenter) = closer and closer]
	[idiom: nokh alts = still (modal)]
	[idiom: nokh alemen = all finished]
	alerley [def: all sorts]
	alde aldem aldi [def: all the]
	[idiom: nit mit alemen = slightly ill]
alef{#ʼ}/H [def: letter Alef] alefbeyz{alf-byT}/H alfabet [def: alphabet]
	alfabetish/A [def: literate] onalfabetish/A [def: illiterate]
alegorye/S [f] [def: allegory]
aleykhem{elyxm}/H/C [def: to you]
	[idiom: sholem{Slwm} aleykhem{elyxm} = hello (first speaker)]
	[idiom: aleykhem{elyxm} sholem{Slwm} = hello (second speaker)]
aleyn [def: oneself (with a personal pronoun), only]
	aleyns [def: only] aleynkayt/N [def: solitude]
alfabetish/A [def: literate] umalfabetish/A [def: illiterate]
alfons/N [m] [def: pimp] 
algemeyn/A [def: general] algemeynkayt/N [f] [def: generality]
	algemeynerung/N [f] [def: generalization] 
aligator/N [m] [def: allligator]
alii'r/V/Balii'rt [def: ally]
alimentn [noun] [def: alimony] 
aliye{elyh}/H [def: rise, immigration, Torah honor]
alker/D alkern [def: niche]
alkn/S [def: ??]
alkohol [m] [def: alcohol (chemical)] /Iish [def: alcoholic] 
alkolponem{el-Kl-pnym}/H [def: in any case]
almanakh/N [def: almanac]
almemor/S [m] balemer/S [m] [def: lectern for a holy book]
almen{almn}/H/S [m] [def: widower]
	almone{almnh}/Xalmones{almnwT}/H [f] [def: widow]
		almoneshaft{almnhshaft}/N [f] [def: widowhood]
almer/S [m] [def: closet, wardrobe]
als [preposition] [def: as (German)]
alt/Kelt elterlekh/A altink/A [def: old, stale] altitshke/A
	fareltert/A [def: aged]
	elter/V/T [def: age (with "zikh")]
	alterheyt altkayt/N [f] [def: age]
	altetshk/A [def: old one]
	eltern [f] [def: parents] elterns
	mitlelter [def: Middle Ages] /Ilekh
	uralt/A [def: original]
	altertum/N [def: antiquity]
	altfrenkish/A [def: old-fashioned]
	mitl-elter [def: Middle Ages] 
		mitl-alter [def: Middle Ages] [usage: inadmissable]
a'ltshaymer [m] [def: Alzheimer's disease] 
aluminyum [m] [def: aluminum (Al)]
am{em}/H [def: nation]
	amkho{emx} [n] [def: common people] 
amator/N [m] amater/N [m] [def: amateur] 
	amatorish/A [def: amateur] 
ambasade/S [def: embassy] 
	ambasado'r/N [def: ambassador] 
ambitsye/S [f] [def: ambition] /Iz [def: ambitious] 
ambivalent/A [def: ambivalent] 
ambrazur/N [m?] [def: embrasure] 
ambrozye [def: ambrosia]
ambulans/N [m] [def: ambulance]
ambulatorye/S [f] [def: infirmary (for outpatients)] 
amendi'r/V/ amendi'rt [def: amend] 
	amendirung/N [f] [def: amendment] 
ameritsyum [m] [def: americium (Am)] 
amnesti'r/V/Bamnesti'rt [def: grant amnesty] 
	amnestye/S [f] [def: amnesty] 
amorets{em-horc}/Xameratsem{em-horcym}/H [m] [def: ignoramus]
	ameratses{em-horcwT}/H [def: acts of ignorance]
amper/V/T [def: quarrel (with "zikh")] tseamper/V/Btseampert
amt/N [m] [def: office]
	amti'r/V/Bamti'rt [def: hold office]
	baamt/A [def: official, clerk]
	postamt/N [m] [def: postoffice] 
	tsenzusamt/N [m] [def: census office]
amuzi'r/V/Bamuzi'rt [def: amuse]
analizi'r/V/Banalizi'rt [def: analyze] analiz/N [m] [def: analysis]
	psikhoanalitiker/S [m] [def: psychoanalyst]
	analitiker/S [m] analitikerin/S [f] [def: analyst] 
	analitish/A [def: analitic] 
analogye/S [f] [def: analogy] analogi'zm/N [m] [def: analogy] 
ananas [m] [def: pineapple]
anarkhi'st/N [m] anarkhistke/S [f] [def: anarchist] anarkhistish/A
anatomye/S [f] [def: anatomy] 
ander/A andersh [def: other, next]
	anand anander anandern [def: each other]
	nokhanand [def: in a row]
	videranand [def: repeatedly]
	andersh/V/T [def: change] /Giber
	andershkayt/N [f] [def: difference] 
andes/X [m] [def: gooseberry]
anekdot/N [m] [def: anecdote]
anen [def: awareness, imagination] anung [f] [def: inkling]
anestezyolog/N [m] [def: anesthesiologist (occupation)] 
angazhi'r/V/Bangazhi'rt [def: engage, hire; make a commitment (with "zikh")] 
angine [f] [def: tonsilitis (disease)] 
angst/N [def: suffering]
anyo'n/N [def: anion]
anives{enyvT}/H [def: humility] /Idik
anker/S [m] [def: anchor]
	faranker/V/Bfarankert [def: anchor]
ankete/S [f] [def: questionniare]
anonim/A [def: anonimous]
anons/N anontsi'r/V/Banontsi'rt [def: announce]
anotirung/N [def: annotation]
ansambl/N [def: ensemble]
anshey{anSy}/H [def: men of]
anshtot [def: instead of]
anti [prefix] [def: anti-] 
antik/N/D [m] [def: antique; a real gem; something exquisite]
	antik/A [def: ancient, antique] 
antimon [m] [def: antimony (Sb)] 
antipatye/S [f] [def: antipathy]
antli/V/Bantlien [def: borrow]
antologye/S [f] [def: anthology]
antoysh/V/Bantoysht [def: disappoint] antoyshung/N [f] [def: disappointment]
antplek/V/Bantplekt [def: uncover] antplekung/N [f] [def: disclosure]
anttsik/V/Banttsikt [def: delight (German)]
antvikl/V/Bantviklt [def: develop] antviklung/N [f] [def: development]
	shpet-antvikler/S [m] [def: late bloomer] [note: V] 
anumlt [adv] anumltn [adv] [def: once] anustn [adv] [def: recently, just now]
anvelop/N [def: envelope (English)]
apara't/N [m] [def: apparatus]
	foto-apara't/N [m] [def: photographic camera] 
	distili'r-apara't/N [m] [def: distillation apparatus] 
apatye/S [f] [def: apathy] apatish/A
ape'l/N [m] [def: appeal; roll call] 
apenditsi't [m] [def: appendicitis]
apeti't/N [m] [def: appetite]
apikoyres{apykwrs}/Xapikorsem{apykwrsym}/H [m] [def: unbeliever, cynic]
	apikorsish{apykwrsish}/A [def: heretical]
	apikorses{apykwrswT} [def: heresy]
apl/X shvartsapl/X [def: pupil of eye]
aplikatsye/S [f] [def: application]
apokalipsis/N [def: apocalypse] apokaliptish/A [def: apocalyptic] 
apologye/S [def: apologetic] apologetish/A [def: apologetic] 
aponem{apnym}/H [adv] [def: obviously]
aposto'l/N [m] [def: apostle] /Iish [def: apostolic] 
apotropos{aptrwps}/Xapotroposem{aptrwpsym}/H [m] [def: legal guardian]
apriko's/N [m] [def: apricot] 
april [m] [def: April]
apshite{apSyt#}/H [def: clearly]
aptey'k/N [f] [def: pharmacy (store)] /D [def: medicine chest]
	apteyker/S [m] /D [n] apteykerin/S [f] /D [n] [def: pharmacist]
	apteykeray'/N [n] [def: pharmacy (profession)]
ar/V/T [def: bother] % not all forms exist; only 3rd person (impersonal)
araber [m] [def: Arab] arabish/A [def: Arabian, Arabic]
	arabi'st/N [m] [def: Arabist] % Forwards
aranzhi'r/V/Baranzhi'rt [def: arrange] aranzhirung/N [f]
arayn [adv] araynet [adv] arayntsu [adv] [def: into]
arbe{arbh}/H [def: four]
arbes/X/D [def: pea (food)]
arbet/V/T [def: work]
	/Gop/Goys/Gdurkh/Giber/Gmit/Garoyf/Garoys/Goyf
	/Gtsuzamen [def: collaborate] 
	baarbet/V/Bbaarbet [def: cultivate]
		baarbetung/N [f] [def: cultivation]
	arbeter/X [m] [def: worker]
		boyarbeter/S [m] [def: construction worker] [note: V] 
		fremdarbeter/S [m] [def: foreign worker] % Forwards
		shmidarbeter/S [m] [def: steelworker] 
	arbetorin/S [f] [def: worker]
	erdarbeter/X [m] [def: farmer]
	tsuzamenarbet [f] mitarbet [f] [def: cooperative work, collaboration]
	arbet|sloz/A [def: unemployed]
		arbet|slozikayt/N [f] [def: joblessness; unemployment]
	arbet|sfeik/A [def: craftsmanlike]
	funanderarbetung/N [f] [def: demolition]
	oysarbetung/N [f] [def: design]
	arbet/S [f] [def: work]
		drotarbet [f] [def: filigree] 
		hantarbet/N [f] [def: handwork] 
		erdarbet [f] [def: farming]
		hoyzarbet [f] [def: housework] heymarbet
		shvartsarbet [f] [def: unskilled work] 
			shvartsarbeter/S [m] [def: unskilled worker] 
		zamlarbet [f] [def: collection work]
	[idiom: zikh nemen tsu der arbet = get to work]
	[idiom: arbetn far zikh = freelance]
arbitrarish/A [def: arbitrary]
arbl/X [m] /Idik [def: sleeve]
arbuz/N [m] [def: watermelon]
arende/S [f] [def: leasehold] arendar/N [m] arendarke/S [f] [def: leaseholder]
arene/S [f] [def: arena] 
aresti'r/V/Baresti'rt [def: arrest]
	arest [def: arrest]
		hoyzarest [def: house arrest] 
	arestant/N [m] [def: person arrested]
	mitarestant/N [m] [def: co-prisoner]
	arest/N [m] [def: arrest]
argon [m] [def: argon (Ar)] 
argumenti'r/V/Bargumenti'rt [def: argument (reason)] 
	argume'nt/N [m] [def: argument (reason)] 
arikhes{aryxwT}/H [def: length] /Lb
aristokra't/N [m] [def: aristocrat] aristokratish/A [def: aristocratic]
arkheolog/N [m] [def: archeologist] /Iish arkheologye [f] [def: archeology] 
arkhitekt/N [m] arkhitekto'r/N [m] [def: architect]
	arkhitektish/A [def: architectural]
	arkhitektu'r/N [f] [def: architecture]
		/Ie'l /Iish [def: architectural] [usage: doubtful admissability]
	arkhitektonish/A [def: architectural] 
arkhiv/N [m] [def: archive] /Ialish [def: archival] 
	archivar/N [m] archivarke/S [f] [def: archivist] 
armey/N [f] armeyer/S [n] [def: army]
	roytarmey [f] roytarmeyer/S [n] [def: Red Army]
	platsdarm/N [m?] [def: military base] 
aroma't/N [m] [def: aroma] /Iish [def: aromatic] 
arop [adv] aropet [adv] [def: down]
aroyf [adv] aroyfet [adv] aroyftsu [adv] [def: up (preposition)]
aroys [adv] aroyset [adv] [def: out]
arsen [m] arshenik [m] [def: arsenic (As)] 
art/N [def: manner]
	filartik/A [def: full-fledged] filartikayt/N [f] [def: comprehensiveness] 
	groysartik/A [def: wonderful (German)] 
	farsheydnartik/A [def: multifaceted]
		farsheydnartikayt/N [f] [def: multifaceted nature]
arterye/S [f] [def: artery] 
artikl/N [m] [def: article]
artilerye/S [f] [def: artillery] 
arti'st/N [m] [def: artist] /Iish
artsibishof/N [m] [def: archbishop] 
aruf{aroyf}/H [def: up (converb)]
arum/P arum [adv] arumet [adv] [def: around]
	arumik/A [def: surrounding]
	um [prep] derum [adv] [def: around] 
	um [adv] [def: in order to (with "tsu")] 
	drum darum [def: therefore (German)]
arure{arwrh}/H [def: forbidden thing]
aryer [def: Aryan]
arzenik [m] [def: arsenic (chemical)] arsen [m]
asekuratsye/S [def: protective measure (Russian)] 
aser{asr}/H/V/T [def: forbid]
	oser{oswr}/H [adj] [def: forbidden]
	oser{oswr}/H [interj] [def: by my honor] [grammar: only in negative constructions]
	iser{#yswr}/Xisurem{#yswrym}/H [m] [def: prohibition] 
	asir{asyr}/Xasirem{asyrym}/H [m] [def: prisoner] 
aseres{eQrT}/H [def: ten]
asfalt [m] [def: asphalt]
ash [n] [def: ash]
asher{aSr}/H [def: who]
ashkenaz{aSKnz}/Xashkenazem{aSKnzym}/H [m] [def: Ashkenazic Jew]
asife{asyfh}/Xasifes{asyfwT}/H [f] [def: meeting]
asimili'r/V/Basimili'rt [def: assimilate]
	asimilator/N/Iish [def: assimilator]
	asimilirung/N [f] [def: assimilation] asimilatsye/S [f]
asistent/N [m] [def: assistant (English)] 
asketish/A [def: ascetic] asketi'zm/N [m] [def: asceticism] 
asoben/A [def: apart] 
asore{eQr#}/H [def: ten (Aramaic)]
asotsii'r/V/Basotsiirt [def: associate (with "zikh")] 
	asotsiatsye/S [f] [def: association] % Forwards
	[idiom: asotsiirter profesor = associate professor]
aspekt/N [m] [def: aspect]
aspiratsye/S [f] [def: aspiration]
aspiri'n/N [m] [def: aspirin]
astatin [m] [def: astatine (At)] 
astme [f] [def: asthma] /Itish
astronom/N [m] [def: astronomer]
astronoyt/N [m] [def: astronaut]
ataki'r/V/Bataki'rt [def: attack] ata'k/N [m] atake/S [f] [def: attack] 
ate{aWh}/H atem{aWm}/H [def: you]
atei'st/N /Iish ateistke/S [m] [def: atheist]
	ateizm [m] [def: atheism]
	monoteizm [m] [def: monotheism] 
		monotei'st/N /Iish monotheistke/S [f] [def: monotheist] 
atelye/S [f] [def: studio]
atem{aWm}/H [def: you (plural)]
atentat/N [m] [def: assasination] 
atle't/N/Iish [m] [def: athlete, jock]
	atletik [f] [def: gym, athletics (subject)] 
atmosfer/N [f] [def: atmosphere]
atom/N [m] [def: atom] /Iish
atraktsye/S [f] [def: attraction]
	bonus-atraktsye/S [f] [def: special feature] [note: V] 
atsves{ecBwT}/H [def: sadness]
avade{avd#y}/H [def: certainly]
avangard/N [def: avant guard (French)]
avansi'r/V/Bavansi'rt [def: advance] avansirung/N
avanture/S [f] [def: adventure]
aveyde{aBydh}/Xaveydes{aBydwT}/H [f] [def: lost object] 
	mayved{maBd} [def: lose (with "zayn")] 
aveyre{eByrh}/Xaveyres{eByrwT}/H [f] [def: sin, waste]
avgust [m] [def: August]
avle{evlh}/Xavles{evlwT}/H [def: sin, mistreatment]
	baavl{baevl}/V/Bbaavlt{baevlt} [def: mistreat, abuse]
avoyde{eBwdh}/Xavoydes{eBwdwT}/H [def: work, worship]
	avoydas{eBwdT}/H [def: worship of]
avtomat/N [m] [def: automat]
avyo'n/N [def: airplane] 
ay [def: (expression of delight)]
ayen{eʼ}/H [def: Hebrew letter Ayin]
ayen_{e|yn}-hore{hre}/H/S [m/f] [def: evil eye] 
ayl/V/T [def: hasten] /Gfarbay/Gdurkh
	ay'lenish/N [n] [def: hurry]
	aylik/A [def: hurried]
	geayl{ge#ayl}/N [n] [def: rush]
aylbirt/N [m] [def: olive]
ayn [def: in (separable converb)]
aynflus/V/T [def: influence] aynflus/N
	baaynflus{ba#aynflus}/V/Bbaanynflust{ba#aynflust} [def: influence] 
	baaynflusung{ba#aynflusung}/N [f] [def: influence] 
aynshtaynyum [m] [def: einsteinium (Es)] 
ayter/S/D [m] [def: udder]
ayz [n] [def: ice] /Ien [def: icy] /Iik
	ayz-smorke/S [def: icicle] 
ayzn/S [n] [def: iron (Fe)] ayzern/A ribayzn/S [m] [def: grater]
	akerayzn{aker#ayzn} [def: plow]
	grobayzn{grob#ayzn} [n] [def: hoe]
	presayzn{pres#ayzn}/S [m] [def: iron (appliance)] 
	[idiom: shtol un ayzn = firm]
az [def: that, when]
aza azan azelkh/A [def: such]
azart [m] [def: heat, excitement, gambling] 
azh [def: actually]
azil [m] [def: asylum]
azimut/N [m] [def: azimuth (astronomy)] 
azore{ezrh}/Xazores{ezrwT}/H [def: courtyard]
	ezras{ezrT}/H [def: courtyard of]
azot [m] [def: nitrogen (N)] 
azoy azoyns azoyne/A azelkhes [def: such] viazoy
baal{bel}/H [m] [def: master]
	baley{bely}/H [def: masters of]
	balebos [m] balebos_{bel-hbyT}/Xbalebatem{bely-bWym}/H [m] [def: householder, owner, boss] 
		/Dbalebes [def: householder] 
		baleboste/S/D [f] [def: housewife]
		balebateve/V/Bbalebatevet [def: deal with household affairs]
		balebatish/A [def: orderly] % loses Hebraic spelling
			balebatishkayt/N [f] [def: orderliness] % loses Hebraic spelling
	balegole{bel-eglh}/Xbalegoles{bel-eglwT}/H [m] [def: wagoneer, coachman]
	balmelokhe{bel-mloxh}/H/S [m] [def: craftsman]
	balekhayem{bely-HIm}/H [m] [def: living creatures] 
babke/S [def: butter cake]
badkhn{bdHn}/Xbadkhonem{bdHnyn}/H [m] [def: jester (wedding)]
bafel/V/Bbafoyln [def: order, command]
	bafel/N [m] [def: order, command] 
	bafeler/Iish [def: commander]
bagazh [m] [def: baggage]
baginen [m] [def: dawn]
bagleyt/V/Bbagleyt [def: accompany] /Gnokh/Garoys
	baleyt/V/Bbaleyt [def: accompany] /Gnokh/Garoys % variant form
		baleyter/S bagleyter/S [def: companion] 
		leytung/N [f] [def: guidance, direction, management] 
	bagleytung/N [f] baleytung/N [f] leytung/N [f] [def: accompaniment]
	bagleyter/S [m] bagleyterin/S [f] [def: companion]
		lebnsbagleyter/S [m] lebnsbagleyterin/S [f] [def: life companion] 
bagnedik/V/Bbagnetikt [def: forgive, release from prison] 
bagnet/N [m] [def: bayonet] 
bahavnt/A [def: proficient] bahavntkayt/N [f] [def: proficiency] 
bak/N /Iik /Dbek [f] [def: cheek]
	kinbak/N [def: chin]
	rozbekldik/A [def: rosy-cheeked]
bak/V/T [def: bake] /Gop
	/Gfrish [def: freshly baked]
	/Bgebakn /Gop [def: bake] /Gfrish [freshly baked] % variant
	/Gayn [def: become part of]
		[idiom: ayngebakn in hartsn = part of oneself]
	gebeks/N [n] [def: pastry; baked goods]
		putergebeks/N [def: baked dairy goods]
	beker/S [m] bekerin/S bekerke/S [f] [def: baker]
	bekeray'/N [f] [def: bakery]
	derbakn/A [def: polished, fully prepared] 
bakoshe{bkSh}/Xbakoshes{bkSwT}/H [f] [def: request]
bakterye/X/S [f] [def: bacterium] 
bakvem/A [def: pleasant] /Ilekh
	bakvemkayt/N [f] [def: pleasantness] bakvemlekhkayt/N [f]
	umbakvem/A umbakvemlekh/A [def: unpleasant]
bal/N [m] [def: dance, ball]
bala'beshke/S [def:  a cooked food made with buckwheat flour]
balade/S [f] [def: ballad] 
balagan/N [m] [def: mess, showbooth] 
balalayke/S [f] [def: balalaika]
balang/V/Bbalangt [def: belong (English)] /Gon
balans/N [m] balants/N [m] [def: balance]
bald/Iik [def: soon]
baldover{bel-dBr}/H [def: defendent]
balem/S [m] [def: ball]
	koyshbol [m] [def: basketball]
	netsball [m] [def: volleyball]
	fusbol [m] [def: soccer] fusboli'st/N [m] [def: soccer player]
	beysbol [m] [def: baseball]
	netsbol [m] [def: basketball]
balemutshe/V/Bbalemutshet [def: gibber, procrastinate, waste time] 
balet/N [m] [def: ballet]
baleye/S [f] [def: wash basin (for clothing)]
balkn/S [m] [def: balcony] balkon/N [m] % both forms exist
baln{beln}/Xbalonem{belnym}/H [m] [def: eager person, interested person]
	balones{belnwT} [f] [def: eagerness]
balon/N [m] [def: baloon]
balzam [m] [def: balm, balsam] 
ban/N [f] [def: train]
	unterban/N [f] [def: subway]
	ayznban/N [f] [def: train]
banane/S [f] banan/N [m] [def: banana]
	kokh-banane/S [f] kokh-banan/N [m] [def: plaintain (fruit)] 
band/Xbend [m] [def: volume (book)]
	filbendik/A [def: multi-volume] % Forwards
band/Xbender [f] [def: ribbon, band, tape]
	arumband/Xarumbender [f] [def: cummerbund] 
	haldzband/Xhaldzbender [f] [def: necklace] 
	gartlband/Xgartlbender [def: cummerbund] 
	kopband/Xkopbender [f] [def: headband] 
	reyfband/Xreyfbender [def: cummerbund]
	shukhbendl/Xshukhbendlekh [n] [def: shoelace (clothing)]
bandazh/N [m] [def: bandage] 
	bandazhi'r/V/Bbandazhi'rt [def: bandage] /Garum
bande/S [f] [def: gang, band] /Dband
bandero'l/N [m] [def: (mailing) wrapper] 
bandi't/N [m] [def: bandit]
bang [def: empty]
	[idiom: es tut mir bang = I am sorry]
bank/Xbenk [f/m] [def: bench, bank] /Dbenk [def: small bench; stool; chair] 
	bankoma't [m] [def: automated teller machine (ATM)] 
	banknot/N [m] [def: banknote]
	bankrot/N [m] [def: bankruptcy] 
	bankroti'r/V/Bbankroti'rt [def: bankrupt]
	/Dfusbenk [def: footstool]
	[idiom: tsushteln dir a benkele tsu emetsn = tattle on you to someone]
banke/S [f] [def: medicinal cupping, tin can]
banket/N [m] [def: banquet]
bansher{b#Sr}/H [def: insofar as]
	[idiom: bansher bekheyn{bxn} = as far as that's concerned]
bar{br}/H [def: son (Aramaic), in the category of]
	ben{bn}/Xbonem{bnym}/H [m] [def: son, child]
		bney{bny}/H [def: children of]
	barmitsve{br-mycvh}/Xbarmitsves{br-mycvwT} [def: Bar Mitsvah (ceremony or lad)]
	ba'rmenen{br-mynn} [def: corpse, remains]
barabane/V/T [def: play the drum]
barabolye/S [f] barabulye/S [f] [def: potato] 
barak/N [m] [def: barrack]
barashkn/A [def: sheepskin] 
barbar/N [m] [def: barbarian] /Iish [def: barbaric]
bare/-bare opgebaret/A [def: fooled, mangy]
barg/Xberg [m] [def: mountain] /Iik [def: mountainous] /Dberg [n] [def: hill]
	mistbarg/Xmistberg [m] [def: landfill] [note: V] 
barikade/S [f] [def: barricade] 
barim/V/Bbarimt [def: boast, be known, be famous]
	barimt/K [def: famous] 
	barimtkayt/N [f] [def: fame] 
	barimer/S [m] [def: braggart, boaster] 
	barimeray'/N [n] [def: bragging, boasting]
	veltbarimt/A [def: world-famous]
barishnye/S [f] [def: lady (Russian)] 
bariton/N [m] [def: baritone] 
barm/V/T [def: be merciful] barmenen
	derbarem/V/Bderbaremt [def: be merciful]
	derbaremdik/A [def: merciful] 
barne/S berne/S [f] [def: pear]
barometer/S [m] [def: barometer] 
baron/N [m] [def: baron]
barsht/V/T [def: brush]
	barsht/Xbersht [f] [def: brush] /Dbersht
		golbershtl/Eekh [n] [def: shaving brush] % Harduf
	tseburshet/A [def: unkempt]
barye'r/N [m] [def: barrier; hurdle (sport)] 
	[idiom: aribershpringen dem baryer = clear the hurdle]
baryum [m] [def: barium (Ba)] 
bas/Xbeser [m] [def: bass voice] /Iov
bas{bT}/H [f] [def: daughter]
	[idiom: simkhas{QymHT}-bas{bT} = baby naming for daughter]
baseyn/N [m] [def: pool (water)] 
	shvimbaseyn/N [m] [def: swimming pool] 
bashaymperlekh/A [def: obvious]
bashert/A [def: destined]
bashlis/V bashlosn/A [def: decide]
bashtat/V/Bbashtat [def: hide, secure] 
bastilye [f] [def: prison; Bastille] 
batalyon/N [m] [def: battalion]
batate/S [f] [def: sweet potato] 
batayt/V/Bbatayt [def: signify]
	batayt/N [m] /Iik [def: meaning]
	daytlekh/A [def: precise; clear; distinct]
	badayt/V/Bbadayt [def: signify] [usage: inadmissable]
		badayt/N [m] badaytung/N [f] [def: meaning] [usage: inadmissable]
	tsveydaytikayt/N [f] [def: ambiguity]
baterye/S [f] baterey/N [f] [def: battery (electric)]
	batereyke/S [f] [def: flashlight] 
bati'st [m] [def: cambric (material)] /In
batribt/A [def: sad] % no Yiddish base verb
batsirk/N [m] [def: district, ward, county] 
batyushke [m] [def: Orthodox priest (Russian)]
bavl [m] [def: cotton; thread]
bay/P bam [prep]  [def: at, by, near]
	derbay/Iik [def: present; neighboring, nearby, close]
	farbay/P [def: past]
bay/P [def: at] bam
baybak/Ees/D/Ishen [m] [def: marmot, lazybones]
baydl/N [n] [def: hut, shed, booth]
bayer/V/T [def: spin a tale, fool] 
bayes{byT}/Xbatem{bTym}/H [m] [def: house] /Lh
	bes{byT}/Xbatey{bWy}/H [def: houses of]
bayke [def: unbelievable story (Russian)]
bayl/N [def: lump (swelling)]
bayl/V/T [def: clench]
baynir [def: adrenal gland]
bays/V/Bgebisn [def: bite] /Garayn/Gadurkh/Gayn/Gon
	/Giber [def: eat breakfast]
		iberbaysn [n] [def: breakfast]
	farbays/V/Bfarbisn [def: snack]
	farbisn/A [def: grim, obstinate] farbisnkayt/N [f] [def: bitterness]
		[idiom: a farbisener hund = a mean, bitter person]
	tsebays/V/Btsebisn [def: eat]
	onbaysn [n] [def: lunch]
	bis/N [m] [def: bite] bisn/S [m] [def: morsel, bite] 
	baysik/A [def: biting, sharp; painful] 
bayt/V/Bgebitn [def: exchange, change] /Giber
	/Goys [def: take turns (with "zikh")] 
	farbayt/V/Bfarbitn [def: exchange; replace]
		farbaytlekh/A [def: replaceable] 
	oysbayt/N [m] opbayt/N [m] [def: exchange]
	bay'tevdik/A [def: changeable] 
	[idiom: es bayt zikh gornit oys = it makes no difference]
baytl/Xbaytlekh [m/n] [def: wallet, handbag, pouch, purse; scrotum] % no positive
	nash-baytele/Ekh [n] [def: goodie bag (for children)] [note: V] 
baytsh/N [f] [def: whip] /D
baze/Xbazn [f] [def: base; basis]
baza'kht/A [def: slow, deliberate, leisurely; dispassionate; demure] 
bazar/N [m] [def: bazaar] 
bazesn/A [def: crazy]
bazi'r/V/Bbazi'rt [def: base]
be [interj] [def: well (expression of doubt), pooh! (expression of dismissal)]
be/Een [m] [def: the letter B] 
bebe/V/T [def: babble] 
bebekhe/S [def: blanket, rag]
beduiner/X [m] [def: Bedouin] 
befeyresh{bfyrwS}/H/A [def: explicitly]
befra't{bfrt}/H/Lu [def: in particular]
beged{bgd}/Xbegodem{bgdym}/H [m/n] [def: clothing]
beheyme{bhmh}/Xbeheymes{bhmwT}/H [f] [def: cow, beast, fool]
behole{bhlh}/Xbeholes{bhlwT}/H [f] [def: commotion]
beke/V/T [def: bleat (sound of a cow)] 
be'keshe/S [f] [def: long jacket (Chassidic clothing)] 
bekher/S/D [def: drinking cup]
bekheyn{bxn}/H [def: therefore]
bekhine{bxynh}/Xbekhines{bxynwT}/H [f] [def: test]
bekhire{bHyrh}/H [f] [def: choice]
bekhlal{bxll}/H [def: generally]
bekn/S [m] [def: basin, pool (artificial), pelvis, roasting pan] 
belaz{blez}/H [def: in the vernacular]
beletristik [f] [def: belles lettres, fiction] /Ibeletristish
benefit/N [m] [def: benefit]
benemones{bn#mnwT}/H [def: in good faith]
benimes{bne|ymwT}/H [def: pleasant] /Idik
benk/V/T [def: yearn] /Goys
	benkndikerheyt [adv] [def: while yearning] 
	benkshaft/N [f] [def: nostalgia] be'nkenish [def: yearning]
	farbenk/V/Bfarbenkt [def: strongly yearn]
		farbenktkayt/N [f] [def: strong yearning]
benkart/N [def: bastard]
bentsh/V/T [def: bless, recite after-meal grace]
	bentshung/N [f] [def: blessing]
benzin [def: benzine, gasoline]
ber/N/D [m] [def: bear] /Iish [def: bearish] 
	berele/Ekh [n] [def: burr] 
beret/N [m] [def: beret (cap)]
bereze/S [f] [def: birch] /Ive
	beryoze/S [f] [def: birch] /Ive
berkelyum [m] [def: berkelium (Bk)] 
berilyum [m] [def: beryllium (Be)] 
berlinke/S [def: raft]
berye{bryh}/Xberyes{brywT}/H [m/f] [def: expert, hard-working person] 
	beryeshkayt{bryhshkayt}/N [f] [def: expertise]
	berye{bryh}/V/T [def: manage under difficult circumstance (with "zikh")] 
		% bug: not getting gebryht
berze/S [f] [def: stock exchange] 
beshas{bSeT}/H/P [def: while]
beshtike{bSWyk|h}/H [def: silently; surreptitiously]
beshum{bSwm}/H [def: in no manner of]
besomem{bQmym}/H [def: spices]
bestye/S [f] [def: beast] bestyal/A
bet/N/D [n/f] [def: bed] bankbet/D [f]
	iberbet/N [n] [def: bedcovers] 
	oysleygbet/N/D [n] [def: folding bed (opened when needed)]
bet/V/T [def: request] /Gon/Gtsu
	/Giber [def: reconcile] /Gayn [def: invite]
	bet/V/Bgebotn [def: request] /Giber/Gayn/Gon % both participles exist
	farbet/V/Bfarbet [def: invite] farbetung/N [f] [def: invitation]
	% the adjectival form is not the participial, but "gebetn", with all
	% converbs
	umgebetn/A [def: uninvited] oysgebetn/A [def: requested]
	gebot/X/N [n] [def: commandment]
	gebet/N [n] [def: prayer; plea] % Harduf 
	beter/S [m] [def: requester]
	shtilbet [def: silent request]
	[idiom: zikh lozn betn = play hard-to-get]
betl/V/T [def: beg] /Gtsuzamen/Goys
	betler/S [m] [def: beggar]
betokhn{btHwn}/H [def: trust, confidence]
	betuekh{btwH}/Xbetukhem{btwHym} [def: confident]
	mavtiyekh{mBtyH} [def: assure (with "zayn")] 
beton [m] [def: concrete] 
betshe/V/T [def: bleat, jabber] 
beyde beydn beydns beyder [def: both]
beyg/V/Bgeboygn [def: bend, decline (grammar)] % not "boyg"
	/Gariber/Garop/Gayn/Goys/Gon/Garunter/Gtsu
	farbeyg/V/Bfarboygn [def: bow]
	tsebeyg/V/Btseboygn [def: bend]
	beygl/X [m] [def: bagel]
	boygn/S [m] [def: bow, sheet of paper]
		regnboygn/S/Idik [m] [def: rainbow] elnboygn/S [m] [def: elbow]
		[idiom: oyf eyn mol ibertsien dem boygn = do it all at once]
	boygik/A [def: bent] beygik/A beygevdik/A [def: flexible, lithe]
		beygevdikayt/N [f] [def: flexibility] 
	beygung/N [f] [def: bending, declension (grammar)] 
	oysbeyg/N [m] [def: bend, curve] 
beylik [def: white meat (poultry)]
beyn/Eer [m] [def: bone] /Dbeynd 
	/Iish /Iik /Ierdik [def: bony]
	gebeyn beynikayt/N [f]
	breytbeynerik/A [def: large-boned]
	baknbeyn/Eer [m] [def: cheekbone] 
	elfnbeyn [m] helfandbeyn [m] [def: ivory]
	markhbeyn [m] [def: marrow bone]
	nozbeyn [m] [def: nasal cartilage]
	ruknbeyn [m] [def: backbone]
	vintshbeyndl/Eekh [n] [def: wishbone (American)] 
	[idiom: aroystsien di kley fun di beyner = impoverish]
	[idiom: onbrekhn di beyner = attack, harm]
	[idiom: a yung mit beyner = a strapping lad]
beyomeynu{bymynw}/H [def: in our days]
beys_{bʼ}/H [m/f] [def: Hebrew letter Beys]
beys{beT}/H/P [def: while]
beyt/N [f] [def: (garden) bed] 
beytse{bych}/Xbeytsem{bycym}/H [f] [def: egg; testicles (in plural)]
beyz/K [def: evil, angry, bad] /Iik /Ilekh
	beyzer/V/T [def: become angry (with "zikh")]
	gebeyzer/S [n] [def: anger]
	tsebeyzer/V/Btsebeyzert [def: become angry]
	derbeyzer/V/Bderbeyzert [def: become angry]
	beyzkayt/N [f] [def: anger, malice] 
bez/N [m] [def: lilac]
bezdushne/A [def: soulless]
bezem/S/Eer [def: broom] /D 
bezpokoye/V [def: bother (Russian), exert effort (Russian)] 
bgide{bgydh}/H [f] [def: treason] 
b|gilufn{gylwfyn}/H [def: tipsy]
biber/S [m] [def: beaver]
bibl [f] [def: Bible] 
	biblyotek/N [f] [def: library]
		shtatbiblyotek/N  [def: public library]
		biblyoteker/S [m] biblyotekerin/S [f] biblyotekershe/S [f] [def: librarian] 
	biblyografye/S [def: bibliography] 
bidne/A [def: unfortunate]
bifresye{bfrhsy#}/H [def: publicly]
bik/Ees [m] [def: bull]
bikarbonat [m] [def: bicarbonate]
biker{bykwr}/H [def: visit, search] mevaker{mBkr}
biks/N [f] [def: rifle (weapon)]
bil/V/T [def: howl (sound of a dog), bark (sound of a dog)] biler/S
	bileray'/N [f/n] [def: barking] 
bilbl{bylbwl}/Xbilbulem{bylbwlym}/H [m] [def: slander]
	mevulbl{mBwlbl} [adj] [def: confused] 
bild/Eer [n] [def: picture] bilderish/A [def: picturesque]
	bilderishkayt/N [f] [def: picturesqueness]
	likhtbild/Eer [f] [def: slide, transparency (photographic)] 
	shpiglbild/Eer [def: mirror image]
	bild/V/T [def: paint] /Gop
	opbild/Eer [n] [def: image] 
bild/V/T [def: educate] 
	bildung/N [f] [def: education]
		fakhbildung/N [f] [def: vocational education] 
		zelbstbildung/N [f] [def: self-education] 
	gebildet/A [def: educated]
	umgebildet/A [def: uneducated]
	yesod{yswd}-bildung [def: basic education]
bile't/N [m] [def: ticket]
	b|khinem{Hynm}-bile't [def: complementary ticket] 
bilik/K [def: cheap]
bilkher/A [def: preferable]
bilyon/N [m] [def: billion] 
bim-bom [interj] [def: ding-dong (sound of a bell)]
bimkem{bmkwm}/H [def: substitute]
bin/N [f] [def: bee] 
bin bist bistu iz zay zaynen zenen zayt zent zayn geven gevezn/A [def: be]
	binen izn [def: be] [grammar: redoubled form]
	baygeven [def: be present] baytsuzayn bayzayn
	voylzayn [def: well-being]
	zayendik/A [def: being] zayik/A [def: existing] 
	/Vopzayn/Bopgeven [def: be absent; stay as long as]
		[grammar: not in present tense]
		opzayn [m] [def: absence]
	sʼiz [def: it is]
	gevezn/A [def: former] 
bind/V/Bgebundn [def: bind; commit oneself (with "zikh")]
	/Garayn/Garum/Gtsu/Gtsunoyf/Gtsuzamen/Gunter/Gop/Giber/Goyf/Goys
	derbind/V/Bderbundn farbind/V/Bfarbunden [def: bind]
	aynbinder/S [m] [def: bookbinder]
		aynbindn/V/Bayngebundn [def: bind books] aynbund [def: binding (bood)]
	farbind/V/Bfarbundn [def: unite]
		farbi'ndenish/N farbindnkayt/N [f] farbindung/N [f] [def: unification]
			geshefts-farbindung/N [f] [def: network (professional)] [note: V] 
			gezelshaft-farbindung/N [f] [def: network (social)] [note: V] 
		farband/N [m] [def: union]
			ratnfarband/Iish [m] [def: Soviet Union]
	bund/N [m] [def: alliance, association, Jewish Labor Party]
		bundi'st/N [m] bundistke/S [f] [def: member of Jewish Labor Party]
		shlislbund/N [def: keyring] 
		tsuzamenbund/N [def: connection]
	binde/S [f] [def: sling] 
	/Dbint [def: bundle] 
	tsugebundnkayt/N [f] [def: close friendship] 
	[idiom: geknipt un gebundn mit = part and parcel of]
bine/S [f] [def: stage (in a theater)]
binyen{bnyn}/Xbinyonem{bnynym}/H [m] [def: building]
bir/N [n] [def: beer]
	vortslbir/N [n] rutbir/N [n] [def: root beer] [note: V] 
birger/S [m] [def: citizen] birger/V/T/Gayn
	birgershaft/N [f] [def: citizenship]
bis/N [m] [def: encore] bis [interj] [def: encore!] 
	[idiom: oyf bis = as an encore]
	bis/D abisl [def: bit]
	bislekh/A [def: somewhat]
	bislekhvayz [adv] tsubislekh [adv] [def: by small amounts] 
biskup/N bishof/N [m] [def: bishop]
biskvit/N [m] [def: biscuit] 
bistre [adj] [def: swift, agile] 
bite [interj] [def: please] [usage: doubtful admissability]
	bite/S [f] [def: request]  [usage: doubtful admissability]
bitel{bytwl}/H [def: nullification]
biter/K [def: bitter] biterlekh/A
	biternish/N [f] [def: bitterness]
	biterkayt/N [f] [def: bitterness] 
	farbiter/V/Bfarbitert [def: make bitter]
bitl{bytwl}/H [def: nullification]
bitsikli'r/V/Bbitsikli'rt [def: ride a bicycle] 
biyesh{bywS}/H [def: embarrassment]
	mevayesh{mBywS}/H [def: embarrass (with "zayn")] 
	bushe{bwSh}/Xbushes{bwSwT}/H [def: embarrassment, shame]
biz/P [def: until, at the time (in future) when] bizkl
bizmut [m] [def: bismuth (Bi)] 
biznes/Ees [m] [def: business, trade] [usage: doubtful admissability]
bizoyen{bzywn}/Xbizyoynes{bzywnwT}/H [m] [def: embarrassment]
	mevaze{mBzh}/H [def: embarrass (with "zayn")] 
bkhoyre{bxwrh}/H [f] [def: right of the first-born; right of way] 
blank/V/T [def: gleam]
	blank/N [m] [def: blank (form)] 
	blank/A [def: glossy, shiny, briliant; spick-and-span] 
blas/A [def: pale]
	blaskayt/N [f] [def: paleness]
	bloyblas/A bloblas/A [def: pale blue] 
blat/Xbleter [m/n] [def: leaf, page; newspaper (informal)]
	/Dblet [def: leaflet, handout (paper)] 
	bleterish/A [def: leafy] 
	bleter/V/T [def: turn pages] /Goyf/Gdurkh
	barekhn-blat/Xbarekhn-bleter [m/n] [def: spreadsheet] 
		oysrekhn-blat/Xoysrekhn-bleter [m/n] [def: spreadsheet] 
	faygnblat/Xfaygnbleter [m/n] [def: fig leaf]
	flugblat/Xflugbleter [m/n] /Dflugblet [n] [def: leaflet] 
	heymblat/Xheymbleter /Dheymblet [m/n] [def: home page (computer)]
	klepbletl/Eekh [n] [def: post-it note] [note: V]
	krikhblat/Xkrikhbleter [def: vine, tendril] 
	/Xsharfbleter [n] [def: holly (tree)] 
	togblat/Xtogbleter [m/n] [def: newspaper]
	tseglider-blat/Xtseglider-bleter [m/n] [def: spreadsheet] 
	vebsblat/Xvebsbleter /Dvebsblet [m/n] [def: web site]
	vokhnblat/Xvokhnbleter [def: weekly publication] % Harduf
blate [def: underworld, criminal element]
blay/N/A [n] [def: lead (Pb)] /Ien /Iern
	blayer/S blayshtif/N [m] [def: pencil]
blayb/V/Bgeblibn [def: remain] /Giber/Goys/Gtsurik
	farblayb/V/Bfarblibn [def: remain]
	iberblaybekhts/N [n] [def: remnant]
	blaybik/K [def: permanent] 
bleke/V/T [def: bleat (sound of sheep)] 
ble'kets/V/T [def: chant unintelligibly] 
blekh/N/D [n] [def: tin, tin plate, badge]
	/Iern /In [def: tin] 
	blekher/S [m] [def: tinsmith] 
	blekheray'/N [f] [def: tin works] 
	shitsblekh/Xshitsblekher [n] [def: bumper (automotive)] [note: V]
blender/S [m] [def: blender (American)] 
bleykh/K [def: pale] gebleykht/A oysgebleykht/A
	bleykh/V/T [def: bleach] 
		bleykhekhts/N [n] [def: bleach]
bli/V/T tsebli/V/T [def: bloom, blossom, flourish]
	farbli/V/Bfarblit [def: fade] 
	bli/N [m] [def: bloom, prime] 
	blum/N [f] /Dblim [n] [def: bloom, flower]
	bliekhts/N [n] [def: blossom] 
	bliung/N [f] [def: blooming] 
	shpet-tseblier/S [m] [def: late bloomer] [note: V] 
bli{bly}/H [def: without]
blik/V/T [def: blink] /Gop
	blik/N [m] [def: glance]
		aroysblik/N [m] [def: view; panorama] 
		iberblik/N [m] [def: overview]
		onblik/N [m] [def: appearance] 
			[idiom: hobn dem onblik fun = resemble]
			[idiom: oyfn onblik = at first glance]
		opblik/N [m] [def: sideways glance]
		oygnblik/N/D [def: blink of an eye]
		oysblik/N [m] [def: point of view] 
		tsurikblik/N [def: retrospect]
blind/A [def: blind] blindns
	blindkayt/N [f] [def: blindness] 
	blinderheyt [adv] [def: in a state of blindness] 
	farblend/V/Bfarblendt [def: trick the eyes]
		farble'ndenish/N [def: hallucination]
blintse/S [def: crépe, blintz]
blishtshe/V/T [def: sparkle, glitter, shine]
	blishtsh/N [m] [def: glitter, glamor] 
blits/V/T [def: flash] /Garoys/Goyf
	tseblits/V/Btseblitst [def: flash]
	blits/N [m] [def: flash, lighting] /Iik [def: sparkling]
	[idiom: meg dunern un blitsn = come hell or high water]
blo/A bloy/A [def: blue]
	bloykayt/N [f] blokayt/N [f] [def: blueness] 
	bloy/V/T [def: become blue (with "zikh")] 
blof/V/T [m] [def: bluff] 
	blof/N [m] [def: bluff] 
	blofer/S [m] [def: bluffer, liar] 
blog/N [m] [def: blog, weblog] [note: V] 
	blogi'r/V/Bblogi'rt [def: write a weblog] [note: V]
blok/N [m] [def: block (of houses)] kinderblok/N
	bloknot/N [m] [def: note pad] 
	klepblok/N [m] [def: post-it pad] [note: V]
blokade/S [f] [def: blockade]
blond/A [def: blond] /Iin /Iink
blondzhe/V/T [def: wander, go astray] /Gavek/Garum
	farblondzhe/V/Bfarblondzhet [def: become lost]
		farblo'ndzhenish/N [def: wandering lost]
blote/S [f] [def: mud] blotik/A blotkele
bloter/S [m] [def: blister] 
bloyz/A [def: unadorned, only] antbloyz/V/Bantbloyzt
bloz/V/T [def: blow] /Garayn/Gon/Garoys
	/Bgeblozn/Garayn/Gon [def: blow] % variant participle
	tsebloz/V/Btseblozn/Btseblozt [def: blow on coal to make a fire]
	bloz/N [m] [def: blow] 
	/Dblez [def: bubble] /Dgazblez [def: gas bubble]
		blezl/V/T [def: bubble] /Garoys
		zeyfblezl/Eekh [n] [def: soap bubble] 
blut/N [n] [def: blood] blutik/K [def: bloody]
	blutikayt/N [f] [def: bloodiness]
	blutik/V/T [def: make bloody]
	farblutik/V/Bfarblutikt [def: make bloody]
	tseblutik/V/Btseblutikt [def: make bloody]
	kaltblutik/A [def: without sympathy]
	[idiom: geyn bizn blut arayn = come to blows]
bluze/S [f] [def: blouse] bluzke/S/D [f]
blyaki'r/V/Bblyaki'rt [def: bleach, fade (color)] /Gop/Goys
blyask/N [m?] [def: ??] % khvalyes khapn zikh on, on a blyask fun der levone
bob/Ees [m] [def: bean (food)] /Dbeb
bobe/S/C/J [f] [def: grandmother]
	bobenyu [f] [def: dear grandmother]] 
	bobele [f] [def: little grandmother, baby]
	elter-bobe/S [f] [def: great-grandmother] 
	zeyde-bobe [def: grandparents] % plural
bobke/S [f] [def: goat excrement]
bobre/V/T [def: mess around (with "zikh"), move with difficulty (with "zikh")]
bod/V/T [def: bathe; wallow (with "zikh")] /Goys/Gop
	/Bgebodn /Goys/Gop % variant participle
	bod/Xbeder [f] [def: bath]
		shvitsbod/Xshvitsbeder [f] [def: Turkish bath] 
		[idiom: ikh hob dikh in bod = to hell with you]
	gebodenerheyt [adv] [def: having bathed]
	beder/S [m] [def: bath-keeper] 
boday [def: even; if only; rather]
bodn/S [m] [def: terrain, ground, soil] 
	valdbodn/S [m] [def: forest floor] 
bohe'm/N [m] bohemyen/N [m] [def: Bohemian, artist, sensualist]
	bohemyum [m] [def: rhenium (Re)] 
bok/Xbek [m] [def: male goat]
bokal/N [m?] [def: goblet] 
bokh/N [m] [def: river, stream] /D
bokher{bHwr}/Xbokhrem{bHwrym}/H /Ish [def: bachelor]
	bokherl{bHwrl}/Xbokhuremlekh{bHwrymleX} [n] [def: bachelor]
	bokhervayz{bHwrvayz} [def: as a lad]
	bokhershaft{bHwrshaft} [def: bachelorhood]
	khosn{HTn}-bokher{bHwr} [m] [def: marriagable lad] 
	yeshive{ySyBh}-bokher{bHwr} [m] [def: yeshivah student] 
boks [m] [def: boxing (sport)] 
	bokser/S [m] [def: boxer] 
	boks/V/T [def: box (sport)] 
bokser/N [m] [def: carob] 
boky{bky}/Xbekiyem{bkAm}/H [m] [def: expert]
bol [m] [def: ball] 
	koysbol [m] [def: basketball] 
	netsbol [m] [def: volleyball] 
	oy'smaydbol [m] [def: dodge ball] 
bolshevi'st/N [m] bolshevik/Ees [m] bolshevistke/S [f] [def: Bolshevist] /Iish
bombe/S [f] [def: bomb]
	atom-bombe [def: atomic bomb] [note: V] 
	brenbombe/S tsindbombe/S [def: fire bomb]
	yoder-bombe [def: nuclear bomb] [note: V] 
	bombardi'r/V/Bbombardi'rt [def: bomb]
		tsemombardi'r/V/Btsebombardi'rt [def: bomb]
		bombarde/S bombardirung/N bombirung/N [f] [def: bombardment]
	bombastik [f] [def: bombast; pride] bombastish/A [def: bombastish; prideful] 
bombl/V/T [def: toss in the wind (clothing), dangle (with "zikh")]
bombonierke/S [f] [def: box of candies]
bomut [def: part of equipment connecting horse to cart] 
bonus/N [m] [def: bonus] 
bor [m] [def: boron (B)] 
bord/Xberd [f] [def: beard] /Dberd
	berdik/A baberdikt/A [def: bearded]
	gelbord/N [def: blond beard]
	kozheberdl/Eekh [n] kozeberdl/Eekh [n] [def: goatlike beard] % Stutshkov
	[idiom: a vits mit a bord = a stale joke]
bore/V/T [def: fight (with "zikh")] 
borekh{brwx}/Xbrukhem{brwxym}/H [adj] [def: blessed]
	brokhe{brxh}/Xbrokhes{brxwT}/H [def: blessing]
	borekh-habe{brwX-hb#}/H [def: welcome] 
	yisborekh{yTbrx}/H [def: may he be blessed]
	[idiom: makht brokhe{brxh} = have something to eat]
	[idiom: in mazl{mzl} un in brokhe{brxh} = good luck (to them)]
borer{bwrr}/H [def: arbitrator]
	borer{bwrr}/H/V/T [def: arbitrate]
	boreres{bwrrwT}/H [n] [def: arbitration]
borg/V/T [def: lend, borrow] /Goys
	farborg/V/Bfarborgt [def: lend]
borsht/N [m] [def: beet soup]
	[idiom: bilik vi borsht = very inexpensive]
borti'r/V/Bborti'rt [def: board (a conveyence)] 
	borti'r-kartl/Eekh [n] [def: boarding pass] 
bortn/S [m] [def: shore, coast] 
borves/A [def: barefoot]
boryum [m] [def: bohrium (Bh)] 
bos/Xboses [def: boss (English)]
bosr{bQr}/H [def: flesh]
bot/N [m] [def: boot (clothing; for rain or snow)] 
bot/V/Bgebotn [def: bid, offer] /Gon % rare in plain form
	onbot/N [m] [def: bid, offer] 
botanik [f] [def: botany (subject)]
	botaniker/S [m] [def: botanist]
boterskatsh [m] [def: butterscotch] 
botl{btwl}/H [def: worthless, void, senile (with "oyver -")]
	batl{btl}/H/V/T [def: waste]
	batlen{btln}/Xbatlonem{btlnym}/H [m] [def: unemployed person, loafer]
		batlones{btlnwT}/H [def: idleness]
		batlon{btln}/Iish [def: idle]
	mevatl{mBtl}/H/V/T [def: nullify (with "zayn")]
botshan/Ees [m] butshan/Ees [def: stork]
botvine botshene botshvene [f] [def: beet leaves] 
boy/V/T [def: build] /Goyf/Gtsu/Gnokh/Goys/Giber
	geboy [n] [def: construction]
	oyfboy [m] [def: construction]
	nokhboy [def: reconstruction]
	shifboyeray'/N [n] [def: ship building]
	gebayde/S [f] [def: building]
boyd/N [def: buggy]
boydem/S/Xbeydemer [m] [def: attic]
	[idiom: oyslozn zikh a boydem = come to nothing, fizzle out]
boyer/V/T [def: perforate] /Goys tseboyer/V/Btseboyert
	boyer/S [m] [def: drill] 
boykh/Xbaykher [m] [def: belly] /Dbaykh
	baykhik/A [def: potbellied]
	dikbaykhik/A [def: fat]
	fulbaykhik/A [def: potbellied] 
	[idiom: aynredn a kind in boykh = take advantage of gullability]
boykoti'r/V/Bboykoti'rt [def: boycot] boykot/N [m]
boylet{bwlt}/H/A [def: apparent]
boym/Xbeymer [m] [def: tree] /Dbeym
	beymish/A beymerish/A [def: tree-like]
	ashboym/Xashbeymer [m] [def: ash (tree)] 
	bokserboym/Xbokserbeymer [m] [def: carob (tree)] 
	eplboym/Xeplbeymer [m] [def: apple (tree)]
	frukhtboym/Xfrukhtbeymer [m] [def: fruit tree]
	karshnboym/Xkarshnbeymer [m] [def: cherry (tree)]
	kestnboym/Xkestnbeymer [m] [def: chestnut (tree)] 
	knupboym/Xknupbeymer [m] [def: elm (tree)] 
	nezboym/Xnezbeymer [m] [def: maple] 
	nodlboym/Xnodlbeymer [m] [def: evergreen, conifer (tree)] 
	tenenboym/Xtenenbeyeymer [m] [def: spruce (tree)] 
	tsugeboym/Xtsugebeymer [m] [def: hemlock (tree)] 
	valdboym/Xvaldbeymer [m] [def: forest tree] 
	vaynshlboym/Xvaynshlbeymer [m] [def: sour-cherry (tree)]
	yodleboym/Xyodlebeymer [m] [def: fir (tree), frost (on window)]
boyml/N [m] [def: oil (edible)] /Idik [def: oily, bland] 
	boymldikayt/N [f] [def: oiliness] 
	boymlung/N [f] [def: annointing; unction] 
boyre{bwr#}/H [m] [def: creator] /Lh
boyt/V/T [def: shake (liquid)] /Gon
braki'r/V/Bbraki'rt [def: reject, condemn] 
	brakirer/S [m] [def: picky person] 
brand/N [m] [def: fire, blaze] 
	[idiom: brand tayer = extremely expensive]
	brandopfer/N [def: sacrifice]
brand/N [f] [def: gangrene; blight (grain disease)] 
brashek/A [def: ??]
braunston/S [def: brownstone house (English)]
brav/A [def: brave]
	bravo [interj] [def: bravo!] 
bray/V/T [def: brew] 
braye/V/T [def: talk at length] /Goys
	[idiom: vos zol ikh aykh lang brayen = to make a long story short]
brayl [m] [def: braille] 
breg/N/Ees [m] [def: shore, brim]
brekh/V/Bgebrokhn [def: break, wring (the hands), vomit]
	/Goyf/Gdurkh/Gop/Gunter/Garayn/Giber/Gayn/Gtsuzamen
	/Garoys/Goys [def: vomit]
	tsebrekh/V/Btsebrokhn [def: break]
	farbrekh/V/Bfarbrokhn [def: break the law, wring (the hands)]
		farbrekh farbrekhn/S [n] [def: crime]
		farbrekher/S [def: criminal] /Iish
		[idiom: bageyn a farbrekhn = commit a crime]
	gebroks/N [def: crumbled cracker]
	oysbrokh/N [m] [def: outbreak]
		oysbrukh/N [m] [def: outbreak] [usage: doubtful admissability]
	unterbrokhn/A [def: interrupted] umunterbrokhn/A [def: uninterrupted]
brekl/V/T [def: crumble] 
	brekl/Xbreklekh [n] [def: scrap, crumb] % no positive form
	tsebrekl/V/Btsebreklt [def: broken into small pieces]
brem/N [f] [def: eyebrow] 
bren/V/T [def: burn] /Gop
	/Goys [def: burn out, blow (fuse)] [note: V]
	/Gdurkh [def: burn through, blow (fuse)] [note: V]
	farbren/V/Bfarbrent [def: burn up]
	tsebren/V/Btsebrent [def: burn for a while]
	bren [m] [def: ferver, ardor] 
	brener/S [m] [def: burner (on a stove)] 
breng/V/T [def: bring]
	/Garayn/Garop/Garoys/Garoys/Gtsuzamen/Goys/Gunter/Gtsu/Goyf/Gmit
	/Gtsuzamen/Gtsunoyf/Gaheym/Gtsurik
	/Gfir [def: suggest] 
	/Gum [def: kill]
	/Bgebrakht [def: bring]  % variant participle
		/Garayn/Garop/Garoys/Garoys/Gtsuzamen/Goys/Gunter/Gtsu/Goyf/Gmit
		/Gtsuzamen/Gtsunoyf/Gaheym/Gtsurik
		/Gum [def: kill]
	farbreng/V/T /Bfarbrakht [def: pass the time pleasantly]
bret/Eer/D [f/n] [def: board]
	fentsterbret/Eer/D [def: shutter (window)]
	gipsbret/Eer [f] [def: drywall] 
	meldbret/Eer [f] [def: announcement board] 
	elektre-bret/Eer [f] [def: power strip/board (electric)] 
breyre{bryrh}/Xbreyres{bryrwT}/H [f] [def: choice]
breyt/K [def: wide, broad, generous (with "zikh firn")] /Ilekh
	breytkayt/N [f] breyt/N [f] [def: width] 
	breyter/V/T [def: broaden] /Goys
	farbreyter/V/Bfarbreytert [def: broaden]
		farbreyterung/N [f] [def: broadening]
breyt/V/T [def: prepare (German)] /Gfor
	forbreytung/N [def: preparation] 
brezent/N [m] [def: tarpaulin] 
bri/V/T [def: burn] /Gop
	farbri/V/Bfarbrit [def: scald; boil] 
bridke/A [def: ugly, loathsome, nasty] 
brigade/S [f] [def: brigade] 
brik/N/D [f] [def: bridge] hengbrik/N/D [f] [def: suspension bridge]
bril/N [def: eyeglass (clothing)] zunbriln
brilyant/N [m] [def: diamond] brilyantn/A barlyant/N [m]
	brilyanteve/V/Bbrilyantevet [def: sparkle (poetic)]
brinze [def: sheep cheese]
bris{bryT}/H/N [m] [def: circumcision]
	brisnitse{bryTnitse}/S [f] [def: birth celebration for a girl] 
britve/S [def: shaving blade] 
briv/X/D [def: epistle, letter]
	blitsbriv/X/D [def: e-mail]
	libebriv/X/D [def: love letter]
briye{bry#h}/Xbriyes{bry#wT}/H [def: creation, creature]
	briyas{bry#T}/H [def: creation of]
	bruem{brw#ym}/H [def: creatures] [grammar: plural; no singular]
brodevke/S [f] brodovke/S [f] [def: wart]
brodzhe/V/T [def: wander, ramble, prowl, wade (in water)] 
	brodyane/S [m/f] [def: vagabond, vagrant, tramp, hobo] 
brok/V/Bgebrokn [def: crumble] /Garayn
	farbrokt/A [def: crumbled]
	gebroks [def: food cooked with crumbled matso]
	[idiom: khotsh hak un brok = no matter how hard you try]
brokat [noun] [def: brocade] /Ien
brokh/N [def: curse, fracture, disaster]
brom [m] [def: bromine (Br)] 
brone/S [f] [def: harrow] 
bronfn/S [m] [def: whiskey]
brondz [m] [def: bronze] /In
	brondzovnik/Ees [m] [def: bronze-worker] 
brontsh [m] [def: brunch]  [note: V]
broshu'r/N [def: brochure, pamphlet]
brot/V/Bgebrotn [def: roast] /Gop
broy/V/T [def: brew]  /Garum [def: disturb (with "zikh")] 
	broyer/S [m] [def: brewer] 
	broyeray'/N [f] [def: brewery] 
	broyz/N [f] [def: brewery] /Dbrayz
broykh/V/T [def: need (German)] [usage: doubtful admissability]
	[grammar: er broykh]
	farbroykh/V/Bfarbroykht [def: need (German)] 
	gebroykh/N [m] [def: need; use]
		gebroykher/N [m] [def: consumer]
broyn/A [def: brown]
	broyn/N [m] [def: brown] 
	farbroyn/V/Bfarbroynt [def: toast]
	opgebroynt/A [def: browned] 
broyt/N [n] [def: bread]
	betlbroyt [n] [def: handout (charity)]
	knoblbroyt [n] [def: garlic bread]
	mandlbroyt [n] [def: almond bread]
	ovntbroyt [def: evening meal, supper]
	[idiom: gefrisht broyt = French toast]
broyz/V/T [def: act angrily] /Goyf
brud [m] [def: filth] /Iik [def: filthy] 
bruder/Xbrider [m] [def: brother]
	bruderl/Xbriderlekh [n] [def: little brother]
	tsvilingbruder/Xtsvilingbrider [def: twin]
	bridershaft/N [f] [def: brotherhood]
	briderlekh/A [def: brotherly] briderlekhkayt/N [f] [def: brotherliness]
	farbridert/A [def: fraternized] 
		farbriderung/N [f] [def: friendship; fraternization] 
bruk/N [m] [def: cobblestone]
	bruki'r/V/Bbruki'rt [def: pave] /Goys
brum/V/T [def: hum] /Gtsu/Gunter brum/N [m] bruml/V/T
	horn-brumer/S [m] [def: bull horn] 
brunem/S/Xbrinemer [m] [def: well] % variant plural
brunet/N brunetin/S [f] brunetke/S [f] [def: brunette]
	brunet/A [def: brunet] 
brust/N [f] /Iik bristn [def: breast] % both plurals exist
bruta'l/A [def: brutal] 
	brutalite't/N [f] [def: brutality]
	brutalizi'r/V/Bbrutalizi'rt [def: brutalize, treat brutally] 
bshas{bSeT}/H [def: while]
bsule{bTwlh}/Xbsules{bTwlwT}/H [f] [def: virgin]
bsure{bQwrh}/Xbsures{bQwrwT}/H [f] [def: news]
bude/S [f] [def: booth, kennel]
	budke/S [def: stall, small shop]
		confesye-budke/S [f] vide{vydwy}-budke/S [f] [def: confessional] [note: V]
	budinke/S [def: tiny shed]
buduar/N [def: boudoir]
budzhet/N [m] [def: budget] 
bufet/N [m] [def: buffet]
bufloks/N [m] [def: buffalo (animal)]
buhay'/Ees [m] [def: bull (animal)] 
buk/V/T [def: bow (with "zikh")]
buk/Ees [m] [def: beech (tree)] 
buket/N [m] [def: bouquet]
bukh/Xbikher [n] /Dbikh [def: book]
	brenbukh/Xbrenbikher [n] [def: book to be burnt]
	kinderbukh/Xkinderbikher [n] [def: children's book] /Dkinderbikh 
	lernbukh/Xlernbikher [n] [def: textbook] 
	notits-bikhl/Eekh [n] [def: note pad] 
	tashnbukh/Xtashnbikher [n] [def: pocket-sized book] /Dtashnbikh
	togbukh/Xtogbikher [n] [def: diary] 
		veb-totbikhl/Eekh [n] [def: blog, weblog] [note: V]
	trelbukh/Ees [m] [def: paunch]
	verterbukh/Xverterbikher [n] [def: dictionary]
	zamlbukh/Xzamlbikher [n] [def: collection]
bukhshtab/N [m] [def: letter of the alphabet]
	bukhshteblekh/A [def: literal] 
bulan/N [def: a kind of horse]
bulbe/S [f] bulve/S [f] [def: potato]
buldog/N [m] [def: bulldog] 
buletin/N [m] [def: bulletin] 
bulke/S [f] [def: bread roll]
bulvan [def: boor, moron]
bulvar/N [def: boulevard]
bunt/A [def: colored, gaudy] 
bunt/N [def: rebellion, mutiny] /Iarish [def: rebellious, mutinous] 
	bunteve/V/T [def: stir (to rebellion), rebel (with "zikh")] 
	buntovnik/Ees [def: rebel, mutineer] 
bunt/N [m] [def: bundle, bunch] /D
burbl/V/T [def: bubble] 
bure/S [f] [def: gale]
	bure/V/T [def: gust] /Goyf [def: anger]
burg/N [def: palace; chateau; fort] 
burik/Ees [def: beet] % not burek
	borek/N [m] [def: beet] % variant
burke/S [def: parka (clothing)]
burtshe/V/T buratshe/V/T [def: growl, grumble]
	burtsh/N [m] [def: growl; rumble] 
burzhua'/Een [m] [def: bourgeois] /Iz
	burzhu'i/N/Ees [def: bourgeois] [usage: contemptuous]
	burzhuazye/S [f] [def: bourgeoisie] 
busheve/V/T [def: oppress]
bushl/Een [m] [def: stork]
bushl/Een [m] [def: bushel (measure: American)]
busi'r/V/Bbusi'rt [def: bus (transitive)] 
buzem/S [m] [def: bosom]
	[idiom: leygn nit keyn feygelekh in buzem = be practical]
byografye/S [f] [def: biography]
	oytobyografye/S [f] [def: autobiography]
	byografish/A [def: biographical] 
		oytobyografish/A [def: autobiographical]
byologye [f] [def: biology]
	byologish/A [def: biological]
	byolog/N [m] [def: byologist]
	byonish/A [def: bionic] [note: V] 
byuletin/N [m] [def: bulletin (English)] 
byuro [n] [def: office; desk] /Dbyurokh byurke/S [f] [def: desk] 
byust/N [m] [def: bust] 
daf{df}/Xdapem{dpym}/H [m] [def: page]
dagesh{dgS}/H [def: emphasis, punctuation mark]
dakh/Xdekher [m] [def: roof]
	fardekhtik/V/Bfardekhtikt [def: cover, hide a secret, accuse]
	opdakh/N [m] [def: shed; shelter, refuge] 
	valddakh/Xvalddekher [m] [def: forest canopy] 
dakht/V/T [def: appear, seem (with "zikh")] /Goys
	dukht/V/T [def: appear] /Goys % variant base
	badakht/A [def: calm ??] % geredt badakht un ruik
	fardakht/N [m] [def: suspicion] [usage: deprecated]
	gede'khenish/N [n] [def: memory; remembrance, recollection] 
	[idiom: nisht far dir gedakht = it shouldn't happen to you]
daled{dʼ}/H [def: letter Dalet]
dales{dlwT}/H [m] [def: poverty]
dalfn{dlfwn}/Xdalfonem{dlfwnym}/H [m] [def: poor man] [def: usage: humorous] 
dam/V/T [def: damn]
dam{dm}/H [m] [def: blood] /L|v [def: and blood]
dambe/S [f] [def: dam, dike] 
dame/S/N [f] [def: lady]
damf/N [m] [def: steam] % plural very unusual
	damfer/S [m] [def: steamer] 
damke/S [f] [def: checkers (game, object)] 
dan [def: then]
dank/V/T [def: thank] /Gop/Gopet
	badank/V/Bbadankt [def: thank]
	fardank/V/Bfardankt [def: thank]
	dank/N [m] [def: thanks; gratitude]
		dankbar/A [def: thankful, grateful]
		dankbarkayt/N [f] dankshaft/N [f] [def: gratitude]
		umdankbar/A [def: ungrateful]
danostshik/Ees [m] [def: informer (Russian)] 
dar/K [def: thin; lean]
	dar/V/T [def: be thin] /Goys/Gop fardart/A
dardaki{drdky}/H [def: grammar (with "- melamed")]
darf/V/T badarf/V/Bbadarft [def: need, require]
	badarf/N [m] [def: need] 
	bade'rfenish/N [n] [def: need]
darmoyed{darmo|yed}/N/Ees [m] [def: parasite, sponger] 
dashek/Xdashkes [m] [def: cap visor] % Harduf has dashik/Ees
date/S [f] [def: date] 
	dati'r/V/Bdati'rt [def: set a date] /Gforoys
	datirung/N [def: dating] 
dati'v/N [m] [def: dative (grammar)] /A
datn [def: data]
datshe/S [f/n] [def: cottage; summer house]
	datshnik/Ees [def: someone living in a summer house] 
davke{dvk#}/H [def: actually; only so; necessarily]
davn/V/T [def: pray] /Gop/Gunter davner/S
davolno [interj] [def: enough! (Russian)] 
dayge{d#gh}/Xdayges{d#gwT}/H [f] [def: worry]
	dayge{d#gh}/H/V/T 
	fardayget{fard#ght}/A [def: worried] 
	[idiom: nit dayn bobes dayge = none of your business]
	[idiom: dayge nisht = never mind; don't go out of your way]
daytsh/N [m/n] [def: German] altdaytsh/N [m/n] [def: Old German]
	daytshmerish/A [def: imitation of German]
	daytshmerizm/N [m] [def: imitation of German] 
de/Een [m] [def: the letter D] 
debati'r/V/Bdebati'rt [def: debate] 
	debate/S [f] [def: debate] 
debyu't/N [m] [def: debut] 
dediki'r/V/Bdediki'rt [def: dedicate] dedikatsye/S [f] [def: dedikation]
defektiv/A [def: defective]
defili'r/V/Bdefili'rt [def: march past, parade] 
defini'r/V/Bdefini'rt [def: define] definitiv/A [def: definitive] 
	definitsye/S [f] [def: definition]
defitsi't/N [m] [def: deficit] % Harduf 
degenera't/N [m] [def: degenerate] 
degradi'r/V/Bdegradi'rt [def: degrade]
dehayne{dhAnw}/H [def: namely]
dek/N [m] [def: ship's deck] tsvishndek/N [m]
dek/V/T [def: cover] /Gop/Gtsu/Goyf/Goys/Giber
	antdek/V/Bantdekt [def: uncover; discover]
		antdekung/N [f] [def: discovery] 
	fardek/V/Bfardekt [def: cover]
	badek/V/Bbadekt [def: cover, veil]
		badekns [def: veiling the bride]
	dek [f] dekung/N [f] [def: cover; blanket]
		/Ddek [def: cover; lid] % Harduf 
		oygndekl/Eekh [n] [def: eyelid]
dekade'nts [f] [def: decadence] dekade'nt/A [def: decadent] 
dekan/N [m] [def: dean] 
dekhe/V/T [def: gasp, breath hard] /Goyf [def: finish panting] 
	dekh/N [m] [def: gasp, breath] 
	[idiom: khapn a dekh = catch one's breadth]
deklami'r/V/Bdeklami'rt [def: declare; recite]
	deklamatsye/S [f] deklaratsye/S [f] [def: declaration] 
deklari'r/V/Bdeklari'rt [def: declare] 
	deklarirung/N [f] [def: declaration] 
deklinatsye/S [f] [def: declination; declension]
	deklini'r/V/Bdeklini'rt [def: decline] % Harduf 
dekolte' [def: V-necked] [grammar: indeclinable adjective]
dekor/N [m] [def: decor] dekoratsye/S [f] [def: scenery (drama); decoration]
	dekori'r/V/Bdekori'rt [def: decorate] % Harduf 
dekre't/N [m] [def: decree] % Harduf 
delega't/N [m] [def: delegate] delegatsye/S [f] [def: delegation] 
delfi'n/N [m] [def: dolphin (animal)] 
delika't/A [def: delicate]
demago'g/N [m] [def: demagogue] /Iish [def: demagogic]
	demagogye/S [f] [def: demagogy] 
demisyoni'r/V/Bdemisyoni'rt [def: resign] 
demb/N [m] [def: oak (tree)]
demokratsye/S [f] demokratye/S [f] [def: democracy]
	demokra't/N [m] [def: democrat] % Harduf 
	demokratish/A [def: democratic] 
	demokratizatsye/S [f] [def: democritization] 
	demokratizi'r/V/Bdemokratizi'rt [def: democratize] 
demonizi'r/V/Bdemonizi'rt [def: demonize] 
demonstratsye/S [f] [def: demonstration (English)]
	demonstri'r/V/Bdemonstri'rt [def: demonstrate] 
dempik/A [def: damp] % Harduf 
den [def: in that case]
deneshke/S [def: money (Russian)]
denk/V/T [def: opine; think]
	gedenk/V/T [def: remember] ondenk/V [def: memory]
		fargedenk/V/Bfargedenkt [def: commit to memory] 
		fargedenklekh/A [def: memorable] 
	gedank/N [m] [def: thought; idea]
	gedenk/N [def: memory] /Ilekh [def: memorable]
	gedekhtnis [n] [def: memory; remembrance, recollection] [usage: inadmissable]
	denker/S denkerin/S [def: intellectual]
	denkmol/Xdenkmeler [m] [def: monument]
denominatsyone'l/A [def: denominational (religious)] 
	umdenominatsyone'l/A [def: non-denominational] 
denti'st/N [m] dentistke/S [f] [def: dentist] % Harduf 
denuntsye/S [f] [def: denunciation] 
departme'nt/N [m] [def: department (esp. US government)] 
depesh/N/S [f] [def: telegram] % both plurals exist
	depeshi'r/V/Bdepeshi'rt [def: send a telegram]
deporti'r/V/Bdepo'rtirt [def: deport] deportatsye/S [f] [def: deportation]
deputat/N [def: deputy, elected member (Russian)] 
derekh{drx}/Xdrokhem{drxym}/H [def: path]
	/Lb [def: on the road]
	/Lh [def: the road]
	/LK [def: like the way]
	madrekh{mdryx}/H [m] [def: guide]
	moyre_{mwrh}-derekh{drx}/H [m] [def: guide; role model] 
	derekh{drx}-agev{agB} [interj] [def: by the way] 
	derekh{drx}-erets{#rc} [def: respect, esteem]
derfarung/N [f] [def: experience (German)]
	derfarn/A [def: experienced] derfarnkayt/N [f] [def: experience]
	umderfarn/A [def: inexperienced] 
derfolg [m] [def: success (German)] /Iraykh
derivat/N [def: derivative] 
derkutshe/V/Bderkutshet [def: bother, pester]
derkvik/V/Bderkvikt [def: refresh; delight]
	derkvi'kenish/N [n] derkvikung/N [f] [def: refreshment] 
derlang/V/Bderlangt [def: hand over]
derober/V/Bderobert [def: conquer] [usage: inadmissable]
	deroberung/N [f] [def: conquest] [usage: inadmissable]
dershnap/V/Bdershnapt [def: sense; detect] 
despot/N [m] [def: despot]
desyatine [f] [def: tenth part (land measure)] 
deta'l/N [m] [def: detail] % Harduf 
detekti'v/N [m] [def: detective] % Harduf 
detsember/S [m] [def: December]
detsidi'r/V/Bdetsidi'rt [def: decide]
deye{deh}/Xdeyes{dewT}/H [f] [def: opinion; knowledge; influence]
	/Lb [def: of the opinion]
	yediye{ydyeh}/Xyediyes{ydyewT}/H [f] [def: news]
	moydiye{mwdy|e}/H [def: inform (with "zayn")]
	kidue{Kydue}/H [def: as is well known]
	das{deT}/H [m] [def: religion, opinion of] /Ll
	khilukey{Hylwky}-deyes{dewT} [def: differences of opinion] 
deyet [f] [def: diet] dyete/S [f]
	[idiom: haltn deyet = go on a diet]
deyver/V/T /Goys [def: emaciated]
dezerti'r/V/Bderzerti'rt [def: desert] dezerti'r [m] [def: deserter]
di dos dem der [article] [def: the, this]
	der [article] [def: the, this]
		derfa'r [adv] [def: therefore]
		derfu'n [adv] [def: thence]
		dervegn [adv] [def: concerning]
		derno'kh [adv] [def: thereafter; afterwards]
		derba'y [adv] [def: near]
		dermi't [adv] [def: with; herewith]
		dertsu' [adv] [def: in addition; thereto]
	destvegn [adv] [def: nonetheless (with "fun -")]
		fundestvegn [def: nonetheless, nevertheless] 
	nokhdem [def: afterward]
	fardem [def: before]
	oyserdem [def: besides]
diabolish/A [def: diabolic] 
diagno'z/N [m] [def: diagnosis] 
	[idiom: shteln a diagnoz = diagnose]
diber{dybwr}/Xdiburem{dybwrym}/H [m] [def: word] /Lh [def: the word]
	dibraye{dbry#}/H [def: commandments (Aramaic)]
	divrey{dBry}/H [def: words of]
dibuk{dybwk}/H [def: spirit possessing someone else's body]
	dveykes{dBykwT}/H [def: mystical attachment]
	fardveyket{fardByket}/A [def: mystically attached]
		fardveyketkayt{fardByketkayt}/N [f] [def mystical attachment]
difterit difteriten [m] [def: diphtheria (disease)]
digital/A/Iish [def: digital] digiziti'rt/A [def: digitized] 
dik/A [def: broad; thick] /Ilekh
dikdek{dykdwk}/H [m] [def: grammar; detail]
	medakdek{mdkdk}/Xmedakdeykem{mdkdkym}/H [m] [def: punctilious person]
dikh/N [m] [def: thigh] % Harduf 
dikhe/V/T [def: breathe (Russian)] 
dikhter/S [m] dikhterin/S [f] [def: poet] dikhtung/N [f] [def: poetry]
	dikht/V/T [def: write poetry] /Giber [usage: doubtful admissability]
	badikht/V/Bbadikht [def: write poetry] 
dikti'r/V/Bdikti'rt [def: dictate]
	dikta't/N [m] [def: order; dictation] diktator/N [m] [def: dictator]
		diktatu'r/N [f] [def: dictatorship] % Harduf 
	diktsye/S [f] [def: diction] 
dil/N [m] [def: floor]
dileme/S [f] [def: dilemma] % Harduf 
dileta'nt [m] /Iish [def: diletant]
dimensye/S [n] [def: dimension]
dime'nt/N [m] [def: diamond]
diminutiv/A [def: diminutive]
dimyen{dmywn}/Xdimyoynes{dmywnwT}/H [def: appearance, falsehood] /Lh
din/A [def: thin] /Iik /Iink
din/V/T [def: serve] /Goys
	fardin/V/Bfardint [def: earn] /Gop
		fardiner/S [def: bread-winner]
		fardinst/N/D [n] [def: earnings]
	badin/V/Bbadint [def: serve, wait on] badinung/N [f] [def: service]
	dinst/N [f] [def: female servant] folksdinst/N [f]
	diner/S [m] dinerke/S [f] [def: server]
	dineray'/N [n] dinung/N [f] [def: service]
	getsndiner/S [def: idol worshiper]
	dinst/N [n] [def: service] 
		got|sdinst [def: prayer] 
		militer-dinst [def: military service] 
		[idiom: tsu emetsns dinst = at someone's service]
dinamik [f] [def: dynamics (subject); dynamics (music)] 
	dinami'zm/N [m] [def: dynamism] 
	aerodinamik [f] [def: aerodynamics (subject)] 
	byodinamik [f] [def: biodynamics (subject)] 
	elektrodinamik [f] [def: electrodynamics (subject)] 
	hidrodinamik [f] [def: hydrodynamics (subject)] 
	termodinamik [f] [def: thermodynamics (subject)] 
dinami't [m] [def: dynamite] % Harduf 
dinamo [m] [def: dynamo] 
dinastye/S [f] [def: dynasty] % Harduf 
ding/V/Bgedungen [def: hire, rent; haggle, dicker (with "zikh")] /Goys
	farding/V/Bfardungen [def: rent out]
	di'ngenish/N [def: dickering]
	bading/V/Bbadingt [def: agree on price]
	bading/N [m] badingung/N [def: condition]
	umbadingt/A [def: untouched]
	forbading/N [m] [def: precondition] 
dinstik/N [m] [def: Tuesday]
dinye/S [f] [def: melon] dinke/S [f] [def: cantaloupe]
diplo'm/N [m] [def: diploma] diplome/S [f] 
diploma't/N [m] [def: diplomat] /Iish [def: diplomatic] % Harduf 
	diplomatye [f] [def: diplomacy] % Harduf 
dire{dyrh}/Xdires{dyrwT}/H [f] [def: apartment]
diregi'r/V/Bdiregi'rt [def: direct]
dire'kt/A [def: direct]
	direktor/N/S [m] direktorin/S [f] [def: director]
	direkti'v/N [m] [def: order] 
disertatsye/S [f] [def: dissertation] % Harduf 
dishl/N [m] [def: wagon shaft; wooden shaft for spanning horses]
disk/N [m] [def: disk (computer)] disket/N [def: diskette]
	kompaktdisk/N [def: compact disk (CD)]
	kompaktl/N [def: compact disk (CD)]
	kompaktlnik/Ees [m] [def: portable compact disk player] [note: V] 
diskote'k/N [f] [def: discotheque] % Harduf 
diskret/A [def: discreet]
diskrimini'r/V/Bdiskrimini'rt [def: discriminate]
	diskriminatsye/S [f] [def: discrimination]
diskuti'r/V/Bdiskuti'rt [def: discuss] diskusye/S [f] [def: discussion]
disona'nts/N [m] [def: dissonance; discord] 
dispozitsye/S [f] [def: inclination, disposition; utilization, disposition] 
	predispozitsye/S [f] [def: predisposition] 
disprosyum [m] [def: dysprosium (Dy)] 
disput/N [def: dispute]
distants/N [f] [def: distance]
distsipli'n/N [f] [def: discipline] % Harduf 
	distsiplini'r/V/Bdistsiplini'rt [def: discipline] % Harduf 
diva'n/N [m] [def: sofa; carpet]
divizi'r/V/Bdivizi'rt [def: divide] divizye/S [f] [def: division (military)]
din_{dyn}/Xdiynem{dynym}/H [m] [def: judgement, law]
	/Lh/Lb
	beyzdin{byT-dyn}/H [n] [def: court]
	dayen{dAn} [def: religious judge]
dizhu'r/N [m] [def: tour of duty] 
	dizhuri'r/V/Bdizhuri'rt [def: be on duty] 
	dizhurn/A [def: on-duty] 
dlonye/S [f] [def: palm of hand]
dno/N [m] [def: bottom of container]
do /Izik /Iik danen [def: here]
	dosdozike [adj] derdoziker [adj] didozike [adj] [def: this very]
	demdozikn [adj] [def: this very]
	doikayt/N [f] [def: presence, existence] 
dobu've/V/Bdobu'vet dobive/V/Bdobivet [def: get, obtain, reach] 
	[idiom: dobuven dem leber = annoy, torment]
dokh [def: of course; yet, still]
dok/N [m] [def: dock, pier] 
dokter/Xdoktoyrem{doktoyrym} doktorshe/S [f] [def: doctor (occupation)]
	doktorye [def: the science of medicine]
	[idiom: zayn a doktor far zikh = have a private medical practice]
	doktor/N [m] [def: doctor (holder of title)] 
doktrine/S [f] [def: doctrine] 
dokume'nt/N [m] [def: document] /Ia'l
	dokumenti'r/V/Bdokumenti'rt [def: document] 
dolar/N [m] [def: dollar (currency)]
	toler/S [m] [def: dollar (currency)] 
dolete/S [f] [def: chisel (tool)] % Harduf
dolye/S [f] [def: lot, fate] 
domino/S [m] [def: domino (game piece)] % Harduf
donershtik/N [m] [def: Thursday]
dor{dwr}/Xdoyres{dwrwT}/H [m] [def: generation] /Lh /Idik
dorayso{d#wreyT#}/H [def: ritual law with Biblical support]
dorem{drwm}/H [m] [def: south] /Idik
dorf/Xderfer [n] /Iish [def: village]
	/Dderf [n] [def: hamlet]
dorn/Xderner [m] [def: thorn]
dorobe/V/Bdorobet [def: reach through effort (with "zikh tsu") (Polish)] 
dorsht/V/T [def: thirst]
	dorsht/N [m] [def: thirst] /Iik [def: thirsty]
	blutdorshtik/A [def: bloodthirsty, ferocious]
	% variant spelling:
	dursht/V/T [def: thirst] dursht/N [m] [def: thirst] /Iik
		blutdurshtik/A [def: bloodthirsty]
dort /Iik dortn [def: there]
dos/V/T [def: defecate (slang)] % Harduf
dotse'nt/N [m] [def: docent] 
dover{dBr}/H [def: thing]
	doverakher{dBr-#Hr}/H [def: unpleasant thing; pig; scoundrel]
doyer/V/T [def: last]
	gedoyer/V/T [def: last; continue]
		doyer/N [m] gedoyer/N [m] [def: duration]
	langdoyerndik/A [def: boring]
	badoyer/V/Bbadoyert [def: regret] badoyerung/N [f] [def: regret]
doyfek{dwfk}/H [m] [def: hit, pulse (with "zayn")]
doykhek{dwHk}/H [m] [def: shortage] 
	dakhkes{dHkwT} [n] [def: need] 
	doykhek{dwHk}/H [m] [def: urge (with "zayn")] 
doyme{dwmh}/H [adj] [def: similar] % indeclinable
	/LK [def: similar] ukedoyme{|wKdmh} [def: and similar] 
	dami{dmy}/H [def: similar]
doyne/S [def: kind of Gypsy melody/dance] 
doze/S [f] [def: dose (medicine)] 
dozore/S dozorts/Ees [m] [def: overseer, guardian, inspector] 
	dozorshtibl/Eekh [n] [def: warden's house] 
dr [m] [def: Dr.]
drab [m] [def: a jerk] drabke/S [f] [def: slut] 
drake/S [def: fight]
drame/S [f] [def: drama] dramatish/A [def: dramatic]
	folksdrame/S [f] [def: folk drama] 
	dramaturg/N [m] [def: playwright] 
	dramatizi'r/V/Bdramatizi'rt [def: dramatize] 
drape/V/T [def: scratch; clamber (with "zikh")] /Goys
drastish/A [def: drastic]
dray [def: 3] drit/A [def: 3rd] dritik/A [def: tertiary]
	dritl [def: 1/3] dritns [def: 3rd]
	drayer/D [def: three-unit money]
	drayek/N [m] [def: triangle]
	draytsn [def: 13] /It draytsntl [def: 1/13]
	draysik/A [def: 30] /Ist draysikstl [def: 1/30]
	drithalbn [def: 2.5]
drek [m] [def: dirt, excrement, slut, weak-hearted person]
	/Iik [def: dirty] 
dreml/V/T [def: nap] /Gayn dreml/N [m]
	driml/V/T /Gayn [def: nap] % variant
	antdriml/V/Bantdrimlt [def: go to sleep]
dreng/V/T [def: wring] /Goys
	drenger/S [m] [def: wringer]
	drang/N [m] [def: desire, impulse; striving] 
	gedrang/N [n] [def: crowd, throng; congestion]
dresh/V/Bgedroshn [def: thresh] /Goys
	dresher/S [def: thresher]
dretl/N/Eekh [n] [def: staple]
	tsondretl/Eekh [def: braces (dentistry)] [note: V]
drey/V/T [def: twirl; turn; twist]
	/Gavek/Goys/Gtsunoyf/Gum/Giber/Gop/Gon/Gayn/Garoys
	/Garum [def: twirl; hang out (with "zikh")] 
	/Garayn [def: Entangle]
	/Ddreyd [def: top (toy)]
	fardrey/V/Bfardreyt [def: confuse] fardrey'enish/N [def: confusion]
	tsedreyt/A [def: confused]
	dreyer/S [def: twirler, confuser; swindler]
		drey'enish/N [def: twirling, confusion]
		kopdrey'enish/N [def: flattery, impossible task, disorder]
	gedrey [n] [def: swirl (mixture)] 
	[idiom: dreyen mit dem hintl = wiggle the behind]
dreyf/V/T [def: drift] 
dreyst/K [def: courageous, bold]
	dreystkayt/N [f] [def: courage, boldness] 
dribl/V/T [def: unravel]
drige/V/T [def: kick] 
drinde/S [f] [def: a kind of horse] 
drik/V/T [def: squeeze; press; oppress]
	/Garoys/Gtsu/Garayn/Gunter/Gtsuzamen/Gtsunoyf
	/Goys [def: express]
	badrik/V/Bbadrikt [def: squeeze, oppress]
		badrikung/N [f] [def: squeezing, oppression]
	fardrik/V/Bfardrikt [def: squeeze]
	oysdriker/S [def: expresser] oysdriklekh/A [def: expressive]
	unterdrik unterdrikung/N [f] [def: oppress]
	drikung/N [f] [def: stress; pressure] drik'enish/N [n] [def: pressure]
		svive{sByBh}-drikung/N [f] svive{sByBh}-druk/N [f] [def: peer pressure] [note: V] 
dring/V/Bgedrungen [def: argue, claim; deduce (with "fun"); penetrate]
	/Garayn/Garoys/Gdurkh/Goys
	arayndringer/S [m] [def: deducer]
	dringlekh/A [def: urgent; penetrating] % Harduf
		arayndringlekh [def: penetrating] 
	durkhdringlekh/A [def: implied]
	dringevdik/A [def: penetrable] 
	oysdringung/N [f] [def: deduction] 
drivl/-drivl oysgedrivlt/A [def: worn out]
driz/N [f] [def: gland] /D
	shilddriz/N [f] [def: thyroid gland] 
dro/V/T [def: threaten; flutter]
	badro/V/Bbadrot [def: threaten] 
	droung/N [f] [def: threat] 
drobne/A [def: tiny] drobnink/A
	dribne/A [def: tiny] dribnink/A % variant 
drong/N/Xdreng/Xdrenger [m] [def: pole; bar]
drosh{drS}/H/D [m] droshe{drSh}/Xdroshes{drSwT}/H [f] [def: homily, sermon]
	darshn{drSn}/Xdarshonem{drSnym}/H [def: preacher] 
	darshen{drSen}/V/T [def: sermonize; preach]
	midresh{mdrS}/H [m] [def: Rabbinic legend]
		medresh{mdrS}/Xmedroshem{mdrSym}/H [m] [def: Rabbinic legend] 
		beysmedresh{byT-mdrS}/H [def: house of study] /Idik
		midreshnik{mdrSnik}/Ees [def: ??]
droshke/S [f] [def: droshky (vehicle)] 
drot/N [m/n] [def: wire] shtekhldrot [m] [def: barbed wire]
droyb/D [def: poultry innards] % includes heads, intestines
drozd/N [m?] [def: thrush (bird)] 
drozhke/S [f] [def: 3-wheel horse-drawn carriage]
druk/V/T /Gayn/Garoys/Gayn/Gop/Giber [def: press; print]
	druker/S [m] [def: printer] 
		drukeray'/N [f] [def: printing shop] 
	druk/N [m] [def: print; pressure] 
		blutdruk/N [m] [def: blood pressure] 
	oysdruk/N [def: expression]
	ayndruk/N [def: impression]
		ayndruksful/A [def: impressive] 
	druker/S [def: printer] drukeray'/N [def: printing house]
dubnyum [m] [def: dubnium (Db)] 
dudl/V/T [def: play badly (instrument), cheat] 
	tsedudl/V/Btsedudlt [def: confuse] 
due'l/N [m] [def: duel]
due't/N [m] [def: duet]
duft/N [def: fragrance] royznduft/N
dugme{dwgmh}/Xdugmes{dwgm#wT}/H [f] [def: example]
dukat/N [m] [def: ducat]
dul/V/T [def: confuse; annoy]
	tsedul/V/Btsedult [def: confuse]
	fardul/V/Bfardult [def: stun] 
	duler [def: obfuscator, fool]
dume [def: town hall] 
duner/V/T [def: thunder]
	duner/N [m] [def: thunder] /Idik [def: thunderous]
	geduner/S [n] [def: thunderstorm] 
	[idiom: a duner iz mir = woe is me]
duplikat/A [def: duplicate]
	dupliki'r/V/Bdupliki'rt [def: duplicate] 
dupye/S [f] [def: vagina (taboo)] 
durkh/P durkhet [adv] adurkh/P adurkhet [adv] [def: though]
	derdurkh [adv] [def: thereby] 
	durkhoys [adv] [def: throughout]
	durkhdem [adv] [def: thereby]
dushne/A [def: stuffy]
	dushe/V/T [def: suffocate (Russian)] 
dutske/S [f] [def: goad, shove] 
dvar{dBr}/Xdvorem{dBrym}/H [m] [def: word, thing]
dvorets dvortses [def: palace]
dyale'kt/N [m] [def: dialect] /Iish
	hoyptdyale'kt/N [m] [def: principal dialect] 
	iberdyalektish/A [def: trans-dialect] 
dyalo'g/N [m] [def: dialog]
dyaspore/S [f] [def: Diaspora] 
dzhet/N [m] [def: jet airplane]
dzhez [m] [def: jazz]
/Xdzhins /Xbloydzhins [def: jeans (clothing)] [note: V]
dzhobe/V/T [def: peck] % Harduf 
e/Een [m] [def: the letter E] 
editorya'l/N [m] [def: editorial (article)] 
	editorye'l/A [def: editorial] 
ef/N [m] [def: the letter F] 
efekt/N [m] [def: effect] /Ii'v
	bay'efekt/N [m] [def: side effect] 
	benzin-efekti'v/A [def: fuel-efficient] [note: V] 
efn/V/T [def: open] /Goyf/Gfunander
	tseefn/V/Btseefnt [def: open]
	derefn/V/Bderefnt [def: open]
	farefentlekh/V/Bfarefntlekht [def: publish]
	ofn/K [def: open]
		ofenerheyt [adv] [def: openly] 
		ofnkayt/N [f] [def: openness] 
	efntlekh/A [def: public] efntlekhkayt/N [f] [def: publication]
		farefntlekh/A [def: public]
	efenung/N [def: opening]
efsher{#fSr}/H [def: maybe]
egalita'r/A egalitarish/A [def: egalitarian] 
ego [def: ego]
	egoi'st/N [m] [def: egotist] /Iish [def: egotistical]
	egoi'zm [m] [def: egoizm] 
	egofo'b/N [m] [def: self-hater] 
ek/N [m] [def: border, tail] /Iik
	ek/V/T [def: end (with "zikh")]
	drayek/Iik [m] [def: triangle]
	hartnekik/A [def: stubborn]
	grodekik/A [def: square-cornered]
ekber/V/T [def: bother]
ekdish/N [m] [def: scorpion (animal)]
ekho/S [m] [def: echo] % Harduf
ekht/A [def: true to form]
ekipazh/N [def: equipment (French)]
ekl/V/T [def: disgust] [usage: doubtful admissability]
	ekldik/A [usage: doubtful admissability]
	eklhaftik/A [def: disgusting] [usage: inadmissable]
ekologye/S [f] [def: ecology] ekologish/A
ekonomye/S [f] [def: economy] ekonimik [def: economics]
	ekonomish/A [def: economic, economical] ekonom/N [def: accountant]
	ekonomi'st/N [m] ekonomistke/S [def: economist]  % Forwards
ekran/N [m] [def: screen]
eksisti'r/V/Beksisti'rt [def: exist] eksistents [f] [def: existence]
eksklusi'v/A [def: exclusive] 
ekskursye/S [f] [def: excursion] 
eksmisi'r/V/Beksmisi'rt [def: evict] 
	eksmisye/S [f] [def: eviction] 
ekspeditsye/S [f] [def: expedition]
eksperiment/N [m] [def: experiment]
	eksperimentalizm [m] [def: experimentalism] 
ekspert/N [m] [def: expert] /A
eksplodi'r/V/Beksplodi'rt [def: explode] 
ekspona't/N [m] [def: exhibit (object)] 
eksporti'r/V/Beksporti'rt [def: export] 
	ekspo'rt/N [m] [def: export] 
ekstaz/N [n] ekstaze/S [f] [def: ecstacy]
ekstempori'r/V/Besktempori'rt [def: improvise, jam (music)] [note: V] 
ekstre [adv] extra [adv] [def: extra]
ekstrem/N [f] [def: extreme] ekstrem/A [def: extreme] 
	ekstremi'st/N [def: extremist] % Forwards
ektselents [f] [def: excellency]
ektses/N [def: excess]
ekvator [m] [def: equator] 
ekvivalent/A [def: equivalent]
ekzamen/S [m] [def: examination, test]
	ekzamini'r/V/Bekzamini'rt [def: examine] 
ekzisti'r/V/Bekzisti'rt [def: exist] 
	ekziste'nts [f] [def: existences] % Forwards
ekumenish/A [def: ecumenical] 
ekzekutiv/A [def: executive] /N ekzekutsye/S [f] [def: execution]
ekzemplar/N [m] [def: copy]
ekzotish/A [def: exotic]
elastish/A [def: elastic] % Harduf
	elastishkayt/N [f] [def: elasticity] 
ele_{#l#}/H [def: rather] % must disambiguate from -ele diminutive ending
elebe'le etsh-petsh [interj] [def: so there! (expression of triumph)] 
elef{#lf}/Xalofem{alfym}/H [def: thousand] /Lb
elega'nt/A [def: elegant, upscale] /Iish
elegye/S [f] [def: lament (song)] 
elehey [adv] lehey [adv] [def: as if, as though, for instance]
elektron/N [m] [def: electron] /Iish
	elektre elektrye [def: electricity] elektrish/A
	elektriker/S [m] [def: electrician] 
	elektronik [f] [def: electronics (subject)]
		mikroelektronik [f] [def: microelectronics (subject)]
	elektrolit/N [def: electrolyte]
	elektroplatirung/N [f] [def: electroplating]
	elektro [adj] [def: electro] % uninflected, hyphenated
elel{#lwl}/H [m] [def: Hebrew month of Elul] /Idik
element/N [m] [def: element] /Ia'r/Iarish [def: primitive, elementary] 
	gruntelement/N [m]
elf [def: 11] elft/A eleft/A [def: 11th] elftl [def: 1/11]
	elftns [adv] [def: 11th] 
elimini'r/V/Belimini'rt [def: eliminate; suspend (from school)]
elit [f] [def: elite] /Iar /Iarish [def: elite] 
elnt/K [def: lonely] elntkayt/N [f] [def: loneliness]
elokven't/A [def: eloquent] eloqve'nts/N [f] [def: eloquence] 
em/En [m] [def: the letter M] 
emantsipi'r/V/Bemantsipi'rt [def: emancipate]
embargo/S [m] [def: embargo] % Harduf
emer/S [m] [def: bucket]
emeritur [f] [def: retirement] % Harduf
emes{#mT}/H [m] [def: truth] /Lb [adv] [def: truly] /Lh [m] [def: the truth] 
	emesn{#mTn} [m] [dative]
	emes{#mT}/H/A [def: true] /Idik
	[idiom: zogn dem reynem emes{#mT} = tell it like it is]
	[idiom: vos emes iz emes = when you're right, you're right]
emets emetser emetsn emetsns [def: someone or something]
emigri'r/V/Bemig'rirt [def: emigrate]
	emigrant/N [m] [def: emigrant] emigratsye/S [f] [def: emigration]
emotsye/S [f] [def: emotion] emotsyone'l/A
emune{#mwnh}/H [f] [def: faith]
en/En [m] [def: the letter N] 
end/N [f] [def: end] [usage: doubtful admissability]
ender/V/T [def: change] enderung/N [f] [def: change]
	farender/V/Bfarendert [def: change] farenderung/N [f] [def: change]
endik/V/T [def: finish]
	farendik/V/Bfarendikt [def: finish]
	endlekh/A [def: at last] onendik/A umendlekh/A [def: interminable]
energye/S [f] [def: energy] energish/A
eng/K [def: narrow] engshaft/N [f]
	geengt/A [def: closed-in] 
enkavudenik/Ees [def: member of NKVD, Soviet secret police]
enlekh/A [def: similar] umenlekh/A enlekhkayt/N [f] [def: similarity]
	[idiom: enlekh oyf = similar to]
entfer/V/T [def: answer] /Gop/Gtsurik
	entfer/S [m] [def: answer]
	farentfer/V/Bfarentfert [def: give an excuse]
		farentferung/N [f] [def: solution (to a problem)] 
	farantvortlekh/A [def: responsible]
	umfarantvortlekh/A [def: not responsible]
	farantvortlekhkayt/N [f] [def: responsibility]
	entferke/S [f] [def: answering machine] [note: V] 
entsiklopedye/S [f] [def: encyclopedia] 
entuzya'zm/N [m] [def: enthusiasm] 
	entuzyast/N/Iish [m] [def: enthusiast] 
epes [def: something] etvos [def: something (German)]
	epes [adv] [def: somewhat, very] 
	[idiom: gey tu epes = it's hopeless]
epidemye/S [f] [def: epidemic] epidemish/A
epizod/N [m] [def: episode]
epl/X/Depe [m] [def: apple]
	erdepl/X [m] [def: potato] 
epokhe/S [f] [def: epoch]
epik/N [f] epopee/S [f] [def: epic] 
	epish/A [def: epic] 
er/En [m] [def: the letter R] 
erbyum [m] [def: erbium (Er)] 
erd/N [f] [def: earth] /Iish /Ien [def: earthy]
	erdishkayt/N [f] [def: earthliness; materiality] 
	drerd [def: in the earth]
	[idiom: ikh hob dikh in drerd = go to hell]
	khuts{Hwc}-erdish/A [def: extra-terrestrial]
	untererdish/A [def: subterranean]
	[idiom: vi himl un erd = completely opposite]
ere/S [f] [def: honor (German)] [usage: inadmissable] 
	ern [adj] [def: of honor, honorable, testimonial]
		[grammar: often connected to next word]
	baer/V/Bbaert [def: honor] 
erekh{erx}/H [def: approximation] /Lb
erets{#rc}/H [f] [def: land]
	erets{#rc}-yisroyl{yQr#l} [def: land of Israel] 
erev{erB}/H [def: evening, day before; be responsible]
ergets [def: somewhere]
	[idiom: ergets-vu = somewhere]
	[idiom: nit in ergets = nowhere]
erlekh/K [def: honest, upright, in good faith]
	erlekhkayt/N [f] [def: honesty]
	umerlekh/A [def: dishonest, in bad faith]
	umerlekhkayt/N [f] [def: dishonesty, bad faith] 
ern [prefix] [def: of honor, honorary; testimonial; honorable] 
	ernhaftik/A [def: honorable] 
ernst/A [def: earnest]
erodrom/N [m] [def: airport] 
eropla'n/N aeropla'n/N ayropla'n/N [m] [def: airplane]
erotish/A [def: erotic]
	erotishkayt/N [f] erotitsizm/N [m] [def: eroticism] 
erve{ervh}/Xerves{ervwT}/H [def: genitalia; sexual immodesty; nakedness; shameful behavior] 
	arayes{erywT}/H [def: forbidden sexual relations or partners; sinful lust] 
es/En [m] [def: the letter S] 
es/V/Bgegesn [def: eat] /Gop/Gayn/Goyf/Giber/Gon
	deres/V/Bderesn [def: consume; bore; annoy]
	esn/S [m] [def: food] 
		fa'rtik-esn [m] [def: take-out food] 
		gi'khesn [m] [def: fast food] [note: V]
			gi'kheseray' [f] [def: fast food restaurant] [note: V]
esesovets/N [m] [def: SS officer (WWII)] 
esey/N [m] [def: essay]
	esei'st/N [m] eseyi'st/N [m] eseistke/S [f] eseyistke/S [f] [def: essayist] 
eshelon [m] [def: echelon]
esik [def: vinegar] 
eskadron/N [m] skadron/N [m] [def: squad, squadron] 
eskalatsye/S [f] [def: escalation] 
	eskalator/N [m] [def: escalator] % Harduf
eskhatologye/S [f] [def: eschatology] % Forwards
	eskhatologish/A [def: eschatologic] % Forwards
esreg{#Trwg}/H [def: ethrog]
estetik [f] [def: esthetics (subject)] estetish/A [def: esthetic]
et [interj] [def: (expression of disdain)]
etabli'r/V/Betabli'rt [def: establish] 
eter [m] [def: ether] % Harduf
etik [f] [def: ethics (subject)] etish/A
etike't/N [m] [def: label, tag, ticket] /D
	heng-etike't [m] [def: hangtag] [note: V]
etimologye/S [f] [def: etymology] etimologish/A
etlekh/A [def: several]
etnish/A [def: ethnic]
etsem{ecm}/H [def: the same] /Lb [adv] [def: itself]
	atsmoy{ecmw}/H [def: himself]
evakui'r/V/Bevakui'rt [def: evacuate]
evangelye/S [f] [def: gospel]
	evangelyum [def: the Catholic Church]
	evangeliker/X [def: evangelist Christian] 
eved{eBd}/Xavodem{eBdym}/H [m] [def: slave]
	oyved{ewBd}/H [def: laborer]
eventue'l/A [def: possible, contingent] 
evenyu/S [def: avenue]
evolutsye [f] [def: evolution]
evyen{#Bywn}/Xevyoynem{#Bywnym}/H [m] [def: poor person]
ey/Xeyer eyele/Xeyelekh/Xeyerlekh [def: egg] eyen/A % irregular
	[idiom: nit vert keyn oysgeblozn ey = worthless]
eybik/A [def: eternal] eybikayt/N [f] [def: eternity]
	fareybik{far#eybik}/V/Bfareybikt{far#eybikt} [def: make everlasting]
	[idiom: far der eybikayt = for the record]
eyde{edh}/Xeydes{edwT}/H [m] [def: witness]
	% plural form in Hebrew used in the singular in Yiddish
	[idiom: eydes{edwT} zogn = give evidence]
	gviyes{gByT}-eydes{edwT}/H/N [m] [def: testimony, evidence] 
		[idiom: nemen gviyes-eydes{gByT-edwT} = hear testimony]
eydem/S [m] [def: son-in-law]
eyder [def: before]
eydl [def: noble] eydeler eydele eydlen eydls % irregular
	eydlkayt/N [f] [def: nobility]
eydn{edn}/H [def: Garden of Eden]
eyfer [m] [def: jealosy (German)] /Iik /Idik /Izikhtik
eygenik [def: eugenics] eygenish/A [def: eugenic] 
eygn/A [def: own] /Itlekh eygnkayt/N [f] [def: property, quality]
	eygnshaft/N [f] [def: characteristic]
	eygntum/N [n] [def: property, ownership]
	eygntlekh [adv] [def: actually] 
	eygntlimlekh/A [def: unique] eygntlimlekhkayt/N [f] [def: uniqueness] 
eykalipt/N [def: eucalyptus (tree)] 
eykho{#yxh}/H [def: Book of Lamentations]
eym{#m}/H [f] [def: mother]
	voeym{|w#m} [def: Jewish settlement (with "ir -")]
eyme{#ymh}/H/Idik [def: fear]
eyl/N [m] [def: oil] 
eyl/N [f] [def: ell, cubit] 
eyl [m] [def: ale (drink)] 
eyn eyns/D [def: one] eyntsln eyntslne/A % BUG: eyntsln/A generates forms wrong (extra e)
	eyntsik/K [def: only] 
	ersht [def: first, recently]
		/Iik [def: prime (mathematics)] 
	ersht/A ershtns [def: first] tsuersht
		[idiom: tsum alem ershtn = first of all]
	forersht/A [def: previous]
	ershtling/N [m] [def: firstborn]
	eyn/A/Itsik/Iik/Itsl [def: single] % bug: need epenthetic e before l
	eynzam/A eynzamkayt/N [f] [def: lonely] fareynzamt{far#eynzamt}/A
	eynhayt/N [f] [def: unity]
	eynik/V/T fareynik{far#eynik}/V/Bfareynikt{far#eynikt} [def: unite]
		fareynikung{far#eynikung}/N [def: unification] 
	eyntslhayt/N [f] [def: detail]
	eyner/S [def: one] eyntsikvayz [def: one at a time]
	ineynem{in#eynem} [def: together]
	altseyne/A [def: identical] 
eynikl/Xeyniklekh [n] [def: grandchild]  % no positive form
	ureynikl{wr#eynikl}/Xureniklekh{wr#eyniklekh} [n] [def: great grandchild]
eyrev{e|yrwB}/H/N [m] [def: Sabbath boundary]
eyropyum [m] [def: europium (Eu)] 
eys{eT}/H [f] [def: time]
	lesate{leT-eWh}/H [def: until then]
	mesles{meT-leT}/H [def: 24-hour period]
		meslesnvayz{meT-leTnvayz} [adv] [def: by the day] 
eysek{esk}/Xasokem{eskym}/H/D [def: business]
	far|eysek|/V/Bfar|eysek|t [def: busy]
	oysek{ewsk}/H [def: busy]
	askn{eskn}/Xaskonem{esknym} [m] [def: worker (for a cause)] 
	[idiom: poter{ptwr} an eysek{esk} = done; no need to discuss further]
eyshes{#ST}/H [def: woman of]
eyter/N [m] [def: mucus, pus]
eyts{ec}/H [m] [def: tree]
eytse{ech}/Xeytses{ecwT}/H [f] [def: advice]
	eytse{ech}/H/V/T [def: advise] 
	[idiom: haltn zikh an eytse mit emetsn = ask someone for advice]
	[idiom: bal{bel}-yoyets{ywec} = advisor]
eyver{#Br}/Xeyvrem{#Brym}/H [n] [def: limb]
	eyvrem|vayz [adv] [def: limb by limb]
eyzl/N [m] eyzlte/S [f] [def: donkey (animal)]
	moyleyzl{moyl#eyzl}/Xmoyleyzlen{moyl#eyzlen} [m] [def: mule (animal)] 
fabl/N [f] [def: fable] % Harduf
fabrik/N [f] [def: factory]
	fabrikant/N [def: manifacturer] 
	fabrikatsye/S [f] [def: fabrication, construction] 
	fabritsi'r/V/Bfabritsi'rt [def: manufacture] 
faeton/N [m] [def: phaethon carriage]
fago't/N [m] [def: bassoon] 
fakh/N [m] [def: trade, specialty, vocation, occupation; fold; shelf]
	drayfakh /Iik [def: three-fold] 
	eynfakh/A [def: simple] [usage: doubtful admissability]
		fareynfakh{far#eynfakh}/V/Bfareynfakht{far#eynfakht} [def: simplify] 
	fulfakhik/A [def: full-fledged]
	tsveyfakh /Iik [def: two-fold] 
	zibnfakh /Iik [def: seven-fold]
fakl/N [m] [def: torch] [usage: doubtful admissability]
faks [def: fax (English)]
fakt/N [m] [def: fact] /Iish /Indik [def: factual]
	faktor/N [m] [def: factor, influence]
fakultet/N [m] [def: faculty (academic)] 
fal/V/Bgefaln [def: fall; occur]
	/Gtsu/Garayn/Garop/Garunter/Gavek/Gayn/Giber/Gon/Gop/Gtsuzamen/Gum
	/Gfarbay/Giber/Goys/Garoyf/Gariber/Gfunander/Gtsunoyf
	/Gdurkh [def: fail] % Harduf
	bafal/V/Bbafaln [def: attack]
	tsufal/N [m] [def: accident, coincidence]
		tsufelik/A [def: accidental, coincidental]
	eyntslfal/N [m] [def: unique occurrence] 
	tsefal/V/Btsefaln [def: attack]
	aynfal/N [m] [def: idea]
	durkhfal/N [m] [def: failure] % Harduf
	feldznfal/N [m] [def: rockfall] 
	onfal/N [m] [def: attack]
		onfaler/S [m] onfalerin/S [f] [def: attacker]
	toytfal/N [m] [def: fatal incident] 
	vaserfal/N [m] [def: waterfall]
	farbayfalndikerheyt [def: in the act of falling]
	farfaln/A [def: beyond hope]
	fal/N [def: occasion] yednfals [def: anyhow, in any case]
	gefalnkayt/N [f] [def: state of having fallen]
falb/N fald/N [m/f] [def: fold of cloth; pleat]
falk/N [m] [def: hawk (bird)] 
falsh/A [def: false] falshkayt/N [f]
	falsheve/V/T [def: cheat; play/sing flat] 
	felsh/V/T felsheve/V/T farfelsh/V/Bfarfelsht [def: forge, falsify]
		felshung/N [f] farfelshung/N [f] [def: sham, forgery, falsification] 
		felsher/S [m] [def: forger] 
	falsivitsi'r/V/Bfalsifitsi'rt [def: falsify]
falye/S [f] [def: billow] 
familye/S [f] [def: family]
fan/N/Dfend [f] [def: pan]
fanatish/A [def: fanatic] fanatiker/S [m] [def: fanatic] 
	fanatizm/N [m] [def: fanaticism] 
fang/V/Bgefangen [def: catch; imprison] /Gon
	gefangenshaft/N gefe'nkenish/N [def: prison; captivity]
	gefangener [m] [def: prisoner] % Harduf 
	onfang [def: begin (German)]
		onfanger/S [m] [def: beginner]
fantazi'r/V/Bfantazi'rt [def: fantasize] fantazye/S [f] [def: fantasy]
	fantastish/K [def: fantastic]
fanto'm/N [m] [def: phantom] 
far/P [def: for, before] fara
	farik/A [def: previous]
	foroys [def: in front] fornt [def: front]
	derfar [def: therefore]
farakhte/V/T [def: be disgusted] farakhtung/N [f] [def: contempt]
faran/Ien/Iendik [def: exist]
farb/V/T [def: color] /Goys
	farfarb/V/Bfarfarbt [def: color]
	farb/N [f] [def: color]
	farbik/A [def: colorful]
		filfarbik/A [def: multicolored]
		filfarbikayt/N [f] [def: multicolored nature]
		fulfarbik/A [def: highly colored]
		fulfarbikayt/N [f] [def: highly colored nature]
		farshidnfarbik/A [def: variously colored]
	farber/S [m] farberin/S [f] [def: painter (occupation)]
	hoytfarb [def: flesh color]
farborgn/K [def: hidden] farbo'rgenish/N
farbot/V/Bfarbotn [def: forbid]
fardarb/V/Bfardorbn [def: corrupt; waste away]
	fardorbnkayt/N [f] [def: corrupt nature]
farday/V/Bfardayt fardey/V/Bfardeyt [def: digest]
	fardayung/N [f] fardeyung/N [f] [def: digestion] 
fardris/V/Bfardrosn [def: annoy; resent (reverse construction)]
	/Ilekh [def: annoying]
	fardros/N [m] [def: annoyance] /Iik [def: annoying]
	iberdrisik/A [def: tedious]
fareyn/N [m] [def: union]
farfl/Xfarfelekh [n] [def: matso crumbs (food)] 
fargenign/S [n] [def: pleasure]
farges/V/Bfargesn [def: forget]
	fargesung/N [f] [def: act of forgetting] umfargesen/A [def: remembered]
	/Dfargestnit [def: forget-me-not (plant)]
fargin/V/Bfargint [def: begrudge] farginer/S [m]
fargleyz/V/Bfargleyzt [def: glaze (eyes)]
	[idiom: fargleyzn di oygn oyf = stare at]
farheyrat/A [def: married] [usage: deprecated]
farkalotshe/V/Bfarkalotshet [def: slap together, hammer]
farklastert/A [def: ??] % applies to feet
farkove/V/Bfarkovet [def: cover in chains]
farla'g/N [m] [def: publishing house]
	farleger/S [m] farlegerin/S [f] [def: publisher] 
	farlegeray' [n] [def: publishing] 
farlang/V [def: desire]
farlegn/A [def: stale, old] 
farloymd/V/Bfarloymdt [def: slander] [usage: inadmissable]
	farloymdung/N [f] [def: slander] [usage: inadmissable]
farlyape/V/Bfarlyapet [def: become enamored of (with "zikh in"); drench]
farli'r/V/Bfarloyrn [def: lose] /Bfarlorn % both participles exist
	farlust/N [m] [def: loss] [usage: inadmissable]
farm [def: farm] farmer/S [m] [def: farmer]
farmog/V/Bfarmogt [def: possess]
	farmegn/S [n] farmog [def: possession]
	farmeglekh/A [def: well off]
	shprakhfarmog [def: ability to speak]
farnikht/V/Bfarnikhtet [def: destroy, annihilate]
	farnikhtung/N [f] [def: destruction; annihilation] 
farpute/V/Bfarputet [def: jumble] 
farshmakht/A [def: faint, languishing, prostrate]
farshnoshket/A [def: tipsy] [usage: humorous]
farshvind/V/Bfarshvundn [def: disappear]
fartaye/V/Bfartayet [def: hide, conceal] 
farteydik/V/Bfarteydikt [def: defend]
	fartey'dikung/N [f] [def: defense]
		zikh-fartey'dikung/N [f] [def: self-defense] 
	fartey'diker/S [m] fartey'dikerin/S [f] [def: defender] 
	[idiom: klal-farteydiker = public defender]
fartik/A [def: ready]
	fartik/V/T [def: prepare] /Gop [def: finish preparation] 
	farfartik/V/Bfarfartikt [def: make ready] 
	re'khtfartik/A [def: righteous, right-minded, upright] 
	[idiom: fiks-un-fartik = prepared and ready, blowed and saucered]
farts/V/T [def: pass wind]
fartsogt/A [def: very worried]
farvalter/S [m] [def: manager]
	farvaltung/N [f] [def: management] 
	aleyn-farvaltung/N [f] zelbstfarvaltung [f] [def: one-man rule] 
farvayl/V/Bfarvaylt [def: spend time] farvaylung/N [f] [def: party]
	farvaylerish/A [def: humorous]
farvyanet/A [def: wilted] 
	[idiom: vern farvyanet = wilt]
farzam/V/Bfarzamt [def: be late]
farzesn/A [def: old maid]
fas/Xfeser /Dfes [n/f] [def: barrel, vagina (vulgar)]
	vaserfas/Xvaserfeser [n/f] [def: water barrel]
	gefes/X [n] [def: dishes]
		blutgefes/X [n] [def: blood vessel]
	farfas/V/Bfarfast [def: organize]
		farfaser/S [m] [def: author]
		farfa'senish/N [n] [def: written work] 
fashizm [m] [def: fascism] fashi'st/N [m] [def: fascist] /Iish
fasolye/S [f] [def: bean (food)] 
faso'n/N [m] [def: fashion] 
fast/V/T /Gop [def: fast (avoid food)]
fastrigeve/V/T [def: baste (sewing)] 
fatal/A [def: fatal]
fatse't/N [m] [def: dandy, fop] 
fatsheyle/S [f] [def: scarf (clothing)]
fayer/S/D [m/n] [def: fire] /Idik
fayer/V/T [def: celebrate] [usage: inadmissable]
	fayerlekh/A [def: celebratory; solemn]
		fayerlekhkayt/N [f] [def: solemnity; holiday spirit] 
	fayerung/N [f] [def: celebration; festival] 
	fayerlekhkayt/N [f] [def: solemnity, celebratory nature]
fayf/V/T [def: whistle] /Gon/Goys
	fayf/N/D [n] [def: whistle] fayfer/S [m] [def: whistler]
	fayferay'/N gefayferay'/N [def: whistling]
fayg/N [f] [def: fig]
faykht/A [def: damp] faykhtkayt/N [f]
fayl/N [f] [def: arrow]
fayl/N [f] [def: file (tool)] fayl/V/T
fayn/K [def: fine]
	oysgefaynt/A
	farfaynerung/N [f] [def: decoration, improvement, refinement] 
faynd/X [m] [def: enemy] /Ilekh
	fayndlekhkayt/N [f] [def: hostility]
	fayndshaft/N/Ilekh [f] [def: enmity]
faynt [def: despise (with "hobn", "krign")] fayntshaft/N [f] [def: hatred]
faza'n/N [m] [def: pheasant (bird)] 
fe [interj] [def: (expression of disgust)]
februar [m] [def: February]
feder/N [f] [def: feather] /Idik bafedert/A
feder/S [f] [def: pen]
	blayfeder/S [f] [def: pencil] [usage: doubtful admissability]
feder/V/T [def: arise early]
federa'l/A [def: federal] 
fefer [m] [def: pepper] /Idik/Iik
	fefer/V/T /Gon [def: pepper]
	[idiom: vu der shvartser fefer vakst = far away]
feik/A [def: able] arbetsfeik/A umfeik/A feikayt/N [f] [def: ability]
fel/V/T /Goys [def: lack]
	/Bgefaln /Goys % variant participle
	farfel/V/Bfarfaln [def: be irrevocable, overlook]
	feler/N [m] [def: mistake, lack]
		drukfeler/N [m] [def: misprint] 
fel [f] [def: skin]
	tsignfel [f] [def: goatskin]
	shepsnfel [f] [def: sheepskin]
feld/Eer [n] [def: field]
	kornfeld/Eer [n] [def: field of rye]
feldsher/S [m] feldsherin/S [f] [def: barber-surgeon]
feldz/N [m] [def: cliff]
felyeto'n/N [def: broadside]
	felyetoni'st/N [m] felyetonistke/S [f] [def: columnist] 
feminin/A [def: feminine]
fenomen/N [m] [def: phenomenon]
	bay'fenomen/N [m] [def: side effect] 
fentster/X/D [m] [def: window]
	[idiom: di hoykhe fentster = the upper echelon, the elite]
feodal/A [def: feudal] 
ferd/X/D [n] /Iish [def: horse (animal); vault, vaulting horse (gymnastics)]
fermyum [m] [def: fermium (Fm)] 
ferz/N [m] [def: line of a poem]
festik/V/T [def: tighten] fest/A [def: tight]
	bafestik/V/Bbafestikt [def: tighten, fortify]
		bafestikung/N [f] [def: fortification] 
	farfestik/V/Bfarfestikt [def: tighten]
		tson-farfestiker/S [m] [def: retainer (dentistry)] [note: V] 
	farfas/V/Bfarfast [def: arrange]
	festung/N [f] [def: fort (military)] 
festival/N [def: festival]
fet/K [def: fat] fetkayt/N [f] fets
feter/S [m] [def: uncle]
fey{fʼ}/H [m/f] [def: letter Feh]
fi [n] [def: cattle] % no singular form
fiber/V/T [def: have a fever] fiber/N [m] [def: fever] /Idik [def: fevered]
fidbek [m] [def: feedback (acoustic)] 
fidl [m] [def: violin] fidele/Xkh [def: little violin]
	fidler/S [m] [def: violinist]
	fidleray'/N [def: fiddling] 
figur/N [f] [def: figure; (game) piece]
fiksi'r/V/Bfiksi'rt [def: falsify] fiksirung/N [f] [def: falsification]
fiktiv/A [def: imaginary]
	fiktsye/S [f] [def: fiction, imagination] 
fil/V/T [def: feel] /Goys/Giber/Gon
	derfi'l/V/Bderfilt [def: feel]
	gefi'l/N [n] [def: feeling]
		fayngefi'l/N [n] [def: refined sentiment] 
		forgefi'l/N [n] [def: premonition] 
		kegngefi'l/N [n] [def: opposite feeling]
		mitgefi'l/N [n] [def: sympathy]
		ongefi'l/N [def: feeling]
		shuldgefi'l/N [n] [def: guilty feeling]
		vidergefi'l/N [n] [def: repulsion] 
	eydlfilndik/A [def: of noble feeling]
	[idiom: er filt mit mit emetsn = his heart goes out to someone]
film/N [m] [def: film]
	filmograf/N [m] [def: filmmaker] 
	filmirke/S [f] [def: camcorder] [note: V]
filologye [f] [def: philology] filolog/N /Iish [m] [def: philologist]
filosofye/S filozofye [f] [def: philosophy]
	filosof/N /Iish [m] filozof/N /Iish [def: philosopher]
	filosofi'r/V/Bfilosofi'rt filozofi'r/V/Bfilozofi'rt [def: philosophize]
filtri'r/V/Bfiltri'rt [def: filter] /Goys/Garoys
filyal/N [m] [def: affiliate, branch (store or office)] 
finants/N [def: finance] finantsyel/A
	finantsi'r/V/Bfinantsi'rt finansi'r/V/Bfinansi'rt [def: finance]
	finantsirer/S [m] [def: financier] 
	finantsirung/N [f] finansirung/N [f] [def: financing] 
finf finft/A finftns [def: 5] finftl [def: 1/5]
	finef [def: 5] % southern variant
	finfer [def: five-unit money]
	fuftsn fuftsnt/A [def: 15] fuftsntl [def: 1/15]
	fuftsik/A fuftsikst/A [def: 50] fuftsikstl [def: 1/50]
finger/X/D [m] [def: finger]
	taytfinger/X/D [m] [def: forefinger]
	[idiom: shpits finger = fingertip]
	fingerl/Xfingerlekh [n] [def: ring] 
	[idiom: kedushen{kydwSyn} fingerl = wedding ring]
	[idiom: lekn fun emetsn di finger = enjoy someone's presentation]
	[idiom: oyszoygn fun finger = invent, dream up]
finkl/V/T [def: twinkle] /Idik
fintster/K [def: dark] /Ilekh
	fintsternish/N [n] [def: darkness] fintsterkayt/N [f]
	shtokfintster/A [def: completely dark]
	fintster/V/T /Gop [def: waste (with "lebn" or "yugnt")]
	farfintster/V/Bfarfintstert [def: darken]
fir/V/T [def: carry]
	/Giber/Gtsurik/Gon/Gadurkh/Garayn/Gariber/Garoys/Gayn/Garum/Gon
	/Gavek/Garum/Gavek/Goyf/Gayn/Gop/Gtsu/Garop/Gfunander
	/Goys [def: be able]
	/Gdurkh [def: carry out; accomplish] % Harduf 
	farfi'r/V/Bfarfi'rt [def: seduce]
	tsefi'r/V/Btsefi'rt [def: lead astray] tsefirung/N [f]
	derfi'r/V/Bderfi'rt [def: bring about; accomplish]
		derfirung/N [f] [def: result; accomplishment]
	firer/S [m] [def: leader, guide]
		fi'rershaft/N [f] [def: leadership] firung/N [f] firekhts/N [n]
			on'firershaft/N [f] [def: leadership] 
		lazer-gefi'rt/A [def: laser-guided] 
	araynfir/N [m] [def: introduction]
	durkhfir/N [m] [def: passage]
	onfir [m] onfirung/N [f] [def: leadership, direction]
		onfirer/S [m] [def: leader]
	oyffirung/N [f] [def: performance (in theatre)]
	oysfirung/N [f] oysfir [def: carrying out]
	vaserfirer/S [m] [def: water carrier]
fir fert/A fertns fertstn [def: 4] fertl/N [def: 1/4]
	fertsn fertsnt/A [def: 14] fertsntl [def: 1/14]
	fertsik/A fertsikst/A [def: 40] fertsikstl [def: 1/40]
	ferthalbn [def: 3.5]
firme/S [f] [def: company]
firsht/N [m] [def: nobleman] firshtin/S [f] [def: noblewoman]
fish/X/D [m] [def: fish]
	fisher/S [m] [def: fisher]
	hayfish/N [m] [def: shark (fish)] % Harduf
	tunfish/X [m] [def: tuna (fish)]
	tentfish/X [m] [def: squid]
	valfish/N [m] [def: whale] % Harduf
	[idiom: khapn di lokshn far di fish / der yoykh = put the cart before the horse]
fiter/V/T [def: feed (an animal)]
	gefiter [def:feed]
fitsh [adv] [def: wringing wet (with "nas")] 
fizik [f] [def: physics (subject)] fizish/A fizikalish/A [def: physical]
	fiziker/X [m] [def: physicist] 
	metafizik [f] [def: metaphysics (subject)] metafizish/A [def: metaphysical]
flaker/V/T [def: flicker (flame)]
	/Garoyf [def: enflame] 
	tseflaker/V/T [def: flicker]
flakh/N [f] [def: plane, surface] flakh/A [def: flat]  
	hantflakh/N [f] [def: palm (of hand)] 
	eyberflakh/N [f] [def: upper surface] eyberflekhlekh/A [def: surface]
flaks [m] [def: flax] /In
flam/V/T [def: flame] /Goyf/Gayn
	tseflam/V/Btseflamt [def: burst into flame]
	farflam/V/Bfarflamt [def: flame]
		farflamtkayt/N [f] [def: flame] 
	flam/N [m] /Dflem [def: flame] /Iik [def: flaming]
	geflam/N [def: flame]
	fayerflam/N [def: flame]
	likhtflam/N [def: candle flame]
	/Dtsindflem [def: pilot light] 
flank/N [m] [def: flank (body part; food)] 
flants/V/T [def: plant] /Gayn
	/Giber [def: transplant] 
	farflants/V/Bfarflantst [def: plant]
	brust-aynflants/N [m] [def: breast implant] [note: V] 
flash/N/Xflesher /Dflesh [n] [def: bottle]
	fleshlekhvayz [def: by the bottle]
flaster/V/T [def: plaster]
	/Dflester [def: bandage]
flater/V/T [def: flutter] /Garoyf /Idik
	tseflater/V/Btseflatert [def: flutter about]
	geflater/N [def: fluttering]
		fla'terl/Eekh [n] [def: butterfly]
fleg/V/T [def: used to]
fleger/S [m] flegerin/S [f] [def: personal attendant] 
flek/N/D [def: disfigurement]
	flek/V/T [def: disfigure] baflek/V/Bbaflekt [def: disfigure]
	flek/N [m] [def: spot, stain]
flekht/V/Bgeflokhtn [def: braid] /Garayn/Gayn/Gtsunoyf/Giber/Garum/Gdurkh
	tseflokhtn/A [def: braided]
	farflokhtn/A [def: braided]
flentsye/S [f] [def: influenza (disease)] 
fleysh/N [n] [def: meat] /Iik [def: meaty]
	/Iedik [def: meat-based (food) (ritual)] 
	hakfleysh [n] [def: chopped meat] 
	hinerfleysh [n] [def: chicken (meat)]
	mentshnfleysh [n] [def: human flesh]
	rindfleysh [n] [def: beef (meat)]
	roslfleysh [n] [def: sourbraten (cooked food)]
	shandfleysh [n] [def: female genitalia] 
	shepsnfleysh [n] [def: lamb (meat)]
	vildfleysh [n] [def: proud flesh] 
	zitsfleysh [n] [def: patience, perserverence] [usage: humorous] 
	tsefleysht/A [def: withered] 
fleyt/N [f] [def: flute]
fleyts/V/T [def: flood]
	farfleyts/V/Bfarfleytst [def: flood] farfleytsung/N [f] [def: flood]
fli/V/Bgefloygn [def: fly]
	/Gadurkh/Garayn/Garoys/Gunter/Gdurkh/Garoyf/Gmit/Gon/Gavek/Garum/Garop
	/Gtsunoyf
	tsefli/V/Btsefloygn [def: fly apart]
	fligl/N/Dflig [m] [def: wing] gefliglt/A bafliglt/A
	flier/S [m] [def: flyer, pilot] shternflier/S [m] [def: spaceship]
	fliik/A [def: flying] durkhfliik/A [def: flying past]
	[idiom: nit geshtoygn, nit gefloygn = nonsense]
	[idiom: in flug = off hand, at first glance]
flig/N [f] [def: fly]
	titus-flig/N [f] [def: gnat that burrowed into Emperor Titus' brain] 
	[idiom: hobn moyre{mwr#} far a flig = be afraid of one's shadow]
flik/V/T [def: pluck] /Goys/Gop
	flik/N [m]
	fliker/S [m] [def: plucker] 
	tseflik/V/Btseflikt [def: wear out (clothing)]
flikht/N [f] [def: duty]
	farflikhtet/A [def: obligated]
flink/K [def: quick]
flirteve/V/T flirt/V/T [def: flirt] 
	flirt/N [m] [def: flirtation] 
flis/V/Bgeflosn [def: flow] /Gop
	flisik/A [def: fluent] flisikayt/N [f] [def: fluency]
	opflus/N [m] [def: overflow] tsuflus/N [m] [def: inflow]
flister/V/T [def: whisper]
flok/N [m] [def: flake] 
flokn/S/Xfleker [m] /Dflek [def: pole, club]
flot/N [m] [def: navy] 
floy/Xfley [m] [def: flea] 
	[idiom: hobn fley in der noz = have a bee in one's bonnet]
floym/N [f] [def: plum]
fluor [m] [def: fluorine (F)] 
fodem/Xfedem [m] /D [def: string]
foder/V/T [def: demand] /Goyf/Garoys
	foderung/N [f]
fodersht/A [def: front]
foke [f] [def: harbor seal (animal)] 
fokhe/V/T [def: wave]
	tsefokhe/V/Btsefokhet [def: wave about]
	fokher/S [m] [def: fan (appliance)] 
fokusnik/Ees [m] [def: juggler] [usage: rare]
folate [def: folate (food chemical)] 
folg/V/T [def: obey]
	/Gnokh [def: follow] 
	nokhfolger/S [m] [def: successor, sycophant]
	farfolg/V/Bfarfolgt [def: persecute] 
		farfolgung/N [f] [def: pursuit, persecution, prosecution]
folk/Xfelker /Iish [n] [def: nation]
	folklor [def: folklore] folklori'st/N [def: folklorist] /Iish
	bafelker/V/Bbafelkert [def: inhabit] bafelkerung/N [f] [def: population]
	porfolk/N [def: married pair]
	herenfolk [n] [def: master race (in nazi terminology)]
	veltfolk [n] [def: world-wide nation] 
fon/N/Xfener [f] [def: flag]
fond/N [m] [def: fund]
fonetik [def: phonetics] fonetish/A fonetizi'r/V/Bfonetizi'rt
fonfe/V/T [def: mumble] /Gunter
	fonfate/A [def: mumbling] 
fonologye/S [f] [def: phonology]
fontan/N [m] [def: fountain]
for/V/Bgeforn [def: travel]
	/Gtsurik/Gtsuzamen/Gavek/Gadurkh/Gaher/Garayn/Garoys/Garum/Gdurkh/Gfarbay
	/Gfunander/Gnokh/Gon/Gop/Goys/Gtsu/Gum/Gariber/Giber/Garop/Garoyf/Gahin
	farfor/V/Bfarforn [def: travel too far; fetch, pick up]
	tsefor/V/Btseforn [def: travel about]
	araynfor [m] [def: entrance, driveway] aynfor [m]
		aynfor- [def: drive-in] 
	aroysfor [m] [def: exit]
	tsufor [m] [def: approach] 
	tsuzamenfor [m] [def: convention]
	onfor [m] [def: start of traveling]
	foreray'/N [def: traveling]
	forer/S [m] [def: traveler] mitforer/S [m] [def: traveling companion]
	[idiom: lozn durkhforn tsu ersht = yield the right of way]
forem/Xformen [f] [def: form, shape]
	furem/V/T [def: form, shape, fashion] /Gayn/Goys
		furem/S [m] [def: mold, cast; pattern]
		furemung/N [f] aynfuremung/N [f] [def: formation; shaping]
	formi'r/V/Bformi'rt [def: form]
forkht [f] [def: fear] /Iik/Izikhtik
	got|sforkhtik/A [def: God-fearing] 
formel/A [def: formal]
	formalite't/N [f] [def: formality] 
formuli'r/V/Bformuli'rt [def: formulate] formulistish/A
	formulirung/N [f] [def: formulation] % Forwards
foroys [adv] [def: in advance] /Iik
forsh/V/T [def: research] /Goys
	forsher/S [m] /Iish forsherin/S forsherke/S [f] [def: researcher]
	forshung/N [f] oysforshung/N [f] oysforsh/N [def: research]
	oysforsher/S [m] oysforsherin/S [f] [def: researcher]
fort [adv] [def: after all] 
fortifikatsye/S [f] [def: fortification] 
forum/S [m] [def: forum] 
forverts{forvert|s} [def: Forwards newspaper]
fosfor [m] [def: phosphorus] 
	fosfori'r/V/Bforsfori'rt [def: phosphoresce]
fosi'l/N [m] [def: fossil] 
fote'l/N [def: footstool]
foter/S [m] [def: father (German)] /Ilekh
	shtamfoter/S [m] [def: ancestor]
fotograf/N [m] fotografin/S [f] [def: photographer]
	foto/S [f] fotografye/S [f] [def: photograph]
	fotografish/A [def: photographical] 
	fotografi'st/N [m] fotografistke/S [f] [def: photographer] % Harduf
	fotografi'r/V/Bfotografi'rt [def: photograph] 
foye'/N [m] [def: foyer] 
foygl/N/Xfeygl [m] [def: bird] % both plurals exist
	/Dfeyg [def: little bird, male homosexual (America)] 
		zumer-feygele/Ekh [n] [def: butterfly] 
	feyglsh/A [def: bird-like] 
foyl/V/T [def: spoil, be lazy (with "zikh")] /Gdurkh/Goys
	farfoyl/V/Bfarfoylt [def: spoil]
	tsefoyl/V/Btsefoylt [def: spoil]
	foyl/A [def: lazy] foylkayt/N [f] [def: laziness] 
		foylya'k/Ees [m] foyler/S [m] [def: sloth (animal)] 
foyst/N/D [def: fist]
fragme'nt/N [m] [def: fragment] /Iarish [def: fragmentary] 
	fragment'ir/V/Bfragmenti'rt [def: fragment] % Forwards
frak/N [m] [def: dress coat, tails (clothing)] 
fraktsye/S [def: faction] 
frandz/N /Dfrendz [def: fringe]
frank/A [def: simple]
frantsyum [m] [def: francium (Fr)] 
frask/N [m] [def: powerful smack] 
fraternal/A [def: fraternal]
fray/A [def: free]
	bafray/V/Bbafrayt [def: liberate; make available (with "zikh")]
		bafrayung/N [f] [def: liberation] 
	frayhayt/N/S [f] fraykayt [f] [def: freedom] 
	bafrayer/S [m] [def: liberator]
	bafrayung/N [f] bafrayungs [def: liberation]
	[idiom: fraye tsayt = spare time]
fraynd/X [m] [def: relative] /Ilekh [def: friendly] 
	umfrayndlekh/A [def: unfriendly] 
	frayndin/S [f] [def: friend (female)]
	frayndshaft/N [f] [def: friendship]
	bafrayndet/A [def: befriend]
	buzemfraynd/X [m] [def: close friend, bosom buddy]
	hartsfraynd [m] [def: close friend]
	yugntfraynd [m] [def: friend of one's youth]
	gastfrayndlekh/A [def: hospitable] umgastfrayndlekh/A [def: inhospitable] 
		gastfrayndlekhkayt/N [f] [def: hospitality] 
fraynt/X [m] [def: friend]
fraytik/N [m] [def: Friday]
fraze/S/Xfrazn [f] [def: phrase]
	frazeologye/S [f] [def: phraseology] frazeologish/A [def: phraseological] 
	frazirung/N [f] [def: phrasing] 
freg/V/T [def: ask] /Gnokh/Gon/Goys/Giber/Gop onfreg/N
	derfreg/V/Bderfregt [def: discover by asking]
	opfreglekh/A [def: questionable] umopfreglekh/A [def: unquestionable]
	freger/S [m] fregerke/S [f] [def: questioner; inquisitive person] 
		fregerish/A [def: inquisitive] 
	frage/S/D [f] [def: question] freg/N/D [f]
		[idiom: a freg ton = ask]
	nokhfreg/N [m] [def: demand] % Harduf
frekh/K [def: fresh]
fremd/A [def: foreign] fremdkayt/N [f] [def: foreignness]
	farfremdt/A [def: foreign]
fres/V/Bgefresn [def: gulp down, eat (like an animal)] /Goyf/Gon
	tsefres/V/Btsefresn [def: gulp down]
	freser/S [m] freserin/S [f] [def: fast eater]
		meser-freser/S [m] [def: sword swallower] [note: V]
	drekfreser/S [m] [def: someone who enjoys poor food (vulgar)] 
frey/V/T [def: rejoice (with "zikh")] 
	derfrey/V/Bderfreyt [def: gladden; be delighted (with "zikh")]
	freyd/N [f] [def: joy]
	fridn [def: peace] /Idik
	fridlekh/A [def: happy] freydik/V/T
	freylekh/K [def: happy] freylekhkayt/N [f] [def: happiness]
	tsufridn/A [def: satisfied, glad, pleased, content] /Idik
		tsufridnkayt/N [f] [def: satisfaction, gladness, contentment]
	umtsufridn/A [def: dissatisfied]
	bafridik/V/Bbafridikt [def: satisfy]
		bafridikung/N [f] [def: satisfaction] 
fri/K/Iik/Ierik/Ierdik [def: early] tsufrier
	inderfri [m] [def: morning] 
	tsufriik/A [def: premature; untimely] 
	[idiom: oyf tsufrier = in front]
friling [m] [def: Spring (season)]
frir/V/Bgefroyrn [def: freeze] /Gop
	farfri'r/V/Bfarfroyrn [def: freeze]
	frost/Xfrest [m] [def: frost] /Iik [def: frosty]
		frostikayt/N [f] [def: frostiness] 
	frirke/S [n] [def: freezer (appliance)] 
	[idiom: der frost brent = it's very cold]
frish/K [def: fresh] /Iink frishkayt/N [f] [def: freshness]
	frish/V/T [def: freshen] /Gop/Goyf
	derfrish/V/Bderfrisht [def: restore; refresh]
		derfrishung/N [f] [def: refreshment] 
frishtik [n] [def: breakfast]
frizhider/N [m] [def: refrigerator (American)]
frizi'r/V/Bfrizi'rt [def: style (hair)] frizir/N [def: hairstyle]
front/N [m] [def: front]
frosh/Xfresh /D [f/m] [def: frog]
froy/N froyke/S [f] [def: woman; wife]
	froyish/A [def: womanly; wifely] froyishkayt/N [f] [def: womanliness; wifeliness] 
	fraylin/N [f] [def: unmarried woman] 
	gasnfroy/N [f] [def: prostitute] 
frukht/N [f] [def: fruit] frukhtper/V/T
	frukhtsheyk/N [m] [def: fruit shake, smoothie] [note: V] 
	greypfrukht/N [m] greypfrut/N [m] [def: grapefruit] 
frum/Kfrim [def: pious]
	frumkayt/N [f] [def: piety]
	frumak/Ees [def: over-pious person] /Iish [def: sanctimonious] 
	farfrimt/K [def: pious]
fuks/N/D [m] [def: fox]
ful/A [def: full] fulkayt/N [f] [def: fullness] fulkum/A [def: fully]
	iberful/A [def: overfull]
	fil/V/T [def: fill] /Gon
	fil [def: many (German)]
	tsufil [def: too many] vifl [def: how many]
		viflt/A [def: which (in order)] viflst/A
	prestizhful/A [def: prestigious] 
fun/P [def: from]
fundamenta'l/A [def: fundamental] 
	fundamentali'st/N [m] [def: fundamentalist (religious)] /Iish
fundeve/V/T [def: found] /Gayn
	ayngefundevetkayt/N [f] [def: foundation]
	farfundeve/V/Bfarfundevet [def: found]
	fundatsye/S [f] [def: foundation]
	derfindung/N [f] [def: invention] 
funk/N [m] [def: spark]
funktsye/S [f] [def: function] 
	funktsyoni'r/V/Bfunktsyoni'rt [def: function]
	funktsyonel/A [def: functional] 
	funktsyona'r/N [m] [def: functionary] 
funt/N [m] [def: pound]
fur/N/D [f] [def: wagon]
	furman/Xfurmener [m] [def: wagon driver] 
fus/Xfis/D/Iik [m] [def: foot (part of body)]
	fus/X/D/Iik [m] [def: foot (measure of length)]
	drayfisik/A [def: tripodal] eynfusik/A [def: with one foot]
	fisnoge/S [def: foot (Lithuanian Yiddish)]
	tsufusns [def: on foot]
	drayfus/N [m] [def: three-legged cooking pot]
	[idiom: vu nor er shtelt a fus = whereever he goes]
	[idiom: mitn rekhtn fus (foroys) = good luck!]
	[idiom: hobn kadme{kdm#}-veazle{v|azlo} fis = bow-legged]
	[idiom: hobn fis vi a merkhe{mrx#}-tipkhe{typH#} = knock-kneed]
	[idiom: hobn aroysgedreyte fis = penguin-toed] [note: V]
	[idiom: hobn arayngedreyte fis = pigeon-toed] [note: V]
futbol [m] [def: (American) football] futboli'st/N [m] [def: football player]
futuri'st/N [m] futuristke/S [f] [def: futurist (artistic movement)] 
	futuristish/A [def: futuristic] % Forwards
fyole't/A vyole't/A [def: violet (color)]
gabe_{gb#y}/Xgaboyem{gbo|ym} [m] [def: charity overseer (Jewish religious functionary)] 
gabe{gby}/H [def: with regard to] /Ll
gadolinyum [m] [def: gadolinium (Gd)] 
gadyo{gdy#}/H [def: kid (Aramaic), jail (khad gadyo)]
gaf/V/T [def: stare]
	fargaf/V/Bfargaft [def: stare]
gal/N [f] [def: gall, bile]
	fargal/V/Bfargalt [def: gall]
	fargaltkayt/N [f] [def: state of being galled]
	[idiom: oysshpayen di gal = be ill (often metaphoric)]
galaksye/S [f] [def: galaxy]
galanterye/S [f] [def: haberdashery] % Harduf
galekh{glH}/Xgalokhem{glHym}/H/D/N [m] [def: Christian priest (pejorative)]
	vide{vydwy}-galekh{glH} [def: confessor] 
	goluekh{glwH}/Xglukhem{glwHym}/H [m] [def: clean-shaven Jew]
	galkhes{glHwT} [n] [def: non-Jewish (Latin) alphabet] 
galerye/S [f] [def: gallery]
galon/N [m] [def: gallon] % Harduf
galop/N [m] [def: gallop] galopi'r/V/Bgalopi'rt
galyum [m] [def: gallium (Ga)] 
gam{gm}/H [def: also]
gamor{gmwr}/H [def: entire] legamrey{lgmry} [def: entirely]
gan{gn}/H [m] [def: garden]
gandz/Xgendz [f] [def: goose] /D gendzn/A
ganef{gnB}/Xganovem{gnBym}/H [m] [def: thief]
	ganeyve{gnyBh}/Xganeyves{gnyBwT}/H [f] [def: theft]
		/Iish [def: theiving, untrustworthy] /Lb [def: by theft]
	ganve{gnBe}/Vganvenen{gnBenen}/T [def: steal] 
		/Garayn/Garoys/Gavek/Garop/Garoyf/Gdurkh/Gtsu
	[idiom: a metsiye{mcy#h} fun a ganef{gnB} = unbelievable bargain]
ganeydn{gn-edn}/H/S [m/n] [def: paradise] /Idik
	[idiom: tam{tem} ganeydn{gn-edn} = delicious]
ganik/S [m] [def: porch]
gants/A /In [def: whole, full, complete] gantskayt/N [f] [def: whole] 
	ingantsn [adv] [def: entirely]
gar/V/T [def: crave, yearn for (with "nokh")]
	gern [def: eager; willing] umgern [def: unwilling] [grammar: undeclined]
	bager/N [m] [def: desire]
	bager/V/Bbagert [def: desire] 
	girik/A [def: eager] 
garantye/S [f] [def: warranty, guarantee] 
	garanti'r/V/Bgaranti'rt [def: guarantee] % Harduf
gara'zh/N [m] [def: garage] % Harduf
garber/S [m] [def: tanner] % Harduf
	garberay'/N [f] [def: tannery] % Harduf
gardero'b/N [m] [def: wardroom; wardrobe, clock room, locker room]
gardi'n/N [m] [def: drape]  % Harduf
gargole/S [f] [def: gargoyle] [note: V]
garniter/S [m] [def: outfit, suit]
	garni'r/V/Bgarni'rt [def: garnish, decorate] 
garnizo'n/N [m] [def: garrison (military)] 
gartl/V/T [def: wrap] /Gunter gartl/N [m] [def: belt, sash, girdle]
	talye-gartl/N [m] [def: cummerbund] 
gas/N [f] [def: street] /Dges [def: alley] 
	/Dhinterges [def: alley]
	/Dhoyptges [def: main street] 
	/Dunterges [def: side street] 
gashmiyes{gSmywT}/H [def: physical] /Idik /Lb
gast/Xgest [m] [def: guest]
	erngast/Xerngest [m] [def: honoree] 
gastroli'r/V/Bgastroli'rt [def: perform]
	gastrol/N [def: gig]
gatke/S [def: suspenders, underpants] % usually in plural
gayst/Eer [m] [def: spirit] /Iik /Ilekh [def: spirited]
	gaysterishkayt/N [f] [def: spiritedness, enthusiasm] 
	bagayster/V/Bbagaystert [def: enthuse, inspire]
	bagaysterung/N [f] [def: enthusiasm, inspiration]
gayve{g#vh}/H [f] [def: pride, arrogance] /Idik [def: proud]
	gayvenik{g#vhnik}/Ees [m] [def: proud person]
gaz/N [m] [def: gas]
	fargaz/V/Bfargazt [def: gas]
gaze/S [f] [def: gauze] % Harduf
gazet/N [def: journal]
gazlen{gzln}/Xgazlonem{gzlnym}/H [def: robber] gazlonish{gzlnish}/A
	gazl{gzl}/H/V/T [def: rob]
	bagazl{bagzl}/H/V/Bbagazlt{bagzlt} [def: rob]
	gazlones{gzlnwT}/H/N [f] gazlevoystve{gzlevoystve} [f] [def: thievery, brigandage]
ge/Een [m] [def: the letter G] 
geb/V/Bgegebn [def: give]
	/Garayn/Garop/Garoys/Gtsu/Garoys/Gtsu/Giber/Gavek/Gmit/Gnokh/Gon
	/Goys/Gtsurik/Gunter
	/Gayn [def: bring to court (with "oyf emetsn"); be possible (with "es ... zikh")]
	/Gfor [def: suggest, propose] 
	/Gop [def: be concerned with (with "zikh mit")] 
	gib gist git gibn gib [def: give] % some spurious forms in present tense
	geber/S [m] [def: giver] 
		arbetgeber/S [m] [def: employer] 
	aroysgabe/S [f] [def: edition] aroysgeber/S [m] [def: publisher]
	ibergebnkayt/N [f] ibergegebnkayt/N [f] [def: devotion]
	gob/N [f] [def: gift, talent]
	bagabt/A [def: talented; gifted] [usage: doubtful admissability]
		hoykhbagabt/A [def: highly talented] [usage: doubtful admissability]
		bagabung/N [f] bagabtkayt/N [f] [def: talent] [usage: doubtful admissability]
	opgob/N [m] [def: tax]
	oyfgabe/S [f] [def: task] oysgabe/S [f] [def: edition]
	oyfgob/N [m] [def: deposit, down payment] 
	tsugob/N [m] [def: additional amount]
	gezetsgeberish/A [def: legislative] 
	tsegeber/S [m] [def: dispenser] [note: V]
gebe'r/V geboyr/V/Bgeboyrn [def: bear a child]
	geborn/A [def: born] umgeboyrn/A [def: unborn]
	geburt/N geburt|s [f] [def: birth]
	vidergeburt/N [f] [def: rebirth]
	[idiom: geboyrn vern = be born]
gebi'ft/K [def: shrewd] % Harduf
gebit/N [n] [def: territory, realm, field of knowledge] [usage: doubtful admissability]
geday/V/Bgedayet [def: thrive]
gedempt/A [def: boiled]
/Xgederem /Xgederemlekh [def: innards] % no singular.  Not spelled Hebraically.
gedikht/K [def: dense, thick; heavy; dense]
	gedi'khtenish/N [f] [def: thicket] 
gedikht [n] [def: poem]
gedishekhts/N [n] [def: stew (food)] 
geduld [f/n] [def: patience] /Iik [def: patient]
	umgeduld [f] [def: impatience] /Iik [def: impatient]
gefa'r/N [f] [def: danger] geferlekh/K [def: dangerous] 
gefel/V/Bgefeln [def: please; appeal to]
gefin/V/Bgefunen [def: find] /Goys/Gtsurik/Gop
	gefins/N [def: finding] 
gegnt/N [m/f] [def: neighborhood]
geher/V/T [def: belong]
	/Gon [def: connect]
	geherik/A tsugeherik/A [def: proper, appropriate]
	[idiom: eyns tsum anderen geher nit on = one thing has nothing to do with the other]
geheym/A [def: secret] /Iish gehey'menish/N [n] [def: secrecy]
	geheymlekhkayt/N [f] [def: secrecy]
	geheymnishful/A [def: secret] 
gehirn [m] [def: brains] 
gel/A [def: yellow] /Iblekh
	geler/X [m] gelerke/S [f] [def: redhead]
	fargel/V/Bfargelt [def: make yellow]
	gelkhl/Xekh [n] [def: yolk] 
	[idiom: oyszen grin un gel = look unwell]
gelasn/A [def: calm; leisurely] gelasnkayt/N [f] [def: calmness]
	oysgelasn/A [def: of loose morals]  oysgelasnkayt/N [f] [def: loose morals] 
gelenk/N [n] [def: joint; wrist; aptitude] fingergelenk/N [n] [def: knuckle]
geling/V/Bgelungen [def: succeed (German)]
gelt/Eer [n] [def: money]
	dire{dyrh}-gelt/Eer [n] [def: rent] 
	kindergelt [n] [def: child support] 
	hantgelt [n] [def: earnest money]
	kleyngelt [n] [def: change]
	lager-gelt [n] [def: savings] 
	nitsgelt [n] [def: usage fee]
	postgelt [n] [def: postage] 
	rebi{rby}-gelt [n] [def: tuition] 
		[idiom: batsoln rebi{rby}-gelt far = pay dearly for something learned]
	toggelt [n] [def: per diem] 
	trinkgelt [n] [def: tip, gratuity] 
	[idiom: mezumen{mzwmn} gelt = ready money]
gemayzekhts/N [n] [def: wetlands]
gemeyn/K [def: worthless; mean; common]
gemeynzam/A [def: together]
	gemeynzamkayt/N [f] [def: common ground, mutuality]
	gemeynde/S [f] [def: community] 
gemore{gmr#}/Xgemores{gmrwT}/H [f] [def: Talmud] /Ish
gene/S [f] [def: gene] /Itish [def: genetic]
	genetik [f] [def: genetics (subject)] 
genealogye/S [f] [def: genealogy] % Harduf 
genem{gyhnwm}/H [n] [def: Hell] /Idik
genera'l/N [m] [def: general (military)]
genets/V/T [def: yawn] /Gayn genets/N [m] % bug: not generating gegenetst
gengster/S [m] [def: gangster] % Harduf 
genis/V/Bgenosn [def: benefit (from, with "fun"); enjoy]
	geniser/S [m] [def: one who benefits] 
genit/A [def: experienced; skilled] genitung/N [f] [def: exercise, workout]
genize{gnyz|h}/H [def: storehouse]
genoy/A [def: exact, precise]
genug/Iik/Indik [def: enough]
	genugndikayt/N [f] [def: sufficiency]
	ibergenug [def: more than enough]
	banugen/V/Bbanugent [def: be satisfied (with "zikh mit")]
genyal/A [def: genial]
geografye [f] [def: geography] geografish/A [def: geographical]
geologye [f] [def: geology] % Harduf
geometrye [f] [def: geometry] geometrish/A [def: geometrical]
gepilder [n] [def: clamor, noise]
ger{gr}/Xgeyrem{grym}/H [m] gyores{gyrT} [f] [def: convert to Judaism]
	megayer{mgAr} [def: make Jewish (with "zayn"); become Jewish (with "zikh zayn")] 
	giyer{gyur} [m] [def: conversion to Judaism] 
gera'm/A [def: roomy, spacious, capacious] 
geranyum/S [m] [def: geranium (plant)] 
germanyum [m] [def: germanium (Ge)] 
gerot/V/Bgerotn [def: succeed; come to fruition; resemble (with "- in emetsn")]
	/Gop
	gerotn/K [def: ripe]
	gerot [n] gerotnkayt/N [f] [def: ripeness]
		gere'tenish/N [n] [def: abundance; harvest] 
	barot [def: protection, providence] /In [def: protected]
gersht/N [m] [def: barley; grain of barley] 
geru'kh/N [n] [def: odor] % Harduf 
geshe/V/Bgeshen [def: occur] geshe'enish/N [n] [def: event]
geshikhte/S [f] [def: history; story] /D geshikhtlekh/A
	[idiom: far der geshikhte = for the record]
geshir [def: dishes; harness]
geshle'kht/Eer [n] [def: sex] /Ilekh [def: sexual]
geshpenst/N [n] [def: specter] [usage: deprecated]
geshvind/K [def: fast quick] geshvindkayt/N [f] [def: speed]
geshvi'r/N [n] [def: abscess, ulcer]
geshvoln/A [def: swollen] oyfgeshvoln/A % no base verb
gesrokhe{gesrHh}/Xgesrokhes{gesrHwT} [f/n] [def: stench] 
get{gt}/H [def: divorce] /V/T
geto/S [f] [def: ghetto]
	getoizi'r/V/Bgetoizi'rt [def: ghettoize]
	fargetoizi'r/V/Bfargetoizi'rt [def: ghettoize]
getselt/N [n] [def: tent]
geule{g#wlh}/H [f] [def: redemption]
gevald/N [f] [def: force] /Iik [def: strong]
	gevalderay'/N [def: shouts for help]
	gevaldik/V/Bgevaldikt [def: rape]
	geva'ldeve/V/Bgeva'ldevet [def: shout for help]
		tsegvaldeve/V/Btsegvaldevet [def: make a commotion for a while (with "zikh")] 
	fargevaldik/V/Bfargevaldikt [def: rape]
		fargevaldle/V/Bfargevaldlet [def: commit sexual abuse] 
	% variant spelling
	gvald/N [f] [def: force; scream, cry] /Iik [def: strong]
		gvalderay'/N [def: shouts for help]
		gva'ldeve/V/T [def: scream] % Harduf
	gvaldik/V/Bgvaldikt fargvaldik/V/Bfargvaldikt [def: rape]
		fargva'ldikung/N [f] [def: rape] 
gevant/N/D [n] [def: material]
	betgevant [n] [def: bedding]
gevelb/N/Eer /D [n] [def: store, shop; vault (architecture)]
	velbung/N gevelbung/N [f] [def: vault (architecture)] 
geveltik/V/Bgeveltikt [def: dominate] geveltikung/N [f] [def: domination]
gevin/V/Bgevunen [def: win] /Giber gevinung/N [f] [def: victory]
	gevins/N [n] [def: winnings; prize, reward]
	geviner/S [m] [def: victor, winner] gevinerin/S [f] [def: child-bearer]
gevir{gByr}/Xgvirem{gByrym}/H [m] gevirte{gByrte}/S [f] [def: rich person]
	gevirish{gByrish}/A [def: rich] 
	gevirshaft{gByrshaft} [f] [def: wealth]
	geviremshaft{gByrymshaft} [f] [def: the wealthy]
	[idiom: gezelshaftlekhe gevirte{gByrte} = socialite]
gevis/A [def: certain]
gevoyn/V/T [def: accustom; become accustomed (with "zikh")] /Gtsu/Gop/Gayn
	geveynlekh/A geveyntlekh/A [def: ordinary, usual, common; of course]
	umgeveynlekh/A umgeveyntlekh/A [def: unusual]
	oysergeveynlekh/A oysergeveyntlekh/A [def: extraordinary]
	gevoyntshaft/N [f] gevoynhayt/N [f] [def: habit]
gevoyr [def: aware; be informed (with "vern")] gevor % both forms
gey/V/Bgegangen [def: go]
	% limitation:
	% infinitive forms are "geyn", irregular, but gerunds are "geyendik",
	%  regular.  We need to split those roots.
	/Gnokh/Gdurkh/Gadurkh/Garayn/Garoys/Gariber/Garop/Garoys
	/Garum/Gon/Gavek/Gfunander/Giber/Gmit/Gop/Goys/Gtsu/Gum/Gtsurik
	/Goyf/Gunter/Garoyf/Gfunander/Garunter/Gayn/Gforoys/Gfor
	/Gfarbay [def: elapse; pass by] 
	/Bgegan % variant form, southern Yiddish
	geyn % irregular infinitive; bug: can't generate with converbs
	nokhgeyn [def: imitate]
	fargeyn fargey/V/Bfargangen [def: go into the past]
		fargangenhayt/N [f] [def: the past]
		fargeyik/A [def: passing, temporary, momentary] 
	tsegeyn tsegey/V/Btsegangen [def: melt]
	dergeyn dergey/V/Bdergangen [def: bother]
	bagey/Vbageyn/Bbagangen [def: commit (crime)]
	gang/Xgeng [m] [def: walk; gait; way, manner; course] /Ibar [def: passable]
		arayngang/N [m] [def: entrance]
		aroysgang/N [m] [def: exit]
		aroyfgang/N [m] [def: ascent]
		boygngang/N [m] [def: archway] 
		durkhgang/N [m] [def: pass (mountain)] 
		ibergang/N [m] [def: overpass]
		farbaygang/N [m] [def: passage] 
		foroysgang/N [m] [def: preceeding]
		oyfgang/N [m] [def: rising (sun)]
			zunoyfgang{zun#oyfgang}/N [m] [def: sunrise] 
		oysgang/N [m] [def: outlet, issue, vent; death]
		tsugang/N [m] [def: approach] tsugenglekh/A [def: approachable]
			tsugenglekhkayt/N [f] [def: approachability]
		untergang/N [m] [def: setting (sun)]
			zun-untergang/N [m] [def: sunset] 
		zunfargang/N [m] [def: sunset]
		umgang/N [m] [def: surroundings] 
		[idiom: folg mikh a gang = it makes no sense]
	geyer/S [m] [def: traveler]
		dorfgeyer/S [m] [def: traveling salesman]
		durkhgeyer/S [m] [def: traveler]
		farbaygeyer/S [m] [def: someone passing by]
		fusgeyer/S [m] [def: pedestrian] 
		mitgeyer/S [m] [def: traveling companion]
		nokhgeyer/S [m] [def: follower] 
	[idiom: afile di velt zol untergeyn = come hell or high water]
geyder{gdr}/H [def: border]
geyresh{gyrwS}/Xgeyrushem{gyrwSym}/H [m] [def: expulsion]
	megaresh{mgrS}/H [def: divorce (with "zayn")] 
	grushe{grwSh}/H [f] [def: divorced woman]
gezandter/S [m] [def: minister, legate] [usage: inadmissable]
	gezandshaft/N [m] [def: ministry, legation] [usage: inadmissable]
geze{gze}/H/S [def: race; pedigree; origin] 
gezelshaft/N [f] [def: business, society] /Ilekh [def: social] 
	gezel/N [m] [def: apprentice; journeyman; partner (German)]
gezikht/Eer [n] [def: face; countenance]
gezims/N [def: roof eave]
gezint hoyzgezint [def: members]
gezunt/A/Kgezint [def: healthy] gezunt [n] [def: health]
	gezunterheyt [adv] [def: in good health]
	[idiom: zay gezunt = goodbye]
	[idiom: tsu gezunt = gesundheit!]
	[idiom: abi gezunt = as long as one is healthy]
giber{gybwr}/Xgeboyrem{gbwrym}/H [m] [def: hero] /Lh
	gvure{gBwrh} [def: strength, heroism, exploit] gvures{gBwrwT}
		goyver{gwBr} [def: conquer, overcome (with "zayn")]
gift/N [m] [def: poison] /Iik [def: poisonous]
	fargiftung/N [f] [def: poisoning] 
gigantish/A [def: gigantic]
gikh/K [def: quick] ingikhn [def: quickly]
	fargikher/V/Bfargikhert [def: quicken] 
gil/N [def: gland]
gilde/S [f] [def: guild dues] 
gilgl{gylgwl}/Xgilgulem{gylgwlym}/H [m] [def: reincarnation]
	megulgl{mgwlgl}/H [def: reincarnated]
gilt/V/Bgegoltn [def: be effective]
	/Gop [def: pay a reward]
	giltik/A [def: effective]
	glaykhgiltik/A [def: unconcerned] glaykhgiltikayt/N [f] [def: unconcern]
	[idiom: dos gilt nit = that doesn't count!]
giluy{gylw|y}/H [def: revealed] /Lb
	hisgales{hTglwT}/H [def: revelation (of a hidden saint)]
	megale{mglh}/H [def: reveal (with "zayn")] 
gilze/S [f] [def: a kind of pipe] 
giml/H [m/f] [def: letter Gimel]
gimnazye/S [f] [def: high school]
	gimnazi'st/N [m] gimnazistke/S [f] [def: high-school student] 
	gimnastik [f] [def: gym, athletics (subject)] 
	gimnastish/A [def: gymnastic] 
ginekolog/N [m] [def: gynecologist (occupation)]
	ginekologye [f] [def: gynecology]
ginstik/A [def: opportunistic]
gintsik/K [def: favorable]
gips/N [m] [def: gypsum; plaster of Paris; surgical cast] /In
gis/V/Bgegosn [def: pour]
	/Garayn/Garoyf/Garoys/Gariber/Goys/Gtsu/Gon/Gtsunoyf/Gop/Giber/Gunter
	/Gtsunoyf/Gtsuzamen
	fargis/V/Bfargosn [def: pour] fargisung/N [f] [def: pouring]
	bagis/V/Bbagosn [def: drench]
	tsegis/V/Btsegosn [def: splatter]
	opgos/N [m] [def: sink]
	oysgos/N [m] [def: outpour; discharge] 
		oysgus/N [m] [def: outpour; discharge] [usage: doubtful admissability]
	tsunoyfgisung/N [f] [def: mixture (liquids)]
	gisik/A [def: fluid, liquid] 
	gos/N [m] gus/N [m] [def: drop] 
gitare/S [f] [def: guitar] gitar/N [def: guitar]
gitin{gytyn}/H [def: tractate Gitin (divorces) of Talmud]
glants/V/T [def: shine, gleam] /Goys /Gop [def: reflect]
	glentsl/V/T [def: sparkle]
	glantsik/A [def: shiny]
	glentsndik/A [def: bright, splendid] % Harduf
	opglants/N [m] [def: reflection]
glasne/S [m] [def: alderman] 
glat/A /Iik [def: smooth]
	glet/V/T [def: caress] /Goys/Gtsu
		glet/N [m] [def: caress] 
		gle'tenish/N [n] [def: foreplay] [note: V]
	farglet/V/Bfarglet [def: smooth over] 
glaykh/A [def: straight, even; similar] /Iik
	glaykhkayt/N [f] glaykhhayt/N [f] [def: equality]
		umglaykhkayt/N [f] [def: inequality] 
	glay'khenish/N [def: similitude]
	glaykhung/N [f] [def: equation]
	desglaykhn [adv] [def: similarly; likewise] 
	tsuglaykh [adv] tsuglaykhn [adv] [def: at the same time]
	glaykh/V/Bgeglikhn [def: equate; compare] /Goys
	farglaykh/V/Bfarglikhn [def: equate, compare]
		farglaykh/N [m] [def: comparison] /Ilekh [def: comparable] 
	glaykh/V/T [def: straighten] /Goys
	umglaykh/A [def: uneven] 
glaykh/V/T [def: like (English)]
gletsher/S [def: glacier] /D
gleyb/V/T [def: trust]
	gleybik/A [def: trusting] umgleybik/A [def: distrusting]
	fargleybt/A [def: trusting]
	bagleyb/V/Bbagleybt [def: trust]
	gleyblekh/A [def: believable] umgleyblekh/A [def: unbelievable] 
gli/V/T [def: glow] /Gon
	tsegli/V/Btseglit [def: glow]
	gli/N [m] [def: glow] /Iik [def: glowing]
glider/V/T [def: act as a part of, compartmentalize]
	/Gayn [def: assimilate (with "in")] 
	tseglidert/A [def: organized, structured, subdivided]
	glid/Eer [n] [def: limb]
		glid- [adj] [def: once removed, second (genealogical)] 
	mitglid/Eer [m] [def: member]
		mitglidershaft/N [f] [def: membership]
		mitglidgelt [n] [def: membership fee]
glik/N [n] [def: happiness; luck; joyous event]
	gliklekh/K [def: lucky, happy] ibergliklekh/A [def: over-happy]
	umglik/N [def: bad luck] umgliklekh/A [def: unlucky]
	baglik/V/Bbaglikt [def: make happy, make fortunate]
	glikishok [def: ??] % vuhin ikh zol nit geyn vel ikh keyn glikishok nit dergeyn
	[idiom: zol zayn mit glik = good luck]
glin [def: ding (sound of a bell)] glon [def: dong (sound of a bell)]
glitsh/V/T [def: slip] /Garop/Garoys
	/Gdurkh [def: swipe (card)] 
	/Iik
gliver/V/T [def: solidify]
	fargliver/V/Bfarglivert [def: solidify]
global/A [def: global]
glok/Xgleker [m] [def: bell] /Dglek
	glekerdik/A [def: bell-like]
	glekl/V/T [def: jingle] % Harduf
	tirglekl/Eekh [n] [def: doorbell] % Harduf 
glorye/S [f] [def: glory] 
glosar/N [m?] [def: glossary] 
glots/V/T [def: squint] /Garoys/Goys
	farglots/V/Bfarglotst [def: squint]
gloyb/V/T [def: believe] [grammar: takes dative]
	bagloyb/V/Bbagloybt [def: believe]
	gloybik/A [def: believing]
		ibergloybik/A [def: superstitious]
		umgloybik/A [def: disbelieving]
	gloyblekh/A [def: believable] umgloyblekh/A [def: unbelievable]
	gloybn/S [m] [def: belief]
		oybergloybn/S [m] [def: superstition] 
	[idiom: gloyb yo gloyb nit = believe it or not]
gloz/Xglezer [n/f] [def: glass] /Dglez [def: drinking glass] 
	glezern/A [def: glass] glezen/A glezerlekh % variant forms
	glezer/S [m] [def: glazier] % Harduf
	farglezer/V/Bfarglezert [def: make glassy]
	mestglezl/Eekh [n] [def: measuring cup] 
	glezl/V/T [def: guzzle, drink hard liquor] 
glust/V/T [def: desire]
	farglust/V/Bfarglust [def: desire]
	glust [m] /Iik glustung/N [f] [def: desire] glustikayt/N [f]
gnide/S [f] [def: nit (insect egg)] 
gnod/N [f] [def: divine assent; grace]
	gnedik/K [def: favorable; gracious] % zol mayn zikorn zayn gnediker
	bagnedik/V/Bbagnetikt [def: forgive, release from prison] 
godl{gdwl}/Xgedoylem{gdwlym}/H [def: sage, great one]
	/Lh [def: the great]
	gadles{gdlwT}/H [def: greatness]
	gadlen{gdln}/Xgadlonem{gdlnym}/H [def: great one] 
	gedule{gdwlh}/H [def: greatness; grandeur]
	gedoyley{gdwly}/H [def: great ones of] 
	gedile{gdwlh}/H [def: big deal]
goen{gown}/Xgeoynem{g#wnym}/H [m] [def: sage; genius]
	geoynish{gownish}/A [def: sagacious]
gol/V/T [def: shave] /Gop
	gol/A [def: bare, pure]
	[idiom: a gol kop = bald head]
gold /Iik [n] [def: gold (Au)] goldn/A gildern/A gildn/A [def: golden]
	gingold gingoldn/A [def: pure gold]
	bagild/V/Bbagildt [def: gild]
	gilder/V/T [def: become golden] 
	gildeyn/N [def: unit of currency] gildn
goles{glwT}/H [def: exile] /Idik
golf [m] [def: golf (game)] 
golf/N [def: turtleneck sweater]
golova [m] [def: head, chief, mayor (Russian)] 
gombe/S [f] [def: chin]
gomer{gmwr}/H [def: finish]
gomolke/S [def: snowball (Russian)] 
goner/S [m] [def: gander, male goose]
gonerar/N [def: honerarium (payment)] 
gontse/S [def: horserider announcing news]
gopl/N [m] [def: fork] /D
	fargoplt/A [def: forked] 
gor [adv] [def: very; entirely] /A [def: whole] 
gorgl/N [m] [def: throat] /Idik
	gorgl/V/T [def: gargle] % Harduf
gorile/S [f] [def: gorilla] % Harduf
gorn/S [m] [def: floor, story] /Idik
	tsveygorndik/A [def: two-storied]
	draygorndik/A [def: three-storied]
	firgorndik/A [def: four-storied]
	finfgorndik/A [def: five-storied]
gortn/Xgertner [m] [def: garden] /Dgertnd
	gertner/S [m] gertnerin/S [f] [def: gardner]
	gertnerirer/S [m] gertnerirerin/S [f] [def: gardner]
	gertneray' [n] [def: gardening, horticulture]
	vayngortn/Xvayngertner [m] [def: vineyard]
got/Xgeter [m] [def: God, deity] gotenyu [def: dear God]
	getlekh/A [def: Godly, divine]
	fargeter/V/Bfargetert [def: deify; idolize, adore]
	gets/N [m] getshke/S [m] opgot/Xopgeter [m] [def: idol] 
	getin/S [f] [def: goddess, idol]
	[idiom: got iz mir dir = what's wrong with you? (comforting)]
gotish/A [def: Gothic]
goy{gO}/Xgoyem{goAm}/H [m] /Iish [def: non-Jew, nation] /Ll
	% BUG: goyish needs khirik-yud; goyem apparently not
	goye{gOe}/S [def: non-Jewish woman]
goylem{gwlm}/Xgoylomem{gwlmym}/H [m] [def: artificial man]
goymel{gwml}/H [def: blessing of deliverance]
	gemiles{gmylwT}/H [def: generosity]
	gemiles{gmylwT}-khesed{Hsd} [def: interest-free loan]
goyrem{gwrm}/H [def: cause (with "zayn")]
goyrl{gwrl}/H [def: fate] /Idik
	[idiom: varfn goyrl = cast lots, toss a coin ("mit a matbeye{mtbeh}")]
goyses{gwss}/H [def: person on deathbed] /Idik [def: at death's door]
	gesise{gsys|h} [def: last gasp] /Idik [def: at death's door]
goyzer{gwzr}/H [def: command (with "zayn")]
	gezeyre{gzyrh}/Xgezeyres{gzyrwT}/H [f] [def: decree]
	gzar{gzr}/H [def: decree of]
grabitelte/S [def: robber (Russian)] 
grabl/V/T [def: scratch; search on the ground by hand]
	grablye/S [f] [def: rake]
grad/N [m] [def: grade; degree] % Harduf 
	gradnik/Ees [m] [def: thermometer] 
grad grade [def: just] % mostly uninflected
gradui'r/V gradui'rt/A [def: graduate]
graf/N [m] grafin/S grafinye/S [f] [def: count, noble]
	graferay'/N [f] [def: county]
grafik [f] [def: graphics (subject)] grafish/A [def: graphic]
	gra'fiker/S [def: graphic designer] [note: V]
grager/S [m] [def: noisemaker; rattle]
	grageray'/N [f] tsegrager/V/Btsegragert
	greger/S [m] [def: Purim rattle; rattle] % Harduf 
gram/N [m] [def: gram]
gram/V/T [def: rhyme] gram/N [m] [def: rhyme] gramer/S [m] [def: rhymer, poet]
gramafon/N [m] [def: gramophone, phonograph]
gramatik/Ees [f] [def: grammar] gramatish/A [def: grammatical] 
	gramatiker/S [m] [def: grammarian] 
	gramatikalish/A [def: grammatical]
gra'motne/A [def: literate; educated] 
grana't/N [m] [def: grenade (weapon)] 
granit [m] [def: granite] 
grasi'r/V/Bgrasi'rt [def: rule with an iron hand; have the upper hand] 
grate/S [f] [def: grate (on a window)] 
gratsh/N [m] [def: hot-headed person] 
	oysgegratshet/A [def: bulging (eyes)] 
	gratshke/S [f] [def: ratrace] 
gratsye'z/A [def: gracious] 
gratuli'r/V/Bgratuli'rt [def: congratulate] % Harduf 
gravi'r/V/Bgravi'rt /Gayn [def: engrave] 
grayf/V/Bgrifn % never found without an adverbial complement
	/Gon [def: assault] 
	bagrayf/V/Bbagrifn [def: grasp] bagrif/N [def: concept] 
graylekh [def: certainly]
graypl [n] [def: pellet, granule, dry cereal] grayplekh % no positive
grayz/N [m] [def: mistake, error] fargrayzt/A [def: defective]
grayzl/Eekh [n] [def: curl] 
grenets/V/T [def: border on]
	fargrenets/V/Bfargrenetst [def: delimit]
	bagrenets/V/Bbagrenetst [def: limit]
		bagrenetsung/N [f] [def: limitation]
	grenets/N [m/f] [def: border; boundary]
		landgrenets/N [m] [def: border (country)]
grepts/V/T [def: burp] grepts/N [m]
gret [n] [def: laundry, clothes and linens to be washed] % no plural
greykh/V/T [def: reach]
	dergreykh/V/T [def: reach; achieve]
	dergreykhung/N [f] [def: reaching; goal; achievement]
greyt/V/T [def: prepare] /Gtsu/Gon
	greyt/A [def: ready]
	greytkayt/N [f] [def: readiness] % Harduf 
	tsugreytung/N [f] [def: preparation]
grif/N [m] [def: vulture] % Harduf 
gril/N [f] [def: cricket]
	grilts/V/T [def: chirp; grate, make an unpleasant sound]
grim/N [m] [def: actor's make-up] 
	grimi'r/V/Bgrimi'rt [def: apply make up] 
grimase/S [f] [def: grimace] 
grime/V/T [def: burn] 
	gri'menish [n] [def: colic (disease)] 
	grimik/A [def: burning] 
grin/A /Ilekh /Iink [def: green; inexperienced]
	grinkayt/N [f] [def: green quality] 
	grins/N [n] [def: greens (vegetables)]
	grin/V/T [def: become green] /Goys [def: become experienced]
	fargrint/A [def: made green]
grind/V/T [def: found]
	grinder/S [m] grinderin/S [f] [def: founder]
	grindung/N [f] [def: founding] 
	fargrind/V/Bfargrindet [def: found]
	bagrind/V/Bbagrindt [def: prove, substantiate] 
gring/K [def: easy; light]
	fargringer/V/Bfargringert [def: ease; facilitate]
	otem-fargringerer/S [def: decongestant] [note: V]
gripe/S [f] [def: grippe (disease)] 
gris/V/T [def: greet]
	bagris/V/Bbagrist [def: greet] bagrisung/N [f] [def: greeting]
		hoyptbagriser/S [m] [def: host (of a lecturer)]
	gris/N [m] [def: regards] grus/N [m] bagrus/N [m] [def: greeting]
grits [f] [def: grain porridge]
grive/S [f] [def: mane]
grivn/A grivenes [def: rendered poultry fat]
grizhe/V/T [def: gnaw]
grizote [def: sorrow]
gro/A [def: gray] groy/A grov/A
	[idiom: blay gro = livid]
grob/A/Kgreb [def: thick; rude, coarse, vulgar, uncouth; tacky]
	/Ilekh [def: coarse]
	groybyan [m] [def: uncouth person] 
	grobkayt/N [f] [def: coarseness; rudeness]
	fargrebt/A [def: coarsened] 
	greb/N [f] [def: thickness] 
	[idiom: vern greber vi lenger = derive great pleasure from family members]
grob/V/Bgegrobn [def: dig] /Garayn/Gayn/Gon/Gunter/Gop
	/Goys [def: unearth, excavate] 
		oysgrobung/N [f] [def: excavation] 
	bagrob/V/Bbagrobn [def: bury]
		bagreber/S [m] [def: undertaker] 
	fargrob/V/Bfargrobn [def: bury]
	dergrob/V/Bdergrobn [def: dig]
	greber/S [m] [def: digger] 
grod/A [def: exact, even, straight] grod [adv] [def: precisely; just] 
gros/X [m] [def: a gross]
groshn/X [m] [def: groshen (currency)]
	groshedik/A [def: money-centered]
	[idiom: nit hobn keyn groshn = impoverished]
	[idiom: nit vert keyn groshn = worthless]
grotesk/A [def: grotesque]
groy/A [def: gray] grinlekhgroy/A [def: green-gray]
	groyink/A [def: person with gray hair]
groyl/N [m] [def: terror, horror, shudder] /Iik/Iekh [def: horrible, hideous]
groyp/N [f] [def: grain of cereal, cereal, barley, pellet] /Dgrayp
	perlgroypn [f] [def: barley] 
	farfl/X [m] [def: farfl noodles]
groys/Kgres [def: large]
	groys [f] [def: size] groyskayt/N [f] [def: greatness]
	fargreser/V/Bfargresert [def: enlarge]
		fargreserung/N [f] [def: enlargement] 
	groys/V/T [def: behave importantly (with "zikh")]
	[idiom: azoy groys azoy kleyn vi = neither more nor less than]
	greys [f] [def: size, dimension]
groyzam/A [def: cruel] groyzamkayt/N [f] [def: cruelty]
groz/N/Eer [n] [def: grass] /Iik /Dgrez
	federgroz/N [n] [def: fern] 
	lonkegroz/N [n] [def: meadow grass] 
	vildgroz/N [n] [def: weed] 
grub/Xgriber [m/f] /Dgrib [def: pit; grave]
	gribldik/A [def: pit-like]
	keslgrub/Xkeslgriber [m/f] [def: unfortunate situation ??]
		% in voser keslgrub zey zaynen arayngedreyt
	shmaltsgrub [m/f] [def: lap of luxury]
	shlosgrub/Xshlosgriber [m/f] [def: moat] [note: V]
	vasergrub/Xvasergriber [m/f] [def: moat] [note: V]
	zaltsgrub [m/f] [def: saltmine]
	/Dkheyn{Hn}-grib [def: dimple] 
	gribl/V/T [def: dig; search thoroughly, probe]
		[idiom: griblen di noz = pick the nose]
grunt/N [m] [def: ground; foundation; reason]
	hintergrunt/N [m] [def: background]
	[idiom: geyn tsu grunt = go astray]
	opgrunt/N [m] [def: abyss, cliff]
	untergrunt/N [m] [def: underground]
	gruntik/A grintlekh/A gruntovne/A [def: attentive; fundamental] 
	grunti'r/V/Bgrunti'rt grunteve/V/T [def: lay a foundation] 
	dergrunteve/V/Bdergruntevet [def: achieve (with "zikh tsu/biz")] 
grupe/S [f] grup/N [f] [def: group]
	grupi'r/V/Bgrupir't [def: group] % Harduf 
	grupirung/N [f] [def: grouping] 
gruz [m] [def: load, cargo, gravel, rubbish] 
	gruzeve/V/T [def: carry a load] /Garayn
gruzne/S [f] [def: bog] 
gubernator/N [m] [def: governor] gubernye/S [f] [def: governance district]
guf{gwf}/Xgufem{gwfym}/Xgufemlekh{gwfymlekh}/H [def: body] /Ilekh /Iik
	gufe{gwf#}/H [def: to the point, itself]
	gufniyes{gwfnywT}/H [def: physicality]
	dargufik{dargwfik}/A [def: thin]
gula'yeve/V/Bgula'yevet [def: stroll (Slavic)] 
gulye/S [f] [def: gall, growth] 
gume [f] [def: rubber] /In [def: rubber]
	gumelastik/Ien [def: rubber] 
gumen/S [def: palate, roof of mouth]
gurt/V/T [def: gird] /Gon [grammar: requires "on"] 
gust/N [m] [def: liking, taste] 
	[idiom: nokh emetsns gust = according to someone's taste]
gut/Kbes [def: good] /Iink
	aldosgut|s [def: the best] ambestn
	gut|skayt/N [f] gutkayt/N [f] [def: goodness]
	umgut/N [def: evil]
	beser/V/T farbeser/V/Bfarbesert [def: improve]
		beserung/N [f] farbeserung/N [f] [def: improvement]
	oysbeserung/N [f] [def: repair]
	fargitik/V/Bfargitikt [def: upgrade; compensate] 
		fargitikung/N [f] [def: compensation] 
	nisht-gut/A [def: evil] 
guzme{gwzm#}/Xguzmes{gwzm#wT}/H [f] [def: exaggeration]
	megazem{mgzm}/H [def: exaggerate (with "zayn")]
gvardye/S [f] [def: guard]
gvul{gBwl}/H/N [m] [def: border]
gzims/N [m] [def: cornice, ledge, shelf] 
ha [interj] [def: ha! (expression of surprise)]
ha/Een [m] [def: the letter H] 
habe{hb#}/H haboem{hb#ym}/H [adj] [def: to come]
hadibres{hdbrwT}/H [def: the words/commandments]
hafnyum [m] [def: hafnium (Hf)] 
hafsoke{hfsk|h}/Xhafsokes{hfskwT}/H [def: intermission]
haft/N [f] [def: coherence] /Iik [def: coherent, substantial, tenable] 
	ha'ftikayt/N [f] [def: persistence, cohesion] 
	gevisnhaftik/A [def: intellectually substantial] 
haft/N [m] [def: embroidery]
hagam{hgm}/H [conj] [def: although]
hagode{hgdh}/Xhagodes{hgdwT}/H [f] [def: Passover Haggadah] 
hak/V/T [def: cut, chop; knock; chatter]
	/Garayn/Garoys/Gayn/Gop/Goys/Gunter/Gtsu/Garop
	/Giber [def: interrupt]
	farhak/V/Bfarhakt [def: chop]
	tsehak/V/Btsehakt [def: chop]
	hak/Xhek [f] [def: hatchet; axe] /Dhek [def: hatchet] 
	holts|haker/S [m] holts|heker/S [m] [def: woodcutter]
	haker/S [m] [def: (stone-) cutter]
hakdome{hkdmh}/Xhakdomes{hkdmwT}/H [f] [def: introduction, preface]
hakhlote{hHlth}/Xhakhlotes{hHltwT}/H [f] [def: decision] 
hakhnoe{hxneh}/H [def: submissiveness] /Idik
hakhnose{hxns|h}/Xhakhnoses{hxnswT}/H [def: income; provision]
	hakhnosas{hxnsT}/H [def: provision for]
	makhnis{mxnys}/H [def: hospitable (with "- orkhem")]
hakhome{hHmh}/H [f] [def: the sun]
hakhone{hxnh}/Xhakhones{hxnwT}/H [f] [def: preparation]
	mukhen{mwxn}/H [def: prepared]
hakl{hKl}/H [def: of all]
hakofe{hkfh}/Xhakofes{hkfwT}/H [f] [def: Torah procession] 
halb/A [def: half] onderthalb/N [def: 1.5]
	finfhalbn [def: 5.5] zekshalbn [def: 6.5] zibnhalbn [def: 7.5]
	akhthalbn [def: 8.5] naynhalbn [def: 9.5]
	helft/N [f] [def: half]
haldz/Xheldzer [m] [def: neck] /Dheldz 
	haldz/V/T [def: embrace] haldzung/N [f] [def: embrace] 
	[idiom: es krikht fun haldz aroys = it's unbearably repetitive]
	[idiom: du megst zikh shemen in dayn vaytn haldz arayn = you should be ashamed of yourself]
haleshke/S [def: stuffed cabbage]
halevay{hlva|y}/H [def: if only!, would that!; hopefully]
halo [interj] [def: hello!] 
halokhe{hlxh}/Xhalokhes{hlxwT} [f] [def: religious law]
	hilkhas{hylxT}/H [def: religious law of]
halt/V/Bgehaltn [def: hold; stop (in imperative)]
	/Gtsu/Gadurkh/Gfest/Gon/Goyf/Goys/Gunter/Gtsurik
	/Goys [def: survive]
	/Gayn [def: restrain] 
	/Gop [def: abstain] 
	haltung/N [f] [def: posture; attitude] % Harduf
	oys|haltevdik/A [def: robust] 
	anthalt/N [m] [def: contents (German)]
	bahalt/V/Bbahaltn [def: hide] /Goys
		farbahalt/V/Bfarbahaltn [def: hide] 
	bahe'ltenish/N [n] [def: hiding place]
		/Dbahalter [def: hiding place]
	derhalt/V/Bderhaltn [def: acquire; receive; preserve]
	gehalt/N [n] [def: salary, pay]
	farhalt/V/Bfarhaltn [def: hide; delay]
		farhaltenerheyt [adv] [def: hidden, delayed] 
		[idiom: bashteln farhaltenerheyt = back order] [note: V]
	inhalt/N [m] [def: contents] /Iraykh [def: compendious]
	oysgehaltnkayt [f] [def: survival]
		nitoysgehaltnkayt [f] [def: extinction]
	onha'ltenish/N [def: ??]
	ophaltung/N [def: abstention] 
	bukhhalter/S [m] [def: book-end, accountant, bookkeeper]
		bukhhalterye/S [f] [def: account, bookkeeping]
	[idiom: haltn fun epes = believe in something]
	[idiom: haltn in eyn (+ infinitive) = do nothing but (+verb)]
	[idiom: haltn bay (+ infinitive) = be about to (+verb)]
halvoe{hlv#h}/Xhalvoes{hlv#wT}/H [f] [def: loan]
hamer/S [m] [def: hammer] /Dhemer
	hamer/V/T [def: hammer out] /Gdurkh
ha'meve/V/T [def: restrain, check, brake] /Gayn
hamoyn{hmwn}/Xhamoynem{hmwnym}/Xen/H [def: crowd; rabble]
handl/V/T [def: trade, buy and sell; act]
	/Gayn/Giber/Gop/Gunter
	bahandl/V/Bbahandlt [def: treat]
		bahandlung/N [f] [def: treatment] 
		[idiom: nit tsum bahandlen = unwieldy, awkward]
	farhandl/V/Bfarhandlt [def: buy and sell]
	unterhandler/S [def: agent, go-between] 
	handl/N [m] [def: commerce; store (with noun indicating merchandise)]
		[idiom: sforem{sfrym} handl = bookstore]
		gasnhandl [def: street trade] 
		velthandl [def: world trade]
	handls [prefix] [def: pertaining to trade] 
	handlung/N [f] [def: action] 
		farhandlung/N [f] [def: negotiation] 
		ophandlung/N [f] [def: treatise, discourse]
		unterhandlung/N [f] [def: secret handling]
	hendler/S [m] [def: merchant] /Iish
		bukhhendler/S [m] [def: bookseller]
		ferdhendler/S [m] [def: horse trader]
		gasnhendler/S [m] [def: street seller] 
	kleynhendl [def: small goods]
hanoe{hn#h}/Xhanoes{hnowT}/H [f] [def: pleasure] /Idik
	hanoedikayt{hn#hdikayt}/N [f] [def: pleasure] 
hanokhe{hnHh}/Xhanokhes{hnHwT}/H [def: setting down; discount (price); premise]
hant/Xhent [f] [def: hand] /D [def: little hand; handle] 
	eyberhant/Xeyberhent [f] [def: superior position; dominance] 
	groys|hantik/A [def: generous]
	ophentik/A [def: helpless] 
	hentshke/S/D [f] [def: glove]
	[idiom: trogn emetsn oyf di hent = treat someone with special honor]
	[idiom: nisht in emetsns hant = out of one's control]
	[idiom: bay emetsn in di hent = at one's mercy]
	[idiom: fun der ershter hant = hands-on experience]
hantshirke/S [def: rag]
hapokhes{hpHwT}/H [def: the least]
har/N [m] [def: master] % Harduf
harb/A [def: stringent]
harbst/N [m] [def: Autumn (season)] /Iik
harem/S [m] [def: harem] % Harduf
harf/N [f/m] [def: harp (musical instrument)]
harge{hrge}/Vhargenen{hrgenen}/T [def: murder, beat] /Goys
	derharge{derhrge}/Vderhargenen{derhrgenen}/Bderharget{derhrget} [def: murder; kill]
	tseharge{tsehrge}/Vtsehargenen{tsehrgenen}/Btseharget{tsehrget} [def: murder; kill]
	harige{hrygh}/Xhariges{hrygwT}/H [f] [def: slaughter]
	harugem{hrwgym}/H [def: victims of slaughter]
	[idiom: harge{hrge} mikh ikh zol + infinitive = I couldn't possibly + verb]
harike/V/T /Gon [def: ??] % ongedungen zikh un ongehareket zikh gut
harmat/N [m] [def: cannon (weapon)] harmatnik/Ees [m] [def: cannoneer]
harmider [def: noisy gathering]
harmonye/S [f] [def: harmony] harmonish/A [def: harmonious] 
harmoshke/S [f] [def: harmonica] garmoshke/S [f]
hart/K [def: hard] harteve/V/T
	farharteve/V/Bfarhartevet [def: harden; make sturdy] 
	hartkayt/N [f] [def: hardness] 
harts/N/Xhertser [n] [def: heart]
	/Iik/Iedik [def: hearty; cordial] /Dherts [n] [def: heart]
	hartsenyu [def: dear heart]
	hartsloz/A [def: heartless] 
	hertslekh/A [def: hearty]
	baremhartsik/A [def: merciful] baremhartsikayt/N [f] [def: mercy] 
	barmhartsik/A [def: merciful] barmhartsikayt/N [f] [def: mercy]
	breythartsik/A [def: generous] breythartsikayt/N [f] [def: generosity] 
	guthartsik/A [def: generous]
	laykhthartsik/A [def: lighthearted] 
	rey'nhartsik/A o'fnhartsik/A [def: honest, in good faith]
		rey'nhartsikayt/N o'fnhartsikkayt/N [f] [def: honesty, good faith] 
	veykhhartsik/A [def: sympathetic]
	[idiom: tsum hartsn = agreeable]
	[idiom: shlogn (emetsn) tsum hartsn = disgust (someone)]
has/V/T [def: hate] heslekh/A [def: hateful; ugly]
hasbore{hsbrh}/Xhasbores{hsbrwT}/H [f] [def: opinion]
hashem{hSm}/H/S [def: God]
hashgokhe{hSgHh}/H [f] [def: supervision, custody, Providence]
	mashgiyekh{mSgyH}/Xmashgikhem{mSgyHym}/H [m] [def: Rabbinic supervisor] 
hashkofe{hSkfh}/Xhashkofes{hSkfwT} [def: (religious) view]
hashore{hSerh}/Xhashores{hSerwT}/H [f] [def: guess, hypothesis, assumption]
	/Idik
hashpoe{hSpeh}/Xhashpoes{hSpewT}/H [f] [def: influence]
	mashpiye{mSpye}/H [def: influence (with "zayn")]
	mushpe{mwSpe}/H [def: be influenced (with "vern")]
hashtone{hSWnh}/H [f] [def: urine]
haskome{hsKmh}/H [m] heskem{hsKm}/H/S [m] [def: agreement]
hastik/A [def: hasty]
hasyum [m] [def: hassium (Hs)] 
havaye{hevyh}/Xhavayes{hevywT}/H [def: grimace; gesture]
havdole{hBdlh}/Xhavdoles{hBdlwT}/H [f] [def: ceremony at end of Sabbath, havdole candle]
	havdil{hBdyl}/H [def: distinguish] /Ll
	[idiom: l|havdil b|elef havdoles = to make a large distinction]
have{hwh}/H [def: it was]
havke/V/T [def: bark (sound of dog)]
havn/S [m] [def: harbor]
	hafn/S [m] [def: harbor] [usage: inadmissable]
havtokhe{hBtHh}/Xhavtokhes{hBtHwT}/H [f] [def: assurance]
haybam/N [f] [def: midwife]
hayda [interj] [def: lo and behold] 
haynt/Iik [def: today]
	derhayntik/V/Bderhayntikt [def: update, upgrade]
hayrat/V/T [def: marry (German)]
	farhayrat/V/Bfarhayrat [def: marry]
hayter/V/T [def: cheer] /Goyf [usage: deprecated]
	hayter/K [adv] [def: cheerful] [usage: deprecated]
haze{hz|h}/H [def: this] /Idik
	hazenik{hz|hnik}/Ees [m] [def: person involved in the present] 
hebreish/A [def: Hebrew] hebreizm/N [m] [def: Hebraism]
	hebrizi'r/V/Bhebrizi'rt [def: Hebraize]
	dehebrizi'r/V/Bdehebrizi'rt [def: de-Hebraize]
		dehebrizatsye/S [f] [def: de-Hebraization]
hefker{hfkr}/H [adj] [def: ownerless; licentious] /Idik
	hefkeyres{hfkrwT}/H [def: ownerlessness; licentiousness]
	mafker{mfkyr}/H [def: declare ownerless, act altruistically (with "zikh") (with "zayn")] 
heflekh/A [def: polite] heflekhkayt/N [f] [def: politenss]
hefsed{hfsd}/Xhefseydem{hfsdym} [m] [def: loss, injury] 
heft/V/Bgehoftn [def: weave] /Gtsuzamen/Gtsunoyf % variant: /T
	/Goys [def: embroider]
	baheft/V/Bbahoftn [def: weave] baheftung/N [f] [def: weaving]
	geheft/N [n] [def: farmyard, compound]
	shofgeheft/N [n] [def: sheep farm]
	heft/N [n] [def: notebook]
		notits|heft/N [n]
	heftik/A [def: violent, fierce (German)]
heftling/N [m] [def: prisoner (German)]
hegemonye/S [f] [def: hegemony] 
hek/N [m?] [def: distant place]
	[idiom: fun ekn un hekn = from all sorts of places]
hekhsher{hxSr}/Xhekhsheyrem{hxSrym}/H [def: rabbinical permit; seal of kosher supervision]
hekht/X [m] [def: pike (fish)]
hekl/V/T [def: crochet] /Dhek [def: loop]
hel/A [def: bright; clear] /Iish
held/N [m] heldin/S [f] [m] [def: hero]
	heldish/A [def: heroic]
	heldishkayt/N [f] [def: heroism]
	antiheld/N [m] [def: antihero]
helf/V/Bgeholfn [def: help] /Garoys/Goys/Gunter/Gmit [grammar: takes dative]
	derhelf/V/Bderhelft [def: help]
	hilf/N/S [f] gehilf/N [m] [def: help; assistant]
		gehilf [adj] [def: assistant] % uninflected, as in "gehilf redaktor" 
		teykef{WyKf}-hilf/N/S [f] [def: quick help] 
	helfer/S [m] mithelfer/S [m] bahelfer/S [m] [def: helper, assistant]
	belfer/S [m] [def: assistant teacher (in a kheyder)] 
	helfik/A bahilfik/A [def: helpful]
	bahelf/V/Bbaholfn [def: help]
	umbaholfn/A [def: not helped]
	umbaholfnkayt/N [f] [def: state of not being helped]
	hilfloz/A [def: helpless]
helfand/N [m] helfandkhe/S [f] elfand/N [m] [def: elephant]
helm/N [def: helmet] shtolhelm/N [def: steel helmet]
	bahelmt/A [def: helmeted] 
helyum [m] [def: helium (He)] 
hemd/Eer/D [n] [def: shirt (clothing)]
	meshugoyem{mSwge|ym}-hemd/Eer/D [n] [def: straitjacket] 
	nakhthemd/Eer/D [n] [def: nightshirt (clothing)]
	unterhemdl/Eekh [n] [def: undershirt (clothing)] 
hendum [def: (with "- pendum") in a rush]
heng/V/Bgehangen [def: hang]
	/Garoyf/Garoys/Garop/Garunter/Gon/Goys/Gariber/Giber/Goyf
	farhang/V/Bfarhangen [def: drape]
	bahang/V/Bbahangen [def: drape] 
	arophang/N [m] [def: cliff, slope] 
	forhang/N [m] firhang/N [m] [def: curtain] /Dforheng /Dfirheng
	tsuzamenhang/N [m] [def: connection] 
	/Dheng [def: bunch (of grapes)] % Harduf
	henker/S [m] [def: hangman] % Harduf
	heng/V/T [def: hang] /Goys/Gop/Garoys/Gariber/Gfunander/Gon
		firheng/D [m] [def: drape]
		henger/S [m] [def: hanger] onhenger/S [m] [def: adherent]
		ophengik/A [def: dependent]
		umophengik/A [def: independent]
			umophengikayt/N [f] [def: independence]
heore{herh}/Xheores{herwT}/H [def: footnote; note]
her/V/T/Gtsu [def: hear, smell (with "zikh")]
	/Goys/Gon/Gtsu/Gunter
	/Gayn [def: pay attention] 
	/Goyf [def: stop]
		[idiom: nisht oyfhern tsu = keep on ..ing]
	/Goys [def: hear somebody out]
	derher/V/Bderhert [def: discover]
	farher/V/Bfarhert [def: listen to a student recitation]
		durkhfarher/N [m] [def: cross-examination] % Harduf
	tsuher/V/Btsugehert [def: listen (to) (with "zikh (tsu)")] 
	ontsuhe'renish/N aynhe'renish/N [def: news]
	tsuherer/S [m] [def: attentive listener]
	oyfher/N [def: stopping] umoyfherlekh/A [def: unstoppable]
	oys|her/N [def: hear]
		oys|herer/S [m] [def: listener] 
	umgehert/A [def: unheard]
	geher [n] [def: hearing, sense of pitch]
	herevdik/A [def: able to hear] 
	aynherik/A [def: attentive] 
	[idiom: makhn zikh nit herevdik = turn a deaf ear]
	[idiom: fregn vos se hert zikh = say hello]
her/N [m] [def: gentleman] % Harduf
	herlekh/A [def: lovely; glorious]% Harduf
hering [m] [def: herring (fish)]
hermetish/A [def: hermetic] 
hero/N /Iish [m] [def: hero (English)]
hersh/V/T [def: rule]
	bahersh/V/Bbahersht [def: dominate] bahersher/S [m] [def: master]
		bahershung/N [f] [def: domination] 
	hershung/N [f] [def: rule] 
		aleyn-hershung/N [f] zelbsthershung/N [f] [def: self-rule] 
	hersher/S [def: ruler] 
	her/N [m] [def: mister] hershaft/N [f] [def: mastery]
	har/N [m] [def: master (German)]
hertsog/N [m] [def: duke] % Harduf
heshe/V/T [def: snivel, sob] 
	farheshet/A [def: breathless, sobbing] 
hespayles{hTpelwT}/H [def: delight]
	nispoyel{nTpel}/H [def: amazed]
hesped{hspd}/Xhespedem{hspdym}/H [m] [def: eulogy; funeral lament]
	masped{mspyd}/H [def: eulogize (with "zayn")]
het [adv] [def: far away (space or time)]
	[idiom: het a mol = a long time ago]
heter{hyWr}/H [m] [def: permission]
hets/V/T [def: incite; bait (with "kegn")]
	hetse/S [f] [def: incitement]
	hetser/S [m] [def: inciter] 
hey [n] [def: hay]
hey [interj] [def: hey!] 
heyb/V/Bgehoybn [def: raise, lift; exalt] /Garoys/Goyf/Gunter/Goyf/Gunter
	/Gon [def: begin]
		[idiom: es heybt zikh nit on un es lozt zikh nit oys = nonsense]
	farheyb/V/Bfarhoybn [def: raise]
	derheyb/V/Bderhoybn [def: elevate] derheybung/N [f] [def: elevation] 
	onheyb/N [m] [def: start] onheyber/S [m] [def: beginner]
	hoypt/A [def: principal]
		bahoypt/V/Bbahoypt [def: claim, argue; confirm] [usage: inadmissable]
			bahoyptung/N [f] [def: claims, arguments] [usage: inadmissable]
	iberhoypt [adv] [def: mostly]
	derhoypt [adv] [def: especially]
	hipsh/A [def: large, many (with "- bisl" or "etlekhe")]
heyd/N [m] [def: heathen] heydntum [n] [def: heathenism, paganism] 
heykhi{hyxy}/H [def: what is it like? (with "- dami")]
heykhl{hyxl}/Xheykholem{hyxlym}/Xheykholes{hyxlwT}/H [def: palace, temple] 
heyl/N [f] [def: cave, cavern]
heyl/V/T [def: heal, cure] /Goys
	farheyl/V/Bfarheylt [def: heal, cure] 
	heylung/N [f] [def: healing, cure]
	heyler/S [m] [def: healer] 
		alheyler [m] [def: heal-all (plant)] 
		gloybn-heyler/S [m] [def: faith healer] 
		gaystheyler/S [m] [def: spiritual healer] 
heylik/K [def: holy] heylikayt/N [f] [def: holiness]
	heyliker/Xheylike [m] [def: saint] 
	heylik/V/T [def: sanctify]
	farheylik/V/Bfarheylikt [def: sanctify]
heym/N [f] [def: home] /Iish /Iishlekh [def: comfortable; familiar]
	/Ilekh [def: cheerful] % Harduf
	heymlekhkayt/N [f] [def: comfort]
	heymishkayt/N [f] [def: feeling of being at home] 
	aheym [adv] aheymet [adv] [def: homeward]
	togheym/N [f] [def: day-care center] 
	noyte{nwth}-lomes{lmT}-heym/N [f] [def: hospice] [note: V]
	umheymlekh/A [def: uncomfortable] heymloz/A [def: homeless]
heyn{hn} [correl] [def: both .. and (with "azoy")] 
heyoys{hywT}/H [def: given that]
heypekh{hypwx}/H [def: opposite] /Ll
heys/V/Bgeheysn [def: order, tell]
heys/V/T [def: be called] /Ggut [def: ratify]
heysherik/N [m] [def: locust]
heyts/V/T [def: heat] /Gayn
	tseheyts/V/Btsehitst [def: heat]
	baheyts/V/Bbaheytst [def: heat] 
		heytsung/N [f] baheytsung/N [f] [def: heating] 
	heys/K [def: hot]
	hits/N [f] [def: heat; fever] /Iik heytsung/N [f] [def: heat]
		[idiom: redn fun hits = speak crazily]
		zumerhits/N [f] [def: heat of Summer]
/Xheyvn [def: yeast]
heyzerik/A [def: hoarse] /Ilekh heyzerikayt/N [f] [def: hoarseness]
hi [def: here] hig/A [def: local; resident of this locality] /Iedik
hider{hydwr}/H [def: beautification]
	mehader{mhdr}/H [def: beautify (with "zayn")]
hidra'nt/N [m] [def: fire hydrant] 
hidroksid [def: hydroxide (OH)]
higyene [f] [def: hygiene] % Harduf
hil/V/T /Gayn [def: surround]
	hile/S [f] [def: wrapper]
	farhilt/A [def: wrapped]
	farhoyln/A [def: concealed] 
	aynhilung/N [f] [def: wrapper] 
hilekh{hylwx}/H [def: journey]
hilke/S [f] [def: bat (sport)]
hilkh/V/T [def: make a loud noise, resound] /Gop
	farhilkh/V/Bfarhilkht [def: deafen (with noise)] 
	hilkhik/A hilkhedik/A [def: loud, resounding]
	krik|hilkh [m] [def: feedback (acoustic)] 
himen/S [m] [def: anthem] himne/S [f] [def: hymn]
himl/N [m] [def: sky; heaven] /Idik /Iish [def: heavenly; celestial]
	[idiom: himl efn zikh = all hell breaks loose]
hin ahin [def: there] ahintsu hinter hintn [def: behind] bizahin
	hintn/S [m] [def: back, rear] % Harduf
hind/N [f] [def: doe (animal)] 
hindus/N [m] [def: Hindu] 
hiney{hny}/H [def: behold]
hink/V/T/Bgehunken hinker/V/T [def: limp] hinkedik/A [def: lame; limping] 
hinter/P [def: behind] hintersht/A ahinter
hip/V/T /Giber [def: skip]
	hiper/V/T /Giber [def: skip; limp] % variant
hipnotizi'r/V/Bhipnotizi'rt [def: hypnotize]
	farhipnotizi'r/V/Bfarhipnotizi'rt [def: hypnotize]
	hipnoz [m] [def: hypnosis] % Harduf
hipokri't/N [m] [def: hypocrite] % Harduf
	hipokritstve{hipokrit|stve} [f] [def: hypocracy] 
hipote'k/N [f] [def: mortgage] % Harduf
hipote'z/N [m] [def: hypothesis] % Harduf
	hipotetish/A [def: hypothetical] % Harduf
hipsh/A [def: very; considerable]
hirhur{hrhwr}/Xhirhurem{hrhwrym}/H [m] [def: thought] 
hirsh/N [m] [def: deer, stag, buck (animal)]
hirzh [m] [def: millet] /D /In
hirzhe/V/T [def: neigh (sound of a horse)]
hislayves{hTlhBwT}/H [def: enthusiasm] /Idik
hisoyreres{hTewrrwT}/H [def: awakening (spiritual)]
histami'n [m] [def: histamine] 
	antihistami'n [m] [def: antihistamine] 
histerye/S [f] [def: hysteria] % Harduf
	histerish/A [def: hysterical]
historye/S [f] [def: history; story]
	historish/A [def: historical (English)]
		historishkayt/N [f] [def: historicality] 
	historiker/S [m] [def: historian] % Harduf
	prehistorye/S [f] [def: prehistory] 
		prehistorish/A [def: prehistorical] 
hit/V/T [def: guard; watch] /Gop/Goys
	/Goyf [def: save (computer), store (computer)]
	farhit/V/Bfarhit [def: prevent] 
		farhitung/N [f] [def: prevention] 
	bahit/V [def: guard]
		[idiom: bahit un bavornt = on guard]
	hiter/S [m] hiterin/S [f] [def: guard; guardian]
		laybhiter/S [m] [def: bodyguard] 
	opgehitkayt/N [f] [def: care]
hitsel/Ees [m] [def: dogcatcher] 
hob host hostu hot hobn/Idik gehat/A [def: have] % irregular
	libhober/S [m] [def: lover]
	[idiom: zayt|s mir un hot|s mir = goodbye (comical)]
hober [m/n] [def: oat; oats]
ho'deve/V/T [def: raise, rear; breed; cultivate] /Goyf/Gon/Goys
	hodivle [def: feed (for poultry)]
hof/V/T/Bgehofn [def: hope] hofloz/A [def: hopeless]
	farhof/V/Bfarhofn [def: hope] 
	hofenung/N [f] [def: hope] hoferdik/A [def: hopeful]
	[idiom: lomir hofn = hopefully]
hogl/V/T [def: hail] 
	hogl/N [m] [def: hail]
hok/N [m] [def: hook] % Harduf
hoki [m] [def: hockey (game)] % Harduf
hold [m] [def: hero]
holder/V/T [def: gobble (sound of a turkey)] 
/Xho'leptses /Xho'leshkes [def: stuffed cabbage (food)] % only in plural
holmyum [m] [def: holmium (Ho)]
holoveshke/S [f] [def: brand] 
holts [n] [def: wood (material)] hiltsern/A [def: wooden]
	valgerholts [n] [def: rolling pin]
	pik|holts [m] [def: woodpecker (bird)]
	farhiltser/V/Bfarhiltsert [def: make wooden]
	gehilts [n] [def: wooden material]
homofob/N [def: homophobe]
honik [m] [def: honey]
	[idiom: lekn honik far emetsn = benefit from someone]
honori'r/V/Bhonori'rt [def: honor] % Forwards
	honora'r/N [m] [def: honorarium; royalties] 
hopke/V/T [def: hop] 
hor/X [f] [def: hair; mainspring] /Dhere /Dhore
	/Iik [def: hairy]
	shtroyhorik/A [def: blonde] kurtshorik/A [def: short-haired]
horb/N [m] horbat/N [m] [def: hump] /A
horde/S [f] [def: horde] 
hore/S [f] [def: hora (Israeli dance)] % Harduf
hore_{hre}/H [def: the evil]
	enore{e|yn-hre}/H [def: evil eye] 
	[idiom: keyn enore{e|yn-hre} = may there be no evil eye]
	kinehore kenaynehore [interj] [def: no evil eye (heteromalofugitive expression] 
	[idiom: loshen{lSwn} hore{hre} = gossip]
horeve/V/T [def: work hard, toil] /Gop/Gon/Goys/Garayn
	horevanye/S [f] [def: hard work]
	farhoreve/V/Bfarhorevet [def: obtain through hard work]
	horepashnik/Ees [m] [def: toiler] % Harduf
horizont/N [m] [def: horizon]
horkh/V/T [def: notice; listen; obey] /Goys horkhzam/A [def: noticable] 
	gehorkhzam/A [def: obedient] % Harduf
	gehorkhzamkayt/N [f] [def: obedience] % Forwards
horme/S [f] [def: pile]
hormo'n/N [m] [def: hormone] % Harduf
horn/Xherner [m] [def: horn, antler] 
	bahernert/A [def: horned] 
hornitse/S [def: parlor (Russian)]
hote'l/N [m] [def: hotel]
hotseplots [n] [def: mythical distant place] [note: in Austria, near Silesia]
	ayshishtok [def: arbitrary distant place]
	shnipishok [def: distant place with a funny name] 
		[note: Jewish section of Vilna]
	pralnik [def: mythical book (with "seyfer -")]
hotske/V/T [def: shake, bump (with "zikh")] 
	/Idik [def: shaky, bumpy] 
hoyb/N [m] [def: hump]
hoyde/V/T [def: swing] hoyde/S hoydelke/S
hoyer/V/T [def: hover]
hoyf/N/Iik [m] [def: yard; court] /Dheyf [def: patio] 
hoyfn/S [m] [def: pile, heap; handful] /Dhayf [def: bunch, cluster, clump] 
	[idiom: shayter-hoyfn = bonfire, death at the stake]
hoyker/V/T [def: bend over] /Gayn
	hoyker/S [m] /Idik /Dheyker hoykerin/S [f] [def: hunchback]
	ayngehoykerterheyt [def: hunched over]
hoykh/Khekh [def: high; tall; loud] heykh [def: height; elevation] [f]
	tsveythekhst/A [def: second largest]
	hekher/V/T [def: raise (price, wages); promote]
	hekherkayt/N [f] [def: height]
	hekhstns [adv] [def: at most]
	hoykh/V/T [def: raise] /Garoys/Goys
	farhoykh/V/Bfarhoykht [def: raise]
hoyl/A [def: unadorned, pure]
hoyshayne{hwSen#}/Xhoyshaynes{hwSenwT} [def: Hoshana prayer (on Sukkes)] 
	hoyshayne{hwSen#}-rabo{rbh} [def: sixth day of Sukkes] 
	[idiom: shlogn hoyshaynes = beating the willow branches on hoyshayne-rabo]
	[idiom: opgeshlogene hoyshayne = object no longer useful, person no longer active]
hoysofe{hwsfh}/H [def: circuit]
hoyt/N [f] [def: skin] /Iik
	/Dhayt [def: membrane] % Harduf
	eynheytlekh/A [def: uniform]
	gendznhoyt/N [f] [def: goosebumps] 
	hoylhoytik/A [def: bareskin] 	
	[idiom: shpringen fun der hoyt = become emotional]
	[idiom: gendzene hoyt = goosebumps]
	[idiom: oyfhern fun der heler hoyt = quit cold turkey]
hoytsoe{hwc#h}/Xhoytsoes{hwc#wT}/H [f] [def: expenses]
hoyve{hvh} [m] [def: present (tense)] 
hoyz/Xhayzer [n] /Iik [def: house] /Dhayz
	hayzke/S [f] [def: hut] 
	bahoyzung/N [f] [def: shelter]
	aynforhoyz [n] [def: entrance hall]
	firhoyz/Xfirhayzer [n] [def: hall, lobby, antechamber] 
	rothoyz/Xrothayzer [n] [def: town hall]
	tenement-hoyz/Xtenement-hayzer [n] [def: tenement house] 
	varemhoyz/Xvaremhayzer [n] [def: greenhouse] 
	yidishhoyz [n] [def: Yiddish house]
	hoyz/V/T [def: dwell] 
	[idiom: geyn iber di hayzer = beg from door to door]
/Xhoyzn [def: trousers (clothing)]
	/Xgalife-hoyzn [def: riding breeches (clothing)] 
hoz/N/Xhezer [m] /Dhez hozikhe [f] [def: rabbit; hare]
hoze{hez|h}/H [f] [def: gall, impudence]
	azesnik{ezwTnik}/Ees [m] azesnitse{ezwTnitse}/S [f] [def: brazen person] 
	azes{ezwT}/H [def: effrontery, impertinence; gall] /Idik
hrube/S [f] [def: furnace; heating stove] 
hu{hw#}/H [def: he]
hu-ha [m] [def: bustle; noise] [interj] [def: wow!] 
hubl/N [m] [def: plane (tool)] % Harduf
	hubl/V/T [def: plane; smooth with a plane] % Harduf
hudzhe/V/T [def: buzz, hum (like machinery)]
	zuzhe/V/T [def: buzz, hum (like machinery)] zhuzhe/V/T % variants
	zuzheray'/N [def: buzzing, humming (like machinery)]
hulye/V/T [def: have fun; carouse] hulyeve/V/T /Gtsu
	hulyanke/S [def: partygoer]
	hultay/Ees hultayke/S [def: merrymaker, scoundrel]
humanist [m] [def: humanist] /Iish [def: humanistic]
	humanistik [f] [def: humanities (subject)]
humo'r/N [m] [def: humor]
	humori'st/N [m] [def: humorist] /Iish [def: humorous]
	humoreske/S [f] [def: humoresque]
hun/Xhiner [f] [def: hen] /Dhind [def: chick] hon/Xhener [m] [def: rooster]
	hinersh/A hinerish/A [def: chicken] 
	/Xhiner-hener [def: poultry]
	[idiom: kapore{Kprh} hindl = scapegoat]
hundert/A [def: hundred] yorhundert/Eer [m] [def: century]
	hunderter/S [m] [def: 100-dollar bill] 
	tsveyhundert/A [def: 200]
	drayhundert/A [def: 300]
	firhundert/A [def: 400]
	finfhundert/A [def: 500]
	zekshundert/A [def: 600]
	zibnhundert/A [def: 700]
	akhthundert/A [def: 800]
	naynhundert/A [def: 900]
	elfhundert/A [def: 1100]
	tsvelfhundert/A [def: 1200]
	draytsnhundert/A [def: 1300]
	fertsnhundert/A [def: 1400]
	finftsnhundert/A [def: 1500]
	zektstsnhundert/A [def: 1600]
	zibetsnhundert/A [def: 1700]
	akhtsnhundert/A [def: 1800]
	nayntsnhundert/A [def: 1900]
hunger/V/T [def: hunger; starve] /Gtsu/Goys
	farhunger/V/Bfarhungert [def: hunger]
	hunger [m] [def: hunger; famine] /Iik [def: hungry]
		hungerikerheyt [adv] [def: in a state of hunger] 
hunt/Xhint [m] [def: dog] /Dhint [def: puppy]
	hintish/A [def: dog-like, canine; mean]
	shofhunt/Xshofhint [def: sheepdog] 
	yam{|ym}-hunt/Xyam{|ym}-hint [def: seal (animal)] 
hur/V/T [def: frequent prostitutes]
	hur/N [f] [def: prostitute] hureray'/N [f] [def: prostitution]
hura' [def: interj] [def: hurrah!, hooray!] 
huraga'n/N [m] [def: hurricane] 
hurt [m] [def: wholesale]
	hurtovnik/Ees [m] [def: wholesale buyer]
	hurthendler/S [m] [def: wholesale dealer; wholesaler]
hust/V/T [def: cough] /Goys
	hust/N [m] [def: cough]
	farhust/V/Bfarhust [def: have a coughing fit (with "zikh")]
hut/N/Xhit [m] [def: hat (clothing)] 
	/Dhit [m] [def: women's hat (clothing)]
	hitl/N [n] [def: men's hat (clothing)] 
hyene/S [f] [def: hyena (animal)] % Harduf
hyerarkhye/S [f] [def: hierarchy] 
i [correl] [def: both .. and]
i/Een [m] [def: the letter I] 
i-e'm/N [m] [def: instant message, IM (computer) (with "shikn" or "oysbaytn"] [note: V] 
ibed{#bwd} [def: left over] /Ll
iber/P [def: over] /Iik [def: extra] iberikns
	ariber/P [def: over] iberal [def: generally]
	deriber [def: therefore]
	oybersht/A [def: most high] eybersht/A eybershtns
	eyber- [def: chief, upper] 
		oyber- [def: cheif, upper] [usage: inadmissable]
ibl [def: disgust] /Idik [def: disgusting]
	ibl/V/T [def: disgust] 
	faribl{far#ibl}/N [m] [def: grudge] /Idik
	[idiom: hobn faribl = take offence]
ibung/N [def: exercise]
idee/N/S [f] [def: idea] ideish/A [def: pertaining to ideas] 
	ideal/N [n] [def: ideal]
		ideali'st/N [m] [def: idealist]
		ideolog/N [def: idealogue] /Iish [def: idealogical]
	ideologye/S [f] [def: idealogy]
identifitsi'r/V/Bidentifitsi'rt [def: identify] 
	identifitsirung/N [f] [def: identification] 
	identitet/N [f] [def: identity]
	identish/A [def: identical] identishkayt/N [f] [def: sameness] 
idyom/N [m] [def: idiom] /Iatish [def: idiomatic]
idyot/N [m] [def: idiot]
ignori'r/V/Bignori'rt [def: ignore]
igrek/En [m] [def: the letter Y] 
iker{e|ykr}/H/Idik [def: main point] /Lb
	der|iker{e|ykr}/H [adv] [def: especially]
	ikersh{e|ykrsht} derikersht{dere|ykrsht} [adv] [def: especially; essentially] 
	oyker{ewkr}/H [def: uproot (with "zayn")] 
ikev{e|yKwB}/Xikuvem{e|yKwBym}/H [def: hindrance] 
ikh yakh [def: I] mir mikh [def: me] mayn/A/Iik [def: my]
	maynetvegn [def: my sake] 
	du dir dikh [def: you] dayn/A/Iik [def: your]
		daynetvegn [def: your sake]
		duts/V/T [def: speak in familiar voice]
		[idiom: zayn oyf du = speak in familiar voice]
	er [def: he] im [def: him] zayn/A/Iik [def: his]
		zaynetvegn [def: his sake]
	zi [def: she] ir/A/Iik [def: her] iretvegn [def: her sake]
	es se s im [def: it] zayn [def: its]
	zikh [def: self]
		inzikhizm/N [m] [def: introspective movement (art)]
		inzikhi'st/N [m] [def: follower of the introspective movement]
		fa'rzikhdik/A [m] [def: freelance] 
			fa'rzikhnik/N [m] [def: freelancer] [note: V]
	mir [def: we] undz [def: us] undzer/A [def: our]
		undzertvegn [def: our sake]
	ir aykh ets enk enkers ayer/A/Iik [def: you (pl)]
		ayertvegn [def: your (pl) sake] 
		irts/V/T [def: speak in formal voice]
	zey [def: they] zeyer/A/Iik [def: their] zeyertvegn [def: their sake]
iks/En [m] [def: the letter X] 
ile{e|ylwy}/Xiluem{e|ylwym}/H [m] [def: child genius] 
	iluish{e|ylwyyS}/H/A [def: clever (child)] 
ilustri'r/V/Bilustri'rt [def: illustrate]
	ilustratsye/S [f] [def: illustration]
iluzye/S [f] [def: illusion] iluzorish/A [def: illusory]
ima'zh/N [m] [def: image] 
imenye/S [def: estate (Russian)]
imigri'r/V/Bimigri'rt [def: immigrate]
	imigrant/N [m] [def: immigrant] imigratsye/S [f] [def: immigration]
imiti'r/V/Bimiti'rt [def: imitate] imitatsye/S
imperativ/A [def: imperative]
imperye/S [f] [def: empire]
	imperlyalistish/A [def: imperialist] 
	imperyali'zm/N [m] [def: imperialism] 
	perya'l/N [m] imperya'l/N [m] [def: Imperial (currency)] 
	imperya'l/N [m] [def: kind of public bus] 
impet/N [m] [def: impetus, speed] /Idik
implikatsye/S [f] [def: implication]
imponi'r/V/Bimponi'rt [def: impress]
	impoza'nt/K [def: impressive] 
importi'r/V/Bimporti'rt [def: import]
impreze/S [f] [def: social event, enterprise] 
improvizi'r/V/Bimprovizi'rt [def: improvize]
	improvizatsye/S [f] [def: improvization]
impuls/N [m] [def: impulse] /Iiv
imyirtseshem{#m yrc|h hSm}/H [def: God willing] mirtseshem mirtshem
in/P [def: in] inerlekh/K drinen/Idik derin derinen
	inern [adj] [def: interior] % uninflected, as in "inern minister" 
	[idiom: in mitn drinen = suddenly]
indeks/N [m] [def: index]
indik/Ees [m] inditshke/S [f] [def: turkey]
individuel/A [def: individual]
indorsi'r/V/Bindorsi'rt [def: endorse] 
	indorsirung/N [f] [def: endorsement] 
industrye/S [f] [def: industry] industriel/A [def: industrial]
indyum [m] [def: indium (In)] 
indzl/N [m] [def: island] halbindzl{halb#indzl}/N [def: peninsula] 
inertsye/S [f] [def: inertia]
infanterye/S [f] [def: infantry]
infektsye/S [f] [def: infection] dezinfektsye/S [f] [def: disinfection] 
inflatsye/S [f] [def: inflation (economic)] 
informi'r/V/Binformi'rt [def: inform]
	informatsye/S [f] [def: information]
	informati'v/A [def: informative] 
ingber [def: ginger]
ingredie'nt/N [m] [def: ingredient] 
initsya'l/N [m] [def: initial]
	initsyato'r/N [m] [def: initiator] 
initsyati'v/N [f] [def: initiative]
inkrusti'rt/V/Binkrusti'rt [def: encrust] 
inkvizitsye/S [f] [def: the Inquisition] 
	inkvizito'r/N [m] [def: inquisitor] /Iish
inovatsye/S [f] [def: innovation]
inse'kt/N [m] [def: insect] 
insinuatsye/S [f] [def: insinuation]
inspiri'r/V/Binspirirt [def: inspire] inspiratsye/S [f] [def: inspiration]
instalatsye/S [f] [def: (object of) installation, facility] 
	instali'r/V/Binstali'rt [def: install] 
	instalirung/N [f] [def: (act of) installation] 
	instalator/Xinstalato'rn [m] [def: plumber, appliance installer] 
insta'nts/N [def: department]
insti'nkt/N [m] [def: instinct] /Iiv [def: instinctive]
institu't/N [m] [def: institute] institutsye/S [f] [def: institution]
instruktsye/S [f] [def: instruction]
instrume'nt/N [m] [def: instrument]
integri'r/V/Bintegrirt [def: integrate]
	integratsye/S [f] [def: integration] 
intelekt/N [m] [def: intellect] 
	intelektue'l/A [def: intellectual] /Iish
	intelektua'l/N [m] [def: intellectual]
	intelektuali'zm/N [m] intelektualitet/N [f] [def: intellectualism] 
	inteligent/A [def: intelligent]
intensiv/A [def: intensive]
interes/N [m] interesi'r/V/Binteresi'rt [def: interest]
	farinteresirt/V/Bfarinteresirt [def: interest]
	interesant/A [def: interest]
internet [def: Internet] /Iish internets
interpreti'r/V/Binterpreti'rt [def: interpret]
	interpretatsye/S [f] [def: interpretation]
interveni'r/V/Binterveni'rt [def: intervene] 
intervyui'r/V/Bintervyui'rt [def: interview]
	intervyu/N [m] [def: interview]
intim/A [def: intimate]
intrige/S [f] [def: intrigue]
	intrigi'r/V/Bintrigi'rt [def: plot, scheme] 
intsident/N [m] [def: incident]
invalid/N [m] [def: invalid]
invazye/S [f] [def: invasion] 
inventa'r/N [m] [def: inventory]
inversye/S [f] [def: inversion]
investi'r/V/Binvesti'rt [def: invest] 
	investitsye/S [f] [def: investment] 
inyen{enyn}/Xinyonem{enynym}/H [m/n] [def: matter]
inzhener/N [m] [def: engineer] inzhenerye/S [f] [def: engineering]
ion/N [def: ion] kation/N [def: cation] anion/N [def: anion]
iot/N [m] [def: letter J] 
ipesh{e|ypuS}/H [def: stink] faripesh{fare|ypuS}/V/Bfaripesht{fare|ypuSt}
ir_{e|yr}/H [f] [def: city]
	ben{bn}-ir_{e|yr} [m] [def: townsman]
ire [def: people] [grammar: requires a counting word]
iridyum [m] [def: iridium (Ir)] 
ironye/S [f] [def: irony] ironish/A [def: ironic]
iterbyum [m] [def: ytterbium (Yb)] 
itlekh/A [def: each]
itryum [m] [def: yttrium (Y)] 
itst [adv] /Iik itster [adv] itstert [adv] [def: now] 
	atsind [adv] atsinder [adv] atsindert [adv] yetst [adv] [def: now]
	itstikayt/N [f] [def: present (time)] 
ivre{eBry}/H [n] [def: Hebrew (reading in Kheder)]
	ivrit{eBryT}/H [n] [def: modern Hebrew]
ish_{#yS}/Xanoshem{#nSym}/H [m] [def: man]
	isho{#ySh}/Xnoshem{nSym} [f] [def: woman] 
isla'm [m] [def: Islam] /Iish
istmos/N [m] [def: isthmus] 
izoli'r/V/Bizoli'rt [def: isolate] 
ka/Een [m] [def: the letter K] 
kabaret/N [m] [def: cabaret]
kabinet/N [m] [def: room, cabinet]
kabole{kblh}/H [def: Kabbalah]
	mekabl{mkbl}/H [def: receive (with "zayn"); greet (with "- ponem zayn")]
	kabolas{kblT} [def: greeting of]
	mekubl{mkwbl}/Xmekubolem{mkwblym}/H [m] [def: Cabbalist] 
kabtsn{kbcn}/Xkabtsonem{kbcnym}/H [m] [def: pauper]
	kabtsansk [def: Kabtsansk (fictional town of Mendele Moykher Sforem)]
	kabtsanivke [def: Kabtsanivke (fictional town of Isaiah Lerner)]
kadents/N [f] [def: term of office] 
kadmyum [m] [def: cadmium (Cd)] 
kadmoyn{kdmwn}/H [def: original] /Iish
kadokhes{kdHT}/H [def: fever, disease]
kaf{Kf}/H [def: palm]
	kaf{Kf}-hakeyle{hkle} [def: purgatory] 
kafe'/N [m] [def: café]
	kafeterye/S [f] [def: cafeteria] 
kaftan/N/Dkaftand [def: caftan (coat)]
kak/V/T [def: defecate] /Gop farkak/V/Bfarkakt
	kaker/S [m] [def: defecator]
	kakalovitsh [m] [def: son of a turd (vulgar)] 
	[idiom: alter kaker = old fart (vulgar)]
	[idiom: gey kak afn yam{|ym} = get lost (vulgar)]
kakemayke/S [f] [def: television] [usage: humorous]
kakh{Kx}/H [def: such] /Ll
kakhi [def: (sound of a cough)]
kakhlye/S [f] [def: tile] 
kalamashke/S [f] [def: open carriage] 
kalb/Xkelber /Dkelb [def: calf] kelbn/A [def: calf, veal]
	kelb/V/T [def: bear a calf]
kalbase/S [f] [def: sausage]
	kalbasnik/Ees [m] kalbasnitse/S [f] [def: sausage seller, irreligious person]
kale{Klh}/Xkales{KlwT}/H [f] [def: bride, engaged woman]
	khosn{HTn}-kale{Klh} [def: engaged couple] 
	[idiom: vern khosn{HTn}-kale{Klh} = become engaged (couple)]
	[idiom: zayn khosn{HTn}-kale{Klh} = be engaged (couple)]
kaledzh/N [m] [def: college] 
kalemutne/A [def: out of sorts]
kalifornyum [m] [def: californium (Cf)] 
kaligrafye [f] [def: calligraphy] 
	kaligra'f/N [m] kaligrafke/S [f] [def: calligrapher] 
kalik/A [def: ill] kalike/S [m] [def: paralized person] 
kalkh/V/T [def: whitewash]
kalkulus [m] [def: calculus] 
kalt/Kkelt [def: cold] kelt/N [f] [def: cold]
	kil/V/T [def: become cold] /Gop/Gtsu
	farkil/V/Bfarkilt [def: catch cold (with "zikh")]
		farkilung/N [f] [def: cold (disease)]
	kil/K [def: cold] kilkayt/N [f] [def: coldness]
	ayzkalt/A [def: ice-cold]
	kelterer/S [m] [def: refrigerator]
	[idiom: kalt makhn = murder (thieves' argot)]
kaltsyum [m] [def: calcium (Ca)] 
kaluzhe/S [f] luzhe/S [def: puddle]
kalye/A [def: ruined]
kalyake/V/T [def: mispronounce]
kalyum [m] [def: potassium (K)] 
kam/N/Dkem [m] [def: comb; mountain crest, ridge] farkam/V/Bfarkamt [def: comb]
	kem/V/T [def: comb] /Goys/Garoyf
	tsekem/V/Btsekemt [def: comb, untangle (hair)] 
kame{Kmh}/H [def: how many] /L|v [def: and how many]
	[idiom: kame{Kmh} vekame{|wKmh} = very many]
kamer/N [f] [def: chamber] /Dkemer [def: small room, cell (political)] 
	shatskamer/N [m] [def: treasury (poetic)]
kamerad/N [m] [def: comrade]
kameye{kmye}/Xkameyes{kmyewT}/H [f] [def: amulet]
kami'n/N [m] [def: fireplace] 
kamizelke/S [f] kamezelke/S [f] [def: men's vest (clothing)] 
kampanye/S [f] [def: campaign] 
kamtsn{kmtsn}/H/S [def: miser]
kan{Kan}/H [def: here]
kana'l/N [m] [def: channel]
	kanalizi'r/V/Bkanalizi'rt [def: provide with canals] 
	kanalizatsye [f] [def: provision of canals] 
kana't/N [m?] [def: ??] % a bergl tsefoylte kanatn oyf der shif
kandida't/N [m] [def: candidate]
	kandidi'r/V/Bkandidi'rt [def: run for office] 
	kandidatu'r/N [f] [def: candidacy] 
ka'nets/D [def: lantern (kerosine)] 
kanfes{KnfwT}/H [def: corners]
kanibal/N [m] [def: cannibal] kanibalizm [m] [def: cannibalism]
/Xkanikules [f] [def: dog days (hot summer days)] 
	kanikula'r/A [def: dog-day] 
kanoy{knoi}/Xkanoyem{knoim} [m] [def: zealot]
	kanoish{knoiS}/H/A [def: zealous]
kanon/N [m] [def: cannon]
kanonizi'r/V/Bkanonizi'rt [def: canonize]
kant [m/f] [def: edge, rim]
kant/N [m] [def: region, direction] /Iik [def: sided, angular]
	firkantik/A [def: rectangular]
kantoni'st/N [def: drafted soldier in Czar's army]
kantor/N [f/m] [def: office] 
	kantorke/S [f] [def: desk] 
	[idiom: in kantor = over the counter]
kantshik/Ees [def: whip]
kap/N [def: small amount, drop] /Dkap
kapdn{kpdn}/Xkapdonem{kpdnym}/H [m] [def: meticulous person]
	kapdonish{kpdnish} [def: meticulous]
kape/V/T [def: drip, trickle] /Garop
kapelye/S [f] [def: musical group]
kaper/S [def: caper (food)] 
kapital/N [m] [def: capital]
	kapitali'st/N [m] [def: capitalist] kapitalizm [m] [def: capitalism]
kapitan [m] [def: captain]
kapitl/N/Eekh [n/m] [def: chapter]
kapituli'r/V/Bkapituli'rt [def: capitulate, admit defeat] 
	kapitulatsye/S [f] [def: capitulation] 
kapl/N [n] [def: cap (clothing)]
	kapelyush/N [m] [def: hat (clothing)]
	kapele/Ekh [def: small hat (clothing); small amount] 
kaplan/N [m] [def: chaplain] 
kaplye/S [f] [def: drop] 
kapo/S [m] [def: kapo (position in concentration camp)]
	hoyptkapo [m] [def: head kapo (position in concentration camp)]
kapore{Kprh}/Xkapores{KprwT}/H [f] [def: atonement]
	kiper{Kypwr}/H [def: atonement]
		yom{ywm}-kiper{Kypwr} [def: Day of Atonement]
	mekaper{mKpr}/H [def: atone (with "zayn")] 
	[idiom: a sheyne reyne kapore = good riddance]
	[idiom: shlogn kapores = ritually ridding oneself of sins]
kapote/S [f] [def: caftan, overcoat]
kapoyer/A [def: inverted]
	[idiom: Moyshe{mSh} kapoyer = a person who does things in reverse of normal]
	[idiom: shteln di hor kapoyer = frighten]
kapriz/N [m] [def: act of capriciousness]
	kaprizne/A [def: capricious]
kaput [def: broken]
karabin/N [m] [def: carbine]
karafke/S [f] [def: carafe] 
	karafintshik/D [def: carafe]
karahod/N [m] [def: circle dance]
karb /Dkerb [def: kerbl (Ukrainian money)]
karb/N [m] [def: notch, nick, dent] 
	/Gayn [def: notch, score] 
	[idiom: trefn in karb (arayn) = hit the nail on the head]
kardatshe/-kardatshe tsekardatshet/A [def: beaten bloody]
karel/N [def: coral beads]
karete/S [f] [def: carriage]
karg/A [def: stingy] /Ilekh
	karg/V/T [def: begrudge]
	[idiom: iz ementsn karg = it isn't enough for someone]
karikatur/N [m] [def: caricature] 
kark/N [m] [def: back of the neck]
karlik/Ees [m] [def: dwarf, midget]
karnatsele/Xkarnatselekh [n] [def: ground-meat loaf (food)]
karniz [m] [def: cornice; curtain rod]
karo [m] [def: diamonds (playing cards)] % no plural?
karoten [def: carotene (food chemical)] 
	beta-karoten [def: beta-carotene (food chemical)] 
karp/N [m] [def: carp (fish)] 
karsh/N/D [f] [def: light-colored cherry]
kartazh/N [def: commission (on a trade)] 
karte/S [f] [def: ticket; map] /Dkart [def: card] 
	shifkarte/S [f] [def: ship ticket]
	forkartl/Eekh [n] [def: (transport) ticket] 
	postkartl/Eekh [n] [def: postcard] 
kartofl/N [f] kartoflye/S [f] [def: potato]
karto'n/N [m] [def: cardboard, carboard container, carton] 
karyere/S [f] [def: career] % Forwards
kas{Kes}/H [m] [def: anger] tse|kas|/V/Btse|kas|t
	lokhes{lhxe|ys}/H [def: in spite (with "af tsu -")] /Idik [def: spiteful]
	lokhesnik{lhxe|ysnik}/Ees [m] lokhesnitse{lhxe|ysnitse}/S [f] [def: spiteful person] 
	kasn{Kesn}/H [m] kasnte{Kesnte}/S [f] [def: angry person]
kase/S [f] [def: safe, strongbox, ticket window, font (type)] 
	kasetke/S [f] [def: safe] 
	fayerkase/S [f] [def: fireproof safe] 
	kasi'r/V/Bkasi'rt [def: cash, repeal, annul, foreclose (mortgage)] /Gayn
	kasi'r/N [m] kasirshe/S [def: cashier, teller, treasurer] 
	[idiom: in kase = cash on hand]
kaserol/N [m] [def: casserole] 
kaset/N [def: cassette]
	kasetnik/Ees [m] [def: portable cassette player] [note: V] 
kashe [f] [def: buckwheat, cereal (food)]
	[idiom: lozn zikh shpayen in der kashe = let others take advantage of one]
kashkaval [def: sheep-milk cheese]
kashye{kSy#}/Xkashyes{kSywT}/H [f] [def: question]
	[idiom: klots kashye{kSy#} = foolish question]
kasoke/A [def: cross-eyed]
kastn/S [m] [def: box] /Dkest
	ay'zkastn/S [m] [def: freezer] 
	bri'vkastn/S [m] [def: mailbox]
	bru'stkastn/S [m] [def: chest (anatomic)]
	hi'lfkestl/Eekh [n] [def: first-aid kit] [note: V]
	mi'stkastn/S [m] [def: rubbish bin]
	postkestl/Eekh [n] [def: mailbox] 
	gekestlt/A [def: plaid (pattern)] 
kastravet [def: cucumber]
kat/N [m] [def: executioner] 
katalo'g/N [m] [def: catalogue] 
katar [def: nose drip] farkatart/A
katastrofe/S [f] [def: catastrophe]
katedra'l/N [f] [def: cathedral (Catholic)] katedre
kategorye/S [f] [def: category] kategorish/A
	[idiom: shtayer kategorye = tax bracket]
kater/V/T [def: desire strongly (with "zikh")]
katerinke/S [f] [def: barrel organ; jalopy] 
	katerinshtshik/Ees [m] [def: organ grinder] 
kateyger{ktygwr}/H [def: accusing attorney]
katoves [m/n] [def: jest] /D
	[idiom: traybn katoves = jest]
	[idiom: oyf katoves = as a jest]
	[idiom: on katoves = seriously]
katoy'l/N [def: Catholic person] /Iish
kats/Xkets [f] [def: female cat] /Dkets
	koter/S [m] [def: male cat]
katsap/Ees [m] [def: Russian (derogatory)] 
katset/N [m] [def: concentration camp] /Iish/Inish katsetnik/Ees/D [m]
katsetler [m] [def: concentration camp inmate/survivor]
katsev{kcB}/Xkatsovem{kcBym}/H/S [m] [def: butcher] /Iish
katshe/V/T [def: crawl] /Garayn
	/Gop [def: pull away]
	/Goys [def: roll up (as noodles)]
	farkatshe/V/Bfarkatshet [def: roll up (cloth)]
	farkasher/V/Bfarkashert [def: roll up (cloth)] % variant form
katshke/S [f] [def: duck (female)]
katukh/N [m] [def: chicken coop]
kavalir/N [m] [def: cavalier] kavalerye/S [f] [def: cavalry]
kave [f] [def: coffee] kaven/A
kaviar [m] [def: caviar]
kavone{Kvnh}/Xkavones{KvnwT}/H [f] [def: intention] /Lb [def: intentional]
	kivn{Kyvn}/H [def: intention] /Lb [def: intentional] /Idik
kay/V/T [def: chew] /Giber
	kaye/V/T [def: chew] /Giber % variant
	tsekay/V/Btsekayt [def: chew]
kayem{kym}/H [def: exists] /L|v
	kayme{kaym#}/H [def: stands]
		kayme{kaym#}-lon{ln} [def: truism, indisputable truth] 
		[idiom: a kayme{kaym#}-lon{ln} fun = no less than (humorous)]
	kiyem{kywm}/H [def: existence]
	mekuyem{mkw|ym}/H [def: established]
	mekayem{mkAm}/H [def: establish (with "zayn")] 
	yikum{ykwm}/H [def: may redemption arise (with "- purken")]
kay'et [def: notebook] [note: Polish Yiddish]
kaykl/V/T [def: roll] /Gavek/Giber/Garop
	kaykl/N/Dkayk [def: circle] /Idik [def: round]
	kaylekhik/A kaylekhdik/A [def: round]
kayor{ka|yor} [m] [def: early dawn]
kazarme/S [f] [def: barracks]
kebudl/N [def: caboodle (English ??)] 
kedakhes{kdHT}/H/N [f] [def: fever]
keday{Kda|y}/H [def: worthwhile]
	kedey{Kdy}/H [def: in order that] bikhdey{bkhdy}/H
kegn/P [def: against, concerning] antkegn/P /Idik
	akegn/P [def: opposite, vis-à-vis] /Idik
	dakegn/P derkegn/P gegn/P [def: against]
	kegnvart [def: opposition]
	kegner/S [m] kegnerish/A [def: opposite, against]
		[idiom: onnemen dem tsad funem kegner = play devil's advocate] [note: V]
		[idiom: zikh onshteln farn kegner = play devil's advocate] [note: V]
	gegn/V/T /Gon [def: meet unexpectedly] % bug: doesn't give ongegegnt
	bagegn/V/Bbagegnt [def: meet (with "zikh mit")]
		bage'genish/N [n] [def: meeting, encounter]
kehile{k|hylh}/Xkehiles{k|hylwT}/H [f] [def: jewish community] /Idik
	kahal{k|hl}/H [def: community] /Iish [def: communal]
keile{K#ylw}/H [def: as if]
kel/N [f] [def: throat]
keler/S [m] [def: cellar]
	kelner/S [m] /Iish kelnershe/S [f] [def: waiter]
kelishek/D [def: small drinking glass]
kemat{Kmet}/H [def: almost]
kemf/V/T [def: struggle]
	bakemf/V/Bbakemf [def: fight, contest]
	kemfer/S [m] kemferin/S [f] [def: fighter]
	kemferish/A [def: competitive, eager to fight] 
		klasnkemferish/A [def: pertaining to class struggle] 
		kemferishkayt/N [f] [def: pugnaciousness] 
	kamf/N [m] [def: fight, struggle]
		lebnskamf/N [m] [def: struggle for life] 
keml/N [m] [def: camel]
kemp/S [m] [def: camp (English)]
ken/V/T [def: be able, know]
	/Goys [def: be expert at (with "zikh oyf")] 
	kon/V/T [def: be able]
	baken/V/Bbakant [def: recognize, introduce to (with "mit"), acquaint]
	umbakant/A [def: unknown] umbakenevdik/A [def: unrecognizable]
		bakantshaft/N [f] [def: acquaintance]
	derken/V/Bderkent [def: recognize]
		derkentshaft/N [f] [def: relationship (interpersonal)]
	onerken/V/Bonerkent [def: recognize] onerkenung/N [f] [def: recognition]
	kener/S [m] [def: expert] kentnish/N [def: knowledge]
		kentlekh/A kentik/A kontik/A [def: apparent, marked]
		kentshaft/N [f] ke'ntenish/N [n] [def: knowledge]
kendl/N [n] [def: pitcher for washing hands]
kenig/N [m] [def: king] /Ilekh [def: kingly]
	kenigin/S [f] [def: queen]
	kinig/V/T [def: rule] kenigraykh [n] [def: kingdom]
ker/V/T [def: turn, clean] /Giber/Gavek/Gop/Gum/Gtsurik/Giber/Gon/Goys
	farker/V/Bfarkert [def: turn around]
	kereve/V/T [def: turn] farkereve/V/Bfarkerevet [def: turn]
	koymenkerer/S [m] [def: chimney sweep]
	tsurikker/N [m] [def: return]
	umker/N [m] [def: turn around]
	iberke'renish/N [n] [def: upset, mess]
	[idiom: meg di velt zikh iberkern = come hell or high water]
keren{krn}/H [def: fund, horn]
ke'rmeshl/Eekh [n] [def: party, celebration] 
kern/S [m] [def: kernel, nucleus] /Dker/Dkernd [def: seed, pit, nut] 
	[idiom: sosne kerlekh = pine nuts]
kerosi'n [m] [def: kerosine] 
kerper/S [m] [def: body]
	kerpershaft/N [f] [def: corporation]
	farkerper/V/Bfarkerpert [def: incorporate]
		farkerperung/N [f] [def: incorporation; actualization, realization]
kesef{Ksf}/Xksofem{Ksfym} [m] [def: money; silver] 
	shove{Svh}-kesef{Ksf} [m] [def: something worth money; payment in kind] 
		% bug: doesn't give each word separately
keseyder{Ksdr}/H [def: continual]
keshene/S [f] [def: pocket]
kesher{kSr}/H [def: connection]
kesl/N [m] [def: boiler, kettle]
	[idiom: groyser kesl = cauldron]
	[idiom: kishef{KySwf}-kesl = witches' cauldron] [note: V]
kest [f] [def: financial support]
	kest [adj] [def: foster] % uninflected, as in "kest eltern" 
	kestnik/Ees [m] [def: boarder, dependent] 
kest/N [f] [def: chestnut (tree)] 
kevyokhl{KByxwl}/H [def: as it were, God]
keyfl{Kfl}/H/V/T [def: multiply]
	keyfl{Kfl} [m] [def: multiplication (arithmetic)] 
	far|keyfl|/V/Bfar|keyfl|t [def: multiply]
keylev{KlB}/Xklovem{KlBym}/H [m] [def: dog; scoundrel]
	klafte{KlBte}/H/S [f] [def: bitch] 
keyli{Kly}/Xkeylem{Klym}/H [f] [def: vessel; utensil]
	kley{Kly}/H [def: vessels of]
	[idiom: puste keyli{Kly} = shallow person]
keyn [def: to] [grammar: with a place name]
keyn keyne [def: not any]
	keyner keynem keynemen keynems [m] [def: nobody]
keyser/S/Xkeysorem{keysorym}/H [m] [def: Kaiser] % both plurals
keyt/N/D [f] [def: chain]
	keytl/V/T [def: chain together] /Garayn
	farkeytl/V/Bfarkeytlt [def: chain together]
keyver{kBr}/Xkvorem{kBrym}/H/D [m] [def: grave]
	kvoremdik{kBrymdik}/A [def: gravelike] 
	mekaber{mkbr} [def: bury (with "zayn")] 
	kvure{kBwrh}/Xkvures{kBwrwT}/H [def: burial] /Lh
	bes{byT}-hakvures{hkBwrwT} [m] [def: cemetery] 
	[idiom: beys kvures = graveyard]
kez/N [m] [def: cheese]
	shmirkez [m] [def: cream cheese] 
kezayes{KzyT}/H/D [def: the size of an olive]
kha-kha [def: ha-ha; sound of laughter]
khaba'r [m] [def: bribery, graft] 
khad{Hd}/H [def: one (Aramaic)]
khadatay [def: petitioner (Russian)] 
khag{Hg}/Xkhagem{Hgym}/H [m] [def: holiday]
	khago{Hgo}/Xkhagoes{HgowT}/H [def: Easter; Christian festival]
khaki [m] [def: khaki] 
khal{Hl}/H [def: occurs]
khala't/N/D [m] [def: robe, housecoat, smock, frock (clothing)] 
khale{Hlh}/Xkhales{HlwT}/H [f] [def: egg bread, challah (food)]
khalef{Hlf}/Xkhalofem{Hlfym}/H [m] [def: knife]
khalesh{HlS}/H/V/T [def: faint]
	far|khalesh|/V/Bfar|khalesh|t [def: faint]
	khaloshes{HlSwT}/H [def: fainting, nauseating]
khalif/N [m] [def: caliph] 
khalupe/S [f] [def: shack, shed] 
khalyastre/S [f] [def: gang]
kham/Ees [m] khamule/S [m] [def: boor] 
khameleon/N [m] [def: chameleon (animal)] 
khamor{Hmwr}/H [m] [def: donkey]
khaneke{HnwKh}/H [m] [def: festival of Khanuke]
khap/V/T [def: catch, grab; excite]
	/Gariber/Garop/Garoys/Garoyf/Garum/Goyf/Goys/Gunter/Gop/Gtsu
	/Gon [def: grab ahold of, ignite] 
	/Garayn [def: enter in spite of difficulties (with "zikh")] 
	/Giber [def: snack] 
	derkhap/V/Bderkhapt [def: grab]
	farkhap/V/Bfarkhapt [def: grab, hijack, kidnap]
	tsekhap/V/Btsekhapt [def: grab]
	farkhaper/S [m] [def: hijacker] 
	feyglkhaper [m] foyglkhaper [m] [def: bird catcher]
	khaperay'/N [n] [def: grabbing]
		iberkhaperay'/N [m] [def: snack food] 
		khaperish/A [def: greedy] 
	kha'penish [n] [def: rush, haste] 
	khaper/S [m] khaperin/S [f] onkhaper/S [m] onkhaperin/S [f] [def: grabber]
	/Xkhaperlekh [def: tag (game)] 
	khapik/A [def: hasty] umkhapik/A [def: slow, deliberate] 
		khapikayt/N [f] [def: hastiness] 
	khap-lap [adv] [def: helter-skelter] 
kharakter/S/N [m] [def: character] /Iistish [def: characteristic]
	kharakteristik/N [def: characteristic]
	kharakterizi'r/V/Bkharakterizi'rt [def: characterize]
kharif{Hryf}/H [def: sharp]
	kharifes{HryfwT}/H [def: sharpness]
kharote{Hrth}/Xkharotes{HrtwT}/H [f] [def: regret]
	[idiom: hobn kharote{Hrth} = regret]
kharoyses{HrwsT}/H [def: a Passover food]
kharpe{Hrph}/Xkharpes{HrpwT}/H [def: disgrace]
khart/N/Ees [m] [def: greyhound (animal)] 
khas{Hs}/H [def: God forbid (with "- v|kholile)]
	/L|v [def: God forbid (with "kholile -")]
khashmoynoem{HSmwno|ym}/H [def: Hasmoneans]
|khasm|e/V|khasm|enen/T [def: seal] /Gop /Gunter [def: sign]
	khsime{HTymh}/H [def: seal]
	far|khasm|et/A [def: sealed]
khate/S [f] [def: shack, hut; cabin] khatke/S [f] [def: small shack] 
khatekhizm/N [m] [def: catechism, teaching] 
khatsos{HcwT}/H [def: midnight]
khaver{HBr}/Xkhaveyrem{HBrym}/H [m] [def: friend, comrade (male)]
	/Iish [def: comradely]
	khaver|te/S [f] [def: comrade (female)]
	khevre{HBrh}/H [f] [def: gang]
		khevreman{HBrhman} [def: one of the gang; playboy]
		khevrenik{HBrhnik}/Ees
		oyto-khevre{HBrh}/H/S [def: car pool] [note: V] 
		[idiom: vayse khevre{HBrh} = youngsters]
		khevre{HBrh}-drikung/N [f] khevre{HBrh}-druk/N [f] [def: peer pressure] [note: V] 
	khaverishkayt{HBrishkayt}/N [f] khavershaft{HBrshaft}/N [f] [def: friendship]
	khaver{HBr}/H/V/T [def: befriend] /Gtsunoyf
		farkhaverung{farHBrung}/N [f] [def: becoming friendly]
	khiber{Hybwr}/Xkhiburem{Hybwrym}/H [def: bond; edition; treatise]
		mekhaber{mHbr}/Xmekhabrem{mHbrym}/H [m] mekhaberin{mHbrin}/S [f] [def: author]
	khevruse{HBrwT#}/H [def: study partnership] /Lb
khaviv{HByB}/H [def: beloved]
khay{Hy}/H [adj] [def: alive]
	khayem{HAm}/H [def: life] /Lh/Ll
	khaye{Hyh}/Xkhayes{HywT}/H /D [f] [def: beast; animal] /Iish
		shnobl-khaye{Hyh}/Xshnobl-khayes{HywT} [f] [def: platypus]
	khiyes{HywT} [def: strength]
		[idiom: iz khiyes nit zikher = one's life is in danger]
	kheyune{Hywnh}/H [def: sustenance]
	mekhaye{mHyh}/H /Idik [def: pleasure; reviving]
khayel{HAl}/Xkhayoles{HAlwT}/H [n] [def: army]
khazal{Hz"l}/H [def: sages]
khazer{Hzyr}/Xkhazeyrem{Hzyrym}/H [m] [def: pig] /Isher
	khazerl{Hzyrl}/Xkhazeyremlekh{Hzyrymlekh} [def: pig (diminutive)]
	khazeray'{Hzyray}/N [n] [def: item in bad taste; messy situation; junk food] 
khazn{Hzn}/Xkhazonem{Hznym}/H [m] [def: cantor]
	khazonish{Hznish}/A [def: cantorial]
	khaznte{Hznte}/S [f] [def: cantor, cantor's wife] 
khazoke{Hzk|h}/H [def: firm tradition; tenure]  [note: V for tenure]
khemye [f] [def: chemistry] khemish/A [def: chemical]
	elektrokhemye [def: electrochemistry]
	elektrokhemish/A [def: electrochemical]
khes{Hʼ}/H [def: letter Khes]
khesed{Hsd}/H [def: generosity]
	khosed{Hsyd}/Xkhsidem{Hsydym}/H [m] [def: Chassid, follower]
		/Idik [def: Chassidic]
		khosedl{Hsydl}/Xkhsidemlekh{Hsydymlekh} [def: Chassid (diminutive)]
		khsides{HsydwT}/H [def: Chassidic philosophy]
		khsidizm{Hsydizm} [m] [def: Chassidism] khsidish{Hsydish}/A [def: Chassidic]
kheshbn{HSbwn}/Xkheshboynes{HSbwnwT}/H [m] [def: account; calculation] /L|v
	kheshbn{HSbwn}/V/T /Goys [def: reckon] 
kheshvn{HSBn}/H/Idik [m] [def: month of Kheshvan]
khesorn{Hsrwn}/Xkhesroynes{HsrwnwT}/H [m] [def: defect]
	khoserdeye{Hsr-deh} [adj] [def: idiotic] [grammar: predicative] 
	khiser{Hyswr} [m] [def: subtraction (arithmetic)] 
kheyder{Hdr}/Xkhadorem{Hdrym}/H [m] [def: Jewish religious school; room]
	[idiom: nit oyszogn funem kheyder{Hdr} = not wash dirty linen in public]
kheyfets{Hyfc}/Xkhafotsem{Hfcym}/H [def: treasure]
kheylek{Hlk}/Xkhalokem{Hlkym}/H [m] [def: portion]
kheylev{HlB}/H [n] [def: tallow]
kheyn{Hn}/H/Ievdik [m] [def: grace]
	shvartskheynevdik{shvartsHnevdik}/A [def: darkly handsome]
	[idiom: noyse{nwQ#}-kheyn{Hn} zayn (bay ...) = please ...]
kheyrem{Hrm}/H [def: ostracism; ban] /Lb
	[idiom: freg mikh b|kheyrem = I have no idea]
kheyshek{HSk}/H [m] [def: eagerness; desire]
kheyt{Ht#}/Xkhatoem{Hto|ym} [m] [def: sin]
kheytsi{Hcy}/H [def: half] /Lb
khidesh{HydwS}/Xkhidushem{HydwSym}/H [def: novelty]
	khidesh{HydwS}/H/V/T [def: marvel]
	far|khidesh|/V/Bfar|khidesh|t [def: astound]
khikhe/V/T [def: giggle] 
khilek{Hylwk}/Xkhilukem{Hylwkym}/H [m] [def: difference]
	[idiom: subtiler khilek{Hylwk} = diner khilek{Hylwk} = fine line]
khilel{Hylwl}/H [m] [def: profanation]
khimere/S [def: chimera] khimerish/A
khinekh{Hynwx}/H [def: education] /Lh [def: the education]
	mekhanekh{mHnx}/H [def: educate (with "zayn")] 
khinem{Hynm}/H [def: nothing] /Lb [def: free]
khinin [m] [def: quinine] 
khipozen{Hypzwn}/H [def: speed] /Lb
khirek{Hyryk}/H [def: a punctuation mark]
khirurg/N [m] [def: surgeon] khirurugye [f] [def: surgery]  
khitre/A [def: sly, cunning] khirtra'k/Ees [m] [def: sly person] 
khkire{Hkyrh}/H [f] [def: speculation] /V/T [def: speculate (with "zikh")]
khlapotsh/V [def: plead (Russian)] 
khlipe/V/T [def: sob] /Garoys
	khli'penish/N [f] [def: sobbing] 
khlop/Ees [def: boor; churl; peasant]
khlor [m] [def: chlorine (Cl)]
	khlorid [def: chloride]
	hidrokhlor [def: hydrogen chloride (HCl)]
	tsinkkhlorid [def: zinc chloride (ZnCl2)]
khlyeptshe/V/T [def: guzzle] % Harduf
khmal/N [m] [def: whack, smack] [pronunciation: khmaL]
	[idiom: gebn a khmal = smack]
khmare/S [f] [def: cloud]
	khmare/V/T [def: be cloudy] /Gon
	farkhmare/V/Bfarkhmaret [def: cloud up] 
	khmarne/A [def: dreary, gloomy; cloudy] 
khnife{Hnyfh}/Xkhnifes{HnyfwT}/H/D [f] [def: toadying; flattery] /Idik
	khanfe{Hnfe}/Vkhanfenen{Hnfenen}/T [def: butter up, flatter] /Gunter
khnyok/Ees [m] [def: bigot] 
khodo'be [def: cattle]
khok{Hwk}/Xkhukem{Hwkym}/H [m] [def: law, custom] khukas{HwkT} [def: law of]
khokhem{Hxm}/Xkhakhomem{Hxmym}/H [m] [def: sage]
	khokhme{Hxmh}/Xkhokhmes{HxmwT}/H [f] [def: wit; wisdom]
	[idiom: talmed{Wlmyd} khokhem{Hxm} = sage (Jewish)]
khol{Hwl}/H [def: less holy] /Lb
	kholile{Hlylh}/H [def: God forfend, God forbid]
		/L|v [def: may it not be (with "khas -")]
kholel{Hll}/H [m] [def: opening; open space]
kholem{Hlwm}/Xkhaloymes{HlwmwT}/H [m] [def: dream]
	kholem{Hlwm}/H/V/T [def: dream (with "es ... zikh" +dative)]
kholerye [f] kholere [f] [def: cholera, plague; raging person]
kholodne/A [def: cool (Slavic)]
kholyeve/S [def: upper part of a shoe (clothing)]
	[idiom: makhn fun moyl a kholyeve = put one's foot in one's mouth]
khomets{Hmc}/H [def: leavened food] /Idik
khomishoser{HmSh-eQr}/H [def: 15th of a month]
khopte/S [f] [def: gang, horde]
khor/N [m] [def: chorus, choir]
khored{Hrd}/Xkhareydem{Hrdym} [m] [def: ultra-pious Jew]
	khoreydish{Hrdish}/A [def: ultra-pious]
khorev{HrwB}/H [def: destroyed] /A /Idik
khorkhl/V/T [def: rattle, wheeze; snore]
khoshev{HSwB}/H/A [def: important] khshives{HSyBwT}/H
khosn{HTn}/Xkhasonem{Htnym}/H [m] [def: bridegroom, engaged man] /Idik
	/Dkhosnd{HTnd}
	khasene{HTwnh}/Xkhasenes{HTwnwT}/H [f] [def: marriage]
	mekhutn{mHwWn}/Xmakhetonem{mHwWnym}/H [m] [def: son (daugher) in-law's father]
	makhetey'nes|te/S [f] [def: son (daughter) in-law's mother]
	[idiom: oyfshpiln a khasene{HTwnh} = make a scene]
khotsh [conj] khotshe [conj] khotshbe [conj] khotshbi [conj] [def: although]
khove/V/T [def: cultivate, raise, keep, foster] 
khoydesh{HwdS}/Xkhadoshem{HdSym}/H [m] [def: month] /Idik/Ilekh
	mekhadesh{mHdS}/H [def: renew, bless (with "di levone") (with "zayn")] 
	bris{bryT}-khadoshe{HdSh} [def: New Testament] 
khoyle{Hwlh}/Xkheloyem{Hwlo|ym}/Xkhoylem{Hwlym}/H [m] [def: sick person]
	khoyloes{Hwl#T}/H/N [def: sickness]
khoymer{Hwmr} [m] [def: matter (not spirit), flesh, substance] 
	[idiom: kal{kl} v|khoymer{Hwmr} = all the more so]
khoyshed{HwSd}/H [def: suspicious]
	[idiom: khoyshed{HwSd} zayn = suspect]
khoyshekh{HwSx}/H [m] [def: darkness] far|khoyshekh|t/A [def: blackened]
khoyv{HwB}/Xkhoyves{HwBwT}/H [m] [def: obligation; debt]
	far|khoyv|/V/Bfar|khoyv|t [def: obligated]
	khoyvas{HwBT}/H [def: obligation of]
	mekhuyev{mHw|yB}/H [def: obligated]
	khiyev{HywB}/H [def: obligated]
	hiskhayves{hTHIBwT}/H/N [n] [def: obligation]
	miskhayev{mTHyB}/H [def: obligate; be obligated (with "zayn")] 
khoyzek{Hwzk}/H [m] [def: mockery, ridicule]
	/V/T [def: mock] /Gop
khoyzer{Hwzr}/H [def: return (with "zayn")] 
	makhzer{mHzwr}/Xmakhzorem{mHzwrym}/H [def: holiday prayerbook]
	khazr{Hzr}/H/V/T [def: repeat] /Giber
		iberkhazerung{iberHzrung}/N [f] [def: repetition]
khrashe/V/T [def: beautify (Russian)] /Goyf
khratshe/-khratshe tsekhratshe/V/Btsekhratshet [def: unbutton]
khremzl/Eekh [n] [def: Passover pancake (food)] 
khreyn [m] [def: horseradish]
khrezanteme/S [f] [def: chrysanthemum] 
khripe/V/T [def: rasp, grate] 
khrom [m] [def: chromium (Cr)] 
khromosom/N [m] [def: chromosome] 
khronologye/S [f] [def: chronology] 
	khronologish/A [def: chronological] 
	khronish/A [def: chronic]
khrope/V/T [def: snore] khroper/S [m] [def: snorer]
khruke/V/T [def: grunt (sound of a pig)] 
khrushtshe/V/T [def: gnaw]
	tsekhrushtshe/V/Btsekhrushtshet [def: noisily chew bones into small pieces]
khshad{HSd}/Xkhshodem{HSdym}/H [m] [def: suspicion]
khshash{HSS}/Xkhshoshem{HSSym}/H [m] [def: suspicion]
khuliga'n/Ees [m] [def: hooligan, ruffian] 
khumesh{HwmS}/Xkhumoshem{HwmSym}/H [m] [def: Pentateuch]
khumre{Hwmr#}/Xkhumres{HwmrwT} [def: stringency]
khupe{Hwph}/Xkhupes{HwpwT}/H [f] [def: wedding canopy]
	[idiom: geyn tsu der khupe{Hwph} = get married (poetic)]
	[idiom: shteln a khupe = arrange a wedding]
khurbn{Hwrbn}/H [m] [def: mess; Holocaust; destruction, ruin]
	khurve{HwrBh}/Xkhurves{HwrBwT}/H [m] [def: ruin]
	farkhurvet{farHwrBht}/A [def: ruined]
khush{HwS}/Xkhushem{HwSym}/H [m] [def: sense] /Idik [def: sensory]
	khush{HwS}/V/T [def: sense (with "zikh")]
	far|khush|/A [def: distracted]
khut{Hwt}/H [def: thread]
khutor [m] khuter [m] [def: tiny hamlet] 
khuts{Hwc}/H [def: except] /Lm /La
	[idiom: sforem{sfrym} khitsoynem{Hycwnym} = secular books]
khutspe{Hwcph}/H [def: gall, impudence] /Idik [def: brazen]
	khutspenik{Hwcphnik}/Ees [m] khutspenitse{Hwcphnitse}/S [f] [def: impudent person]
khvalye/S [f] [def: wave] khvalyesvayz [adv] [def: wave after wave]
	khvalye/V/T [def: wave]
	mikrokhvalnik/Ees [m] [def: microwave oven] 
khvat/N [def: one of the gang] /Iish [def: comeradely]
kibets/V/T [def: kibitz, give unwanted advice] 
	kibets/N [m] [def: kibitzing] 
	kibetser/S [m] kibetserke/S [f] [def: kibitzer] 
kibuts{kybwc}/Xkibutsem{kybwcym}/H [m] [def: kibbutz (Israeli commune)]
kilo/S [m] [def: kilogram]
kilometer/S [m] [def: kilometer]
kimer/V/T [def: omit]
kimpet [f] [def: childbirth] kimpetorin/S [f] [def: woman in childbirth]
kin [def: lit straw]
kind/Eer [n] [def: child] kindenyu [def: dear child]
	kindele/Ekh
	kindish/A kindersh/A kinderish/A [def: childlike]
	kindvayz [adv] [def: as a child]
	kindhayt/N [f] [def: childhood]
	/Xkindskinder [def: descendents]
	mentshnkind/Eer [def: human being]
	kinderloz/A [def: childless] [usage: doubtful admissability]
	mapl{mpyl}-kind/Xmapl{mpyl}-kinder [n] [def: stillborn child] 
	shvesterkind/Eer [m] [def: cousin]
	zeygkind/Eer [n] [def: infant] 
	kindl/V/T [def: bear children] 
kine{kn#h}/H [f] [def: jealousy]
	mekane{mkn#}/H [def: jealous]
kino [def: film (theater)] 
kine_{kinh}/Xkines_{kynwT}/H [f] [def: lamentation]
kirke/S [f] [def: axe, pickaxe] 
kirkh [f] [def: church] kirkhe % both variants
kiryum [m] [def: curium (Cm)] 
kis{Kys}/Xkisem{Kysym}/H [m] [def: money pouch, scrotum] 
kisey{Ks#}/H [m] [def: chair, throne]
kishef{KySwf}/H [m] [def: magic] /Idik [def: magic]
	farkishef{farKySwf}/V/Bfarkisheft{farKySwft} [def: enchant, bewitch, charm]
	makhesheyfe{mxSfh}/H [f] makhesheyfete{mxSfhte}/S [f] [def: witch]
		mekhashef{mxSf}/Xmekhashfem{mxSfym}/H [m] [def: magician, wizard]
	[idiom: opton a kishef{KySwf} = work a magic trick]
kishke/S [f] [def: intestine (body part); stuffed intestine (food)] /D
	[idiom: blinde kishke = appendix]
	[idiom: grobe kishke = large intestine, colon]
kishn/S [m] [def: pillow] /Dkish
	shney-kishele/Eekh [def: marshmallow (food)]
kite{KWh}/H [def: class, group]
kitl/N [def: kittel (religious garment)]
kitser{kycwr}/H [def: short] /Lb [def: in short] /Lh
	mekatser{mkcr}/H [def: shorten (with "zayn")]
kitsl/V/T [def: tickle]
kitsve{kycBh}/H [f] [def: handout (charity), relief, dole] 
kizl [def: quartz] kizlshteyn/Eer [def: quartz]
klafter [def: crawl stroke (swimming) (with "leygn")]
klak/N [m] [def: sound of a fist beating a chest] 
klal{Kll}/Xklolem{Kllym}/H [m] [def: rule; community]
	/Lh [def: in short] /Lb [def: in general]
	klal{Kll} [adj] [def: ordinary] % indeclinable
	klolem{Kllym}/H  [def: rules]
	koylel{Kwll}/H [def: contains] /Idik [def: general]
	b|derekh{drx}-klal{Kll} [adv] [def: in general] 
klamer/V/T [def: squeeze] /Garum/Gayn
	farklamer/V/Bfarklamert [def: squeeze]
	farklem/V/Bfarklemt [def: squeeze]
		farklemt/A [def: upset (emotionally)] 
	baklem/V/Bbaklemt [def: squeeze]
	klamer/N/Dklemer [m] [def: bracket, vise]
		gretklamer/N [m] [def: clothespin] 
	klem/V/T /Gayn [def: squeeze]
		klem/N [m] [def: squeeze, dilemma] 
klan/N [m] [def: clan] 
klap/V/T [def: knock, beat] /Garayn/Goys/Gtsu/Gtsuzamen/Gon/Gop
	farklap/V/Bfarklapt [def: knock]
	geklaperay'/N [n] [def: knocking, hammering]
	tseklap/V/Btseklapt [def: knock apart]
	klaper/S [m] [def: beater]
	[idiom: homen{hmn}-klaper = Purim rattle]
	hartskla'penish/N [def: beating heart]
	toytklap/N [m] [def: final blow (with "derlangen")] 
	[idiom: hargenen{hrgenen} tsvey flign mit eyn klap = kill two birds with one stone]
	[idiom: mit eyn klap = in one fell swoop]
klape{Klpy} [preposition] [def: in the direction of, concerning, facing] 
	klape{Klpy}-khuts{Hwc} [def: outward, external] 
	klape{Klpy}-pnim{pnym} [def: inward, internal] 
klarine't/N/D [m] klarne't/N [def: clarinet (musical instrument)]
	klarneti'st/N [m] klarnetistke/S [f] [def: clarinet player] 
klas/N [m] [def: class]
	klasik [f] [def: classic literature (subject)] 
		klasish/A [def: classic] klasik/A
	klasifitsi'r/V/Bklasifitsi'rt [def: classify]
	klasifitsirung/N [f] klasifikatsye/S [f] [def: classification]
	mitlklas/N [m] [def: middle class] 
	ershtklasik/A [def: first-rate] 
klaster{klsWr}/H [def: facial appearance (with "- ponem")]
klaun/N [m] [def: cloun] 
klavish/N [m] [def: key] klavyatur/N [f] [def: keyboard]
klay [def: clay]
klayb/V/Bgeklibn [def: choose, gather, prepare to travel (with "zikh")]
	/Garayn/Garoys/Gfunander/Gop/Gtsuzamen/Goyf/Gariber/Gtsunoyf/Gunter
	/Giber [def: be picky]
	/Goys [def: select]
	i'berklayberish/A [def: picky]
		iberklayber/S [m] iberklayberke/S [def: picky person] 
	opklayb/N [m] oysklayb/N [m] [def: choice]
	onklayb/N [m] [def: backlog] [note: V] 
	unterklayber/S [m] [def: collector]
	farklibn/A [def: collected]
klayen [def: bran] /A [def: bran]  
klek/N [m] [def: blot, inkblot] 
	[idiom: shpayen klek oyf = berate]
klek/V/T [def: suffice]
klep/V/T [def: attach] /Gtsu/Goys
	farklep/V/Bfarklept [def: attach; seal (in an envelope)]
	tsukle'penish/N [def: attachment]
	klepik/A [def: sticky] klepikayt/N [f] [def: adhesiveness] kleyb
kler/V/T [def: consider, think] /Goyf/Goys/Giber/Garayn
	oyfklerung/N [f] [def: consideration]
	bakler/V/Bbaklert [def: consider] baklerik/A [def: considerable]
	derkler/V/Bderklert [def: clarify, explain]
		derklerung/N [f] [def: clarification, explanation; statement]
	farkler/V/Bfarklert [def: consider]
	klor/A [def: clear] umklor/A [def: unclear]
	[idiom: klip un klor = as clear as day]
kleshtsh/S [m] [def: tick (insect)]
kleter/V/T [def: climb] /Gariber/Goyf/Garoyf
kley/N [m] [def: glue] 
	tsekleyet/A [def: glued] 
kleyd/Eer/D [n] [def: dress (clothing)]
	kleyd/V/T /Goys [def: clothe]
	bakleyd/V/Bbakleydt [def: clothe]
	gekleydt/A [def: dressed]
	unterkleyd/Eer/D [def: underwear]
	[idiom: khupe{Hwph} kleyd = wedding dress]
kleyn/Kklen/Itshik/Ilekh [def: small] kleynink/A kleynitshk/A
	kleynikayt/N [f] [def: triviality] [usage: often ironic]
	farklener/V/Bfarklenert [def: reduce]
		farklenerung/N [f] [def: reduction]
kleyt/N [f] [def: store] /D
klezmer/S/Xklezmorem{klezmorym} /Iish [m] [def: musician]
	klezmerl klezmoremlekh [def: musicians]
	klezmurek/Xklezmurkes [def: musicians (pejorative)] 
klike/S [f] [def: clique] 
klimat/N [m] [def: climate]
klimper/V/T [def: jingle]
klin/N/Ees [m] [def: wedge] 
kling/V/Bgeklungen [def: ring] /Gon/Gnokh/Gunter/Gop/Giber/Goys
	klingl/V/T [def: tinkle] 
	tsekling/V/Btsegklungen [def: ring out]
	klang/N [m] [def: sound] unterklang/N [m] [def: sound]
		eynklang/N [m] [def: agreement]
			aynklang/N [m] [def: agreement] [usage: inadmissable]
		opklang/N [m] [def: echo]
		ovntklang/N [m] [def: evening bell]
		poyknklang/N [m] [def: drumbeat] 
		iberklang/N [m] [def: sound]
	kling/N [m/f] [def: blade (knife, saw)] 
	klingers [def: money] [usage: doubtful admissability] % only plural
	klingeray'/N [n] geklingeray'/N [n] [def: ringing]
	klung/N [m] [def: telephone call] 
		[idiom: b|tsiber{cybwr}-klung = conference call]
klipe{klyph}/Xklipes{klypwT}/H [def: evil, evil creature]
klishe/S [f] [def: cut; printer's engraving] 
klog/V/T/Garoys/Gon/Goys [def: complain; accuse]
	baklog/V [def: lament (with "zikh")]
	farklog/V/Bfarklogt [def: bewail; accuse someone]
	klogedik/A [def: complaining] % variant to klogndik
	geklogter [m] [def: defendent] 
klole{kllh}/Xkloles{kllwT}/H [f] [def: curse]
kloni'r/V/Bkloni'rt [def: clone]
	klonirung/N [f] klonevanye/S [f] [def: cloning]
klonitse/S [def: chopping stump]
klor/Kkler [def: clear] klorkayt/N [f] [def: clarity]
	derkler/V/Bderkler [def: clarify]
klots/Xkletser [m] [def: block of wood, bungler] /Iik /Dklets
kloymersht{KlwmrSt}/H [adv] [def: as it were] /Lm /Iik klompersht [adv] 
kloyster/S [m] [def: church]
kloyz/N [f] [def: prayer hall] /Dklayz
	kloyznik/Ees [def: person who is often at the prayer hall]
kloze't/N [m] [def: toilet]
	[idiom: geyn in klozet = go to the toilet]
klub/N [m] [def: club] nakhtklub/N [m] [def: nightclub]
	atletik-klub/N [m] [def: health club] [note: V]
	genitung-klub/N [m] [def: health club] [note: V]
klug/Kklig [def: clever]
	klugetshke/A [def: clever]
	klugshaft/N [f] [def: cleverness] klugerheyt [adv] [def: cleverly]
	kligl/V/T /Goys [def: gull, pull a fast one] 
klumek/Xklumkes [def: cloth sack carried over the shoulders]
klyamke/S [n] [def: doorknob]
klyatshe/S [f] [def: mare (female horse)]
klye'nt/N [m] [def: client]
	klyentele/S [f] [def: clientele] % Forwards
klyon/N [m] [def: maple] 
klyotshe [f] [def: oakum] 
	[idiom: a ful moyl klyotshe = of unclear speech]
klyuske/S/D [f] [def: eggdrop (food)] 
knafl/X/N [m] [def: heel (shoe) (clothing)] 
knak/V/T [def: crack] /Gunter
	farknak/V/Bfarknakt [def: knock]
	knaker/S [m] [def: big shot] [usage: humorous]
knal/V/T [def: make a sharp noise]
knap/K [def: mere] [usage: often ironic]
knas{kns}/H [m] [def: engagement, fine]
	farknas{farkns}/V/Bfarknast{farknst} [def: become engaged (with "zikh")]
knayp/V/T [def: pinch] /Bgeknipn % variant participle
	knayper/S [m] [def: cockroach] 
knaytsh/V/T [def: wrinkle]
knekhl/N [n] [def: knuckle] /Dknekh
	geknekhlt/A [def: knuckled] 
knekht/X [m] [def: slave]
	knekhtshaft/N [f] [def: slavery]
knel/V/T [def: teach (humorous), hold forth] 
kneses{KnsT}/H [def: assembly] /Lh
kneyt/V/Bgeknotn [def: knead] /Goys/Gayn
	farkneyt/V/Bfarknotn [def: knead]
	/Dkneyd [def: dumpling (food)] % no positive form
		[idiom: tsi meynt men di hagode{hgdh} tsi di kneydlekh? = is he here for the right reasons?]
kneytsh/V/T [def: wrinkle]
	kneytsh/N/D [def: wrinkle]
	farkneytsh/V/Bfarkneytsht [def: wrinkle]
	tsekneytsh/V/Btsekneytsht [def: wrinkle]
kni/X [m/f] [def: knee]
	[note: Weinreich says only m, and Harduf says m/f]
	kni/V [def: kneel]
	[idiom: hobn aroysgeboygene kni = bow-legged] [note: V]
	[idiom: hobn arayngeboygene kni = hobn krume fis = hobn tsuzamenklapndike kni = knock-kneed] [note: V]
knik/V/T [def: squash] knik [def: sound of an insect being squashed] 
knip/V/T [def: tie, pinch, knot] /Gtsu
	knip/D [def: knot] knipik/D [def: money stash]
knish/S [m] [def: knish (filled-dough food), vagina (vulgar)]
knobl/N [m] [def: garlic]
	farknobl/V/Bfarknoblt [def: season with garlic]
knokhik/A [def: knobby]
knop [m] /Dknep [def: button, tie]
knosp/N [m] [def: bud] 
knoyl/N [def: ball (of thread, string)] /Iik [def: lumpy]
	knoyl/V/T /Gayn [def: wind; roll]
knoyt/N [m/f] [def: wick] /Dkneyt
	/Dkneyt [def: wick] 
	[idiom: leygn emetsn a kneytl = make things worse for someone (being punished)]
knufye{Knwfy#}/Xknufyes{KnwfywT}/H [f] [def: gang, clique]
koalitsye/S [f] [def: coalition]
kobalt [m] [def: cobalt (Co)] 
kod/N [m] [def: code]
	kodi'r/V/Bkodi'rt [def: encode] kodirung/N [f] [def: coding]
	rayonkod/N [m] [def: area code]
	skanirkod/N [m] [def: bar code] [note: V]
	kodeks/N [m] [def: code of law] 
kodei'n [m] [def: codeine] 
kof{Kʼ}/H [m/f] [def: letter Kof]
kol_{kwl}/Xkoyler_{kwler}/Xkoyles{kwlwT}/H [def: voice]
	koyleynu{kwlnw}/H [def: voice] vider|kol_{kwl} [n] [def: echo]
	kol_{kwl}-koyre{kwr#} [def: lonely voice] 
	kelkhl{kwlxl}/Xkelekhlekh{kwlexlex} [def: little voice] 
	viderkol_{viderkwl}/Xviderkoyles{viderkwlwT} [def: echo] 
koldre/S [f] [def: blanket] 
koldunye/S [f] [def: witch] 
kolerley{Klerley} [def: various] 
kolumne/S [f] [def: (newspaper) column] 
	kolumni'st/N kolumnistke/S [def: columnist] 
kolyedeve/V/T [def: carol (Russian)] 
kokh/V/T [def: cook, bake] /Gop/Goyf/Goys/Gon
	tsekokh/V/Btsekokht [def: cook]
	kikh [f] [def: kitchen] kikhtish/N [def: kitchen table]
	kekhne [f] kekhin/S [f] [def: (female) cook]
	kokhedik/A [def: cooking] % variant
	ko'khenish/N [m] kokheray/N [m] [def: cooking, excitement]
	/Dkikh [def: cookie] /Dkukhlekh
		mazl{mzl}-kikhele/Xkh [n] [def: fortune cookied] [note: V] 
	kukhn/S [m] [def: cake]
		kukhnland [n] [def: cake-land] [usage: a kukhn fun kukhnland]
		gekekhts/N [n] [def: cooked food]
		faynkukhn/S [m] [def: pancake]
kokhanik/Ees [m] [def: beloved (Polish)]
kokoshes [def: popcorn]
kokoshnik/Ees [def: old-Russian woman's headdress (clothing)]
koks [noun] [def: chignon] 
kol{Kl}/H [def: all] /Lm/Ll
	ko'lerle'y{Klerley} [def: all kinds of] [grammar: indeclinable]
kolaboratori'st/N [m] [def: collaborator] 
kolbas [m] [def: sausage (non-kosher)]
koledzh/N [m] [def: college]
koleg/N [m] kolegin/S [f] kolege/S [m] [def: colleague]
	shulkoleg/N [m] [def: fellow student]
kolekti'r/V/Bkolekti'rt [def: collect]
	kolektiv/N [m] [def: collective] /A [def: collective]
	kolektor/S [m] [def: collector]
	kolektsye/S [f] [def: collection] 
koler/V/T [def: roll] /Garop
kolir/N [m] [def: color] koli'r/V/Bkoli'rt
	kolirful/A [def: colorful]
	laybkolir/N [m] [def: tights (skin-colored)] 
kolkhoz [def: Soviet collective farm]
	kolkhoznik/Ees [m] [def: resident of a Soviet collective farm]
kolner/S/Xkelner [m] [def: collar] 
	[idiom: mit a ve-kolner = V-neck] [note: V]
kolokotshe/V/T [def: make a tiny noise] 
kolone'l/N [def: colonel (military rank)] 
kolonizi'r/V/Bkolonizi'rt [def: colonize] kolonye/S [f] [def: colony]
koltn koltenes [def: matted hair]
	koltenevat/A [def: matted (hair)]
komande/S [f] [def: troup, team]
	komando [m] [def: commando]
	komandir/N [m] komendant/N [m] [def: commander]
		eyberkomandir/N [m] [def: general, general commander] 
	komandeve/V/Bkomandevet [def: command]
kombini'r/V/Bkombini'rt [def: combine] kombinatsye/S [f] [def: combination]
kome/S [f] [def: comma; decimal point] 
	[idiom: (eg) seks kome nayn = 6.9]
	pintl-kome [def: semicolon] 
komedye/S [f] [def: comedy]
	masknkomedye/S [f] [def: masked comedy]
	komedyant/N [m] [def: comedian]
	komedyantshik/Ees [m] [def: comedian (perjorative)] 
komenti'r/V/Bkomenti'rt [def: comment; explain] 
	komentatsye/S [f] komenta'r/N [m] [def: explanation] 
	komentator/N [m] [def: commentator; popularizer] 
	komentarish/A [def: explanatory] 
komertsye'l/A [def: commercial] 
komets{kmc}/H [def: a punctuation mark]
komisar/N [m] [def: commissar] komisarya't/N [m] [def: precinct, commisariat] 
komish/A [def: comical]
komisye/S [f] [def: commission] komisyone'r/N [m] [def: commisioner]
komitet/N [m] [def: committee]
komod/N [m] [def: dresser (furniture)]
kompa'kt/A [def: small, compact] 
	kompaktkayt/N [f] [def: compactness] 
kompanye/S [f] [def: company]
kompensatsye/S [f] [def: compensation] 
komple'ks/N [n] [def: difficulty; complex (psychological); complex (grouping)] 
	komplikatsye/S [f] [def: complication] 
komple'ks/A [def: complex (mathematical)] 
komple't/N [m] [def: complete set] 
kompliment/N [m] [def: compliment]
komplitsi'r/V/Bkomplitsi'rt [def: complicate]
	komplitsirtkayt/N [f] [def: complication]
komponent/N [def: component]
kompot/N [m] [def: fruit dessert]
	epl-kompot [m] [def: applesauce] 
kompozitor/S [m] kompozitorin/S [f] [def: composer]
	kompozitsye/S [f] [def: composition]
kompres/N [m] [def: compress]
kompromi's/N [m] [def: compromise, tradeoff]
	umkompromislekh/A [def: uncompromizing] 
	kompromisloz/A [def: uncompromizing] [usage: inadmissable]
kompyuter/S [m] /Iish [m] [def: computer] kompyuteray'/N [n] [def: computer]
	shoys-kompyuter/S [m] [def: laptop computer] 
	tish-kompyuter/S [m] [def: desktop computer] [note: V] 
komuniki'r/V/Bkomuniki'rt [def: communicate]
	komunikatsye/S [f] [def: communication]
		telekomunikatsye/S [f] [def: telecommunication] % Forwards
	komunika't/N [m] [def: communiqué, communication] 
	komunikirke/S [f] [def: walkie-talkie] 
komunizm/N [m] [def: communism]
	komuni'st/N [m] [def: communist] /Iish [def: communist]
konbinatsye/S [f] [def: clever plan] 
konditsyone'r/N [m] [def: conditioner] 
	hor-konditsyone'r [m] [def: hair conditioner] 
	hoyt-konditsyone'r [m] [def: skin conditioner] 
konduktor/S [m] [def: conductor]
konferi'r/V/Bkonferi'rt [def: confer, discuss] 
	konfere'nts/N [f] [def: conference]
		mini-konfere'nts [f] [def: mini-conference] 
	konferantsye/S [m] [def: boss] 
konfesye/S [f] [def: confession]
konflikt/N [m] [def: conflict]
konfronti'r/V/Bkonfronti'rt [def: confront (English)] 
konglomera't [m] [def: conglomeration] 
kongres/N [m] [def: congress]
konishine [f] [def: clover]
konkret/A [def: concrete]
konkuri'r/V/Bkonkuri'rt [def: compete]
	konkurent/N konkurirer/S [m] [def: rival] /Iish [def: rival]
	konkurents/N [f] [def: rivalry]
konkurs/N [m] [def: contest, competition, collection]
konsekvents/N [m] [def: consequence] 
konseptsye/S [f] [def: conception] 
konservi'r/V/Bkonservi'rt [def: conserve] 
	konserv/N [def: preserves]
	konservativ/A [def: conservative]
	konservatizm/N [m] [def: conservativism]
	konservatorye/S [f] [def: conservatory (music school)] 
		konservatori'st/N [m] konservatoristke/S [f] [def: music student] 
konsilyum/S [def: council (gathering)] 
konsonant/N [m] [def: consonant]
konspiri'r/V/Bkonspiri'rt [def: conspire] konspiratsye/S [f] [def: conspiracy]
konstitutsye/S [f] [def: constitution]
	konstitutsyone'l/A [def: constitutional] umkonstitutsyone'l/A [def: unconstitutional] 
konstrui'r/V/Bkonstrui'rt [def: construct]
	konstruktsye/S [f] [def: construction]
	konstruktiv/A [def: constructive]
	rekonstrui'r/V/Brekonstrui'rt [def: reconstruct] 
		rekonstruktsye/S [f] [def: reconstruction] 
kontakt/N [m] [def: contact]
	kontakti'r/V/Bkontakti'rt [def: contact]
kontekst/N [m] [def: context] 
kontinent/N [m] [def: continent]
kontinui'r/V/Bkontinui'rt [def: continue]
	kontinuitet/N [f] [def: continuity]
kontrabandi'st/N [m] [def: smuggler, drug dealer] 
kontrakt/N [m] [def: contract]
kontur/N [m] [def: contour]
kontrasti'r/V/Bkontrasti'rt [def: contrast]
	kontra'st/N [m] [def: contrast] 
kontre [def: country (American)] [usage: inadmissable]
kontroli'r/V/Bkontroli'rt [def: control, check]
	kontrol/N [m] kontrole/S [f] [def: control]
kontroversye/S [f] [def: controversy] 
	kontroversyel/A [def: controversial] 
kontsentri'r/V/Bkonsentri'rt [def: concentrate]
	kontsentratsye/S [f] [def: concentration]
kontseptsye/S [f] [def: conception]
	kontsept/N [def: concept]
kontsert/N [m] [def: concert]
kontsesye/S [f] [def: concession] % Forwards
konvents/N [f] [def: convention]
	konventsyone'l/A [def: conventional] 
konve'rt/N [m] [def: envelope, paper jacket] 
konverti'r/V/Bkonverti'rt [def: convert] 
konyugi'r/V/Bkonyugi'rt [def: conjugate (grammar)]
	konyugatsye/S [f] [def: conjugation (grammar)]
	konyugirish/A [def: conjugate (mathematics)] 
koordini'r/V/Bkoordini'rt [def: coordinate]
	koordinirer/S [m] koordinirerin/S [f] [def: coordinator]
kop/Xkep [m] [def: head] /Dkep
	tsukopns [def: at the head]
	eyberkop/Deyberkep [def: head]
	golkop/Xgolkep [def: skinhead] 
	hitskop/Xhitskep [m] [def: hothead] 
	kep/V/T [def: decapitate]
	karpnkop/Xkarpnkep [def: intelligent person] 
	toytnkop [m] [def: death's-head]
	tsapnkop/Xtsapnkep [m] [def: goat head (decoration on a staff)] 
	unterkepl/Xunterkeplekh [def: subtitle (film)] 
	[idiom: fun kop biz fis = from top to bottom]
	[idiom: hobn a kop tsu epes = be in the mood for something]
kope/V/T [def: kick] /Gayn
	kope/S [m] [def: kick] 
kopeke/S [f] [def: kopek (Russian currency; 1/100 ruble)]
kopi'r/V/Bkopi'rt [def: copy] /Gop
	fotokopi'r/V/Bfotokopi'rt [def: photocopy]
	kopye/S [f] [def: copy]
kopite/S [f] [def: hoof]
kora'n [m] [def: Koran] % Forwards
korb/N/Dkerb [m] [def: basket]
kore/S [f] [def: tree bark] /In
korespondi'r/V/Bkorespondi'rt [def: correspond]
	korespondent/N [m] [def: correspondent]
	korespondents/N [f] korespondentsye/S [f] [def: correspondence]
		teykef{WyKf}-korespondentsye/N [f] [def: instant message, IM (computer)] [note: V] 
korete/S [f] [def: trough (for food)]
koridor/N/D [m] [def: corridor]
korigi'r/V/Bkorigi'rt [def: correct]
	korekt/A [def: correct]
korik/N [m] [def: fuse (electrical)] 
korme/V/T [def: feed]
korn [m] [def: rye] koren/A [def: rye]
	kerner [def: grain]
	kerndl/Eekh [def: seed]
korporatsye/S [def: corporation] 
korsazh [m] [def: corsage]
kort/N [f] [def: (playing) card] /Dkert
	[idiom: oyfdekn di kortn = put one's cards on the table]
	[idiom: varfn kortn = tell fortunes]
	[idiom: leygn kortn = tell fortunes]
	[idiom: alts vos in di kortn = every possible evil]
	[idiom: makhn a kertl = play a card game]
kortsh/Ees [m] [def: tree stump] 
kortshe/V/T [def: toss and turn] /Gayn
	oysgekortshevet/A [def: rooted out and discarded] 
korumpi'r/V/Bkorumpi'rt korupti'r/V/Bkorupti'rt [def: corrupt] 
	koruptsye/S [f] [def: corruption] 
kos{Kws}/Xkoyses{KwswT}/H [m] koyse{Kws|h}/H [def: cup, goblet, glass (vessel)]
	farkoset{farKwset}/A [def: tipsy] 
	[idiom: makhn a kos{Kws} = have a drink (alcoholic)]
kose/S [f] [def: small scythe]
	kose/V/T [def: reap, cut]
kose [adv] [def: aslant, diagonal; sloping; oblique] 
	[idiom: kukn kose = squint]
koshe{kSh}/H [def: difficult]
	nishkoshe [def: not bad] /Idik [def: middling]
kosher{KSr}/H/K [def: kosher]
	kashres{KSrwT}/H [def: kosherness]
	kasher{KSr}/H/V/T [def: kosher] /Goys
	makhsher{mxSyr}/Xmakhshirem{mxSyrym}/H [m] [def: utensil, apparatus]
	kishren{KySrwn}/Xkishroynes{KySrwnwT}/H [m] [def: talent]
koshlke/S [m] [def: somersault]
koshmar/N [m] [def: nightmare]
koshme/-koshme tsekoshmet/A [def: in disarray]
kosmonoyt/N [m] [def: cosmonaut]
kosmos/N [m] [def: cosmos]
kost/V/T [def: cost] kost/N [m] [def: cost]
kostard/N [m] [def: custard]
kostyum/N [m] [def: costume]
kotle't/N [m] [def: chop, cutlet; hamburger (food)] 
kotn{ktn}/H [def: small] /Lh
kotsher/Ees [m] [def: poker (fireplace)] 
kovel/Ees [m] koval/Eyes [m] [def: blacksmith] 
	kovadle/S [f] [def: anvil] 
koved{KBwd}/H [def: honor] /Ll /Lh /Lum 
	kibed{Kybwd}/H [def: refreshments, snack in honor of a guest; honor]
	bekoved{bKBwd}/H/A /Iik [def: honorable]
	bekhvoyde{bxBwdw}/H [def: in his glory]
	mekhabed{mxbd}/H [def: honor (with "zayn")]
	kisey{Ks#}-hakoved{hKBwd}/H [m] [def: toilet facility] 
	yiras-hakoved{yir#T-hKBwd}/H [f] [def: respect] 
	yiras-shomayem{yir#T-Smym}/H [f] [def: fear of God] /Idik
		yiras-shomayemdikayt{yir#T-Smymdikayt}/N [f] [def: fear of God] 
	[idiom: ikh bet iber ayer koved = pardon my French]
	[idiom: leygn groys koved{KBwd} oyf = esteem]
koydem{kwdm}/H [def: first]
koydesh{kdwS}/H /Lh /Idik [def: holy] kedoyshem{kdwSym}/H
	koydesh{kdwS}/V/T [def: sanctify]
	kidesh{kidwS}/H [def: benediction over wine for Sabbath and holidays]
		kidesh{kidwS}-levone{lBnh} [def: blessing the new moon] 
	kedishe{kdyS#}/H [def: funeral society (with "khevre -")]
	kedushen{kydwSyn}/H [def: marriage vows]
	kedushe{kdwSh}/H [f] [def: holiness]
	kidshonu{kdSnw}/H [def: has sanctified us]
	kadish{kdyS}/Xkadishem{kdySym} [def: Kaddish prayer, son]
	mikdesh{mkdS}/H /Lh [n] [def: Temple]
	hekdesh{hkdS}/H [def: public poor-person accomodation, mess]
koyekh{KwH}/H [def: ability; strength] /Lb /L|w /Lm [def: in regard to]
	koykhes{KwHwT}/H [def: strength]
	[idiom: iber di koykhes{KwHwT} = beyond one's ability]
	[idiom: nit far mayne koykhes{KwHwT} = beyond my ability]
	[idiom: mit ale koykhes{KwHwT} = with all one's might]
	[idiom: emetsn tsukumen a tsveyter koyekh{KwH} = get a second wind] [note: V]
koyen{Khn}/Xkohanem{Khnym}/H [m] [def: priest, Cohen]
koyf/V/T [def: buy] /Gayn/Goyf/Gunter/Giber/Goys/Gon/Gop/Gavek/Gtsunoyf
	farkoyf/V/Bfarkoyft [def: sell] /Goys
	koyfman [m] [def: merchant] koyfmenish/A [def: merchantlike]
	farkoyfer/S [m] farkoyferke/S [f] [def: merchant]
	oyskoyf/N [def: sale]
koyl/N [f] [def: coal, bullet]
	erdkoyl/N [f] [def: coal] 
	shneykoyl/N [f] [def: snowball]
	keylekhdik/A [def: round]
koyle/V/T [def: slaughter] /Goys/Gavek/Gop
	koylenen % variant infinitive
	koyler/S [m] [def: slaughterer]
koyletsh/N/D [def: braided bread]
koylrabi kilerib [def: kohlrabi (vegetable)] 
koym [adv] [def: barely]
koymen/S [m] [def: chimney] milkoymen/S [m] [def: mill chimney]
koymer{Kwmr}/Xkomrem{Kwmrym}/H [m] [def: Christian clergyman]
koyne{kwnh}/Xkoynem{kwnym}/H [m] koynete{kwnhte}/S [f] [def: customer]
koyp/N [m] [def: hill, knoll; pile, heap] 
koyrev{krwB}/Xkroyvem{krwBym}/H [m] [def: relative (male)]
	kroyvish{krwBish}/A [def: related; cognate] 
	kroyve{krwBh}/Xkoryves{krwBwT}/H [f] [def: relative (female)]
	kroyveshaft{krwBhshaft}/N [f] [def: relation]
	makrev{mkryB}/H [def: bring close, sacrifice, trade off (with "zayn")]
	korben{krbn}/Xkorbones{krbnwT}/H [m] [def: sacrifice]
	kurve/S [def: prostitute] kurvish/A [def: prostitute-like]
	bekoyrev{bkrwB} [adv] [def: soon] 
koysh/N/Dkeysh [m] [def: basket]
	koshik/Ees/D [m] [def: basket]
koyt [def: filth] /Iik [def: filthy]
	mayznkoyt [def: mouse droppings] 
kozak/N [m] [def: Cossack]
koze/S/D [f] [def: goat; prison; rowdy girl] % Stutshkov for prison, rowdy girl
	kozak [m] [def: prison] % Stutshkov
	[idiom: makhn di grobe koze = make a profit] % Stutshkov
kraft/N [f] [def: force] /Iik kreftik/A [def: forceful]
	tsutsikraft/N [f] tsutsiungs-kraft/N [f] [def: attractive force (physics)] 
	bakreftik/V/Bbakreftikt [def: verify] 
krake/V/T [def: caw (sound of a crow)]
krakh/V/T [def: crash] /Garop
	gekrakh/N [m] [def: crashing noise] 
krank/A [def: sick] krenklekh/A [def: sick] 
	krankayt/N [f] krankshaft/N [f] krenk/N [f] krenkung/N [f] [def: sickness]
		[idiom: yene krenk = epilepsy]
		[idiom: di bitere krenk = epilepsy]
	krenk/V/T [def: ail]
	tsu'kerkrenk/N [f] [def: diabetes]
	a'ltshaymer-krenk/N [f] [def: Alzheimer's disease] 
krants/N [m] [def: wreath] /Dkrents [def: group, gathering, huddle] 
krate/S [f] [def: bar (on window)] 
krats/V/T [def: scratch; plaster] /Goys
	tsekrats/V/Btsekratst [def: scratch]
	kratsmikh [def: Christmas (pejorative)]
	volkn-kratser/S [def: skyscraper] 
krayd/N [f] [def: chalk]
krayke/S [f] [def: ??] % zi vigt zikh af a flamiker krayke
kraytekhts/N/Eer [n] [def: vegetables]
krayz/V/T [def: circle] /Garum
	krayz/N [m] arumkrayz/N [m] [def: circle] halbkrayz/N [m] [def: semicircle] 
		krayzl/Eekh [def: ripple] 
	krayzl/V/T [def: circle]
	leyenkrayz [m] [def: reading circle]
	shraybkrayz [m] [def: writing circle]
	sternkrayz [m] [def: universe] 
kredi't [m] [def: credit]
	kley'tkredi't [m] kro'mkredi't [m] [def: store credit] [note: V]
	diskrediti'r/V/Bdiskrediti'rt [def: discredit]
krek/V/T [def: choke]
krekhts/V/T [def: groan] /Gop 
	krekhts/N [m] [def: groan]
	krekhtser/S [m] [def: complainer] 
	kre'khtsenish/N [def: groaning]
krel/N [m] [def: claw, scratch]
krel/N [f] [def: bead]
krem [m] [def: cream]
	ayzkrem [m] [def: ice cream]
	golkrem/N [m] [def: shaving cream] % Harduf
krematorye/S [f] [def: crematorium]
kreml [m] [def: Kremlin]
kre'nitse/S [f] [def: well, spring (water)]
krepke/A [def: sturdy] 
krepl/Xkreplekh [def: filled dough] % no positive; singular diminutive is rare
kretshme/S [f] [def: tavern]
	kretshmer/S [m] [def: tavern keeper]
	kretshmerke/S [f] [def: tavern keeper]
kretsik/A [def: leprous]
kreye/V/T [def: crow (sound of a rooster)] /Garayn
	tsekreye/V/Btsekreyet [def: burst into crowing] 
kreyts/N [m] [def: cross] [usage: doubtful admissability]
	kreytsik/V/T [def: crucify] kreytsikung/N [f] [def: crucifiction] 
	haknkreyts [m] [def: swastika]
	kreytstsug/N [m] [def: crusade] 
	gekreytst/A [def: crossing; cross-shape] 
	kreyts/V/T [def: cross] /Gdurkh
krie/S [def: ice flow]
krig/V/Bgekrogn [def: receive] /Garoys/Gtsu/Gtsurik % not gekrign
	krug/N [m] /Dkrig [def: jug, container for liquid]
	[idiom: zayn tsum krign = available]
krig/V/T/Garayn [def: fight (with "zikh")]
	kriger/S [m] [def: fighter] krigeray'/N [n] [def: fight]
	birgerkrig/N [m] briderkrig/N [m] [def: civil war]
	tsekrig/V/Btsekrigt [def: fight]
	farkrig/V/Bfarkrigt [def: fight]
	krig/N [m] [def: war] krigs [prefix] [def: war] 
krikh/V/Bgekrokhn [def: creep, crawl]
	/Garayn/Garoys/Garoyf/Garunter/Gop/Goys/Garop/Gavek/Gtsu/Gdurkh/Garum
	/Gariber
	farkrikh/V/Bfarkrokhn [def: creep]
	tsekrikh/V/Btsekrokhn [def: creep]
	krikher/S [m] [def: crawler] 
kriminel/A [def: criminal] kriminal/N [m] [def: jail]
kripl/N [m/f] [def: cripple]
	farkripl/V/Bfarkriplt [def: cripple]
kripton [m] [def: krypton (Kr)] 
krire{kryrh}/Xkrires{kryrwT}/H [f] [def: cold] 
krishl/V/T [def: crumble, be brittle (with "zikh")]
	tsekrishl/V/Btsekrishlt [def: crumble, fragment] 
krishtol /Ien [m] [def: crystal]
krist/N [m] [def: Christian] /Ilekh [def: Christian]
	urkrist/N [m] /Ilekh frikristlekh/A [def: early Christian] 
	kristntum [n] [def: Christianity]
		urkristntum [n] [def: early Christianity] 
	farkrist/V/Bfarkrist kristik/V/T [def: make Christian; baptize]
kritiki'r/V/Bkritiki'rt [def: criticise]
	kritik [f] [def: criticism (subject)]
	kritish/A [def: critical] kritiker/S [m] [def: critic]
	krizis/N [m] [def: crisis] 
krits/V/T [def: engrave, scratch] /Garayn/Gayn/Goys
	kritsung/N [f] [def: scratching, engraving]
	kompaktl-aynkritser/S [m] [def: CD burner] [note: V]
krivde/S [def: grievance, injustice]
	[idiom: onnemen zikh emetsns krivde = stick up for someone]
	krivde/V/T [def: injure, wrong] 
kriyas{kry|eT}/H [def: reading, splitting]
	[idiom: kriyas{kry|et} yam suf = extremely difficult]
krizh/Ees [m] [def: loins, small of the back] 
	[idiom: boygn dem krizh = work hard]
kroket [def: croquet]
krokhik/A [def: friable, frangible] 
krokhmal [m] [def: starch]
	krokhmal/V/T [def: starch]
krokshtine/S [f] [def: bracket] 
krok/N [m] [def: crotch, groin]
krokve/S [f] [def: rafter]
krolik/N/D [def: rabbit; timid person]
krom/N [f] [def: store]
	kremer/S/D [m] kremerke/S [f] [def: storekeeper]
	apteykkrom/N [f] [def: pharmacy (store)]
	shnitkrom/N [f] [def: dry-goods store]
	shporkrom/N [f] [def: thrift shop] [note: V]
krop [m] [def: dill]
kropeve [f] [def: nettle]
kroshke/S [f] [def: sugar cube (with "tsuker") (food)] 
kroyn/V/T [def: crown]
	bakroyn/V/Bbakroynt [def: crown] 
	kroyn/N [f] [def: crown]
kroyt/N [n/f] [def: cabbage]
	bleterkroyt [n/f] [def: kale; collard greens] 
	zoyerkroyt [n] [def: sourkraut]
	kreyter [def: herbs, vegetable-based medicines] [grammar: only in plural]
	[idiom: geviklte kroyt = gefilt kroyt = stuffed cabbage (food)]
	[idiom: shemen zikh vi a bok/tsig/koze in kroyt/gortn = display khutspe] % Stutshkov
krum/A/Kkrim [def: crooked]
	krim/V/T/Garoys/Goys [def: bend]
		/Gnokh [def: imitate]
	farkrim/V/Bfarkrimt [def: bend, bastardize]
		farkri'menish/N [n] [def: bending, bastardization] 
krup [noun] [def: flank of horse] 
krupnik [def: barley soup]
ksav{KTB}/Xksovem{KTBym}/H [m/n] [def: writing] /Lb [def: written]
ksenofobye/S [f] [def: xenophobia] ksenofobish/A [def: xenophobic] 
ksenon [m] [def: xenon (Xe)] 
ksube{KTwbh}/Xksubes{KTwbwT}/H [f] [def: marriage contract]
ku/Xki [f] [def: cow] kien/A [def: pertaining to cows]
ku/Een [m] [def: the letter Q] 
ku-ku-ri-ku [interj] [def: cockadoodle-doo (sound of a rooster)] 
kuf{kʼ}/H [m/f] [def: Hebrew letter Kuf]
kugl/N/Dkug [m] [def: pudding]
	erdkugl [m] [def: earth (planet)] /Derdkug
kuk/V/T [def: look]
	/Giber/Gdurkh/Gadurkh/Garayn/Garop/Garoyf/Garum/Gayn/Gnokh/Gon/Goys
	/Gtsu/Gum/Gariber/Gtsurik
	/Garoys [def: expect, look forward to]
	bakuk/V/Bbakukt [def: inspect, examine]
	farkuk/V/Bfarkukt [def: ignore]
	aynkuk [m] [def: attention, scrutiny]
kukavke/S [f] [def: cuckoo]
kukuruze [def: maize]
kulik [m] [def: fist]
kultivi'r/V/Bkultivi'rt [def: cultivate]
	kultu'r/N [f] [def: culture] /Iel [def: cultural]
		kegnkultu'r/N [f] [def: counterculture] 
		multi-kulturishkayt/N [f] [def: multiculturalism] 
		fizkultu'r/N [f] [def: gym, athletics (school subject)] 
	subkultur/N [f] [def: subculture]
	shprakhkultur/N [f] [def: linguistic culture]
kum/V/Bgekumen [def: come]
	/Garoys/Gnokh/Garayn/Gdurkh/Gaher/Gaheym/Gahin/Gariber/Gfor/Gum
	/Gtsurik/Gforoys/Garop/Gfir/Gon/Gtsu/Goys/Gtsunoyf/Goyf/Gop/Gfar
	/Gtsuzamen/Gantkegn/Gakegn/Gavek/Garoyf
	/Gbay [def: prevent, overcome] [grammar: not in present tense]
	/Gon [def: arrive, approach for assistance (with "tsu")]
	/Giber [def: survive, overcome] 
	bakum/V/Bbakumen/Garayn/Garoys/Gtsurik [def: acquire, receive]
		[idiom: zayn tsum bakumen = available]
	kumedik/A [def: coming] % variant
	opku'menish/N [n] [def: come-uppance]
	tsuzamenkum/N [def: meeting]
	oysku'menish/N [n] [def: sustenance, subsistence]
	aynkunft/N [f] [def: salary, pay, earnings] 
	tsukunft/N /Iik [f] [def: future]
	aroyskum/N [m] [def: result]
	onkum/N [m] [def: arrival] 
	tsunoyfkum/N [m] [def: meeting, gathering] 
	umkum/N [def: destruction]
	[idiom: kumen tsu zikh = become conscious]
kumer/N [m] [def: grief, sorrow] 
kund/N [m] kundin/S [f] [def: customer] [usage: doubtful admissability]
kundes{kwnds}/Xkundeysem{kwndsym}/H [m] [def: prankster, brat]
kune/S [def: pillory]
kunst/N [f] [def: art] /Iik [def: artistic]
	kinstlekh/A [def: artificial] 
	kinstler/S [m] [def: artist] /Iish [def: artistic]
kunts/N [f] [def: trick] /Iik [def: tricky]
	[idiom: kuntsn-makher = juggler]
kupe/S [def: rick (hay); drift (snow)]
kupe{kwph}/Xkupes{kwpwT}/H [f] [def: money chest] 
kuper [n] [def: copper (Cu)] kupern/A [def: copper]
kupetshestve/S [def: permission to run a business]
	kupets/N [m] [def: holder of a kupetshestve] 
kupol/N [def: cupola] 
kurator/N [m] [def: curator] 
kuratsye/S [f] [def: cure] kurort [m] [def: spa]
kurazh [def: courage]
kurd/N [m] [def: Kurd] /Iish
kurelapnitshke/S [def: seller of eggs/chickens/ducks]
kurikulum [m] [def: curriculum] 
kuropatke/S [f] [def: partridge] 
kurs/N [m] [def: course]
	kleynkurs/N [m] [def: short course (academic)]
	zumerkurs/N [m] [def: summer course (academic)]
	shprakhkurs/N [m] [def: language course]
kurts/Kkirts [def: short] kirtsung/N [f] [def: shortening]
	kirtslekh/A [def: short]
	kirts/V/T [def: shorten]
	farkirts/V/Bfarkirtst [def: shorten] farkirtsung/N [f] [def: shortening]
kurtshukl/Eekh [n] [def: chick (bird)] 
kuryo'z/N [m] [def: curiosity]
kush/V/T [def: kiss; kiss each other (with "zikh")] /Goys
	kush/N [m] [def: kiss] ku'shenish/N [def: kissing]
	tsekush/V/Btsekusht [def: kiss each other (with "zikh")]
kushetke/S [f] [def: sofa, couch]
kust/Ees/N [m] [def: bush] /Iik
kutsenyu-mutsenyu [def: in an amorous relationship (with "vern mit emetsn")] 
kutshme/S [def: fur hat; Persian-wool hat] 
kuzin/N [m] kuzine/S kuzinke/S [f] [def: cousin] 
khaza'r/N [m] /Xkuzrem{Kwzrym}/H [def: Khazars] 
kvake/V/T [def: croak (sound of a frog)]
kval/N [m] [def: well]
	kvel/V/T [def: rejoice, swell with pride] /Gon
	/Bgekvoln /Gon [def: rejoice] % variant participle
	tsekvel/V/Btsekvoln [def: burst with goodness] 
kvalitet/N [f] [def: quality]
	kvalitsi'r/V/Bkvalitsi'rt [def: qualify]
	diskvalifitsi'r/V/Bdiskvalifitsi'rt [def: disqualify] 
kvantitet/N [f] [def: quantity]
	kvantum/S [m] [def: quantity] 
kvape/V/T [def: have an appetite for (with "zikh oyf")]
kvarti'r/N [f] [def: district, board, lodgings]
	kvartal/N [m] [def: neighborhood, quarter (of a town)]
	kvart'ir/V/Bkvarti'rt [def: lodge, board] 
		aynkvarti'r/V/Baynkvarti'rt [def: lodge, board] 
	hoyptkvartir/N [f] [def: headquarters] % Forwards
kvas [m] [def: kvass (Russian drink), cider]
	kvasnitse/S [f] [def: cider apple] 
kvenkl/V/T [def: hesitate (with "zikh"), be reluctant (with "zikh")]
kvert/D [f/n] [def: quart] [note: Weinreich says f/n, GYD says f/m]
kvestyoni'r/V/Bkvestyoni'rt [def: question the truth or value] 
kvetsh/V/T [def: squeeze, press, pinch] /Gadurkh/Gmit/Garoys/Garayn
	farkvetsh/V/Bfarkvetsht [def: squeeze]
	tsekvetsh/V/Btsekvetsht [def: squeeze]
	gekvetshterheyt [def: squeezed]
	kvetsher/S [m] kvetsherke/S [f] [def: complainer] 
	[idiom: es kvetsht zikh im = he has an urge]
kveyt/N [m] [def: flower, blossom] 
kvik/V/T [def: refresh]
kvit [m] [def: receipt]
	/D [def: receipt, tag] 
		/Dprayzkvit [def: price tag, price label] 
	kvit [interj] [def: paid up (expression of finality)]
	shtrofkvit/N [m] [def: ticket (infraction)] 
kvitshe/V/T [def: squeak, squeal]
	kvitsh/N [def: squeak (sound of a bird), squeal (sound of a pig)]
		/Iik [def: squeaky]
	kvitsheray/N [f] [def: squealing, squeaking] 
kvoder/S [m] [def: quarter (currency)]
kvoke/V/T [def: honk (sound of a goose)]
kvol/A [adj] [def: sickly, scrawny; hypersensitive] 
kvort/N [f/n] [def: quart] [note: Weinreich says f/n, GYD says f/m]
kvote/S [f] [def: quota]
kyo'sk/N [m] [def: newsstand] 
labn/S/Dleb [m] [def: loaf]
laboratorye/S [f] [def: laboratory]
lad/V/Bgeladn/Gayn [def: invite]
	aynlad/N [m] aynladung/N [f] [def: invitation]
ladino [n] [def: Ladino]
lage/S [f] [def: situation]
	baylage/S [f] [def: supplement] 
lager/S/N [m] [def: camp]
	balager/V/Bbalagert [def: besiege] balagerung/N [f] [def: seige] 
lakh/V/T [def: laugh] /Garayn/Gmit/Gop
	/Goys [def: ignore with laughter (with "zikh")] 
	tselakh/V/Btselakht [def: laugh]
	derlakh/V/Bderlakht [def: laugh]
	farlakh/V/Bfarlakht [def: make fun of]
	gelekhter/S/D [n] [def: laughter]
	lakhedik/A [def: laughing] % variant
	lekhlekh/A [def: laughable] lekherlekh/A
	lakherayke/S [def: comedy (theater)] 
laki'r/V/Blaki'rt [def: varnish]
lakkhn{lkHn}/H/V/T [def: steal] /Gtsu/Gavek
	mekekh{mkH} [def: commerce, price]
laks/N [m] [def: lox, salmon (fish)] 
lakrets [m] [def: licorice, a particular playing card]
lalke/S [f] [def: doll]
lam /-lam /Dlem [def: gullible person] lemeshke/S
	[idiom: kuni leml = fool, bumpkin]
lame{lmh}/H [def: why] /Lh
	may_{ma|y}/H [def: what]
	lema'y{lma|y} alema'y{alma|y} halema'y{hlma|y}/H [def: why; why then]
lamed{lmd}/H [m/f] [def: Hebrew letter Lamed]
lamtern/S/Dlamternd [m] [def: lantern]
land/Xlender [m] [def: country] /Iish
	anderlendish/A [def: foreign]
	mitlendish/A [def: Mediterranean (with "yam{|ym}")] 
	tsvishnlenderish/A [def: cross-country]
	oysland [m] [def: a foreign country]
		oyslendish/A [def: foreign]
		oyslender/X [m] oyslendershe/S [f] [def: foreigner]
	foterland/Xfoterlender [n]  heymland/Xheymlender [n][def: homeland]
		foterlendish/A
	hoykhland/Xhoykhlender [n] [def: highland] 
	palmenland [n] [def: place where palm trees grow]
	yidishland [n] [def: place where Yiddish is spoken]
	yidnland [n] [def: Israel (poetic)]
	landshaft/N [m/f] [def: landscape; scenery]
	land/V/T [def: land, come to land] 
		landung/N [f] [def: landing, coming to land] 
lane [def: linen]
lang/Kleng [def: long; for (duration)]
	[grammar: postpositive to mean "for": a sho lang]
	vokhnlang/A [def: for weeks]
	yornlang/A [def: for years]
	langzam/K [def: slow (German)]
		farlangzam/V/Bfarlangzamt [def: make slow]
	leng [f] [def: length] /Ilekh
		lebnslenglekh/A [def: life-long] 
	langonik/A longonedik/A [def: old-time]
	farlenger/V/Bfarlengert [def: extend] 
		farlengerung/N [f] [def: extension] 
lantanum [m] [def: lanthanum (La)] 
lape/S [f] [def: paw] lapke/S
lapitut/N [m] [def: gnome]
lapsus/N [m] [def: lapse] 
	elter-lapsus/N [m] [def: senior moment] [note: V]
lashtshe/V/T [def: crave (with "zikh"), hug]
last/N [f] [def: burden]
	balastik/V/Bbalastikt [def: impose, burden, encumber]
	balestik/V/Bbalestikt [def: molest]
latayn [n] [def: Latin] /Iish [def: Latin]
late/V/T [def: patch]    
	farlate/V/Bfarlatet [def: patch]
	late/S [f] [def: patch]
latke/S [f] [def: potato pancake (food)]
lats/N [m] [def: lapel]
	[idiom: onnemen baym lats = to buttonhole]
lave'ndl/N [n] ave'ndl [n] lave'nder [m] [def: lavender]
lavine/S [f] [def: avalanche] 
lay/V/Blien [def: borrow] antlay/V/Bantlien [def: lend] % not gelayt
	farlay/V/Bfarlien [def: lend]
layb/Eer [m] [def: body] balaybt/A
	/D [def: little body; undershirt (clothing)] 
layd/V/Bgelitn [def: suffer] /Gon
	leyd/N [f] laydn [n] [def: suffering, grief, pain]
		mitleyd/N [f] [def: empathy]
	baleydik/V/Bbaleydikt [def: insult] baleydikung/N [f] [def: insult]
	derlaydn/V/Bderlitn [def: suffer]
	laydnshaft/N [f] [def: passion] /Ilekh [def: passionate]
	layder [interj] [def: alas!, unfortunately] [usage: doubtful admissability]
	[idiom: lange laydn un leydn = trials and tribulations]
layke [f] [def: gauze]
laykht/A [def: easy; light]
	otem-farlaykhterer/S [def: decongestant] [note: V]
	farlaykhter/V/Bfarlaykhtert [def: facilitate; lighten; relieve] 
		farlaykhterung/N [f] [def: relief] 
layle{lylh}/H [m] [def: night] /Lv
	leyl{lyl}/H [def: night of]
laylekh/Eer [m/n] [def: bedsheet]
layt/N [def: people] /Iish [def: proper]
	adl-layt/N [def: nobility]
	arbet|slayt/N [def: workers]
	gevelbslayt/N [def: merchants] 
	landslayt/N [def: people from the same district]
	laytishkayt/N [def: propriety]
	marklayt/N [def: merchants]
	oremelayt/N [def: poor people]
	shtotlayt/N [def: city dwellers]
	yungelayt/N [def: youngsters]
	[idiom: tsu got un tsu layt = upstanding]
layvnt/N [f] [def: linen] layvnten/A [def: linen] % not leyvnt
lazer/N [m] [def: laser] 
lazi'r/V/Blazi'rt /Garayn [def: pop in unannounced (with "zikh")] 
leb/V/T [def: live] /Gadurkh/Goyf/Goys/Gtsunoyf/Gop/Gdurkh/Gayn
	/Giber [def: survive]
	antleb/V/Bantlebt [def: take a life] 
	baleb/V/Bbalebt [def: give life to]
	farleb/V/Bfarlebt [def: live]
	derleb/V/Bderlebt [def: live to see]
	[idiom: ir zolt derlebn iber a yor = many happy returns]
	iberlebung/N [f] [def: experience]
	oyflebung/N [f] [def: reviving]
	lebedik/K [def: lively, alive] lebedikerheyt [def: alive]
	lebn/S [n] [def: life]
		shtillebn/S [n] [def: still life (painting)] 
		khlebn [interj] [def: indeed; as I live] 
		[idiom: mayn gants lebn iz ... = I live for ...]
leber/S/D [f] [def: liver]
lebn/P [def: near]
leder [f/n] [def: leather] /In
lefl/X [m] [def: spoon] lefele/Ekh [n] [def: teaspoon] 
	eslefl/X [m] eslefele/Xeslefelekh [n] [def: tablespoon]
	kokhlefl/X [m] [def: cooking spoon, busybody]
	sheplefl/X [m] [def: ladle] 
	shukhlefl/X [m] shukhlefele/Ekh [n] [def: shoe horn]
	teylefl [m] teylefele/Ekh [n] [def: teaspoon] 
legal/A [def: legal] umlegal/A [def: illegal]
legende/S [f] [def: legend] legendar/A/Iish [def: legendary]
leger/V/T /Gtsu [def: leave lying about]
	farlegert/A [def: stale] 
	tsugelegert/A [def: stale] 
legi'r/V/Blegi'rt [def: alloy] 
	legirung/N [f] [def: alloy] 
legitimi'r/V/Blegitimi'rt [def: legitimize]
	legitimatsye/S [f] [def: legitimacy]
legyon/N [m] [def: legion]
lek/V/T [def: lick] /Goys/Gunter/Gop
	balek/V/Bbalekt [def: lick]
	lek/N [m] [def: lick] leker/S [m] [def: licker]
	lekekh/N/Eer [m] [def: cake; diamond (shape); diamond (playing cards)] 
		/D [def: cookie] 
		honik-lekekh/Eer [m] [def: honeycake] 
lekhlutin{lHlwtyn}/H [def: entirely]
lekhts/V/T [def: yearn]
lekish/N [m] [def: fool, simpleton]
leksikon [m] leksik [m] [def: lexicon]
	leksikograf/N [m] [def: lexicographer] /Iish [def: lexical]
	leksik/A leskikal/A leksish/A [def: lexical]
	umleksik/A [def: improper lexically]
lektor/N [m] [def: lecturer]
	lektsye/S [f] [def: lecture]
leman{lmen}/H [def: for the sake of]
lempert/N [def: leopard] 
len/V/T /Gon [def: lean]
	onlen [def: support]
lend/N [f] [def: loin] % not usually in singular
	[idiom: ruk un lend zolstu brekhn afn glaykhn veg]
lepish/A [def: clumsy]
lepl/N [n] [def: (ear) lobe, eyelid]
lepokhes{lpHwT}/H [def: at least]
lern/Vlernen/T [def: teach, study (with "zikh")] /Gayn/Gtsu/Gop/Gon
	/Goys [def: memorize (with "zikh")] 
	derlern/Vderlernen/Bderlernt [def: master (a study)] 
	lerer/S [m] [def: teacher]
		zelbstlerer/S [m] [def: teach-yourself book] 
	lererin/S [f] [def: teacher (female)] lererke/S
	lerner/S [m] [def: student]
	gelernt/A [def: learned] 
		gelerntkayt/N [f] [def: erudition]
	lere/S [f] ler [m] [def: subject of study] 
	lernung/N [f] [def: learning]
lesh/V/T [def: extinguish] /Goys
	/Bgeloshn /Goys [def: extinguish] % variant participle
	farlesh/V/Bfarloshn [def: extinguish]
	lesher/S [m] [def: extinguisher] 
	[idiom: fayer-lesher = fireman]
lester/V/T [def: blaspheme] 
	lesterung/N [f] [def: blasphemy] 
	lesterer/S [m] [def: blasphemer] 
lets{lc}/Xleytsem{lcym}/Xletsonem{lcnym}/H [m] [def: joker] 
	letsones{lycnwT}/H [def: pranks] /Idik [def: joking]
	halotse{hlch} [def: joke] halotses{hlcwT}
	letseve{lceve}/V/T [def: poke fun]
letst/A [def: last] /-letst % letst is not a form: CY C.9, but "tsuletst"
	letstns [def: recently]
	tsuletst [adv] tsuletstns [adv] [def: finally, the last time]
	farletst/A [def: penultimate] 
levad{lBd}/H [def: alone]
	hisboydedes{hTbwddwT}/H [def: solitude]
levaye{lvyh}/Xlevayes{lvywT}/H [f] [def: funeral]
levone{lBnh}/Xlevones{lBnwT}/H [f] [def: moon]
	levonedik{lBnhdik}/A [def: moonlike] 
levush{lBwS}/H [def: clothing]
	malbush{mlbwS}/Xmalbushem{mlbwSym}/H [def: clothing]
levyosn{lvyTn}/H [def: Leviathan]
leyb/N [m] [def: lion]
leydik/A [def: empty, unmarried] /Eerheyt [def: empty, unmarried]
	leydik/V/T [def: empty] /Goys
	derleydik/V/Bderleydikt [def: empty]
	leydikgeyer/S [m] [def: person with no job]
leyen/V/T [def: read] /Giber/Gfor/Gfir/Gop
	leyenung/N [f] [def: reading]
	leyener/S [m] [def: reader]
	forleyen/V/T [def: recite]
leykemye [def: leukemia (disease)] 
leykn/V/T [def: deny] /Gop
	farleykn/V/T [def: deny]
leym [f] [def: clay] /Ien /Iik [def: clay]
leytena'nt/N [m] [def: lieutenant] 
leyter/S/D [m] [def: ladder]
leyter/V/T [def: ease, purify] /Goys
leytse/S [f] [def: rein]
leyv{lB}/H [def: heart] /Lb
leyz/V/T [def: release, solve] /Goys/Gop
	leyzung/N [f] [def: solution, liberation]
	derleyz/V/Bderleyzt [def: liberate]
		derleyzer/S [m] [def: liberator]
	oysleyzer/S [m] [def: liberator]
le'zeberke/S [f] lezbyanke/S [f] [def: lesbian] 
liak/N [def: jug] 
liarem/N [m] [def: din, noise, clamor]
lib/V/T [def: love]
	lib/K [def: dear] balibt/K [def: beloved]
	libhober/S [m] [def: lover]
	farlib/V/Bfarlibt [def: love; fall in love with (with "zikh in")]
	libling/N [m] [def: pet] liblekh/A [def: dear]
	libe/S/D [f] [def: love] libshaft [f] [def: love]
		yidnlibe [f] [def: philosemitism] 
		[idiom: firn a linke libe = have an extramarital affair]
	libele/Xkh [def: dragonfly (insect)] 
liberal/N/A [m] [def: liberal]
lid/Eer [n] [def: song] /D
	kloglid/Eer [n] [def: dirge] 
	libeslid/Eer [n] libelid/Eer [def: love song]
	folkslid/Eer [n] [def: folk song]
	toytnlid/Eer [n] [def: obituary notice] 
	viglid/Eer [n] [def: lullaby]
	zinglid/Eer [n] [def: song]
lifer/V/T /Goys [def: extradite] 
lig/V/Bgelegn [def: lie] /Gop
	leyg/V/T [def: lay]
		/Gtsu/Garayn/Goys/Ganider/Garayn/Garoyf/Gunter
		/Gahin/Garoyf/Gavek/Gayn/Gon/Gop/Goyf/Giber
		/Gbay [def: enclose, attach] 
		/Gayn [def: invest] 
		/Garoys [def: go out (card games)]
		/Gfir/Gfor [def: suggest] 
		forleyger/S [def: suggester] 
		[idiom: aynleygn veltn = move heaven and earth]
	baleyg/V/Bbaleygt [def: lay]
	derleyg/V/Bderleygt [def: add; lose money in an enterprise]
	farleyg/V/Bfarleygt [def: blocked (with "noz"), constipated, folded (with "hent)", establish]
		[idiom: zitsn mit farleygte hent = choose not to act]
	tseleyg/V/Btseleygt [def: lay]
	bayleyg/N [m] [def: enclosure, attachment (mail)] 
	firleyg/N [m] forleyg/N [m] [def: suggestion] 
	oysleyg [m] [def: spelling]
	tsuleyg [def: addendum]
	geleger/S [n] [def: bed; couch] nakhtleger/S [n]
	gelegnhayt/N [f] [def: opportunity, chance]
	farle'gnhayt/N [f] [def: embarrassment]
		[idiom: shteln in a ferlegnhayt = embarrass, put on the spot]
	tsulog/N [m] [def: attachment (mail)] [note: V]
	u'nterlog/N [m] [def: trivet] 
ligatur/N [def: ligature]
lige/S [f] [def: league]
lign/S [m] [def: falsehood]
	ligner/S lignerke/S [f] lignerte/S [f] [def: liar]
	lignerish/A [def: lying]
lik/Ees [m] [def: alley] /D
likht/X/D [f] [def: candle]
	likht/X [n] [def: light]
	likhtik/K [def: bright] likhtikayt/N [f] [def: brightness]
	loykht/V/Bgeloykhtn [def: shine] /Gdurkh
	baloykht/V/Bbaloykhtn [def: illuminate]
		baloykhtung/N [f] [def: illumination]
	laykhter/S [m] [def: candlestick]
		henglaykhter/S [m] [def: candelabra]
	laykht/V/T [def: shine] /Gdurkh/Garayn
		balaykht/V/Bbaloykhtn [def: illuminate]
	bentshlikht [def: Sabbath candles]
		[idiom: a teyrets{Wyrwc} far di bentshlikht = a weak excuse]
	blitslikht/N [def: flashlight]
	morgnlikht/X [n] [def: morning light] 
	toglikht/X [n] [def: daylight]
	likhttsier/S [m] likhttsierin/S [f] [def: candle-maker]
	[idiom: yortsayt likht = memorial candle]
likui{lykui}/H [m] [def: eclipse (with "- h|levone")]
likvidi'r/V/Blikvidi'rt [def: liquidate]
limene/S [f] [def: lemon]
limuzine/S [f] [def: limousine]
linder/V/T [def: ease]
lindz/N [f] [def: lentil]
lingvi'st/N [m] lingvistke/S [f] [def: linguist]
	lingvistik [f] [def: linguistics (subject)] lingvistish/A [def: linguistic]
	tsvishnlingvistik [f] [def: comparative linguistics (subject)]
		tsvishnlingvistish/A
	sotsyolingvistik [f] [def: social linguistics (subject)] sotsyolingvistish/A
link/K [def: left] linki'st/N [m] [def: leftist (political)]
	gelinkt/A [def: left-handed]
linye/S [f] [def: line]
	hartlinik/A [def: hard-line]
	liniar/A [def: linear]
	banlinye/S [f] [def: railway line]
	rern-linye/S [f] [def: pipeline] 
lip/N/D [f] [def: lip] lefts/N
	hoznlip/N [def: cleft palate] 
lipe/S [f] [def: linden (tree)] lipov/A [def: linden]
lirik/N [f] [def: lyric] lirish/A [def: lyric]
lise/A [def: bald]
lishay/Een [m] [def: lichen, skin fungus] 
liske/S [f] [def: scale (fish)] 
liste/S [f] [def: list] 
liter/S [m] [def: liter (metric unit)] 
literatu'r/N [f] [def: litarature]
	fakt-literatur/N [f] [def: non-fiction] [note: V]
	literarish/A [def: literary] literarishkayt/N [f] [def: literariness]
litke/S [f] [def: thigh] 
litseum/S [m] [def: Lyceum, high school] 
litsiti'r/V/Blitsiti'rt [def: auction] litsitatsye/S [f] [def: auction]
litslan{lycln}/H [def: defend us (with "rakhmone -")]
liturgye/S [def: liturgy] liturgish/A [def: liturgical] 
lityum [m] [def: lithium (Li)] 
liverant/N [m] [def: contractor, caterer, purveyor, carriageman] 
	livree/S [f] [def: livery] 
	liver/V/T [def: supply] 
lyod [m] [def: ice] 
	lyode/S [f] [def: icy confection] 
	[idiom: kalt vi lyod = ice cold]
lyokhe/S [f] [def: sow (female pig)] 
lyustre/S [def: large mirror]
l|khen{xn}/H [def: therefore]
logi'k [f] [def: logic] logish/A [def: logical] 
	logishervayz [adv] [def: logically] 
lod/V/Bgelodn [def: load] /Gayn/Giber/Gon/Goys
	balod/V/Bbalodn [def: load]
	farlod/V/Bfarlodn [def: load]
	lodung/N [f] [def: load, summons]
	lo'denish/N [n] [def: lawsuit, litigation, summons]
lodn/S [m] [def: shutter]
lohem{lhm}/H [def: to them]
lok/N [f] [def: lock (hair)]
loka'l/A [def: local]
	loka'l/N [m] [def: premises, locale] 
		atletik-lokal/N [m] [def: health club] [note: V]
		genitung-lokal/N [m] [def: health club] [note: V]
		na'khtlokal/N [m] [def: nightclub] 
loker/V/T [def: lurk, lie in wait for (with "oyf")]
	loker/N [def: ambush]
lokh/Xlekher [f] /Dlekh [def: hole, vagina (vulgar)]
	kroliklokh/Xkrolikleher [f] [def: rabbit hole] 
	moyznlokh/Xmoyznlekher [f] [def: mouse hole] 
	nozlokh/Xnozlekher [f] [def: nostril]
	ratsnlokh/Xratsnlekher [f] [def: rat hole]
	lekher/V/T [def: pierce]
lokomotiv/N [m] [def: locomotive]
loksh/N [m] [def: noodle, thin person] /Ien
	[idiom: langer loksh = tall, thin person]
lom/A [def: lame]
lomir lomikh [def: let's]
lomp/N/Dlemp [m] [def: lamp]
	gasnlomp/N [m] [def: gas lamp]
	blitslempl/Eekh [n] [def: flashlight] 
	spirtlempl/Eekh [n] [def: alcohol lamp] 
lonke/S [f] [def: meadow]
lontshe/V/T [def: launch ??] /Gtsu
lopete/S [f] [def: shovel] % not lopate
	/Dlopatk [def: cooking spoon] 
lord/N [m] [def: lord] 
	[idiom: lebn vi di lordn = live a life of ease]
lorentsyum [m] [def: lawrencium (Lr)] 
lornet/N [def: binoculars, lornette]
loshik/Ees [m] [def: colt] /D
loshn{lSwn}/Xleshoynes{lSwnwT}/H [n] [def: language] /Lh /Lb
	mameloshn [n] [def: mother tongue, Yiddish]
loterye/S [f] [def: lottery]
	loterayke/S [f] [def: lottery tickets] 
	loto [m] [def: lotto]
loy{l#}/H [def: not] lav{l#v}/H [def: not]
loyalite't{lo|yalitet}/N [f] [def: loyalty] 
loyb/V/T [def: praise] /Gop
	/Goys [def: eulogize]
	farloyb/V/Bfarloybt [def: praise]
	derloyb/V/Bderloybt [def: allow] derloy'benish/N [n] [def: permission]
	loy'benish/N [def: praise] loyb [f]
	urloyb/N [m] [def: leave, furlough] 
	[idiom: oplozn/aoysloyzn oyf urloyb = furlough something]
loyer/V/T [def: impend]
loyf/V/Bgelofn [def: run]
	/Gavek/Gnokh/Garayn/Garoys/Garum/Gfarbay/Gon/Gtsu/Gtsurik/Gum/Giber/Gunter
	/Gantkegn/Gtsunoyf/Gadurkh/Gtsuzamen/Goys/Goyf/Garop/Gdurkh
	loyfl/V/T [def: jog] 
	loyfndikerheyt [def: running]
	farloyf/V/Bfarlofn [def: pass (time), occur]
		farloyf [m] [def: passage of time]
	antloyf/V/Bantlofn [def: run away]
		antloyf [m] antloy'fenish [def: running away]
	tseloyf/V/Btselofn [def: run]
	geloyf [n] [def: running] tsaytgeloyf [n] [def: passage of time]
	loyfer/S [m] [def: runner] loy'fenish/N [n] [def: running]
		mi'tloyfer/S [m] [def: companion; comrade] 
		ve'gloyfer/S [m] [def: roadrunner (bird)] 
	shpring-un-loyf [m] [def: track-and-field] [note: V]
loyn/V/T [def: pay]
	baloyn/V/Bbaloynt [def: reward, pay]
		baloynung/N [f] [def: reward, payment]
	loyn/N [m] [def: wages]
loyt/P [def: according to]
loyter/A [def: pure] loyterkayt/N [f] [def: purity] 
	layter/V/T [def: purify]
loyz/V/T [def: empty]
	loyz/A [def: empty]
loyz/Xlayz [f] [def: louse]
	loyz/V/T [def: remove lice] 
loz/V/T [def: let]
	/Garayn/Garop/Garoys/Garunter/Gavek/Gfarbay/Giber/Gnokh/Gop/Goys
	/Gtsu/Garoyf
	/Gdurkh [def: let through; omit] 
	/Bgelozn % variant participle
	/Garayn/Garop/Garoys/Garunter/Gavek/Gfarbay/Giber/Gnokh/Gop/Goys
	/Gtsu
	/Gdurkh [def: let through; omit] 
	derloz/V/Bderlozt [def: allow; tolerate] derlozbar/A [def: allowable]
	farloz/V/Bfarlozt [def: depart from, desert]
		farloztkayt/N [f] [def: state of bein deserted]
		farlozn/A [def: deserted]
	tseloz/V/Btselozt [def: let loose (hair)]
	durkhloz/N [m] [def: omission]
	lebnslozikayt/N [f] [def: lifelessness]
	lozung/N [f] [def: slogan, motto] 
	[idiom: zikh nit lozn = play hard-to-get]
luakh{lwH}/Xlukhes{lwHwT}/H [m] [def: calendar, tablet]
lufe/S [def: loofa (scrubber)]
luft/N [f] [def: air] /Iik
	luftl/Eekh [n] [def: dandelion (plant)] 
luksus/N [m] [def: luxury] /Idik [def: luxurious, upscale] 
lulev{lwlB}/Xlulovem{lulBym}/H [def: lulav (ceremonial bundle including willow, myrtle, palm waved on Succos] 
lung/N [f] [def: lung]
lust [f] [def: desire, cheer] /Iik [def: cheerful]
lustre/S [f] [def: lighting fixture] % what sort??
lutein [def: lutein (food chemical)] 
lutetsyum [m] [def: lutetium (Lu)] 
lyade [def: any] [grammar: indeclinable adjective]
lyalke/S [f] [def: doll]
lyape/V/T [def: smear, botch]
	lyape/S [def: salve]
lyarem/V/T [def: make a commotion, raise an alarm]
	lyarem/N [def: din, noise, alarm]
lyu [def: (lullaby syllable)]
lyubenyu [def: dear] [grammar: term of address]
lyulke/S [f] [def: pipe]
mabl{mbwl}/H [def: flood]
madam/N [f] [def: madam] madamenyu [def: dear madam] 
madreyge{mdrgh}/Xmadreyges{mdrgwT}/H [f] [def: level]
mafter{mftyr}/H [m] [def: last reading of the Torah]
magazin/N [m] [def: warehouse, storage shed]
maged{mgyd}/Xmegidem{mgydym}/H [m] [def: itinerant preacher] 
mageyfe{mgyfh}/Xmageyfes{mgyfwT}/H [f] [def: plague] 
magister [adj] [def: master (degree)] 
magistra't/N [def: magistrate]
magnat/N [m] [def: magnate]
magnezyum [m] [def: magnesium (Mg)] 
magnet/N [m] [def: magnet]
magreb [m] [def: Magreb (region of northern Africa)] 
	mugrabish [def: Judeo-Arabic from the Magreb] 
mahala [noun] [def: district in a town (Russian)] 
make{mKh}/Xmakes{mKwT} [f] [def: plague, nothing of value]
makel{mkl}/H [def: stick]
makeron/Dmakerond [def: macaroon (food)]
makh/V/T [def: make] /Giber/Gadurkh/Goyf/Gtsuzamen
	/Gavek [def: dismiss]
		[idiom: avekmakhn mit der hant = dismiss with a wave of the hand]
	/Gtsu [def: close]
	/Gmit [def: endure] 
	/Gnokh [def: imitate]
	/Gon [def: ruin]
	/Gop [def: finish]
	/Ggut [def: recompense]
	/Goys [def: make a difference]
	/Gdurkh [def: go through; undergo] 
	gemakht/A [def: artificial] 
	farmakh/V/Bfarmakht [def: lock]
	tsemakh/V/Btsemakht [def: make]
	ayngemakht|s/N [n] [def: preserves]
	opmakh [m] [def: agreement]
	gemakh [def: in peace (with "lozn -")]
	makher/S [m] [def: big shot]
		[idiom: gantser makher = very important person]
		kishef|makher/S [m] kishef|makherin/S [f] [def: magician]
		kuntsnmakher/S [m] [def: trick performer] 
		zeyger-makher/S [m] [def: watchmaker] 
		zeyger-makheray/N [n] [def: watchmaking] 
	gutmakhung/N [f] vidergutmakhung/N [f] [def: recompense]
	nokhmakhung/N [f] [def: imitation] 
	makherayke/S [f] [def: imitation] 
makhloyke{mHlwk|h}/Xmakhloykes{mHlwkT}/Xmakhloykesn{mHlwkTn}/H [def: dispute]
makhmes{mHmT}/H [def: because]
makhne{mHnh}/Xmakhnes{mHnwT}/H [f] [def: crowd]
	makhnesvayz{mHnwTvayz} [def: in a crowd]
makhorke [def: coarse tobacco]
makhshove{mHSBh}/Xmakhshoves{mHSBwT}/H [f] [def: thought] 
makht [f] [def: power] mekhtik/A [def: powerful]
	onmekhtik/A [def: powerless] ummakhtik/A
	almekhtik/A [def: almight]
	groysmakht [f] [def: great power (political)]
	oybermakht [f] [def: superior power]
	bafulmekhtik/V/Bbafulmekhtikt [def: authorize] 
		bafulmekhtikung/N [f] [def: authorization] 
makhteyse{mhxy-WyTy}/H [def: of course]
makhzik{mHzyk}/H [def: strengthen]
makped{mkpyd}/Xmakpidem{mkpydym} [m] [def: strict] 
maksimum [m] [def: maximum]
malay [def: a food made of corn meal (Ukraine)] 
male [def: no telling (with a question word like "vos")]
malekh{ml#x}/Xmalokhem{mloxym}/H [m] [def: angel] /Lh
	malekhl{ml#xl}/Xmalokhemlekh{mloxymlekh} [n] [def: little angel]
malene/S [f] [def: raspberry]
malkes{mlkwT}/H [def: punishment of whipping]
malpe/D/S [f] [def: monkey] /Ish
ma'lyeve/V/T [def: painter ?? some occupation]
	ma'lyever/S [m] [def: ??]
mame/S/C/J [f] [def: mother]
	mameshi [f] mamenyu [f] [def: dear mother]
	mamele [f] [def: little girl (affectionate)]
	shtifmame/S [f] [def: stepmother]
	/Xtate-mame [m] [def: parents (only in plural)] 
mamelige/D [def: maize grits (food)]
mamesh{mmS}/H [def: actually]
	mamoshes{mmSwT}/H [def: actuality] /Idik [def: actual]
	mamoshesdikayt{mmSwTdikayt}/N [f] [def: actuality]
mamzer{mmzr}/Xmamzeyrem{mmzrym}/H [def: bastard] /Iish
man/Xmener [m] [def: man] /Ish/Iish [def: male]
	mansbil/N [def: male] /Ish /Iish [def: male]
	menlekh/A [def: human] mantshik [def: man]
	yungerman/N [m] [def: youth]
	landsman/N [m] [person from the same district]
	manshaft/N [f] [def: team]
	landsmanshaft/N [f] [def: organization of people from the same district]
	arbet|sman/Xarbet|smener [m] [def: worker]
	fakhman/Xfakhlayt [m] [def: skilled laborer]
		fakhmenish/A fakhmenerish/A [def: skilled]
		fakhmenishkayt/N [f] [def: skill] 
	gesheft|sman/N [m] [def: businessman] 
	hoyptman/Xhoyptmener [m] [def: chief]
	shtatman/Xshtetmener [m] [def: statesman]
		shtatmenerish/A [def: statesmanlike] 
	vakhman/Xvakhmener [m] [def: watchman]
	musulman/Xmusulmener [m] [def: Moslem; emaciated person] 
		musulmenish/A [def: Moslem; emaciated]
	man/N [m] [def: husband] /D
		filmeneray'/N [n] [def: polyandry] 
man_{mn} [m] [def: manna] 
manderin [def: Mandarin (language)] manderiner [adj] /Iish
mandat/N [m] [def: mandate]
mandeburke/S [def: potato]
mandl/N [m] [def: almond, tonsil]
manevre/S [f] manyevre/S [f] [def: maneuver] 
mangan [m] [def: manganese (Mn)] 
mangl/N [m] [def: shortage]
manipulatsye/S [f] [def: manipulation] 
mankhe/A [def: many, some] [usage: inadmissable]
mankolye/S [f] [def: melancholy]
	mankolinik/Ees [def: melanchole] mankolinitse/S
mantl/N [m] [def: coat]
	dekmantl/N [m] [def: overcoat]
	regnmantl/N [m] [def: raincoat]
manufaktur [f] [def: manufacture]
manuskript/N [m] [def: manuscript]
manyakalish/A [def: maniacal] 
manye/V/T [def: lure]
manzhe't/N [m] [def: cuff]
mape/S [f] [def: map]
	mapi'r/V/Bmapi'rt [def: map out] 
mapl{mpyl}/H/V/T [def: miscarry]
	mapole{mplh}/Xmapoles{mplwT}/H [f] [def: miscarriage]
mara'n/N [def: Marrano] 
mare{mr#h}/H [f] [def: appearance]
margaritke/S/D [f] [def: daisy]
margine/S [f] [def: margin] 
mark/N [def: mark (German currency)]
mark/Xmerk [m] [def: market]
	fleyshmark/Xfleyshmerk [m] [def: meat market]
	supermark/Xsupermerk [m] [def: supermarket] % Harduf
	[idiom: arop fun mark = disussion over; that's all for you!]
	[idiom: arop fun mark = for sale at any price]
marke/S [f] [def: stamp] postmarke/S [f] 
markh [m] [def: marrow, brain (only in Lithuania)]
marmelad/N [m] [def: marmelade]
marmer [m] /In mirml [m] /In [def: marble]
marokhe{merxh}/H [def: fate]
marshi'r/V/Bmarshi'rt /Garayn/Garoys/Gdurkh/Gforoys [def: march]
	marsh [m] [def: march]
		aroysmarsh [m] [def: march out]
		foroysmarsh [m] [def: advance] 
		marshru't/N [m] [def: march route, itinerary] 
	toytnmarsh [m] [def: death march]
	marsha'l/N [m] [def: marshal]
		marshelik/Xmarshelkes [m] [def: jester] 
martirer/S [m] [def: martyr]
marts [m] [def: month of March]
	merts [m] [def: month of March] [usage: inadmissable]
mase/Xmasn [f] [def: mass of people; mass (physics)]
	folksmase/Xfolksmasn [f] [def: hoi polloi] 
mashin/N [f] mashine/S [f] mashinke/S [f] [def: machine]
	/Dmashind [def: little machine]
	mashinerye/S [f] [def: machinery]
	mashini'st/N [m] mashinistke/S [f] [def: machinist] 
	dre'shmashin/N [f] [def: threshing machine]
	fa'ksmashin/N [f] [def: fax machine]
	hey'bmashin/N [f] [def: crane (machine)] 
	ney'mashin/N [f] [def: sewing machine]
	rekordir-mashin/N [f] rekordir-mashinke/S [f] [def: recorder] 
	re'khn-mashin/N [f] rekhn-mashindl/Eekh [n] [def: calculator] 
	shpa'nmashin/N [f] [def: treadmill] 
	shray'bmashin/N [f] shraybmashinke/S [f] [def: typewriter]
	va'shmashin/N [f] [def: washing mashine] 
		fornt-va'shmashin/N [f] [def: front-loader] [note: V] 
		oybn-va'shmashin/N [f] [def: top-loader] [note: V] 
	mashinal/A [def: mechanical]
mashke{mSk|h}/H [def: strong drink]
masline/S [f] [def: olive] 
mashmoes{mSmewT}/H [def: apparently]
masig{mQyg}/H [def: reach (with "zayn")]
	hasoge{hQgh}/Xhasoges{hQgwT}/H [f] [def: grasp, expectation]
maske/S [f] [def: mask] gazmaske/S [f] [def: gas mask]
	maski'r/V/Bmaski'rt [def: mask]
	farmaski'r/V/Bfarmaski'rt [def: mask]
	demaski'r/V/Bdemaski'rt [def: unmask]
maskem{msKym}/H [def: agree (with "zayn")]
maskone{mskn#}/Xmaskones{msknwT}/H [f] [def: inference, conclusion] 
mason/N [m] [def: Freemason] 
mat/A [def: opaque] 
matbeye{mtbeh}/Xmatbeyes{mtbewT}/H [f] [def: coin]
matematik [f] [def: mathematics (subject)] matematish/A [def: mathematical]
	matematiker/S [m] [def: mathematician]
mater/V/T [def: weary] /Goys
	materndik/A [def: grueling, wearying] 
	maternish/N [def: wearying]
	farmater/V/Bfarmatert [def: weary]
materya'l/N [m] [def: material] /Iistish [def: materialistic] 
materye/S [f] [def: matter]
matone{mWnh}/Xmatones{mWnwT}/H [f] [def: gift] /Lb [def: as a gift]
	[idiom: matone{mWnh} far di gest = party favor]
matore{mtrh}/Xmatores{mtrwT}/H [f] [def: goal]
matriyekh{mtryH}/H [def: exert effort (with "zayn")]
	[idiom: zay zikh nit matriyekh{mtryH} = never mind; don't go out of your way]
matro's/N [m] [def: sailor] 
matse{mch}/Xmatses{mcwT}/H [f] [def: matso bread (food)]
matsel{mcyl}/H [def: rescue (with "zayn")] 
	nitsel{nycwl}/H [def: rescued (with "- vern")]
matsev{mcB}/H [def: situation]
matseyve{mcBh}/Xmatseyves{mcBwT}/H [f] [def: gravestone]
matsh/N [def: match (English)] 
matsil{mcyl}/H [def: save (with "zayn")] /L|u
	[idiom: zol got shoymer u|matsil zayn = may God protect]
matsliyekh{mclyH}/H [def: successful]
	hatslokhe{hclHh}/Xhatslokhes{hclHwT}/H [def: success]
mature/S [f] [def: graduation (Spanish)] 
mauzoley/N [n] [def: mausoleum] 
may [m] [def: month of May]
mayd/V/Bgemitn /Goys [def: avoid]
	farmayd/V/Bfarmitn [def: avoid] 
	farmaydlekh/A [def: avoidable] umfarmaydlekh/A [def: unavoidable]
mayestet [m/f] [def: majesty] /Iish
maykhl{m#xl}/Xmaykholem{m#xlym}/H [m] [def: light meal, delicacy (food)]
	akhl{axl}/H/V/T [def: eat (humorous)]
	akhile{axylh}/H [def: food]
mayl/N [f] [def: mile]
mayle{melh}/Xmayles{melwT}/H [f] [def: advantage] /Ll [def: above]
mayle{melh}-geyre{gyrh} [def: chew the cud (with "zayn")]
	malegere{melh-gyrh}/V [def: chew the cud] 
maymed{memd}/H [def: situation]
maymen{m#myn}/Xmayminem{m#mynym}/H [m] [def: believer]
maymer{m#mr}/Xmaymorem{m#mrym}/H [m] [def: saying]
	maymorey{m#mry}/H [def: sayings of]
	omar{omr}/H [def: he said]
mayontik{ma|yontik}/Xmayontkes{ma|yontkes} [def: estate]
mayrev{merB}/H [m] [def: west] /Idik
	mayrev_{meryB}/H [m] [def: evening prayer] /Idik
mayse{meQh}/Xmayses{meQywT}/H /D/Ll [f] [def: story, genitalia (vulgar)]
	maysem{meQym}/H [def: deeds]
	siper{sypwr}-hamayse{hmeQh} [m] [def: plot (story)] 
	[idiom: zikh onton a mayse = commit suicide]
	[idiom: di emese{#mTe} mayse = cancer]
	[idiom: di yene mayse = cancer]
	[idiom: gekhapt in der mayse = caught red-handed]
	[idiom: bobe mayse = fairy tale]
mayster/S [m] [def: master] /Iish
	feder-mayster/S [m] [def: accomplished author] 
	birgermayster/S [m] birgermaysterke/S [f] [def: mayor] 
	vebmayster/S [m] [def: web master] postmayster/S [m] [def: postmaster]
	maystereve/V/T [def: putter around]
	maynster/S [m] [def: master] % variant
	mayster/V/T [def: create a masterwork] /Goys
maytneryum [m] [def: meitnerium (Mt)] 
mayver{meBr}/H [def: cross (with "zayn")] 
mazek{mzyk}/Xmazikem{mzykym}/H/D [m] [def: damager, damaging]
	nezek{nzk}/H [def: damage]
	mazek{mzyk}/H/V/T [def: damage]
	hezek{hyzk}/Xhezeykes{hyzkwT}/H [m] [def: damage]
mazl{mzl}/Xmazoles{mzlwT}/H [n] [def: good luck, constellation] /Idik
	shlimazl{shilmzl}/S [m] [def: unlucky person, clumsy person]
		/Idik [def: with bad luck]
	shli|mazlnik{shlimzlnik}/Ees [m] shli|mazlnitse{shlimzlnitse}/S [f] [def: unlucky person]
	[idiom: mit mazl{mzl} zolt ir lebn = (reply to mazl-tov)]
mazurke/S [def: mazurke dance]
me [interj] [def: well then (expression of dismissal)] 
	[idiom: be-me = blah blah]
mebl [def: furniture]
	mebli'r/V/Bmebli'rt [def: furnish]
med [m] [def: mead]
medalyo'n/N [m] [def: medallion]
medine{mdynh}/Xmedines{mdynwT}/H/D [f] [def: country]
	medinas{mdynT} [def: country of] 
meditsin/N/Iish [f] [def: medicine]
	biomeditsin [f] [def: biological medicine]
	mediker/X [m] [def: medical researcher] 
mednitse/S [f] [def: large copper pan] 
medyum/S [m] [def: medium]
	medya [f] [def: media (communication)] % Forwards
mefunek{mfwnk}/Xmefunokem{mfwnkym} [m] [def: fastidious person, epicure, picky person] 
meg/V/T [def: may]
	meglekh/A miglekh/A [def: possible] % both variants
		ummeglekh/A ummiglekh/A [def: impossible]
		meglekhkayt/N [f] miglekhkayt/N [f] [def: possibility]
		umeglekhkayt/N [f] umiglekhkayt/N [f] [def: impossibility]
	dermeglekh/V/Bdermeglekht [def: make possible]
megile{mgylh}/Xmegiles{mgylwT}/H [f] [def: scroll, long story] 
mehalekh{mhlx}/H/N [def: travel]
mehane{mhnh}/H [def: give food (with "zayn")]
mehume{mhwmh}/Xmehumes{mhwmwT}/H [f] [def: panic, turmoil]
mehus{mhwT}/H [n] [def: substance]
mek/V/T/Gop [def: erase] /Goys
	farmek/V/Bfarmekt [def: erase]
mekene/S [f] [def: chaff]
mekhabl/Xmekhblem{mHblym}/H [m] [def: terrorist] % Forwards
mekhalel{mHll}/H [def: desecrate (with "zayn")] 
mekhanik [f] [def: mechanics (subject)] mekhanish/A [def: mechanical]
	mekhaniker/S [m] [def: mechanic] 
	mekhanizm/N [m] [def: mechanism] 
mekhitse{mHyc|h}/Xmekhitses{mHycwT}/H [f] [def: separation between men and women at prayer] 
mekhteyse{mhyxy-WyTy}/H [def: of course]
mekintash [def: Macintosh (computer)]
mekler/S [m] meklerin/S [f] [def: broker, agent]
	oysmekler/S [m] oysmeklerin/S [f] [def: broker, agent]
		[idiom: pirge mekler = pimp (taboo)]
	mekleray'/N [n] [def: brokerage, agency]
	mekl/V/T /Goys mekler/V/T [def: act as agent]
meld/V/Bgemoldn [def: announce]
melodye/S [f] [def: melody] melodish/A [def: melodic]
melokhe{mloxh}/Xmelokhes{mloxwT}/H [f] [def: handcraft]
melon/N [m] [def: melon]
mem{mm}/H [m/f] [def: Hebrew letter Mem] 
memorandum/S [m] [def: memorandum] 
memuar/N [def: memoirs]
men me [def: one (indefinite subject)] 
menahel{mnhl}/Xmenalem{mnhlym}/H [m] [def: director (school or yeshiva)] 
menashke/S [f] [def: mess tin] 
menatsl{mncl}/H [def: rescue (with "zikh") (with "zayn")] 
mendelevyum [m] [def: mendelevium (Md)] 
menge/S [f] [def: crowd, multitude] 
meniye{mnyeh}/Xmeniyes{mnyewT}/H [def: interference, obstacle, hurdle]
menore{mnwrh}/Xmenores{mnwrwT}/H [f] [def: candelabrum] 
mentsh/N/D/J [m] [def: person, human, responsible/mature person]
	/Ilekh [def: humane] ummentshlekh/A [def: inhuman]
		mentshlekhkayt/N [def: humanity] 
	mentshish/A [def: human]
	mentshkayt/N [f] mentshhayt [f] [def: humanity]
	folksmentsh/N [m] [def: ordinary person]
	gasnmentsh/N [m] [def: man on the street] 
	luftmentsh/N [m] [def: person with impractical ideas]
	valdmentsh/N [m] [def: forest dweller]
menukhe{mnwHh}/H [def: rest, quiet]
menyu/N [m] [def: menu] 
mer [m] [def: problem] 
	[idiom: vos iz der mer = what is the matter?]
mer/V/T [def: increase] 
	farmer/V/Bfarmert [def: increase] 
	mer/A [def: more] amer % CY C.14.c
	merste merstn merstns [def: mostly] meyn/A meynst/A 
	merhayt/N [f] [def: majority]
	mernit [conjunction] [def: besides; but only]
	nokhmer [conjunction] [def: besides]
meridn [def: hemorrhoids] % plural onl
merk/V/T [def: notice] /Gon/Gop
	bamerk/V/Bbamerkt [def: notice]
		bamerkung/N [f] [def: notice]
		bamerkevdik/K [def: noteworthy]
	merkzam/A [def: noteworthy]
	oyfmerk/N [m] [def: notice] 
	oyfmerkzamkayt/N [f] [def: attention]
	umbamerkt/A [def: unnoticed]
merkhakem{mrHkym}/H [def: distant lands] 
merkhets{mrHc}/Xmerkhotsem{mrHcym}/H [m/n] [def: bath house] 
mern [f] [def: carrot]
mesekhte{msxW#}/H mesekhtes{msxWwT}/H [def: Talmudic tractate] 
meser/S [m] [def: knife]
	golmeserl/Eekh [m] [def: razor] % Harduf
	hakmeser/S [m] [def: chopping knife, chopper] 
	tsvaygmeser/S [m] [def: pruning hook] 
mesh [n] [def: brass] /Ien [def: brass]
meshayer{mSer} [verb] [def: estimate, guess (with "zikh") (with "zayn")] 
meshekh{mSx}/H [def: period of time] /Idik [def: long (in duration)] /Lb
	mamshekh{mmSyx}/H [def: continue (with "zayn")]
	hemshekh{hmSx}/Xhemsheykhem{hmSxym}/H [m] [def: continuation; sequel]
meshores{mSrT}/H [def: assistant] meshorsem{mSrTym}/H
meshoyrer{mSwrr}/Xmeshoyrerem{mSwrrym}/H [m] [def: singer] 
meshu'm{mSwm}/H [def: because of]
meshuge{mSwge}/H [adj] [def: crazy] [grammar: only predicative]
	/In /Idik [def: crazy]
	meshugenervayz{mSwgenervayz} [def: crazily]
	meshegas{mSwgeT}/H/N [n] [def: insanity, craziness]
	meshugoyem{mSwge|ym}/H  [def: crazy people]
	shigoen{Sgewn}/H [m] [def: craziness] 
	shoygeyg{Swgg}/H [def: unintentional] /Lb [def: unintentionally]
meshune{mSwnh}/H [def: strange] /Idik
	[idiom: mise{myTh} meshune{mSwnh} = painful death]
mesikes{mTykwT}/H [def: sweetness]
mest/V/Bgemostn [def: measure] /Gop/Goys/Gon
	farmest/V/Bfarmostn [def: contest (with zikh)] 
		farmest/N [m] [def: contest, race (game)] 
	mos [f] [def: measure]
	fulmosik/A [def: in full measure]
	glaykhmosik/A [def: in equal measure]
	mesik/A [def: measured]
		gemesikt/A [def: moderate] % Harduf 
		reglmesik/A [def: regular]
		umreglmesigkayt/N [f] [def: irregularity]
		mitlmesik/A [def: middle-sized]
	erdmester/S [m] [def: surveyor] 
mesyanish/A [def: Messianic] 
metabolizm/N [m] [def: metabolism] 
metafizik/A [def: metaphysics]
metafor/N [m] [def: metaphor] /Iish
metal/N [m] [def: metal] tsinkmetal [m] [def: zinc metal]
metaltl{mtltl}/H metaltelem{mtltlym}/H [def: movable possessions] 
metapl{mtpl}/H [def: occupied (with "zikh"), minding a child (with "zayn")] 
meteor/N [m] [def: meteor] 
meter [m] [def: meter] 
	galvanometer [m] voltmeter [m] [def: voltmeter]
metod/N [f] [def: method] /Iish
metro/S [def: subway]
metsad{mcd}/H [def: on the side of] 
metsena't/N [m] [def: magnate, financier]
metshe't/N [m] [def: mosque]
metsiye{mcy#h}/Xmetsiyes{mcy#wT}/H [f] [def: bargain]
	metsiyas{mcy#T}/H [f] [def: existence] 
	[idiom: koshere{KSre} metsiye{mcy#h} = true bargain]
mevater{mvWr}/H [def: forgo, set aside a right (with "zayn")] 
meyayesh{my#S}/H [def: give up hope (with "zayn")] 
meye{m#h}/H [f] [def: money] 
meyle{myl#}/H [def: anyhow; never mind] /Lb [def: in the course of things] /Lm
meylekh{mlx}/Xmelokhem{mlxym}/H [m] [def: king] /Lh [def: the king] 
	malkhus{mlxwT}/H [f] [def: kingdom] 
	melukhe{mlwxh}/H [f] [def: government]
		melukhish{mlwxish}/A [def: government]
	benmeylekh{bn-mlx}/Xbney-malokhem{bny-mlxym} [m] [def: prince] 
	malke{mlKh}/H [f] [def: queen] /Lh
		basmalke{bT-mlKh}/Xbasmalkes{bT-mlKwT} [def: princess] 
		melave{mlvh}-malke{mlKh}/H/S [f] [def: formal meal Saturday night] 
meylets{mlyc}/Xmeylitsem{mlycym}/H [m] [def: attorney]
	melitse{mlych}/H [def: advice] melitses{mlycwT}/H
meyn/V/T [def: intend]
	meyn/N [m] [def: intention] 
	meynung/N [f] [def: opinion] 
	[idiom: nit zey meynt men = it doesn't apply to them]
meys{mT}/Xmeysem{mTym}/H [m] [def: dead person] /Lh
	meymes{mmyT}/H [def: kill]
	tse|meymes|/V/Btse|meymes|t [def: kill]
meyven{mByn}/Xmevinem{mBynym}/H [m] [def: expert]
	mevinish{mBynish}/A [def: expert]
	mevines{mBynwT}/H/N [f] [def: expert opinion] 
	[idiom: zayn oyf zikh der bester/shtarkster meyven = be one's own worst critic]
mezoyn{mzwn}/H [m] [def: food]
	mezoynes{mzwnwT} [def: baked goods other than bread]
mezumen{mzwmn}/Xmezumonem{mzwmnym}/H [def: cash] /A
	mezumenke{mzwmn|ke}/H/S [f] [def: automated teller machine (ATM)] 
mezuze{mzwz|h}/H/S [f] [def: mezuzah (ritual adornment on doorposts)] 
mi/V/T [def: exert]
	bami/V/Bbamit [def: strive, exert oneself (with "zikh")]
		bamiung/N [f] [def: effort] 
	mi [m] [def: effort] 
mid/K [def: weary] /Ilekh
	midkayt/N [f] [def: weariness] miderheyt [def: wearily]
		flimidkayt/N [f] [def: jet lag] [note: V]
midber{mydbr}/H/Idik [f] [def: desert] /Lb [def: in the desert]
mide_{mydh}/H mides{mydwT}/H [def: quality, attribute] 
mies{my#ws}/H/K [def: ugly, obscene, loathsome, dirty]
	mies{my#ws}/V/T [def: make ugly] 
	mieskayt{my#wskayt}/N [f] [def: ugliness]
	nimes{nym#s}/H [def: boring; distasteful, disgusting] 
migl/V/T [def: disgust] migl/N [m] [def: feeling of disgust] 
	[idiom: aroysrufn a migl (bay emetsn) = disgust (someone)]
migratsye/S [f] [def: migration] 
mikhshel{myxSwl}/Xmikhshoylem{myxSwlym} [m/n] [def: obstacle] 
miklet{myklt}/Xmiklotem{mykltym}/H [m] [def: refuge] 
	mokem{mkwm}-miklet{myklt} [m] [def: place of refuge] 
mikro [m] [def: microwave oven] 
	mikroi'r/V/Bmikroi'rt [def: cook with microwave] 
	mikrosko'p/N [m] [def: microscope] 
mikve{mkvh}/Xmikveyes{mkv|wT}/H [m] [def: ritual bath]
mild/A [def: mild] milderheyt [adv] [def: mildly; gently] 
milgroym/N [m] [def: pomegranate] 
milimeter/S [m] [def: millimeter] 
militer [n] [def: army, troops] /Iish [def: military]
	militant/N [m] [def: militant] 
mili'ts/N [f] [def: militia] 
milkh [f] [def: milk] /Iik [def: made of milk]
	/Iedik [def: milk-based (food) (ritual)] 
	milkhiker/S [m] [def: dairyman]
	melk/V/T [def: milk] /Goys % not gemolkn
	foyglmilkh [f] [def: dainties (symbol of luxury)]
	mishmilkh/N [f] [def: shake (food)] [note: V] 
	[idiom: blut un milkh = fair complexion]
milkhome{mlHmh}/Xmilkhomes{mlHmwT}/H [f] [def: war] /Idik [def: warlike]
	far|milkhome|dik/A [def: before the war]
	velt-milkhome{mlHmh}/Xvelt-milkhomes{mlHmwT} [def: world war] 
milts/D [f] [def: spleen] 
milyard/N [m] [def: billion]
milyon/N [m] [def: million] milyone'r/N [m] [def: millionaire]
min{myn}/H minem{mynym}/H [def: species, heretic] /Lh
	miney{myny}/H [def: species of] 
mine/S [f] [def: facial expression]
mine/S [f] [def: mine (explosive)] 
	farminirt/A [def: mined] 
mine_{mynh}/Xmines{mynwT}/H [f] [def: appearance] 
mineg{mynhg}/Xminhogem{mynhgym}/H [m] [def: custom]
	manhig{mnhyg}/Xmanhigem{mnhygym}/H [m] [def: leader] 
		manhiges{mhygwT} [f] [def: leadership] 
	hanhoge{hnhgh}/Xhanhoges{hnhgwT}/H [f] [def: custom] 
	noyeg{nwhg}/H [def: accustomed (with "zayn")] 
miner/V/T [def: make small] 
	farminer/V/Bfarminert [def: reduce] farminerung/N [def: reduction]
	mindst/A [def: smallest] % not in positive or comparitive
	minderheyt/N [f] [def: minority] 
	mindlekh/A [def: small] 
minestam{mn-hsWm}/H [def: probably] 
minimum [m] [def: minimum] minimel/K [def: minimal]
minister/N [m] ministerke/S ministershe/S [f] [def: minister]
	ministeryum/S [m] [def: ministry]
minkhe{mynHh}/Xminkhes{mynHwT}/H [f] [def: afternoon prayer]
minoritet/N [f] [def: minority] 
minorne [def: minor (music)] [grammar: indeclinable]
minter/V/T [def: stimulate; attempt to revive]
minus [m] [def: minus] 
minut/N [f] [def: minute] /Dminutke
	minutvayz [def: minute by minute]
	min' [def: minute (abbreviation)]
	[idiom: fun der heyser minut = from the first moment]
minyatur/N [f] [def: miniature] 
minye/V/T [def: change one's emotions (with "zikh")] 
minyen{mnyn}/Xminyonem{mnynym}/H [m] [def: prayer quorum]
misboyded{mTbwdd}/H [def: hermit]
mish/V/T [def: mix; get involved (with "zikh")] /Goys/Garayn/Gtsunoyf/Goyf
	/Giber [def: shuffle]
	farmish/V/Bfarmisht [def: confuse]
	tsemish/V/Btsemisht [def: mix up, confuse, trouble]
		tsemishung/N [f] [def: confusion, trouble]
	araynmishung/N [f] [def: mixture]
	gemish/N [n] gemishekhts/N [n] mi'shenish/N oysmi'shenish/N [def: mixture]
	mishmash/N [m] [def: mish-mash] 
	mishling/N [n] [def: child of mixed ancestry] 
	mishke-moshke [adj] [def: confused, messy] 
mishken{mSKn}/H [def: surety] /V/T
	farmishken{farmSkn}/V/Bfarmishkent{farmSknt} [def: pawn; mortgage] 
mishkn{mSKn}/H [m] [def: tabernacle] 
mishne{mySnh}/Xmishnayes{mySnywT}/H [f] [def: Mishnah]
mishpet{mSpt}/H/V/T [def: judge] /Gop
	farmishpet{farmSpt}/V/Bfarmishpet{farmSpt} [def: sentence] 
	mishpotem{mSptym}/H [def: ordinances] 
	shoyfet{Swft}/Xshoyftem{Swftym}/H [m] [def: judge] 
mishpokhe{mSpHh}/Xmishpokhes{mSpHwT}/H [f] [def: family, clan] /D /Idik 
	mishpokhedikayt{mSpHhdikayt}/N [f] [def: family feeling]  % Forwards
mishte{mSWh}/H/D [m] [def: drinking bout, dinner party]
mishteyns [def: as it were] umshteyns
	nishteyns % Harduf
	[idiom: mishteyns gezogt = after all; alas!]
misnaged{mTngd}/Xmisnagdem{mTngdym}/H [m] [def: opponent of Chassidism]
	misnagdes{mTngdwT}/H [def: opposition to Chassidism]
	misnagdish{mTngdiS}/H/A [def: in opposition to Chassidism]
mist/N [n] [def: garbage, dung] 
	blitsmist/N [n] [def: spam (computer)] [note: V] 
misterye/S [f] [def: mystery] misterye'z/A [def: mysterious] 
	mistifikatsye/S [f] [def: puzzle] 
mistish/A [def: mystic] 
mistome{msWm#}/H [def: probably] 
	[idiom: min_{mn} hastam{hsWm} = probably]
misye/S [f] [def: mission] 
	misyone'r/N [m] [def: missionary] /Iish
mit/P [def: with] dermit [def: thereby]
mit [f] [def: middle] /Iel
	inmitn [def: in the middle]
	[idiom: in mitn drinen = just then]
	[idiom: in mitske drinen = just then]
mite{myth}/H [f] [def: bed] 
miting/N [m] [def: meeting (English)]
mitish/A [def: mythical] 
mitl/Een [n] [def: means, resource, method]
	halbmitl/N [n] [def: half measure] 
	reynik-mitl/Een [n] [def: cleaning fluid] 
	veytik-mitl/Een [n] [def: painkiller] [note: V] 
	zayers-mitl/Een [n] [def: antacid] [note: V]
	farmitler/X [m] [def: proxy] 
mitn [m] [def: middle] mitl/K
mitos [def: mythos; legend] 
mitsve{mycvh}/Xmitsves{mycv|wT}/H [f] [def: commandment] /Lb
miyet{myewt} [m] [def: minority]  % Forwards
mizbeyekh{mzbH}/H [m] [def: altar] 
mizinik/N/D [m] [def: youngest son]
	mizinke/S [f] [def: youngest daughter] 
mizrekh{myzrH}/H [m] mizrekh_{mzrH}/H [def: East] 
mlie/V/T [def: simmer] 
mobil/A [def: mobile] 
	mobilizi'r/V/Bmobilizi'rt [def: mobilize]
	mobilizatsye/S [f] [def: mobilization]
	demobilizi'r/V/Bdemobilizi'rt [def: demobilize] 
mode/S [f] [def: fashion] 
	shraybmode/S [f] [def: manner of writing]
	altmodish/A [def: of ancient fashion] 
	hayntmodish/A [def: of modern fashion] 
	[idiom: kurtse mode = fad]
modeli'r/V/Bmodeli'rt [def: model]
	mode'l/N [m] [def: model; design] [pronunciation: mode'L]
modern/K [def: modern]
	modernizi'r/V/Bmodernizi'rt [def: modernize]
	modernkayt/N [f] [def: modernity] 
	modernizatsye/S [f] modernizirung/N [f] [def: modernization] 
modne/A [def: strange] 
moger/A [def: lean] 
mogn/S/D [m] [def: stomach] /Idik [def: intestinal]
mokem{mkwm}/H [m] [def: place] mekoymes{mkwmwT}/H
moker{mkwr}/Xmokrem{mkrym}/Xmekoyrem{mkwrym}/H [m] [def: source]
mokh/N [m] [def: moss] /Iik
mol/N [m] [def: moth (insect)] 
mol/N [m] [def: pier] 
mol/V/Bgemoln [def: grind] 
	tsemol/V/Btsemoln [def: grind finely] 
	mil/N [f] [def: mill]
		miler/S milner/S [m] milnerin/S [f] [def: miller]
		vintmil/N [f] [def: windmill]
		mel [f] [def: meal, flour] /Iik
			kornmel [f] [def: rye meal]
			papshoymel [f] [def: corn meal] 
	nakhtmol [def: supper (German)] [usage: inadmissable]
mol/V/T [def: paint, imagine (with "zikh")] /Goys
	dermol/V/Bdermolt [def: picture]
	bamol/V/Bbamolt [def: picture]
	farmol/V/Bfarmolt [def: draw]
	gemel [n] [def: illustration]
	moleray'/N [n] [def: painting] 
	moler/S [m] [def: painter] shtubmoler/S [m] [def: house painter] 
	oysmolerish/A [def: ??]
	malyeve/V/T [def: paint houses]
		malyer/S [m] [def: house painter]
mol [n] [def: time] amol [def: once upon a time] /Iik [def: in former days]
	demolt [adv] demolts [adv] demolst [adv] yemolt [adv] [def: then]
	demoltik/A [def: then] 
	denstmol [adv] [def: then] /Iik dent|smol [adv] % both spellings
	alemol [adv] [def: always]
	keynmol [adv] [def: never]
	eynmol [adv] /Iik [def: once]
	hayntmol [adv] [def: now] 
	oftmol [adv] [def: often]
	mitamol [adv] [def: suddenly] /Iik [def: sudden]
	nokhamol [adv] [def: again]
	teylmol [adv] [def: sometimes] /Iik [def: occasional] 
	tsumol [adv] [def: occasionally]
	firmolik/A [def: four-fold] 
		[idiom: firmoliker kalike = quadriplegic]
	[idiom: knas{kns}-mol = engagement party]
	[idiom: zayn vi' a mol = unpredictable; it depends]
mole{ml#}/H [def: full of] 
molekul/N [m] [def: molecule] /Iar
molibdenum [m] [def: molybdenum (Mo)] 
molye/V/T modlye/V/T [def: pray (with "zikh") (Christian)] 
moment/N [m] [def: moment]
	momentvayz momentnvayz [def: moment by moment]
momoyn{mmwn}/H [def: riches] 
mon [m] [def: poppy, poppy seed, tiny object] 
	montshink/A [adj] [def: tiny] [grammar: only attributive]
mon/V/T [def: demand]
	derman/V dermon/V/Bdermont [def: remind; recollect (with "zikh")]
		% both forms
		dermonung/N [f] [def: reminder]
	oybndermont/A [def: mentioned earlier]
monakh/N [m] [def: monk] 
	monasti'r/N [m] [def: convent, monastery] 
monat/N [m] [def: month] 
mones{mnwT}/H/N [def: Purim gifts of food (with "shalekh -")] 
monografye/S [f] [def: monograph] 
monolog/N [m] [def: monologue] 
monopol/N [m] [def: monopoly]
montik/N [m] [def: Monday] 
monument/N /Ial [m] [def: monument] 
	monumentalizm/N [m] [def: monumentalism] % Forwards
moral/N [f] [def: ethics] /Iish [def: moral] moralishkayt/N [f] [def: morality]
	demoralizi'r/V/Bdemoralizi'rt [def: demoralize] % Harduf 
mord/N [m] [def: murder] 
	merder/V/T [def: murder] /Gmit [def: be accomplice to a murder]
		merder/S [m] [def: murderer, ruffian] /Iish /Ilekh [def: murderous]
	mordeve/V/T [def: attack]
		/Gon [def: works hard (with "zikh")]
	aleynmord [m] zelbstmord [m] [def: suicide]
		aleynmerder/N [m] aleynmerderke/S [f] [def: person who commits suicide] 
	masnmord/N [m] [def: mass murder]
	dermorde/V/Bdermordet [def: murder]
morde/S [f] [def: chin] /D mordetshke/S
more{mrh}/H [def: depression (with "- shkhoyre")] 
morfologye/S [f] [def: morphology]
	morfologish/A [def: morphological] 
morgn/S [m] [def: morning, tomorrow] /Idik [def: pertaining to tomorrow]
	ibermorgn [m] /Idik [def: day after tomorrow]
	frimorgn/S [m] /Idik [def: dawn] 
	tsumorgns [def: at dawn] 
mos/N [f] [def: measure] /Iik [def: abundant] 
	ibermosik/A [def: overabundant] 
	[idiom: iberkhapn di mos = overstep a boundary]
moshiyekh{mSyH}/H/S [m] [def: messiah] 
moshl{mSl}/Xmesholem{mSlym}/H [n] [def: example, demo (computer)]
	lemoshl{lmSl}/H [adv] [def: for example] 
	nimshl{nmSl}/H [m] [def: moral] 
	memshole{mmSlh}/H memsholes{mmSlwT}/H [def: government] 
	mishley{mSly}/H [def: Proverbs] 
motiv/N [def: motif]
motivi'r/V/Bmotivi'rt [def: motivate] motivatsye/S [f] [def: motivation]
moto/S [m] [def: motto] 
motor/N [m] [def: motor, engine]
	elektromotor/N [m] [def: electric motor]
	damfmotor/N [m] [def: steam engine]
moves{mvT}/H [m] [def: death] /Lh
	meymes{mmyT}/V/T [def: kill]
	mise{myTh} [f] [def: death] 
moyd/N [f] [def: maid] /Dmeyd [n/f] meydlish/A meydlsh/A [def: girl-like] 
	meydlvayz [def: as a girl]
	dinstmoyd /Ddinstmeyd [f] [def: servant girl/maid]
	kale{Klh}-moyd [f] [def: marriagable girl] 
moyde{mwdh}/H [def: admit, thank (with "zayn")] 
moyed{mwed}/H [m] [def: holiday] /Lh
	[idiom: khol{Hwl} h|moyed{mwed} = intermediate day of a festival]
moyekh{mwH}/H/N [m] [def: brain] moykhes{mwHwT}/H
moyl_{mwhl}/H [def: circumcisor]
	mile{mylh}/H [def: circumcision]
		bris{bryT}-mile{mylh} [def: circumcision, baby naming for son] 
	mal{ml}/H [def: circumcise (with "- zayn")]
moyer/N [m/f] [def: (outside) wall]
	moyer/V/T [def: build a wall] /Gayn [def: wall in]
	farmoyert/A [def: walled in] 
	fraymoyerer/S [m] [def: Freemason] 
moyfes{mwfT}/Xmoyfsem{mwfTym}/H [m] [def: miracle] 
moykher{mwxr}/H [def: sell (with "zayn")] 
moykhl{mwHl}/H [def: forgive (with "zayn")]
	mekhile{mHylh}/H [f] [def: forgiveness, forgive me] 
moyl/Xmayler [n] [def: mouth] /Dmaylekh
	folksmoyl/Xfolksmayler [n] [def: common wisdom]
	oyvnmoyl/Xoyvnmayler [n] [def: opening of an oven]
	[idiom: nemen in moyl arayn = have a bite of something]
moyled{mwld}/H [m] [def: new moon]
moyre{mwr#}/Xmoyres{mwr#wT}/H [f] [def: fear] /Idik
	yiras{yr#T}/H [def: fear of] 
moyred{mwrd}/Xmordem{mwrdym}/H [def: rebel (with "zayn")]
	meride{mrydh}/H [f] [def: rebellion] 
	yordem{ywrdym}/H [def: emmigrants from Israel] 
moyshev{mwSB}/H [def: mess] 
moyshev{mwSB}/H [m] [def: residence, town] 
	toyshev{WwSB}/Xtoyshvem{WwSBym}/H [m] [def: resident]
	yishev{yiSwB}/Xyishuvem{yiSwBym}/H [m] [def: settlement]
		yishevnik{yiSwBnik}/Ees [m] yishevnitse{yiSwBnitse}/S [f] [def: settler]
		yoysheyv{ywSB}/H yoyshvem{ywSBym}/H [def: resident] 
	meyashev{mySB}/H [def: decide (with "zayn")] 
moytsi{mwcy#}/H [def: bring out, fullfill an obligation (with "zayn")]
	/Lh [def: blessing over bread] 
	hmoytsemlekh{hmwcy#mlekh} [def: scraps of bread] 
	moytsey{mwc#y}/H [def: end of holiday (with "- shabes", for instance)] 
	yoytsi{ywc#}/H [def: fulfill an obligation (with "zayn")] 
	yoytsres{ywcrwT}/H [def: additional liturgical poetry]
		[idiom: mishn di yoystres = be confused]
moyz/Xmayz /Dmayz [f] [def: mouse]
	fledermoyz/Xfledermayz [f] [def: bat] 
mozlen [def: measles]
	mozl/V/T [def: have measles]
mrake/S [f] [def: fog and drizzle; gloom] 
	mrake/V/T [def: drizzle] 
mufleg{mwflg}/Xmuflogem{mwflgym}/H [m] [def: unusual; important; scholar] 
mufte/S [f] [def: muff (clothing)] 
muke/V/T [def: moo (sound of a cow)] meke/V/T
multer/S/D [f] [def: trough] 
mum{mwm}/H [m] [def: defect]
mume/S/C/J/D [f] [def: aunt] 
mumkhe{mwmHh}/Xmumkhem{mwmHym}/H [m] [def: expert] 
	mumkheshaft{mwmHhshaft}/N [n] [def: expertise] 
mundir/N [m] [def: uniform] 
munitsipal/A [def: municipal] munitsipalitet/N [def: municipality]
munter/V/T [def: encourage; cheer up; animate] 
	/Gop [def: revive]
	/Goyf [def: alleviate] 
	munter/A [def: happy] 
murashke/S [f] [def: ant]  % also pronounced me'reshkes
	murashnik/Ees [m] [def: anthill] 
murml/V/T [def: murmur] /Gmit
	murml [m] [def: murmur] /Idik [def: murmuring] 
	gemurml/N [def: murmuring] 
muser{mwsr}/H/V/T [def: upbraid] /Goys
	muser{mwsr}/H [def: ethical Musar movement] /Lh
	muser|nik/Ees [m] [def: follower of the Musar movement] 
	moser{msr}/H [def: tattletale] 
	mesire{msyrh}/H mesires{msyrwT}/H [def: endangerment]
	mesoyre{mswrh}/H [def: tradition] 
	maser{msr}/V/T [def: turn in to the authorities]
mushl/N [m?] [def: sea shell]
	oyer-mushl/N [def: ear]
mushti'r/V/Bmusti'rt [def: drill (exercise; with "zikh")]
	mushtir/N [m] [def: drill (exercise)]
muskul/N [m] [def: muscle] /Iirt [def: muscled]
muster/N [m] [def: pattern, example]
mut [def: courage] /Iik [def: courageous]
	mutikayt/N [f] [def: courage]
	gutmutik/A [def: of good disposition]
		gutmutikayt/N [f] [def: good disposition]
	dermutik/V/Bdermutikt [def: encourage]
	gemit/Eer [n] [def: disposition, frame of mind, mood] 
		gemitlekh/A [def: pleasant; cozy] 
	[idiom: shver gemit = heavy heart]
	[idiom: gring gemit = light heart]
	[idiom: hobn an alt gemit = be precocious]
	mutvilik/A [def: wanton]
mutatsye/S [f] [def: mutation] 
muter/S/D [f] [def: mother] 
	perlmuter [f] [def: mother-of-pearl] 
mutshe/V/T [def: bother, absuse, expend effort (with "zikh")] /Goys
	farmutshe/V/Bfarmutshet [def: bother]
muvek{mwBhk} [adj] [def: brilliant, clear] 
muz/V/T [def: must]
muzey/N [m] [def: museum] /Iish muzeum/S [def: museum] 
	ontap-muzey/N [m] [def: hands-on museum] 
muzhik/Ees [def: peasant (Russian)] 
muzik [f] [def: music] /Ial/Ialish [def: musical]
	muzikant muziker [m] [def: musician]
	marshmuzik [f] [def: marching music]
	muzikologye/S [f] [def: musicology] muzikolo'g/N [m] [def: musicologist] 
myantshe/V/T [def: ??]
myauke/V/T [def: meow (sound of a cat)] 
na nat [def: take] [grammar: only in imperative]
	[idiom: na dir = take that]
na{ne}/H [def: homeless (with "-v|nad")] 
nad{nd}/H /L|v [def: homeless (in "na v|nad")]
nadn{ndn}/H [m] [def: dowry] 
nafke{nfk|h}/H/S [f] [def: prostitute] 
na'fkemine{nfk#-mynh}/Xnafkemines{nfk#-mynwT}/H [f] [def: difference] 
naft [m] [def: kerosene; naphtha] 
	naftfeld/Xer [n] [def: oil field] 
nagan [m] [def: pistol (weapon)]
	% 7-chambered, made by  Emile and Leon Nagant, Belgium
nahi't [def: chickpeas (food)] 
naiv/A [def: naïve] naivkayt/N [f] [def: naïvité]
naket/K [def: naked] naketkayt/N [f] [def: nakedness]
	naketerheyt [def: in a naked state]
nakher [def: afterward(s) (German)]
nakhes{nHT}/H [def: pleasure] /Idik [def: pleasant]
	[idiom: shepn nakhes{nHT} = derive pleasure]
nakhle{nHlh}/H [def: inheritance]
nakhlesik/A [def: negligent] 
	farnakhlesik/V/Bfarnakhlesikt [def: treat cavalierly] % no base verb
nakht/Xnekht [f] [def: night] /Iik nekht/D
	baynakht [adv] /Iik [def: at night]
	oyfdernakht [adv] [def: at night]
	farnakht [adv] farnakhtn [adv] [def: dusk]
	nakhtish/A nakhts [def: night]
	afdernakht{Ofdernakht} [adv] [def: at night]
	nekhtik/V/T [def: spend the night] /Giber/Gunter 
	eyernekhtn [def: day before yesterday] 
		eyernekhtik/A [def: of the day before yesterday]
	nekhtn [def: yesterday] nekhtik/A [def: yesterday]
	[idiom: a nekhtiker tog = an impossibility]
	mitlnakht/Xmitlnekht [f] [def: midnight] /Iik
		halbnakhtik/A [def: at midnight]
	shternnakht/Xshternnekht [f] [def: starry night]
	vakhnakht/Xvakhnekht [f] [def: vigil (religious)] 
	zumernakht/Xzumernekht [f] [def: summer night]
	vinternakht/Xvinternekht [f] [def: winter night]
	[idiom: di vayse nakht = all-nighter (remain awake through the night)]
	[idiom: halbe nakht = middle of the night]
	[idiom: oyf der nakht = in the evening]
	[idiom: vi tog un nakht = completely opposite]
nakhtigal/N [f] [def: nightingale] 
nakn/S [m] [def: neck] 
nam/N [f] [def: wetnurse] 
nar/V/T [def: fool] /Garoys/Gop/Gayn/Garayn/Goys
	farnar/V/Bfarnart [def: foo]
	banarish/V/Bbanarisht [def: act foolishly (with "zikh")] 
	nar/Xnaronem{naronym}/D [m] [def: fool] /Iish [def: foolish] 
	narishkayt/N [f] [def: foolishness]
	opnarer [m] [def: someone who fools others]
	genareray [n] [def: deception] % Harduf 
narativ/N [def: narrative] folksnarativ/N [def: folk narrative]
naraye/V/Bnarayet [def: suggest, offer] 
	naray/N [m] [def: suggestion, offer, recommendation] 
narkotik/N [m] [def: narcotic (drug)] 
	narkotiker/S [m] [def: drug addict] 
narod [def: people (collective noun, Russian)] 
nartl/V/T [def: ski] nartler/S [m] [def: skier]
nartsis/N [m] [def: narcissus (plant)] 
nas/A [def: wet] /Ilekh
	nets/V/T [def: moisten] /Gdurkh
	banets/V/Bbanetst [def: moisten]
	farnets/V/Bfarnetst [def: wet]
nash/V/T [def: snack, plagiarize]
	nash/N/D [def: snack]
	nasher/S [m] nasherke/S [f] [def: snacker]
	nasheray'/N [n] [def: snack] 
	farnash/V/Bfarnasht [def: spend on sweets] 
nashpits/Iik [def: in a row (horses)] 
natryum [def: sodium (Na)] 
natshalnik/Ees [m] [def: boss (Russian)] 
natsi/S [m] /Ish /Istish natsikhe/S [f] [def: Nazi]
	natsizm/N [m] [def: Nazism]
natsye/S [f] [def: nation]
	natsyonal/A [def: national] /Iish
		natsyonalizm/N [m] [def: nationalism] 
		natsyonalistish/A [def: nationalist] 
	internatsyonal/A [def: international]
		internatsyonali'st/N [m] [def: internationalist] /Iish
	natsyonalitet/N [f] [def: nationality]
natur [f] [def: nature] natirlekh/A [def: natural]
	ibernatirlekh/A [def: supernatural]
	umnatirlekh/A [def: unnatural]
	naturalizi'r/V/Bnaturalizi'rt [def: become a citizen] 
nay/K [def: new] nayes/N [def: news] naykayt/N [f] [def: newness]
	banay/V/Bbanayt [def: renew] banayung/N [f] [def: renewal]
	iberanays [def: yet again]
	funsnay' oyfsnay' [def: anew]
nayert [def: rather] 
nayger/Iik [def: eager] naygerikayt/N [f] [def: eagerness]
nayn [def: 9] naynt/A [def: 9th] nayntl [def: 1/9] nayntns [def: ninthly]
	nayntsn [def: 19] nayntsnt/A [def: 19th] nayntsntl [def: 1/19] 
	nayntsik/A [def: 90] nayntsikst/A [def: 90th] nayntsikstl [def: 1/90] 
nebekh [interj] [def: (expression of pity)]
	/D [def: helpless person] 
	/Idik [def: pitiable] 
	nebekhdikayt/N [f] [def: pitiability]
nebl/Idik [def: cloud]
nebn/P [def: near] dernebn
nedove{ndBh}/Xnedoves{ndBwT}/H [f] [def: handout]
	menadev{mndB}/Xmenadvem{mndBym}/H [m] [def: donor] 
neelm{nelm}/H [def: disappear (with "vern")] 
nefesh{nfS}/Xnefoshes{nfSwT}/H/D [n] [def: soul, person] /Lh
	moyser{mwsr}-nefesh{nfS} [def: self-sacrificing (with "zayn")] 
		mesiras{msyrT}-nefesh{nfS} [def: self-sacrifice]
	agmas{egmT}-nefesh{nfS}/H [def: grief, sorrow]
	[idiom: sakonas{sKnT} nafoshes{nfSwT} = mortal danger]
negativ/A [def: negative]
neged{ngd}/H [def: against] /Lke
neger/S [m] negerte/S [f] [def: Negro] [usage: was polite, no longer acceptible in America]
negeye{nwge}/H [f] [def: touch (with "zayn")] /Lb [def: in regard to]
	negiye{ngye}/H negiyes{ngewT}/H [def: contact] 
negishes{ngySwT}/H [def: torture, discrimination, oppression, persecution] 
negl/Eekh [def: nail] 
	nigl/V/T /Gon [def: attach oneself (with "zikh")] 
	ne'gelekh [n] [def: cloves (herb)] 
	blumennegl/Eekh [def: flower spike] 
nekeyve{nkBh}/Xnekeyves{nkBwT}/H [f] [def: female] /Lv
	nekeyvenik{nkBhnik}/Ees [def: womanizer] 
nekhay [def: let it be (Russian)] 
nekhome{nHmh}/Xnekhomes{mHmwT}/H [f] [def: comfort]
nekhosem{nxsym}/H [def: property]
nekome{nkmh}/Xnekomes{nkmwT}/H [f] [def: revenge]
	noykem{nwkm}/H [def: take revenge (with "zayn")] 
nekrolog/N [m] [def: obituary notice] 
nekst/A [def: next (English)]
nekude{nkwdh}/Xnekudes{nkwdwT}/H [f] [def: punctuation]
	menaked{mnkd}/H [def: punctuate (with "zayn")] 
nem/V/Bgenumen [def: take, begin (with infinitive)]
	/Gon/Gavek/Gtsu/Garayn/Garop/Garoys/Gunter/Garum/Gayn/Gdurkh/Giber/Gmit
	/Gtsurik/Gtsuzamen/Gtsunoyf/Garunter/Garoyf/Gfor/Gfunander
	/Goys [def: be a success, make a hit, stipulate (with "bay ... "az"), run out (with "zikh")] 
	/Goyf [def: greet, receive] 
	/Gop [def: fetch, pick up] 
	banem/V/Bbanumen [def: comprehend]
		banem/N [m] [def: comprehension] banemung/N [def: comprehension]
	dernem/V/Bdernumen [def: take]
	farnem/V/Bfarnumen [def: be busy] 
	tsenem/V/Btsenumen [def: take]
	unternemung/N [f] [def: undertaking, affair]
	opnemer/S [m] [def: customer] 
	teylnemer/S [m] onteylnemer/S [m] [def: participant]
	nemlekh/A [def: similar]
	arumnemik/A [def: thorough] 
	ayngenem/A [def: pleasant] ongenem/A angenem/A
		umayngenem{um#ayngenem}/A umongenem/A umangenem/A [def: unpleasant]
	aroysnem/N [m] aroysnemekhts/N [n] [def: take-out food] [note: V]
	oysnem/N [m] [def: exception]
		oysnam/N [m] [def: exception] [usage: doubtful admissability]
	oyfname/S [f] [def: reception] 
	nemer/S [m] [def: taker]
	[idiom: oyf mi'ttsunemen = take-out (food)]
neo [prefix] [def: neo, new] 
neodimyum [m] [def: neodymium (Nd)] 
neologizm/N [m] [def: neologism] 
neon [m] [def: neon (Ne)] 
nepl/N [m] [def: fog] /Idik [def: foggy]
	farneplt/A [def: fogged up] 
neptunyum [m] [def: neptunium (Np)] 
ner/V/T [def: nourish] ner/N [m] [def: nourishment] 
	nerung/N [f] [def: nourishment] 
	derner/V/Bdernert [def: nourish] dernerung/N [f] [def: nourishment]
	narhaftik/A nerevdik/A [def: nutritious] 
	[idiom: ner-spetsyalist = nutritionist]
nerv/N [m] [def: nerve] /Iez /Ieish nervezlekh/A [def: nervous]
	denervi'r/V/Bdenervi'rt [def: vex, put on edge, annoy; be nervous (with "zikh")]
	nervi'r/V/Bnervi'rt [def: make nervous] % Harduf
neshike{nSykh}/H [f] [def: kiss] /Lb
neshome{nSmh}/Xneshomes{nSmwT}/H [f] [def: soul] /Iik
	neshomenyu{nSmhnyu} [def: dear soul] 
nesiye{nsyeh}/Xnesiyes{nsyewT}/H [f] [def: journey] 
nesoyen{nsywn}/Xnesyoynes{nsywnwT}/H [m] [def: test] 
nest/N/D [f] [def: nest] 
net/A [def: flush, snug] 
	[idiom: pasn net = fit tightly]
neto [def: net (as a measure)] % Harduf
nets/N [f] [def: net]
	veltnets [f] i'nternets [f] [def: Internet] internetish/A
	netsverk/N [m] [def: network] 
netsekh{ncH} [m] [def: eternity; the Sefirah Netsakh (kabbalah)] 
nevrologish/A [def: neurologic] 
ney/V/T [def: sew] /Gayn/Goyf/Gtsu/Gtsunoyf/Garum
	baney/V/Bbaneyt [def: sew]
	farney/V/Bfarneyt [def: sew up]
	neytorin/S [f] [def: seamstress]
neyder{ndr}/Xnedorem{ndrym}/H [m] [def: oath]
	[idiom: gebn nedorem = make a pledge]
neyg/V/T [def: nod; be inclined; be different] 
	/Gop [def: differentiate] 
	farneyg/V/Bfarneygt [def: nod in agreement or recognition] 
	neygung/N [f] [def: leaning, inclination] 
	noyg/V/T [def: nod] [usage: doubtful admissability]
	opneyg/N [m] opneygung/N [f] [def: trajectory; difference]
neyn [def: no] 
neys{ns}/Xnisem{nsym}/H [m] [def: miracle] 
neyt/V/T neytik/V/T [def: force]
	noyt/N [f] [def: need] neytik/K [def: necessary] 
		noytik/K [def: necessary] [usage: doubtful admissability]
	neytikayt/N [f] [def: need]
neytral/A [def: neuter, neutral]
	neytralitet [f] [def: neutrality]
	neytralizi'r/V/Bneytralizi'rt [def: neutralize] 
	neytralizirung/N [f] [def: neutralization] 
neytron/N [def: neutron] 
nezir{nzyr}/Xnezirem{nzyrym}/H [m] [def: Nazirite] /Iish 
nibl{nybwl}/H [def: vulgar]
	menuvl{mnwBl}/Xmenuvolem{mnwBlym}/H [m] [def: vulgar person or thing]
	neveyle{nBlh}/Xneveyles{nBlwT}/H [def: corpse, carcass; slut; sloven]
	nevole{nBlh}/Xnevoles{nBlwT}/H [def: scandal; scandalous behavior] 
	niblpe'{nybwl-ph} [m] [def: pornography, vulgarity]
nider/V/T/Garop [def: descend]
	dernider/V/Bdernidert [def: descend]
	derniderik/V/Bderniderikt [def: lower; humiliate]
		derniderikung/N [f] [def: humiliation] % Harduf 
	niderik/K [def: low]
	anider [def: downwards] [adv]
nief{ny#wf}/H [m] [def: adultery]
	noyef{nw#f}/Xnoyofem{nw#fym}/H [m] [def: adulterer]
nifloyes{nfl#wT}/H [def: miracles]
	pile{pl#y}/H peloem{plo|ym}/H [def: miracle] /Idik [def: miraculous]
niglezhe [m] [def: negligée] 
nign{nygwn}/Xnigunem{nygwnym}/H [m] [def: melody]
	nigndl{nygwndl}/Xnigunemlekh{nygwnymlekh} [def: melody]
		ni'gele/Xkh [def: light tune] 
	negine{ngynh}/H [def: song]
	nign{nygwn}/V/T [def: hum] % bug in forming past in unicode
niked{nykwd}/Xnikudes{nkwdwT}/H [m] [def: point (orthographic)]
nikhe{nyH#}/H [def: pleasant] 
nikhne{nyxne}/Xnikhnoem{nyxnoim}/H [m] [def: subservient]
nikhpe{nxph}/H [def: anger]
	nikhpenik{nxphnik}/Ees [m] [def: angry person]
nikhter/V/T [def: sober up] /Goys
	nikhter/A [def: sober] oysnikhterung/N [f] [def: becoming sober]
nikl [m] [def: nickel (Ni), 5-cent coin] 
nikoti'n [m] [def: nicotine (chemical)] 
nile{ne|ylh}/H [def: Neilah prayer on Yom Kippur] 
nimfe/S [f] [def: nymph] % Harduf
nimtse{nymc#}/H [def: consequently; is found] /Lb [def: available] 
	tamtses{Wmc#wT}/H [def: essence] 
	hamtsoe{hmc#h}/Xhamtsoes{hmcowT}/H [f] [def: gadget, device, idea] 
nir/N [f] [def: kidney] 
nis/V/Bgenosn [def: sneeze] 
	nos/N [m] [def: sneeze] 
nishe/S [f] [def: niche]
nisht nit [def: not]
	nite [def: don't (do it)]
	gornit gornisht /Iik gornishteray/N [n] nitl [def: nothing] 
	nito /Iik nishto [def: does not exist]
		nitoikayt/N [f] [def: absence; non-existence] 
	anisht anit [def: if not]
	mernisht mernit [def: only] 
	umnisht [def: for no good reason (with "umzist un -")] 
	nishtik/A [def: unimportant]
	mitnitshke/S [f] [def: seller of minor food items like flour]
	nishme'r [conj] [def: however]
	mernisht [conj] mernit [conj] [def: however] 
	mernisht [adv] mernit [adv] [def: only] 
	tsunisht [def: to nothing] 
	[idiom: makhn tsunisht = destroy]
nishter/V/T [def: look through] 
nishtoymeym{nSWwmm}/H [def: amazed] 
nits/V/T [def: use] /Goys [def: abuse]
	nuts/V/T [def: use] /Goys [def: abuse] % variant spelling
	banits/V/Bbanutst [def: use, employ]
	banits/N [m] [def: use] shprakhbanits/N [def: language usage]
	nits/N [m] [def: use] /Ilekh /Iik [def: useful] 
	nuts/N [m] [def: use] /Ilekh /Iik [def: useful] % variant
	nitseve/V/T/Giber [def: recycle, re-sew with sides reversed to re-use]
			litseve/V/T /Giber
	nitser/S [m] banitser/S [m] [def: user]
	farnits/V/Bfarnitst [def: use up] 
nitses{nycwc}/H [def: sparkle]
nitsokhn{nycHwn}/Xnitskhoynes{nycHwnwT}/H /Idik [def: victory]
	menatseyekh{mncH}/H [def: victorious] 
nivo [m] [def: level] 
nobel [def: Nobel prize (with "premye")] 
nobelyum [m] [def: nobelium (No)] 
nodl/N [f] [def: needle] /Dned
noent/Kneent [def: near] noentkayt/N [f] [def: nearness]
	neent|st/A [def: near] % variant superlative
	nenter/V/T [def: approach] 
	dernenter/V/Bdernentert [def: bring near; approach (with "zikh")]
		dernenterung/N [f] [def: approach] 
nog/V/T [def: gnaw] 
noged{ngyd}/Xnegidem{ngydym}/H [m] [def: wealthy person]
	negidish{ngydish}/A [def: wealthy] 
	negidiste{ngydyTte}/H/S [f] [def: wealthy woman] 
nogl/N [m] [def: nail] 
	naytnogl/N [m] [def: hangnail] 
nokh/P [def: after, still] dernokh/P
	dernokhdem [def: afterwards] 
	[idiom: un nokh vi', un nokh vo's, un nokh a mi'n = exceedingly (interj)] 
nol/N [f] [def: awl] 
nomad/N [m] [def: nomad] % Harduf
nomen/Xnemen [m] [def: name]
	tsunomen/Xtsunemen [m] tsune'menish/N [m] [def: nickname] 
	nominativ/A [def: nominative (grammar)] 
	nomini'r/V/Bnomini'rt [def: nominate] 
		nominatsye/S [f] [def: nomination] 
	banoment/A [def: called, titled]
none/S [f] [def: nun] 
nopl/N [def: umbilical cord, navel]
	opnoplung/N [f] [def: separation from mother]
nor [def: but, only] 
nore/S [f] [def: lair] 
normal/A [def: normal] /Iish [def: normal] 
	umnormal/A /Iish [def: abnormal] 
	norme/S [f] [def: norm] % Harduf
nosi{nQy#}/Xnesiyem{nQy#ym}/H [def: prince; ruler] 
nostalgye/S [f] [def: nostalgia] nostalgish/A [def: nostalgic] 
not/Xnet [f] seam % Harduf
notar/N [m] notaryus/N [m] [def: notary] 
note/Xnotn [f] [def: musical note] 
notits/N [f] [def: notice, note (written)]  
	notatsye/S [f] [def: accusation]
novele/Xnoveln [f] [def: novel] 
november [m] [def: November] 
novene [def: rare occasion] 
novi{nBy#}/Xneviyem{nBy#ym}/H [m] [def: prophet] /Lh
	neviish{nBy#ish}/A [def: prophetic] 
	neviyes{nBy#wT}/H [def: prophesy] 
	nevue{nBu#h}/H [def: prophesy]
noye/V/T [def: ache; gnaw; haunt (feelings)] 
noyfl{nwfl}/Xnoyflem{nwflym}/H [def: fall (with "zayn")] 
	nefile{nfylh}/Xnefiles{nfylwT}/H [f] [def: downfall] 
noyre{nwr#}/H [def: wondrous] 
noyte{nwth}/H [def: incline (with "zayn")] 
	netiye{ntyh}/Xnetiyes{ntywT}/H [def: inclination] 
	[idiom: noyte{nwth} l|moves{mwT} = near death]
noz/Xnezer [f] [def: nose] /Dnez
	nozdre/S [def: nostril] 
	[idiom: arayn emetsn in der noz = well remembered by someone]
	[idiom: aroplozn di noz = feel dejected]
nu anu [interj] [def: well then] 
	anu/Een [m] [def: challenge] 
	[idiom: anu, pruv nor = just try; I dare you]
nudne [def: boring] /Idik [def: queasy] 
	nudnik/Ees [m] nudnitse/S [n] [def: boring person] 
	nudye/V/T nudzhe/V/T [def: bother] 
	farnudye/V/Bfarnudyet [def: bore]
	nudote [f] [def: boredom] 
nul [m] [def: zero, null] 
	anuli'r/V/Banuli'rt [def: annul, nullify] 
	anulirung/N [f] [def: annulment, nullification] 
numer/N [m] [def: number]
	numeri'r/V/Bnumeri'rt [def: enumerate] 
	numerator/N [m] [def: calculator] 
	shlu'snumer/N [m] [def: closing number (concert)] 
	[idiom: tsugob-numer = addend]
	[idiom: ershter numer = opening number (concert)]
nun{nʼ}/H [m/f] [def: Hebrew letter Nun] 
nure/V/T [def: look deeply into] /Gayn [def: burrow into]
nus/Xnis [m] /Dnis [def: nut, nit (insect egg)]
	khazer{Hzyr}-nisl/Eekh [n] [def: acorn] 
	knaknisl/Eekh [n] [def: nutcracker]
	[idiom: ruf im knaknisl = you can't hurt him]
nusekh{nwsH}/Xnuskhoes{nwsHwT}/H [m] [def: style; edition] 
nyanye/S [f] nyanke/S [f] [def: babysitter, nanny, governess]
	nyantshe/V/T [def: babysit]
nyezheli [conj] [def: than, rather than (Russian)] 
nyobyum [m] [def: niobium (Nb)] 
nyuans/N [m] [def: nuance]
o [interj] [def: oh! (expression of dismay)] 
o/Een [m] [def: the letter O] 
obdirke/S [def: skin with fat (poultry)]
obedye [noun] [def: a particular Russian Orthodox service] 
ober [def: but] 
oblave/S [f] [def: police raid, search] 
obligatsye/S [f] [def: obligation]
	obligatorish/A [def: obligatory] 
observi'r/V/Bobservi'rt [def: observe]
	observator/N [m] [def: observer]
	observatsye/S [f] [def: observation] 
obshtshestve [def: society, common folk (Russian)] /In
obyekt/N [m] [def: object] /Iiv [def: objective (grammar)] 
odekolon [noun] [def: eau de cologne (perfume)] 
odem{odm}/H [def: person, Adam] 
oder/N/D [f] [def: vein] /Idik
oder [def: or] 
odler/S [m] [def: eagle (bird)] 
of{ewf}/Xoyfes{ewfwT}/H [n] [def: bird, chicken]
	eyfele{ewfele}/Xeyfelekh{ewfelekh} [def: child] 
ofensiv/A [def: offensive] 
	ofensive/S [f] [def: offensive] 
ofitsir/N [m] [def: officer] 
ofitsyel/A [def: official]
	ofis/N [m] [def: office (English)] 
oft/A [def: frequent, rife] oft [adv] [def: often] 
	[idiom: oft mol = frequently]
oydef{ewdf} [m] [def: excess, surplus] 
oyfn_{#wfn}/H oyfanem{#wfnym}/H [def: method]
oyneg{eung} [m] [def: enjoyment] 
oke/S [f] [def: measure of weight (Ukrainian)]
oke/S [f] [def: a card game]
okersht [def: once] /Iik
okh [def: woe (okh un vey)] 
okrop [m] [def: boiled water] 
oks/N [m] [def: ox] 
oktober [m] [def: October] 
okupi'r/V/Bokupi'rt [def: occupy]
	okupa'nt/N [m] [def: occupant] 
	okupatsye/S [f] [def: occupation] 
ol{ewl}/H [m] [def: yoke] 
olimpish/A [def: Olympic; stoic] 
olov{elyw}/H [def: on him] oleynu{elynw}/H [def: on us] 
omed{emwd}/H [def: podium] 
omeyn{omn}/H [interj] [def: amen (expression of pious agreement] 
on/P onet [adv] [def: without, upon (as separable part of verb)] 
onlayn [adj] [def: on-line] [grammar: indeclinable]
onerken/V/T [def: respect] 
ones{anws}/Xanusem{anwsym}/H [def: forced convert from Judaism] 
o'ngepikevet/A [def: chock-full of (with "mit")] 
ongeshnyokert/A [def: tipsy, drunk] 
ongezolyet/A [def: ill at ease] % no base verb
onkl [m] [def: Uncle] [usage: inadmissable]
onov{env}/Xanovem{envym}/H [m] [def: modest person] 
onver/V/Bongevoyrn [def: loss, forfeit] 
	onver [m] [def: loss]
op [prep] opet [adv] [def: finishing/up (as separable part of verb)] 
opeku'n/N [m] [def: guardian (legal)] 
opera [f] [def: opera] operete/S [f] [def: operetta] 
operi'r/V/Boperi'rt [def: operate]
	operatsye/S [f] [def: operation] 
	[idiom: durkhmakhn an operatsye = undergo surgery]
	operativ/A [def: functional, operational] 
o'pgekhoymlt/A [def: shabby] 
opozitsye/S [f] [def: opposition] 
opshay [m] [def: respect] 
optimistish/A [def: optimistic]
	optimi'st/N [m] [def: optimist] 
	optimizm/N [m] [def: optimism] 
o'ptrinik/A [def: dissident] 
optsye/S [f] [def: option] 
or{#wr}/H [m] [def: light] 
orandzh/A [def: orange color] 
orator/N [m] [def: orator] 
orbit/N [m] [def: orbit] 
ordn/V/T [def: set in order] /Gayn
	o'rdenung/N [f] aynordenung/N [f] farordenung/N [f] [def: order]
	umo'rdenung/N [f] [def: disorder]
	ordn/S [m] [def: order (organization), medal] 
	o'rdener/S [m] [def: usher] 
orem/K [def: poor]
	farorem/V/Bfaroremt [def: impoverish]
		faroremung/N [f] [def: impoverishment] 
	oreman [m] [def: pauper]
	oremkayt/N [f] oremshaft/N [f] [def: poverty] 
oren{orwn}/H [def: ark (cabinet for Torah scroll)] 
	oren{orwn}-koydesh{kdwS} [def: ark (cabinet for Torah scroll)] 
orev{erB}/Xorvem{erBym}/Xareyvem{erBym} [def: guarantor] 
	orev{erB} [def: guarantee (with "zayn")] 
	orevnik{erBnik}/Ees [def: hostage] % Forwards
organ/N [m] [def: organ (biological)] /Iish [def: organic] 
	otemorgan/N [m] [def: breathing organ] 
organizatsye/S [f] [def: organization]
	organizi'r/V/Borganizi'rt [def: organize]
		organizirung/N [f] [def: organization (act)] 
		teke-organizirke/S [f] [def: directory (computer)] [note: V]
	reorganizi'r/V/Breorganizi'rt [def: reorganize]
		reorganizatsye/S [f] [def: reorganization] 
	organizm/N [m] [def: organism] 
orgl/N [m] [def: musical organ]
original/N [m] [def: master copy] 
	origine'l/A [def: original] originelkayt/N [f] [def: originality] 
orkester/S [m] [def: orchestra] 
orl{erl}/H areylem{erylym}/H [def: uncircumcised]
	[idiom: der orl{erl} meyven{mByn} kol{Kl} diber{dybwr} = The non-Jew understands Yiddish]
orntlekh/A [def: honest, in good faith] 
	umorntlekh/A [def: dishonest, in bad faith] 
	umo'rntlekhkayt/N [f] [def: dishonesty, bad faith] 
ort/Xerter [n] [def: place] /Iik
	ekranort/Xekranerter [n] [def: desktop (computer)] [note: V]
	parkirort/Xparkirerter [n] [def: parking place] 
	shmuesort/Xshmueserter [n] [def: chat room] [note: V]
	vaserort/Xvasererter [n] [def: wetland] 
	voynort/Xvoynerter [n] [def: habitation] 
	zitsort/Xzitserter [n] [def: seat] 
	eynartik/A [def: unique] [usage: inadmissable]
	eygnartik/A [def: idiosyncratic]
	farsheydnartik/A farshidnartik/A [def: multi-faceted] [usage: inadmissable]
	ertervayz [adv] [def: in places] 
	ortshaft/N [f] [def: neighborhood]
ortodoks/A [def: orthodox] /Iish
ortografye/S [f] [def: orthography]
	ortografish/A [def: orthographic] 
oryentalish/A [def: oriental] 
	oryentali'st/N [m] [def: orientalist]
		orientalistik [f] [def: orientalism (subject)] 
oryenti'r/V/Borienti'rt [def: orient]
	orientirung/N [f] [def: orientation] 
os{#wT}/H oysyes{wTywT}/H [def: letter of alphabet] 
	[idiom: kidesh{kidwS}-levone{lBnh} oysyes{#wTywT} = large lettering]
osed{eTyd} [m] [def: future] 
oshamnu{eSmnw}/H [def: penitential prayer (vidui)] 
osyen [m] [def: Autumn (season)] /Idik
ot [def: this very] 
otem/V/T [def: breathe] /Gayn/Gop
	otem/N [m] [def: breath] /Idik 
otshene/S [f] [def: flower of indoor plant] 
otshiske/S [f] [def: scabies (disease)]
ov{oB}/Xoves{oBwT}/H [m] [def: father, ancestor]
	ovinu{oBynw}/H [def: our father]
	avoyseynu{aBwTynw}/H [def: our ancestors] 
ovatsye/S [f] [def: ovation] 
over{eBr}/H/S [m] [def: (time) past] 
ovl{oBl}/Xaveylem{aBlym}/H [def: mourner]
	aveyles{aBlwT} [f] [def: mourning] 
ovnt/N/D [m] [def: evening] /Iik
oy [interj] [def: woe! (expression of pain or wonder)] 
oyb [def: if]
oybn [adv] oybns [noun] [def: above]
	oybnon [adv] [def: at the head of the table] 
oyditorye/S [f] [def: listening public; auditorium] 
	oyditoryum/S [f] [def: auditorium] 
oyditsye/S [f] [def: audition]
oyer/N/D [m] [def: ear] 
oyf/P af/P [def: on]
	deroyf [adv] [def: above] 
oyflage/S [f] [def: edition]
oyg/N /Deyg [n] [def: eye] 
	[idiom: gut oyg = beyz oyg = evil eye]
	[idiom: ful vi an oyg = overflowing]
	[idiom: haltn oyfn oyg = keep track of]
oygust [m] [def: August] 
oykh [adv] oykhet [adv] [def: also] 
oyle{e|wlh}/Xoylim{ewlym}/H [def: immigrant to Israel] 
oylem{ewlm}/H [m] [def: world, congregation]
	/Lh [def: world] /Lb [def: in the world]
	/Lm [def: from everlasting] /Ll [def: to everlasting] 
	besoylem{byT-ewlm}/H [m/n] besalmin{byT-elmyn}/H [m/n] [def: cemetery] 
oymer{ewmr} [m] [def: 50-day period between peysekh and shevues] 
oyps/N [n] [def: fruit]
oyrekh{#wrH}/Xorkhem{#wrHym}/H [m] [def: guest]
oys [adv] oyset [adv] [def: out] oyset [interj] [def: gone]
	oysn [predicate adjective] [def: intending] 
	[idiom: nit dem bin ikh oysn = that's not my point]
	oyser/P [def: except for] /Ilekh [def: external] 
		[idiom: oyser zikh = beside oneself]
	deroys [adv] [def: out from there] 
	droysn [def: outdoors; outside] /Idik droysn/S [m] [def: exterior] 
		indroysn [def: outside] /Idik
	oysterlish/A [def: exceptional] 
	oysern [adj] [def: foreign] % uninflected, as in "oysern minister" 
oysgefyokevet/A [def: dolled up] 
oysher{ewSr}/H [m] [def: rich person]
	ashires{eSyrwT}/H [n] [def: wealth]
oytentish/A [def: authentic] 
oyto/S [m] [def: auto] oytomobil/N [m]
	sharoyto/S [m] shney-sharoyto/S [m] [def: snow plow (vehicle)] [note: V]
oytobus/N [m] [def: bus] 
oytoklav/N [m] [def: autoclave (sterilizing device)] 
oytomatish/A [def: automatic] 
	oytoma't/N [m] [def: machine gun; cafeteria] 
	gelt-oytoma't/N [m] [def: automated teller machine (ATM)] 
oytor/N [m] [def: author] 
	oytoritet/N [f] [def: authority] /Iish [def: authoritative] 
oytser{#wcr}/Xoytsres{#wcrwT}/H [m] [def: treasure] 
oyver{ewBr}/H [def: in violation]
	[idiom: oyver{ewBr} botl{btl} = senile]
oyvn/S [m] [def: oven]
	brot-oyvn/S [m] [def: broiler] 
	kalkhoy'vn/S [m] [def: lime oven]
	mikrooy'vn/S [m] [def: microwave oven] 
	vantoy'vn/S [m] [def: fireplace (between two rooms)]
ozere/S [f] [def: lake] 
ozmyum [m] [def: osmium (Os)] 
pade/V/T [def: fawn on, philander, woo] /Garum
paganer/S [m] [def: pagan] 
pak/V/T [def: pack] /Gayn/Gon/Goys/Garayn
	pakeve/V/T [def: pack] 
	pekl/V/T /Garayn/Gariber [def: pack] 
	farpak/V/Bfarpakt [def: pack] 
	pak/N/Xpek [m] /Dpek gepek [def: pack]
		sanitar-pekl/Eekh [def: first-aid kit] [note: V]
		pasik-pekl/Eekh [n] [def: fanny pack] [note: V] 
pakhed{pHd}/Xpekhodem{pHdym}/H [m] [def: fear] 
	pakhdones{pHdwnwT}/H [def: timidity; cowardice] /Idik [def: timid] 
	pakhdonish{pHdnish}/A [def: timid; cowardly] 
	pakhdn{pHdn}/Xpakhdonem{pHdnym}/H [m] [def: timid person]
pakhter/S [m] [def: leaseholder (Jewish); tax farmer] 
	likhtpakhter/S [m] [def: candle-tax collector] 
pakt/N [m] [def: agreement, compact, pact] 
	kompa'kt/N [m] [def: agreement, compact] 
palate/S [f] [def: hospital ward] 
palats/N [m] [def: palace] 
palitre/S [f] [def: palette]
palm/N palme/S[f] [def: palm (tree)] 
	shtekhpalme/S [f] [def: holly (tree)] 
paltn/S [m] [def: overcoat (clothing)] 
pamelekh/A /Ilekh [def: slow] /Iink
	farpamelekh/V/Bfarpamelekht [def: slow down, slacken pace] 
pamelye{pmly#}/H [def: heavenly host (with "- shel mayle")] 
pamfle't/N [m] [def: pamphlet] 
pan [def: Mister (Polish)] pani [def: Mrs.] 
	panski [adj] [def: of the nobility] [grammar: indeclinable]
	panibrat [adj] [def: good buddy] [grammar: indeclinable, predicative]
	yashne-panye [def: Your Excellency (Polish, slightly ironic)] 
	panish/A panske/A [adj] [def: relating to nobility] 
panik [f] [def: panic] 
panorame/S [f] [def: panorame] 
pansyo'n/N [m] [def: boarding house] 
panter/N [m] [def: panther (animal)] 
pantofl/Eekh [n] [def: slipper]
pantomim [f] pantomime/S [def: pantomime] /Iik
pantser [m] [def: armor]
	bapantser/V/Bbapantsert [def: armor] 
pantsher/S [m] [def: flat tire; puncture] 
papakhe/S [f] [def: round fur hat (clothing)] 
papke/S [f] [def: folder (paper, computer)] 
	hoyptpapke/S [f] tekepapke/S [f] [def: directory (computer)] [note: V]
papir/N/D [n] [def: paper (material)] /In
	zilberpapir/N [n] [def: silvered paper] 
papiros/N/Dpapires [m] [def: cigarette] /D
	papirosnik/S [m] [def: cigarette seller or user] 
papshoy/Ees [m] [def: corn (ear of)]  
parad/N [m] [def: parade] 
paradke/S [def: decree, order (Russian)] 
parado'ks/N [m] [def: paradox] % Harduf
parafra'z/N [m] [def: paraphrase] % Harduf
	parafrazi'r/V/Bparafrazi'rt [def: paraphrase] % Harduf
paragra'f/N [m] [def: paragraph] 
parale'l/A [def: parallel]
	paraleli'zm/N [m] [def: paralelism] 
parali'z [m] [def: paralysis] 
	paralizi'r/V/Bparalizi'rt [def: paralyze] 
paranoye{parano|ye}/H/S [f] [def: paranoia] 
parashu't/N [m] [def: parachute] % Harduf
	parashuti'st/N [m] [def: parachutist] 
parazi't/N [m] [def: parasite] % Harduf
pardes{prds}/Xpardeysem{prdsym} [m] [def: fruit garden, paradise (mystic)] 
pare/S [f] [def: steam] /Idik
	parokhod/N/D [def: steam boat] 
	parove [adj] [def: steam-powered] [grammar: undeclined]
parekh/Ees parkh/Ees [def: scalp canker, scab (disease)] 
	parkehvate/A [def: scabby, scabrous] 
pare'ntsh/N [m] porentshe/S [f] [def: railing]
pareve/A [def: neither milk nor meat food]
parfumi'r/V/Bparfumi'rt [def: perfume] 
	parfum/N [m] [def: perfume] 
park/N [m] [def: park] 
park/V/T [def: park (a vehicle)] % Harduf
parkan/Ees [m] [def: fence] 
parlament/N [m] [def: parliament] /Iarish
parmet/N [m] /In [def: parchment] 
parnose{prns|h}/H [def: income] /D parnoses{prnswT}/H
	parnes{prns}/Xparnosem{prnsym}/H [m] [def: financial supporter]
	mefarnes{mfrns}/H [def: financially supporting] 
parodye/S [f] [def: parody] parodish/A [def: parodic] 
parol [def: fight song] 
parom/N [m] [def: ferry boat] 
parondek [def: order, arrangement] parondkes
	parondkeve/V/T [def: arrange]
parshe{prSh}/Xparshes{prSywT}/H [f] [def: section of the Pentateuch, Biblical text]
	parshevayz{prShvayz} [adv] [def: text by text] 
	parshas{prST}/H [def: Biblical text of]
parshoyn/N [m] [def: person] /Dparshoynd
	mansparshoyn/N [m] [def: male human] 
parsish [def: Judeo-Persian] 
parta'tsh/Ees [m] partatshke/S [f] [def: bungler] /Iish [def: sloppy] 
	parta'tsheve/V/Bparta'tshevet [def: bungle] 
partey/N/Iish [f] [def: political party]
	umparteyish/A [def: without party affiliation] 
partikl/N [def: particle (grammar)] 
partitsip/N [m] [def: participle] 
partiza'n/N [m] partizaner/S [m] partisanke/S [f] [def: partisan] 
partner/S [m] partne'rin/S [f] [def: domestic partner] 
	shtubpartner/S [m] [def: domestic partner] [note: V]
partsef{prcwf}/Xpartsufem{prcwfym}/H [m] [def: face] 
pa'rubek/Xpa'rubkes [m] [def: unmarried non-Jewish youth (Ukrainian)]
paru'k/N [m] [def: wig] 
parusine [def: sail material] 
pas/Xpeser [m] [def: pass; permit] 
pas/N [m] [def: belt, track (electronics)] pasik/N/Ees
	pasme/S [f] [def: strip] 
	elektre-pas [m] [def: power strip/board (electric)] 
	shlumperpas/N [m] [def: cummerbund] 
	shitspas/N [m] [def: safety belt] 
pas/V/T [def: be appropriate] /Gtsu/Goyf
	pasik/K [def: appropriate] umpasik/A [def: inappropriate] 
	oyfpaser/S [m] oyfpaserin/S [f] [def: protector] 
	tsupasung/N [f] [def: adjustment] 
pas [def: void (with "pust un -")]
	pustunpasnik/Ees [m] pustepasnik/Ees [m] [def: someone without income] 
pasazhi'r/N [m] [def: passenger] 
	[idiom: blinder pasazhi'r = stowaway]
pasekh{pTH}/H/N [def: Hebrew vowel point pasekh] 
pashe/V/T [def: pasture] 
pashol [interj] [def: giddyap, let's go (Russian)] 
pasi'r/V/Bpasi'rt [def: occur]
	pasirung/N [f] [def: occurrence] 
pasi'v/A [def: passive] pasivkayt/N [f] [def: passivity] 
paskudne [def: ugly, nasty, loathesome]
	paskudnik/Ees [m] paskudnitse/S [f] [def: digusting person] 
	paskudnyak/Ees [m] paskudnyatshke/S [f] [def: scoundrel] 
	paskudstve/S [f] [def: filth, abomination] 
paspo'rt/N [m] [def: passport] 
	onpasportler/S [m] [def: person without a passport] 
paste/S [f] [def: paste] 
pastekh/Eer/D [m] [def: shepherd]
	pastushke/S [f] [def: shepherdess] 
pastke/S [f] [def: mousetrap] 
pa'sternak [m] [def: parsnips]
pastrami [f] /Dpastrame [def: pastrami (food)] 
patelnye/S [f] [def: frying pan]
pate'nt/N [m] [def: patent (legal)] 
pater{ptr}/H/V/T [def: waste] /Gop/Gtse
	tsepatr{tseptr}/V/Btsepatrt{tseptrt} [def: completely waste] 
	poter{ptwr}/H [def: free]
	ptire{ptyrh}/H [def: death (of a saint)]
	nifter{nftr} [adj] [def: dead (of a saint)] 
	[idiom: vern nifter = die (said only of a saint)]
	haftoyre{hftwrh}/Xhaftoyres{hftwrwT} [f] [def: prophetic (Bible) reading] 
	[idiom: a nomen fun der haftoyre{hftwrh} = a fictitious name]
patetish/A [def: pathetic] 
patilnitse/S [f] [def: nape of the neck]
patlozhan/Dpatlozhe [m] [def: eggplant] 
patologye/S [f] [def: pathology] patologish/A [def: pathological] 
patos [m] [def: pathos] 
patrol/N [m] [def: patrol] 
patro'n/N [m] [def: patron]
	patroni'r/V/Bpatroni'rt [def: patronize] patrona'zh [def: patronage] 
patrya'rkh/N [m] [def: patriarch] 
patryot/N [m] [def: patriot] /Iish [def: patriotic] 
	patryotizm/N [m] [def: patriotism] 
patsh/V/T [def: slap; applaud] /Gon
	/Gunter [def: slap in secret]
	patsh/Xpetsh [m] [def: slap] /Dpetsh [def: tap] 
		patsheray'/N [n] [def: slapping] 
	farpatsh/V/Bfarpatsht [def: slap] 
	tsepatsh/V/Btsepatsht [def: slap] 
patsherke [def: handwriting (Russian)] 
patshke/V/T [def: overdo]
	/Gon [def: ruin by overdoing] 
	/Garum [def: make a general mess] 
	farpatshke/V/Bfarpatshket [def: overdo] 
	[idiom: eydl gepatshket = picky]
patsyent/N [m] [def: patient] 
pave/S [f] [def: peacock] 
pavilyon/N [m] [def: pavilion] 
pavolye/A pavolink/A [def: slow] 
pavya'k/N [def: prison for political prisoners]
paya'ts{pa|yats}/N [m] [def: clown]
	pa|ya'tseve/V/Bpa|ya'tsevet [def: clown] 
paynik/V/T [def: torture]
	farpaynik/V/Bfarpaynikt [def: torture] 
	payn [def: pain] /Ilekh [def: painful]
	payniker/S [m] [def: torturer]
	paynikung/N [f] [def: torture] 
paze [prep] [def: along] 
pe/En [m] [def: the letter P] 
pedagogye/S [def: pedagogy] 
	pedago'g/N [m] [def: pedagogue; teacher] 
pedan't/N [m] [def: pedant] 
	pedantish/A [def: pedantic] 
pedler/S [m] [def: peddlar] 
	pedl/V/T [def: peddle] 
pekh [n] [def: pitch] /Iik
pelts/N/D [m] [def: fur] peltsern/A [def: fur] 
	peltsl/Eekh [def: small fur, fruit peel] 
pen/N [f] [def: pen] 
pendum [def: (with "hendum -") in a rush] 
pendzl/N [m] [def: paintbrush]
	pendzl/V/T /Goys [def: depict by painting]
peni/S [m] [def: penny] 
pense [f] [def: pince-nez (clothing)] 
pensye/S [f] [def: pension] 
	pensyone'r/N [m] [def: retired person] % Harduf
	elter-pensye/S [f] [def: old-age pension] 
	[idiom: oyf pensye = retired]
pente/V/T [def: chain]
pe'rene/S [f] [def: feather bed; down quilt] 
per [def: per; via; by] % Harduf
pereodem{pr#-odm}/H/S [m] [def: savage; imbecile] 
perfekt/K [def: perfect]
	umperfekt/A [def: imperfect]
		umperfektkayt/N [f] [def: imperfection] 
	perfektiv/A [def: perfective (grammar)] 
peri{pry}/Xpeyres{pyrwT}/H [f] [def: fruit]
	pri{pry}/H [def: fruit of] 
periferye/S [m] [def: periphery] % Harduf
perifrastish/A [def: periphrastic] 
perl/X /Dper [m] [def: pearl]
permane'nt/A [def: permanent] 
perokhes{prwxT}/H/N [def: cloth ark curtain (religious)] 
perspektiv/N perspective/S [f] [def: perspective]
peryod/N [m] [def: period] /Iish [def: periodic] 
perzo'n/N [f] [def: person] [grammar: may use singular after a plural number]
	perzonik/A perzenlekh/A [def: personal]
	perzenlekhkayt/N [f] [def: personality] 
	perzonifitsi'r/V/Bperzonifitsi'rt [def: personify] 
		perzonifikatsye/S [f] [def: personification] 
	persona'l [m] [def: staff, personel] 
		persone'l/A [def: personal (regarding persons)] 
		personalite't/N [f] [def: personality (quality)] 
		persona'zh/N [m] [def: personality (person)] 
	persona grata [def: welcome person] 
	persona non grata [def: unwelcome person] 
pesimi'st/N [m] pesimistke/S [f] [def: pessimist]
	pesimizm/N [m] [def: pessimism] pesimistish/A [def: pessimistic] 
pest [def: poison] 
	farpestik/V/Bfarpestikt [def: poison] 
peti't [def: small typeface] 
petitsye/S [f] [def: petition] 
petrishke/S [f] [def: parsley (food)] 
petse' [m/f] [def: jellied calves' feet (food)] 
petshatek [m] [def: business deal]
pey{pʼ}/H [def: Hebrew letter Pe] 
peye{p#h}/Xpeyes{p#wT}/H [def: sidelock] /D
	[idiom: shvern bay bord un peyes{p#wT} = swear up and down]
peyger{pgr}/H/V/T [def: die (animal)]
	pegire{pgyrh}/Xpegires{pgyrwT}/H [f] [def: death (animal)]
	peyger{pgr}/Xpegeyrem{pgrym}/H [m] [def: corpse (animal)]
peyrek{prk}/Xprokem{prkym}/H [m] [def: chapter]
	pirkey{prky}/H [def: chapters of] 
peyresh{pyrwS}/Xpeyrushem{pyrwSym}/H [m] [def: explanation]
	meforesh{mfrS}/Xmeforshem{mfrSym}/H [def: explain, explainer, Rabbinic authority]
	poresh{prwS} prushem{prwSym} [def: Pharisee, separated man] 
peysekh{psH}/H/Idik [m] [def: Passover]
	far|peysekh|dik/A [def: pre-Passover]
	nokh|peysekh|dik/A [def: post-Passover] 
pe{ph}/H [def: mouth] pi{py}/H [def: mouth of] 
	bal-pe{bel-ph} [def: oral] /IJk
pgam{pgm}/Xpgomem{pgmym}/H [def: defect, blemish] 
	pgime{pgymh}/Xpgimes{pgymwT}/H [def: scratch; defect] 
pidyen{pdywn}/H [def: redemption] 
	pidnaben{pdywn-h|bn}/H [def: redemption of the first-born son] 
pik/N [m] [def: spades (playing cards)] % no plural?
pik/V/T [def: peck] /Goys/Gon
	pike/V/T [def: peck] % variant
	pikeve/V/T/Gon [def: find fault] 
pika'nt/A [def: sharp; spicy; sexy] 
piketi'r/V/Bpiketi'rt [def: picket (English)] 
pikeyekh{pykH}/Xpikkhem{pykHym} [m] pikeyekhte{pykHte}/S [f] [def: clever person]
piknik/N [m] [def: picnic] 
pil/N [f] [def: pill] 
pilder/V/T [def: be too loud]
	gepilder [n] [def: noise] 
pilke/S [f] [def: ball, baseball (with "hilke -")] 
pilneve/V/T [def: nurse, pamper] pileve/V/T
pilo't/N [m] [def: pilot] % Harduf
pilpl{pylpwl}/H [def: Talmudic hairsplitting] 
	pilple{pylpwle}/H/V/T [def: split hairs (with "zikh")]
pingpong [m] [def: ping-pong (game)] 
pinkes{pnks}/H [m] [def: register, notebook] 
pintl/V/T [def: squeeze the eyes almost shut] 
	/Dpint [n] [def: point] % no positive
		/Ddraypint [n] [def: ellipsis marks (printing)] 
	gepintlt/A [def: speckled; dotted] % Harduf 
pipernoter/S [m] [def: dragon] 
pipke/V/T [def: peep (sound of a bird)] 
pips/N [m] [def: squeak] 
	pipser/S [m] [def: beeper (telephone messages)] [note: V]
piramid/N [m] [def: pyramid] 
pira't/N [m] [def: pirate] % Harduf
pirkhey{prHy}/H [def: children] 
piro'g/N [m] [def: meat pie, vagina (vulgar)]
	pirge/S [f] [def: vagina (taboo)] 
pirsem{pyrswm}/H [m] [def: publication]
	mefursem{mfwrsm}/H [def: famous] 
	mefarsem{mfrsm}/H [def: publish (with "zayn")] 
	iber-pirsem{pyrsym}/H [m] [def: hype] 
pish/V/T [def: urinate]
	pishekhts/N [n] [def: urine]
	pisher/S [m] pisherke/S [f] [def: child] /D [usage: humorous]
	[idiom: ruf mikh kaker pisher = sticks and stones]
pishe-peyshe [f] [def: a children's card game] 
pishtshe/V/T [def: chirp (sound of a bird), squeal, whine] 
	pishtsh/N [m] [def: chirp, squeal, whine] 
pishtshevke/S pitshevke/S [f] [def: detail]
pisk/Ees/D [m] [def: mouth]
	piskate/S [f] [def: foul-mouthed woman]
pisn/A [def: moldy (Russian)]
pistoyl/N [m] pistolet/N [def: pistol (weapon)] 
	[idiom: vi a pistoyl in hartsn = like a knife in the heart]
pitse/S [f] [def: pizza (food)] 
pitsl/Eekh [def: tiny] % not in the positive
	tsepitslt/A [def: tiny] 
	pits [def: shreds (with "- pitslekh")]
	pitshedik/A [def: tiny]
pizhames [def: pajamas (clothing)] % Harduf
pizmen{pzmwn}/Xpizmoynem{pzmwnym}/Xpizmoynes{pzmwnwT} [m] [def: liturgical poem] 
plagia't [def: plagiarism]
plaka't/N [m] [def: poster, plackard]
plakhe [def: block, log]
plan/Xplener [m] [def: plan, map]
	plani'r/V/Bplani'rt [def: plan, schedule]
		planirung/N [f] [def: planning] 
		geveytlekh-planirt/A [def: regularly scheduled] [note: V] 
	planeve/V/T [def: plan] 
	tsaytplan/Xtsaytplener [m] [def: schedule] 
	lernplan/Xlernplener [m] [def: syllabus]
planet/N [m] [def: planet] 
plapl/V/T [def: babble]
	plapleray'/N [n] [def: babble] 
plastik [m] [def: plastic] plastish/A
platforme/S [f] [def: platform] 
platinum [m] [def: platinum (Pt)] 
plats/V/T [def: burst]
	tseplats/V/Btseplatst [def: burst]
plats/Xpletser [m] [def: place]
	hoyptplats/Xhoyptpletser [m] [def: main place]
	markplats/Xmarkpletser [m] [def: marketplace] 
	shpilplats/Xshpilpletser [m] [def: playground] 
	sportplats/Xsportpletser [m] [def: sport ground, arena]
	vebplats/Xvebpletser [m] [def: website]
	zitsplats/Xzitspletser [m] [def: seat] 
platshik/A [def: shallow, low-lying] 
	[idiom: makhn platshik = flatten]
plazhe/S [f] [def: sea shore] 
	plazhenik/Ees [m] [def: beach bum] [note: V]
plazme [f] [def: plasma] % Harduf
plebitsi't/N [m] [def: plebiscite] % Harduf
pleferish/A [def:  astonishing]
	gepleft/A [def: baffled, bewildered, dumbfounded] 
	geplef/N [n] [def: perplexity, bafflement] 
pletsl/Xpletslekh [def: cracker (food), roll] % no postitive form
	[idiom: tsibele pletsl = onion roll]
pleyade{ple|yade}/S [def: Pleiades (constellation); cluster] 
pleyn/N [m] [def: plain; (geometric) plane] 
pleytse/S [def: shoulder]
	breytpleytsik/A breytpleytsedik/A [def: broad-shouldered] 
	[idiom: tsushteln a pleytse = help]
plikh/N/Ees [m] [def: bald head]
	/Ievat [def: bald] 
plimenik/Ees [m] [def: nephew] plimenitse/S [f] [def: niece] 
plit/N [def: vinyl record, raft]
plitke/A [def: shallow] 
plodye/V/T [def: breed] /Gon
plog/V/T [def: torment, plague afflict, harass] 
	plog/N [f] [def: plague, affliction; scourge] 
plombe/S [f] [def: metal seal, filling (dental)] 
	blomb [def: permission, sealed with a plombe] 
	[idiom: leygn +dative a plombe = put a filling in the tooth in someone]
plonter/V/T [def: stumble] /Garum/Gfunander
	/Goyf/Goys [def: untie, disentangle] 
	plonter/S [m] plonternish [def: muddle, tangle, jumble]
	farplonter/V/Bfarplontert [def: stray (with "zikh")] 
plosh/N [m] [def: gust (of wind)] 
ploshe/V/T [def: run in circles]
	tseploshet/A [def: in disarray] 
ploster/N [def: some body part] % plostern fun di gendz
ployder/V/T [def: gossip] /Idik [def: gossiping] 
	ployderay'/N [n] [def: gossip] 
ployt/N [m] [def: fence] 
plump/N [m] [def: pump] plump/V/T [def: pump]
	plumper/D [def: ??]
	leshplump [m] [def: fire hydrant] 
pluralizm/N [m] [def: pluralism] pluralistish/A [def: pluralistic] 
plus [def: plus] 
plut/N [m] [def: scatterbrain, fickle person] 
	farplutet/A [def: out of kilter] 
plutonyum [m] [def: plutonium (Pu)] 
plutsling [adv] [def: suddenly] /Idik [def: sudden]
	plutsem [adv] [def: suddenly] /Idik [def: sudden] 
	plutslung [adv] [def: suddenly] /Idik [def: sudden] 
plyame/S [f] [def: spot, stain] 
plyeske/V/T [def: clap to the beat] 
plyukhe/V/T [def: pour, gush; slop] 
	plyukh/N [m] [def: splash (sound of liquid falling)] 
plyush [m] [def: plush] % Harduf
plyushke/V/T [def: splash] 
pnie{pnyh}/H [def: ulterior motive] pnies{pnywT}
pnyak/Ees [m] [def: tree stump] 
podane/S [def: subject (person), citizen (Russian)] 
podbokem [def: on the hips (with "nemen di hent -")] 
podeshve/S [f] [def: sole (shoe) (clothing)] 
podloge/S [f] [def: floor]
	pol/N [m] [def: floor] [usage: dialect]
podobne [adj] [def: similar] [grammar: undeclined]
po'dlost/N [f] [def: mean act (Ukrainian)] 
poet/N [m] [def: poet] /Iish [def: poetic] 
	poetese/S [f] [def: poetess] 
	etnopoetish/A [def: ethno-poetic] 
	poeme/S [f] [def: poem] poem/N
	poezye/S [f] [def: poetry] 
pof/V/T/Bgepofn [def: sleep overlong]
	pefer/S [m] [def: lazybones] 
pogode/S [def: pogoda] 
pogrom/N [m] [def: anti-Jewish riot]
	pogromi'r/V/Bpogromi'rt [def: riot] 
pok/N [f] [def: pock] % katshkes hobn moyre far pokn
pokn [def: pox (disease)]
	pok/V/T [def: have pox]
	[idiom: shteln pokn = vaccinate]
	[idiom: pokn un mozlen = go through childhood diseases]
pokrishke/S [f] [def: lid, pot cover]
pokshive/S [f] [def: nettle (plant)] % Harduf
poladyum [m] [def: palladium (Pd)] 
pole/S [m] [def: pole, sleeve]
	polar/A [def: polar (mathematics)] 
pole/V/T [def: weed (a garden)]
polemik/Ees [f] [def: polemics] 
polet{plyt}/Xpleytem{plytym}/H [def: refugee]
	pleyte{plyth}/Xpleytes{plytwT}/H [def: escape] /Lh
	[idiom: makhn pleyte = run away]
	[idiom: sheyres{S#ryT} h|pleyte = Holocaust survivors]
poligamye/S [f] [def: poligamy] 
poli'r/V/Bpoli'rt [def: polish; burnish] 
	poli'r/N [m] [def: polish; surface glow] 
polish [m/n] [noun] [def: synagogue anteroom] 
politik [f] [def: politics (subject), policy] /A
	politish/A [def: political]
	oysglaykh-politic [f] [def: affirmative action] [note: V]
	realpolitik [f] [def: realpolitic] 
politse/S [f] [def: bookshelf] 
politsey [f] [def: police]
	politsye/S [f] [def: police] [usage: doubtful admissability]
	politsya'nt/N [m] [def: policmeman] 
politu'r/N [f] [def: polish (substance)] 
polk/N [def: regiment (Russian)] 
	polkovnik/Ees [m] [def: lieutenant (Russian)] 
polke/S [n] [def: polka (dance)] 
polne/A [adj] [def: perfect (ironic), incomplete]
	[grammar: may be left undeclined]
polonik/Ees [m] [def: ladle] 
polonyum [m] [def: polonium (Po)] 
polu'mesik [m] [def: shallow wooden bowl, platter]
pomerants/N [m] marants/N [m] [def: orange (fruit)]
pomidor/N [m] [def: tomato] 
poml/Xpomelekh [n] [def: oven broom] 
pompedikl/N [m] [def: pendulum]
pompe/S [f] [def: pump] 
	pompeve/V/T [def: pump] 
pompe/S [f] [def: pomp] 
	pompe'z/A [def: pompous] 
pomu'ni'tse/S [f] [def: slops, slop pail] pomoy'nitse/ % either accent ok
	pamu'ntskele/Ekh [n] [def: slop pail] 
pomyeshtshik/Ees [m] [def: estate owner (Russian)] 
ponem{pnym}/H/D penemer{pnymer}/H [def: face] 
	ponem{pnym}-khadoshes{HdSwT} [n] [def: novelty] 
	azes{ezwT}-ponem{pnym} [def: effrontery]
pop/N [m] [def: Leader of Eastern Orthodox Church]
poperik [def: athwart]
popetshitel/Eyes [def: caretaker, trustee (Russian)] 
popke/S [f] [def: doll] 
popugay'/N [m] papuge/S [f] [def: parrot] 
	[idiom: la'ngnekiker popugay = parakeet]
popule'r/K [def: popular]
	populazito'r/N [m] [def: popularizer]
	popularite't/N [f] [def: popularity]
por/D [f] [def: pair]
	por/V/T [def: pair up] /Gtsunoyf
	porlekhvayz [adv] [def: in twos] /A
poradke/S [def: decree, order (Russian)] 
pore/V/T [def: busy oneself] /Garum
poresh{prwS}/H [def: Pharisee] prushem{prwSym}/H
porets{pryc}/H [m] [def: landowner] /Iish pritsem{prycym}/H
pornografye/S [f] [def: pornography]
	pornografish/A [def: pornographic] 
porske/V/T [def: snort] 
portativ/A [def: portable]
	portativkayt/N [f] [def: portability] 
portfel/N [m] [def: portfolio, document case]
portye'r/N [m?] [def: portiere] 
portret/N [m] [def: portrait]
portsela'n [n] [def: porcelain] portselayen/A
portsye/S [f] [def: portion] 
posek{pswk}/Xpsukem{pswkym}/H [def: verse of Bible]
	posekvayz [adv] [def: verse by verse] 
	psak{psk}/H [def: adjudication] 
	pasken{psken}/Vpaskenen{pskenen}/T [def: adjudicate]
poselenye [def: settlement (Russian)] 
posesye/S [f] [def: possession] 
poshet{pSwt}/H/K pshite{pSyt#}/H [def: simple]
	pashtes{pStwT}/H [def: simplicity] 
	pshat{pSt}/H [def: simple textual meaning] 
	pshetl{pStl} pshetlekh{pStlekh} [def: quibbling]
		pshetl{pStl}/V/T [def: quibble (with "zikh")] /Goys
poshline/S [f] [def: tax, dues] 
posl{pswl}/H [def: unfit]
	pasl{psl}/H/V/T [def: declare unfit] 
	poslen{pswlen}/H [def: unfit things (with "treyf-")]
posma'keve/V/T [def: smack the lips] 
	[idiom: posmakeven zikh mit epes = thoroughly enjoy something]
post/N [f/n] [def: mail] % MEYYED [f], Harduf [n]
	blitspost [f/n] [def: electronic mail]
		bli'tspostekhts/N [def: spam, junk email] [note: V]
	peklpost [f/n] [def: parcel post] % Harduf
	shleppost [f/n] [def: physical mail] 
	posilke/S/D [def: parcel (Russian)] 
postn/S [m] [def: soldier's position; job appointment]  
potakeve/V/T [def: keep consenting] 
potash [m] [def: potash (KOH)] 
potentsya'l/N [m] [def: potential] potentsye'l/A [def: potential] 
potkeve/S podkeve/S [f] [def: hoof; horseshoe]
	potkeve/V/T podkeve/V/T [def: nail a shoe]
	[idiom: dem ferds baytsh-shtekels potkeve = a distant relation]
pots [m] [def: penis (taboo)]
potshevke/S [f] [def: lining (clothing)] 
povidle/S [f] [def: prune jam (food)] 
po'vod [def: reins (horse)]
povyerene/S [def: attorney (Russian)] 
poye/V/T [def: give drink to (animals)] /Gon
poyer/N/Xpoyerem{poyerym}/D [m] /Iish /Ish poyerte/S [f] [def: peasant, jack (playing cards)]
poyk/V/T [def: drum] 
	tsepoyk/V/Btsepoykt [def: drum, hype] 
	poyk/N [f] [def: drum] /Dpayk
poyl{pw|el}/H/V/T [def: accomplish]  
	poyl{pw|el}/H [m] [def: result] /Lb
	poyl{pw|el}-yoytse{ywc#} /H [m] [def: result, upshot] /Lb
	pule{pewlh}/Xpules{pewlwT}/H [f] [def: effect]
poysek{pwsk}/Xpoyskem{pwskym} [def: Rabbinic authority] 
poyze/S [f] [def: pause] 
poyze/V/T [def: crawl] /Garayn
poze/S [f] [def: pose] 
	pozi'r/V/Bpozi'rt [def: pose] 
	puent-poze/S [f] [def: pointe (ballet)] [note: V]
pozesiv/A [def: possessive (grammar)] 
pozitiv/K [def: positive]
pozitsye/S [f] [def: position] 
/Xprakes [def: cabbage stuffed with rice and meat (food)] % only in plural
prakht [def: precious thing]
	prakhtful/A prekhtik/A prakhtik/A [def: precious] 
praktik praktish/A [def: practical]
	praktike/S [f] [def: medical practice]
	praktika'nt/N [m] praktika'ntke/S [f] [def: intern (student)] 
pral/V/T [def: open wide] /Garayn/Goyf/Goys/Goyf
prazeodimyum [m] [def: praseodymium (Pr)] 
prat{prt}/Xprotem{prtym}/H [m] [def: detail]
	protemdik{prtymdik}/A [def: detailed]
	protis{prtyT}/H [def: divine providence (with "hashgokhe -")] 
pratse/X [f] [def: toil]
	pratseve/V/T [def: toil] 
prave/V/T [def: celebrate] 
pravoslav/N [def: Greek Orthodox person]
	/In /Ine [def: Greek Orthodox]
	pravoslavye [f] [def: Greek Orthodoxy]
prays/N [m] [def: cockroach (animal)] 
prayz/N [m] [def: price, award] 
predik/V/T [def: preach] 
	prediker/S [m] [def: preacher] 
preferents/N [f] [def: preference] 
prefiks/N [m] [def: prefix] 
pregl/V/T [def: fry] /Goys
premye/S [f] [def: award] 
premye'r/N [m] premyershe/S [f] [def: prime minister] 
premyere/S [f] [def: premiere] 
	avanpremyere/S [f] [def: advance screening (film)] 
prepozitsye/S [f] [def: preposition (grammar)] 
prerye/S [f] [def: prairie] 
pres/V/T [def: press] /Goys
	prese [f] [def: press]
prestizh [m] [def: prestige] % Harduf
pretendi'r/V/Bpredendi'rt [def: pretend]
	pretenzye/S [f] [def: pretence, claim] 
	pretende'nt/N [m] [def: claimant] 
pretsede'nt/N [m] [def: precedent] 
	[idiom: on a pretsedent = unprecedented]
pretsept/N [def: precept] 
pretshmelyet/A [def: stupefied]
pretsl/Xpretslekh [n] [def: pretzel] 
pretsiz/A [def: precise]
	pretsizkayt/N [f] [def: precision] 
preydik/V/T predik/V/T [def: preach] 
	preydikung/N [f] predikung/N [f] [def: preaching] 
preygl/V/T [def: fry] /Gayn
preympl/V/T prepl/V/T [def: pray (non-Jewish) (pejorative)]
prezent/N [m] [def: present, gift] 
	prezenti'r/V/Bprezenti'rt [def: present] 
prezhenitse/S [def: omelet, scrambled eggs]
prezident/N [m] [def: president] /Iish [def: presidential] 
prikre/A [def: unpleasant] 
primadona/S [f] [def: prima donna] 
primiti'v/A [def: primitive]
prints/N [m] [def: prince] printsesin/S [f] [def: princess]
	pri'tseve/V/T [def: play prince; lord it] 
printsip/N [m] [def: principle] /Ial [m] [def: principal] 
priparke/S [def: hot bandage]
	[idiom: kalte priparkes = a punishment]
pripetshik/N [def: oven] 
prishtsh/Ees [m] [def: pimple] /Iik /D
pristav [n] [def: police commissioner (Russian)] 
privat/A [def: private]
	privatkayt/N [f] [def: privacy] 
	privatizi'r/V/Bprivatizi'rt [def: privatize] 
privilegye/S [f] [def: privilege] 
priz/N [m] [def: prize]
priziv [m] [def: draft (Russian army)]
	prizivnik/Ees [def: draftee] 
	[idiom: zikh tsushteln tsum priziv = enlist]
probe/S [f] [def: attempt, essay, probation] 
	klangprobe/S [f] [def: sound check] [note: V] 
	[idiom: zayn oyf probe = hobn probe = be on probation]
	[idiom: nemen/shteln oyf probe = put on probation]
	[idiom: extemporir-probe = improvizir-probe = jam session (music)] [note: V]
problem/N [f] [def: problem] /D
	problematish/A [def: problematic] 
produtsi'r/V/Bprodutsi'rt [def: produce]
	produtsirer/S [m] [def: producer] 
	produkt/N [m] [def: product]
		produktiv/A [def: productive]
		produktsye/S [f] [def: production] 
		reproduktsye/S [f] [def: reproduction] 
profesor/N [m] profesorin/S [f] [def: professor]
	profesye/S [f] [def: profession] 
	profesyonel/A [def: professional] /Iish
profi'l/N [m] [def: profile] % Harduf
profi't/N [m] [def: profit] % Harduf
	profiti'r/V/Bprofiti'rt [def: profiteer] 
prognoz/N [m] [def: forecast] 
	veter-prognoz/N [m] [def: weather forecast] 
program/N [f] [def: program]
	programke/S [f] [def: program (printed)] 
	programi'r/V/Bprogrami'rt [def: program] 
		programirer/S [m] [def: programmer] 
progres [m] [def: progress]
	progresi'r/V/Bprogresi'rt [def: progress] 
	/Iiv [def: progressive] 
proklami'r/V/Bproklami'rt [def: proclaim] 
	proklamatsye/S [f] [def: proclamation] 
prokuri'r/V/Bprokuri'rt [def: prosecute]
	prokurirung/N [f] [def: prosecution (act)] 
	prokuro'r/N [m] [def: prosecutor] 
	prokuratu'r [f] [def: prosecution (office); district attorney's office] 
proletarya't/N [m] [def: proletariat]
	proletaryer/X [m] [def: proletarian] 
	proletarish/A [def: proletarian] 
prolo'g/N [m] [def: prologue] 
promenade/S [f] [def: promenade (structure)]
prometyum [m] [def: promethium (Pm)] 
prominent/A [def: prominent] 
prono'm/N [m] [def: pronoun (grammar)] 
propagandi'r/V/Bpropagandi'rt [def: propagandize] 
	propagande/S [f] [def: propaganda] 
propagi'r/V/Bpropagi'rt [def: propagate] 
propn/S [m] [def: bottle stop, cork]
proponi'r/V/Bproponi'rt [def: propose] % Harduf
proportsye/S [f] [def: proportion]
	proportsyonel/A [def: proportional] 
	disproports/N [f] [def: disproportion] 
prose [f] [def: millet]
proshek/Xproshkes [m] [def: powder, medicine] 
	milkhproshek [m] [def: dehydrated milk] 
	proshe/V/T [def: sprinkle] farproshet/A [def: drugged] 
proshenye/S [def: petition (Russian)] 
prospe'kt/N [m] [def: pamphlet] 
prosperite't [f] [def: prosperity] % Harduf
prost/A [def: simple, unrefined, ordinary; tacky, vulgar]
	prostak/N prostnyak/N [m] [def: simple person] 
	prostkayt/N [f] [def: vulgarity] 
prostitutke/S [f] [def: prostitute] 
protaktinyum [m] [def: protactinium (Pa)] 
protagoni'st/N [m] protagonistke/S [f] [def: protagonist] 
protein/N [m] [def: protein (chemical)] 
protektsye [f] [def: patronage, pull, special influence] 
	protektora't/N [m] [def: protectorate] 
protesti'r/V/Bprotesti'rt [def: protest] 
	protest/N [m] [def: protest, formal complaint]
	protesta'nt/N [m] [def: Protestant] /Iish
protezhi'r/V/Bprotezhi'rt [def: promote, countenance, back] 
	protezhe [m] [def: protegée] 
protivlyave/V/Bprotivlyavet [def: oppose (Russian)] 
protokol/N [m] [def: protocol, summons] 
proton/N [def: proton] 
prototip/N [m] [def: prototype] 
protsedur/N [f] [def: procedure] 
protsent/X [m] [def: percent, interest]
	protsentnik/Ees [m] [def: usurer] 
protses/N [m] [def: court case; process] 
	protsesi'r/V/Bprotsesi'rt [def: process, try (a court case)]
	protsesirung/N [f] [def: processing] 
protsesye/S [f] [def: procession] 
provints/N [f] [def: province]
	provintsyalizm/N [m] [def: provincialism]
	provintsyel/A [def: provincial] 
provizorish/A [def: provisional, temporary] 
provotsi'r/V/Bprovotsi'rt [def: provoke]
	provokatsye/S [f] [def: provocation] 
	provokato'r/N [m] [def: informer (to the police); provocator]
provyant [m] [def: provisions] provizye
	aprovizatsye/S [f] [def: provisions] % Forwards
proye'kt{pro|yekt}/N [m] [def: project]
	forshproye'kt{forshpro|yekt}/N [m] [def: research project] 
proyektor{pro|yektor}/H/S [m] prozhektor/S [m] [def: projector]
proze [f] [def: prose]
	a'rblproze [f] [def: improvized speech (theater)] 
	fa'ktproze [f] [def: non-fiction] [note: V]
	folksproze [f] [def: prose of the people]
	takhles{WxlyT}-proze [f] [def: non-fiction] [note: V]
	prozaiker/S [m] [def: prose writer] prozaish/A [def: prosaic] 
	[idiom: hametne proze = boring prose]
prute{prwth}/Xprutes{prwtwT}/H [f] [def: small coin] 
pruv/V/T [def: try]
	/Goys [def: try out] 
	prubi'r/V/Bprubi'rt [def: try] /Goys
	probe/S [f] [def: test; attempt]
pyonir/N/Iish [m] [def: pioneer] 
pryoritet/N [f] [def: priority, right of way] 
psevdoni'm/N [m] [def: pseudonym] 
pshore{pSrh}/Xpshores{pSrwT}/H [f] [def: compromise, tradeoff]
	um|pshores|dik/A [def: uncompromising] 
psikhe{pTyHh}/Xpsikhes{pTyHwT}/H [f] [def: opening] 
psikholo'g/N [m] [def: psychologist]
	/Iish [def: psychological]
	psikhologye/S [f] [def: psychology] 
	psikhe [def: psyche]
		psikhik/A [def: psychic] 
	psikhoze/S [f] [def: psychosis] 
	parapsikhologye/S [f] [def: parapsychology]
		parapsikhologish/A [def: parapsychological] 
	psikhyatrye/S [f] [def: psychiatry] 
		psikhyater/S [m] [def: psychiatrist] 
pubertet/N [f] [def: puberty] 
publikatsye/S [f] [def: publication] 
	publikum [def: public] 
	publitsi'st/N [m] [def: publicist] 
	publiki'r/V/Bpubliki'rt [def: publish] 
pud/N [def: about 40 pounds (Russian)] 
puder/S [m] pudre/S [f] [def: powder (cosmetic)] 
	milkhpuder [m] [def: dehydrated milk] 
	puder/V/T [def: apply powder] 
puding/N [m] [def: pudding] % Harduf
pudl/N [m] [def: poodle (dog)] % Harduf
pukh [m] [def: feather down] /Iik /Iove /In [def: feather down] 
pulke/S polke/S [f] [def: thigh] 
pulpit/N [m] [def: pulpit] % Harduf
puls/N [m] [def: pulse] pulsi'r/V/Bpulsi'rt [def: pulsate] 
pulver/S [m] [def: powder] 
	pulverizi'r/V/Bpulverizi'rt [def: reduce to powder, atomize (convert to mist)] 
punkt/N [m] [def: point, exactly]
	punkti'r/V/Bpunkti'rt [def: dot, punctuate] 
	punkt [adv] [def: just, exactly] 
	pinktlekh/A [def: exact] umpinktlekh/A [def: vague] 
	pinktlekhkayt/N [f] [def: exactitude] umpinktlekhkayt/N [f] [def: vagueness] 
	dreypunkt/N [m] [def: pivot] 
	hoykhpunkt/N [m] [def: summit] 
	shtandpunkt/N [m] [def: standpoint]
pupik/Ees/D [m] [def: belly button (body part); gizzard (food)] 
	pempik/N/D [m] [def: belly button; gizzard; chubby lad] 
	[idiom: Moyshe{mSh} pupik = John Doe (humorous)]
purim{pwrym}/H [m] [def: holiday of Purim] /Idik [def: Purim-like] 
puristish/A [def: purist] 
purken{pwrkn}/H [def: redemption] 
purpur /In [m] [def: purple] 
	purpl [m] [def: purple] % Harduf
pushke/S [f] [def: can, charity box] 
pushta'k/Ees [m] [def: hollow nut; dud] 
pust/A [def: empty] pustkayt/N [f] [def: emptiness] 
	pu'stenish/N [f] [def: wasteland] 
	pustsha'k/Ees [m] [def: empty nutshell; shallow person] 
puter [f] [def: butter] /Idik [def: buttery] 
	[idiom: geyn mit der puter arop = suffer misfortune]
puts/V/T [def: clean] /Garayn/Gop/Goys/Gtsu
	baputs/V/Bbaputst [def: clean] baputsung/N [f] [def: cleaning] 
	farputs/V/Bfarputst [def: clean] 
	putser/S [m] putserke/S [f] [def: cleaner]
	shikhputser/S [m] [def: shoe-shine person] 
pyane/S [f] pyano/S [f] [def: piano]
	pyani'st/N [m] pyanistke/S [f] [def: pianist] 
pyate/S [def: ball of foot] 
	[idiom: akhiles-pyate = Achilles heel]
pyavke/S [f] [def: leech]
pyese/S [f] [def: drama] 
pyeshtshe/V/T [def: spoil, dote on]
pyeze/S [def: play (drama)] 
rabi'r/V/Brabi'rt [def: rob] 
radika'l/N [m] [def: radical] /A
radon [m] [def: radon (Rn)] 
radyo/S [m] [def: radio] 
radyum [m] [def: radium (Ra)] 
radyus/N [m] [def: radius] 
rafini'r/V/Brafini'rt [def: refine] 
rahetsh [m] [def: device made from a wooden pole and a two-pronged metal holder for removing a pot from an oven (Ukrainian)]
rak [m] [def: cancer; crayfish; crustacean] /D
rak_{rk}/H [def: only]
rakete/S [f] [def: rocket] 
rakhash{rH"S} [n] [def: fee for religious service such as matchmaking] 
	[note: from "rov, khazn, shames"]
rakhmone{rHmn#}/Xrakhmones{rHmnwT}/H [f] [def: mercy, pity]
	/Idik [def: merciful] 
	rakhomem{rHmym}/H [def: merciful people]
	umberakhmonesdik{umbrHmnwTdik}/A [def: unmerciful] 
	merakhem{mrHm}/H [def: show mercy (with "zayn")] 
	[idiom: mir iz a rakhmones{rHmnwT} oyf = my heart goes out to]
rakhves{rHBwT}/H [def: breadth] /Idik [def: broad, spacious] 
ram/V/T [def: clean (house)] /Goyf
	ramerin/S [f] [def: house cleaner]
ramsh/N/Ees [def: junk, odds and ends] /D
rand/N [m] [def: edge]
	/Drend [def: coin]
	[idiom: a rendl arop, a rendl aroyf = you win some, you lose some]
randke/S [f] [def: date (social)] 
	randkeve/V/T [def: date (social, with "zikh ... mit")] 
rang/N [m] [def: rank; rating] /Iik
	hoykhrangik/A [def: high-ranking] % Forwards
rangl/V/T [def: fight]
	gerangl/N [n] [def: struggle] ra'nglenish/N
rane/V/T ranye/V/T [def: wound] 
	rani'r/V/Brani'rt [def: wound] [usage: doubtful admissability]
raptum [def: suddenly (Polish)] raptem % both variants
rase/Xrasn/Xrases [f] [def: race] 
rash{reS}/H/N/Iik [def: commotion]
	rash{reS}/H/V/T [def: make a commotion] 
	far|rash|/V/Bfar|rash|t [def: surprise] 
	iberrash/V/Biberrasht [def: surprise]
		iberrashung/N [f] [def: surprise] 
rat/V/Bgerotn [def: advise] /Gop
	rot/V/Bgerotn [def: advise] % variant
	rot/N [m] [def: council]
		rotgeber/S [m] rotgeberin/S [f] [def: advisor] 
	reter/S [m] [def: advisor] retung/N [f] [def: advice]
	barat/V/Bbarotn [def: consult (with "mit")] 
		baratung/N [f] [def: consultation, suggestion] 
		[idiom: oyfn barot fun emetsn = at one's mercy]
	farrat/V/Bfarrotn [def: betray] farreter/S [m] farrater/S [def: traitor] 
		farraterish/A [def: treasonous; treacherous] 
	landshulnrat [def: school council] 
	veltrat [def: world council]
	yudnrat [def: Jewish council]
rate/S [f] [def: premium, part payment, installment] 
rateve/V/T [def: rescue] /Garoys/Gop
	ratever/S [m] ratirer/S [m] [def: rescuer, lifeguard] 
rats/N/D [m] [def: rat] 
ratsik/A [def: rough] 
rayb/V/Bgeribn [def: grate] /Goys/Gop/Goys/Gayn/Gon
	tserayb/V/Btseribn [def: grate] 
raye{ra|yh}/Xrayes{raywT}/H [f] [def: proof]
	[idiom: an ayzerne raye{ra|yh} l|dover{dBr} = smoking gun] [note: V]
rayf/K [def: ripe] rayfkayt/N [f] [def: ripeness] 
raykh/K [def: rich, wealthy] raykhkayt/N [f] [def: wealth] 
	baraykher/V/Bbaraykhert [def: enrich]
		baraykherung/N [f] [def: enrichment] 
	aynflusraykh/K [def: influential] 
	derfolgraykh/A [def: successful]
	glorraykh/A [def: glorious] 
	tsolraykh/A [def: frequent; many] [usage: doubtful admissability]
rayon{ra|yon}/N [m] regyon/N /Iel [def: region]
rayon_{re|ywn}/H rayones{re|ywnwT}/H [def: imagination] 
rays/V/Bgerisn [def: pull]
	/Goys/Garayn/Garoys/Garum/Gon/Gop/Gdurkh/Giber/Gmit/Gavek/Garop
	/Giber [def: interrupt] 
	/Gayn [def: budge] 
	/Garunter [def: tear down, belittle] 
	/Goyf [def: explode] 
	[idiom: aynraysn veltn = move heaven and earth]
	tserays/V/Btserisn [def: tear, rip]
	farrays/V/Bfarrisn [def: tear]
		farrisnkayt/N [f] [def: state of being torn] 
	hartsraysndik/A [def: heart-rending] 
	iberrays/N [m] [def: interruption]
	oyfrays/N [m] [def: explosion] 
	rayser/S [m] [def: ripper, yanker] 
	ris/N [m] [def: rip, gap, yank] 
		ayngerist/A [def: filthy] % perhaps from a different root
	[idiom: ris in a zayt = swerve]
	[idiom: ris in hartsn = a great pity]
	[idiom: ris oyf = start]
rayt/V/Bgeritn [def: ride] /Garayn/Garum/Gavek
	rayter/S [m] rayterin/S [f] [def: rider] 
	riter/S [m] [def: knight] 
rayz [m] [def: rice] 
rayze/S [f] [def: voyage] 
	rayznder/X [m] [def: (merchant) voyager] 
razberaye/V/T [def: understand, comprehend a problem (Russian)] 
reagi'r/V/Breagi'rt [def: react]
	reaktsye/S [f] [def: reaction] 
rea'l/A [def: real, actual]
	/Iistish [def: realistic]
	realizirung/N [f] [def: realization, actualization] 
	realitet/N [f] realkayt/N [f] [def: reality]
		umrealkayt/N [f] [def: unreality] 
	realizm/N [m] [def: realism]
	umreal/A [def: unreal] 
rebeli'r/V/Brebeli'rt [def: rebel] 
red/V/T [def: speak]/Garop/Garoys/Gon % variant: reyd/V
	/Gtsu/Garayn/Goys/Garum/Gfunander/Goyf/Gunter
	/Giber [def: reconcile]
	/Gop [def: preclude] 
	/Gayn [def: convince] 
	/Gtsurik [def: retract (statement)] 
		[idiom: ober tsurikgeredt = on the other hand]
	/Gdurkh [def: discuss (with "zikh")] 
	aynre'denish/N [n] [def: misconception, delusion, idée fixe] 
	reder/S [m] rederin/S [f] [def: speaker]
		redner/S [m] rednerin/S [f] [def: speaker]
		gastredner/S [m] [def: guest speaker] 
	redevdik/A [def: talkative] 
	rede/S [f] [def: speech]
		forrede/S [f] [def: introduction]
	reyd [f] [def: speech]
		aroysreyd oysreyd [def: speech] 
		[idiom: hobn in zikh nayn mos reyd = be talkative]
		[idiom: puste reyd = nonsense]
	farred/V/Bfarredt [def: disturb]
	bared/V/Bbaredt [def: slander, backbite]
		baredevdik/A [def: slanderous] 
	tsered/V/Btseredt [def: talk for a while (with "zikh")] 
	derred/V/Bderredt [def: reach an understanding (with "zikh")] 
		derredtkayt/N [f] [def: inconclusiveness] 
	[idiom: derredn zikh tsu = come to the conclusion (in conversation)]
	gered [n] geredekhts [n] [def: talk] 
	[idiom: kumen tsu red = be under discussion]
redagi'r/V/Bredagi'rt [def: edit] /Goys
	redaktor/S/N [m] redaktorin/S [f] [def: editor]
	redaktsye/S [f] [def: editorial staff] 
referi'r/V/Breferi'rt [def: give a lecture] 
	refera't/N [m] [def: lecture; scholarly paper] 
	refere'nts/N [f] [def: reference] 
reflekti'r/V/Breflekti'rt [def: reflect] 
reform/N [f] [def: reform] /Iish [def: reform]
	reformi'r/V/Breformi'rt [def: reform]
	reformirer/S [m] [def: reformer] 
	reformer/S [m] reformi'st/N [m] [def: member of reform sect] 
refreyn/S [m] [def: refrain] 
reftl/Eekh [n] [def: slice, first cut] 
reg/V/T [def: trouble] /Goyf [def: annoy] /Gon
	oyfregung/N [f] [def: annoyance] 
rege{rge}/H [def: moment, second (unit of time)] 
regiles{rgylwT}/H/N [def: custom]
regi'r/V/Bregi'rt [def: rule] 
	regirung/N [f] [def: government]
	regirungs [adj] [def: governmental] [grammar: indeclinable]
	reglame'nt/N [m] regulami'n/N [m] [def: regulation] 
		reglamenti'r/V/Breglamenti'rt [def: regulate] 
registratsye/S [f] [def: registration]
	registri'r/V/Bregistri'rt [def: register] 
	farregistri'r/V/Bfarregistri'rt [def: pre-register] 
regl{rgl}/H [def: pilgrimage holiday] regolem{rglym}/H
regn/S/Dregnd [m] [def: rain] /Idik [def: rainy]
	regn/V/T [def: rain] 
reguli'r/V/Breguli'rt [def: regulate] /Gayn
	reguler/A [def: regular]
	harts-regulirer/S [m] [def: pacemaker] 
	regulatsye/S [f] [def: regulation] 
rehabiliti'r/V/Brehabiliti'rt [def: rehabilitate] 
rekhiles{rxylwT}/H [def: malicious gossip] 
rekhn/V/T [def: calculate, plan] /Garayn/Goys/Gop/Giber/Gtsunoyf
	barekhn/V/Bbarekhnt [def: calculate, consider; change one's mind (with
	"zikh")]
	farrekhn/V/Bfarrekhnt [def: account] 
	rekhenung/N [f] [def: accounting; arithmetic] 
		aroprekhenung/N [f] [def: discount] 
		farrekhenung/N [f] [def: payment] 
		finger-rekhenung/N [f] [def: counting on fingers] 
	[idiom: dos rekhnt zikh nit = that doesn't count!]
rekht/N [n] [def: right (privilege)]
	rekht/A [def: right (direction)]
		rekhts [def: right (direction)] 
	gere'kht/A [def: correct, right] [usage: of a person]
		umgerekht/A [def: wrong] [usage: of a person]
		gerekhtikayt/N [f] [def: correctness; justice] 
		[idiom: gerekht iz gerekht = when you're right, you're right]
	barekhtik/V/Bbarekhtikt [def: justify]
		barekhtikung/N [f] [def: justification]
			glaykhbarekhtikung/N [f] [def: equal rights] 
				glaykhbarekhtikt/A [def: equally justified] 
		barekhtiktkayt/N [f] [def: justifiability] 
		[idiom: barekhtikt tsu = entitled]
	tsurekht [def: in order] 
		[idiom: tsurekht makhn = fix]
	mentshnrekht [n] [def: human rights]
	shtimrekht [n] [def: voting rights]
	drukrekht [n] [def: imprimatur; copyright]
	postnrekht [n] [def: tenure] 
	umrekht [n] [def: wrong, injustice] 
	vetorekht [n] [def: veto power] 
rekl/N [n] [def: jacket (clothing)] 
reklami'r/V/Breklami'rt [def: advertise] 
	reklame/S [f] [def: advertisement] 
rekomendi'r/V/Brekomendi'rt [def: recommend] 
	rekomendatsye/S [f] [def: recommendation]
rekordi'r/V/Brekordi'rt [def: record]
	rekord/N [m] [def: record] 
	rekordirke/S [f] [def: recorder (machine)]
rekrut/N [m] [def: recruitment] 
	[idiom: zikh tsushteln tsum rekrut = enlist]
rekvizi'r/V/Brekvizi'rt [def: requisition] 
	rekvizit/N [def: prop (theater)]
relativ/A [def: relative]
	relativkayt/N [f] relativitet [f] [def: relativity] 
religye/S [f] [def: religion] /Iz [def: religious] 
rels/N [m] [def: rail] 
rem/V/T /Gayn [def: border]
rematn [m] [def: rheumatism]
remez{rmz}/Xremozem{rmzym}/H [def: hint, allegory]
	meramez{mrmz}/H [def: hint (with "zayn")] 
remi{rmy}/H [def: tie (outcome of contest)] 
remont/N [def: remodeling] 
	remonti'r/V/Bremonti'rt [def: remodel, repair]
renesans/N [m] [def: renaissance] 
renovi'r/V/Brenovir't [def: renovate] 
rentsl/Eekh [n] [def: satchel] % no positive form
renyum [m] [def: rhenium (Re)] 
repari'r/V/Brepari'rt [def: make amends]
	reparatsye/S [f] [def: reparation] 
repertuar/N [m] [def: repertoire] 
repetitsye/S [f] [def: rehearsal]
reportazh [def: reportage] 
represiv/A [def: repressive] 
reprezentant/N [m] [def: representative]
	reprezentatsye/S [m] [def: representation]
	reprezenta'nts/N [m] [def: leadership] 
republik/N [f] [def: republic]
	folksrepublik/N [f] [def: people's republic]
	republikaner [adj] republikanish/A [def: Republican (political party)] 
reshime{rSymh}/Xreshimes{rSymwT}/H [def: list] 
reshodke/S [f] [def: barbeque grill] 
resht/N/D [def: rest, remainder, excess]
reshus{rSwT}/H [m] [def: permission, ownership] 
respekt [m] [def: respect (honor)] 
	umrespekt [m] [def: disrespect] 
restoran/N [m] [def: restaurant] 
resurs/N [m] [def: resource] 
retekh [m] [def: radish] 
re'tenish/N [n] [def: puzzle] 
retorik [f] [def: rhetoric (subject)] retorish/A [def: rhetorical] 
retsenzye/S [f] [def: review] 
retsept/N [m] [def: recipe, prescription] 
retsesi'v/A [def: recessive (genetic trait)] [note: V]
retsikhe{rcyHh}/H [f] [def: murderousness] /Idik
retsiti'r/V/Bretsiti'rt [def: recite]
	retsitatsye/S [f] [def: recitation] 
retshke [f] [def: buckwheat] retshn/A [def: buckwheat]
revantshistish/A [def: revisionist] 
reve/V/T [def: roar, howl]
revekh{rvH}/Xrevokhem{rvHym}/H [def: profit] 
reverants [def: curtsey] 
revidi'r/V/Brevidi'rt [def: review, inspect, audit] 
	revizor/N [m] revizorshe/S [f] [def: inspector, auditor] 
	revizye/S [f] [def: revision, house search, audit] 
revir/N [m] [def: precinct] 
revolti'r/V/Brevolti'rt [def: revolt] 
	revolutsye/S [f] [def: revolution]
	revolutsyone'r/S [m] /A revolutsyonerke/S [f] [def: revolutionary]
revolver/N [m] [def: revolver] 
revyu/N [def: burlesque] 
rey/N [f] reye/S [def: row, turn (at a game)] 
reyekh{ryH}/Xreykhes{ryHwT}/H [m] [def: smell]
reyf/N [m/f] [def: tire] /D [def: ring] 
	[idiom: geplatster reyf = flat tire]
reykher/V/T [def: smoke] /Gon/Goys
	farreykher/V/Bfarreykhert [def: smoke] 
	roykh/N [m] [def: smoke] 
reynik/V/T [def: purify] /Gop
	reyn/K [def: pure, clean]
		reynkayt/N [f] reynikayt/N [f] [def: purity, cleanliness] 
	umreyn/K [def: impure, dirty]
		umreynkayt/N [f] umreynikayt/N [f] [def: impurity, uncleanliness] 
	farumreynik/V/Bfarumreynikt [def: taint, dirty] 
reysh [m/f] [def: letter Reysh] 
/Xreytuzn [def: jodhpurs, tights (undergarment; clothing)] 
reyts/V/T [def: annoy, tease (with "zikh mit"); attract (sexually); tear]
	/Gon/Goyf
	tsereyts/V/Btsereytst [def: tear up] 
reyvekh{rBH}/H [def: increase] 
rezervi'r/V/Brezervi'rt [def: reserve] 
	rezervuar/N [m] [def: reservoir] 
	rezer'v/N [m] [def: backup (in case of failure)] 
		rezervpekl/Eekh [def: spare packet] 
	rezervatsye/S [f] [def: condition, provision; rezervation (thought)] 
	[idiom: general in rezerv = rear General ??]
rezhim/N [m] [def: regime]
rezhisi'r/V/Brezhisi'rt [def: direct] /Goys
	rezhisor/N [m] [def: director]
	rezhi [f] [def: direction] 
rezigni'r/V/Brezigni'rt [def: resign oneself (with "zikh"); be calm (with "zikh"); abdicate] 
rezolutsye/S [f] [def: resolution]
rezultat/N [m] [def: result]
	gruntrezultat/N [m] [def: primary result] 
ridikyul/N [m] [def: reticule, handbag, purse]
rifs [def: reps (a corduroy-like material)] /Ien
rigl/V/T [def: lock, bolt] 
	farrigl/V/Bfarriglt [def: lock] 
	rigl/N [m] [def: bolt] 
rikht/V/T [def: judge, expect (with "zikh oyf")] /Goys/Gtsu/Goyf
	/Gayn [def: soil] 
	/Gop [def: expect, celebrate]
	[idiom: oprikhtn goles = go on spiritual wanderings]
	/Iik [def: right, correct] [usage: not applied to people]
		rikhtikayt/N [f] [def: correctness] 
	oy'frikhtik/A [def: honest, in good faith] 
		oy'frikhtikayt/N [f] [def: honesty, good faith] 
	rikhter/S [m] [def: judge] 
	umgerikht/A [def: unexpected]
		umgerikhterheyt [adv] [def: unexpectedly] 
	farrikht/V/Bfarrikht/Bfarrokhtn [def: fix, repair, correct]
		farrikhtik/V/Bfarrikhtikt [def: fix, repair, correct] 
	rikht/N geri'kht/N [def: court]
	barikht/N [m] [def: report, account]
	oprikhtung/N [f] [def: celebration, expecttation]
	aynrikhtung/N [f] [def: soil]
	rikhtung/N [f] [def: direction] 
rim [m] [def: rubble, debris] % no plural
rimen/S [m] rimet/N [m] [def: strap, belt]] 
	hoyznrimen/S [m] [def: trouser belt] 
rin/V/Bgerunen [def: run]
	/Goys [def: diminish] 
	antrin/V/Bantrunen [def: run away] 
	tserin/V/Btserunen [def: run apart] 
	rine/S [f] rinve/S [f] [def: gutter]
		tsamrine [f] [def: border gutter]
rind/Xrinder [def: cow/ox] rindern/A [def: beef]
ringl/V/T [def: surround] /Garum
	ring/N/D [m] [def: ring]
		dimentring/N/D [m] [def: diamond ring] 
rip/N [f] [def: rib] 
	[idiom: arayntsuzogn emetsn in der zibeter rip arayn = make a cutting comment]
rir/V/T [def: move (with "zikh")]
	/Gtsu/Goyf
	/Gon [def: touch] 
	bari'r/V/Bbari'rt [def: touch, mention (a problem)]
		barirung/N [f] [def: contact] 
	umbarirt/A [def: untouched] 
	rirevdik/A [def: touching]
rishen{r#Swn}/H [def: first, early sage] rishoynem{r#Swnym}/H
rishtevanye/S [f] [def: scaffold] 
ritem/Xritmen [m] [def: rhythm]
ritshe/V/T [def: yell] 
	tseritshe/V/Btseritshet [def: yell] 
ritshke/S [f] [def: stream, creek] /D
ritua'l/N [m] [def: ritual] 
riv/N [m] [def: drainpipe; culvert] 
riz/N [m] [def: giant, ream (paper)] /Iik/Iedik [def: giant] 
riziki'r/V/Briziki'rt [def: risk]
	rizikant/N [m] [def: risk-taker] 
	rizikalish/A [def: foolhardy] 
rizl/V/T [def: trickle; gurgle] 
	rizldik/A [def: trickling; gurgling] 
rob/N [m] [def: raven (bird); wren (bird)] 
rod/Xreder [f] [def: wheel] /Dred [def: group, dial]
	redlekhvayz [adv] [def: in small groups]
	redl/V/T [def: roll, dial] 
	tseynrod/Xtseynreder [f] [def: gear (mechanical)] 
rodyum [m] [def: rhodium (Rh)] 
roe{reh}/H roes{rewT}/H [def: wild, evil] 
rog/N [m] [def: (street) corner] 
rogozhe/S [f] [def: straw mat] 
rov_{rwB}/H [def: most] /Ll
	rabem{rbym}/H [def: majority]
rok/N [m] /Drek [def: suit coat, robe]
	shlofrok/N [m] [def: morning gown, bathrobe] 
role/Xroln [f] [def: rôle] 
	rol/N [f] [def: rôle] [usage: doubtful admissability]
	hoyptroli'st/N [m] hoyptrolistke/S [f] [def: star (of a performance)] 
	[idiom: dos shpilt nit keyn role = that doesn't count!]
rom/N [f] [def: frame] /Drem
	ayngeramt/A [def: framed] 
roman/N [m] [def: novel] /Itish [def: romantic] 
	romantitsizm/N [m] [def: romanticism] 
	neoromantish/A [def: neoromantic] 
ror/N [m] [def: reed, cane] 
	rer/N [f/m] [def: pipe, tube] /Indik
		/D [n] [def: telephone receiver] 
	moylrerl/Eekh [n] [def: gargoyle/downspout] [note: V]
rosh{roS}/H [def: head] /Lb [def: at the head] 
	reyshes{r#SyT}/H [def: beginning]
		/Lb [def: at first, book of Genesis]
		b|reyshes|dik/A [def: pertaining to Genesis] 
		[idiom: reyshes khokhme = first of all]
	rosheteyves{roSy-WyBwT}/H/N [def: abbreviation] 
roshe{rSe}/H reshoyem{rSe|ym}/H [def: evil] 
	rishes{rySewT}/H [def: evil] /Idik [def: evil] 
rosheshone{r#S-hSnh}/H [m] [def: Jewish New Year] 
roshtshine/V/T [def: let bread rise]
	roshtshene [f] [def: leaven]
rosl [m] [def: broth; brine]
rot/V/Bgerotn /Goys [def: eradicate] 
rote/S [f] [def: company (military)] 
rots [def: snot] farrotst/A [def: snotty] 
rotsn{rcwn}/H [def: desire] 
rouy{r#wy}/H [adj] [def: deserving]
rov/N [m] [def: ditch] 
rov{rB}/H [m] [def: Rabbi] /Lh
	reb/H [m] [def: Mr.] % not spelled Hebraically
	reboyne{rbwnw}/H [def: master (with "- shel oylem", of the world)] 
	rabeynu{rbynw}/H [def: our master]
	rabon{rbn}/Xrabonem{rbnym}/H [m] [def: Rabbi] /Iish [def: Rabbinic]
	rebe{rby}/Xrebeyem{rbeym}/H/C/J [m] [def: Rabbi]
		rebenyu{rbynyu} [def: dear Rabbi] 
		rebn{rbyn} [def: Rabbi (dative form)]
		rebitsin{rbycyn} [f] [def: Rabbi's wife] 
	rabiner/S [m] [def: Rabbi (Reform)] /Iish [def: Rabbinic] 
		rabinerte/S [f] rabinerin/S [f] [def: Rabbi] 
	[idiom: eyner hot lib dem rebn, un der anderer di rebitsin{rbycyn} = everyone to his own tastes]
roy/A [def: raw]
royb/V/T [def: rob] /Gavek/Gtsu
	royb [m] [def: booty, spoils, loot, prey]
	royber/S [m] [def: robber]
	barabeve/V/Bbarabevet [def: rob] 
	baroyb/V/Bbaroybt [def: rob] 
roydef{rwdf}/H/V/T [def: pursue]
	roydef{rwdf}/H [def: pursuer, persecutor] rodfem{rwdfym}/H
	redife{rdyfh}/H redifes{rdyfwT}/H [def: pursuit, persecution] 
roye/V/T [def: swarm, teem, hover, seek among items (with "zikh")] 
royfe{rwf#}/H [m] [def: healer] 
	refue{rfw#h}/H refues{rfw#wT}/H [def: cure] 
	veytik-refue{rfw#h} [def: painkiller] 
	[idiom: nit oyf a refue = not at all]
roygez{rwgz}/H [def: anger]
	b|roygez{rwgz}/H/A [def: angry] 
roym/V/T [def: clean] /Gayn/Gtsu/Gop/Goys/Goyf/Garum
	ram/V/T [def: clean] % variant
roym/N [m] [def: room; space]
	himlroym/N [m] [def: outer space] 
roysh/V/T [def: make a commotion] /Gdurkh
	geroysh/N [n] [def: (faint) noise] 
	royshik/A [def: noisy] 
	roy'shenish/N [n] roysheray'/N [n] [def: enthusiasm, excitement] 
	tseroysh/V/Btseroysht [def: create excitement (with "zikh", "es")] 
royshem{rwSm}/H [m] [def: impact, impression] /Idik
royt/A /Ilekh /Iink [def: red]
	royts [n] [def: hearts (playing cards)] % no plural?
	roytkayt/N [f] [def: redness] 
	roytl/V/T [def: become red (with "zikh")] 
roytseyekh{rwcH}/Xrotskhem{rwcHym}/H [m] [def: murderer] /Iish
	tirtsakh{WrcH}/H [def: you shall (not) murder] 
	retsikhe{rcyHh}/Xretsikhes{rcyHwT}/H [f] [def: murderous intent]
royz/N [f] [def: rose]
	rozik/A [def: rosy] 
	rozeve/A [def: pink, whole-wheat]
	ga'rtlroyz [f] [def: shingles (disease)]
	zunroyz/N [f] [def: sunflower]
rozhdestve [def: Christmas (Russian)] 
rozhinke/S [f] [def: raisen] 
ru/V/T [def: rest] /Gop/Goys
	baruik/V/Bbaruikt [def: calm] 
	baumruik/V/Bbaumruikt [def: disquiet]
	ruik/A ruikayt [f] ru [f] tsuru [def: peace]
	umruik/A umruikayt/N [f] umru [f/m] [def: disquiet]
	opru/N [m] [def: rest] 
rubidyum [m] [def: rubidium (Rb)] 
rubl/N [m] [def: ruble (currency)] 
rubrik/N [def: rubric] 
ruder/V/T [def: rumble, trouble, row (boat)] /Goyf
	tseruder/V/Btserudert [def: confuse]
	geruder/S [n] [def: commotion, tumult]
	oyfruderung/N [f] [def: commotion] 
	ruder/N [m] [def: oar] 
ruekh{rwH}/Xrukhes{rwHwT}/H [m] [def: spirit, ghost, devil]
	[idiom: tsu aldi rukhes = damn it all]
	[idiom: a ruekh{rwH} in dayn tatns tatn arayn = damn you]
	rukhniyes{rwHnywT}/H [def: spiritual] /Idik [def: spiritual]
		/Lb [def: spiritual] 
ruf/V/Bgerufn [def: call]
	/Gon/Garoys/Goyf/Goys/Gtsu/Gtsurik/Gtsuzamen/Garayn/Gnokh/Gavek/Gtsunoyf
	/Gop [def: cancel, postpone, respond, influence (with "zikh oyf")] 
	baruf/V/Bbarufn [def: assign a job] 
	onruf/N/D [m] [def: call]
	aroysruf [m] [def: call out]
		aroysru'fenish/N [def: calling out] 
	opruf/N [m] [def: call] 
	oysruf/N [m] [def: call]
	oyfruf/N [m] [def: summons, groom's Torah call-up before wedding]
	farruf/V/Bfarruft [def: call, cite (with "zikh oyf")] 
	hilfsruf/N [m] [def: call for help]
	hornruf/N [m] [def: horn call] 
	yugntruf [m] [def: Yugntruf-Youth for Yiddish]
		yugntrufnik/Ees [m] yugntrufi'st/N [m] [def: member of Yugntruf]
ruini'r/V/Bruini'rt [def: ruin]
	rui'n/N [f/m] ruinirung/N [f] [def: ruin] 
ruk/V/T [def: turn away] /Garop/Garoyf/Garoys/Gop/Gon/Garayn/Giber/Gtsu
	/Gfunander/Gunter/Garunter
	/Gforoys [def: advance]
	farruk/V/Bfarrukt [def: turn] 
	tserukt/A [def: turn] 
	rukn/S [m] [def: back] 
		bargrukn/S [m] [def: mountain ridge] 
	tsurik [adv] tsuriket [adv] krik [adv] [def: back]
	[idiom: a vokh gerukt = a week apart]
ruml [def: old goods]
	[idiom: tsum ruml = into the bargain; add insult to injury]
rund/A [def: round] [usage: inadmissable]
runde/S [f] [def: round (of voting or a game)] 
runtsl/V/T [def: wrinkle; ripple (with "zikh")]
	runtsl/N [m/n] [def: wrinkle] 
	tseruntsl/V/Btseruntslt [def: wrinkle] 
rute/S [f] [def: route] 
rutenyum [m] [def: ruthenium (Ru)] 
ruterfordyum [m] [def: rutherfordium (Rf)] 
rutin/N [f] [def: routine (English)] 
sablye/S [f] [def: saber (weapon)] 
sabotazh/N [m] [def: sabotage]
	sabotazhnik/Ees [m] [def: saboteur] 
	saboti'r/V/Bsaboti'rt [def: sabotage] 
sadi'st/N [m] [def: sadist] /Iish [def: sadistic] 
sagenoer{sgy-nhwr}/H [m] [def: blind person] 
sakh{sx}/H [def: many, sum] /Lb
	sakhakl{sx-hKl}/H [def: total, summary] /Lb [def: totaling] 
sakhari'n [m] [def: saccharine (chemical)] % Harduf
sakone{sKnh}/Xsakones{sKnwT}/H [f] [def: danger] /Idik
	sakonas{sKnT}/H [def: danger of] 
	mesukn{mswKn}/H [def: dangerously] /Idik
		khoyle{Hwlh}-mesukn{mswKn} [def: dangerously ill person] 
saksofo'n/N [m] [def: saxophone] % Harduf
sakve/S [f] [def: sack] 
salat/N [m] [def: salad]
sale/S [def: parlor] salon/N [m] salke/S [def: room]
	zal/N [m] [def: hall, auditorium]
		gerikhtzal/N [m] [def: courtroom] 
salu't/N [m] [def: salute] % Harduf
	saluti'r/V/Bsaluti'rt [def: salute]  % Harduf
sam{sm}/H [m] [def: poison] /Iik [def: poisonous, toxic] 
	sam{sm}/V/T [def: poison]
	farsam{farsm}/V/Bfarsamt{farsmt} [def: poison]
	farsamung{farsmung}/N [f] [def: poisoning] 
		mogn-farsamung{farsmung}/N [f] [def: food poisoning] 
samaryum [m] [def: samarium (Sm)] 
same/A [def: complete]
samekh{sʼ}/H [m/f] [def: Hebrew letter Samekh] 
samet [m] [def: velvet] /In [def: velvet] 
samogon/N [m?] [def: home-brew (liquor)] 
samovar/S [m] [def: samovar] 
sanatorye/S [m] [def: sanatorium] 
sandal/N [m] [def: sandal] 
sandek{sndk}/Xsandkoes{sndk#wT}/H [def: Sandek (holds child during ritual circumcision)] 
sanitar/N [m] sanitarin/S [f] [def: cleaning person] 
sanktsye/S [f] [def: sanction] 
sape/V/T [def: gasp]
	farsapet/A [def: gasping]
sara [def: such (= vos far a)] 
sardin/N [m] [def: sardine] 
sarkazm [m] [def: sarcasm] sarkastish/A [def: sarcastic] 
sarver/S [m] [def: waiter] 
satelit/N [m] [def: satellite] 
satire/S [f] [def: satire ] satirish/A [def: satirical] 
satisfaktsye/S [f] [def: satisfaction; revenge] 
	[idiom: fodern satisfaktsye = challenge to a duel]
	[idiom: gebn satisfaktsye = duel]
satmer /Eer [def: Satmar (Chassidim)] 
saus/N [m] [def: sauce, dressing] 
savlones{sBlnwT} [f] [def: patience] 
savule/S [def: ??] % a khalyastre fun savules un fun gontses
say [def: both] 
	[idiom: say vi (say) = in any case]
saydn [def: unless] 
sazhe/S [f] [def: soot; lamp-black] 
sazhen/Xsazhenyes [m] [def: fathom (Russian)] 
sekretar/N [m] sekretarin/S [f] sekretarzhe/S [f] [def: secretary]
	sekrete'r [def: desk] 
seks [m] [def: (matters of) sex] /Iue'l
	homoseksue'l/A [def: homosexual]
		homoseksua'l/N homoseksuali'st/N [m] [def: homosexual]
		homoseksuali'zm/N [m] [def: homosexuality]
sekte/S [f] [def: sect]
	sekta'nt/N [def: sectarian] /Iish [def: sectarian]
		umsektantish/A [def: non-denominational] 
	sektor/N [m] [def: sector]
	sektsye/S [f] [def: section] 
sekunde/S [f] [def: second (unit of time)] 
	sek' [def: second (unit of time; abbreviation)]
sekvesti'r/V/Bsekvesti'rt [def: kidnap] 
	sekvester/S [m] [def: kidnapper] 
sele{slh}/H [interj] [def: Selah (expression of satisfaction)] 
selekti'r/V/Bsekti'rt [def: select] /Goys
	selektsye/S [f] [def: selection] 
	selekti'v/A [def: picky, selective] 
selenyum [m] [def: selenium (Se)] 
selerye [f] [def: celery] 
semester/S [m] [def: semester] % Harduf
seminar/N [m] [def: seminar]
semit/N [m] [def: semite] /Iish [def: semitic] 
	antisemit/N [m] [def: antisemite] /Iish [def: antisemitic]
	antisemitishkayt/N [f] antisemitizm [m] [def: antisemitism]
semitshke/S [def: sunflower seed] 
sendvitsh/N [m] [def: sandwich] 
senezents/N [def: hayloft] 
sensatsye/S [f] [def: sensation] sensatsyonel/A [def: sensational] 
sensiti'v/A [def: sensitive] 
sensuel/A [def: sensual] 
sentiment/N [m] [def: sentiment] /Ial [def: sentimental] 
september [m] [def: September] 
serp/N [def: scythe, sickle] 
sertse [def: beloved] 
servi'r/V/Bservi'rt [def: serve]
	servetke/S [f] [def: serviette]
	se'rvetl/Xekh [n] [def: placemat] 
serye/S [f] [def: series]
serzha'nt/N [m] [def: sergeant (military)] 
sesye/S [f] [def: session]
seyder{sdr}/Xsedorem{sdrym}/H [m] [def: order, Passover meal]
	b|seyder{sdr}/H [def: in order]  /Idik
	keseyder{Ksdr}/H [adv] [def: continually] /Idik [def: continual] 
	sedre{sdrh}/H [def: portion of the Torah, series of events] 
seyfer{sfr}/Xsforem{sfrym}/H [m] [def: religious book]
	seyferl{sfrl}/Xsforemlekh{sfrymlekh} [def: religious book]
	sforem|nik/Ees [m] [def: bookseller] 
	soyfer{swfr}/H soyfrem{swfrym}/H [def: scribe] 
seykhl{Qxl}/H [def: wisdom, common sense, prudence] /Idik
	maskil{mQKyl}/Xmaskilem{mQKylym}/H [m] [def: enlightened person] /Iish
	haskole{hQKlh}/H [def: enlightenment]
seym [def: Polish parliament] 
sezon/N [m] [def: season (of year)] 
sfard{sfrd}/Xsfardem{sfrdym}/H [m] [def: Spanish Jew] /Iish 
sfere/S/Xsfern [f] [def: sphere] % Harduf
sfire{sfyrh}/Xsfires{sfyrwT}/H [f] [def: heavenly sphere, counting]
	sfiras{sfyrT} [f] [def: counting of (with "h|oymer{ewmr}")] 
sgule{sgwlh}/Xsgules{sgwlwT}/H [f] [def: charm]
	mesugl{mswgl}/H [def: charmed, able] 
	/Xyekhidey{yHydy}-sgule{sgwlh} [def: privileged few] 
sha [verb] [def: be quiet] [verb] shat [grammar: only in imperative]
	sha-shtil/A [def: silent] 
	[idiom: zol zayn sha = quiet!]
shabe/S [f] shvab [def: cockroach] 
shabes{SbT}/Xshabosem{SbTym}/H [m] [def: Sabbath] /Idik 
	[idiom: makhn shabes{SbT} far zikh = take an independent path]
shad/V/T [def: injure, hurt] 
	shedik/V/T [def: damage]
		shedikung/N [f] [def: damage, hurt] 
	antshedikung/N [f] [def: reparation] 
	bashedik/V/Bbashedikt [def: damage, hurt] 
	shod [m] [def: shame]
	shodn/S [m] [def: damage; mischief] 
	shedlekh/A [def: dangerous] umshedlekh/A [def: safe, not injurious] 
shadkhn{Sdxn}/Xshadkhonem{Sdxnym}/H [m] shadkhnte{Sdxnte}/S [f] [def: matchmaker] 
	shadkhones{SdxnwT}/H [f] [def: matchmaking] 
	shidekh{Sydwx}/Xshidukhem{Sydwxym}/H [m] [def: match] 
	meshadekh{mSdx}/H [def: match (with "zayn")] 
	shadkhn{Sdxn}/H/V/T [def: make a match (with "zikh")] 
shaf/V/Bgeshafn /Gayn/Gop/Gayn [def: create]
	/Bgeshaft /Gayn/Gop/Gayn [def: create] % variant participle
	shafung/N [f] [def: creation]
		boyshafung/N [f] [def: construction (building)] 
	shafer [m] [def: creator]
	shaferay'/N [n] [def: creation] 
	geltshaferay' [n] geltsha'fenish [def: income, fundraising]
	bashaf/V/Bbashafn [def: create]
		bashafung/N [f] [def: creation]
		umbashafn/A [def: unformed]
		bashe'fenish/N [n] [def: creature]
		shefer/S [m] bashefer/S [m] bashafer/S [m] [def: creator]
	farshaf/V/Bfarshaft [def: create] 
	sheferish/A shaferish/A [def: creative]
		sheferishkayt/N [f] [def: creativity] 
	geshe'ft/N/D [m] [def: business]
		ayzngesheft/N [m] [def: ironworks] 
	basheftik/V/Bbasheftikt [def: employ]
		basheftikung/N [f] [def: employment, pursuit] 
shafe/S [f] [def: shelf (with doors)] shafke/S [f] 
	kleydershafe/S [f] [def: wardrobe] 
	bikhershafe/S [f] [def: bookcase] 
shakal/N [m] [def: jackal]
shakhres{SHryT}/H [m] [def: morning prayer] 
shakhte/S [m] [def: mine (excavation)] 
shaklo{Skl#}-vetaryo{|wtry#} [def: give and take (Talmudic argument)] 
shal/N [m/f] [def: shawl]
shalatn [def: lettuce (food)]
shalfey [def: sage (herb)] 
shalve{Slvh}/H [f] [def: peace] /Lb [def: in peace] /Idik [def: peaceful] 
	shalve|dikayt/N [f] [def: peacefulness] 
shames{SmS}/Xshamosem{SmSym}/H [m] [def: beadle]
	shameste{SmSte}/S [f] [def: beadle's wife] 
	meshames{mSmS}/H [def: serve (with "zayn")] 
shande/S [f] shand [def: disgrace, shame]
	shend/V/T [def: disgrace] shendlekh/K [def: disgraceful] 
shaneve/V/T [def: spare, save, take care of] 
	shanevdik/A [def: sparing] 
shank/Xshenk [f/m] [def: closet]
	kleydershank/Xkleydershenk [f/m] [def: clothes-closet] 
shans/N [def: chance] shants/N
	/Xshansn /Xshantsn [def: odds, chances] 
shants/N [m] [def: ditch, trench] 
	vasershants/N [m] [def: moat] [note: V]
shar/V/T [def: shuffle, move along, rake, scrape]
	/Garum/Gtsu/Gunter/Garoys
	tseshar/V/Btseshart [def: ??] 
	farshar/V/Bfarshart [def: rub] % farsharn a tepele mit ash
	[idiom: sharn di shney = shovel/plow the snow]
sharb/Dsherb [def: shard] 
sharbn/S [m] [def: skull] 
sharf/K [def: sharp]
	sharfkayt/N [f] [def: sharpness]
	sharf/N [f] [def: blade] 
	sharf/V/T /Gon [def: sharpen]
	farsharf/V/Bfarsharft [def: sharpe sharpenn] 
sharlekh/A [def: scarlet]
sharts/V/T [def: roll up, fold up] /Garoyf
	farsharts/V/Bfarshartst [def: roll up] 
shas_{S"s}/H [m] [def: Talmud]
shaste/V/T [def: cut, run around] 
shat/V/T [def: harm]
	farshatn/A [def: harmed] 
shatirung/N [f] [def: shade (of color), hue] 
shats/V/T [def: value] /Gop [def: appreciate]
	dershats/V/Bdershatst [def: appreciate]
	shatsung/N [f] opshatsung/N [f] [def: evaluation]
	gringshatsung/N [f] laykhtshatsung/N [f] [def: deprecation, belittling] 
		laykhtshetsik/A [def: belittling] 
shayekh{SIx}/H /Idik [def: relevant] shaykhes{SIxwT}/H [def: relevance] 
	[idiom: vos shayekh{SAx} = concerning]
shayer/S [m] [def: barn] 
shayer/V/T [def: scrub] 
shayle{S#lh}/Xshayles{S#lwT}/H [f] [def: question of ritual] 
	konter|shayle{S#lh}/Xkonter-shayles{S#lwT} [def: question in response]
shayn/V/T [def: gleam] /Garayn/Goyf/Gop/Garop
	dershayn/V/Bdershinen [def: appear; be published]
		dershaynung/N [f] [def: appearance; phenomenon] 
	tseshayn/V/Btseshinen [def: gleam] 
	bashayn/V/Bbashaynt [def: appear]
		bashaynperlekh/A [def: obvious]
	vorshaynlekh/A varshaynlekh/A [def: clearly] [usage: inadmissable]
	opshayn [m] [def: reflection] 
	zunenshayn [m] [def: sunshine] 
shayn [m] [def: luster, shine, certificate] 
shays/V/T [def: defecate] [usage: taboo]
	shayse/S [def: feces] [usage: taboo]
shayter/N [m] [def: pyre, woodpile, bonfire] 
shedever/S [m] [def: masterpiece] 
shedre{Sdrh}/H [f] [def: spine] 
shef/N [m] [def: chief, head, boss, principal, superior] 
shefe{Sfe}/H [f] [def: cornucopia] /Idik
shehoye{Shyh}/H [def: that was] 
shekel{Skl}/H [m] [def: ancient coin] 
sheker{Skr}/H [m] shakres{SkrwT}/H [def: falsehood] 
shekheyanu{ShHynw}/H [m] [def: prayer of renewal] 
shekht/V/Bgeshokhtn /Goys
	shekhter/S [m] [def: slaughterer]
	shoykhet{SwHt}/Xshokhtem{SwHtym} /H/D [m] [def: ritual slaughterer] 
		shoykhetke{SwHtke}/S [f] [def: slaughterer's wife]
	shkhite{SHyth}/Xshkhites{SHytwT}/H [f] [def: slaughter]
shel{Sl}/H [def: of] 
shel [m] [def: diamonds (playing cards)] % no plural?
sheliyekh{SlyH}/Xshlikhem{SlyHym}/H [m] [def: messenger, agent]
	shlikhes{SlyHwT}/Xshlikhesn{SlyHwTn}/H [n] [def: embassy] 
	meshulekh{mSwlH}/H [m] [def: messenger] 
	meshaleyekh{mSlH}/H [def: expel (with "zayn fun")] [usage: humorous]
	shalekh/D [def: sending] meshloyekh{mSlwH}
shelmak/N [def: rascal]
shelt/V/Bgesholtn [def: curse] 
	farsholtn/A [def: cursed] 
shem/V/T [def: be embarrased]
	farshem/V/Bfarshemt [def: embarrass]
		umfarshemt/A [def: unembarrassed]
		umfarshemtkayt/N [f] [def: lack of embarrassment]
	shemevdik/A [def: shy] shemevdikayt/N [f] [def: shyness] 
shema{Sme}/H [f] [def: declaration of God's unity] 
shenk/N/D [f] [def: tavern]
	shenker/S [m] shenkerke/S [f] [def: innkeeper]
shenk/V/T [def: give away] /Gavek/Gop
	/Bgeshonken /Gavek/Gop % variant participle
	bashenk/V/Bbashonken [def: gift] 
	tseshenk/V/T [def: distribute gifts] 
	geshank/N [n] [def: gift] 
shep/V/T [def: draw, derive] /Goys/Gon/Gop
shepilyave/A [def: lisping]
sheps/N [def: sheep] /Ien
	shof/X/N [f/m] /In /Dshef [def: sheep] 
	yungshof/X/N [f/m] [def: lamb] % Stutshkov
sheptshe/V/T [def: whisper] 
sher/V/Bgeshoyrn [def: cut] /Gop/Garum/Goys
	/Bgeshorn /Gop/Garum % variant participle
	sher/N [n] [def: type of dance] /D [def: scissors]
	sherer/S [m] [def: barber] 
sherenge/S [f] [def: line, file] 
	sherengesvayz [adv] [def: in a line] 
sherets{Src}/Xshrotsem{Srcym}/H [m] [def: insect, lizard] 
sherts/D /-sherts [def: apron, pinafore]
shetekh{StH}/Xshtokhem{StHym}/H [def: district; territory] 
shevekh{SBH}/Xshvokhem{SBHym}/H [m] [def: praise] /Ll
shevet{SBt}/Xshvotem{SBtym}/H [m] [def: tribe] 
shevet_{SBt}/H [m] [def: month of Shevat]
	beshvat{bSBt}/H [def: in the month of Shevat]
	[idiom: vi di zun in shevet = cold and distant]
shevues{SBewT}/H [m] [def: holiday of Shavuos] /Ilekh /Idik
sheyd/N [f] [def: sheath] 
sheyd/V/T [def: separate] /Gop/Gfunander
	tsesheyd/V/Btsesheydt [def: separate] 
	antsheyd/V/Bantsheydt [def: decide] antsheydnd/A [def: decisive] 
	farsheydn/K farshidn/K [def: different]
		farsheydnerley [def: various]
		farsheydnkayt/N [f] [def: difference] 
	basheyd/V/Bbasheydt [def: interpret] 
		basheyd/N [m] [def: interpretation, decision] 
	basheydn/A [def: modest] basheydnkayt/N [f] [def: modesty] 
	untershid/N [f] untersheyd/N [f] [def: difference]
	shayd/V/Bgeshidn [def: separate] 
	tseshayd/V/Btseshidn [def: separate] 
sheyd{Sd}/Xsheydem{Sdym}/H [m] [def: demon] 
sheyfe{Sfe}/H [def: cornucopia] /Lb [def: in full measure] 
sheyl/V/T [def: peel] /Gop/Gavek/Goys
	sholekhts/N/Eer [f] [def: peelings]
shem_{Sm}/H [m] [def: name]
	geshem_t{geSmt}/A [def: famous] 
	shmoy{Smw}/H [def: his name] hashe'm{hSm}/H [m] [def: God] 
	balshem{bel-Sm} [m] [def: wonder worker] 
sheyn/Kshen [def: pretty] sheynink/A
	sheynkayt/N [f] [def: beauty] 
sheyres{S#ryT}/H/N [f] [def: remnant; Holocaust survivor (with "- h|pleyte")]
	shirayem{SyrAm}/H [def: leftovers] 
sheys [def: excrement (taboo)] 
sheytl/N [n] [def: wig] 
shier [adv] [def: almost, nearly (with "nit")]
shier_{Syewr}/H [def: almost]
shif/N/D [f] [def: ship]
	shifer/S [m] shiferin/S [f] [def: sailor]
	shifl/V/T [def: row] 
	kosmosshif/N [f] [def: space ship] 
	damfshif/N [f] [def: steam ship] 
	krigshif/N [f] [def: warship] 
	zeglshif/N [f] [def: sailboat] 
	[idiom: farbrent ale shifn = no way back (burned one's bridges)]
shifer/N [m] [def: cipher, code] 
	yerishe{yrySh}-shifer/N [m] [def: genetic code] [note: V]
shifles{SflwT}/H [def: humility] 
shiit/N [m] [def: Shiite (Moslem)] 
shik/V/T [def: send]
	/Gaheym/Garayn/Garop/Garoyf/Garoys/Gop/Gtsurik/Gavek/Gtsu
	farshik/V/Bfarshikt [def: exile]
	tseshik/V/Btseshikt [def: send away] 
	geshi'kt/A [def: skillful, deft, dexterous]
		geshiktkayt/N [f] [def: dexterity] 
	onshi'kenish/N [f] [def: curse, blockhead]
shiker{SyKwr}/Xshikurem{Sykwrym}/H [def: drunk (intoxicated)] /A
	/Iish [def: drunken] 
	shikererheyt{SyKwrerheyt} [adv] [def: in a drunken state]
	shiker{SyKwr}/H/V/T [def: become drunk] /Gon
	farshiker{farSyKwr}/V/T [def: intoxicate] 
	shikres{SyKrwT}/H [f] [def: drunkeness] 
shikht/N [m] [def: layer, level]
shikse/S [f] [def: non-Jewish woman (derogatory)] 
	shiksenik/Ees [m] [def: womanizer who likes non-Jewish women] 
	sheygets{Sgc}/Xshkotsem{Skcym}/H [def: non-Jewish young male (derogatory), brat]
		sheygetsl{Sgcl}/Xshkotsemlekh{Skcymlekh} [def: brat] 
shild/N/D [m/f] [def: metal plate, sign, signboard, shield] 
	onerke'n-shild/N/D [m/f] [def: plaque] [note: V]
shilder/V/T [def: depict] 
	farshilder/V/Bfarshildert [def: ??] 
	shilderung/N [f] [def: depiction] 
shildkroyt [def: tortoise] 
shilt/V/Bgesholtn [def: curse] 
	farshilt/V/Bfarsholtn [def: curse] 
shimenesre{Smnh-eQrh}/H [def: eighteen benedictions] /Idik
shimer/V/T [def: shimmer]
	shimeri'r/V/Bshimeri'rt [def: shimmer] 
	shimerirung/N [f] [def: shimmer] 
shiml [def: grey horse with brown spots]
shiml [m] [def: mold] /V/T [def: molder]
	farshiml/V/Bfarshimlt [def: molder] 
shin{Sʼ}/H [m/f] [def: Hebrew letter shin] 
shind/V/Bgeshundn [def: flay] /Garop/Gop
	shinder/S [m] [def: flayer]
shindl/N [f] [def: shingle]
shine{Synwi}/Xshinuem{SynwEm} [def: euphamism; modification] 
shipue{Sypwe}/Xshipuem{Sypwe|im} [m] [def: hillside; cliff] 
	meshupe{mSwpe}/H [def: aslant, sloping] /Idik
shir [def: nearly (with "- nisht")] 
shir{Syr}/Xshirem_{Syrym}/H [m] [def: song] /Lh
	shire{Syrh}/H [def: song] 
shirem/S [m] [def: umbrella] 
shis/V/Bgeshosn [def: shoot] /Garop/Garoys/Gavek/Goys/Gtsu/Gdurkh
	/Gunter [def: shoot down] 
	dershis/V/Bdershosn [def: kill by shooting] 
	bashis/V/Bbashosn [def: shoot] 
	tseshis/V/Btseshosn
	shiser/S [m] [def: shooter]
	shiseray'/N [n] [def: shooting]
	shos/N [m] [def: shot] 
	flokn-shiser/S [m] flokn-shiserke/S [f] [def: braggart (ironic), swashbuckler] 
	[idiom: shisn tsvey hozn mit eyn shos = kill two birds with one stone]
shishke/S [f] [def: pine cone, bigshot] 
	[idiom: nit vert keyn shishke = worthless]
shisl/N [f] [def: bowl, dish]
shit/V/Bgeshotn [def: pour] /Garop/Garoys/Garop/Goys/Gon
	dershit/V/Bdershotn [def: pour] 
	tseshit/V/Btseshotn [def: pour] 
	farshit/V/Bfarshotn [def: fill by pouring] 
	bashit/V/Bbashotn [def: fill by pouring] 
shite{Syth}/Xshites{SytwT}/H [f] [def: school of thought]
shiter/A [def: thin]
	dershiter/V/Bdershitert [def: shock; stroke]
		dershiterung/N [f] 
shits/V/T [def: protect]
	bashits/V/Bbashitst [def: protect]
		bashitsung/N [f] [def: protection] 
		bashitser/S [m] [def: protector] 
		umbashitst/A [def: unprotected] 
	shuts/N [f] [def: protection]
		verkshuts [f] [def: worker's compensation]
		zelbshuts [f/m] [def: self-defense] 
	shitser/S [m] [def: protector] 
shive{SBeh}/H [f] [def: 7 days of mourning] 
shiyer{Syewr}/Xshiurem{Syewrym}/H [m] [def: limit]
shkarlatines [def: scarlet fever (disease)]
shkarpet/N [def: stocking (clothing)] 
shkhine{Sxynh}/H [f] [def: presence of God] 
shkiye{Skyeh}/Xshkiyes{SkyeT}/H [f] [def: sunset]
shklaf/N [m] [def: slave]
	shklaferay' [n] [def: slavery] 
	farshklaf/V/Bfarshklaft [def: enslave] 
		farshklafung/N [f] [def: enslavement] 
shkole/S [f] [def: school] 
shkrabe/S [def: old horse] 
shlaberik/A [def: slack] 
shlaf/A [def: ill (Ukraine), weak (Lithuania)]
	shlafkayt/N [f] [def: disease (Ukraine), weakness (Lithuania)]
shlak/N [m] [def: roof of a Succoh]
	durkhshlak/N [m] [def: colander]
	toybnshlak/N [m] [def: dovecote; pigeon coop]
	untershlak/N [m] [def: lining (of clothing), background]
shlak/Xshlek [m/n] [def: stroke, evil, nuisance, dross, junk, shrew, misfortune]
	shlak/A [def: junky] 
	shlaks/N [m] [def: downpour (with "- regn")]
	hartsshlak/N [def: heart attack]
	hitsshlak/N [def: heatstroke]
	zunshlak/N [def: sunstroke]
	[idiom: tsores mit shlek = one misfortune after another]
shlakht/N [f] [def: slaughter, battle]
shlal{Sll} [m] [def: great number] 
shlang/N [m/f] [def: snake; penis (taboo)] /Dshleng
	shlengl/V/T [def: weave through] /Garop
shlank/K [def: lithe] /Iik
	shlankayt/N [f] [def: litheness] 
shlayder/V/T [def: fling] /Garayn/Gavek/Garunter
shlaye/N [m] [def: tench fish]
shlayf/V/T [def: polish] /Bgeshlifn % variant participle
	/Goys [def: become sensitive (with "zikh")]
shlaykh/V/T /Garoys/Gdurkh [def: pass unnoticed] 
shlaym/N [m] [def: slime] 
	tsonshlaym [m] [def: plaque (dental)] [note: V]
shlekht/Kerg [def: bad] /Iink
	erger/V/T [def: anger] 
		ergernish/N [def: anger]
	[idiom: does noytike shlekhts = necessary evil] [note: V] 
shlenderl [n] [def: morning glory (plant)] 
shlep/V/T [def: drag]
	/Gaher/Garoys/Garunter/Gavek/Gmit/Gtsu/Gmit/Garum/Garop
	/Garayn/Garoyf/Giber
	/Gnokh [def: imitate] 
	shleper/S [m] [def: poorly dressed person]
	nokhshleper/S [m] [def: imitator, sycophant] 
shleyer/V/T [def: veil] /Gon
	shleyer/N [m] [def: veil] 
shleyf/N [m?] [def: body part ??]
shleyme{Slymh}/H [def: complete (with "refue -")] 
	shleymes{SlymwT}/H [def: completeness] 
	mashlem{mSlym}/H [def: complete (with "zayn")] 
shling/V/Bgeshlungen [def: swallow, guzzle]
	/Garayn/Garop/Garunter/Gayn/Gmit
	farshling/V/Bfarshlungen [def: swallow up] 
	shverdshlinger/S [m] [def: sword swallower] 
shlis/V/Bgeshlosn [def: lock] /Gayn/Gon/Gtsu/Gop
	/Goys [def: lock out; suspend (from school)] 
	bashlis/V/Bbashlosn [def: decide]
		bashlus/N [m] [def: decision]
	farshlis/V/Bfarshlosn [def: lock] 
	antshlis/V/Bantshlosn [def: unlock, decide]
		antshlosnkayt/N [f] [def: unlocked state] 
	oysshlislekh/A [def: exclusive]
	shlos/Xshleser [m] [def: lock, castle] 
		shlisl/X/D [m] [def: key]
		shloser/S [m] [def: locksmith] 
			shloseray/N [f] [def: locksmith shop] 
		kombinatsye-shlos/Xshleser [m] [def: combination lock] [note: V]
	geshlos/N [def: decision] 
	/Dshles [def: zipper]
	rern-shloser/S [m] [def: plumber] 
shlite{Slyth}/H [f] [def: school of thought] 
shlitn/S [m] [def: sled] /Dshlit
	shlitl/V/T [def: sled] /Garop
shlof/V/Bgeshlofn [def: sleep] /Gayn/Giber/Gop/Goys
	farshlof/V/Bfarshlofn [def: affected by sleep] 
	antshlof/V/Bantshlofn [def: fall asleep] 
	dershlof/V/Bdershlofn [def: sleep soundly] 
	shlof/N [m] [def: sleep] shlofloz/A [def: sleepless] 
	shleferik/A [def: sleepy] 
	[idiom: gey shlofn = go to sleep]
shlog/V/Bgeshlogn [def: hit, beat]
	/Garoys/Giber/Gop/Goyf/Gdurkh/Gon/Gunter
	/Gfor [def: suggest]
	/Goys [def: recoup expenses, strike (the hour), knock out] 
	/Garoyf [def: nail up; affix] 
	bashlog/V/Bbashlogn [def: beat] 
	dershlog/V/Bdershlogn [def: oppress; depress]
		dershlognkayt/N [f] [def: oppression] 
	farshlog/V/Bfarshlogn [def: beat]
	tseshlog/V/Btseshlogn [def: hit] 
	shloger/S [m] [def: hitter]
	forshlag/N [m] [def: suggestion] 
	geshle'g/N [n] [def: fight, context] 
		freggeshleg/N [n] [def: College Bowl (game of questions)] [note: V] 
shluk/N [m] [def: sip] 
shlukerts/V/T [def: hiccup] shlukekhts/N [m] [def: hiccups] 
shlump [m] [def: hangdog person] 
	farshlumpert/A [def: wrinkled, in poor repair] 
	shlumperl [n] [def: Cinderella] 
	shlumperdik/A [def: dowdy] 
shlyakh/N [m] [def: path, dirt road, unpaved road]
shlyape/S [f] [def: hat worn by Chasidim (clothing); worthless person]
shlyare/S [f] [def: ruffle] 
shlyonder/V/T [def: stroll, wander; lounge] /Garum
shloype/V/T [def: wade (through snow or mud)]
	farshlyopet/A [def: deep in mud]
shmad{Smd}/H/V/T [def: convert from Judaism] /Gop
	farshmad{farSmd}/V/Bfarshmadt{farSmdt} [def: convert from Judaism] 
	meshumed{mSwmd}/Xmeshumodem{mSwmdym}/H [m] /Eeste/Eestes [f] [def: convert from Judaism]
shmalts [n/f] [def: poultry fat] /Iik
	gendznshmalts [def: goosefat] 
shmant/N [m] [def: cream] 
	[idiom: parever shmant = non-dairy creamer (liquid)]
shmarts/Xshmertsn [m] [def: pain (German)]
	shmertslekh/A [def: painful]
shmate/S [f] [def: rag] /Idik
shmayd/V/Bgeshmidt [def: strike] /Goys/Gayn/Gtsu/Giber
	farshmayd/V/Bfarshmidt [def: strike] 
	shmid/N/D [m] [def: smith]
		goldshmid/N [m] [def: goldsmith]
		shmideray' [n] [def: smithy] 
	shmaydik/A [def: striking] 
	[idiom: geshmidte geslekh = ??]
shmaye/V/T [def: grin, bustle]
	/Garum [def: bustle, pretend to accomplish something] 
	farshmaye/V/Bfarshmayet [def: grin] 
shmays/V/Bgeshmisn [def: strike] /Gop/Gavek/Gtsu
	shmayser/S [m] [def: wagon driver] % not geshmayst
	shmits/X [m] [def: lash]
shmek/V/T [def: smell] /Garayn/Gon
	/Iedik [def: fragrant] 
	dershmek/V/Bdershmekt [def: smell; detect by smelling] 
	farshmek/V/Bfarshmekt [def: be fragrant] 
	geshma'k/A [def: tasty] geshmakn/A
	geshma'k/N [m] [def: taste] 
		[idiom: yederer loyt zayn geshmak = everyone to his own tastes]
	shmek/N [m] [def: smell]
	shmeker/S [m] [def: nose]
	faynshmeker/S [m] [def: connoisseur] 
shmelts/V/Bgeshmoltsn [def: melt] 
	tseshmelts/V/Btseshmoltsn [def: melt] 
	geshmelts/N [n] [def: alloy] 
shmendrik/Ees [def: fool, simpleton, weakling] 
	[note: from the name of a Goldfaden operetta] 
shmerts/N [m] [def: pain]
	boykhshmerts/N [m] [def: stomache ache] 
shmeter/V/T [def: destroy]
	tseshmeter/V/Btseshmetert [def: destroy]
		tsushmeterung [f] [def: destruction] 
shmeterling/N/D [def: butterfly (German)]
shmeykhl/V/T [def: smile] /Garoyf/Gunter/Garoys/Gtsu
	tseshmeykhl/V/Btseshmeykhlt [def: smile] 
	shmeykhl/N/D/Idik [m/n] [def: smile]  
shminke/S [def: makeup, rouge] 
	shmink/V/T [def: apply makeup] 
shmini{Smyny}-atseres{ecrT} [def: festival directly after Sukkes] 
shmir/V/T [def: spread; grease, lubricate] /Goys
	/Gunter [def: bribe] 
	bashmi'r/V/Bbashmi'rt [def: spread, grease] 
	farshmi'r/V/Bfarshmi'rt [def: spread, grease] 
	shmirekhts/N [n] [def: spread, grease] 
		hoytshmirekhts/N [n] [def: hand and body lotion] 
	shmirung/N [n] [def: spreading, greasing]
	[idiom: der gantser shmir = the total package (German)]
	[idiom: vi geshmirt = smoothly, fluently]
shmite{Smyth}/H [def: Sabbatical year] 
shmitsik/S [def: bow (of violin)] 
shmol/Kshmel [def: narrow] 
	[idiom: haltn shmol = be in a critical state]
shmonde/S [f] [def: female genitalia (taboo)] 
shmoshes{SmSwT}/H /Lh [def: evening (with "beyn -")] /Idik
shmoys{SmwT}/H [m] [def: book of Exodus] 
shmoysh/N [m] [def: lambskin] /In
shmues/V/T [def: converse] /Gadurkh/Goys/Gop/Gayn/Gtsurik/Gdurkh
	shmues/N [m] [def: conversation]
	shmue_{Smweh}/Xshmues_{SmwewT} [def: rumor; piece of news] 
	shmues [prefix] [def: conversational] 
shmugl/V/T [def: smuggle] /Garayn/Garoys/Gdurkh
	shmugl/N [def: smuggling activity] 
shmuk/N [def: jewelry] [def: usage: inadmissable] 
	shmukler/S [m] shmuklerke/S [f] [def: lacemaker] 
	shmok [def: penis (taboo)] /Dshmek
shmukht/V/T [def: reek of (with "mit")] 
	shmukht/N [m] [def: scent, odor] 
shmuts [n] [def: dirt] /Iik /Iedik
	bashmuts/V/Bbashmutst [def: defile, pollute]
	bashmutsung/N [f] [def: dirt] 
shnaps/N [m] [def: brandy] 
shnar/N [m] [def: scar]
shnayd/V/Bgeshnitn [def: cut, harvest]
	/Garoys/Garum/Gayn/Giber/Gop/Goys/Garayn/Gdurkh/Gon
	tseshnayd/V/Btseshnitn [def: cut apart] 
	farshnayd/V/Bfarshnitn [def: cut] 
	shnayder/X/S /D [m] shnayderke/S [f] [def: tailor (occupation)] 
	shnit/N [m] [def: cut, harvest]
		durkhshnit/N [m] [def: average; crosscut] /Ilekh
		oysshnit/N [m] [def: selection] 
	farshnitn/A [def: cut off] 
	shnaydik/A [def: cutting]
shnayts/V/Bgeshnitst [def: blow the nose] 
shnek/N [m] [def: snail (animal)]
	[idiom: der hoyler erdshnek = slug (animal)]
shnel/K [def: quick] shnelkayt/N [f] [def: haste] 
shney/N/D/Iik [m] [def: snow] shneyele/Ekh [def: snowflake]
	shney/V/T [def: snow]
		farshneyt/A [def: snow-covered] 
	shneyer [m] [def: snowman (with "feter -")] 
	papshoy-shneyelekh [def: corn flakes] 
shnip/V/T [def: cut finely] /Gavek/Garop
shnips/N [m] [def: necktie]
shnits/V/T [def: whittle, carve] 
	shnitseray'/N [n] [def: carving]
shnobl/N [m] [def: beak] shnobele/Ekh
	vaser-shnobl/N [m] [def: gargoyle/downspout] [note: V]
shnol/N [def: poke]
	farshnol/V/Bfarshnolt [def: poke] 
shnor/V/T [def: beg, scrounge] /Gtsuzamen
	shnorer/S [m] [def: beggar] 
shnoravadle/S [def: shoelace (clothing)] 
shnorkh/V/T [def: snore, snort]
shnoyts/N [m] [def: prow (ship)]
shnuk/N [m] [def: snout, trunk (elephant)] 
shnur/N/Xshnir [f] [def: daughter-in-law]
shnur/N [m/f] [def: rope, chain, line, thread, cord] /Dshnir
	farshnureve/V/Bfarshnurevet [def: chain] 
	onshnurik/A [def: cordless, wireless] 
		onshnurke/S [f] onshnurikl/Eekh [n] [def: cordless telephone] 
sho{Seh}/Een/H [f] [def: hour] b|shas{SeT}/H/P [def: when] 
	shoenvayz{Sehenvayz} [def: by the hour] 
	beshate{bSeWw} [adv] [def: in his/its time] 
	lekhayem{lHIm}-sho{Seh} [def: cocktail hour] [note: V]
	[idiom: b|shas mayse = meanwhile]
shod/N [m] [def: shame, pity] 
shok [m] [def: 60; a long time (with "a - mit yorn")] 
shok [def: sound made to calm a horse] 
shokh [m] shakhma't [m] [def: game of chess]
	shakh [m] [def: game of chess] [usage: doubtful admissability]
shokher{SHwr}/Xshokhrem{SHrym}/H [m] [def: black man] [usage: code]
	shokherte{SHwrte}/S [f] [def: black woman]  [usage: code]
	shkhoyre{SHwrh}/H [def: depression (with "more -")] /Idik
shokhn{Sxn}/Xshkheynem{Sxnym}/H [m] [def: neighbor]
	shokhnte{Sxnte}/S [f] shkheyne{Sxnh}/H [f] [def: neighbor] 
	shkheynes{SxnwT}/H [def: proximity] /Idik [def: neighboring] 
		beshkheynes{bSxnwT} [adv] [def: close by] 
	shkeynish{Sxnish}/A [def: neighboring]
	shkeynishaft{Sxnishaft}/N [f] [def: neighborhood]
shoki'r/V/Bshoki'rt [def: shock] 
shokl/V/T [def: rock] /Gtsu/Goys/Gop
	tseshokl/V/Bteshoklt [def: rock] 
	[idiom: shoklen mit dem oyer / der noz = wiggle the ear / nose]
shokolad/N [m] [def: chocolate] /In [def: chocolate]
	shokoladke/S [f] [def: chocolate candy] 
	tshekolad tshokolad % variants
shol/N [f] [def: bowl; shell] 
sholem{Slwm}/H/Idik [m] [def: peace]
	/Lb [def: in peace] /Lh [def: the peace] /L|v [def: and peace] 
	[idiom: olov{elyw} h|sholem{Slwm} = may he rest in peace]
	[idiom: khas |v|sholem = God forbid]
sholtekhti{S#wl-WHTyh}/H [def: purgatory, hell] 
shomayem{Smym}/H [def: heaven] /Lh
	[idiom: min_{mn} hashomayem{hSmym} = by heavenly decree]
shop/N [m] [def: racoon (animal)] /In
shor{Swr}/H [def: ox] 
shorkhe/V/T shorkh/V/T [def: rustle] 
	shorkh/N [m] [def: rustle] 
shorsh/V/T [def: rustle (noise)] 
shosey'/N [m] [def: highway] 
shotn/S [m] [def: shadow]
	shotn/V/T [def: shade] 
		tseshotnkayt/N [f] [def: shade] 
	farshotn/V/Bfarshotnt [def: shade] 
	bashotn/V/Bbashotnt [def: shade] 
shovinizm/N [m] [def: chauvinism] shovinistish/A [def: chauvinistic] 
shoy [def: storefront (with "fentster")]
shoyb/N [def: shutter, pane  (window)]
	akhtshoybik/A [def: 8-shuttered] 
shoyder/V/T [def: shudder] /Goyf
	shoyder/N [m] [def: shudder] /Ilekh [def: dreadful] 
shoyfer{Swfr}/Xshoyfres{SwfrwT}/H [m] [def: shofar] 
shoykhet{SwHt}/H [m] [def: ritual slaughterer]
	shkhite{SHyth}/Xshkhites{SHytwT}/H [f] [def: slaughter] 
shoym/N/D [m] [def: foam]
	shoym/V/T [def: foam] 
shoymer{Swmr}/Xshoymrem{Swmrym}/H [m] [def: guard]
	shmire{Smyrh}/H [f] [def: watch, guard] shmiras{SmyrT}/H [def: watching of] 
shoyn/V/T [def: look after] [usage: inadmissable]
shoyn [def: already] 
	[idiom: nit shoyn zhe = after all (accusing)]
shoyresh{SwrS}/Xshorashem{SrSym}/H [m] [def: root] 
shoys/N [m] [def: lap] 
	shoyserl/Eekh [n] [def: laptop computer] [note: V]
shoyt/N [m] [def: seed pod] 
shpage/S [f] [def: epée]
shpalt/V/Bgeshpoltn [def: split] /Goyf
	/Gop [def: compartmentalize] 
	tseshpalt/V/Btseshpoltn [def: split, compartmentalize] 
	shpalt/N [m] [def: crack] /Dshpelt [def: crevice] 
shpan/V/T [def: tighten, bridle, stride]
	/Gayn/Garum/Gavek/Goys/Gtsu/Garoys/Gforoys
	/Gon [def: tighten, make tense] 
	/Gariber [def: surpass]
	geshpan/N [n] [def: stride; harness] 
	shpan/N [m] [def: span (short distance), horse-drawn carriage]
	shpanung/N [f] [def: tension] geshpa'nt/A [def: strained] 
shpar/V/T [def: press; dispute (with "zikh")]
	/Gdurkh/Gtsu/Garoys/Gunter/Garayn/Giber/Gtsu
	/Gon [def: support]
	/Gayn [def: be stubborn]
		ayngeshpartkayt/N [f] [def: stubborness] 
	farshpar/V/Bfarshpart [def: make stubborn] 
	onshpar shpa'renish/N [def: stubbornness]
shparber/S [m] [def: sparrow hawk (bird)] /Iish
shpare/S [f] shparune/S [f] [def: crack, slit] 
shpas/N [m] [def: joke] /Iik [def: humorous, joking] 
	/Dshpits [def: trick, joke] 
shpatsi'r/V/T [def: stroll] /Garum/Gdurkh
	/Bshpatsirt /Garum/Gdurkh % variant participle
shpay/V/Bgeshpign [def: spit] /Goys/Gon
	bashpay/V/Bbashpign [def: cover with spit] 
	farshpay/V/Bfarshpign [def: cover with spit] 
	oysshpay [def: spit] shpayekhts/N [n] [def: spit] 
shpaykhler/S [m] [def: granary] 
shpayz/V/T [def: feed] /Gmit
	shpayz/N [f] [def: food] 
	forshpayz/N [f] [def: appetizer]
	nokhshpayz/N [f] [def: dessert] 
shpend/D /-shpend [def: kindling]
shpet/K /Iik/Ierdik/Ilekh [def: late] 
	shpetertsu [adv] [def: later] 
	shpetik/V/T [def: delay]
	farshpetik/V/Bfarshpetikt [def: delay, be late (with "zikh")]
shpet/V/T [def: deride] /Goys/Gnokh % shpot/V/T is German
	shpot/N [m] [def: mockery, object of derision] /Iish [def: mocking] 
	shpoter/S [m] [def: mocker]
shpigl/V/T [def: mirror] /Gop [def: reflect] 
	opshpiglung/N [f] [def: reflection] 
	shpigl/N [m] [def: mirror] /Idik [def: reflective] 
shpil/V/T [def: play] /Gop/Goys/Gtsu/Goyf/Gon
	shpiler/S [m] shpilerin/S [f] [def: performer] 
		shoyshpiler/S [m] [def: actor] 
		tashnshpiler/S [m] [def: pickpocket] 
		shpilerke/S [f] [def: player (machinery)] 
	shpil/N [f/n] [def: game]
		azartshpil/N [f/n] [def: game of chance, gambling] 
		bayshpil/N [m] [def: example]
		bretshpil/N [f/n] [def: board game] 
		kindershpil/N [f/n] [def: children's play] 
		purim|shpil/N [f/n] [def: Purim play] 
		shokhshpil/N [f/n] [def: chess game] 
		shoysphil/N [f/n] [def: play (performance)] 
		tseykhnshpil/N [f/n] [def: jacks (game)] [note: Stutshkov]
		tsuzamenshpil/N [m] [def: interplay]
		vortshpil/N [f/n] vertershpil/N [f/n] [def: pun]
		[idiom: oys shpil = the game's over]
	farshpil/V/Bfarshpilt [def: lose] 
	tseshpil/V/Btseshpilt [def: play] 
	shpilevdik/A [def: playful] 
	shpilekhl/Xshpilekhlekh [n] [def: plaything]
shpilye/V/T [def: pin] /Gayn/Gfunander
	farshpilye/V/Bfarshpilyet [def: pin, button] 
	tseshpilye/V/Btseshpilyet [def: unpin, unbutton] 
	shpilke/S [f] [def: pin] 
		horshpilke/S [f] [def: hairpin] % Harduf
	[idiom: zitsn oyf shpilkes = wait nervously]
shpin/V/T [def: spin] shpin/N [f] [def: spider]
	shpiner/S [m] [def: spinner]
	goldshpiner/S [m] [def: gold spinner] 
	shpindl/N [m] [def: ??] % di shpindlen in di hor zaynen farzhaverte
shpina't/N [m] [def: spinache] 
shpinte/S [f] [def: cigarette butt] 
shpyon/N [m] shpyonke/S [f] [def: spy] shpyonazh [m] [def: espionage] 
	shpyoni'r/V/Bshpyoni'rt /Goys [def: spy out] 
shpir/V/T [def: sense]
	/Gnokh [def: detect] 
	dershpi'r/V/Bdershpi'rt [def: sense] 
shpitol/N/Xshpiteler [m] [def: hospital] 
	shpitolizi'r/V/Bshpitolizi'rt [def: hospitalize] 
shpits/V/T [def: make a tip] /Giber/Goyf/Gon
	shpits/N [m/f] [def: point] /Iik 
	/D [def: joke] 
	oybershpitslekh/A  [def: principle] 
	farshpitst/A [def: pointed] farshpitstkayt/N [f] [def: pointedness] 
	boymshpits/Xbeymershpitsn [m/f] [def: treetop] 
	fingershpits/X/N [def: fingertip]
	horshpits/N [def: tip of the hair] 
	[idiom: farshpitsn di oyern = listen attentively]
shpitsn/A [def: lace]
shpiz/N/D/Iik [m/f] [def: spear]
	shpiz/V/T [def: spear] /Gadurkh [def: impale] 
shpliter/N [m] [def: splinter, sliver] 
	shpliter/V/T [def: splinter] /Gop
shpog [m] [def: club (playing cards)] % no plural?
shpogl [def: brand new] 
shpondrik/Ees [def: (a derisive term for a person)] 
shpor/V/T [def: save up] /Gon/Gayn/Gop
	farshpor/V/Bfarshport [def: avoid] 
shpot/V/T [def: deride] /Goys/Gnokh % /Bgeshpet ??
	shpot/N [m] [def: mockery, object of derision] /Iish [def: mocking] 
	shpoter/S [m] [def: mocker]
	geshpet/N [n] [def: mockery] % Harduf 
shprakh/N [f] [def: language]
	oysshprakh/N [f] [def: expression]
	kvalshprakh/N [f] [def: original language] 
	shprakhik/A [def: language]
		andershprakhik/A [def: foreign language]
		tsvishnshprakhik/A [def: multilingual] mershprakhik/A
	shprakhikayt/N [f] [def: ability to speak] 
	guf{gwf}-shprakh/N [def: body language] 
	folkshprakh/N [def: folk language] /Iik
	fremdshprakh/N [f] [def: foreign language]  /Iik
	kulturshprakh/N [f] [def: high language] 
	mutershprakh/N [f] [def: mother tongue]
	redshprakh/N [f] [def: spoken language]
	shprukh/N [def: formula (verbal)]
		antshprekh/V/Bantshprekht [def: charm away] 
		shprekh/V/T [def: recite a formula] /Gayn/Gop/Goys
			/Bgeshprokhn /Gayn/Gop/Goys % variant participle
		geshprekh/N [n] [def: formula; conversation]
		opshprekher/S [m] opshprekherin/S [f] [def: curse remover]
shprayz/V/T [def: walk, stalk] /Garum/Giber/Garop/Garoyf
	ibershprayz [m] [def: stroll]
	ibershprayzer/S [m] [def: stroller] 
shprenkl/V/T [def: sprinkle] /Dshprenk [def: freckle] 
	zumer-shprenkele/Eekh [n] [def: freckle] 
	bashprenklt/A [def: speckled] 
shpreyt/V/T [def: spread out] /Goys/Gfunander
	farshpreyt/V/Bfarshpreyt [def: disseminate; spread (with "zikh")]
		farshpreyt/K [def: widespread] farshpreytung/N [f] [def: dissemination] 
	tseshpreyt/V/Btseshpreyt [def: disseminate] 
	shpreyt/K [def: widespread]
shpring/V/Bgeshprungen [def: jump] 
	/Garoys/Garayn/Gariber/Garop/Garoyf/Gum/Goyf/Gop/Gunter
	shprung/N [m] [def: jump] hoykhshprung/N [m] [def: high jump] 
		urshprung/N [m] [def: beginning] [usage: inadmissable]
		urshpringlekh/A [def: primitive, rudimentary; original] [usage: inadmissable]
	tseshpring/V/Btseshprungen [def: shatter]
	shpringer/S [m] [def: jumper] 
shprits/V/T [def: spray] /Garoys/Gop
	geshpritseray'/N [n] [def: spraying] 
	bashprits/V/Bbashpritst [def: sprinkle, splash] 
	shpritser/S [m] [def: fountain, shower, selzer bottle] 
shprots/V/T [def: sprout] /Goyf
	shprots/N [m] [def: sprout] /D
shprudl/V/T [def: well, sputter] 
	shprudldik/A [def: ebullient] 
shpur/N [f/m] [def: trace] 
shrank/Xshrenk [m] [def: closet] [usage: inadmissable]
	[idiom: sforem{sfrym}-shrank = bookcase]
	bashrenk/V/Bbashrenkt [def: limit, inhibit] [usage: inadmissable]
shray/V/Bgeshrign [def: call, shout]
	/Garayn/Garop/Goys/Giber/Gon/Gnokh/Garayn/Gtsurik
	/Bgeshrien /Garayn/Garop/Goys/Giber/Gon/Gnokh/Garayn/Gtsurik % variant 
	geshrey/N [n] [def: call, shout; scream] geshreyeray'/N [n] % not geshray
		oysgeshrey/N [n] [def: outcry] 
	tseshray/V/Btseshrign/Btseshrien [def: call for a period of time (with "zikh")] 
	himlshrayendik/A [def: abysmal, terrible] 
	shray/N [m] [def: hoot (sound of an owl)] [note: V]
	farshray/V/Bfarshrign [def: cast an evil eye] 
shrayb/V/Bgeshribn [def: write]
	/Garayn/Goyf/Gop/Garoys/Gavek/Giber/Gnokh/Gon/Gtsu/Gunter/Goys/Gayn
	/Gdurkh/Gadurkh [def: correspond (with "zikh")] 
	bashrayb/V/Bbashribn [def: depict, describe]
		bashrayber/S [m] [def: depicter, writer] /Iish
		bashraybung/N [f] [def: depiction, description] 
		bashraybekhts/N [f] [def: depiction, description] 
	farshrayb/V/Bfarshribn [def: prescribe]
	shrift/N/Ilekh [m] [def: font] oyfshrift/N [m] [def: writing] 
		hantshrift/N [f] [def: handwriting] [def: doubtful admissability] 
		tsaytshrift/N [f] [def: newspaper] 
	shrayber/S [m] shrayberin/S [f] [def: writer] 
		shrayberish/A [def: authorial] 
	shrayberuk [m] shraybune/S [f] [def: writer (pejorative)]
	shrayberay'/N [n] [def: writing] shraybung/N [f]
	aroysshrayb [def: output]
	umbashrayblekh/A [def: unwritable]
	shraybke/S [f] [def: writing pad] [note: V]
		byuro-shraybke/S [f] [def: memo pad] [note: V]
		notits-shraybke/S [f] [def: note pad] [note: V]
	[idiom: es shteyt geshribn = it is accepted (in the tradition)]
shrek/V/Bgeshrokn [def: fear] /Gop/Giber/Gon
	dershrek/V/Bdershrokn [def: frighten] 
	tseshrek/V/Btseshrokn [def: frighten] 
	shreklekh/K shrekik/K [def: terrible] 
	shrekevdik/A [def: timid] 
/Dshret [n] [def: dwarf; elf; gnome] 
shrimp/V/Bgeshrumpn [def: shrink] /Gayn/Gtsunoyf
shrit/N [m] [def: step] forshrit/N [m] [def: progress]
shroyf/N/Dshrayf [m] [def: screw]
shrunt/N [m] [def: parting in the hair; gap]
shtab/N [m] [def: staff, headquarters] 
shtabe/S [f] [def: metal bar] 
shtadlen{SWdln}/Xshtadlonem{SWdlnynm}/H [m] [def: intercessor]
	shtadlones{SWdlnwT}/H [n] [def: intercession] 
shtafet/N [m] [def: runner, herald]
shtakhet/N [def: fence paling] 
shtal/N [f/m] [def: stall (for animals)] 
	hinershtal/N [f] [def: roost] 
	khazer{Hzyr}-shtal [f/m] [def: pigsty] 
shtaltik/A shtaltne [def: handsome, shapely; stately, presentable] 
	geshtalt/N [def: appearance; shape, form]
shtam/V/T [def: originate] /Gop
	opshtam/N [m] [def: origin] /Iik opshtamung/N [f] [def: origin] 
	shtam/N [m] [def: origin] /Iik
	shtamling/N [m] opshtamling/N [m] [def: descendent] 
	boymshtam/Xbeymershtamen [m] [def: tree trunk] 
shtaml/V/T/Garoys [def: stammer]
shtang/N/D [m/f] [def: pole, bar, beam] /Dshteng
	bangenshtang/N [m] [def: ??] % haynt hot er gearbet bay bangenshtangen
	balansir-shtang/N [m/f] [def: balance beam (gymnastics)]
	tsveyshtang/N [m/f] [def: parallel bars (gymnastics)] 
	[idiom: khupe{Hwph} shtang = wedding-canopy support]
shtapl/N [m/f] [def: step] 
shtar/V/T [def: stare]
	farshtart/A [def: frozen]
shtar{Str}/H [m] [def: receipt, document] 
shtarb/V/Bgeshtorbn [def: die]
	/Gavek/Gop/Goys
	farshtarb/V/Bfarshtorbn [def: die] 
	oysshtarb [m] [def: extinction] 
	shterblekh/A [def: mortal] umshterblekh/A [def: immortal] 
		shterblekhkayt/N [f] [def: mortality] 
		umshterblekhkayt/N [f] [def: immortality] 
shtark/V/T [def: strengthen] 
	farshtark/V/Bfarshtarkt [def: strengthen]
		farshtarkung/N [f] [def: strengthening] 
	shtark/K [def: strong] shtarkayt/N [f] [def: strength] 
shtarts/V/T [def: poke] /Garoys
shtat/N [m] [def: state]
	eybershtat/N [m] [def: high part of town] 
	varshtat/N [m] [def: workshop] 
shtat/N [m] [def: pomp] 
	[idiom: firn a groysn shtat = live in high style]
	[idiom: haltn shtat = keep up appearances]
shtat/V/T /Goys [def: equip, fit out, endow]
	oysshtatung/N [f] [def: equipment] 
shtayer/V/T [def: support] /Goys [def: equip] 
	bayshtayer/V/Bbaygeshtayert [def: contribute, tax, donate] [grammar: not in present tense]
		baytsushtayern [infinitive]
	shtayer/N [m] [def: tax]
	bayshtayer/N [m] [def: contribution, taxation]
		bayshtayerer/S [m] [def: contributor, supporter] 
		bayshtayerung/N [f] [def: contribution, support] % Forwards
	oysshtayer/N [m] [def: equipment, outfit] 
shtayg/V/Bgeshtoygn [def: climb] /Gariber/Goyf/Garoyf
	/Bgeshtign /Gariber/Goyf/Garoyf % variant participle
	shtig/N [f] [def: stair] 
shteg/N [m] [def: path, lane, trail]
shtek/V/T [def: place] /Garoys/Garayn/Gop
	/Gon [def: catch a disease (with "zikh fun")]
	/Gunter [def: bind]
	farshtek/V/Bfarshtekt [def: place]
	bashtek/V/Bbashtekt [def: place] 
	shtekn/S [m] [def: stick] /Dshtek
	binshtok/N [m] [def: beehive] 
	rinshtok/N [m] [def: downspout] 
	vaynshtok/N [m] [def: grapevine]
	/Dtsoybershtek [def: magic wand] 
shtekh/V/Bgeshtokhn [def: poke; cut] /Gdurkh
	farshtekh/V/Bfarshtokhn [def: poke; cut]
	shtekhik/A [def: sharp; barbed; prickly; pungent, caustic] 
	tseshtekh/V/Btseshtokhn [def: poke] 
	shtekheve/V/T [def: poke] 
	shtokh/N [m] [def: prick, sting, pang, stab, insinuation]
		mesershtokh/N [m] [def: knife cut] 
	shtokh/Xshtekh [m] [def: stitch] 
	geshtikt/A [def: embroidered] 
	shtekhl/V/T [n] [def: prick] 
		shtekhlke/S [f] [def: prickle, barb] 
		shtekhler/S [m] [def: hedgehog (animal)] 
	shtekheli'r/V/Bshtekheli'rt [def: needle] 
shtekh [m] [def: barter] 
	shtekheve/V/Bshtekhevet [def: barter] 
shtel/V/T [def: place]
	/Garayn/Goyf/Gakegn/Gantkegn/Garoys/Gtsurik/Gtsu/Gtsunoyf
	/Gavek/Gop/Gtsuzamen/Gfest/Gayn/Gforoys/Ganider/Garoyf/Garum/Garop
	/Gunter/Giber
	/Gkegn [def: oppose] 
	/Gfor [def: introduce, perform] 
	/Goys [def: make out (a check)] 
	/Gon [def: pretend (with "zikh vi"); argue for (with "zikh")] 
	bashtel/V/Bbashtelt [def: order (goods)]
		bashtelt/A [def: custom-made] 
		bashtelung/N [f] [def: order (for goods)] 
		[idiom: farhaltene bashtelung = back order] [note: V]
	farshtel/V/Bfarshtelt [def: hide]
	tseshtel/V/Btseshtelt [def: group, arrange, line up] 
	shtel/N [m] shtelung/N [f] [def: position; disposition] 
		aynshtel/N [m] aynshtelung/N [f] [def: order]
		forshtelung/N [f] [def: performance, introduction]
		ibershtelung/N [f] [def: combination, permutation (mathematical)] 
		opshtel/N [m] [def: bus-stop; stop] opshtelung/N [f] [def: stop] 
			[idiom: on opshtel = non-stop]
		oyfshtel/N [m] oyfshtelung/N [f] [def: construction (mathematical)] 
		tseshtelung/N [f] [def: deployment] 
		tsuzamenshtelung/N [f] tsunoyfshtelung/N [f] [def: composition] 
		untershtel/N [m] untershtelung/N [f] [def: substitution (mathematical)] 
	kegnshtel [m] [def: opposition]
	mode-shtelung/N [f] mo'deshte'l/N [m] [def: fashion statement] [note: V] 
	oysshtel oysshtelung/N [f] [def: performance, exhibition] 
	onshtel/N [m] [def: pretense]
	shriftshteler/S [m] [def: author]
	tsunoyfshteler/S [m] tsuzamenshteler/S [m] [def: collector]
		tsuzamenshtel [def: collection] 
	untershtelik/A hintershtelik/A hintershtelikayt/N [f] [def: retarded]
	shtele/S [f] [def: position]
	anshtalt/N [m] [def: institution] 
	geshtel/N [n] [def: easel; scaffold; rack; stand]
	shtaltn/A [def: ??] % er iz geven faryosemt; itst iz er a shtaltner man
	[idiom: aynshteln dos lebn = risk one's life]
shtempl/V/T [def: stamp] shtempl/N [m] [def: stamp] 
	postshtempl/N [m] [def: postmark] 
shter/V/T [def: prevent] 
	tseshter/V/Btseshtert [def: destroy] tseshterung/N [f] [def: destruction]
		tseshterer/S [def: destroyer] /Iish [def: destructive] 
	farshter/V/Bfarshtert [def: prevent] 
		[idiom: der freyd-farshterer = party pooper] [note: V]
	shte'renish/N shterung/N [f] [def: obstacle] 
shtern/Dshternd [m] [def: star] [morphology: plural is same]
	geshternt/A [def: starry] oysgeshternt/A
shtertsl/Eekh [n] [def: lid] 
shtey/Vshteyn/Bgeshtanen [def: stand] /Garum/Gant/Gayn/Gon
	/Goyf [def: stand up] 
		[idiom: oyfshteyn tkhies{WHyT}-hameysem{hmTym} = be resurrected]
	/Gbay [def: be present, help, withstand]
	/Gtsu [def: oppose] /Goyf [def: rebel, awake]
	/Goys [def: surmount] 
	/Gop [def: stop over, lag behind]
	/Giber [def: turn sour] 
	shteyn % irregular infinitive
	farshtey/Vfarshteyn/Bfarshtanen farshtand [def: understand]
		farshtendik/A [def: intelligible] farshtendlekh/A
			farshtendlekhkayt/N [f] [def: intelligibility, intelligence] 
		misfarshte'ndenish/N [def: misunderstanding] 
		umfarshtendlekh/A [def: unintelligible] 
		zelbstfarshtendlekh/A [def: self-evident] 
		[idiom: es farshteyt zikh (aleyn) = of course, obviously]
	aynfarshtey/Vaynfarshteyn/Baynfarshtanen [def: agree] 
		aynfarshtey'enish/N [n] aynfarshte'ndenish [n] [def: agreement]
	bashtey/Vbashteyn/Bbashtanen [def: consist of, consent]
	antshtey/Vantshteyn/Bantshtanen [def: consist of; exist; congeal] 
		antshteyung/N [f] [def: rise, origin]
	shtand/N [m] [def: standing, estate, station] 
		bashtand/N [m] [def: situation] 
			voyl-bashtand/N [m] [def: well-being] 
		gegnshtand/N [m] [def: thing (German)]
		opshtand [def: separation] 
		oyfshtand/N [m] [def: uprising; rebellion] 
			oyfshtandler/S [m] oyfshtendler/S [m] [def: rebel] 
		tsushtand/N [m] [def: state, condition]
		umshtand/N [m] [def: circumstance]
		vidershtand/N [m] [def: opposition, resistance]
		vofn-shtilshand/N [m] [def: armistice; cease-fire] 
		voylshtand/N [m] [def: public health] 
	shtendik/A [def: continual] zelbstshtendik/A [def: independent] 
		bashtendik/A [def: continual] 
		onshtendik/A [def: respectible] umonshtendik/A [def: disrespectable] 
		fulshtendik/A [def: complete]
		zelbshtendik/A [def: independent] 
			zelbshtendikayt/N [f] [def: independence] 
	forshteyer/S [m] [def: president]
	shtender/S [m] stender/S [m] [def: podium] 
shteyger/S [m] [def: custom]
	ashteyger [def: after all]
	[idiom: lebns-shteyger = lifestyle]
shteyn/Eer/Dshteynd [m] [def: stone] farshteynert/A [def: stone]
	farshteynt/A [def: stony] 
	shteynern/A shteynerdik/A [def: stony] 
	burshtin [def: amber]
	eydlshteyn/Eer [m] [def: jewel] 
	grinshteyn/Eer [m] [def: jade] % Harduf 
	gruntshteyn/Eer [m] [def: cornerstone] % Harduf 
	maylshteyn/Eer [m] [def: milestone] 
	milshteyn/Eer [m] [def: millstone]
	oniklshteyn/Er [m] [def: onyx]
	shlayfshteyn/Er [m] [def: grindstone]
	tungshteyn [m] [def: tungsten (W)] 
	vinklshteyn/Eer [m] [def: cornerstone] 
shtif/V/T [def: stiffen] 
	farshtif/V/Bfarshtift [def: stiffen] 
	shtifer/S [m] [def: joker, brat]
	shtayf/A [def: stiff]
		farshtayf/V/Bfarshtayft [def: stiffen] 
shtif [prefix] [def: step- (genealogical)] shtifs [prefix]
shtik/Eer [n/f] /D [def: piece (of substance), small amount of, piece (in a performance)]
	teatershtik/Eer [n/f] [def: play] 
	shtiklekhvayz [adv] [def: piece by piece] 
	[idiom: kostn a shtik gezunt = damage health]
	[idiom: oysraysn a shtik harts = damage emotional calm]
shtik/V/T [def: suffocate] 
	dershtik/V/Bdershtikt [def: suffocate; choke]
		dershti'kenish/N [n] [def: suffocation] 
	farshtik/V/Bfarshtikt [def: suffocate] 
shtil/V/T [def: quiet] /Gayn
	farshtil/V/Bfarshtilt [def: quieten] 
	shtil/K [def: quiet] 
	shtilerheyt [adv] [def: silently]
	shtilkayt/N [f] shti'lenish/N [n] [def: silence] 
	shtil/V/T
		antshtil/V/Bantshtilt [def: quiet down] 
shtim/V/T [def: agree, vote] /Gayn/Gop/Gtsu
	bashtim/V/Bbashtimt [def: settle, appoint, designate]
		bashtimt/A [def: definite] 
		bashtimung/N [f] [def: agreement] 
			zelbstbashtimung/N [f] [def: self-determination] 
	shtimung/N [f] [def: mood, spirits] opshtimung/N [f] [def: voting]
		geshtimt/A [def: disposed] 
	tsushtimung/N [f] [def: agreement]
	froyenshtim/N [f] [def: women's vote] 
shtim/N [f] shtime/N [f] [def: voice] /Dshtim
shtink/V/Bgeshtunken [def: stink] 
	farshtink/V/Bfarshtunken [def: stink] 
	geshtank/N [n] [def: stink] 
shtits/V/T [def: support] /Gunter
	shtits/N [m] shtitse/S [f] [def: support (often with "gebn")] 
	shtitser/S [m] [def: supporter] 
	untershtitsung/N [f] [def: support] % Forwards
shtivl/X [m] [def: boot]
	shtivloyne/S [f] [def: boot ??] 
shtof/N [m] [def: material] 
	koylnshtof [m] [def: carbon (Ca)] 
	oyfraysshtof [m] [def: explosives] 
	runtslshtof [m] [def: seersucker] /In
	shtikshtof [m] [def: nitrogen (N)] 
	vasershtof [m] [def: hydrogen (H)] 
	zoyershtof [m] [def: oxygen (O)] 
	zumershtof/N [m] [def: summer-weight material] 
shtok/N [m] [def: floor, story]
shtok [adv] [def: completely] 
	[idiom: shtok nakht = full dark]
shtol/N [n] [def: steel] /Ien
shtolts/A [def: proud]
	shtoltsi'r/V/Bshtoltsi'rt [def: be proud] 
shtop/V/T [def: stuff] /Gon/Garayn/Goys
	/Gop [def: unclog, clear] 
		noz-o'pshtoper/S [def: decongestant] [note: V]
	farshtop/V/Bfarshtopt [def: stuff] 
shtopsl/Xekh [def: cigarette butt] 
shtor/N [m/f] [def: eye cataract, window shade]
shtorts/V/T [def: protrude]
	shtortsik/A [def: protruding]
shtot/Xshtet [f] /Dshtet [def: town]
	shtetldik/A shtotish/A shtetlsh/A [def: town] 
		kleynshtetldik/A kleynshtetlish/A kleynshtetlsh/A [def: small-town]
		groysshtotish/A [def: big-city] 
		oysershtotish/A [def: out-of-town] 
	havnshtot/Xhavnshtet [f] [def: port city] 
	heymshtot/Xheymshtet [f] [def: home town] 
	hoyptshtot/Xhoyptshtet [f] [def: capital]
	kroynshtot/Xkroynshtet [f] [def: capital] 
	veltshtot/Xveltshtet [f] [def: world-class city]
	geburt|sshtot/Xgeburt|sshtet [f] [def: birthplace]
	portshtot/Xportshtet [f] [def: port city] 
	hintershtot/Xhintershtet [f] [def: suburb] /Iish /Dhintershtet
	forshtot/Xforshtet [f] [def: suburb] /Iish
	onshtot [def: instead of] 
	bashtetik/V/Bbashtetikt [def: certify, confirm, corroborate, acknowledge, approve]
		bashtetikung/N [f] [def: confirmation, certification, acknowledgement, approval] 
shtotsik/A [def: steep] 
shtoyb [m/n] [def: dust, pollen] /Iik [def: dusty] 
	farshtoyb/V/Bfarshtoybt [def: make dusty] 
	vegsshtoyb [m/n] [def: traveller's dust] 
	blumenshtoyb [m/n] [def: pollen] 
	bashtoyb/V/Bbashtoybt [def: pollinate] bashtoybung/N [f] [def: pollination] 
shtoyn/V/T [def: astound]
	shtoynung/N [f] [def: astonishment] 
	dershtoyn/V/Bdershtoynt [def: astonish, amaze] 
shtoys/V/Bgeshtoysn [def: shove]
	/Gavek/Gon/Goys/Garum/Garoys
	/Gop [def: disgust (often with "b|emes")] 
	/Gtsuzamen/Gtsunoyf [def: collide] 
	farshtoys/V/Bfarshtoyst [def: shove] 
	tsuzamenshtoys/N [m] [def: collision] 
	/Dshtoys [def: mortar/pestle]
	opshtoyser/S [m] [def: bumper (automotive); bumper (bowling)] [note: V]
shtral/N [m] [def: sunbeam]
	shtral/V/T /Goyf [def: shine] 
	bashtral/V/Bbashtralt [def: shine on] 
	tseshtral/V/Btseshtralt [def: shine on] 
shtrayf/N [m] [def: stripe, strip] [usage: deprecated]
shtraykh/V/Bgeshtrokhn [def: mark]
	/Gunter [def: emphasize] 
	shtraykh/N/D [def: mark] 
	shtrikh/N [m] [def: trait, feature]
shtrayml/N [n] [def: Chassidic fur hat (clothing)]
shtreb/V/T [def: reach for]
	shtrebung/N [f] [def: striving, aspiration, pursuit]
shtrek/V/T [def: stretch] /Garoys/Goys
	dershtrek/V/Bdershtrekt [def: stretch] 
	tseshtrek/V/Btseshtrekt [def: stretch] 
shtreng/V/T [def: be severe] /Gon
	shtreng/K [def: severe] 
	onshtrengung/N [f] ongeshtrengtkayt/N [f] [def: effort] 
shtrik/V/T [def: sew] 
	shtrik/X [m/f] [def: rope] /D 
		gretshtrik/X [m] [def: clothesline]
	shtriker/S [m] shtrikerke/S [f] [def: needleworker] 
shtrikh/V/T [def: make a stroke]
	/Gunter [def: underline] 
	/Bgeshtrokhn [def: make a stroke] % variant participle
		/Gunter [def: underline] 
	shtrokh/N [m] [def: stroke, line]
	baystrikh/N [m] [def: comma]
	bindshtrikh/N [m] [def: hyphen] 
shtrimp [noun, collective] [def: hose (clothing)] 
shtrof/V/T [def: punish]
	bashtrof/V/Bbashtroft [def: punish]
	shtrof/N [f] [def: punishment] toytshtrof [f] [def: capital punishment] 
shtrom/V/T shtrom/N [m] [def: stream] 
	baystrom/N [m] [def: side stream] 
	hopytshtrom/N [m] [def: main stream]
	klangshtrom/N [m] [def: ??] 
	shtremung/N [f] [def: intellectual movement] 
shtroy/N [f] [def: straw] /Ien
shtroykhl/V/T [def: go astray (with "vern"), tempt]
	shtroykhlung/N [f] [def: temptation] 
	shtroykhl/N [m] [def: bump] /Idik [def: bumpy] 
shtroys/N [m] [def: ostrich]
shtroysl [def: bouquet]
shtrudl/N [m] [def: strudel (food)] 
shtshav [m] [def: sorrel] 
shtsherbe/V/T /Gon [def: notch, jag]
	shtsherbate/A [def: notched] 
shtshipe/V/T [def: nibble at] 
shtshire/V/T [def: grind (teeth), reveal the teeth] /Goys
shtshur/Ees [m] [def: rat] 
shtub/Xshtiber [f] [def: house, home] /Iik [def: houselike]
	/Dshtib [def: room, prayer-room]
	boydemshtub/Xboydemshtiber [f] [def: attic room] /Dboydemshtib
	shlofshtub/Xshlofshtiber [f] [def: bedroom] /Dshlofshtib
	verkshtub/Xverkshtiber [f] [def: workroom] 
shtudi'r/V/Bshtudi'rt [def: study] /Goys
	shtudye/S [f] [def: study] 
	student/N [m] [def: student] /Iish studentke/S [f] [def: student] 
shtuke/S [def: trick]
	[idiom: shpiln a shtuke = play a trick]
	[idiom: makhn shtukes = play tricks]
	[idiom: a shtuke a yung = a hulk of a youngster]
	shtukeve/V/T /Gtsunoyf [def: piece together] 
shtul/N [f/m] [def: chair]
	fotershtul/N [f/m] [def: easy chair]
	vebshtul/N [f] [def: loom] 
shtum/A [def: voiceless] /Eerheyt [adv] [def: voicelessly]
	shtumkayt/N [f] [def: voicelessness] 
	antshtum/V/Bantshtumt [def: silence]
	farshtum/V/Bfarshtumt [def: silence] 
shtumpik/A [def: stupid] 
shtund/N [f] [def: hour (German)] 
shtup/V/T [def: shove, have intercourse (vulgar)]
	/Garayn/Garoyf/Gavek/Garoys/Gdurkh/Gtsu/Gop
	farshtup/V/Bfarshtupt [def: shove] 
	shtu'penish/N [n] [def: congestion]
	aroyfshtup/N [m] [def: press-up (athletic exercise)] 
	[idiom: shtup-sho{Seh} = rush hour]
shturem/V/T [def: storm]
	shturem/S [m] [def: storm] /Idik shturmish/A
	shneyshturem/N [m] [def: snowstorm] 
shturkats/N [m] [def: torch] 
shturkh/V/T [def: jostle, poke]
	shturkh/Ees [m] [def: poke, bump, jab]
shtus{StwT}/Xshtusem{StwTym}/H [m/n] [def: foolishness]
	shtuseray'{StwTeray}/N [n/f] [def: foolishness] 
	shoyte{Swth}/H [m] [def: fool] 
shtutshke/S [def: trickery (Polish)] 
shufl/N [m] [def: shovel; scoop] 
	shufl/V/T [def: shovel] 
shuflod/N [m] [def: drawer (furniture)] 
shukh/Xshikh [m] [def: shoe (clothing)] /Dshikhk
	klapshukh/Xklapshikh [m] [def: tap-dance shoe (clothing)] [note: V]
	shtekhshukh/Xshtekhshikh [m] [def: slipper]
	shuster/S [m] shusterke/S [f] [def: cobbler] 
		shusteray/N [n] [def: shoe-making] 
	puent-shukh/Xpuent-shikh [m] [def: pointe shoes (ballet)] [note: V]
shul/N [f] shule/S [f] shil/N [f] [def: school; synagogue]
	mitlshul/N [f] [def: high school]
	fakhshul/N [f] [def: vocational school] 
	folkshul/N [f] [def: elementary school]
	ovntshul/N [f] [def: night school] 
	togshul/N [f] [def: day school (religious)] 
	vaybershul/N/Dvaybershulkh [f] [def: women's section of synagogue]
	shiler/S [m] shilerin/S [f] [def: student] 
	shilekhl/Eekh [n] [def: chapel (in a synagogue)] [note: V] 
	oysgeshult/A [def: schooled; trained] 
shuld/N/Iik [f] [def: guilt]
	shuldikayt/N [f] [def: guiltiness] 
	antshuldik/V/Bantshuldikt [def: excuse] antshuldikung/N [f] [def: excuse]
	bashuldik/V/Bbashuldikt [def: accuse] bashuldikung/N [f] [def: accusation]
	farshuldik/V/Bfarshuldikt [def: convict]
	umshuldik/A [def: innocent]
	mitshuldiker/X [def: co-defendant] 
	[idiom: got di neshome shuldik = completely innocent]
shum{Swm}/H /Lb [def: in no way]
shund/N [m] [def: cheap (in quality)] 
shup/N [n] [def: scale (fish), flake, dandruff] 
shure{Swrh}/Xshures{SwrwT}/H [f] [def: line] 
	shuredik{Swrhdik}/A [def: lined] 
shurek{Swrwk}/H [def: Hebrew vowel point shuruk] 
shushke/V/T [def: quiet] 
shutef{SwWf}/Xshutfem{SwWfym}/H [m] [def: partner]
	shutfes{SwWfwT}/H [n] [def: partnership] /Lb [def: in partnership] 
	bshutfes{bSwWfwT} [def: joint, in partnership] /Idik
	b|shutfesdikayt{SwWfwTdikayt}/N [f] [def: partnership] 
shvakh/K [def: weak]
	shvakhkayt/N [f] [def: weakness] 
	shvakh/V/T [def: weaken] /Gop
	opshvakhung/N [f] [def: weakening] % might not exist in non-combined form
shvalb/N [f] /Dshvelb [def: swallow (bird)] 
shvan/N [m] [def: swan (bird)] 
shvarts/A [def: black]
	shvarts/A [def: Negro] [usage: no longer acceptible]
	shvarts/A [def: brunette]
	shvarts [n] [def: spades (playing cards)] % no plural?
	shvartskayt/N [f] [def: blackness] 
	shvarts/V/T [def: blacken (with "zikh")] 
	farshvarts/V/Bfarshvartst [def: blacken, oppress] 
shvayg/V/Bgeshvign [def: be silent] 
	antshvayg/V/Bantshvign [def: become silent] 
	farshvayg/V/Bfarshvign [def: be silent about] 
		farshvaygung/N [f] [def: silence] 
	shvay'genish/N [def: silence]
		shtilshvay'genish/N [def: complete silence] 
	shvayger/S [m] shvaygerin/S [f] [def: silent person] 
	shtilshvaygn [m] [def: armistice; silence] /Idik [def: silent] 
shveb/V/T [def: sweep; soar; float (in the air)] /Gdurkh/Gtsu
shvebl/Xshveblekh [m] shvebele/Xshvebelekh [def: sulfur (S); match]
shvel/N [f/m] [def: doorstep, threshold] 
shvenk/V/T [def: rinse] /Goys/Gop
	bashvenk/V/Bbashvenkt [def: rinse] 
	farshvenk/V/Bfarshvenkt/Bfarshvonken [def: flood] 
	horshvenkekhts/N [n] nokhtsvog-shvenkekhts/N [n]nokhtsvog-shvenkekhts/N [n]  [def: hair conditioner] 
shver/K [def: difficult]
	shverikayt/N [f] shverkayt/N [f] [def: difficulty] 
shver/V/Bgeshvorn/Bgeshvoyrn [def: swear] 
	bashver/V/Bbashvorn [def: cause to swear, exorcise] 
		bashverung/N [f] [def: exorcism] 
		bashverer/S [m] [def: exorcist] 
	farshver/V/Bfarshvorn [def: conspire] farshverung/N [f] [def: conspiracy] 
	shve'renish/N [def: swearing] 
	geshvoyrener [n] [def: jurist] /Xgeshvoyrene [def: jury] 
shverd/N [f] [def: sword (weapon)] /D
shvester/X [f] [def: sister]  /D 
	geshvester [def: siblings (German)]
shveys [m] [def: sweat] 
shviger/S [f] [def: mother-in-law]
	shvigerin/S [f] [def: sister-in-law] 
	shvoger/S [m] [def: brother-in-law] 
	shver/N [m] [def: father-in-law]
	/Xshver-un-shviger [def: in laws (parents only) (only in plural)]
shvim/V/Bgeshvumen [def: swim, float; wallow] /Gavek
	tseshvim/V/Btseshvumen [def: swim about] 
	shvum/N [m] [def: swimming stroke; swim] 
shvindl/V/T [def: be dizzy, cheat] /Gadurkh
	shvindler/S [m] shvindlyak [m] shvindlyuk [m] [def: swindler, cheat] 
	shvindlak [m] [def: swindler, cheat] 
	bashvindl/V/Bbashvindlt [def: defraud] 
shvits/V/T [def: sweat] /Iik /Gdurkh
	farshvitst/A [def: sweaty] 
	shvitser/S [m] [def: braggart] 
shvom/N [m/f] /Dshvem [def: sponge, mushroom] 
shvue{SBweh}/Xshvues_{SBwewT}/H [f] [def: oath]
	mashbiye{mSbeh} [def: exorcise (with "zayn")] 
	hashboe{hSBeh} [def: exorcism]
shvues{SBewT}/H [m] [def: holiday of Shavuoth] 
shvung/N [m] [def: zest, swing] [usage: doubtful admissability]
sibe{sybh}/Xsibes{sybwT}/H [f] [def: reason] 
siborgyum [m] [def: seaborgium (Sg)] 
sider{sydwr}/Xsidurem{sydwrym}/H [m] [def: prayer book] 
	siderl{sydwrl}/Xsiduremlekh{sydwrymlekh} [def: prayerbook] 
signa'l/N [m] [def: signal] 
	signali'r/V/Bsignalirt signalizi'r/V/Bsignalizir't [def: signal] 
	signalizatsye/S [f] [def: (electronic) signaling equipment] 
sikhsekh{syxswx}/Xsikhsukhem{syxswxym}/H [m] [def: quarrel; conflict]
silek{sylwk}/H [m] [def: settlement]
	silek{sylwk}/V/T [def: pay off debts to someone (with "mit")]
	[idiom: a halber silek = partial payment]
silitsyum [m] [def: silicon (Si)] 
silvester [m] silvester-ovnt/N [m] [def: New-Year's Eve] 
silye/V/T /Gon [def: string objects on a thread]
simbol/N [m] [def: symbol] /Iish
	simbolizm/N [m] [def: symbolism] 
	simboleve/V/T /Garayn [def: read symbolism into something] 
simen{symn}/Xsimonem{symnym}/H [m] [def: symbol, abbreviation] 
simetrye/S [f] [def: symmetry] simetrish/A [def: symmetric] 
simfonye/S [f] [def: symphony] simfonish/A [def: symphonic] 
simkhe{QymHh}/Xsimkhes{QymHwT}/H [def: party, affair] /Lb 
	simkhas{QymHT}/H [def: joy of, holiday of Simkhas Toyre (with "- toyre")] 
	mesameyekh{mQmH}/H [def: entertain (with "zayn")] 
	kale{Klh}-simkhe{QymHh} [f] [def: bridal shower] [note: V] 
simpatye/S [f] [def: sympathy] simpatish/A [def: sympathetic] 
	simpatizi'r/V/Bsimpatizi'rt [def: sympathize] 
simpozyum/N [m] [def: symposium] 
simpto'm/N [m] [def: symptom] /Iatish [def: simptomatic] 
	tsuriktsi-simpto'm/N [def: withdrawal symptoms (addiction)] [note: V] 
sin{Qʼ}/H [m/f] [def: Hebrew letter Sin] 
sindika't/N [m] [def: syndicate] 
	sindika'l/A [def: syndicate] 
	sindiki'r/V/Bsindiki'rt [def: syndicate]
sindrom/N [def: syndrome] 
sine{Qyn#h}/H [def: hatred]
	sinas{Qn#T} [def: hatred of] 
	soyne{Qwn#}/Xsonem{Qwn#ym}/H [def: enemy]
	soyney{Qwn#y}/H [def: enemies of]
	[idiom: onnemen dem tsad funem soyne{Qyn#} = play devil's advocate] [note: V]
	[idiom: zikh onshteln farn soyne{Qyn#} = play devil's advocate] [note: V]
sinke [f] [def: blueing (laundry product)]
sinkhronizi'r/V/Bsinkhronizi'rt [def: synchronize] 
sinonim/N [m] [def: synonym] 
sinopsis/N [m] [def: synopsis; plot (story)] 
sintaks [m] [def: syntax]
sintez/N [m] [def: synthesis] 
	sintetish/A [def: synthetic] 
siper{sypwr}/Xsipurem{sypwrym}/H [m] [def: story; storytelling] 
sirene/S [f] [def: siren] % Harduf
sistem/N [f] [def: system] /Iatish [def: systematic] 
	shraybsistem/N [f] [def: writing system]
sitshke [f] [def: horse food] 
situatsye/S [f] [def: situation] 
sivn/H [m] [def: Hebrew month of Sivan]
siyem{sywm}/H [def: feast of completion] 
skabke/S [f] [def: splinter] 
skandal/N [m] [def: scandal] /Iyez [def: scandalous] 
skandyum [m] [def: scandium (Sc)] 
skale/S [f] [def: scale (measure)] 
skarpe't/N [m] [def: stocking, sock] 
skelet/N [m] [def: skeleton] /Iish [def: skeletal] 
skeptitsizm/N [m] skepsis/N [m] skeptishkayt/N [f] [def: skepticism] 
	skeptish/A [def: skeptical] 
skhakh{sxx}/H [def: sukkoh topping (religious)] 
skhar{Qxr}/H [def: payment]
skheme/S [f] [def: scheme, pattern] 
skhoyre{sHwrh}/Xskhoyres{sHwrwT}/H [f] [def: merchandise] 
	leger-skhoyre{sHwrh} [def: shopworn articles] 
	shvarts-skhoyre{sHwrh} [def: black-market articles] 
	miskher{msHr}/Xmiskhorem{msHrym}/H [m] [def: merchandise]
		miskher{msHr}/H/V/T [def: buy and sell] 
	soykher{swHr}/Xsokhrem{swHrym}/H [m] [def: merchant] /Iish 
		hurt-soykher{swHr}/Xhurt-sokhrem{swHrym} [m] [def: wholesaler] 
	skhires{sHyrwT}/H [def: merchandise] 
skhum{sxwm} [m] [def: sum total] 
ski/X [m] [def: ski] 
skirde/S [f] [def: haystack, pile] 
skitse/S [f] [def: sketch, draft] 
	skitsik/A [def: sketchy] 
	skitsi'r/V/Bskitsi'rt [def: outline, sketch] 
sklad/N [m] [def: warehouse, lumberyard, storehouse, coalyard] 
	/D [def: collection] 
skorpyo'n/N [m] [def: scorpion (animal)] % Harduf
skotsl [def: look who's here! (with "- kumt")] 
skrabne/A [def: elegantly dressed (woman) (Polish)] 
skripe/V/T [def: scrape, play (violin)]
	skrip/N [m] [def: squeak, creak]
skrukh/N [m?] [def: shudder ??] % ikh derfil a skrukh ibern layb
skulptor/N [m] skulptorin/S [f] [def: sculptor] 
	skulptur/N [f] [def: sculpture]
slikhes{slyHwT}/H [def: penitential prayers] 
sline/S [f] [def: saliva, spittle]
sloy/Ees/Iik [m] [def: jar] 
slup/Ees [m] [def: pole, post]
sluzhe/V/T [def: serve faithfully] 
smalye/V/T [def: be brave (Russian), singe] 
	farsmalyet/A [def: singed] 
	smalye/S [m] [def: burn] 
smetene [f] [def: sour cream] 
smikhe{smyxh}/H [f] smikhes{smyxwT}/H [def: ordination] 
	smakh{smx}/H [m] [def: authority] 
	asmakhte{asmxW#}/Xasmakhtes{asmxWwT}/H [def: support (textual)]
	soymekh{swmx} [def: depend, rely on (with "zikh zayn oyf")] 
smitshik/Ees [m] smik/Ees [m] [def: bow (violin)] 
smoking [m] [def: smoking jacket, tuxedo (clothing)] 
smole [f] [def: tar, pitch, resin] /Idik [def: tarry, sulfurous]
smore/V/T [def: snort] 
smotshke/V/T [def: smack the lips] 
smutne/A [def: lonely; sorrowful, sad] 
snast [def: ??] % kuk nit oyf mayn snast, vos ikh bin azoy dar
snob/N [m] [def: snob] /Iish % Harduf
snop/Ees [m] [def: sheaf (grain)] 
sobek [def: money stash] 
sod/Xseder [m] [def: orchard] /Dsed [def: park] 
	karshnsod/Xkarshnseder [m] [def: cherry orchard] 
sod{swd}/Xsoydes{swdwT}/H [m] [def: secret]
	/Lb [def: in secret] /Idik/Iful [def: secret]
	bsodik{bswdik}/A [def: secret] 
	soyde{swde}/V/T [def: exchange secrets (with "zikh")] 
	farsoydet{farswdet}/A [def: secret] 
	[idiom: a sod far gants brod = an open secret]
sode [f] [def: soda]
	baksode [def: baking soda]
	vani'l-sode [f] vani'le-sode [def: cream soda] [note: V]
sof{swf}/H [def: end] /Ll
	sofklsof{swf-Kl-swf}/H [def: all told] 
	eynsof{#yn-swf}/H [def: infinity] /Iik [def: infinite] 
	[idiom: az der sof iz gut iz alts gut = all's well that ends well]
sofek{sfk}/Xsfeykes{sfkwT}/H [def: doubt]
	mesupek{mswpk}/H [def: doubtful] /Idik [def: doubtful] 
sofke/S sofe/S [f] [def: sofa]
sok/N [m] [def: syrup, sap] 
sokhe/S [def: scythe] 
soldat/N soldatske/S [m] [def: soldier] 
solid/A [def: solid] 
	solidarish/A [def: in solidarity]
	solidarishkayt/N [f] solidarite't [f] [def: solidary] 
	solidarizi'r/V/Bsolidarizi'rt [def: agree (with "zikh mit"); support] 
soli'st/N [m] solistke/S [f] [def: soloist (musical)] 
solovey/N [m] [def: nightingale] 
sope/S [f] [def: ladle] 
sope/V/T [def: pant, breathe heavily] 
sored{Qryd}/H [def: remnant, impotent man] 
soroke/S [f] [def: magpie (bird)] 
sort/N [m] [def: sort] 
	sorti'r/V/Bsorti'rt [def: sort] 
sos/N [m] [def: gravy (food)] 
	tunksos/N [m] [def: dip (food)] [note: V]
soshlke/S [def: lake]
sosne/S [def: fir (tree)] 
sotsyal/A [def: social] /Iish
	sotsyalizm [m] def: socialism]
		sotsyali'st/N [m] sotsyalistke/S [f] [def: socialist]
		sotsyalistish/A [def: socialist] 
	sotsyologye/S [f] [def: sociology] sotsyologish/A [def: socialogical] 
		sotsyolog/N [m] [def: sociologist] 
sove/S [f] [def: owl] 
sozhe/S [f] [def: soot] 
spageti [def: spaghetti (food)] 
spa'klyeve/V/T [def: apply spackle] 
sparzhe [f] [def: asparagus (food)] 
spazme/S [f] [def: spasm] 
spektakl/N [m] [def: spectacle] 
spekulatsye/S [f] [def: speculation] 
	spekuli'r/V/Bspekuli'rt [def: speculate]
	spekulan't/N [m] [def: speculator] 
spetsye'l/A [def: special]
	spetsyalizi'r/V/Bspetsyalizi'rt [def: specialize] 
	spetsifish/A [def: specific] 
	spetsyali'st/N [m] [def: specialist] 
	spetsyalite't/N [f] [def: specialty] 
spinke/S sponke/S [f] [def: cufflink]
spira'l/N [m] [def: spiral] /Iish
spirt [m] [def: spirit (alcohol)] 
	vaynspirt [m] [def: grain alcohol] 
spodik/S [m] [def: hat (high fur cap trimmed in plush or fur) (clothing)]
	[idiom: dreyen a spodik = annoy]
spodnitse/S [f] [def: petticoat] spudnitse/S [f]
sponta'n/A [def: spontaneous] 
	spontanve/V/T [def: improvize, jam (music)] [note: V] 
sporadish/A [def: sporadic] 
sport/N [m] [def: sport]
	sportler/S [m] [def: sportsman] 
sprenzhine/S [f] sprunzhine/S [f] spruzhine/S [f] [def: spring (device)] 
sreyfe{Qrfh}/Xsreyfes{QrfwT}/H [def: fire]
	nisref{nQrf}/H [def: burned, person affected by a fire] 
srore{Qrrh}/Xsrores{QrrwT}/Xsrorem{Qrrym}/H [def: lord]
stabi'l/A [def: stable; stationary]
	stabilizi'r/V/Bstabilizi'rt [def: stabilize]
		stabilizatsye/S [f] [def: stabilization] 
	stabilkayt/N [f] [def: stability] 
	stabilite't/N [f] [def: stability] [usage: doubtful admissability] % Forwards
stade/S [f] [def: herd of animals] 
stadye/S [f] [def: stadium] 
stagnatsye/S [f] [def: stagnation] 
stam{sWm}/H [def: plain, regular, ordinary] [grammar: attributive] /Iik
standard/N [m] [def: standard] /A
	standardizi'r/V/Bstandardizi'rt [def: standardize]
	farstandardizi'r/V/Bfarstandardizi'rt [def: standardize] 
	standardizirung/N [f] [def: standardization] 
stantsye/S [f] [def: station] 
	statsye/S [f] [usage: inadmissable]
	[idiom: haltn stantsye = to board (at a rooming house)]
stare/V/T [def: endeavor, try hard (with "zikh")] 
stareste/S [def: head of organization, chairman (Russian)] 
startshe/V/T [def: protrude] 
statetshne/A [def: stately] 
statish/A [def: stationary, immobile] 
statistik [f] [def: statistics (subject)]
	statistish/A [def: statistical] 
statue/N [f] [def: statue] 
status/N [m] [def: status] 
stav/N [m] [def: artificial lake, artificial pool, artificial pond]
staye/V/T [def: suffice, last] 
stazh/N [m] [def: length of service; seniority] 
stelye/S [f] [def: ceiling] 
stenografye [f] [def: stenography] 
	stenografi'st/N [m] stenografistke/S [f] [def: stenographer] 
step/Ees [m] [def: steppe (geographical term)]
stereotip/N [m] [def: stereotype] 
sterilizi'r/V/Bsterilizi'rt [def: sterilize; neuter, spay] 
steshke/S/D stezhke/S/D stetshke/S/D [def: path] % all acceptible
steynge/S [f] [def: ribbon]
stikhye/S [f] [def: elemental force; the elements] 
	stikhish/A [def: elemental] 
stil/N [m] [def: style] stilistik [def: stylistics] 
stimuli'r/V/Bstimuli'rt [def: stimulate] 
stipendye/S [f] [def: stipend; scholarship]
	stipendyant/N [m] [def: receiver of stipend] 
stire{sWyrh}/Xstires{sWyrwT}/H [f] [def: contradiction] 
	b|seyser{sWr}/H [def: privately] 
stiseve/V/T [def: jibe, concur] 
stolyer/S [m] [def: cooper, carpenter, cabinetmaker (occupation)] /Iske
	stolyeray'/N [n] [def: cooperage] 
stoyp/N [m] [def: post, pole, stake; pile] 
	[idiom: baym stoyp = at the stake]
strakhi'r/V/Bstrakhi'rt [def: insure]
	strakhirung/N [f] [def: insurance]
	farstrakhi'r/V/Bfarstrakhi'rt [def: insure] 
straptshe/S [m] [def: policeman] 
	[idiom: ikh bin nit gots straptshe = I am not in charge of religious purity]
strashe/V/T [def: threaten] /Goys
	strashidle/S [f] [def: scarecrow] 
strayk/V/T [def: strike (labor)] 
	strayk/N [m] [def: strike (labor)] 
strategye/S [f] [def: strategy] 
strofe/S [def: verse]
stronge/S [f] [def: trout (fish)] 
strontyum [m] [def: strontium (Sr)] 
stroyer/V/T [def: adjust] /Gon
strozh/Xstrezher [m] strozhke/S [f] struzh/N/Ees [m] struzhnik/Ees [def: janitor; building superintendent]
struktur/N [f] [def: structure] 
	infrastruktur/N [f] [def: infrastructure] 
	strukturi'r/V/Bstrukturi'rt [def: structure] 
/Xstrulkes [def: jacks (game)] [note: Stutshkov]
strune/S [f] [def: string (of a musical instrument)]
strushke/S [f] struzhke/S [f] [def: wood shaving; chip] 
stsene/S [f] [def: scene] 
	stsenar/N [m] [def: scenario] 
	instseni'r/V/Binstseni'rt instsenizi'r/V/Binstsenizi'rt [def: dramatize] 
	stseni'r/V/Bstseni'rt [def: dramatize] [usage: doubtful admissability]
sturde/S [def: rick (of hay)]
sublimi'r/V/Bsublimi'rt [def: sublimate] 
subotnik/Ees [m] [def: Christian observing Sabbath on Saturday] 
subsidye/S [f] [def: subsidy] % Harduf
substa'nts/N [f] [def: substance] 
	substanti'v/N [m] [def: noun (grammar)]
subtil/A [def: subtle] 
subye'kt/N [m] [def: subject]
	subyekti'v/A [def: subjective (grammar)] 
sude{sewdh}/Xsudes{sewdwT}/H [f] [def: feast, festive meal]
	sudenyu{sewdhnyu} [def: dear feast] 
suf{swf}/H [def: Reed sea (with "yam{|ym}")]
sufiks/N [m] [def: suffix] 
sufit/N [m] [def: ceiling]
sugye{swgy#}/H [f] [def: subject (in Talmud)] 
suk/Ees [m] [def: knot (in wood); gnarl] 
	sukate/A sukevate/A [def: gnarled, knotty] 
suke{swKh}/Xsukes{swKwT}/H [f] [def: booth for festival of Sukkoth] 
sukhostoy [m?] [def: dried-up tree] 
sulta'n/N [m] [def: sultan] % Harduf
sumatokhe/S [f] [def: mess, confusion, uproar] 
sume/S [f] [def: sum] 
sumi'r/V/Bsumi'rt [def: add up] 
sumne/A [def: mournful, gloomy, drab]
suni't/N [m] suni/S [m] [def: Sunni (Moslem)] 
superlativ/N [def: superlative] 
surdut/N [m] [def: long coat] 
surealistish/A [def: surrealistic] 
surpri'z/N [m] [def: cause of alarm] 
sus{sws}/Xsusem{swsym}/H [m] [def: horse] 
suveni'r/N [m] [def: souvenir] % Harduf
suveren [m] [def: sovereign] 
	suverenitet/N [f] [def: sovereignty] 
suzhe't/N [m] [def: plot (story)] 
svastike/S [f] [def: swastika] % Harduf
sveter/S [m] [def: sweater] 
svishtshe/V/T [def: whistle piercingly] 
	svishtsh/N [m] [def: piercing whistle] 
	tsvitshe/V/T tsvitsher/V/T [def: twitter (sound of a bird)] 
svive{sByBh}/Xsvives{sByBwT}/H [def: neighbornood, milieu, environment] /Idik
svore{sBr#}/Xsvores{sBrwT}/H [f] [def: opinion, obvious conclusion] 
	masber{msbyr}/H [def: be of the opinion (with "zayn")] 
tabak/N [m] tabeke [def: tobacco] tabik [m] [def: snuff]
	tabatshnik/Ees [m] [def: tobacconist] 
	[idiom: vert a shmek tabak = worthless]
tabele/S/Xtabeln [f] [def: table]
tabune/S [def: herd of horses] 
taburetke/S [f] [def: stool]
tadl/V/T [def: wag a finger] 
taflye/S [f] [def: slab, panel, window pane]
	[usage: "pane" is of doubtful admissability] 
take [adv] [def: indeed, truly] 
takef{Wkyf}/Xtakifem{Wkyfym} [m] [def: influential person]
takhbule{Wxbbulh}/Xtakhbules{WHbwlwT}/H [f] [def: means, remedy]
takhles{WxlyT}/H [def: purpose] /V/T
takhrikhem{Wxryxym}/H [def: shrouds] % only in plural
takt/N [def: tact, (music) measure, cadence]
takse/S [f] [def: tax on kosher meat]
	[idiom: hobn a kheylek in der takse = get a percent of the meat tax]
taksi/S [m/n] [def: taxicab] 
talanke/V/T [def: clang (sound of tin bells)] 
tala'nt/N [m] [def: talent]
	talanti'rt/A [def: talented]
	talantarnye/S [f] [def: talent show]
tales{tlyT}/Xtaleysem{tlyTym}/H [m] [def: prayer shawl] 
talmed{Wlmyd}/Xtalmidem{Wlmydym}/H [m] [def: student]
	talmido{Wlmydh}/Xtalmides{WlmydwT}/H [f] [def: student] 
	talmedl{Wlmydl}/Xtalmidemlekh{Wlmydymlekh}/H [m] [def: student]
	talmidey{Wlmydy}/H [def: students of]
	talmud{Wlmwd}/H [m] [def: Talmud] 
	melamed{mlmd}/Xmelamdem{mlmdym}/H [m] [def: teacher (kheder)]
		melamdish{mlmdish}/A [def: learned] 
	limed{lymwd}/Xlimudem{lymwdym}/H [m] [def: subject of study] 
		/Xgezelshaft-limudem{lymwdym} [f] [def: social studies] 
	lamdn{lmdn}/Xlamdonem{lmdnym}/Xlomdem{lwmdym}/H [m] [def: scholar]
		lamdones{lmdnwT}/H [n] lomdes{lmdwT}/H [def: scholarship] 
		lomdish{lwmdish}/A [def: scholarly] 
	melumed{mlwmd}/Xmelumodem{mlwmdym}/H [m] [def: sage]
talyum [m] [def: thallium (Tl)] 
tam{tem}/N/Xtamem{temym}/H [m] [def: taste; reason]
	batamt{batemt}/A [def: tasty] umbatamt{umbatemt} [def: tasteless, tacky] 
	[idiom: nit hobn keyn tam{tem} = be unappealing]
tam_{Wm}/H [def: simple] /Ievate
	temimes{WmymwT}/H [n] [def: simplicity] /Idik [def: simple] 
tamez{Wmwz}/H [m] [def: Hebrew month of Tammuz] /Idik [def: summer-like] 
tanakh{Wn|"x}/H [m] [def: Bible] 
tango/S [m] [def: tango] 
tank/N [m] [def: tank (military); tank (vessel)] % BUG: plural should generate tankn?
tano{Wn#}/H [m] [def: Mishnaic authority] 
tantalum [m] [def: tantalum (Ta)] 
tante [f] [def: aunt] 
tants/V/T [def: dance] /Gfunander/Gmit/Gakegen/Gop
	/Gnokh [def: imitate, ape] 
	tants/Xtents [m] /Dtents [def: dance]
	tentser/S [m] tentserin/S [f] [def: dancer]
	kla'ptants/V/T [def: tap-dance] [note: V]
		kla'ptentser/S [m] [def: tap tancer] [note: V]
tap/V/T [def: touch; probe; grope] /Gon/Garum
	dertap/V/Bdertapt [def: reach, find] 
	batap/V/Bbatapt [def: touch] 
	ta'penish/N [def: probing] 
taptshan/N [def: sofa] 
taraka'n/Ees [m] [def: cockroach] 
tarara'm [m] tarera'm [m] [def: commotion, fuss]
	tarara'm/V/T [def: make a fuss] 
	fartarara'mt/A [def: upset]
tarbes{WrbwT}/H [n] [def: politeness]
targ/N [def: market] 
targem{Wrgwm}/H [m] [def: Aramaic translation] 
tarif/N [m] [def: tariff] 
taryag{Wry"g}/H [def: 613, number of Biblical commandments] 
tash/N [f/m] [def: purse, bag, pocketbook; pouch; pocket]
	aktntash/N [def: briefcase (German)]
	buzemtash/N [def: shirt pocket] 
	homentash{hmn-tash}/N [def: Purim pastry (filled)] 
tashme/S [f] [def: tape] 
taske/V/T tashtshe/V/T [def: lug, pull, drag] /Gavek
tate/S/C/J/D [m] [def: father]
	tatenyu tateshi tatelyu [m] [def: dear father; daddy] 
	tatele [m] [def: little boy (affectionate)]
	/Idik [def: fatherly] 
tats/N [f/m] [def: tray] /Dtets [def: saucer] 
/Xtaybelekh [n] [def: stuffed cabbage (food)] % only in plural
tayer/K [def: dear] /Iink
tayge/S [f] [def: taiga (landform in Russia)] 
taykh/N [m] [def: river; lake (NY)] /D [def: creek, brook] 
tayne{tenh}/H/V/T [def: complain; argue; plead] /Goys/Gayn
	tayne{tenh}/Xtaynes{tenwT}/H [f] [def: complaint] 
	[idiom: hobn taynes{tenwT} tsu emetsn = complain about someone]
	[idiom: tsum lets hob taynes{tenwT} = out of our control]
tayneg{Wenwg}/Xtaynugem{Wenwgym}/H [m] [def: delight]
tayster/S [m] [def: wallet; purse]
	talye{Wlyh}-tayster/S [m] [def: fanny pack] [note: V] 
taytl/V/T [def: point out] 
	/Gon [def: accuse] 
	ontaytler/S [m] [def: whistleblower, accuser] 
taytsh/V/T [def: explain; interpret] /Goys/Giber
	taytsh/N [m/f] [def: meaning] 
	tsveytaytshik/A [def: ambiguous]
		tsveytaytshikayt/N [f] [def: ambiguity] 
	fartaytsh/V/Bfartaytsht [def: explain] 
	oystaytsher/S [m] [def: explainer]
		oystaytshung/N [f] [def: explanation]
	staytsh [def: how can it be?] 
	ivre{eBry}-taytsh [n] [def: archaic Yiddish] 
tayve{W#vh}/Xtayves{W#v|wT}/H [f] [def: desire]
	tayvas{W#vT}/H [def: desire of]
tayvl/Xtayvlonem{tIvlonym}/Xtayvolem{tIvolym} [m] [def: devil]
	tayvlonish/A [def: devilish, diabolical] 
te/Een [m] [def: the letter T] 
te-te-te' [interj] [def: well, well; what do you know (expression of surprise)] 
teater/S [m] [def: theater]
	teatra'l/N [m] teatra'lke/S [f] [def: showman, theater enthusiast] 
teke/S [f] [def: file (computer); briefcase] 
tekhiles{WHylwT}/H [def: outset, first of all] 
	lekhatkhile{lxWHylh}/H [def: before the fact] 
	haskhole{hTHlh}/Xhaskholes{hTHlwT}/H [def: beginning] 
tekhine{WHynh}/Xtekhines{WHynwT}/H [f] [def: women's prayer] 
tekhiye{Whyh}/H [def: rebirth]
	tekhiyas{WHyT}/H [def: rebirth of] 
tekhnetsyum [m] [def: technetium (Tc)] 
tekhnik [f] [def: technique; technology (subject)]
	tekhniker/S [m] [def: technician] 
	tekhnish/A [def: technical] umtekhnish/A [def: non-technical] 
	tekhnologye/S [f] [def: technology]
		tekhnolog/N [m] [def: tech] /Iish [def: technological] 
	tekhnikum/N [def: 2-year vocational school]
teksi/S [m] [def: taxi] 
tekst/N [m] [def: text] 
teksti'l/N [m] [def: textile] 
tekufe{Wkwfh}/Xtekufes{WkwfwT}/H [f] [def: season (of year)] 
teyl_{Wl}/H [m] [def: ruin]
teytl/N [m/f] [def: date (food)] 
telefo'n/N [m] /Iish [def: telephone] /Dtelefond [def: mobile phone] 
	telefoni'r/V/Btelefoni'rt [def: call on the telephone] /Gon
	kvetsh-telefon/N [m] [def: touch-tone phone] 
	tselfon/N [m] [def: cell phone] 
telegra'f/N [m] [def: telegraph]
	telegrafi'r/V/Btelegrafi'rt [def: send a telegram] 
telegrame/S [f] [def: telegram] 
teler/S [m] [def: plate; bowl] /D [def: saucer] 
teleskop/N/Iish [m] [def: telescope] 
televizye/S [f] [def: television] televizor/N [def: television] 
	fla'khekran-televizor/N [def: flat-screen television] [note: V] 
teluryum [m] [def: tellurium (Te)] 
teme/S [f] [def: theme, topic]
	tematik/N [f] [def: theme]
	hoyptteme/S [f] [def: main point] 
temp/A [def: dull; dense]
	temp/V/T [def: dull] /Gop [def: temper] 
temperame'nt/N [m] [def: temperament] 
temperatu'r/N [f] [def: temperature] 
templ/N [m] [def: temple]
tempo/S [m] [def: tempo, pace] 
tende'nts/N [f] [def: tendency] 
tendl/V/T [def: deal in second-hand goods] 
	tendler/S [m] tendlerin/S [f] [def: second-hand dealer] 
tener/X [m] [def: palm of hand]
tenis [m] [def: tennis (game)] 
tentativ/A [def: tentative, provisional] 
teologye/S [f] [def: theology]
	teolog/N [def: theologist] 
	teologish/A [def: theological] 
teorye/S [f] [def: theory]
	teoretiker/S [m] [def: theoretician] 
	teoretish/A [def: theoretical] 
tepekh/Eer [m] [def: rug]
terapye/S [f] [def: therapy] 
	terapevtish/A [def: therapeutic] 
terase/S [f] [def: terrace] 
terbyum [m] [def: terbium (Tb)] 
teritorye/S [def: territory] teritorye'l/A [def: territorial] 
termin/N [m] [def: term; deadline] /Iik
	terminologye/S [f] [def: terminology] 
	terminologish/A [def: terminological] 
termi't/N [m] [def: termite (insect)] 
termometer/S [m] [def: thermometer] 
tero'r [m] [def: terror] 
	terori'st/N [m] [def: terrorist] 
	terori'zm/N [m] [def: terrorism] 
terpke/A [def: sharp, tart] [grammar: may be left undeclined]
tes/H [m/f] [def: letter tes] 
tese/V/T [def: hew] /Goys [def: hew up] 
	[idiom: gey tese fleker = try to make sense of it]
test/N [m] [def: test] 
	brusttest/N [m] [def: breast (cancer) screening] 
tey [f] [def: tea]
teyg [n] [def: dough] [morphology: no plural]
	honikteygl/Eekh [def: a sweet baked good]
	zoyerteyg [n] [def: leaven] 
teykef{WyKf}/H [def: immediately] 
teyl/V/T [def: apportion; divide] /Goys/Gfunander/Gop/Gayn/Gmit/Gtsu
	tseteyl/V/Btseteylt [def: distribute; divide]
		tseteylung [f] [def: distribution, division, partition]
		tseteylevdik/A [def: divisable] umtseteylevdik/A [def: indivisable] 
		tseteylbar/A [def: divisable] [usage: inadmissable]
			umtseteylbar/A [def: indivisable] [usage: inadmissable]
	bateyl/V/Bbateylt [def: distribute] 
	farteyl/V/Bfarteylt [def: distribute] 
	bateylik/V/Bbateylikt [def: participate (with "zikh")]
		bateylikung/N [f] [def: participation] 
	fartilik/V/Bfartilikt [def: decimate, annihilate, exterminate, destroy]
		fartilikung/N [f] [def: destruction, annihilation] 
	teyl/N [m/f] [def: part] teylung/N [f] [def: division (arithmetic)] 
		teyler/S [m] [def: denominator] 
	onteyl [m] [def: participation] onteylung/N [f] [def: participation] 
	opteyl/N [m] [def: division, department]
		opgeteyltkayt/N [f] opteylung/N [f] [def: division, department] 
		[idiom: intensiver opteyl = intensiv-opteyl = intensive care (medical)] [note: V]
	bashtandteyl/N [m] [def: component]
	veltteyl/N [m] [def: part of the world] 
	teylvayz/A [def: partial] teylnvayz [adv] [def: bit by bit]
	merstnteyl/S [adv] meynstnteyl/S [adv] [def: for the most part] 
	urtl/N [m] [def: sentence] 
		farurtl{far#urtl}/V/Bfarurtlt{far#urtlt} [def: sentence, doom] 
			farurtlung/N [f] [def: sentencing; condemnation] 
		fo'rurtl{for#urtl}/N [m] [def: prejudice] 
		[idiom: hobn a forurtl = be prejudiced]
		urteyl/N [m] [def: sentence] [usage: doubtful admissability]
			farurteylung/N [f] [def: sentencing; condemnation] 	
teyrets{Wyrwc}/Xteyrutsem{Wyrwcym}/H [m] [def: authoritative response]
teyt/V/T [def: kill] 
	toyt/A [def: dead]
	toyt/N [m] [def: death] 
	toyterheyt [adv] [def: in death] 
teyve{tBe}/H/S [f] [def: nature] /Lh /Lb
teyves{tBT}/H [m] [def: Hebrew month of Teves]
teze/S [f] tezis/N [m] [def: thesis] 
tfile{Wfylh}/Xtfiles{WfylwT}/H [f] [def: prayer]
	bal{bel}-tfile{Wfylh}/Xbaley{bely}-tfiles{WfylwT}/H [m] [def: prayer leader]
	mispalel{mTpll}/Xmispalelem{mTpllym}/H [m] [def: pray (with "zayn")] 
	tfilen{Wfylyn}/H [def: tefillin (religious wear)] % only in plural
	tifle{Wyflh}/H/S [f] [def: church] % also spelled phonetically
tfise{Wfys|h}/Xtfises{WfyswT}/H [f] [def: prison] 
tfu [def: fooey! (expression of disgust)]
	[idiom: tfu zolstu vern = go fly a kite (mild hetero-malo-petitive)]
tfutses{WfwcwT}/H [def: exile] 
tif/K [def: deep]
	ti'fenish/N [n] [def: deep place] tifkayt/N [f] [def: depth] 
	fartif/V/Bfartift [def: immerse; engross; delve into (with zikh)]
		fartifung/N [f] [def: depression, dip, recess] 
	fartifer/V/Bfartifert [def: deepen] 
		fartiferung/N [f] [def: deepening] 
tiferes{WfrT}/H [def: beauty] 
tifus [m] [def: typhus (disease)] 
tiger/S [m] [def: tiger] 
tik [def: tick (sound of a clock)]
	tak [def: tock (sound of a clock)]
	tik-tak [def: tick-tock] 
tiken{Wykwn}/Xtikunem{Wykwnym}/H [m] [def: repair] 
	takone{Wknh}/Xtakones{WknwT}/H [f] [def: correction] 
	[idiom: trinken tiken{Wykwn} = take a drink of shnapps at a yortsayt (Khasidic)]
tiket/N [def: ticket (English)] 
tilem{Whylym}/H/D [def: book of Psalms] 
tink [m/f] [def: plaster] 
tink/V/Bgetunkt [def: dip] /Gayn
	% both participles exist
	/Bgetunken /Gayn
	tunk/N [m] [def: dip] 
tint/N [f] [def: ink] 
	tinter/N/D [m] [def: inkwell] 
	tintler/S [m] [def: scribbler] 
tip/N [m] [def: type; type of person] /Iish
	stereotip/N [m] [def: stereotype] /Iish [def: stereotypic] 
tipesh{typS}/Xtiphsem{typSym}/H [m] [def: fool]
	tipshes{typSwT}/H [f] [def: foolishness] 
	tipsheva't/A [def: stupid] 
tir/N/D [f] [def: door]
	droysntir/N [f] [def: outside door] 
	hintertir/N [f] [def: back door] 
	paradtir/N [f] [def: street door] 
	[idiom: fun tir tsu tir = door to door]
tira'n/N [m] [def: tyrant] /Iish
	tiranye/S [f] [def: tyrrany] 
tirazh/N [m] [def: circulation (journal), drawing (lottery)] 
tirkhe{tyrHh}/Xtirkhes{tyrHwT}/H [f] [def: effort, trouble] 
tish/N/D [m] [def: table]
	estish/N/D [m] [def: dining-room table] 
	nakhttish/N/D [m] [def: nightstand] 
	shraybtish/N/D [m] [def: writing desk] 
	[idiom: tokhes{WHwT} afn tish = getting down to business (vulgar)]
tishebov{WSeh-b#B}/H [m] [def: commemorative day of the Ninth of Av] 
tishri{WSry}/H [m] [def: Hebrew month of Tishri] 
titanyum [m] [def: titanium (Ti)] 
titl/N [m] [def: title]
	ontitldik/A [def: untitled] 
	tituli'r/V/Btituli'rt [def: title] 
titun [m] [def: tobacco (for smoking)] 
tkheyles{WHylT}/H [def: purple] 
tkhoyr/N [m] [def: skunk] 
	[idiom: shtubiker tkhoyr = European ferret]
tkhum{WHwm}/H [m] [def: Sabbath boundary] 
tlie/V/T [def: smolder; glow (with "zikh")] 
tliye_{Wlyh}/Xtliyes{WlywT}/H [f] [def: gallow]
	talyen{Wlywn}/Xtalyonem{Wlynym}/H [def: hangman] 
tlo/N [f] [def: hoof] 
tlumik/Ees [m] klumik/Ees [m] [def: bundle] 
tnay{tn#y}/Xtnoyem{tno|ym}/H [def: condition; engagement agreement (plural)] 
	/Lb [def: conditional] 
	[idiom: shraybn tnoyem{tno|ym} = get engaged]
tnue{Wnweh}/Xtnues{WnewT}/H [f] [def: gesture] 
to [def: so]
toes{tewT}/H/N/D [m] [def: error, mistake] 
	toye{tweh} [def: err (with "zikh") (with "zayn")] 
tof{Wʼ}/H [m/f] [def: Hebrew letter Tof] 
tog/Xteg [m] [def: day]
	/Iik [def: daylike]
	teglekh/A [def: daily] togteglekh/A [def: daily]
	mitog [m] [def: noon] mitogs [def: lunch]
		frishtik-mitog [m] [def: brunch]  [note: V]
	nokhmitog/N [m] [def: afternoon]
	farmitog/N [m] [def: morning] 
	baytog/N [def: by day] /Iik [def: by day] 
	fartog/S [m] [def: dawn] /Iik [def: dawning] 
	farakhttogn [def: a week ago]
	tog/V/T [def: become day, dawn]
	geboyrntog/Xgeboyrnteg geburt|stog/Xgeburt|steg [m] [def: birthday] % Harduf
	haynttsutog [def: these days] 
	iberakhttogn [def: in a week] 
	danktog [def: Thanksgiving (American holiday)] 
	marktog/Xmarkteg [m] [def: market day] 
	oyftog/Xoyfteg [m] [def: daybreak] 
	shturemtog/Xshturemteg [m] [def: stormy day]
	vintertog/Xvinterteg [m] [def: winter day] 
	yortog/Xyorteg [m] [def: anniversary] 
	zumertog/Xzumerteg [m] [def: summer day] 
	[idiom: halber tog = midday]
	[idiom: heler tog = broad daylight]
	[idiom: a nekhtiker tog = it won't work; nonsense; impossibility]
tohore{thrh}/H [f] [def: ritual fitness] 
	tohor{thwr}/H [def: ritually fit] 
tok/V/T [def: turn on a lathe, fashion] 
	toker/S [m] [def: woodworker]
tokh{Wwx}/H [m] [def: contents] /Iik
	toykhn{Wwxn} [def: contents]
	besoykhem{bTwxm}/H [def: included]
tokhes{WHwT}/H [def: rear end (vulgar)]
	takhtoynem{WHWwnym}/H [def: underwear] [grammar: only in plural]
	[idiom: tokhes leker = sycophant (vulgar)]
	[idiom: kush mir in tokhes = kiss my ass (vulgar)]
tokhter/Xtekhter [f] [def: daughter] /Dtekhter
	brudern-tokhter/Xbrudern-tekhter [f] [def: niece] 
tol/N/Xteler [m] [def: valley] /Dtelkh [def: dale] 
	to'leke/S [f] [def: meadow, pasture] 
	do'lene/S [f] [def: small valley; depression in the ground] 
toleri'r/V/Btoleri'rt [def: tolerate]
	tolerants [f] [def: tolerance] 
tolk/N [m] [def: order; sense] [usage: with "dergeyn"]
tomat/N [m] [def: tomato] 
tomed{Wmyd}/H [def: always] 
	masmed{Wmyd}/Xmasmidem{Wmydym}/H [def: dedicated student] 
	hasmode{hTmdh}/Xhasmodes{hTmdwT}/H [def: dedication; diligence]
tomer [def: perhaps; lest; if perchance] 
tomey{tm#}/H [m] [def: ritually unfit] /Idik
	metame{mtm#}/H [def: render ritually unfit (with "zayn")] 
	tume{twm#h}/Xtumes{twm#wT}/H [f] [def: ritual unfitness; church (pejorative)] 
ton/Xtener [m] [def: tone] 
	baton/V/Bbatont [def: sound, opine, accentuate] 
ton/N [m] [def: ton (weight)] 
tones{WenyT}/Xtaneysem{WenyTym}/H [m] [def: fast (religious)]
top/Xtep [m] [def: pot] /Dtep
	blumen-top/Xblumen-tep [m] [def: flower pot] 
	shmeltstop/Xshmeltstep [m] [def: melting pot] 
	mesttepl/Eekh [n] [def: measuring cup] 
	teper/S [m] [def: potter] 
	[idiom: kukn in yenems top = get involved in someone else's business]
topl/V/T [def: double]
	topl/A [def: double]
	doplt/A [def: double] [usage: inadmissable]
topol/N topolye/S [f] [def: poplar (tree)]
toptshe/V/T [def: plod, trudge; tread; stamp (feet); wade (with "zikh")]
topye/V/T [def: melt] /Gon
tor/V/T [def: ought; be allowed] [grammar: only in negative constructions]
torbe/S [f] [def: sack] 
tore/V/T torke/V/T [def: jab, annoy, badger] 
	[idiom: ton a tore = nudge]
torf [noun] [def: turf, peat] 
torg [def: buying and selling]
	torgovoy [adj] [def: trade (Russian)] [grammar: indeclinable]
torkl/V/T [def: coo (sound of a dove)] % Harduf
tormoz/N [m] [def: brake (automotive)]
tornado/S [m] [def: tornado] 
torpede/S [f] [def: torpedo] 
tort/N [m] [def: cake] 
toryum [m] [def: thorium (Th)] 
tost/N [m] [def: toast (celebratory)] 
total/A [def: entire]
	totalita'r/A totalitaristish/A [def: totalitarian]
toter/N [m] [def: Tatar] /Ish /Iish 
	toterish [n] [def: gibberish, Tatar language] 
totshe/V/T [def: nag] % Harduf
tov{twB}/H [def: good]
	tuv{twB}/H [def: goodness] 
	letoyvas{ltwBT} [prep] [def: for the sake of] 
tovl/N [m] [def: board; hard book cover]
	tevele/Ekh [def: slab] 
	tovl/V/T /Gayn [def: bind (book)]
	meldtovl/N [m] [def: bulletin board] 
	ondenktovl/N [m] [def: plaque] [note: V]
toy/N [m] [def: dew] 
toyb/A [def: deaf]
	toybkayt/N [f] [def: deafness] 
	fartoyb/V/Bfartoybt [def: deafen] 
toyb/N [f] [def: pigeon, dove] /Dtayb
	ringltoyb/N [f] [def: trapping pigeon] 
toyer/N [m] [def: gate; goal (sport)] 
toyf/V/T [def: baptize] 
toyfes{Wwfs}/H [def: holding]
toyg/V/T [def: be of use; be good for] 
	/Goys [def: have expertise (with "zikh")]
toykhekhe{WwHHh}/Xtoykhekhes{WwHHwT}/H [def: curse] 
toykhn{Wwxn}/H [def: contents] 
toyre{Wwrh}/Xtoyres{WwrwT}/H [f] [def: tradition]
	/Lh [def: the Torah] /D
	seyfer{sfr}-toyre[Wwrh} [def: scroll of the Law] 
	talmetoyre{Wlmwd-Wwrh}/H [f] [def: grammar school (religious)] 
	[idiom: sisrey{sTry} toyre{Wwrh} = hidden depths of the Jewish law]
	[idiom: gedoyley{gdwly} toyre{Wwrh} = Jewish sages]
toysfes{WwsfwT}/H [def: Tosafists: Talmudic commentators] 
toysh/V/T [def: exchange; change] /Goys
	oystoysh/N [m] [def: exchange] 
	fartoysh/V/Bfartoysht [def: exchange] 
toyve{twBh}/Xtoyves{twBwT}/H [f] [def: goodness, favor] /Ll
	toyv{twB}/Xtoyvem{twBym} [adj] [def: good] /Lh
	toyves{twBwT}/H [def: favors] 
	tov{twB}/H [def: good]
	tuv{twB}/H [def: goodness] 
	mazl{mzl}-tov{twB} [interj] [def: congratulations] 
toyvl{twBl}/H/V/T [def: ritually immerse]
	tvile{tBylh}/Xtviles{tBylwT}/H [f] [def: ritual immersion] 
toyz/Xtayz [m] [def: ace (playing cards)] 
toyznt/A/N [m] [def: thousand]
	yortoyznt/N [m] [def: millenium] 
toz/N [m] [def: board of health (Poland)] 
	oze/S [f] [def: board of health (Russia)] 
traditsye/S [f] [def: tradition]
	traditsyone'l/A [def: traditional] 
traf/N [m] [def: accent; syllable] 
	[idiom: oyf (blindn) traf = in random order, at random]
tragedye/S [f] [def: tragedy]
	tragish/A [def: tragic] 
trakh/N [def: collision, (sound of breaking)] 
	trakh [interj] [def: bang!, crash!]
trakht/V/T [def: think; plan] /Garayn/Gdurkh/Giber/Gtsu
	/Goys [def: invent] 
	batrakht/V/Bbatrakht [def: consider]
		batrakht [m] batrakhtung/N [f] [def: consideration, examination]
			guf{gwf}-batrakhtung/N [f] [def: physical examination] 
		[idiom: nemen in batrakht = take under advisement]
		[idiom: dos kumt nit in batrakht = that doesn't count!]
	fartrakht/V/Bfartrakht [def: ponder]
		fartrakhterheyt [adv] [def: deep in thought] 
	trakht/N [f] [def: thought]
		[idiom: a trakht ton = give a thought]
	trakhtung/N [f] [def: thinking] tra'khtenish/N
	oystra'khtenish/N [def: invension] 
	nidertrekhtik/A [def: base, vile] % Harduf
	[idiom: zolst nit ibertrakhtn = don't worry; never mind]
trakht/N [f] mutertrakht/N [f] [def: womb]
trakt/N [m] [def: dirt road, highway]
traktor/N [m] [def: tractor] 
trampoli'n/N [m] [def: trampoline] 
tramvay'/N [m] [def: tram, trolley car, streetcar]
transferi'r/V/Btransferi'rt [def: transfer] 
	transfer/N [def: transfer] 
transformi'r/V/Btransformi'rt [def: transform]
	transformatsye/S [f] [def: transformation] 
transistor/N [m] [def: transistor] 
transkribi'r/V/Btranskribi'rt [def: transcribe] 
	transkriptsye/S [f] [def: transciption]
	transkribirterheyt [adv] [def: in transcription]
	transkribirer/S [m] [def: transcriber] 
transliteratsye/S [f] [def: transliteration] 
transmiti'r/V/Btransmiti'rt [def: transmit] 
transporti'r/V/Btransporti'rt [def: transport] /Gop
	transport/N [m] [def: transport; shipment] 
traske/V/T [def: hit]
	trask/N/Ees [m] [def: blow; bang, crash] 
	fartraske/V/Bfartrasket [def: hit] 
	[idiom: endikn mit a trask = finish with a bang]
travesti'r/V/Btravesti'rt [def: cross-dress, dress in drag] [note: V]
	travestirer/S [m] travesti'rerke/S [f] [def: cross-dresser, transvestite] 
travme/S [f] [def: wound, trauma] 
tray/A [def: true, trusty; faithful] getray/A [def: faithful] 
	trayshaft/N [f] getrayshaft/N [f] [def: trustworthiness, faithfulness]
	getroy/V/T [def: trust] /Gon/Goys
	fartroy/V/Bfartroyt [def: entrust] /Gon
		fartroylekh/A [def: trustworthy] 
	tsutroy [m] [def: trust in (with "tsu"), reliance on (with "tsu")] 
		zikh-tsutroy [m] [def: self confidence] 
trayb/V/Bgetribn [def: drive] /Gavek/Giber/Gdurkh
	/Garoys [def: drive out, exorcise]
	/Gop [def: cause an abortion]
	batrayb/V/Bbatribn [def: drive] 
	fartrayb/V/Bfartribn [def: drive] 
	dertrayb/V/Bdertribn [def: drive to a conclusion] 
	tsetrayb/V/Btsetribn [def: drive] 
	trayber/S [m] ontrayber/S [m] [def: animal driver] 
		aroystrayber/S [m] [def: exorcist] 
traybl/N [n] [def: telephone, speaking tube]
tref/V/Bgetrofn [def: find, meet, guess] /Gon/Gtsuzamen
	batref/V/Bbatrofn [def: amount to]
		/Gon [def: meet] onbatref/N [def: meeting] 
		batref/N [m] [def: sum, value, importance, significance] 
		[idiom: hobn a batref = count]
	trefer [m] [def: finder]
	trefung/N [f] tre'fenish/N [n] [def: meeting, encounter]
	tsuzamentref/N [m] [def: meeting]
tren/V/T [def: rip out, have intercourse (taboo)] 
treni'r/V/Btreni'rt [def: train] 
	trenirer/S [def: trainer] 
trep/X/D [f] [def: stair]
	fayertrep/X [f] [def: fire-escape stair] 
trer/N [f] [def: tear] /D
	fartrert/A [def: teary]
	[idiom: tsibele trern = crocodile tears]
tret/V/Bgetrotn [def: step; tread]
	/Garayn/Gariber/Giber/Gop/Goyf/Gtsu/Gon/Goys
	/Garoys [def: appear for the purpose presenting a speech] 
	fartret/V/Bfartrotn [def: represent]
		fartreter/S [m] [def: representative] 
		fartretung/N [f] [def: representation] 
	tsetret/V/Btsetrotn [def: trample]
	batret/V/Bbatrotn [def: tread, set foot on]
	trot/Xtrit/N [m] [def: step, pace] 
		optrot/N [m] [def: withdrawal, retreat] 
	trit/X/D [m] [def: footstep] 
		fustrit/X [m] [def: footstep] 
		oyftrit/X [m] [def: appearance (performance); opening (performance)] 
		tsutrit/X [m] [def: approach] /Ilekh [def: approachable] 
	optret/N optrit/N [m] [def: retreat, toilet facility] 
		[idiom: optret gelt = legal bribe; monetary incentive]
	trotuar/N [m] [def: sidewalk] 
treyf/A/Ien [def: non-kosher] % usually not in Hebraic spelling
	treyfe_{tryfh} treyf_{tryf}
	meturef{mtwrf}/Xmeturofem{mtwrfym}/H [m] [def: crazy or confused man] 
		meturefes{mtwrfT}/Xmeturefesn{mtwrfTn} [f] [def: crazy woman] 
		meturefdik{mtwrfdik}/A [def: crazy, confused] 
	treyfnyak/S [m] [def: unkosher person] % loses Hebraic spelling
	fartreyf/V/Bfartreyft [def: falsify, render unfit] 
		fartreyfung/N [f] [def: falsification, unkosher mixture] 
treysl/V/T [def: quiver; shake] /Goyf/Gop
	tsetreysl/V/Btsetreyslt [def: upset] 
treyst/V/T [def: comfort, console] 
	treyst/N [f] [def: comfort]
	treyster/S [m] [def: comforter] 
trib/A [def: dismal; sorrowful]
	tribkayt/N [f] [def: sorrow] 
	tribe [def: sorrow] 
tribun/N [m] [def: tribune (person)] 
tribune/S [f] [def: daïs, grandstand] 
trif/V/T [def: drip] /Garunter
trikn/V/T [def: dry] /Goys/Goyf
	fartrikn/V/Bfartriknt [def: dry] 
	trukn/A [def: dry]
	truknkayt/N [f] tri'kenish/N [f] [def: dryness; drought] 
trikota'zh [m] [def: knitwear]
tril/V/T [def: coo (sound of a dove), to fool] 
trink/V/Bgetrunken [def: drink] /Goys/Gop/Gon
	fartrink/V/Bfartrunken [def: drink] 
	dertrink/V/Bdertrunken [def: drown] 
	trunk/N [m] [def: drink] getrank/N [n] [def: drink, beverage] 
trishak [def: gleek (card game)]
trishtshe/V/T [def: make a breaking sound]
tryumfi'r/V/Btryumfi'rt [def: triumph]
	tryumf/N [m] [def: triumph]
	tryumfali'zm/N [m] [def: triumphalizm] % Forwards
trog/V/T/Bgetrogn [def: carry]
	% both participles exist, getrogn is dominant
	/Goys/Gariber/Garayn/Garoys/Garum/Gdurkh/Gop/Gtsu
	/Gtsunoyf/Gunter/Goyf/Gon
	/Giber [def: bear]
	/Gavek [def: carry away, run about (with "zikh")] 
	dertrog/V/Bdertrogn [def: bear] dertreglekh/A [def: bearable] 
	fartrog/V/Bfartrogn [def: carry away, bear, tolerate]
		fartrogn/A [def: absent-minded, unconscious] 
	tsetrog/V/Btsetrogn [def: bear] tsetrognkayt/N [f] [def: ??] 
	ibertreglekh/A [def: bearable] 
	troger/S [m] [def: bearer] treger/S [m] [def: porter]
		brivtreger/S brivntreger/S [def: mailman] 
		vasertreger/S [m] [def: water carrier] 
	trogedik/A [def: pregnant]
	[idiom: es trogt mit ... = it smells of ...]
trold/N [m] [def: fringe, tassel]
trombo'n/N [m] [def: trombone]
	trombeniker/S [m] [def: itinerant musician, glutton, loafer, boaster] 
tron/N [m] [def: throne; toilet] 
tronts/N [m] [def: tantrum] 
	[idiom: in im arayn der tronts = he is throwing a fit]
trop/N [m] [def: accent; stress] 
	[idiom: leygn/shteln dem trop oyf = concentrate on]
tropik/N [m] [def: tropic (geographical)] tropish/A [def: tropical] 
tropn/S [m] [def: drop]
	regntropn/S [m] [def: raindrop] 
trots/P [def: aside from (German)] 
troyb/N [f] [def: grape] vayntroyb/N [f]
troyer/V/T [def: be sad, mourn, grieve] 
	troyer [m] [def: sadness, grief] /Iik/Idik [def: sad]
		troyerikayt/N [f] [def: sadness] 
	fartroyer/V/Bfartoryert [def: ??] % perhaps it has to do with the word "fartroylekh" above
troym/N [m] [def: dream]
	troym/V/T [def: dream (as of an ideal)]
	fartroymt/A [def: in a dream-like state] 
trume{Wrwmh}/Xtrumes{WrwmwT}/H [def: priestly portion] 
trumpeyt/N [m] trumeyt/N [m] trumeyter [m] [def: trumpet] 
	tsetrumeyter/V/Btsetrumeytert [def: hype]
trune/S [f] trumne/S [def: casket, burial crypt (non-Jewish)] /Idik
trupe/S [f] [def: troupe] 
trus/N [m] [def: coward] 
truskafke/S [f] [def: strawberry]
tsad{cd}/Xtsdodem{cddym}/H [m] [def: attribute; side (of a family)] 
	min_{mn}-hatsad{hcd} [def: to the side] 
tsadi{cʼ}/H [m/f] [def: Hebrew letter Tsadi] 
tsadik{cdyk}/Xtsadikem{cdykym}/H [m] [def: righteous person] /Lh
	tsadekes{cdkT}/H/N [f] [def: righteous person]
	tsidkones{cdknyW}/Xtsidkonyes{cdknywT} [f] [def: God-fearing woman] 
	tsedek{cdk}/H [m] [def: righteousness] 
	tsedoke{cdk|h}/H [f] [def: charity]  
	matsdek{mcdyk}/H [def: credit (with "zayn")] 
tsam/N [m/f] [def: border, fence]
	ayntsam/N [m] [def: hedge] 
	tsam/V/T /Garum
		fartsam/V/Bfartsamt [def: border] fartsamung/N [f] [def: boundary] 
	tsoym/N [m/f] [def: border] % variant
		tsoym/V/T [def: put up a border] 
			/Garum [def: surround with a fence] 
			/Gop [def: fence off] 
				optsoym/N [m] [def: fenced-in area] 
		fartsoym/V/Bfartsoymt [def: border] fartsoymung/N [f]
	tsam/N [n] [def: plug, faucet]
tsank/V/T [def: sputter (candle)]
tsap/Ees [m/f] [def: (male) goat] 
	tsapnberdl/Eekh [n] [def: goatlike beard] % Stutshkov
tsap/V/T/Goys [def: draw (liquid)]
	tsa'penish/N [def: drawing] 
		bluttsa'penish/N [def: drawing blood] 
	ayztsapn/S [m] [def: icicle]
	tsapn/S [m] [def: faucet] 
tsapl/V/T [def: shudder] /Goyf
	/Idik [def: shuddering] 
tsar/N [m] /Iish [def: Czar] 
tsar_{cer}/H [m] [def: sorrow] 
	far|tsar|/V/Bfar|tsar|t [def: sadden] 
tsatske/S [f] tshatshke/S [def: bric-a-brac, plaything] 
	tsatske/V/T [def: play (with "zikh")] /Goys
	getsatsket/A [def: ornate] % Harduf 
		ibergetsatsket/A [def: excessively delicate or refined] [note: V]
tsavoe{cvoh}/Xtsavoes{cv#wT}/H [f] [def: will] 
tsayg/V/T
	/Giber [def: convince]
	ibertsaygik/A ibertsaygevdik/A [def: convincing] 
		ibertsaygung/N [f] [def: convicing] 
	tsay'genish [n] [def: certificate]
	% ibertsaygt/A is German
tsayg getsayg [n] [def: cloth, stuff, fabric]
	ayzngetsayg [m] [def: ironware]
	klaper-getsayg [m] [def: tools]
	shraybgetsayg [m] [def: writing materials]
	shpiltsayg [m] [def: toys] 
	verktsayg [m] [def: work materials] 
tsayt/N [f] [def: time] /Iik [def: ripe]
	tsaytik/V/T [def: ripen] 
	fartsaytik/A [def: underripe] 
	alttsaytish/A [def: ancient]
	haynttsaytik/A [def: modern]
	glaykhtsaytik/A [def: contemporaneous]
	eyntsaytik/A [def: unique]
	frilingtsayt/N [f] [def: springtime] 
	fritsaytik/A [def: early] 
	fartsaytns [def: early] fartsaytish/A [def: of yore] 
	frishtiktsayt/N [f] [def: breakfast time] 
	moltsayt/N [f] [def: meal]
	probetsayt/N [f] [def: probation period] [note: V]
	shterntsayt/N [f] [def: nightfall (poetic)]
	teytsayt/N [f] [def: tea time]
	vintertsayt/N [f] [def: winter]
	harbsttsayt/N [f] [def: autumn]
	zumertsayt/N [f] [def: summer] 
	fraytsayt/N [f] [def: time of freedom] 
	mitogtsayt/N [f] [def: midday] 
	tsvishntsayt/N [f] [def: interval]
	batsaytns [adv] [def: on time] 
	tsaytnvayz [adv] [def: time by time] 
	fartsaytn [adv] fartsaytns [adv] [def: of old] 
	[idiom: tsu der tsayt = punctually]
	[idiom: kedey ayntsushporn tsayt = in the interest of time] [note: V]
tsaytung/N [f] [def: newspaper] /D
	togtsaytung/N [f] [def: daily newspaper] 
tse/Een [m] [def: the letter C]
tsebaleve/V/Btsebalevet [def: spoil (child)] 
tsebre/S tseber/S [m] tsuber/S [m] [def: manger, tub]
tsekh/N [def: guild] 
	[idiom: redn fun tsekh = talk shop]
tsekhrastet/A [def: unbuttoned]
tsel/N [def: cell] /Iular [def: cellular] 
	tselke/S [f] [def: cell phone]
	tselula'r/A [def: cellular] 
tselnik/Ees [m] [def: notions seller] 
tselofan [m] [def: cellophane, cellophane tape] 
tsement/N [m] [def: cement] 
tsen [def: ten] tsent/A [def: tenth]
	tsendlik/Eer [m] [def: unit of ten]
	tsendling/Eer [m] [def: ten]
	tsentl/Eekh [def: 1/10]
	yortsendlik/Eer [m] [def: decade] 
	tsenerling/N [m] [def: teenager]
	tsener/D [def: 10-unit money] 
tsene{c#ynh}/H [def: go forth (plural feminine)] 
	tsenerene{c#ynh-|wr#ynh}/H [def: "Tsene urene" = women's devotional book] 
tsenter/S [m] [def: center]
	aynkoyf-tsenter/S [m] [def: mall, shopping mall] 
tsentimeter/S [m] [def: centimeter]
tsentral/A [def: central]
	ontsentrish/A [def: without center] 
	tsentrale/S [f] [def: central office, organization] 
tsenzur/N [f] [def: censor] 
	tsenzuri'r/V/Btsenzuri'rt [def: censored]
tsenzus [def: census] 
tsepolokhe/V/T [def: readjust wings (bird)] % no base verb
tsepoloshet/A [def: wild with fright (horse)] % no base verb
tseprie/V/Btsepriet [def: rot] 
tseremonye/S [f] [def: ceremony] 
	nomen-tseremonye/S [f] [def: naming ceremony] [note: V]
	tseremonyal/N [m] [def: ceremony] 
tsereve/V/T [def: darn clothing]
	fartserive/V/Bfartserevet [def: darn] 
tserkve/S [f] [def: Orthodox church]
tsertifitsi'r/V/Btsertifitsi'rt sertifitsi'r/V/Bsertifitsi'rt [def: certify] 
	tsertifika't/N [m] sertifika't/N [m] [def: diploma; certificate] 
tsertl/V/T [def: comfort] 
	tsertlekh/A [def: tender, gentle]
		tsertlekhkayt/N [f] [def: compassion] 
	tsart/K [def: gentle]
		tsartkayt/N [f] [def: gentleness] 
	tse'rtlenish/N [n] [def: foreplay] [note: V]
tseryum [m] [def: cerium (Ce)] 
tsetl/N/D [m] [def: receipt, document, note, slip, tag]
	batsetl/V/Bbatsetlt [def: write on a scap of paper] 
tsetrukhnet/A [def: tattered, threadbare] 
tseydo{cdh}/H [def: food] 
	tseydo{cdh}-ladeyrekh{ldrx}/H [def: food for a journey] 
tseykhn/V/T [def: depict] /Gon/Goys/Giber/Goys/Gop
	fartseykhn/V/Bfartseykhnt [def: depict] 
	batseykhn/V/Bbatseykhnt [def: label, designate] 
		batseykhenung/N [f] [def: label, designation] 
	tseykhenung/N [f] [def: marking] 
	tseykhn/S [m] [def: mark] /Dtseykhnd
		shri'fttseykhn/S [m] [def: character (letter or number)] 
	/Xtseykhn/Xtseykhns [def: jacks (game)] [note: Stutshkov]
tseyl/V/T [def: count] /Garayn/Giber/Gop/Goyf/Gon
	tsol/N [f] [def: number, inch] 
		draytsol [adv] [def: thrice]
		eyntsol [adv] [def: singular] /Iik
		gruntsol/N [f] [def: cardinal number] 
		filtsolik/A [def: frequent; often; many] 
		mertsol/N [f] [def: plural] 
	tseylung/N [f] [def: count]
		folkstseylung/N [f] [def: census] 
	dertseyl/V/Bdertseylt [def: recount, tell, narrate] /Goys/Giber
		dertseylung/N [f] [def: story, tale] 
		dertseyler/S [m] dertseylerin/S [f] [def: storyteller] 
		iberdertseyler/S [m] [def: storyteller] 
	getseylt/A [def: few] umgetseylt/A [def: countless] 
tseylem{clm}/Eer/Xtslomem{clmym}/H [m] [def: image, cross] /Lb
	tseylem{clm}/H/V/T [def: make the sign of the cross] 
tsezyum [m] [def: cesium (Cs)] 
tshad [m] [def: carbon monoxide]
	fartshadet/A [def: poisoned by carbon monoxide]
tshape/V/T [def: go clumsily] 
tsharter/S [m] [def: charter] 
tshate/S [f] [def: gang, flock (birds), pack (wolves)]
	tshateve/V/T [def: stalk] 
	tshatesvayz [adv] [def: in a flock or pack] 
tshaynik/S/D [m] [def: teakettle, teapot] 
	[idiom: hakn (emetsn) a tshaynik = annoy (somebody)]
tshelo/S [m] vyolontshe'l/N [m] [def: cello] 
tshemoda'n/Ees /Dtshemodand [m] [def: valise; suitcase] 
tshek/N [m] [def: check (monetary instrument)] 
tsheke/V/T [def: go out of the way to get something ??] 
tshepe/V/T [def: touch; bother (with "zikh")] /Gtsu 
	/Gop [def: move away (with "zikh")]
	fartshepe/V/Bfartshepet [def: hook, stumble on, pick a quarrel with (with "zikh mit")]
		zatshepe/V/Bzatshepet [def: interfere] 
	tsutshe'penish/N [n] [def: nuisance, pest]
tsherede/S [f] [def: flock] 
tsherepakhe/S [f] [def: tortoise; turtle] 
tshikave/K [def: curious] 
tshin/N [def: rank]
	tshine/S [def: badge of rank]
	tshinovnik/Ees [m] [def: official, clerk (Russian)] 
tshipmonk/N [m] [def: chipmunk (animal)] % Harduf
tshliene/S [def: member of an organization (Russian)] 
tsholnt/N [m/n] [def: tsholent (slow-cooked stew)]
tshub/N [def: tuft of hair]
tshu'bekl/Eekh [n] [def: lock of hair (for children)]
tshuda'k/Ees [m] tshudatshke/S [f] [def: crank, oddball] 
tshugun/Ees [m] [def: cast iron (pot)] /Ien
tshuke{WSwk|h}/Xtshukes{WSwkwT}/H [f] [def: lust] 
	tshukhe/V/T /Goys [def: fully awaken, shake off sleep, come to one's senses (with "zikh)] 
tshuprine/S [f] [def: forelock; well-styled hair (men)] 
tshuve{WSwBh}/Xtshuves{WSwBwT}/H [f] [def: answer, repentance] /Lb /Lu
	[idiom: baltshuve{bel-WSwBh} = repentant]
tshvok/N/Xtshvekes [m] [def: nail] /Dtshvek
tsi [def: whether] [grammar: introduces question]
tsi/V/Bgetsoygn [def: pull]
	/Garayn/Garoys/Garop/Garoyf/Gtsu/Gavek/Giber/Gtsunoyf/Gtsurik/Gayn
	/Gvayter/Giber/Goyf/Gon/Gariber/Gunter
	/Gtsurik [def: recall (political)] [note: V] 
	/Goys [def: extract] 
	tsiung/N [f] [def: pulling]
		tsutsiung/N [f] [def: attraction]
		aribertsi [def: pulling over] 
	tsienish/N [n] [def: pull] 
	batsi/V/Bbatsoygn [def: relate to (with "zikh"), cover with cloth]
		batsiung/N [f] [def: relation, attitude]
			tsvishnbatsiung/N [f] [def: relation] 
		batsiekhts/N [f] [def: bed linens]
	dertsi/V/Bdertsoygn [def: educate; bring up]
		dertsiung/N [f] [def: education; upbringing]
		umdertsoygn/A [def: uneducated] 
		dertsier/S [m] [def: educator] 
	fartsi/V/Bfartsoygn [def: delay, tighten, protract, call (sb.) for short, inhale (in smoking)]
	aroptsibar/A [def: ??] % perhaps "herunterziehbar" - "possibility to pull down something"
	tsug [m] [def: train (German)]
		batsug [m] [def: clothing; covering; connection] [usage: inadmissable]
	antsug/N ontsug/N [m] [def: suit of clothes]
	oystsug/N [m] [def: extract, excerpt] 
	aroyftsi/N [m] [def: chin-up (athletic exercise)] 
	propntsier/S [m] [def: corkscrew] 
tsibele/S [f] [def: onion] tsibelke/S
	yoykhtsibele/S [f] [def: soup onion] 
	[idiom: nit vert keyn tsibele = worthless]
tsiber{cybwr}/H [def: public] /Lb
tsifer/X [m/f] [def: digit, figure (number), numeral]
	tsiferl/X [def: numeral]
tsig/N/D [f] [def: goat] tsikele/Ekh [def: young goat] % Stutshkov
	tsignberdl/Eekh [n] [def: goatlike beard] % Stutshkov
	[idiom: vilde tsig = rowdy girl] % Stutshkov
tsigar/N [m] [def: cigar] 
tsigayner/S [m] tsigaynerin/S [f] tsigaynershe/S [f] [def: Gypsy]
	tsigaynish/A [def: Gypsy] 
tsigl/X [m] [def: brick, checker piece (game)] /In
	tsigelnye/S [f] [def: brickwork] 
tsikh/N [f] [def: tidy; blanket cover] /D [def: pillowcase] 
tsikhtik/A [def: clean] umtsikhtik/A [def: dirty] 
	tsikhter [def: cleaner] 
	[idiom: ferd-tsikhter = groom]
tsikl/N [m] [def: cycle]
	tsikl/V/T [def: ride a bicycle]
tsiklo'n/N [m] [def: cyclone] 
tsikorye [f] [def: chicory (drink)]
tsil/V/T [def: aim] /Gon
	tsil/N [m] [def: goal]
	sharftsiler/S [m] [def: sharpshooter] 
tsilinder/S [m] [def: top-hat (clothing)] 
tsimbl/N [m] [def: cymbal]
	tsimbl/V/T [def: beat a cymbal] 
	[idiom: nemen emetsn oyfn tsimbl = poke fun at someone, ridicule]
tsimer/N/D [m] [def: room] /Ilekh
	bodtsimer/N/D [m] [def: bath room]
	estsimer/N/D [m] [def: dining room]
	shloftsimer/N/D [m] [def: bedroom] 
	tuale't-tsimer/N/D [m] [def: locker room] 
	vashtsimer/N/D [m] [def: toilet room]
tsimering [m] [def: cinnamon] 
tsimes/N [m] [def: a baked sweet root-crop food] 
	[idiom: makhn a tsimes = make a fuss]
tsin [m] [def: tin (Sn)] 
tsind/V/Bgetsundn [def: set fire] /Gon/Gunter
	tsetsind/V/Btsetsundn [def: enflame] 
	untertsinder/S/X [m] ontsinder/S [m] [def: lighter]
	ontsindung/N [f] [def: setting afire; inflammation]
		lungen-ontsindung/N [f] [def: inflammation of the lungs] 
		moyekh{mwH}-ontsindung/N [f] [def: inflammation of the brain]
	likhtsinder/S [m] [def: candle lighter] 
tsinish/A [def: cynical] tsiniker/X [def: cynic] 
tsink [n] [def: zinc (Zn)] 
tsindz/N [m] [def: tax, toll, tribute, interest (in plural)]
	tsindzer/S [m] [def: tax collector]
tsipres/N [m] [def: cypress (tree)] 
tsirk/N [m] [def: circus] 
tsirko [def: circa] 
tsirkonyum [m] [def: zirconium (Zr)] 
tsirkuli'r/V/Btsirkuli'rt [def: circulate]
	tsirkulatsye/S [f] [def: circulation] 
tsir/N [m] [def: ornament] 
	tsirung/N [f] [def: jewelry] 
	batsi'r/V/Bbatsi'rt [def: adorn] 
tsishe/V/T [def: hiss; sizzle] /Garoys
tsisterne/S [f] [def: cistern] 
	vaser-tsisterne/S [f] [def: water tank] 
tsiter/V/T [def: tremble, shiver] /Gnokh/Garoys/Goyf
	tsiter/S [m] [def: tremble] /Idik [def: trembling]
		tsiternish/N [n] [def: trembling]
			erdtsiternish/N [n] [def: earthquake] 
			nokhtsiternish/N [n] [def: aftershock] 
	fartsitert/A [def: atremble]
	nokhtsiter/S [m] [def: trembling] 
	dertsiter/V/Bdertsitert [def: strike]
		dertsiterung/N [f] [def: stroke] 
	oyftsiter/N [m] [def: trembling] 
	[idiom: tsitern hent un fis = tremble all over]
tsiti'r/V/Btsiti'rt [def: cite]
	tsitatsye/S [f] tsitat/N [m] [def: citation] 
tsitron/N [def: citron, lemon] tsitrin/N [m]
	tsitrus [def: citrus] 
tsits [m] [def: chintz, calico] /In
tsitse/S [f] [def: teat] /Dtsits tsitske/S
tsitses{cycyT}/H [f] [def: ritual fringe on garments]
	[morphology: Hebrew singular is both Yiddish singular and plural]
	[idiom: skhoyre{sHwrh} on tsitses{cycyT} = contraband]
tsivil/A [def: civil]
	tsivilizi'r/V/Btsivilizi'rt [def: civilize] 
		umtsivilizi'rt/A [def: uncivilized] 
	tsivilizatsye/S [f] [def: civilization] 
	tsivili'st/N [m] [def: civilian] 
tsniyes{cnyewT}/H [n] [def: modesty, virtue, chastity]
	/Idik [def: modest, virtuous, chaste] 
tsofn{cfwn}/H [m] [def: north] /Idik [def: northern] 
tsol/V/T [def: pay] /Gop/Gtsu/Garum/Gtsurik
	batsol/V/Bbatsolt [def: pay]
		batsolung/N [f] [def: payment] 
	dertsol/V/Bdertsolt [def: pay up] 
		[idiom: nit-dertsolte shtayern = back taxes] [note: V]
	brukhtsol/N [f] brukhteyl/N [f] [def: fraction (mathematics)] 
	komplekstsol/N [f] [def: complex number (mathematics)] 
	optsol/N [m] [def: dues, toll]
	tsol/X [m] [def: count, inch]
	[idiom: enge benge stupe stenge, artse bartse gole shvartse, eygele feygele khik = eenie meenie maynie mo (counting rhyme)]
tson/Xtseyn/Xtseyner /Dtseynd /Iik [def: tooth] 
	khokhme{Hxmh}-tson/Xkhokhme{Hxmh}-tseyner [def: wisdom tooth]
	[idiom: farredn di tseyn = speak nonsense; use far-fetched justification]
tsop/Xtsep /Dtsep [def: braid of hair] 
tsore{crh}/Xtsores{crwT}/H [f] [def: trouble, misfortune]
	/Idik [def: troubled] 
	[idiom: onton tsores = abuse]
	[idiom: gehakte tsores = troubles]
tsorn [def: rage] /Idik [grammar: no plural]
	dertsornt/A [def: angry] 
	grimtsorn [m] [def: wrath]
	tsorn/V/T [def: anger]
	tseren/V/T [def: anger]
	dertsorn/V/Bdertsornt [def: anger]
	dertseren/V/Bdertsernt [def: anger]
	[idiom: tsar_{cer} un tsorn = trials and tribulations]
tsoyber [def: magic] [usage: inadmissable]
	batsoyber/V/Bbatsoybert [def: enchant, charm] [usage: inadmissable] 
	batsoyberung/N [f] [def: enchantment] [usage: inadmissable]
tsoye{cw#h}/H [f] [def: excrement] 
tsoyg/Xtsayg [f] /Dtsayg [def: bitch]
tsoytik/A [def: shaggy] 
tsu/P tsun [prep] [def: towards, in addition, each] 
	tsushoyer/S [m] [def: audience] [usage: doubtful admissability]
tsuk/V/T [def: eat up, adorn] 
	fartsuk/V/Bfartsukt [def: eat up]
tsuker [m] [def: sugar] /D [def: candy] 
	fartsuker/V/Bfartsukert [def: sweeten] 
tsulib/P [def: for] 
tsung/N/Xtsinger [f] /Dtsing [def: tongue]
	fayertsung/N [f] [def: flame]
tsunoyf [def: together]
tsup/V/T [def: tug; pluck; pick]
tsure{cwrh}/Xtsures{cwrwT}/H [f] [def: face, appearance] 
	tsurkele/S [f] [def: little face] 
tsuzamen [adv] [def: together]
tsvayg/N/D [f] [def: branch] 
	tsvaygung/N [f] [def: branching] tsetsvaygung/N [f]
	tsetsvaygt/A [def: branching]
	tsvaygldik/A [def: ??] % ire tsvaygldike tseplekh
	optsvayg/N [f] [def: fork (in road)] [note: Khaver-Paver's Klinton Street] 
tsvek/N [m] [def: purpose] 
	batsvek/V/Bbatsvekt [def: aim] % Forwards 
tsvey/N [def: 2]
	/It [def: 2nd] /Iik [def: binary (mathematical)] 
		/Itik [def: secondary] 
	tsveytns [adv] [def: secondly]
	tsveyerley [adv] [def: two-sorted] 
	tsvelf tsvelft/A [def: 12]
		tsvelftns [adv] [def: 12th]
		tsvelftl [def: 1/12] 
	tsvantsik/A tsvontsik/A [def: 20]
		tsvantsikst/A [def: 20th] 
		tsvantsikstl [def: 1/20] 
	tsviling/N [def: pair of twins] 
tsveyfl/V/T [def: doubt] 
	fartsveyfl/V/Bfartsveyflt [def: confuse]
		fartsveyflung/N [f] [def: despair, desparation]
	ontsveyfldik/A [def: certain, without a doubt] 
	tsveyflhaft/A [def: doubtful] [usage: inadmissable]
tsving/V/Bgetsvungen [def: force] /Goyf
	/Garoyf [def: put on (ill-fitting clothing)] 
	batsving/V/Bbatsvungen [def: force] 
tsvinter/S [m] [def: non-Jewish cemetery]
tsvishn/P [def: between] 
tsvit/N [m] [def: bloom, blossom] 
tsvog/V/Bgetsvogn/Goys [def: wash]
tsvorekh [m] [def: cottage cheese] % no plural
tsvuak{cBuek}/H/Xes [m] [def: hypocrite]
tu/Vton/Bgeton [def: do]
	/Garayn/Gahin/Goyf/Gop/Gtsu
	/Gon [def: wear, get dressed (with "zikh")]
	/Goys [def: take off]
	/Gnokh [def: imitate, repeat]
	tetik/A [def: active] tetikayt/N [f] [def: activity]
	oyftu/Een [m] [def: exploit, feat, accomplishment, achievement]
	oyftuekhts/N [n] [def: accomplishment] 
	ontuekhts/N [n] [def: clothing]
	tuer/S [m] tuerin/S [f] [def: doer; active person]
		gevaldtuer/S [m] gvaldtuer/S [m] [def: rapist] 
	tuung/N [f] tuekhts/N [n] [def: deed] 
	fartu/Vfarton/Bfarton [def: occupy, use up, spend, get engrossed (with "zikh")] 
	[idiom: fregn vos se tut zikh = say hello]
tuberkulo'z [m] [def: tuberculosis]
tuk/V/T [def: dunk] 
	/Garoys [def: be visible above the water]
	tukerin/S [f] tukerke/S [f] [def: ritual bathhouse attendant (Jewish)] 
	tukung/N [f] [def: dive] 
tukh/Xtikher [n] [def: cloth] /Dtikh [def: kerchief] 
	tishtukh/Xtishtekher [n] /Dtishtekh [def: tablecloth] 
	fartukh/Xfartekher [n] [def: apron] 
	/Dkoptikh [def: scarf (clothing)] 
	noztukh/Xnoztikher [n] /Dnoztikh [def: handkerchief] 
	hantukh/Xhantikher/Xhantekher [m/n] /Dhantikh [def: washcloth] 
		kikhhantukh/Xkikhhantikher/Xkikhhantekher [n] [def: kitchen cloth] 
tukhle/A [def: stale]
tulep/N [m] [def: sheepskin coat (clothing)] 
tulip/N tulpa'n [m] tulipa'n [m] tulpe [f] [def: tulip (plant)]
tulye/V/T [def: cuddle, nestle; clasp] /Gayn/Gtsu
tulyum [m] [def: thulium (Tm)] 
tuma'n/N [m] [def: fog; mist] 
tuml/V/T [def: make a commotion]
	tuml/N [m] [def: commotion] /Idik [def: noisy]
	tumler/S [m] [def: scrapper, entertainer]
	tu'mlenish/N [n] tumleray/N [n] [def: enthusiasm, excitement] 
	fartuml/V/Bfartumlt [def: deafen] 
	tsetuml/V/Btsetumlt [def: confuse, bewilder, arouse excitement (with "zikh")]
		tsetu'mlenish/N [n] tsetumltkayt/N [f] [def: confusion]
	getuml/N [m] [def: commotion] 
tumor [def: tumor] 
tunel/N [m] [def: tunnel] 
tunk/V/T [def: dip] /Gayn
	% both participles exist
	/Bgetunken /Gayn
	tunk/N [m] [def: dip] 
	tunker/S [m] [def: diver] 
tunkl/K [def: dark; dim; obscure] tunkel/A
	/-tunkler/-tunkle/-tunkln % still get some spurious forms
	tunklkayt/N [f] tunklhayt/N [f] [def: darkness] 
	halbtunkel/A [def: half-dark] 
	tunkl/V/T [def: darken] 
	fartunkl/V/Bfartunklt [def: darken] 
tupe/V/T [def: beat time; stamp the foot] tuperay'/N [n] [def: beating]
	tup/N [m] [def: thump] 
turem/S [m] [def: tower] 
turi'st/N [m] [def: tourist] 
	turistik/N [f] [def: tourism] % Forwards
turme/S [f] [def: prison] 
turnament [def: tournament] 
tush/N [m] [def: India ink] 
tutin [noun] [def: cheap smoking tobacco] 
tuts/N [m] [def: dozen] 
tvan [def: swamp] 
tviye{WBy|eh}/Xtviyes{WBy|ewT}/H [def: warning; command; complaint] 
tvue{WBw#h}/H [f] [def: grain] 
tyokhke/V [def: throb] 
	tyokh/N [m] [def: thump (sound of a beating heart)]
tyopke/V/T [def: poke, trip, move lightly] 
	fartyopet/A [def: smeared (clothing)]
tyul [m] [def: tulle (fabric)] [pronunciation: tyuL] /In % no plural
tyulik [def: some article of clothing??] 
u/Een [m] [def: the letter U] 
udobne [adj] [def: comfortable (Slavic)] 
ugaritish/A [def: Ugaritic] 
ugerke/S [f] [def: cucumber]
	[idiom: zoyere ugerke = pickle]
ukaz/N [m] [def: decree (Russian)]
um [def: around] 
ume{#wmh}/Xumes{#wmwT}/H [f] [def: nation] 
	umes{#wmwT}-h|oylem{ewlm} [def: nations of the world] 
umet [def: uneasy feeling, anomie]
	/Iik [def: uneasy] /Iiklekh
	farumetik/V/Bfarumetikt [def: make uneasy] 
	farumer/V/Bfarumert [def: ??] 
umetum [adv] [def: everywhere]
umgehayer/A [def: tremendous, enormous]
umgelumpert/A [def: awkward, unwieldy] 
umishne [adv] umistne [adv] [def: especially] 
umzist/A [adv] [def: in vain]
un [conj] [def: and] 
uniform/N [f] uniforem [f] [def: uniform] % both versions use same plural
unikod [def: Unicode] % note: alphabetize under "kod"
univers/N [m] [def: universe] /Ial [def: universal] 
universitet/N [m] [def: university] 
unter/P [def: under]
	untn [adv] [def: under]
	untersht/A [def: bottom]
	arunter/P
	derunter{der#unter} [adv] [def: below] 
untertenik/A [def: at a lower rank, subservient]
	untertenikayt/N [f] [def: subservience] 
utopye/S [f] [def: utopia] 
ur [prefix] [def: grand (genealogical)] 
uranyum [m] [def: Uranium (Ur)] 
urba'n/A [def: urbane] 
	urbanizirung/N [f] [def: urbanization] 
urne/S [f] [def: urn, ballot box] 
urzakh/N [f] [def: cause, reason] [usage: inadmissable]
uvde{ewBdh}/Xuvdes{ewBdwT}/H [f] [def: accomplishment]
v{|w}/H [conj] [def: and] % connected to next word
	u{|w}/H [conj] [def: and]  % connected to next word
	ve{|w}/H [conj] [def: and]  % connected to next word
vad{ved}/H [m] [def: council]
vaflye/S [f] [def: waffle (food)] % Harduf
vag/V/T [def: dare] 
	dervag/V/Bdervagt [def: dare] 
	derveg/V/Bdervegt [def: dare (with "zikh")]
	gevagt/A [def: daring] % Harduf 
vago'n/N [m] [def: railroad car] 
	mistvagon/S [m] [def: dumpster] 
	raytvogn/S [m] [def: carriage] 
	vogn/S/Xvegener [def: cart, buggy]
vakatsye/S [f] [def: vacation] 
vakh/V/T [def: watch, keep vigil; be awake] /Goys/Goyf
	dervakh/V/Bdervakht [def: watch] 
	bavakh/V/Bbavakht [def: guard] 
	vakh/N [f] [def: awakeness; guard] /Iedik [def: awake]
	vekhter/S [m] vekhterin/S [f] [def: guard]
	ernvakh/N [f] [def: guard of honor] 
vakhtl/N [m] [def: quail (bird)] % Harduf
vakl/V/T [def: rock; shake; hesitate (with "zikh")] /Gunter
	va'klenish/N [n] [def: rocking] vakldik/A [def: unsteady] 
vaks/V/Bgevaksn [def: grow]
	/Goyf/Goys/Garoys/Garayn/Garum/Gon/Gunter/Gfunander
	farvaksn/A [def: overgrown, healed (wound)]
	dervaksn/A [def: adult]
		bi'zdervaksling/N [n] [def: pre-adolescent] 
	tsevaks/V/Btsevaksn [def: grow bigger]
	bavaksn/A [def: hairy]
	geviks/N [n] [def: plant] /Iik [def: plant-like] 
	vuks/N [m] /Iik [def: growth, appearance]
		beyzvuks/N [m] [def: malignant tumor] 
		nokhvuks/N [m] [def: regrowth] 
		kleynvuksik/A [def: short] 
		langvuksik/A [def: tall] 
		mitlvuksik/A [def: medium-height] 
		tsuvuks/N [m] [def: additional growth]
		shlankvuksik/A [def: thin] 
vaks/N [m] [def: wax (substance)] % Harduf
val/N [m] [def: roller; bulwark, rampart] 
vald/Xvelder [m] [def: forest] /Dveld [def: grove] 
	veldldik/A [def: forest-like] 
	baveldert/A [def: forested] 
valger/V/T [def: roll; wander; be homeless (with "zikh")] /Gavek/Garum
	/Gum [def: knock down]
	farvalger/V/Bfarvalgert [def: lie about]
valize/S [f] [def: valise, suitcase]
/Xvaln [def: election] 
	val [prefix] [def: elective] 
valute/S [f] [def: currency] 
vanadyum [m] [def: vanadium (V)] 
vanda'l/N [m] [def: vandal] % Harduf
	vandalizm [m] [def: vandalism] % Harduf
vander/V/T [def: travel; wander] /Goys/Garum
	vanderung/N [f] [def: wandering]
		oysvanderung/N [f] [def: emmigration] 
	vanderer/S [m] [def: wanderer]
		oysvanderer/S [m] [def: emmigrant] 
vandl/V/T [def: become; go for a walk] 
	farvandl/V/Bfarvandlt [def: transmogrify]
		farvandlung/N [f] [def: conversion, transformation]
	umvandlung/N [f] [def: vicissitude] 
vane/S [f] [def: bathtub] 
	[idiom: makhn a vane = take a bath]
vani'l vanile [def: vanilla] 
vant/Xvent [f] /Dvent [def: wall] 
	shteynvant/Xshteynvent [f] [def: rock wall] 
	[idiom: shlogn a kop in vant = make a commotion]
	[idiom: nit zey meyn ikh, di vant meyn ikh = not to mention names]
	[idiom: krikhn oyf di glaykhe vent = go stir-crazy]
vants/N [f] [def: bedbug] 
var/A [def: true] tsvor [def: truly] 
varem/K [def: warm, thermal]
	tsevarm/V/Btsevaremt [def: warm up (with "zikh")] 
	varemkayt/N [f] [def: warmth] 
	varem/V/T [def: heat] /Gadurkh/Gon 
	dervarem/V/Bdervaremt [def: warm] 
	varmes/N [n] varemes/N [n] [def: dinner]
varenye/S [f] [def: jam (food)]
	/Xvarenikes [f] [def: a kind of food] 
varf/V/Bgevorfn [def: throw, pitch, cast; toss about (with "zikh")]
	/Garayn/Garoys/Garop/Garoyf/Gavek/Gfor/Gop/Gunter/Gariber/Garum/Gdurkh
	/Giber/Gayn/Gum/Goys/Gtsu
	/Gon [def: attempt] 
	farvarf/V/Bfarvorfn [def: set aside for safekeeping] % gendz in a shtayg
	forvurf/N [m] [def: reproof] 
	tsevarf/V/Btsevorfn [def: toss] 
	bavarf/V/Bbavorfn [def: sprinkle, pelt] 
	varfer/S [m] [def: pitcher, thrower] 
	oysvurf/N [m] [def: discard]
	vorf/N [m] [def: toss, hurl, throw]
	onvarf/N [m] [def: attempt] 
	[idiom: kartn varfer = fortune teller]
varg [n] [def: material]
	aheymvarg/N [n] [def: take-out food] [note: V]
	altvarg/N [n] [def: old things]
	apteykvarg/N [n] [def: pharmaceuticals]
	ayznvarg/N [n] [def: ironware]
	esnvarg [n] [def: food]
	grinvarg [n] [def: vegetables] 
	glozvarg [n] [def: glassware]
	kleynvarg [def: small people or things]
	kupervarg [n] [def: copper wares]
	lernvarg [n] [def: teaching aids] 
	leyenvarg [n] [def: reading material]
	luftvarg [n] [def: vaporware (advertized but unavailable goods) (computer)]
	nashvarg [n] [def: snack food]
	nervarg [n] [def: nutrient] 
	royvarg [n] [def: raw materials]
	shtubvarg [n] [def: household material]
	shukhvarg [n] [def: shoe materials] 
	tepvarg [n] [def: pottery] 
	veykhvarg [n] programvarg [n] [def: software (computer)]
	yungvarg [n] [def: youngsters] 
	zilbervarg [n] [def: silverware] 
	zisvarg [n] [def: sweet food] 
variant/N [m] [def: variant]
	variatsye/S [f] [def: variation] 
varnishkes/X [def: a fried-pasta food]
vart/V/T [def: wait] /Giber/Gtsu/Gop/Goys
	dervart/V/Bdervart [def: await, expect] dervartung/N [f] [def: expectation] 
	umdervart/A [def: unexpected] 
varyant/N [def: variant] 
	redvaryant/N [def: spoken variant] 
	varyatsye/S [f] [def: variation; (musical) variation] 
	varyabl/N [m] [def: variable (mathematics)] 
vaser/N/D [n] [def: water] /Iik [def: watery]
	kvalvaser [n] [def: spring (water)] 
	sheydvaser [n] [def: nitric acid (common name)] 
	vundervaser [n] [def: magic water] 
	zaltsnvaser [n] [def: saltwater]
	farvaser/V/Bfarvasert [def: water] 
	bavaser/V/Bbavasert [def: irrigate] 
		bavaserung/N [f] [def: irrigation] 
	[idiom: ton a hant in kalt vaser = be involved in physical labor]
	[idiom: haltn zikh oyf vaser = float]
	[idiom: vi in vaser arayn = disappearing without a trace]
	[idiom: vi a fish in vaser = in one's element]
vash/V/Bgevashn [def: wash] /Garum/Gayn/Goys/Gop/Goyf
	tsevash/V/Btsevashn [def: wash] 
	umgevashn/A [def: unwashed] 
	vesh [n] [def: laundry; underwear; linen] untervesh [n] [def: underwear]
	vesher/S [m] vesherin/S [f] [def: washer (person)] 
	vasher/S [m] [def: washer (machine)] 
		keylem{Klym}-vasher/S [m] [def: dishwasher] 
	[idiom: zikh vashn esn = wash the hands before eating]
vate [f] [def: cotton; cotton batting] /In [def: cotton] 
vayb/Xvayber [n/f] [def: wife; woman] /D /Iish /Ilekh [def: female; feminine]
	klogvayb/Xklogvayber [n] [def: professional mourner]
	vayberish/A vaybersh/A vayblekh/A [def: female] 
	bavaybt/A [def: married] 
	vaybernik/Ees [def: womanizer] 
	[idiom: man un vayb = married couple]
vayikro{|w|ykr#}/H [def: book of Leviticus] 
vayivrekh{|w|yBrH}/H [m] [def: escape, running away] 
	[idiom: makhn a vayivrekh{|w|yBrH} = escape, run away]
vaykh/V/T [def: move away; stay distant] 
vayl [def: during, as long as; because]
	vayle/S [f] [def: while] 
	dervayl [adv] dervayls [adv] [def: meanwhile]
	tsaytvaylik/A [def: temporary]
	vaylinke/S [def: little while] 
	langvayl/V/T [def: bore]
		langvaylik/A [def: boring]
		langvaylikayt [f] [def: boredom] 
	vayl/V/T [def: stay; enjoy oneself (with "zikh")] % Harduf
vayn/N [m] [def: wine] 
	/Dvaynper [def: grape] % no positive
	vaynshl/X [m] [def: sour cherry]
vays/K [def: white] /Ier /Iink /Ilekh
	vayskayt/N [f] [def: whiteness] 
	farvays/V/Bfarvayst [def: whiten] 
	shneyvays/A [def: snow-white] 
	vaysl/Eekh [n] [def: egg white; white of the eye]
vayt/K [def: far; further, next (as "vayter")]
	/Iik [def: remote] /Ilekh [def: somewhat far] /Ierdik [def: next]
	vaytn/S [def: distance]
	vaytkayt/N [f] [def: distance]
	vaytn/A [def: distant] 
	dervayter/V/Bdervaytert [def: separate]
		dervaytertkayt/N [f] [def: separation] 
	fundervaytns [adv] [def: from afar] 
vayz/V/Bgevizn [def: show] /Garoys/Goyf/Gon/Goys
	bavayz/V/Bbavizn [def: appear; show, prove; succeed (with infinitive)]
		/Garoys
		bavayz/N [m] [def: proof] 
	dervayz/V/Bdervizn [def: show; proof] dervayz/N [m] [def: proof] 
	vayzer/S [m] [def: indicator, hand (clock/watch), needle (gauge)]
		likhtvayzer/S [m] [def: signal light] 
		vegvayzer/S [m] [def: directory, guide, guidebook]
	onvayz/N [m] [def: example; indication, proof]
		onvayzung/N [f] [def: proof, indication] 
	foroysvayz/N [m] [def: advance showing (drama, film)]
	vayzfinger/S [m] [def: index finger]
	oysvay'zenish [n] [def: appearance, mirage] 
vaze/S [f] [def: vase]
	vazon/N [m] [def: flower pot] 
vazeli'n/N [m] [def: vaseline] 
vazhne/A [def: fine] 
ve/Een [m] [def: the letter V] 
	to'plve/Een [m] [def: the letter W] 
veb/V/T [def: weave] /Gayn/Gdurkh/Goys
	veb [m] [def: web]
		shpinvebs [n] [def: spider web] shpinvebekhts/N [n]
		geveb [m] [def: web] 
	bavebt/A [def: woven] farvebt/A [def: woven] 
	veber/S [m] veberke/S [f] [def: weaver] 
vedlik [prep] [def: according to; concerning]
vedme/S [f] [def: witch] 
veg/N/D [m] [def: way; road]
	avek [adv] [def: away]
		[idiom: eyn mol avek = that's number one]
	lebnsveg/N [m] [def: life path]
	kreytsveg/N [m] [def: crossroad, intersection]
	hinterveg/N/D [m] [def: byway]
	milkhveg [m] [def: Milky Way] 
	onleygveg/N [m] [def: detour; roundabout way] 
	oysveg/N [m] [def: exit] 
	sheydveg/N [m] [def: fork (in road)] 
	toytnveg/N [m] [def: death path]
	vanderveg/N [m] [def: wanderer's road] 
	zaytnveg/N/D [m] [def: side road] 
	tsurikvegs [adv] [def: backward]
	untervegs [adv] untervegns [adv] [def: on the way]
veg/V/Bgevoygn [def: weigh] /Gop
	/Giber [def: outweigh] 
	bavog/V/Bbavoygn [def: weigh] 
	vog/N [f] [def: weight (measure); scale] /Iik [def: heavy] 
	vogshl/N vogshal/N [f] [def: scale, scale dish]
	baveg/V/Bbavegt [def: move]
		bavegung/N [f] [def: movement]
		baveglekh/A [def: movable]
		umbaveglekh/A [def: immovable] 
	glaykhgevikht glaykhvog [f] [def: balance, poise]
	gevikht/N [n] [def: weight (object)]
vegetaryer/X [m] [def: vegetarian]
vek/V/T [def: awaken, wake] /Goyf/Goys/Giber
	dervek/V/Bdervekt [def: awaken] 
	veker [m] [def: awakener, alarm clock] /D
veksl/N [m] [def: exchange; bill of exchange; promissory note]
	veksl/N [def: exchange; change (clothes)]
	veklser/S [m] [def: money-changer; banker]
	veksl-gesheft/N [n] [def: exchange business]
ve'ktor/N [m] [def: vector (mathematics)]
vel vest vestu vet veln [verb] [def: will (future)] [grammar: takes infinitive]
	khʼvel [def: I will]
velk/V/T [def: wither]
	farvelk/V/Bfarvelkt [def: wither] 
velkher [adj] velkhes [adj] velkhn [adj] velkhe [adj] [def: which]
	% velkh/A generates bad forms: velkhs, velkh
velt/N/D [f] [def: world] /Iish
	veltlekh/K [def: worldly; secular]
		alveltlekh/A [def: old-worldly] 
		veltlekhkayt/N [f] [def: worldliness] veltishkayt/N [f]
	sportvelt/N/D [f] [def: world of sports] 
	vundervelt/N/D [f] [def: world of wonders]
	yeneveltik/A [def: of the world to come]
	oysveltlekh/A [def: unworldly]
	alveltlekh/A [def: world-wide] 
	[idiom: zint di velt iz a velt = it's always been this way]
	[idiom: stam{sWm} in der velt arayn = without evident purpose]
	[idiom: klingen/shemen mit emetsn a velt = be famous]
velvl/A [def: cheap] volvl/A
ven [conj] [def: when, if (contrary to fact)] 
	vens [adv] [def: ever] 
	[idiom: eyder vos un eyder ven = immediately]
vend/V/T [def: turn; depend on (with "zikh in")] /Gop
	gevondn/A [def: turned]  % alternative participle
	/Gon [def: apply] 
	vendung/N [f] [def: turning]
	onvendung/N [f] [def: application] 
	[idiom: es vendt zikh = it depends]
	[idiom: ongevendte forshung = applied research]
vene/S [f] [def: vein] 
ventilatsye [f] [def: ventilation] 
	ventilator/N [m] [def: fan, ventilator] 
ventke/S [f] [def: fishing rod]
ver/V/Bgevorn [def: become]
ver/V/T [def: defend] /Gon
	geve'r [n] [def: defense; weapon, arms]
	farver/V/Bfarvert [def: prohibit, forbid] 
	opver [adj] [def: defense] % uninflected, as in opver-kamf
ver [pronoun (subjective)] [def: who] 
	vemen vem [pronoun (objective)] [def: whom] 
	vemes vemens [pronoun (possessive)] [def: whose]
	[idiom: vi bay vemen = everyone to his own tastes]
	[idiom: nit abi ver = not just anybody]
verande/S [f] [def: veranda, porch] 
verb/N [m] [def: verb]
	konverb/N [m] [def: converb (grammer)] 
	verbal/A [def: verbal (spoken)] 
verbe/S [f] [def: willow] 
verbi'r/V/Bverbi'rt [def: solicit, recruit, canvass] 
verg/V/Bgevorgn [def: strangle; choke]
	dervarg/V derverg/V/Bdervorgn [def: suffocate; choke]  % both forms
verk/X [n] [def: work]
	kunstverk/X [n] [def: art] kunstverker [m] [def: artist]
	hantverk/X [n] [def: handicraft] hantverker [m] [def: handcrafter] 
		hantverkeray'/N [n] [def: handicraft] 
		ha'ntverkung/N [f] [def: handwork] 
	geve'rk/N [n] [def: mechanism] 
versye/S [f] [def: version]
vert/N [f/m] [def: value; worth]
	verde/S [f] [def: dignity; worth] 
	vertik/A verdik/A [def: dignified; worthy]
		merkverdik/K [def: noteworthy]
		gedenkverdik/A [def: memorable] 
		umverdik/A [def: unworthy] umverdikayt/N [f] [def: unworthiness] 
		farumverdik/V/Bfarumverdikt [def: make/declare unfit] 
	[idiom: der hunt iz vert dem shtekn = he deserves his fate]
vesle/S [f] [def: oar] 
vesne [f] [def: Spring (season)] 
vest_{vsW}/H [f] [def: menstruation]
vestl/Eekh [n] [def: vest]
vet/V/T [def: wager, bet (with "zikh")] 
	vet/N [m] gevet/N [n] [def: bet, wager] geve'tenish/N [n]
veter/N [m] [def: weather] 
	tseveterung/N [f] [def: weathering, erosion] 
veteran/N [m] [def: veteran] 
veterina'r/N [m] [def: veterinarian] 
veto/S [m] [def: veto] 
	vetoi'r/V/Bvetoi'rt [def: veto] 
ve'tshere/S [m] [def: evening meal] 
vevrik/S/D [m] [def: squirrel]
	veverke/S [f] [def: chipmunk; squirrel] 
vey/N [def: woe] 
	vey [interj] [def: woe!] 
	vey'enish/N [def: pain]
		nokhvey/N nokhvey'enish/N [def: residual pain]
		trogvey'enish/N [def: labor pang] 
	veytik/N [m] [def: pain] veytog/N [m] % variant spelling
		veytikdik/A [def: painful] 
		hartsveytik/N [m] [def: heartache]
		boykhveytik/N [m] [def: stomach ache]
		kopveytik/N [m] [def: headache] 
		vuksveytik/N [m] [def: growing pains] [note: V]
	veytik/V/T [def: ache] /Gon
		farveytikt/A [def: torture] 
	tseveytik/V/Btseveytikt [def: pain] 
	veytuendik/A [def: painful] 
	[idiom: es tut mikh vey = it hurts]
veydl/N [m] veyndl/N [def: tail] 
	nashnveydl [n] [def: Cinderella] 
veyk/V/T [def: soak] /Goys
	veykshaft/N [f] [def: koshering pot] 
veykh/K [def: soft] /Iink [def: small and soft] 
	veykhkayt/N [f] [def: softness] 
veyl/V/T [def: select, elect] [usage: inadmissable] /Goys
	derveyl/V/Bderveylt [def: select] /Goys
		oysderveyltkayt/N [f] [def: specialness] 
	/Xvaln [def: election]
		/Xtsuriktsi-valn [def: recall election] [note: V] 
	oysval/N [m] [def: choice, selection (often with "makhn")] 
veyn/V/T [def: cry, weep] /Gon/Goys
	geveyn/N [n] [def: groan; lament] geveyneray'/N [n] [def: groaning] 
	tseveyn/V/Btseveynt [def: cry for a while (with "zikh")] 
	farveyn/V/Bfarveynt [def: bemoan]
		farveynt/A [def: tearful] 
		farveyntkayt/N [f] [def: sorrow] 
	baveyn/V/Bbaveynt [def: lament]
		baveyner/S [m] baveynerke/S [f] [def: cryer] 
	antveyn/V/Bantveynt [def: wean]
veynik/K [def: few]
	i'nveynik/K i'neveynik/K i'nenveynik/K i'nerveynik/K [def: inside]
	oy'snveynik [adv] [def: outside, external; by heart (with "fun"/"oyf")] 
		oy'snveynik/N [m] [def: outside] 
		oy'snveynikst/A [def: outside] 
	veynikstns [def: at least] 
	vaynikayt/N [f] [def: fewness, smallness] 
	[idiom: mer (oder) veyniker = give or take; approximately]
	[idiom: mayn veynikayt = I]
veys/Vvisn/Bgevust [def: know]
	bavust/A [def: famous] umbavust/A [def: unknown] 
	bavustzayn [n] [def: consciousness]
		bavustzinik/A [def: conscious] 
	derveys/Vdervisn/Bdervust [def: learn, find out (with "zikh")] 
	visn/S [m] [def: knowledge] 
	visnshaft/N [f] [def: science] /Ilekh [def: scientific]
		visnshaftler/S [m] [def: scientist] 
	umvisndik/A [def: unwitting]
		umvisndikayt/N [f] [def: ignorance] 
	visik/A [def: conscious] 
		visikayt/N [f] [def: knowledge] 
			shprakhvisikayt/N [f] [def: knowledge of languages] 
		untervisikayt/N [f] [def: subconscious] 
	gevisn/S [n] [def: conscience] 
		[idiom: lign afn gevisn = lie on one's conscience]
	[idiom: men zol visn = for the record]
	[idiom: zolst visn (zayn) = zay visn = megst visn = for your information]
veye/V/T [def: blow (wind); winnow] 
	veye/N [m] [def: flurry] 
veyts [m] [def: wheat] /In [def: wheaten] 
vezn/S [n] [def: being; fuss]
	shulvezn/S [n] [def: school system] 
	vezntlekh/A [def: actual, systematic] 
vi [adv] [def: how; as]
	vibald [adv] [def: so long as] 
vibor/Ees [def: election (Russian)] 
vibri'r/V/Bvibri'rt [def: vibrate] /Gdurkh
vide{vydwy}/Xviduem{vydwym}/H [f] [def: confession; "vidui" penitential prayer] 
video [def: video] 
vider [adv] [def: again] 
vider [m] [def: repulsion] dervider [def: disgust]
	vidershpenik/V/Bvidershpenikt [def: disobey] % should be moved to shpan/V
vider/S [m] [def: ram]
vidme/V/T [def: dedicate]
	vidmenung/N [f] [def: dedication] 
vie/S [f] [def: eyelash] 
vig/V/T [def: rock; swing] /Giber
	farvig/V/Bfarvigt [def: rock] 
	tsevig/V/Btsevigt [def: rock] 
	vig/D [f] [def: cradle] 
vikher/S [m] [def: whirlwind] 
	vikher/V/T [def: whirl, rush] 
vikhtik/K [def: important, major]
	vikhtikayt/N [f] [def: importance] 
vikl/V/T [def: wrap] /Gayn/Garoyf/Goyf/Garum/Gop
	tsevikl/V/Btseviklt [def: wrap] 
	farvikl/V/Bfarviklt [def: wrap] 
	/Dvik [def: wrap] 
vikoyekh{vyKwH}/Xvikukhem{vyKwHym}/H [m] [def: argument, polemic, dispute]
vil/V/Bgevolt [def: want]
	veln % infinitive
	bavilik/V/Bbavilikt [def: grant, accord, deign (with "tsu")]
	vilik/K [def: willing]
		umvilik/K [def: unwilling]
		frayvilik/A [def: freely willing, volunteer] 
	farvil/V/Bfarvolt farveln [def: desire (with "es - zikh")]
	vilndik/A [def: intentional] nishtvilndik/A [def: unwilling] 
	viln/S [m] [def: will, desire] 
	khʼvil [def: I want]
vild/K [def: wild]
	vildkayt/N [f] [def: wildness]  vi'ldenish/N [f] [def: wilderness] 
	vildeve/V/T [def: rampage] 
	farvildeve/V/Bfarvildevet [def: rampage, run wild, degenerate]
	tsevildeve/V/Btsevildevet [def: rampage] 
vilgotsh/X [def: dampness]
vilkir [def: brutality] [usage: not recommended] [origin: maybe from Valkyrie]
vinakush [def: sex appeal]  % from Yekhiel Shraybman, via Sheva Zuker
vind [def: misfortune ("vey un vind")] 
vindl/Eekh [n] vindele/Ekh [n] [def: diaper] 
	vindl/V/T [def: diaper] 
		/Giber [def: change diapers] 
vink/V/Bgevunken [def: wink] /Gon/Garop
	vunk/N [m] [def: wink]
	onvunk/N [m] [def: wink] 
vinkl/N/D [m] [def: corner; angle]
	kukvinkl/N [m] [def: standpoint] 
	farvinklt/A [def: full of corners]
	grodvinkldik/A [def: right-angled] 
	[idiom: groder vinkl = right angle]
vint/N/D [m] [def: wind] /Iik
	tsevintl/V/Btsevitlt [def: flutter (with "zikh") (poetic)]
	shturemvint/N [m] [def: storm wind]
	virblvint/N [m] [def: whirlwind] 
	zumervint/N [m] [def: summer wind] 
vinter/S [m] [def: Winter (season)] /Idik [def: wintry] 
vintsh/V/Bgevuntshn [def: wish] /Gop
	vintsheve/V/T [def: wish] /Gon
	vintshevanye/S [f] [def: good wishes] 
	vintshung/N [f] vuntsh/N [m] [def: wish] 
vintsik/A [def: few] /Ilekh [def: few] 
	vinstikstns [adv] [def: at least] 
	[idiom: mer oder vintsiker = fil-vintsiker = give or take; approximately]
virbl/V/T [def: seethe, whirl] 
virk/V/T [def: have an effect; cause] /Gayn/Goyf/Goys
	virkung/N [f] [def: effect] 
	virklekh/A [def: real; indeed]
		virklekhkayt/N [f] [def: reality] umvirklekhkayt/N [f] [def: unreality] 
		umvirklekh/A [def: unreal]
	virkzam/A [def: real, actual] [usage: inadmissable]
	farvirklekh/V/Bfarvirklekht [def: effect, realize, accomplish]
	bavirk/V/Bbavirkt [def: have an effect; cause] 
virtshaft/N [f] [def: economy] [usage: inadmissable]
	/Ilekh [def: of the economy] [usage: inadmissable]
	landvirtshaft/N [f] [def: national economy] [usage: inadmissable]
virtue'l/A [def: virtual] % Forwards
virtuo'z/N [m] [def: virtuoso] 
vish/V/T [def: wipe] /Gop/Goys
	/Gnokh [def: mop up] 
	farvish/V/Bfarvisht [def: wipe away] 
	dervish/V/Bdervisht [def: wipe; catch; trace, track down] 
vishnik [m] [def: cherry brandy]
viski/S [m] [def: whiskey] 
vispe/S [f] [def: island] 
vist/A [def: empty; desolate]
	vi'stenish/N [f] [def: desolation; wasteland, desert]
	farvist/A [def: desolate]
vitami'n/N [m] [def: vitamin] 
vitrine/S [f] [def: display case, shop window, showcase]
	vitrazh/N [def: stained-glass window] 
vits/N [m] [def: joke] /Iik /Iedik [def: joking] 
	vitsl/V/T [def: joke (with "zikh")]
	[idiom: privater vits = inside joke] [note: V]
vitse [def: vice (president)] 
vize/S [f] [def: visa] 
vizele/Ekh [n] [def: weasel] 
	[idiom: dos shvarts-fusike vizele = American ferret]
vizit [m] [def: visit]
vizye/S [f] [def: vision]
	vizue'l/A [def: visual] 
vofn/S [m] [def: weapon]
	gevofnt/A [def: armed]
	bavofn/V/Bbavofnt [def: arm] 
	antvofn/V/Bantvofnt [def: disarm] 
vogl/V/T [def: wander] 
	vo'glenish/N [n] [def: wandering] 
	farvoglt/A [def: homeless]
vokabula'r/N [m] [def: vocabulary] 
voka'l/N [m] [def: vowel]
	vokalizi'r/V/Bvakalizi'rt [def: vocalize] 
vokh/N [f] [def: week] /Iik /Indik [def: weekly]
	/Iedik [def: everyday, ordinary]
	mitvokh/N [m] [def: Wednesday]
	vokhnik/Ees [m] vokhernik/Ees [m] vokherer/S [m] [def: usurer]
	indervokh [def: weekday] /Iedik [def: week-day] 
		indervokhn [def: weekday]
	vokhntog [m] [def: weekday]
	tsveyvokhndik/A [def: two-week] 
vokzal/S/N [m] [def: train station] 
vol/V/T [def: wish] /-vol % no present tense
vol [f] [def: wool] /In [def: woolen] 
	volek/Ees volik/Ees [def: felt boot] 
volf/N/Xvelf [m] [def: wolf] /Iish [def: wolf-like] 
	velfikhe/S [f] [def: she-wolf]
volkn/S [m] [def: cloud] /Idik [def: cloudy]
	farvolknt/A [def: cloudy] 
volt/N [m] [def: volt (electrical)]
	voltazh/N [m] [def: voltage] 
volt/V/T [def: would] [grammar: takes infinitive]
	mʼvolt [def: one would]
von [interj] [def: get away]
vontse/S/D [def: whisker; moustache]
	/D [def: whiskers of an animal] % Harduf
vor [f] [def: reality] farvor [interj] [def: really] 
	vorhayt/N [f] [def: truth] % Harduf
	vorhaftik/A [def: true, real]
vor/A [def: awake]
	vor [def: state of being awake] 
	[idiom: oyf der vor = awake]
vorem [def: because (German)] 
vorem/Xverem [m] [def: worm] /Dverem
	lindvorem/Xlindverem [m] [def: dragon] 
vorke/V/T [def: coo (sound of a dove)] 
vorn/V/T [def: warn] 
	bavorn/V/Bbavornt [def: safeguard] 
		bavo'renish/N [n] [def: safeguard, precaution] 
	vorenung/N [f] [def: warning] 
	gevorntkayt/N [f] [def: wariness] 
vort/Xverter [n] [def: word]
	verterdik/A [def: word-like]
	vertl/Eekh vertele [n] [def: witty saying]
	bindvort/Xbindverter [n] [def: conjunction (grammar)] 
	dankvort/Xdankverter [n] [def: thank-you speech] 
	forvort/Xforverter [n] [def: forword, preface] 
	gezegnvort/Xgeze'gnverter [n] [def: parting word] 
	ernvort/Xernverter [n] [def: word of honor; parole] 
		[idiom: oyf ernvort = on parole]
	glaykhvort/Xglay'khverter [n] /Dglaykhvert [def: witty saying]
		glaykhvertik/A [def: wittily said] 
	farfirvort/Xfarfi'rverter [n] [def: misnomer] 
	hoyptvort/Xhoy'ptverter [n] [def: main point] 
	shtekhvort/Xshte'khverter [n] /Dshtekhvert [def: verbal jab] 
	shprikhvort/Xshpri'khverter [n] /Dshprikhvert [def: folk saying] 
	tsaytvort/Xtsay'tverter [n] [def: verb (German)]
	zakhvort/Xzakhverter [n] [def: noun] 
	zidlvort/Xzi'dlverter [n] /Dzidlvert [def: curse word]
	ve'lt|svertl/Eekh fo'lksvertl/Eekh [n] [def: folk saying] 
	vortirer/S [m] [def: word processor]
	vertl/V/T [def: jest] /Gdurkh [def: quarrel, dispute (with "zikh")] 
		durkhgevertlt/A [def: angry] 
vortshe/V/T [def: turn restlessly; growl, grumble] /Gunter
	vortsh/N [m] [def: growl] % Harduf
vortsl/V/T [def: root]
	/Gayn [def: plant]
	/Goys [def: uproot] 
	farvortsl/V/Bfarvorstlt [def: root] 
	vortsl/N [m] [def: root] /Iish [def: root-like] 
		boymvortsl/N [m] [def: tree root] 
		tsonvortsl/N [m] [def: root (dental)] 
	gevirts/N [n] [def: spice] /Iik [def: spicy] 
vos voser/A voden voszhe [def: what, why (interrogative); that (conjunction)]
	farvos [def: why (interr)] 
	[idiom: nokh dem vos = after (conjunction)]
vov{vov}/H/N [m/f] [def: Hebrew letter Vav] 
	lamedvovnik{lmd-vovnik}/H/Ees [m] [def: hidden righteous person]
vovkalak/Ees [def: wereworlf] 
voyazhor/N [m] [def: peddler] 
voye/V/T [def: howl (sound of a wolf)] 
	gevoy/N [m] voy/N [m] [def: howl (sound of a wolf)] 
	tsevoyet/A [def: ??] % hint fun keytn voyen un vern tsevoyet
voyevudestve/S [f] [def: administrative region, main town in a region (Polish)] 
voyl/A [def: nice, good] 
voyn/V/T [def: live, reside] /Gop
	/Gbay [def: attend] 
	voyner/S [m] voynerin/S [f] [def: inhabitant] 
		aynvoyner/S [m] aynvoynerin/S [f] [def: resident] 
		mitvoyner/S [m] mitvoynerin/S [f] [def: roommate]
	voynung/N [f] [def: residence, dwelling; apartment] 
	bavoyn/V/Bbavoynt [def: inhabit] 
vozne/S [m] [def: bailiff] 
vu vanen vanet [adv] [def: where]
	andershvu [adv] [def: somewhere else]
	vuhin [adv] [def: wither, wither?] 
	bizvanen [adv] [def: until, until when?] 
vulga'r/A [def: vulgar] 
vulka'n/N [m] [def: volcano] 
vund/N [m] [def: wound]
	vundik/V/T [def: wound]
	farvundik/V/Bfarvundikt [def: wound] 
	farvundet/A farvundt/A [def: wounded] 
	[idiom: oyf gehakte vunden = in trouble]
vunder/V/T [def: astonish; wonder, be surprised (with "zikh")]
	vunderlekh/A vunderbar/A [def: wonderful]
	vunder/S [m] [def: marvel] 
	bavunder/V/Bbavundert [def: admire]
		bavunderung/N [f] [def: admiration] 
	farvunder/V/Bfarvundert [def: be amazed at]
		farvunderung/N [f] [def: amazement] 
		farvundertkayt/N [f] [def: amazement] 
	beyzvunder/S [n] [def: horrible sight]
vursht/N [def: sausage; salami; clarinet (klezmer-loshn)]
	/D [def: hot dog, frankfurter] 
vredne/A [def: ugly; disgusting] 
vyo [interj] [def: gidyap (to a horse)] 
vyolontshe'l/N [m] [def: cello, violoncello] % Harduf
vyorst/N verst/N [m] [def: verst (about 0.66 miles)]
yaades{yhdwT}/H [n] [def: Jewishness; Judaism] 
yabed/V/T [def: gossip (Russian)]
yabke/S [f] [def: potato] 
yad{yd}/H/N [m] [def: hand; pointer]
	/Ll [def: at hand]
	/Lm [def: immediately]
	/Lb [def: in the hand] 
	[idiom: kafhayadke{Kf-hydke} = hand computer] % neologism
yadishlev/A [def: worn out] 
yagde/S [f] [def: berry] 
	[idiom: shvartse yagdes = blueberries]
yahudish [def: Judeo-Arabic] 
yak/N [f] [def: jacket (clothing)]
yakhmer/V/T [def: wail??]
	tse|yakhmer/V/Btse|yakmert [def: be hysterical] 
yakht/N [m] [def: yacht] 
yakres{|ykrwT}/H/N [n/m] [def: inflation] /Idik [def: inflationary]  
yam{|ym}/Xyamem{|ymym}/H/N [m] [def: ocean] % both plurals exist
	/Ll [def: to the sea] 
	[idiom: eyver_{eBr} l|yam = over the sea]
yanua'r [m] [def: January] 
yar/N [m] [def: gulch, ravine] 
yard/N [m] [def: yard (measure)] 
yari'd{yryd}/H/N [m] [def: fair (for selling goods)] 
yarli'k/N [m] [def: label, ticket] [usage: rare]
yarmlke/S [f] [def: scullcap] 
yarshn{|yrSn}/H/V/T [f] [def: inherit] 
	yerushe{yrwSh}/H/S [f] [def: inheritance]
		/Lb [def: by inheritance] 
		/Idik [def: inherited] 
		yerushedikayt{yrwShdikayt} [f] [def: inheritability] 
	yoyresh{ywrS}/Xyorshem{ywrSym}/H [m] [def: heir] 
yasher{ySr}/H [def: congratulations (with "- koyekh")] 
ya'shtsherke/S [f] [def: lizard]
	[idiom: lakhn mit yashtsherkes = laugh through tears]
yasine/S [f] yasen/S [m] [def: ash (tree), mountain ash or rowan (tree)] 
yasle/S [f] [def: gums (mouth)
yasles [def: manger] % plural only
yasmi'n/N [def: jasmine (plant)] 
yat/N [m] [def: fine lad; chap] yatikhe/S [f] [def: fine lass] 
yatebedam/S [m] [def: self-important person] 
yatke/S [f] [def: butcher shop] 
yave/V/T [def: show up surprisingly (with "zikh")] 
yede/A [def: each, every] % irregular; we show the forms
	yederer [adj] yedere [adj] yedern [adj] yedns [adj] [def: each] 
	yederns [adj] [def: each] 
	a|yeder [adj] a|yederer [adj] a|yedn [adj] [def: each] 
	yetveder [def: each] 
	% CY E.27, E.28
yefeyfye{yfhfyh}/Xyefeyfyes{yfhfywT} [f] [def: beauty, beautiful woman] 
yehudem{|yhwdym}/H [def: Jews]
	/Ll [def: joyous] % reference to Esther:9
yek/V/T [def: taunt] % Harduf
yeke/S [m] [def: German Jew (pejorative)]
yelole{yllh}/Xyeloles{yllwT}/H [f] [def: wail]
yemakh{ymH}/H [def: be blotted out] 
	[idiom: yemakh shmoy{Smw} = may his name be blotted out]
yener [adj] [def: that] % irregular; we show all forms; CY E.30
	yenem [adj] yene [adj] yents [adj] yenems [adj] yeners [adj] [def: that]
	yenik/A [def: that]
yenike{ynyk|h}/Xyenikes{ynykwT}/H [f] [def: sustenance; inspiration] 
yenke/V/T [def: moan] % Harduf
yente/C [def: Yente; blabbermouth, busybody; shrew] 
yents/V/T [def: have intercourse (taboo)] 
	yentser/S [def: someone who has intercourse (taboo)] 
yer/V/Bgeyoyrn [def: ferment] 
yerokes{yrkwT}/H [def: vegetables]
yeseyre{yTyrh}/H [def: extra]
	[idiom: neshome{nSmh} yeseyre = extra soul for the duration of the Sabbath]
yesh{yS}/H [m] [def: existence] 
yeshive{ySyBh}/Xyeshives{ySyBwT}/H [f] [def: religious academy] 
	/Lb [def: in the acadamy] 
yeshue{ySweh}/H [f] [def: salvation] 
yesod{yswd}/Xyesoydes{yswdwT}/H [m] [def: foundation]
	[adj] [def: prime (mathematics)] [grammar: undeclined]
	meyased{mysd}/H [def: based] 
/Xyesurem{yswrym}/H [def: pains] 
	[idiom: hob nit keyn yesurem{yswrym} = dont worry; never mind]
yet/V/T [def: weed] % Harduf
yetsire{ycyrh}/H [f] [def: creation]
yetsiyas{ycy#T}/H [def: departure from] % TODO: put under moytsi
	[idiom: yetsiyas mitsrayem = exodus from Egypt]
yeyesh{yi#wS}/H [m] [def: doubt, despair] % also pronounced "yiyesh"
yeytser{ycr}/H [def: inclination] 
	[idiom: yeytser h|ra{re} = evil inclination]
	[idiom: yeytser h|toyv{twB} = good inclination]
yid/N/J/D [m] [def: Jew]
	yidntum [n] [def: community of Jews]
	yidene/S [f] [def: Jewish woman (sometimes pejorative)] 
	yidish [n] [def: Yiddish language] /A [def: Yiddish, Jewish] 
		yidishkayt/N [f] [def: Jewishness, Judaism]
		yidishizm/S [m] [def: Yiddish awareness movement]
		yidishlekh/A [def: Jewish, Yiddish] 
		faryidish/V/Bfaryidisht [def: Judaize] 
		yidishi'st/N [m] yidishistke/S [f] [def: partisan of Yiddish] 
	yudaistik/N [f] [def: Judaic studies] 
yikhes{yiHws}/H [m] [def: pedigree, noble descent; quality]
	yakhsn{|yHsn}/Xyakhsonem{|yHsnym}/H [m] [def: well-born man; privileged man]
		/Iish [def: pedigreed]
		yakhsnte{|yHsnte}/S [def: well-born woman] 
	meyukhes{mywHs}/Xmeyukhosem{mywHsym}/H [m] [def: well-born]
		/Idik [def: well-born] 
yishev{yiSwB}/H/V/T [def: contemplate (with "- zikh")] 
	meyushev{mywSB}/H [def: contemplate (with "zayn")] 
		/Idik [def: sedate, deliberate]
yishev{yiSwB}/Xyishuvem{yiSwBym}/H [def: settled place] 
yizker{yzKwr}/H [def: memorial prayer]
yo [interj] ye [interj] [def: yes]
	a|yo [interj] [def: really?]
yod [m] [def: iodine (I)] 
yoder/A [def: nuclear] 
yodl/V/T [def: yodel] 
yodle/S [f] [def: fir (tree)]
yog/V/T [def: chase]
	/Garoys/Gtsurik/Gon/Garunter/Garum/Gariber/Gnokh
	deryog/V/Bderyogt [def: catch up to; overtake] 
	yog/N [f] [def: chase] 
	yoger/S [m] [def: chaser]
		nokhyoger/S [m] [def: pursuer]
		ge|yeg/N [n] [def: race, chase]
		yo'genish/N [n] [def: haste]
	yeger/S [m] [def: hunter, huntsman] 
	faryog/V/Bfaryogt [def: pursue; drive away] 
	yogeray/N [f] [def: persecution] 
yogurt/N [m] [def: yogurt] 
yokh/N [m/f] [def: yoke] 
yokhid{yHyd}/H [m] yekhide{yHydh}/H [f] [def: individual]
	[idiom: bas{bT} yekhide = only daughter]
	[idiom: ben{bn} yoihid = only son]
	yekhides{yHydwT}/H [def: solitude]
		/Lb [def: alone] 
yold/N [m] [def: chump, dupe, sucker]
yom{ywm}/Xyomem{ymym}/H [m] [def: day] /Lh [def: the day] 
	yomom{ywmm}/H [adv] [def: daily] 
	yemey{ymy}/H [def: days of] 
	[idiom: yomom{ywmm} velayle{|wlylh} = day and night]
yomer/V/T [def: bewail, lament]
	yomer/N [m] [def: lament] 
	yomeray'/N [n] ge|yomer [def: wailing] 
	tse|yomer/V/Btse|yomert [def: wail] 
	katsnyomer [def: hangover (illness)]
	yomerlekh/A [def: wailing] 
yontef{ywm-twB}/Xyontoyvem{ywm-twBym}/H [m] [def: religious holiday] 
	/Idik [def: holiday] 
yor/N/D [n] [def: year] /Iik [def: yearly]
	yortsayt/N [m] [def: anniversary of death] % note gender is m
	yerlekh/A [def: yearly] 
	iber_{e|ybwr}-yor/N [n] [def: leap year] 
	lernyor/N [n] [def: school year]
	hay|yor [n] [def: this year] /Iik hay|yerik/A [def: this year's] 
	iberayor/N [n] [def: next year] 
	yerik/A [def: old] % apparently -yerik and -yorik are interchangable
		mitlyerik/A [def: middle-aged] mitlyorik/A [def: middle-aged] 
		faryorik/A fara|yorik/A [def: last year's]
		gantsyorik/A [def: year-round]
		langyorik/A [def: long-standing] 
		eynyorik/A [def: 1-year-old]
		tsveyyorik/A [def: 2-year-old]
		drayyorik/A [def: 3-year-old]
		firyorik/A [def: 4-year-old]
		finfyerik/A finfyorik/A [def: 5-year-old]
		zeksyorik/A [def: 6-year-old]
		zibnyorik/A [def: 7-year-old]
		akhtyorik/A [def: 8-year-old]
		naynyorik/A [def: 9-year-old]
		tsenyorik/A [def: 10-year-old]
		tsvantsikyorkik/A [def: 20-year-old]
		draysikyorik/A [def: 30-year-old]
		fertsikyorik/A [def: 40-year-old]
		fuftsikyorik/A [def: 50-year-old]
		zekhtsikyorik/A [def: 60-year-old]
		zibetsikyorik/A [def: 70-year-old]
		akhtsikyorik/A [def: 80-year-old]
		nayntsikyorik/A [def: 90-year-old]
	ba|yornt/A [def: aged]
	kinderyorn [def: childhood] 
	[idiom: aza yor af im = curse him]
	[idiom: gut yor = difficult times (ironic)]
	[idiom: shvarts yor = devil]
	[idiom: im tsu lengere yor = may he live and be well]
	[idiom: fun a gants yor = ordinary]
yosem{yTwm}/Xyesoymem{yTwmym} [m] yoseme{yTwmh}/Xyesoymes{yTwmwT}/H [f] [def: orphan]
	far|yosem|t/A [def: ophaned] 
yovn{yvn}/Xyavonem{yvnym}/H [m] [def: Greek, non-Jew]
	yavonish{yvnish}/A [def: Greek, non-Jewish] 
	[idiom: vi a yovn in suke = like a wild man]
yoykh [f] yukhe/S [f] yuke/S [f] yushke/S [f] [def: soup (clear), broth; gravy]
	brotyoykh [f] [def: gravy] 
	[idiom: goldene yoykh = wedding broth]
yoyred{ywrd}/H [m] [def: someone going down] 
	yeride{yrydh}/Xyerides{yrydwT}/H [f] [def: downfall] 
yoysher{ywSr}/H [m] [def: justice; fairness] /Idik [def: just, fair] 
	um|yoysher{ywSr}/H [m] [def: injustice] 
	[idiom: kosher{KSr} v|yosher{ySr} = proper and just]
yoyvl{ywBl}/H [m] [def: jubilee year] /Idik [def: festive] 
	[idiom: eyn mol in a yoyvl = very seldom]
yozh [def: porcupine]
	ongeyozhet/A [def: in form like a porcupine]
yubileum/S [m] [def: jubilee] 
yud{yʼ}/H/N [m/f] [def: letter Yod] 
yuli [m] [def: July] 
yunesko [def: UNESCO]
yung/N [m] [def: youth] /Dying [def: boy, fellow, lad]
	yung/Kying [def: young] /Iink /Iitshk [def: young and small]
	yungatsh [m] [def: brat, rascal] 
	yungling/N [m] [def: strapping lad] 
	yugnt [f] [def: youth] /Ilekh [def: youthful] 
	gasnyung/N [m] gasnyungatsh/N [m] [def: street urchin]
	lernyung/N/Dlernying [m] [def: student]
	milneryung/N [m] [def: miller's child or apprentice]
	shnayderyung/N [m] [def: apprentice tailor] 
	yungerish/A yinglish/A yinglsh/A [def: young] 
	yinglvayz [adv] [def: as a boy] 
	grober-yung/Xgrobe-yungen [def: ruffian] % Harduf 
yuni [m] [def: June] 
yunion/S [f] [def: union] 
yuri' [m] [def: jurisprudence, law (subject of study)] 
yutshe/V/T [def: grunt] % Harduf
zabobon/Ees [def: nonsense]
zadiltshe/V/Bzadiltshet [def: confused ??]
	% arayngeredt in yenem biz er iz zadiltshet gevorn
zafron [m] [def: saffron] 
zaft/N [m] [def: juice; sap] /Iik [def: juicy; pleasingly plump] 
zak/Xzek [m] [def: sack] /Dzek [def: pouch] 
	drekzak/Xzek [m] [def: bag of feces]
	rukzak/Xrukzek /Drukzek [m] [def: backpack] 
zakh/N [f] [def: thing] za'khenish/N [n] [def: thing (ironic)] 
	/Ilekh [def: neuter (gender)] 
	veltzakh/N [f] [def: common event]
	bayzakh/N [f] [def: corollary] 
	muzzakh/N [f] [def: necessity] 
	[idiom: a got|s zakh = an act of God]
	[idiom: a muz zakh = a necessity]
zal/N [m] [def: hall, auditorium]
	gerikhtzal/N [m] [def: courtroom] 
zalb/N [f] [def: salve, ointment] /Iik % in Weinreich
	zalp/N [def: salve, volley, salvo]
	zalb/V/T bazalb/V/Bbazalbt [def: anoint] 
zalbe [def: together] 
zalts/V/T [def: salt] /Gayn/Gon/Goys
	zalts [n/f] [def: salt] [grammar: no plural]
		/Iik/Ien [def: salty] 
		kokhzalts [f] [def: cooking salt] 
		biterzalts [f] [def: epsom salts] 
	bazalts/V/Bbazaltst [def: salt] 
zam/V/T zoym/V/T [def: linger (with "zikh")] 
zamd/N [n] [def: sand] /Iik
zaml/V/T [def: collect] /Gayn/Gon/Gtsunoyf
	farzaml/V/Bfarzamlt [def: convene, assemble]
		farzamlung/N [f] [def: assembly, meeting]
	zamler/S [m] [def: collector]
	zamleray'/N [f] zamlung/N [f] [def: collection] 
	gezeml [def: collection, gang] 
	aynzamlung/N [f] [def: accumulation, gathering, crowd]
	hoyptzamlung/N [f] [def: principal collection] 
	onzamlung/N [f] [def: backlog] [note: V] 
zang/N/D [f] [def: stalk; ear (of corn)] 
zani'titse/S [f] [def: hangnail] 
zap/V/T [def: suck] /Garayn/Gdurkh
	/Gayn [def: absorb] 
zapas/N [m] [def: reserve, margin, supply] /Iik [def: reserve] 
	zapastir [def: emergency door]
	zapaske/S [def: article of women's clothing from waist down]
zaraze/S [f] [def: contagion, contagious disease] 
	zarazlive/A [def: contagious] 
	zaraze/V/T [def: infect] 
zasik/Ees [m] [def: bin, corner for laying up produce]
zastav/Ees [def: place where one can exchange horses for the next stage of a journey] 
zautrenye [def: a particular Russian Orthodox service] 
zavelkes [def: ??] % a disease
zaverukhe/S [f] [def: blizzard] 
zavod/N [m] [def: factory, stud (horse)] 
	tsukerzavod/N [def: sugar works] 
zavulik/Ees/Xzavulkes [m] [def: alley] 
zavyese/S [f] [def: hinge] 
zayd [f] [def: silk] /In [def: silk] 
zayen{zAn}/H [m/f] [def: Hebrew letter zayin] 
zayl/N [m] [def: column; pillar] 
zayt/N [f] [def: side, page] /Iik/Ildik /D
	berglzayt/N [f] [def: hillside] 
	vebzayt/D [f] vebszayt/N/D [f] [def: web page (computer)] 
	heymzayt/D [f] [def: home page (computer)]
	alzaytik/A [def: complete, entire] 
	filzaytik/A [def: many-sided]
	eynzaytik/A [def: one sided]
		eynzaytikayt/N [f] [def: one-sidedness]
	kegnzaytik/A [def: opposite] 
	bazaytik/V/Bbazaytikt [def: depose, remove] 
	[idiom: oyf der linker zayt = inside out, reversed]
ze/V [def: see] zeen/Lder gezen gezeen/A derzen derzeen/A
	% irregular third plural
	% limitation: irregularity can't be captured, so we list forms
	derze/V/Bderzen [def: catch sight of] 
	forzikhtik/A [def: careful]
	durkhzikhtik/A [def: transparent] durkhzikhtikayt/N [f] [def: transparency] 
		umdurkhzikhtikayt/N [f] [def: opacity] 
	aroysgezen [def: appear] 
		aroyszen [m] [def: appearance]
		aroyszeendik/A oyszeendik/A [def: apparently; appearing] 
	arumze/V [def: realize after consideration (with "zikh")] arumgezen
	ayngezen foroyszen foroysgezen ibergezen onzen oysgezen oystsuzen oyszen
	tsutsuzen
	arumgezen
	tsuzen tsugezen tsuzeendik/A derzen derzeendik/A
	farze'enish/N [n] [def: monster, freak]
		geze'enish/N [n] [def: sight]
	ongezeen/K [def: honorable]
	zeendik/A [def: sighted]
	hinzikht/N [m] [def: detail, connection, respect] [usage: deprecated]
	iberzikht/N [def: abstract, overview]
	oyszikht/N [def: prospect] 
	zeer/S [m] [def: seer, prophet] 
		foroyszeer [m] [def: soothsayer] foroyszeendik/A [def: predicting] 
		oyfzeer/S [m] [def: supervisor] 
		shvartszeer/S [m] [def: pessimist] 
	zeevdik/A [def: visible] umzeevdik/A [def: invisible]
		foroy'szeevdik/A [def: predicatable] 
		umforoysze'evdik/A [def: unpredicatable] 
	umgezeen/A [def: unseen] 
	ongezen/A [def: distinguished, outstanding, eminent]
		onzeevdik/A [def: famous]
	zeung/N [f] [def: vision] 
	aynzen [n] [def: discretion, regard]
		aynze'enish [n] [def: consideration, empathy] 
		aynzeung/N [f] [def: realization] 
zebre/S [f] [def: zebra (animal)] 
zeg/N [f] [def: saw] zeg/V/T [def: saw] /Gdurkh/Gunter
	zegekhts [n] [def: sawdust] 
zegl/N [m] [def: sail] 
zegn/V/T [def: bid farewell (with "zikh")] /Gop
	gezegn/V/Bgezegn /Gop [def: bid farewell (with "zikh")] 
	gezegenung/N [f] [def: farewell]
zehires{z|hyrwT}/H [n] [def: care]
zeks [def: 6]
	zekst/A [def: 6th] zekstl [def: 1/6]
	zekhtsn [def: 16] zekhtsnt/A [def: 16th] zekhtsntl [def: 1/16]
	zekhtsik/A [def: 60] zekhtsikst/A [def: 60th] zekhtsikstl [def: 1/60] 
	[idiom: an ofener zeks un zekhtsik = an open book (from the card game 66)]
zel zele/N [f] [def: soul]
	laytzelik/V/T [def: grace, favor] 
		laytzelikayt/N [f] [def: grace, favor, goodwill]
zelbe/A [def: self]
	zelbik/A /-zelbik [def: same] % no form zelbik: CY C.9
	zelbst [def: itself; self] 
	derzelber [adj] derzelbiker [adj] [def: the same]
	dizelbe [adj] dizelbike [adj] [def: the same]
	demzelbn [adj] demzelbikn [adj] [def: the same]
zelner/S [m] zelnerin/S [f] [def: soldier] /Iish [def: military]
	zelneray'/N [n] [def: military service] 
zeltn/A [def: unusual, rare]
	zeltnhayt/N zeltnkayt/N [f] [def: rarity] 
zemer{zmr}/H/D [m] [def: song]
	zmire{zmyrh}/Xzmires{zmyrwT}/H [def: Sabbath table song (usually plural)]
zeml/X [m/f] [def: roll, bun (food)] /Dzem
zeneft [m] [def: mustard] 
zeriz{zryz}/Xzerizem{zryzym}/H [def: punctual, hasty] 
zet/En [m] [def: the letter Z] 
zetik/V/T [def: satisfy, satiate] /Gon
	zat/A [def: satisfied, full]
	zet [f] zatkayt/N [f] zetikayt/N [f] [def: satiety] 
	zetik/K [def: nourishing] 
	zetikung/N [f] [def: saturation] 
zets/V/T [def: seat; place]
	/Ganider/Garayn/Garoyf/Gavek/Gon/Gayn/Goyf/Gunter/Gtsurik
	/Garum
	/Goys [def: seat (each it its place); compose (printing)] 
	/Gfor [def: continue (German)]
	/Giber [def: translate] 
	/Garoys [def: evict] 
	/Garop [def: depose] 
	/Gtsu [def: sit for a while (with "zikh")] 
	bazets/V/Bbazetst [def: occupy, settle]
		bazetser/S [m] [def: settler] 
		bazetsung/N [f] [def: occupation, settlement] 
	farzets/V/Bfarzetst [def: plant; pawn]
	iberzetsung/N [f] [def: translation]
		iberzetser/S [m] [def: translator] 
	zets/N [m] [def: blow, knock]
		oyfzets/N [m] [def: sit-up (athletic exercise)] 
		[idiom: derlangen emetsn a zets = hit somebody]
		[idiom: mit eyn zets = in one fell swoop]
		tsonopzets [m] [def: plaque (dental)] [note: V]
	zetser/S [m] [def: composer; typesetter] onzetser/S [def: ??]
	tsezetst/A [def: crazy] 
	gezets/N [n] [def: law] /Iik/Ilekh [def: lawful] 
		oysglaykh-gezetsgebung [f] [def: affirmative action] [note: V]
	zats/N [m] [def: sentence]
		kegnzats/N [m] [def: opposite]
		bayzats/N [m] [def: subordinate clause]
	forzetsung/N [f] [def: continuation] 
zey/V/T [def: sow (seed)] /Gadurkh
	tsezey/V/T [def: sow (seed)] 
	bazey/V/Bbazeyt [def: sow (seed)] 
	farzey/V/Bfarzeyt [def: sow (seed)]
		farzey'enish/N [def: sowing] 
zeyde/S/C/J [m] [def: grandfather] zeydenyu [def: dear grandfather]
	elter-zeyde/S [def: great-grandfather] 
zeyer [def: very] 
zeyf [f/m] [def: soap]
	zeyf/V/T [def: soap] /Goys
zeyger/S/D [m] [def: clock]
	zeygerl/Eekh [n] [def: watch; clock (diminutive)] % wrong: zeygerle
	azeyger [def: o'clock] /Idik
	vekzeyger [m] [def: alarm clock] 
	[idiom: mitn zeyger in zinen = in the interest of time] [note: V]
zhabe/S [f] zhabke/S [f] [def: frog] 
zhake't/N [f?] [def: jacket (clothing)] 
zhaleve/V/T [def: hold back, hold in reserve; economize; spare; begrudge] 
	zhalevanye/S [f] [def: easily earned money] 
zhalovanye/S [def: salary, wages (Russian)] 
zhandarm/N [m] [def: policeman] 
zhaner/S [m] [def: genre] 
zhargo'n/N [m] [def: jargon] 
zhaver/N [m] [def: rust] 
	zhaver/V/T [def: rust] 
	farzhaver/V/Bfarzhavert [def: rust] 
zhe [interj] [def: so, then, expression of endearment or annoyance]
	[grammar: postpositive]
zhedne/A [def: greedy] zhednekayt/N [f] [def: greediness] 
zheni'/Een [m] [def: genius]
zhest/N [m] [def: gesture]
	zhestikuli'r/V/Bzhestikuli'rt [def: gesticulate] 
zhid/Ees [m] [def: Jew (Russian), derogatory] zhidlak
zhile't [def: vest without sleeves]
zhipe/V/T [def: breathe with difficulty] 
	[idiom: koym zhipen = be barely alive]
zhira'f/N [m] [def: giraffe]
zhire/S [f] [def: endorsement] 
	zhiri'r/V/Bzhiri'rt zhire/V/T [def: endorse (a check)] 
zhlob/Ees [m] [def: yokel, hick, boor]
zhlyoke/V/T [def: slurp (liquid), guzzle (gasoline)] /Gon
zhmenye/S [f] [def: fistful] 
zhmure/V/T [def: blink]
	ayngezhmuret/A [def: closed (eyes)] 
	farzhmure/V/Bfarzhmuret [def: squint] 
zhonglyor/N [m] [def: juggler] 
zhuk/N/D [m] [def: insect, bug; beetle] dzhukhe/S [f]
zhume/V/T [def: hum] /Gunter
	zhum/N [m] gezhum/N [def: humming] 
	zhumzhe/S [f] [def: bumblebee (insect)] 
zhulik/Ees [m] [def: rogue, crook, blackguard] 
zhungl/N [m] dzhongl/N [m] [def: jungle]
zhupitse/S [f] [def: frock (clothing)] 
zhurkhline/S [def: cranberry] 
zhurna'l/N [m] [def: journal]
	zhurnali'st/N [m] zhurnalistke/S [f] [def: journalist]
		/Iish [def: journalistic]
	vebzhurnal/N [m] [def: Web-based journal]
	zhurnalistik [f] [def: journalism (subject)] 
zhvave/A [def: pert, lively, vivacious, brisk] 
zibn [def: 7]
	/It zibet/A [def: 7th] zibetl [def: 1/7]
	zibetsn [def: 17] zibetsnt/A [def: 17th] zibetsntl [def: 1/17] 
	zibetsik/A [def: 70] zibetsikst/A [def: 70th] zibetsikstl [def: 1/70] 
zid/V/T/Bgezotn [def: boil] /Goyf
	farzid/V/Bfarzidt [def: simmer]
	farzotn/A [def: boiled] 
	zudik/A [def: boiling] 
zidl/V/T [def: curse; revile; scold] /Goys
	zidleray'/N [n] [def: cursing]
	oyszidlung/N [f] [def: cursing] 
zifts/V/T [def: sigh] /Gop
	zifts/N [m] [def: sigh] 
zig/V/T [def: overcome, conquer, win]
	zig/N [m] [def: victory] 
	ziger/S [m] [def: winner; conqueror] 
	bazig/V/Bbazigt [def: overcome, conquer] 
	zigraykh/A [def: victorious; successful] [usage: inadmissable]
zigl/V/T [def: seal] /Gayn [def: seal into] 
	zigl/N [m/n] [def: seal] 
zigzag/N [n] [def: zig-zag] /Iish
zikher/V/T [def: assure] 
	farzikher/V/Bfarzikert [def: insure]
		farzikherung/N [f] [def: insurance] 
	zikher/K [def: sure; safe] % strange but true: zikhererer
		zikherheyt [adv] [def: surely] 
	umzikher/A [def: uncertain] 
	zikherung/N [f] [def: fuse (electrical)] 
	zikherkayt/N [f] [def: safety; certainty; backup (in case of failure)] 
		zelbstzikherkayt/N [f] [def: self confidence] 
zikorn{zKrwn}/H/Xzikhroynes{zxrwnwT}/S [def: memory; memoirs (in plural)] /Ll
	zikhroynoy{zxrwnw}/H [def: his memory] 
	zeykher{zxr}/H [def: vestige] 
	hazkore{hzKrh}/Xhazkores{hzKrwT} [def: memorial] 
zilber [n] [def: silver (Ag)] /In [def: silver]
	bazilber/V/Bbazilbert [def: silver] 
	kvekzilber [m] [def: mercury (Hg)] 
zind/X [f] [def: sin] /D
	/Iik [def: sinful] 
	zindik/V/T [def: sin] /Gunter
		zindiker [m] [def: sinner] 
	farzindik/V/Bfarzinkdikt [def: sin] 
zin [m] [def: sense]
	zinen [m] [def: sense; consciousness] 
	laykhtzinik/A [def: carefree] 
	tifzinik/A [def: in deepest sense] 
	bazinen/V/Bbazinen [def: come to one's senses (with "zikh")] 
	umzinik/A [def: senseless]
	zinloz/A [def: senseless] [usage: doubtful admissability]
	[idiom: arop funem zinen = crazy]
zing/V/Bgezungen [def: sing]
	/Gtsu/Goys/Gmit/Goyf/Gunter/Giber/Gop
	zinger/S [m] /D zingerke/S [f] zingerin/S [f] [def: singer]
	bazing/V/Bbazungen [def: laud (in song)] 
	tsezing/V/Btsezungen [def: sing for a while (with "zikh")] 
	zingeray'/N [n] gezang/N [n] [def: song; chant; singing]
		shvangezang [n] [def: swan song] 
zink/V/Bgezunken [def: sink] /Gayn
	farzink/V/Bfarzunken [def: sink] 
zint [adv] [def: since] 
zip/N [f] [def: sieve] 
	zip/V/T [def: sift] 
zis/K [def: sweet]
	ziskayt/N [f] [def: sweetness] 
	[idiom: tsuker zis = cutesy] [note: V] 
zits/V/Bgezesn [def: sit]
	/Gadurkh/Giber/Gop/Goys/Gayn
	forzitser/S [m] forzitserin/S [f] [def: president]
	zitsung/N [f] [def: meeting; session]
		[idiom: telefo'nishe zitsung = conference call]
	zitser/S [m] zitserke/S [f] [def: sitter] 
	zitsndikerheyt [adv] [def: while seated] 
	bazits/V/Bbazitst [def: possess] bazits [m] [def: possession] 
		bazitser/S [m] bazitserin/S [f] [def: owner]
	zits/N [m] [def: seat] 
	geze's/N [n] [def: seat, buttocks] 
ziveg{zyvg}/Xzugem{zwgym}/H [m] [def: mate; match]
	ziveg|shaft/N [f] [def: partnership]
zkhus{zxwT}/N/Xzkhusem{zxwTym}/Xzkhiyes{zxywT}/Xzkhiyesn{zxywTn} [m] [def: merit]
	zkhiye{zxyh}/H [def: merit] 
	zoykhe{zwxh}/H [def: merit (with "zayn")] 
	zkhusoy{zxwTw} [def: his merit]
	mezake{mzKh} [def: merit (with "zayn")] 
	[idiom: zkhus-oves = inherited merit]
zlidne/A [def: irksome, annoying] 
	zlidne/S [f/m] [def: pest] 
zlote/S [def: zloty (Polish money)] 
zman{zmn}/Xzmanem{zmnym}/H [m] [def: term; semester] 
	shul|zman{zmn} [m] [def: school term] 
zog/V/T [def: say]
	/Garoys [def: commit oneself (with "zikh")] 
	/Gnokh/Goys/Gforoys/Gunter
	/Gtsu [def: promise]
	/Gon [def: announce, request]
	/Gop [def: refuse; fire from job] 
	/Garayn [def: verbally attack] 
	onzog/N [m] [def: announcement, message]
		teykef{WyKf}-onzog/N [m] [def: instant message, IM (computer)] [note: V] 
	opzog/N [m] [def: refusal, dismissal]
	antzog/V/Bantzogt [def: refuse] 
	zoger/S zogerke/S [m] [def: reciter] 
		hespedem{hspdym}-zoger/S [m] [def: professional eulogizer]
	foroyszoger/S [m] [def: soothsayer] foroyszo'genish/N [def: prophesy] 
		foroy'szogevdik/A [def: predicatable] 
	vertlzoger/S [m] [def: joker]
	tsuzog/N [m] [def: promise] 
	farzog/V/Bfarzogt [def: pass the word (to)]
	derzog/V/Bderzogt [def: say to the end, hold back, imply]
	aroyszogung/N [f] [def: pronouncement] 
	[idiom: hobn tsu zingen un tsu zogn = go through many trials and tribulations]
zok/N [m/f] [def: sock, stocking (clothing)]
zokher{zxr}/Xzkhorem{zxrym} [m] [def: male] 
	loshn{lSwn}-zokher{zxr} [def: masculine (gender)] 
zokn{zkn}/Xzkeynem{zknym}/H [m] zkeyne{zknh}/H [f] [def: old person]
	/Idik [def: aged] 
	zkunem{zkwnym}/H [def: old age]
zol/V/T [def: should]
zone/S [f] [def: zone] 
	zeyger-zone/S [f] [def: time zone] 
zoologye/S [def: zoology] 
	zoologish/A [def: zoological] 
zorg/V/T [def: worry] 
	zorg/N [f] [def: worry; care] /Ievdik [def: careful] 
	farzorg/V/Bfarzorgt [def: supply]
		farzorger/S [m] [def: supplier] 
	bazorg/V/Bbazorgt [def: attend to, provide] 
		bazorgt/A [def: worried, provided] 
	[idiom: zorg zikh nisht = dont worry; never mind]
zotl/N [m/n] [def: saddle]
	zotl/V/T [def: saddle] /Gon
zoyber/A [def: clean]
	zoyberkayt/N [f] [def: cleanliness] 
zoyer/K [def: sour; acidic]
	zoyers/N [n] [def: sour food; acid (chemical)] 
	onzoyerung/N [f] [def: acidification] 
	farzoyer/V/Bfarzoyert [def: acidify] 
	zoyerkayt/N [f] [def: acidity] 
zoyf/V/T [def: guzzle] zoyfer/S [m] [def: guzzler; drunkard] 
zoyg/V/T [def: suck] /Goys
	oysgezoygn/A [def: sucked dry] 
	zeyg/V/T [def: suckle, nurse] 
		zeygerin/S [f] [def: wet nurse] 
		zeygling/N [def: nursing infant] 
zoyl/N [f] [def: sole (shoe) (clothing)] 
zoylel{zwll}/H [m] [def: glutton] 
	[idiom: zoylel{zwll} |v|soyvey{swB#} = disobedient, gluttonous child]
zoym/N [m/f] [def: hem] 
zoymen/S [m] [def: seed; semen; offspring] 
	bazoymen/V/Bbazoyment [def: seed] 
zoyne{zwnh}/Xzoynes{zwnwT}/H [f] [def: prostitute]
	znus{znwT}/H [m/f] [def: lewdness] 
zubitshes [def: tooth ailment] 
zukh/V/T [def: seek]
	/Goys/Garoys/Gdurkh/Gop/Gunter/Garum/Goyf
	bazukh/V/Bbazukht [def: visit, detect]
		bazukh/N [m] [def: visit, attendance, stay]
		bazukher/S [m] [def: visitor, detector] 
			elektro-bazukher/S [m] [def: metal detector] [note: V]
	farzukh/V/Bfarzukht [def: taste]
	zu'khenish/N [n] zukhung/N [f] zukheray'/N [n] [def: seeking] 
zumer/N [m] [def: Summer (season)]
	/Idik /Iik [def: summer-like]
	zumer/V/T /Giber [def: survive the summer] 
zump/N [m] [def: swamp] /Iik [def: swampy] 
zumze/V/T [def: buzz (sound of a bee)] 
zun/N [f] [def: sun] /Iik [def: sunny] 
	zunengold [n] [def: golden sunshine] 
	tsezunik/V/Btsezunikt [def: light up]
	morgnzun/N [f] [def: morning sun] 
zun/Xzin [m] [def: son]  /D /Dzind
	zunenyu [def: dear son]
	brudern-zun/Xbrudern-zin [m] [def: nephew] 
	hurnzun/Xhurnzin [m] [def: bastard] 
	gezind/D [n] hoyzgezind [n] [def: members of household]
zunder/V/T /Gop [def: separate] 
	opzunderung/N [f] [def: separation; distinct place]
	opgezundertkayt [f] [def: separation] 
	bazunder/A [def: separate, special] bazundersh [adv] [def: especially] 
		bazunderheyt [adv] [def: separately]
		bazunderkeyt/N [f] [def: separation] 
zuntik/N [m] [def: Sunday] 
zup/N [f] [def: soup] 
zup/V/T [def: slurp; sip] /Gop
zuze/S zhuzhe/S [f] [def: gravy] 
zuze/S [def: semen] [usage: taboo]

% names of people, places, or things worth spelling right.

afrike [def: Africa] afrikaner/X [m] afrikanerin/S [f] afrikanish/A
albani [def: Albany (USA)] 
albert [def: Albert] 
aleks [def: Alex] 
aleksander [def: Alexander]
aleksandrie [def: Alexandria (Egypt)] aleksandrish/A
aleska [def: Alaska (USA)] 
algerye [def: Algeria] algeryer/X [def: Algerian] % TODO: use this form
amerike [def: America] amerikaner/X [m] amerikanerin/S [f] amerikan/A /Iish
amsterdam [def: Amsterdam (Holland)] 
antyokhes{antyHws}/H [def: Antiochus (Syrian Greek king)] 
araber/S [def: Arab] 
aramish/A [n] [def: Aramaic]
	arameish/A [n] [usage: doubtful admissability]
arele/C [def: Arele] 
argentine [def: Argentina] argentiner/X [def: Argentinian] 
arish/A [def: Aryan] 
aristotel [def: Aristotle]
ashkenaz{aSKnz}/H/Eer/Iish [def: Ashkenaz, Germany]
ashur [def: Assyria] /Iish
aynshtayn [def: Einstein]
ayzik [def: Isaac]
azye [def: Asia] azyer/X [def: Asian] azyat/N [m] /Iish azyatke/S [f]
balkan/A /Iish [def: Balkan] 
baltish/A [def: Baltic]
bareyn [def: Bahrain] 
bashe/C [def: Bashe] bashke/C
bayern [def: Bauruth (Germany)] 
belgye [def: Belgium] belgyer/X
belorusye [def: Belorus, White Russia] 
belz [def: Belz (place, Khasidic dynasty] belzer/X
ber berl berele [def: Berl] 
berditshev [def: Berditshev, Ukraine] berditshever/X barditshev barditshever/X
berkshir/N [def: Berkshire hills (NY, USA)] 
berlin [def: Berlin (Germany)] berliner/X
besarabye [def: Bessarabia] besarabish/A
beyle/C [def: Beyle] 
binem/C [def: Binem] 
birnboym/C [def: Birnbaum] 
birobidzhan [def: Birobidzhan] birobidzhaner/X
bizantyum [def: Byzantium] bizantinesh/A
bobov [def: Bobov (Town, Khasidic dynasty)] bobover/X
bogdan/C [def: Bogdan (Ukrainian name)] 
bolek{blk}/H/C [def: Balak (Biblical Moabite king] 
	[idiom: lernen bolek{blk} mit emetsn = teach someone a harsh lesson]
bolts/N [m] [def: tall ungainly person] 
bontshe/C [def: Bontshe] 
boston [def: Boston (USA)] 
bovl{bBl}/H [def: Babylonia] 
brak{brk}/H [def: (Bney Brak, Israel)]
bremen [def: Bremen (German)] 
breslav [def: Breslau/Bratslev (Ukraine)] breslaver/X
brisk [def: Brest-Litovsk] brisker/X
	% "fun brisk biz trisk iz gelofn a fuks un gahaltn a biks in pisk"
brisl [def: Brussels (Belgium)] 
brod [def: Brod (Poland)]  /Iish broder/X
brodvey [def: Broadway (NY)] 
bronfman/C [def: Bronfman] 
bronks [def: Bronx (NY)] 
bruklin [def: Brooklyn (NY)] 
buda/C [def: Buddha] 
budapesht [def: Budapest (Hungary)] 
buenos [def: Buenos (Aires) (Argentina)] 
bukaresht [def: Bucharest (Rumania)]
bukhenvald [def: Buchenwald (Germany)] 
bukovine [def: Bukovine (Rumania)] bukoviner/X
bulgarye [def: Bulgaria] /Ir bulgar bulgatsh/N
byalik/C [def: Khayim Nakhman Bialik]
byalistok [def: Byalostok (White Russia)] byalistoker/X
dagesta'n [def: Dagestan] dagestaner/X
damesek{dmQk} [def: Damascus] 
dantsig [def: Dantsik/Gdansk (Germany/Poland)] dantsiger/X
daytshland [def: Germany] daytsh/A/Iish
	daytshin/S  daytshke/S daytshmerizm/N [m] daytshmerizi'r/V/Bdaytshmerizi'rt
	daytshmerizirung/N fardaytsh/V/Bfardaytsht folksdaytsh/N hoykhdaytsh/Iish
	germanets/N [m] [def: German (Russian, derogatory)] 
denmark [def: Denmark] denish/A [def: Danish] 
detroyt [def: Detroit (USA)] 
dnyepr nyeper [def: Dneiper River (Europe)] 
dominikaner [def: Dominican] 
drayzl/C [def: from Drusilla of the Bovo Mayse] 
dreyfus/C [def: Dreyfus] 
dubrovne [def: Dubrovne] dubrovner/X
dunay [def: Danube]
dzhoyrzi [def: Jersey] 
ekspres [m] [def: varshever ekspres, Yiddish newspaper] 
ekvador [def: Equador] 
elke/C [def: Elke] 
elyet/C [def: Elliot]
elzas [def: Alsace (Germany and France)] elzaser
england [def: England] englender
	english [n] /A [def: English]
epshteyn/C [def: Epstein] 
esperanto [def: Esperanto language] 
estland [def: Estonia] estlander/X
estraykh [def: Austria] estraykher/X /Iish
etl/C [def: Ethyl] 
etyu'd/N [m] [def: etude; artistic study] 
evnezre{#Bn-ezr#}/H [def: Even Ezrah, Torah commentator]
eyrope [def: Europe] /Eer /Iish
Eysev{eQw}/H/C [def: Esau] 
fayvish fayvl [def: Fayvish (from Phoebus)] 
feygl/C feygele/C [def: Feygl (means "Violet")] 
filadelfye [def: Philadelphia (USA)] 
filipin filipiner [def: Phillipine] 
finland [def: Finland] finlander/X
floride [def: Florida (USA)] 
fonye [def: Russian] [usage: derogatory]
	[idiom: fonye ganef{gnB} = oppressive Russia]
ford/C [def: Henry Ford] 
frankfurt frankfurter/X [def: Frankfurt]
frankraykh [def: France] frantseyzish/A [n] [def: French] 
	frantsoyz/N [m] frantsoyzer [m] [def: Frenchman]
		frantsoyz/N [m] [def: cockroach] 
	frantsoyzerin/S [def: Frenchwoman]
freydl/C freydele/C [def: Freydl] fradl/C
frume/C [def: Frume]
galitsye [def: Galicia] galitsish/A galitsyaner
gebirtik/C [def: Gebirtik] 
ger/Eer [def: Ger (Khasidic dynasty)]
germanish/A [def: German]
gibralter [def: Gibralter] 
gitl/C gitele [def: Gitl] 
glatshteyn [def: Glatstein]
glupsk [def: Glupsk (fictional town of Mendele Moykher Sforem)] glupsker/X
gnendl/C [def: Genendl] 
goldfadn/C [def: Abraham Goldfaden, founder of Yiddish theater] 
gorki/C [def: Maxim Gorky, Russian author]
gotesman/C [def: Bella Gotesman] 
grikhnland [def: Greece] grikh/N [m] [def: Greek] /A /Iish 
	grek/N [m] [def: Greek] /Iish % Harduf 
grodne [def: Grodno (Russia/Poland/Belarus)] grodner/X
groys-britanye [def: Great Britain] britanye [def: Britain] british/A
hamburg [def: Hamburg, Germany] hamburger/X
hanke/C [def: Hanke] 
harkavi/C [def: Harkavi (author of Yiddish dictionary)] 
hersh/C [def: Hershel]
hertsl/C [def: Theodore Hertzl, founder of Zionism]
heydlberg [def: Haidelburg (Germany)] 
hinde/C [def: Hinde] 
hitler/C [def: Adolf Hitler] hitleri'st/N /Iish hitlerizm [m] 
hodl/C [def: Hodl] hodele/C
holand [def: Holland] holender/X holenderke/S holendish [n] /A niderlandn
homen{hmn}/H/C [def: Haman] 
irak [def: Iraq] iraker [adj] [def: Iraqi] 
iran [def: Iran] /Ier
irland [def: Ireland] irlender/X irlendish/A
istanbul [def: Istanbul (Turkey)] 
italye [def: Italy] italyener/X italyenish/A
ivan [def: Ivan] 
kadye/C [def: Kadye] 
kalifornye [def: California (USA)] 
kalmen{klmn}/C [def: Kalman] 
kamenets [def: Kamenets] kamenetser/X
kanade [def: Canada] kanader/X
karaim{kara#ym} [def: Karaite] /Eer /Iish
kaspish/A [def: Caspian] 
kasrilevke{KTrilevke} [def: Kasrilevke, (from Sholem Aleichem stories)]
	kasrilevker{KTrilevker}
kavka'z [def: Caucasus] /Iish kavkazer/X
kelem [def: Kelme (Lithuania)]
keltish/A [def: Celtic] 
kenaan{Knen}/H [def: Canaan]
kenigsberg [def: Königsburg (Germany)] 
kentoki [def: Kentucky (USA)]
keshenev [def: Kishinev (Moldova)] keshenever/X
keyle/C [def: Keyle] 
khaldey [def: Chaldea] khaldeyish [n] /A
kharkov [def: Kharkov (Ukraine)]
khelem [def: Chelm (Poland)] khelemer
khevren{HBrwn} [def: Hebron (Israel)] 
khezbola [def: Hizbollah (Moslem group)] % Forwards
kheyfe{Hyfh}/H [def: Haifa] kheyfer{Hyfhr} [adj]
khine [def: China] khinezish [n] /A khinezer/X [m]
khmelnitski/C [def: Bogdan Chmielnicki] 
kiev [def: Kiev (Ukraine)] kiever/X
kineres{KnrT} [m] [def: Lake Tiberias (Israel)] 
kitay [def: Cathay; China] 
kolomey [def: Kolomey (Rumania)] 
kolumbus/C [def: Christopher Columbus] 
konfutsyus/C [def: Confucius] 
korea koreaner [def: Korea] 
kotsk [def: Kock (Poland)] kotsker/X /Idik
kovne [def: Kovne (Lithuania)]
krim [def: Crimea] krimtshik/Ees [def: Crimean] 
kroke [def: Crakow] krokever/X
kusi{KwTy}/Xkusem{KwTym} [def: Samaritan] 
kvins [def: Queens (NY)] 
latvye [def: Latvia] letland /Iish letlender
layptsig [def: Leipsig (Germany)] layptsiger/X
leksington [def: Lexington] leksingtoner/X
lemberg [def: Lemberg/Lvov] lemberger/X
leningrad [def: Leningrad, Soviet Union] 
letland [def: Latvia]  letlander/X
levant [m] [def: Levant] 
levonen{lBnwn} [def: Lebanon] 
leyb/C leybl/C leybke/C [def: Leybl] leybush/C leybe/C
leyvik/C [def: H. Leivick]
leyzer/C [def: Leyzer (Eliezer)] 
lipe/C [def: Lipe] 
lite [def: Lithuania]
	litviner/X [def: non-Jewish Lithuanian] litvinke/S litvinish/A
	litvish [n] /A
	litvak/N/Ees [def: Jewish Lithuanian] 
lodzh [def: Lodz (Poland)] lodzher/X
lomzhe [def: Lomze (Poland)] lomzher/X
london [def: London (England)] londoner/X
lotoringye [def: Lorraine (Germany and France)] 
lublin [def: Lublin (Poland)] lubliner/X
lutsifer/C [def: Lucifer] 
lutsk [def: Luck (Poland)] lutsker/X
madagaskar [def: Madagascar] madagaskarer/X
maksim/C [def: Maxim (Russian name)]
malayzye [def: Malaysia] malayer malayish [n] /A
manger/C [def: Itsik Manger] 
manhetn [def: Manhattan] 
maroko [def: Morocco] marokan/A
maynts [def: Maintz, Mayence] 
meksike [def: Mexico] meksikan/A /Iish
melburn [def: Melbourne (Australia)] melburner/X
mendl/C mendele/C [def: Mendel] mendeli'st/N mendelnitse/S mendelyaner/S
mikita/C [def: Mikita] 
mindl/C [def: Mindl] 
mine/C [def: Mine (name)] 
minke/C [def: Minke]
minsk [def: Minsk (Belarus)] minsker/X
mirl/C [def: Mirl] mirele/C
mishigan [def: Michigan (USA)] mishiganer/X
mitsrayem{mcrym}/H [def: Egypt] mitsrayemer{mcrymer}/X egiptn
	mitsrish{mcrish}/H/A egiptish/A [def: Egyptian] 
moldavye moldave moldaver moldavish [n] /A [def: Moldova]
	moldova'n [m] moldovanke/S [f] [def: Moldavian] 
molodovske [def: Kadya Moldodovske] 
mongolye [def: Mongolia] mongolyer/X
montreal [def: Montreal (Canada)] 
moskve [def: Moscow] moskver
motl/C [def: Motl] motke/C
mukhamed/C [def: Mohammed] 
niklsburg [def: Nickelsburg (Germany)] niklsburger/X
nil nilus [m] [def: Nile (river)] 
nine/C [def: Nina] 
norvegye [def: Norway] norveger/X [m] [def: Norwegian] 
note/C [def: Notte] notele/C
nyu-york [def: New York (USA)] nyu-yorker/X
odes [def: Odessa (Ukraine)]
	[idiom: vi got in odes = living grandly]
oksford [def: Oxford (England)] 
otoman/N [def: Ottoman] 
oviv{oByB} [def: Aviv (Tel-Aviv, Israel)] 
oyshvits [def: Auschwitz (Poland)] 
oystralye [def: Australia] oystralish/A oystralyer/X
palestine [def: Palestine] palestiner/X
pakista'n [m] [def: Pakistan] pakistaner/X
Pare{preh}/H [def: Pharaoh]
pariz [def: Paris (France)] parizer/X
patsifik [m] [def: Pacific ocean] 
Penina{pnynh}/H/C [def: Penina] 
pensilveynye [def: Pennsylvania (USA)] 
persye [def: Persia] persish [n] /A persyer/X perser/X
pesye/C [def: Peshe] 
petersburg [def: Petersburg] petersburger/X
pilzn [def: Pilsen] pilzner/X
pinye/C [def: Pinye] 
pirineyen [def: Pyranee mountains] 
pisem{pyTwm} [def: Pithom (ancient Egypt)] 
pitsburg{pit|sburg} [def: Pittsburg (PA, USA)] 
plotsk [def: Plock (Poland)] plotsker/X
plungian [def: Plunge (Lithuania)] 
podalsk [def: Podolsk]
podolye [def: Podolia] 
polesye [def: Polesia] 
polus/N [def: pole (magnetic, electrical)] 
portugal [def: Portugal] portugezer/X portugezish/A [def: Portuguese] 
poyln [def: Poland] poylish [n] /A
	polyaner [def: Jewish Pole] polyak/N [def: non-Jewish Pole] 
	farpoylish/V/Bfarpoylisht
poyps [m] poypst [m] [def: Pope] 
prag prog [def: Prague (Czech Republic)] 
praysye praysn [def: Prussia] prays [m] [def: Prussian] /Iish
preshburg [def: Pressburg = Bratislava, Slovakia] preshburger/X
radom [def: Radom (Poland)] radomer/X
radomsk [def: Radomsk (Poland)] radomsker/X
ramses{remss} [def: Ramses (ancient Egypt)] 
	[idiom: tsuzogn pisem{PyTwm} veramses{wremss} = promise the moon]
reyzn/C [def: Abraham Raisen] 
rige [def: Rige (Latvia)] 
ra'ki-berg [def: Rocky Mountains (USA)] 
rokfeler/C [def: Rockefeller] 
rotshild/C [def: Rothschild] 
roym [def: Rome (Italy)] /Iish romaner romanish/A romanizatsye/S
	romanizi'r/V/Bromanizi'rt
royz/C reyzl/C [def: Rose] 
rumenye rumenish [n] /A rumener [def: Romania] 
rusland [def: Russia] rusish [n] /A rus/N ruslendish/A
	rus/N [m] [def: cockroach] 
sambatyen{smbtywn} [def: mythical Sambatyon River] 
saudye [def: Saudi Arabia] 
sdoym{sdwm} [def: Sodom] sdoymer{sdwmer}/X 
sena't/N [m] [def: senate] 
	senato'r/N [m] [def: senator] 
sender/C [def: Sender (from "Alexander")] 
sent/N [m] [def: cent (currency)] 
serbye [def: Serbia] serbish [n] /A
shagal/C [def: Maurice Chagall] 
shampanye [def: Champaign (France)] shampanyer/X
shavl [def: Siauliai (Lithuania)] 
sheykspir/C [def: Shakespeare] 
shlezye [def: Silesia] 
shmerl/C [def: Shmerl] 
shomron{Sumrwn}/H [def: Samaria] shomronem{Sumrwnym}
shopnhoyer [def: Schopenhauer] 
shotland [def: Scotland] shotlander/X shotish/A [def: Scotch, plaid] 
shpanye [def: Spain] shpanyer shpanish [n] /A
shtrasburg [def: Strassbourg (France)] 
shvedn [def: Sweden] shvedish [n] /A
shveyts [def: Switzerland] 
sibir [def: Siberia] 
Sinay{syny}/H [def: Sinai (Egypt)] 
	[idiom: zayn (toyras{WwrT} Moyshe{mwSh}) misinay{msyny} = carved in stone]
singapur [def: Singapore] singapurer/X
sinsinati [def: Cincinnati (USA)] 
sirye [def: Syria] sirish/A siryer/X
sitsilye [def: Sicily] 
slav/N [def: Slav] /Iish alslavish/A
slovakye [def: Slovakia] slovak/N
slovenye [def: Slovenia] slovenish [n] /A
sokrates/C [def: Socrates] 
sonye/C [def: Sonya] 
sovetn sovetish/A [def: Soviet] sovyet/N /Iish
	sovetn-farband [def: Soviet Union] 
stalin/C [def: Josef Stalin] /Iistish stalinizm [m] 
strashun-biblyotek [def: Judaica library in pre-Holocaust Vilne]
sudetn [def: Sudetnland (Czech Republic)] 
tarnov [def: Tarnow] 
tay'land [def: Thailand] tay'lender tay'lendish/A
taybl/C [def: Taybl] 
telzh [def: Telz (Lithuania)] 
Terekh{WrH}/H [def: Terach (father of Abraham)]
terkay' [def: Turkey] terk/N [def: Turk] /Iish [def: Turkish] 
	[idiom: opton emetsn oyf terkish = play a nasty trick on someone]
	[idiom: zitsn oyf terkish = sit with legs folded under]
teyman{Wymn} [def: Yemen] teymaner{Wymner} [adj] [def: Yemenite] 
tog [m] [def: Vilner Tog, Yiddish daily newspaper] 
tolstoy [def: Count Tolstoy, Russian author]
toronto [def: Toronto (Canada)] 
treblinke [def: Treblinka (Poland)] 
tsherkas [def: Circassia] tsherkaser/X
tseytlin [def: Avram Tseitlin] 
tshad [def: Chad] 
tshekhoslovakay [def: Czechoslovakia] 
	tshekhye [def: Czech Republic] tshekh/N
tshekye [def: Czech Republic] tshekhish [n] /A
tshernovits [def: Czernowitz (Rumania)] 
tshikago [def: Chicago (IL, USA)] 
tsirl/C [def: Tsirl] tsile/C
tsiyen{cywn}/H [def: Zion, Israel] /Iistish
	tsiyeni'zm{cywnizm}/N [m] [def: Zionism] 
	tsiyeni'st{cywnist}/H/N [m] tsiyenistke{cywnistke}/H/S [f] [def: Zionist] 
tunezye [def: Tunisia] tunezyer [adj] [def: Tunisian] 
tuzman/C [def: Malka Heyfets Tussman] 
ukrayn [def: Ukraine] ukraynish [n] /A ukrayner/X
	ukrain ukraine ukrainer/X % variant spellings
	alukraynish/A [def: all-Ukrainian] 
umen [def: Uman (Ukraine)] 
ungarn [def: Hungary] ungarish [n] /A madzhar madzharish/A
varshavski/C [def: Mark Markovitch Warshavsky] 
varshe [def: Warsaw (Poland)] varshever
vashington/C [def: Washington] 
vasil/C [def: Vasily] 
vatika'n [m] [def: Vatican] 
vaynraykh/C [def: Weinreich]
vaysl [f] [def: Vistula (river in Poland)] 
vaysrusland [def: Belorus] vaysrusish/A vaysrus/N
vayzoso{|wyzT#} [def: Vayzoso, Haman's youngest son; fool; penis]
vikinger/X [def: Viking] 
vilne [def: Vilnius (Lithuania)] vilner
vilyamsburg [def: Williamsburg (USA)] 
vin [def: Vienna (Austria)] viner
vinitse [def: Vinnitse]
volga [def: Volga (river)] 
volin [def: Volin] voliner/X
vyetnam [def: Viet Nam] vyetnamer/X
yapan [def: Japan] yapanish [n] /A yapaner
yarden{yrdn} [def: Jordan] yordanye yordanyer/X
	eyver_{eBr}-hayarden{hyrdn} [def: Transjordan]
Yehoyesh{yhwaS}/H/C [def: Yehoash]
yentl/C [def: Yentl] 
yerushelayem{yrwSlym}/H [def: Jerusalem] yerushelaymer{yrwSlymer}/H
yezus/C [def: Jesus]
	Yeshu{ySw}/C hanotsri{hnwcry}
	yoshke/C khristus/C kristus/C
yisroyl{yQr#l}/H [def: Israel] /Idik /Iish [def: Israeli] yisroyl|dikayt/N
	kvuras{kBwrT}-yisroyl{yQr#l} [def: Jewish burial] 
	yisroyle{yQr#ly}/Xyisroylem{yQr#lym} [m] [def: Israeli citizen] 
yivo [def: YIVO]
yugoslavye [def: Yugoslavia] 
zaksenhauzn [def: Sachsenhausen]  
zamet [def: Zamet (Romania)] 
zeyland [def: New Zeeland] 
zhidovskaya [def: Jew Street] zhidovske
zhitomer [def: Zhitomir] 
zidikai [def: Zidikai (Lithuania)]

% proper names, mostly Hebraic

Akhashveyresh{#HSvrwS}/H/C [def: Ahasuerus]
Akive{ekyB#}/H/C [def: Akiba]
Aleykhem{elyxm}/H/C [def: Sholem Aleykhem (Sholom Rabinovitz, 1859-1916)]
Ames{emws}/H/C [def: Amos]
Aren{ahrwn}/H/C [def: Aaron]
Arye{aryh}/H/C [def: Aryeh]
Avrem{aBrhm}/H/C Avrem|l/C Avrem|tshe/C Avrem|tshele/C [def: Avram]
	abrashe/C [def: Abrashe] 
Avrohom{aBrhm}/H/C [def: Abraham] avromtshe/C
Basheva{bTSBe}/H/C [def: Batsheba]
Basye{bTyh}/H/C [def: Batya] 
Binyomen{bnymyn}/H/C [def: Benjamin] Binyomen{bnymyn}/H/C
Borekh{brwx}/H/C [def: Borukh] Brukhe{brwxh}/H/C [def: Brukhe] 
Boyez{bwez}/H/C [def: Boaz] 
Dan{dn}/H/C [def: Dan] Daniel{dny#l}/H/C [def: Daniel] 
Dine{dynh}/H/C [def: Dinah] 
Dov{dwB}/H/C Dov_{dB}/H/C [def: Dov] 
Doved{dwd}/H/C [def: David] 
Dvore{dBwrh}/H/C
Efrem{#frym}/H/C Efroyem{#frym}/H/C [def: Ephraim] 
Eli{#ly}/H/C [def: Eli] Eyli{#ly}/H/C 
Elye{#lyhw}/H/C [def: Elijah] 
Elyezer{#lyezr}/H/C [def: Eliezer] 
Ester{#sWr}/H/C [def: Esther] Esterl{#sWrlC}
Eyzer{ezr}/H/C [def: Eyzer] 
Ezre{ezr#}/H/C [def: Ezrah] 
Gavriyel{gBry#l}/H/C Gavriyel|ik/C Gavriyel|ikl/C
Gedalye{gdlyh}/H/C
Gershn{grSwn}/H/C
Hadase{hds|h}/H/C [def: Hadassah]
hene/C henye/C
Henekh{hnx}/H/C [def: Enoch]
herman/C
hershl/C [def: Hershl] hershele/C
Hilel{hll}/H/C
Ite/C
Iyev{#ywB}/H/C [def: Job]
Kasriyel{KTry#l}/C
khabad{Hb"d}/H/C khabadnik{Hbdnik}/H
Khane{Hnh}/H/C [def: Hanna] Khanele{Hnhle}/C
Khave{Hwh}/H/C
Khaye{Hyh}/H/C Khaye|le/C Khayke/C/D
Khayem{HAm}/H/C Khayeml{HAml} % spelled with a tsvey-yud, surprisingly
Kheyfets{Hfc}/H/C
Koyen{Khn}/H/C
Levi{lwy}/H/C
Leye{l#h}/H/C
Lipe{lyp#}/H/C
Lovn{lBn}/H/C [def: Laban] 
Malke{mlKh}/H/C
Matisyohu{mWTyhw}/C [def: Mattathias] 
Matye/C
Mekhl{myx#l}/H/C
Menakhem{mnHm}/H/C
Menashe{mnSh}/H/C
Meyer{m#yr}/H/C
Meylekh{mlx}/H/C
Mikhl{myx#l}/H/C
Mikhl{myx#l}/H/C
Mikhoyl{myx#l}/H/C
Miryem{mrym}/H/C [def: Miriam] 
Mordkhe{mrdxy}/H/C
Moyshe{mSh}/H/C
Moyshe{mSh}/H/C Moyshe|le/C
Naftoli{nfWly}/H/C
Naftoli{nfWly}/H/C
Nakhmen{nHmn}/H/C
Nekhe{neHe}/H/C
Nekhemye{nHmyh}/H/C
Nokhem{nHwm}/H/C
Nosn{nTn}/H/C [def: Nathan] 
Noyekh{nH}/H/C
Noymi{nemy}/H/C [def: Naomi]
Odem{#dm}/H/C
Og{#wg}/H/C
Osher{oSr}/H/C Osherl{oSrl}/C
Penina{pnynh}/H/C
Perets{prc}/H/C
Pinkhes{pynHs}/H/C
Rambam{rmb"|m} [def: Maimonides, Moshe ben Maimon] 
Ramban{rmb"|n} [def: Nakhmanides, Moshe ben Nakhman] 
Rashi{rS"y}/H/C
Refoyl{rf#l}/H/C
Rivke{rBk|h}/H/C
Rokhl{rHl}/H/C Rokhl|e/C rekhl/C reykhl/C
Rus{rwT}/H/C [def: Ruth] 
Ruvn{r#wBn}/H/C
Sheve{SBe}/H
sheyndl/C
Shimen{Smewn}/H/C
Shloyme{Slwmh}/H/C
Shmaye{Sme|yh}/H
Shmuel{Smw#l}/H/C shmulik/C [def: Samuel] 
Shmul{Smw#l}/H/C
Shmulik{Smwlyk}/H/C
Shneyer{Sny#wr}/H/C
Sholem{Slwm}/H/C
Shulamis{SwlmyT}/H/C
Simkhe{QmHh}/H/C
Sore{Qrh}/H/C Sore|le soshe/C [def: Sarah] 
Sotn{Qtn}/H/C [def: Satan] 
Tevye{WByh}/H/C
Tsodek{cdwk}/H/C
Tsvi{cBy}/H/C
Uri{#wry}/H/C
Uryel{#wry#l}/H/C
Yankev{yekB}/H/C [def: Jacob] yekl/C yankl/C
Yehude{yhwdh}/H/C [def: Judah] 
Yehudis{yhwdyT}/H/C
Yekheved{ywHBd}/H/C
Yekhezkl{yHzk#l}/H/C [def: Ezekiel]
Yekhiyel{yHy#l}/H/C
Yeshaye{ySyehw}/H/C [def: Isaiah]
Yeshue{ySeh}/H/C
Yirmiahu{yrmyhw}/H/C [def: Jeremiah]
Yishmoyl{ySme#l}/H/C [def: Ishmael] 
Yisroyl{yQr#l}/H/C [def: Israel] Yisroyllik{yQr#lik}/C sruli/C srulik/C
Yitskhok{ycHk}/H/C itsik/C itsikl/C
Yoykhonon{ywHnn}/H/C [def: John] 
Yoyl{yw#l}/H/C [def: Joel] Yoylik{yw#lik}/C
Yoyne{ywnh}/H/C
Yoynesen{ywnTn}/H/C [def: Jonathan]
Yoysef{ywsf}/H/C [def: Joseph] yosi/C yosl/C yosele/C
Zalmen{zlmn}/H/C
Zekharye{zxryh}/H/C

% addendum for later:

% bugs in expand.pl
%  khoyloes{Hwl#T}/N [def: sickness] --- doesn't generate plural using Hebrew
%  /L|u --- doesn't prevent prophylactic alef
%  we don't handle hyphenated words well.
%  let's put (') in words to mark accent.

% vim:filetype=words:
% See ~/.vim/syntax/words.vim for details.
