/*
 * FILE : tableau.h
 */

#include <stdio.h>
#include <string.h>

#define YES 1
#define NO  0
#define YES 1
#define MODATOM 2
#define EMPTYSTR -1
#define DTMAXSIZE 1024*128
#define WTMAXSIZE 1024
#define MAXATOMS  1024*128

#define TRUTH 1
#define FALSITY 0

#define PC   0
#define N    10
#define t    11
#define K    20
#define T    30
#define D    40
#define S4   50
#define kd45 60
#define S4f  70
#define Sw5  80
#define S5   90

struct node {
   int from;
   int length;
   int label;
   int used;
   int closed;
   struct node *parent;
   struct node *left;
   struct node *right;
};

struct branchid {
   struct node *ttop;
   int length;
   struct branchid *former;
};

extern unsigned BOXSIZE;
extern int current_logic, org_logic;
extern int axiom_t, axiom_4;

extern int *maintheory, *auxtheory;
extern int *auxthindex, *spelltab;
extern int *facts;
extern int tempfacts[MAXATOMS];
extern int mts, ats, atn;
extern int *counter;
extern char **atomslexic;
extern struct node *root;
extern struct branchid *forest;
extern int forestsize, maxforestsize;
extern struct node *active;
extern int leftfrom, leftto, rightfrom, rightto, leftvalue, rightvalue;
extern int mode, value1, value2, value3, value4;
extern int fullprover, iter, ftrace, atrace;
extern int dispiter;

extern int exploited, Mexploited, Aexploited;
extern int Mex[WTMAXSIZE], Aex[DTMAXSIZE], varont[MAXATOMS];
extern int Mfnotexpl, Afnotexpl;

struct node *newnode(), *first_not_closed();
struct node *fresh_branch_K(), *freshnode();
struct node *fresh_branch_N();
struct node *fresh_branch_S4();
struct node *modal_active(), *add_to_branch();
struct node *better_shot();
