#!/usr/local/bin/tclsh

# See if files known to be left by exploits exist.
#  Copyright (c) 2002 Raphael Finkel.  See the COPYRIGHT file for details.

source unix.tcl

set bads ""
set confFile [open ./rootkit.conf r]
while {[gets $confFile line]>=0} { ;# one line
	if {[regsub {#.*} $line {} new]} {set line $new}
    if {[regexp {^ *$} $line]} continue ;# empty line
	if {[regexp : $line]} {
		set both [split $line :]
		set dirs [lindex $both 0]
		set files [lindex $both 1]
		regsub -all { ([^ ])} $files " -o -name \\1" newFiles
		regsub { -o } $newFiles {} files
		# puts "$findProg $dirs $files";
		catch {
			set found [eval "exec $findProg $dirs $files 2> /dev/null"]
		} found
		regsub {child process exited abnormally} $found {} found
		regsub "\n" $found "\n\t" found
		if {[string length $found] > 0} {
			append bads "\n\t$found"
		}
		continue;
	} else {
		set badFile $line
		# puts "trying $badFile"
		if {[file exists $badFile]} {
			append bads "\n\t$badFile"
		}
	}
} ;# one line

if {[string length $bads] > 0} {
	report rootkit $myHost 35 "These files should not exist:$bads"
	puts "These files should not exist: $bads"
} else {
	report rootkit $myHost 0 "ok"
}

exit 0
